;    Copyright 2015 by Arnes
;
;    This file is part of ArnesLink.
;
;    ArnesLink is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    ArnesLink is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with ArnesLink. If not, see <http://www.gnu.org/licenses/>.

!include x64.nsh
!include LogicLib.nsh
!include nsDialogs.nsh 

!ifdef NSIS_UNICODE
   !echo "Nsis installer supports Unicode!"
!else
   !echo "Nsis installer DOES NOT support Unicode!"
!endif

Name "ArnesLink"
OutFile "ArnesLink.exe"
;Unicode true
RequestExecutionLevel user

Var Dialog
Var Label
Var Select
Var Platform
Var myLanguage

Page custom languageDialog languageDialogPageLeave
Page instfiles

Function .onInit
    ${If} ${RunningX64}
    StrCpy "$INSTDIR" "$PROGRAMFILES64\ArnesLink"
    StrCpy $Platform "64"
    ${Else}
    StrCpy "$INSTDIR" "$PROGRAMFILES\ArnesLink"
    StrCpy $Platform "32"
    ${EndIf}
FunctionEnd

Function languageDialog
    nsDialogs::Create 1018
    Pop $Dialog
    ${If} $Dialog == error
        Abort
    ${EndIf}
    ${NSD_CreateLabel} 0 0 100% 12u "Izberite jezik (Please select a language):"
    Pop $Label
    ${NSD_CreateDropList} 0 13u 100% 72u "Izbira jezika"
    Pop $Select
    ${NSD_CB_AddString} $Select "Slovenscina"
    ${NSD_CB_SelectString} $Select "Slovenscina"
    ${NSD_CB_AddString} $Select "English"
    nsDialogs::Show
FunctionEnd

Function languageDialogPageLeave
    ${NSD_GetText} $Select $0
    ${If} $0 == "Slovenscina"
	    StrCpy $myLanguage "Sl"
    ${Else}
	    StrCpy $myLanguage "En"
    ${EndIf}
FunctionEnd

Section
	SetOutPath "$TEMP\ArnesLink"
	File "ArnesLinkEn32.msi"
	File "ArnesLinkEn64.msi"
	File "ArnesLinkSl32.msi"
	File "ArnesLinkSl64.msi"
	File "arnes.arneslink-config-xml"

	DetailPrint "Run ArnesLink installer"
	ExecWait 'msiexec.exe /i "$OUTDIR\ArnesLink$myLanguage$Platform.msi" /qb' $0
	IfErrors 0 +3
		MessageBox MB_OK "Error installing ArnesLink.$\nEmbedded installer didn't complete succesfully.$\nReport: $0"
		Quit

	;These need admin premissions :-/.
	;SetShellVarContext all
	;CreateShortCut "$SMPROGRAMS\ArnesLink\Eduroam.si.lnk" "$INSTDIR\al_wlanmanager.exe" "profile eduroam.si"
	;CreateShortCut "$DESKTOP\Eduroam.si.lnk" "$INSTDIR\al_wlanmanager.exe" "profile eduroam.si"
	CreateDirectory "$SMPROGRAMS\ArnesLink\"
	CreateShortCut "$SMPROGRAMS\ArnesLink\Eduroam.si.lnk" "$INSTDIR\al_wlanmanager.exe" "profile eduroam.si"
	IfErrors 0 +2
		MessageBox MB_OK "Profile manager shortcut wasn't created! Continuing anyway!"

	DetailPrint "Fire up profile import"
	ClearErrors
	;ExecWait "%SystemRoot%\System32\netsh.exe wlan add profile user=all filename=$OUTDIR\Eduroam.si.arneslink-config-xml" $0
	;ExecShell "open" "%SystemRoot%\System32\netsh.exe" "wlan add profile user=all filename=$OUTDIR\Eduroam.si.arneslink-config-xml"
	;ExecWait '"$WINDIR\System32\netsh.exe" wlan add profile filename=$OUTDIR\Eduroam.si.arneslink-config-xml' $0
	ExecWait '"$INSTDIR\al_import.exe" arnes.arneslink-config-xml'
	IfErrors 0 +2
		MessageBox MB_OK "Wlan profile import failed! Continuing anyway!$\nMake sure to import wlan profile manually!"
SectionEnd
