/*
    Copyright 1991-2015 Amebis

    This file is part of AOsn.

    AOsn is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    AOsn is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AOsn. If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __AOSNP_H__
#define __AOSNP_H__

#include "AOsn.h"


////////////////////////////////////////////////////////////////////////////
// Zasebni lani imenskega prostora AOsn
////////////////////////////////////////////////////////////////////////////

namespace AOsn
{
    extern T_VERZIJAOS verzija_os;      // verzija operacijskega sistema
#ifndef _WIN64
    extern T_BOOL je_proces_wow64;      // ali na 32-bitni proces tee znotraj 64-bitnega okolja
#endif
    extern T_UINT st_vzpostavitev;      // kolikokrat smo vzpostavili knjinico AOsn
    extern T_ROCICAOS kljucavnica;      // sinhronizacija vzpostavitev in zakljuitev

#ifndef _WIN64
    extern BOOL    (WINAPI *IsWow64Process)(__in HANDLE hProcess, __out PBOOL Wow64Process);
#endif
#ifdef RDATUM_NALOZI_JEDRO
    extern VOID    (WINAPI *GetSystemTimeAsFileTime)(__out LPFILETIME lpSystemTimeAsFileTime);
#endif
    extern HWINSTA (WINAPI *GetProcessWindowStation)();
    extern BOOL    (WINAPI *GetUserObjectInformation)(__in HANDLE hObj, __in int nIndex, __out_opt PVOID pvInfo, __in DWORD nLength, __out_opt LPDWORD lpnLengthNeeded);

#ifdef AOSN_IZJEMA
    extern RNevarenOdsek kljucavnica_izjem;                     // sinhronizacija obdelave napak
    extern LPTOP_LEVEL_EXCEPTION_FILTER rokovalnik_izjem_prej;  // kazalec prejnjega rokovalnika izjem
    extern RIzjemeGlobalnaNit *izjeme_nit;                      // nit, ki v ozadju vzpostavi rokovanje izjem in preveri, ali aka kakna datoteka s poroilom o napaki na poiljanje in jo polje streniku
#endif

    extern HANDLE rocica_std[3]; // roice standardnega vhoda/izhoda/napake konzole
    extern T_BOOL je_konzola[3]; // logine spremenljivke, ki doloajo, ali je standardni vhod/izhod/napaka konzola ali datoteka
};

#endif // __AOSNP_H__
