/*
    Copyright 1991-2015 Amebis

    This file is part of AOsn.

    AOsn is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    AOsn is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AOsn. If not, see <http://www.gnu.org/licenses/>.
*/

#include "StdAfx.h"
#include "AOsn.h"


BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID)
{
    T_STANJE stanje;

    switch (fdwReason) {
    case DLL_PROCESS_ATTACH:
        // Vzpostavimo knjiznico.
        stanje = AOsn::Vzpostavi();
        if (NEUSPESNO(stanje)) {
            RNiz sporocilo, naslov;

            naslov.NastaviV(hinstDLL, IDS_AOSN_NASLOV);
            sporocilo.OblikujV(hinstDLL, IDS_AOSN_NAPAKA_VZPOSTAVITEV, AOSN_PRIVZETI_JEZIK, T_LOCALE_THREAD_DEFAULT, stanje);
            ::MessageBox(NULL, sporocilo, naslov, MB_OK | MB_ICONERROR);
            return FALSE;
        }
        break;

    case DLL_PROCESS_DETACH:
        // Preverimo, da je uporabnik zakljucil knjiznico AOsn tolikokrat, kolikokrat jo je vzpostavil!
        assert(AOsn::st_vzpostavitev == 1);

        // Prisilimo zakljucitev knjiznice v vsakem primeru.
        AOsn::st_vzpostavitev = 1;

        // Zakljucimo knjiznico.
        verify(USPESNO(AOsn::Zakljuci()));
        break;
    }

    return TRUE;
}
