/*
    Copyright 1991-2015 Amebis

    This file is part of AOsn.

    AOsn is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    AOsn is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AOsn. If not, see <http://www.gnu.org/licenses/>.
*/

#include "StdAfx.h"
#include "AOsn.h"
#ifdef RDATUM_NALOZI_JEDRO
#include "AOsnP.h"
#endif


RDatum::RDatum()
{
    datum = 0;
}


RDatum::RDatum(T_TRENUTEK datum)
{
    this->datum = datum;
}


RDatum::RDatum(T_U1 dan, T_U1 mesec, T_4 leto, T_U1 ura, T_U1 minuta, T_U1 sekunda, T_U2 milisekunda)
{
    NastaviDatum(dan, mesec, leto, ura, minuta, sekunda, milisekunda);
}


RDatum::RDatum(const T_DATUM *datum)
{
    NastaviDatum(datum);
}


RDatum::RDatum(const SYSTEMTIME *datum)
{
    NastaviDatum(datum);
}


RDatum::RDatum(const FILETIME *datum)
{
    NastaviDatum(datum);
}


RDatum::RDatum(DATE datum)
{
    NastaviDatum(datum);
}


T_TRENUTEK RDatum::VrniTrenutniCas()
{
    FILETIME cas;

#ifdef RDATUM_NALOZI_JEDRO
    verify(::WaitForSingleObject(AOsn::kljucavnica, INFINITE) == WAIT_OBJECT_0);
    assert(AOsn::st_vzpostavitev);
    assert(AOsn::GetSystemTimeAsFileTime);
    AOsn::GetSystemTimeAsFileTime(&cas);
    verify(::ReleaseMutex(AOsn::kljucavnica));
#else
    ::GetSystemTimeAsFileTime(&cas);
#endif

    return RDatum::Pretvori(&cas);
}
