/*
    Copyright 1991-2015 Amebis

    This file is part of AOsn.

    AOsn is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    AOsn is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AOsn. If not, see <http://www.gnu.org/licenses/>.
*/

#include "StdAfx.h"
#include "AOsn.h"


//////////////////////////////////////////////////////////////////////
// RElement
//////////////////////////////////////////////////////////////////////

RElement::RElement()
{
}


RElement::~RElement()
{
}


//////////////////////////////////////////////////////////////////////
// RSisElement
//////////////////////////////////////////////////////////////////////

RSisElement::RSisElement(T_ROCICAOS r) : RElement(), rocica(r)
{
}


RSisElement::RSisElement(const RSisElement &el) : RElement()
{
    assert(0); // TODO: Preizkusi ta del kode.
    verify(USPESNO(el.Podvoji(FALSE, &rocica)));
}


RSisElement::~RSisElement()
{
    // Si pozabil poklicati metodo Zapri()?
    assert(NI_VELJAVNA_ROCICA(rocica));
}


T_STANJE RSisElement::Uporabi(T_ROCICAOS rocica)
{
    // Trenutno razred RSisElement ne sme imeti veljavne roice, e mu pripenjamo novo.
    assert(NI_VELJAVNA_ROCICA(this->rocica));

    // Nastavimo novo roico (lahko je tudi neveljavna).
    this->rocica = rocica;
    return A_OK;
}


T_ROCICAOS RSisElement::Odpusti()
{
    T_ROCICAOS r = rocica;
    rocica = NEVELJAVNA_ROCICA;
    return r;
}


T_STANJE RSisElement::Zapri()
{
    // e je roica veljavna, jo zapremo in nastavimo na NEVELJAVNA_ROCICA, sicer vrnemo opozorilo.
    if (JE_VELJAVNA_ROCICA(rocica)) {
        if (::CloseHandle(rocica)) {
            rocica = NEVELJAVNA_ROCICA;
            return A_OK;
        } else {
            DWORD rezultat = ::GetLastError();
            if (rezultat == ERROR_INVALID_HANDLE) {
                // Element s to roico v bistvu ne obstaja (ve), oz. je e zaprt. Pravzaprav je stanje, ki smo ga s klicem te funkcije eleli dosei, e doseeno.
                rocica = NEVELJAVNA_ROCICA;
                return AOSN_OPOZORILO_ZE_ZAPRTA;
            } else
                return astanje(rezultat, AOSN_NAPAKA_ZAPIRANJE);
        }
    } else
        return AOSN_OPOZORILO_ZE_ZAPRTA;
}


T_STANJE RSisElement::Podvoji(T_BOOL deduj, T_ROCICAOS *nova_rocica) const
{
    return RSisElement::Podvoji(rocica, deduj, nova_rocica);
}
