/*
    Copyright 1991-2015 Amebis

    This file is part of AOsn.

    AOsn is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    AOsn is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AOsn. If not, see <http://www.gnu.org/licenses/>.
*/

#include "StdAfx.h"
#include "AOsn.h"

#ifdef AOSN_ISKDAT


T_STANJE RIskalnikDatotek::Odpri(TK_NIZ _pot)
{
    assert(NI_VELJAVNA_ROCICA(rocica));
    T_NIZ p;

    rocica = ::FindFirstFile(_pot, &podatki);
    if (JE_VELJAVNA_ROCICA(rocica)) {
        p = astrrchr(_pot, _T(LOCILO_IMENIKOV));
        if (p)
            pot.Nastavi(_pot, p - _pot + 1);
        else
            pot.Sprazni();

        konec = FALSE;
        return A_OK;
    } else {
        konec = TRUE;
        return astanje(::GetLastError(), AOSN_NAPAKA_ISKANJE);
    }
}


T_STANJE RIskalnikDatotek::Zapri()
{
    // Ne kliemo podedovanega RSisElement::Zapri(), saj iskalnik zapiramo s FindClose() in ne CloseHandle().
    if (JE_VELJAVNA_ROCICA(rocica)) {
        if (::FindClose(rocica)) {
            rocica = NEVELJAVNA_ROCICA;
            return A_OK;
        } else {
            DWORD rezultat = ::GetLastError();
            if (rezultat == ERROR_INVALID_HANDLE) {
                // Iskalnik s to roico v bistvu ne obstaja (ve), oz. je e zaprt. Pravzaprav je stanje, ki smo ga s klicem te funkcije eleli dosei, e doseeno.
                rocica = NEVELJAVNA_ROCICA;
                return AOSN_OPOZORILO_ZE_ZAPRTA;
            } else
                return astanje(rezultat, AOSN_NAPAKA_ZAPIRANJE);
        }
    } else
        return AOSN_OPOZORILO_ZE_ZAPRTA;
}


T_STANJE RIskalnikDatotek::Poisci(T_NAJDENADATOTEKA *_podatki)
{
    assert(_podatki);
    assert(JE_VELJAVNA_ROCICA(rocica));

    if (!konec) {
        T_UINT dolzina_poti = pot.VrniDolzino();

        _podatki->atributi               = podatki.dwFileAttributes;

        _podatki->datum.stvaritve        = RDatum::Pretvori(&podatki.ftCreationTime);
        _podatki->datum.zadnjega_dostopa = RDatum::Pretvori(&podatki.ftLastAccessTime);
        _podatki->datum.zadnje_spremembe = RDatum::Pretvori(&podatki.ftLastWriteTime);

        _podatki->dolzina = ((T_DOLZINA)podatki.nFileSizeHigh << 32) | podatki.nFileSizeLow;

        astrncpy2(_podatki->kratko_ime_datoteke, 14, podatki.cAlternateFileName, 14);
        astrncpy2(_podatki->pot_datoteke, MAX_PATH, pot.Vrni(), dolzina_poti);
        astrncpy2(_podatki->pot_datoteke + dolzina_poti, MAX_PATH - dolzina_poti, podatki.cFileName, MAX_PATH - dolzina_poti);
        _podatki->ime_datoteke = _podatki->pot_datoteke + dolzina_poti;

        if (!::FindNextFile(rocica, &podatki))
            konec = TRUE;
        return A_OK;
    } else
        return AOSN_NAPAKA_NI_VEC_ZADETKOV;
}

#endif // AOSN_ISKDAT
