/*
    Copyright 1991-2015 Amebis

    This file is part of AOsn.

    AOsn is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    AOsn is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AOsn. If not, see <http://www.gnu.org/licenses/>.
*/

#include "StdAfx.h"
#include "AOsn.h"

#ifdef AOSN_KAZNAP


//////////////////////////////////////////////////////////////////////
// RKazalnikNapredka
//////////////////////////////////////////////////////////////////////

T_VOID RKazalnikNapredka::NastaviBesedilo(TK_NIZ)
{
}


T_VOID RKazalnikNapredka::NastaviBesedilo(T_UINT)
{
}


T_VOID RKazalnikNapredka::NastaviObmocje(T_INT, T_INT)
{
}


T_VOID RKazalnikNapredka::Nastavi(T_INT)
{
}


T_VOID RKazalnikNapredka::Prikazi(T_BOOL)
{
}


T_BOOL RKazalnikNapredka::PrekiniPostopek()
{
    return FALSE;
}


//////////////////////////////////////////////////////////////////////
// RCasKazalnikNapredka
//////////////////////////////////////////////////////////////////////

RCasKazalnikNapredka::RCasKazalnikNapredka(T_UINT c_k) :
    RKazalnikNapredka(),
    casovna_kontrola(c_k),
    zadnja_milisekunda(0),
    zacetek(0),
    konec(0),
    trenutni(-1)
{
}


T_VOID RCasKazalnikNapredka::NastaviObmocje(T_INT zacetek, T_INT konec)
{
    this->zacetek = zacetek;
    this->konec = konec;
    this->PraviNastaviObmocje();
}


T_VOID RCasKazalnikNapredka::Nastavi(T_INT trenutni)
{
    if (trenutni == this->zacetek || trenutni == this->konec) {
        // e je napredek enak zaetku ali koncu, osveimo.
        this->zadnja_milisekunda = ::GetTickCount();
    } else if (trenutni == this->trenutni) {
        // e ni spremembe napredka, ni treba narediti niesar.
        return;
    } else {
        DWORD cas = ::GetTickCount();
        if ((cas - this->zadnja_milisekunda) < casovna_kontrola) {
            // asovna kontrola e ni potekla, zato ne naredimo niesar.
            return;
        }
        this->zadnja_milisekunda = cas;
    }

    // e smo prili do tukaj, osveimo napredek.
    this->trenutni = trenutni;
    this->PraviNastavi();
}


T_VOID RCasKazalnikNapredka::PraviNastaviObmocje()
{
}


T_VOID RCasKazalnikNapredka::PraviNastavi()
{
}


//////////////////////////////////////////////////////////////////////
// RGlobalniKazalnikNapredka
//////////////////////////////////////////////////////////////////////

RGlobalniKazalnikNapredka::RGlobalniKazalnikNapredka(RKazalnikNapredka *kazalnik)
{
    this->kazalnik = kazalnik;
}


T_VOID RGlobalniKazalnikNapredka::NastaviBesedilo(TK_NIZ besedilo)
{
    if (kazalnik)
        kazalnik->NastaviBesedilo(besedilo);
}


T_VOID RGlobalniKazalnikNapredka::NastaviBesedilo(T_UINT id_res)
{
    if (kazalnik)
        kazalnik->NastaviBesedilo(id_res);
}


T_VOID RGlobalniKazalnikNapredka::NastaviObmocje(T_INT zacetek, T_INT konec)
{
    kaz.zacetek = zacetek;
    kaz.konec = konec;
}


T_VOID RGlobalniKazalnikNapredka::Nastavi(T_INT trenutni)
{
    T_INT dolzina = kaz.VrniDolzino();

    if (dolzina) {
        T_INT x = amuldiv(trenutni - kaz.zacetek, odsek.VrniDolzino(), dolzina) + odsek.zacetek;

        if (kazalnik)
            kazalnik->Nastavi(x);
    }
}


T_VOID RGlobalniKazalnikNapredka::Prikazi(T_BOOL pokazi)
{
    if (kazalnik)
        kazalnik->Prikazi(pokazi);
}


T_BOOL RGlobalniKazalnikNapredka::PrekiniPostopek()
{
    return kazalnik ? kazalnik->PrekiniPostopek() : FALSE;
}

#endif // AOSN_KAZNAP
