/*
    Copyright 1991-2015 Amebis

    This file is part of MSIMSM.

    MSIMSM is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    MSIMSM is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with MSIMSM. If not, see <http://www.gnu.org/licenses/>.
*/

#include "StdAfx.h"


/////////////////////////////////////////////////////////////////////////////
// CMSIMSMModule
/////////////////////////////////////////////////////////////////////////////

class CMSIMSMModule : public CAtlExeModuleT<CMSIMSMModule>
{
public :
    DECLARE_LIBID(LIBID_MSIMSMLib)
};


#define MIDL_DEFINE_GUID(type,name,l,w1,w2,b1,b2,b3,b4,b5,b6,b7,b8) \
        const type name = {l,w1,w2,{b1,b2,b3,b4,b5,b6,b7,b8}}

MIDL_DEFINE_GUID(IID, IID_IEnumMsmString, 0x0ADDA826,0x2C26,0x11D2, 0xAD,0x65,0x00,0xA0,0xC9,0xAF,0x11,0xA6);
MIDL_DEFINE_GUID(IID, IID_IMsmStrings, 0x0ADDA827,0x2C26,0x11D2, 0xAD,0x65,0x00,0xA0,0xC9,0xAF,0x11,0xA6);
MIDL_DEFINE_GUID(IID, IID_IMsmError, 0x0ADDA828,0x2C26,0x11D2, 0xAD,0x65,0x00,0xA0,0xC9,0xAF,0x11,0xA6);
MIDL_DEFINE_GUID(IID, IID_IEnumMsmError, 0x0ADDA829,0x2C26,0x11D2, 0xAD,0x65,0x00,0xA0,0xC9,0xAF,0x11,0xA6);
MIDL_DEFINE_GUID(IID, IID_IMsmErrors, 0x0ADDA82A,0x2C26,0x11D2, 0xAD,0x65,0x00,0xA0,0xC9,0xAF,0x11,0xA6);
MIDL_DEFINE_GUID(IID, IID_IMsmDependency, 0x0ADDA82B,0x2C26,0x11D2, 0xAD,0x65,0x00,0xA0,0xC9,0xAF,0x11,0xA6);
MIDL_DEFINE_GUID(IID, IID_IEnumMsmDependency, 0x0ADDA82C,0x2C26,0x11D2, 0xAD,0x65,0x00,0xA0,0xC9,0xAF,0x11,0xA6);
MIDL_DEFINE_GUID(IID, IID_IMsmDependencies, 0x0ADDA82D,0x2C26,0x11D2, 0xAD,0x65,0x00,0xA0,0xC9,0xAF,0x11,0xA6);
MIDL_DEFINE_GUID(IID, IID_IMsmMerge, 0x0ADDA82E,0x2C26,0x11D2, 0xAD,0x65,0x00,0xA0,0xC9,0xAF,0x11,0xA6);
MIDL_DEFINE_GUID(IID, IID_IMsmGetFiles, 0x7041ae26, 0x2d78, 0x11d2, 0x88, 0x8a, 0x0, 0xa0, 0xc9, 0x81, 0xb0, 0x15);

MIDL_DEFINE_GUID(IID, LIBID_MsmMergeTypeLib, 0x0ADDA82F,0x2C26,0x11D2, 0xAD,0x65,0x00,0xA0,0xC9,0xAF,0x11,0xA6);
MIDL_DEFINE_GUID(CLSID, CLSID_MsmMerge, 0x0ADDA830,0x2C26,0x11D2, 0xAD,0x65,0x00,0xA0,0xC9,0xAF,0x11,0xA6);

#if (_WIN32_MSM >= 150)
MIDL_DEFINE_GUID(IID, IID_IMsmMerge2, 0x351A72AB, 0x21CB, 0x47AB, 0xB7, 0xAA, 0xC4, 0xD7, 0xB0, 0x2E, 0xA3, 0x05);
MIDL_DEFINE_GUID(IID, IID_IMsmConfigurableItem, 0x4D6E6284, 0xD21D, 0x401E, 0x84, 0xF6, 0x90, 0x9E, 0x00, 0xB5, 0x0F, 0x71);
MIDL_DEFINE_GUID(IID, IID_IEnumMsmConfigurableItem, 0x832C6969, 0x4826, 0x4C24, 0xA3, 0x97, 0xB7, 0x00, 0x2D, 0x81, 0x96, 0xE6);
MIDL_DEFINE_GUID(IID, IID_IMsmConfigurableItems, 0x55BF723C, 0x9A0D, 0x463E, 0xB4, 0x2B, 0xB4, 0xFB, 0xC7, 0xBE, 0x3C, 0x7C);
MIDL_DEFINE_GUID(IID, IID_IMsmConfigureModule, 0xAC013209, 0x18A7, 0x4851, 0x8A, 0x21, 0x23, 0x53, 0x44, 0x3D, 0x70, 0xA0);
MIDL_DEFINE_GUID(CLSID, CLSID_MsmMerge2, 0xF94985D5,0x29F9,0x4743, 0x98,0x05,0x99,0xBC,0x3F,0x35,0xB6,0x78);
#endif

MIDL_DEFINE_GUID(IID, LIBID_MSIMSMLib, 0x4DCFE636, 0x59D8, 0x440A, 0x81, 0xD7, 0xE4, 0x86, 0x74, 0x9F, 0xCF, 0xB0);
MIDL_DEFINE_GUID(CLSID, CLSID_Nastavljalnik, 0x60222E15, 0x6FDE, 0x47E0, 0xBC, 0xC5, 0x30, 0xA9, 0x94, 0x33, 0xE8, 0x97);

#undef MIDL_DEFINE_GUID


T_VOID _IzpisiNastavitve(RSeznamNastavitev *nast, TK_UNICODE koren = L"")
{
    assert(nast);
    T_ROCICA rocica;

    for (rocica = nast->VrniPrvega(); rocica; rocica = nast->VrniNaslednjega(rocica)) {
        T_NASTZAPIS &el = nast->VrniElement(rocica);
        RSeznamNastavitev *n;
        RNizU *niz;
        
        if ((n = dynamic_cast<RSeznamNastavitev*>(el.element)) != NULL) {
            RNizU novi_koren(koren);
            novi_koren += _L(LOCILO_IMENIKOV);
            novi_koren.Prilepi(el.id, RSEZNAST_DOLZINA_ID);
            _IzpisiNastavitve(n, novi_koren);
        } else if ((niz = dynamic_cast<RNizU*>(el.element)) != NULL) {
            AOsn::IzpisiO(AOSN_STD_NAPAKA, _T("%ls%c%.*ls=%.*ls\n"), AOsn::locale_OCP, koren, LOCILO_IMENIKOV, RSEZNAST_DOLZINA_ID, el.id, niz->VrniDolzino(), niz->Vrni());
        } else
            AOsn::IzpisiO(AOSN_STD_NAPAKA, _T("%ls%c%.*ls=???\n"), AOsn::locale_OCP, koren, LOCILO_IMENIKOV, RSEZNAST_DOLZINA_ID, el.id);
    }
}


inline T_VOID _VrniNaslednjiElement(TK_UNICODE deli, T_UINT &zacetek, T_UINT &konec)
{
    TK_UNICODE presledek;
    
    // Preskoimo presledke na zaetku.
    for (; deli[zacetek] == L' '; zacetek++);

    // Poiemo naslednji presledek.
    presledek = astrchr(deli + zacetek, L' ');
    konec = presledek ? presledek - deli : zacetek + astrlen(deli + zacetek);
}


inline T_UINT _IzpisiNize(IMsmStrings *seznam, RNizU &izhod)
{
    assert(seznam);

    long i, n;
    BSTR bstr;

    verify(SUCCEEDED(seznam->get_Count(&n)));
    for (i = 0; i < n; i++) {
        verify(SUCCEEDED(seznam->get_Item(i + 1, &bstr)));
        if (i) izhod.Prilepi(L' ');
        izhod.Prilepi(bstr, ::SysStringLen(bstr));
        ::SysFreeString(bstr);
    }

    return n;
}


inline T_UINT _IzpisiNize2(IMsmStrings *seznam, IMsmMerge *zlivalnik, TK_UNICODE koren = _T(""))
{
    assert(seznam);

    long i, n;
    BSTR bstr;
    RNizU niz;

    verify(SUCCEEDED(seznam->get_Count(&n)));
    for (i = 0; i < n; i++) {
        verify(SUCCEEDED(seznam->get_Item(i + 1, &bstr)));
        niz.Nastavi(koren);
        niz.Prilepi(bstr, ::SysStringLen(bstr));
        zlivalnik->Log((BSTR)niz.Vrni());
        ::SysFreeString(bstr);
    }

    return n;
}


inline T_UINT _IzpisiNapake(IMsmErrors *napake, IMsmMerge *zlivalnik) 
{
    assert(napake && zlivalnik);

    long i, n;
    short jezik;
    IMsmStrings *seznam_nizov;
    BSTR bstr;
    RNizU besedilo;
    
    verify(SUCCEEDED(napake->get_Count(&n)));
    for (i = 0; i < n; i++) {
        IMsmError *napaka;
        msmErrorType vrsta_napake;

        verify(SUCCEEDED(napake->get_Item(i + 1, &napaka)));
        verify(SUCCEEDED(napaka->get_Type(&vrsta_napake)));

        besedilo.Nastavi(L">> Error: ");

        switch (vrsta_napake) {
        case msmErrorLanguageUnsupported:
            verify(SUCCEEDED(napaka->get_Language(&jezik)));
            besedilo.PrilepiO(L"A request was made to open a module with a language not supported by the module. No more general language is supported by the module. Language code: %Iu", AOsn::locale_ACP, (T_UINT)jezik);
            break;

        case msmErrorLanguageFailed:
            verify(SUCCEEDED(napaka->get_Language(&jezik)));
            besedilo.PrilepiO(L"A request was made to open a module with a supported language but the module has an invalid language transform. Language code: %Iu", AOsn::locale_ACP, (T_UINT)jezik);
            break;

        case msmErrorExclusion:
            besedilo.PrilepiO(L"The module cannot be merged because it excludes, or is excluded by, another module in the database.", AOsn::locale_ACP);
            break;

        case msmErrorTableMerge:
            besedilo.PrilepiO(L"Merge conflict during merge.", AOsn::locale_ACP);
            break;

        case msmErrorResequenceMerge:
            besedilo.PrilepiO(L"There was a problem resequencing a sequence table to contain the necessary merged actions.", AOsn::locale_ACP);
            break;

        case msmErrorDirCreate:
            verify(SUCCEEDED(napaka->get_Path(&bstr)));
            besedilo.PrilepiO(L"There was a problem creating a directory to extract a file to disk. Path: \"%.*ls\"", AOsn::locale_ACP, ::SysStringLen(bstr), bstr);
            ::SysFreeString(bstr);
            break;

        case msmErrorFeatureRequired:
            besedilo.PrilepiO(L"A feature name is required to complete the merge, but no feature name was provided.", AOsn::locale_ACP);
            break;

        case msmErrorBadNullSubstitution:
            besedilo.PrilepiO(L"Substitution of a Null value into a non-nullable column.", AOsn::locale_ACP);
            break;

        case msmErrorBadSubstitutionType:
            besedilo.PrilepiO(L"Substitution of Text Format Type or Integer Format Type into a Binary Type data column.", AOsn::locale_ACP);
            break;

        case msmErrorMissingConfigItem:
            besedilo.PrilepiO(L"A row in the ModuleSubstitution table references a configuration item not defined in the ModuleConfiguration table.", AOsn::locale_ACP);
            break;

        case msmErrorBadNullResponse:
            besedilo.PrilepiO(L"The authoring tool has returned a Null value for an item marked with the msmConfigItemNonNullable attribute.", AOsn::locale_ACP);
            break;

        case msmErrorDataRequestFailed:
            besedilo.PrilepiO(L"The authoring tool returned a failure code (not S_OK or S_FALSE) when asked for data.", AOsn::locale_ACP);
            break;

        case msmErrorPlatformMismatch:
            besedilo.PrilepiO(L"Indicates that an attempt was made to merge a 64-bit module into a package that was not a 64-bit package.", AOsn::locale_ACP);
            break;

        default:
            besedilo.PrilepiO(L"Unknown error type. Type code: %Iu", AOsn::locale_ACP, (T_UINT)vrsta_napake);
        }
        zlivalnik->Log((BSTR)besedilo.Vrni());

        verify(SUCCEEDED(napaka->get_DatabaseTable(&bstr)));
        verify(SUCCEEDED(napaka->get_DatabaseKeys(&seznam_nizov)));
        besedilo.Oblikuj(L"   o Database, table: %.*ls, row: ", AOsn::locale_ACP, ::SysStringLen(bstr), bstr);
        _IzpisiNize(seznam_nizov, besedilo);
        seznam_nizov->Release();
        ::SysFreeString(bstr);
        zlivalnik->Log((BSTR)besedilo.Vrni());

        verify(SUCCEEDED(napaka->get_ModuleTable(&bstr)));
        verify(SUCCEEDED(napaka->get_ModuleKeys(&seznam_nizov)));
        besedilo.Oblikuj(L"   o Module, table: %.*ls, row: ", AOsn::locale_ACP, ::SysStringLen(bstr), bstr);
        _IzpisiNize(seznam_nizov, besedilo);
        seznam_nizov->Release();
        ::SysFreeString(bstr);
        zlivalnik->Log((BSTR)besedilo.Vrni());

        napaka->Release();
    }

    return n;
}


T_REZULTAT amain(T_UINT argc, TK_NIZ argv[])
{
#ifndef AOSN_DLLIMP
    verify(USPESNO(AOsn::Vzpostavi()));
#endif

    // Nastavimo locale modulu.
    asetlocale(LC_ALL, _T(".OCP"));

    T_REZULTAT rezultat;

    {
        HRESULT hr;
        IMsmMerge2 *zlivalnik;
        T_UINT i;
        CMSIMSMModule modul_atl;
        RNiz
            datoteka_paket,
            datoteka_modul,
            datoteka_nastavitve,
            datoteka_dnevnik,
            pot_datoteke;
        CComObject<CNastavljalnik> *nastavitve;
        T_STANJE stanje;
        BSTR bstr, bstr2;
        T_BOOL
            shrani_spremembe = FALSE,
            dolga_imena_datotek = FALSE;
        IMsmErrors *napake;

        if (argc < 3) {
            AOsn::IzpisiO(AOSN_STD_NAPAKA,
                _T("MSIMSM - Orodje za zlivanje namestitvenih paketov MSI v%s. Copyright Amebis, d. o. o., Kamnik, 2006-") _T(BUILD_YEAR_STR) _T("\n\n")
                _T("Uporaba:\n\n")
                _T("  MSIMerge.js <paket.msi> <modul.msm> [<stikala>]\n\n")
                _T("    <paket.msi>  namestitveni paket, v katerega dodajamo modul\n")
                _T("    <modul.msm>  modul, ki ga dodajamo v namestitveni paket\n\n")
                _T("  Stikala (velikost rk ni pomembna):\n")
                _T("    /N <nastavitve.msmcfg>  datoteka z nastavitvami za zlivanje\n")
                _T("    /D <dnevnik.log>        datoteka z dnevnikom\n")
                _T("    /Sd <pot>               pot, kamor shrani datoteke modula (dolga imena datotek)\n")
                _T("    /Sk <pot>               pot, kamor shrani datoteke modula (kratka imena datotek)\n")
                _T("    /F                      shrani spremembe v namestitveni paket tudi v primeru napak\n\n"), AOsn::locale_OCP,
                _T(MSIMSM_VERZIJA_STR)
            );

            rezultat = 1;
            goto napaka1;
        }

        datoteka_paket = argv[1];
        datoteka_modul = argv[2];

        for (i = 3; i < argc; i++) {
            if (!astricmp(argv[i], _T("/n"))) {
                // Nali smo parameter /n za nastavitve.
                if (++i < argc)
                    datoteka_nastavitve = argv[i];
                else {
                    AOsn::IzpisiO(AOSN_STD_NAPAKA, _T("Manjka ime datoteke z nastavitvami pri parametru /N.\n"), AOsn::locale_OCP);
                    rezultat = 2;
                    goto napaka1;
                }
            } else if (!astricmp(argv[i], _T("/d"))) {
                // Nali smo parameter /d za dnevnik.
                if (++i < argc)
                    datoteka_dnevnik = argv[i];
                else {
                    AOsn::IzpisiO(AOSN_STD_NAPAKA, _T("Manjka ime datoteke z dnevnikom pri parametru /D.\n"), AOsn::locale_OCP);
                    rezultat = 2;
                    goto napaka1;
                }
            } else if (!astrnicmp(argv[i], _T("/s"), 2)) {
                // Nali smo parameter /s za shranjevanje datotek.
                switch (argv[i][2]) {
                    case _T('D'):
                    case _T('d'): dolga_imena_datotek = TRUE; break;
                    case _T('K'):
                    case _T('k'): dolga_imena_datotek = FALSE; break;
                    default:
                        AOsn::IzpisiO(AOSN_STD_NAPAKA, _T("Napana oblika parametra /S.\n"), AOsn::locale_OCP);
                        rezultat = 2;
                        goto napaka1;
                }
                if (++i < argc)
                    pot_datoteke = argv[i];
                else {
                    AOsn::IzpisiO(AOSN_STD_NAPAKA, _T("Manjka ime poti pri parametru /Sd oziroma /Sk.\n"), AOsn::locale_OCP);
                    rezultat = 2;
                    goto napaka1;
                }
            } else if (!astricmp(argv[i], _T("/f"))) {
                // Nali smo parameter /f
                shrani_spremembe = TRUE;
            } else {
                AOsn::IzpisiO(AOSN_STD_NAPAKA, _T("Neznan parameter %s.\n"), AOsn::locale_OCP, argv[i]);
                rezultat = 2;
                goto napaka1;
            }
        }

        hr = ::CoInitialize(NULL);
        if (FAILED(hr)) {
            AOsn::IzpisiO(AOSN_STD_NAPAKA, _T("Pri vzpostavitvi COM je prilo do napake (koda MS %#010I32x).\n"), AOsn::locale_OCP, hr);
            rezultat = 5;
            goto napaka1;
        }

        hr = CComObject<CNastavljalnik>::CreateInstance(&nastavitve);
        if (FAILED(hr)) {
            AOsn::IzpisiO(AOSN_STD_NAPAKA, _T("Napaka pri stvaritvi nastavljalnika (koda MS %#010I32x).\n"), AOsn::locale_OCP, hr);
            rezultat = 2;
            goto napaka2;
        }
        nastavitve->AddRef();

        // Napolnimo nastavitve s privzetimi vrednostmi.
        RSeznamNastavitev *nastavitve_splosno = new RSeznamNastavitev();
        nastavitve_splosno->Nastavi(_T("jezik"), new RNiz(_T("0")));
        nastavitve_splosno->Nastavi(_T("imenik"), new RNiz(_T("TARGETDIR")));
        nastavitve_splosno->Nastavi(_T("deli"), new RNiz(_T("")));
        nastavitve->Nastavi(_T("splosno"), nastavitve_splosno);

        if (!datoteka_nastavitve.JePrazen()) {
            RMedFizDatoteka dat;
            T_KODNASTRAN kodna_stran;
            RNizU vrstica, razdelek;
            T_UINT st_vrstice;

            // Odpremo datoteko z nastavitvami za branje.
            stanje = dat.Odpri(datoteka_nastavitve, RDAT_BRANJE | RDAT_SH_BERI | RDAT_TEKSTOVNO | RDAT_DOSTOP_ZAPOREDEN);
            if (NEUSPESNO(stanje)) {
                AOsn::IzpisiO(AOSN_STD_NAPAKA, _T("Napaka pri odpiranju datoteke %.*s (koda %#010I32x).\n"), AOsn::locale_OCP, datoteka_nastavitve.VrniDolzino(), datoteka_nastavitve.Vrni(), stanje);
                rezultat = 3;
                goto napaka3;
            }

            // Doloimo kodno stran datoteke z nastavitvami.
            kodna_stran = dat.DolociKodnoStran();

            for (st_vrstice = 0; ; st_vrstice++) {
                T_UINT i;

                dat.PreberiVrstico(vrstica, kodna_stran);
                stanje = dat.VrniStanje();
                if (stanje == AOSN_NAPAKA_KONEC_TOKA)
                    break;
                else if (NEUSPESNO(stanje)) {
                    AOsn::IzpisiO(AOSN_STD_NAPAKA, _T("Napaka pri branju datoteke %.*s (koda %#010I32x).\n"), AOsn::locale_OCP, datoteka_nastavitve.VrniDolzino(), datoteka_nastavitve.Vrni(), stanje);
                    rezultat = 3;
                    goto napaka3;
                }

                // Poistimo presledke spredaj in zadaj.
                vrstica.Poravnaj();
                if (!vrstica.VrniDolzino() || vrstica.VrniZnak(0) == L'#') {
                    // Nali smo komentar ali prazno vrstico.
                    continue;
                }

                if (vrstica.VrniZnak(0) == L'[' && vrstica.VrniZnak(vrstica.VrniDolzino()-1) == L']') {
                    // Nasli smo nov razdelek [xxx]
                    razdelek = vrstica.Sredina(1, vrstica.VrniDolzino()-2);
                    razdelek.Poravnaj();

                    // e razdelka e ni v tabeli nastavitev, ga dodamo.
                    if (!nastavitve->Vrni(razdelek))
                        nastavitve->Nastavi(razdelek, new RSeznamNastavitev());

                    continue;
                }

                if ((i = vrstica.Najdi('=')) != T_UINT_MAX) {
                    // Nali smo novo nastavitev, ki jo dodamo v trenutni razdelek.
                    RNizU
                        ime(vrstica, i),
                        *vrednost = new RNiz(vrstica.Vrni() + i + 1);

                    ime.Poravnaj();
                    vrednost->Poravnaj();

                    dynamic_cast<RSeznamNastavitev*>(nastavitve->Vrni(razdelek))->Nastavi(ime, vrednost);
                    continue;
                }

                // Nali smo napako v sintaksi vrstice.
                AOsn::IzpisiO(AOSN_STD_NAPAKA, _T("%.*s(%Iu): Napaka v sintaksi.\n"), AOsn::locale_OCP, datoteka_nastavitve.VrniDolzino(), datoteka_nastavitve.Vrni(), st_vrstice+1);
                rezultat = 4;
                goto napaka3;
            }
        }

#ifdef _DEBUG
        // Diagnostino izpiemo prebrane nastavitve.
        _IzpisiNastavitve(nastavitve);
#endif

        hr = ::CoCreateInstance(CLSID_MsmMerge2, NULL, CLSCTX_ALL, IID_IMsmMerge2, (LPVOID*)&zlivalnik);
        if (FAILED(hr)) {
            AOsn::IzpisiO(AOSN_STD_NAPAKA, _T("Pri stvaritvi IMsmMerge2 je prilo do napake (koda MS %#010I32x).\n"), AOsn::locale_OCP, hr);
            rezultat = 6;
            goto napaka3;
        }

        if (!datoteka_dnevnik.JePrazen()) {
            // Odpremo dnevnik

            // Najprej zbriemo datoteko z dnevnikom, e obstaja, saj IMsmMerge2 le dodaja v dnevnik.
            AOsn::ZbrisiDatoteko(datoteka_dnevnik);

            // Poizkusimo odpreti datoteko z dnevnikom.
            bstr = datoteka_dnevnik.VrniBSTR();
            hr = zlivalnik->OpenLog(bstr);
            ::SysFreeString(bstr);
            if (NEUSPESNO(hr)) {
                AOsn::IzpisiO(AOSN_STD_NAPAKA, _T("Pri odpiranju dnevnika %.*s je prilo do napake (koda MS %#010I32x).\n"), AOsn::locale_OCP, datoteka_dnevnik.VrniDolzino(), datoteka_dnevnik.Vrni(), hr);
                rezultat = 7;
                goto napaka4;
            }
        }

        // Odpremo namestitveni paket
        bstr = datoteka_paket.VrniBSTR();
        hr = zlivalnik->OpenDatabase(bstr);
        ::SysFreeString(bstr);
        if (NEUSPESNO(hr)) {
            AOsn::IzpisiO(AOSN_STD_NAPAKA, _T("Pri odpiranju namestitvenega paketa %.*s je prilo do napake (koda MS %#010I32x).\n"), AOsn::locale_OCP, datoteka_paket.VrniDolzino(), datoteka_paket.Vrni(), hr);
            rezultat = 7;
            goto napaka5;
        }

        // Odpremo modul.
        bstr = datoteka_modul.VrniBSTR();
        hr = zlivalnik->OpenModule(bstr, (short)astrtou4(dynamic_cast<RNizU*>(dynamic_cast<RSeznamNastavitev*>(nastavitve->Vrni(_T("splosno")))->Vrni(_T("jezik")))->Vrni(), T_UINT_MAX, NULL, 10));
        ::SysFreeString(bstr);
        if (NEUSPESNO(hr)) {
            AOsn::IzpisiO(AOSN_STD_NAPAKA, _T("Pri odpiranju modula %.*s je prilo do napake (koda MS %#010I32x).\n"), AOsn::locale_OCP, datoteka_modul.VrniDolzino(), datoteka_modul.Vrni(), hr);
            rezultat = 7;
            goto napaka6;
        }

        // Sedaj zlijemo modul z namestitvenim paketom.
        RNiz *deli = dynamic_cast<RNizU*>(dynamic_cast<RSeznamNastavitev*>(nastavitve->Vrni(_T("splosno")))->Vrni(_T("deli")));
        assert(deli);
        T_UINT zacetek_delov = 0, konec_delov;
        _VrniNaslednjiElement(deli->Vrni(), zacetek_delov, konec_delov);
        bstr = zacetek_delov < konec_delov ?
            deli->Sredina(zacetek_delov, konec_delov - zacetek_delov).VrniBSTR() :
            ::SysAllocString(L"");
        bstr2 = dynamic_cast<RNizU*>(dynamic_cast<RSeznamNastavitev*>(nastavitve->Vrni(_T("splosno")))->Vrni(_T("imenik")))->VrniBSTR();
        hr = zlivalnik->MergeEx(bstr, bstr2, nastavitve);
        ::SysFreeString(bstr2);
        ::SysFreeString(bstr);
        if (NEUSPESNO(hr)) {
            AOsn::IzpisiO(AOSN_STD_NAPAKA, _T("Pri zlivanju modula z namestitvenim paketom je prilo do napake (koda MS %#010I32x).\n"), AOsn::locale_OCP, hr);
            rezultat = 7;
            goto napaka6;
        }

        // Poveemo modul s preostalimi deli
        for (;;) {
            zacetek_delov = konec_delov;
            _VrniNaslednjiElement(deli->Vrni(), zacetek_delov, konec_delov);
            if (zacetek_delov >= konec_delov)
                break;

            bstr = deli->Sredina(zacetek_delov, konec_delov - zacetek_delov).VrniBSTR();
            hr = zlivalnik->Connect(bstr);
            if (FAILED(hr)) {
                AOsn::IzpisiO(AOSN_STD_NAPAKA, _T("Pri zlivanju z delom %.*ls je prilo do napake (koda MS %#010I32x).\n"), AOsn::locale_OCP, ::SysStringLen(bstr), bstr, hr);
                ::SysFreeString(bstr);
                rezultat = 7;
                goto napaka7;
            } else
                ::SysFreeString(bstr);
        }

        // Pogledamo, e smo naleteli na kaj napak.
        hr = zlivalnik->get_Errors(&napake);
        if (FAILED(hr)) {
            AOsn::IzpisiO(AOSN_STD_NAPAKA, _T("Pri ugotavljanju napak je prilo do napake (koda MS %#010I32x).\n"), AOsn::locale_OCP, hr);
            rezultat = 7;
            goto napaka7;
        }
        if ((i = _IzpisiNapake(napake, (IMsmMerge*)zlivalnik)) != 0 && !shrani_spremembe) {
            AOsn::IzpisiO(AOSN_STD_NAPAKA, _T("Pri zlivanju je prilo do napak (t. napak: %Iu). Preberite datoteko z dnevnikom.\n"), AOsn::locale_OCP, (T_UINT)i);
            rezultat = 7;
            goto napaka8;
        }

        if (!pot_datoteke.JePrazen()) {
            // Uporabnik je elel izloiti datoteke iz modula.
            IMsmStrings *seznam_datotek = NULL;
            RNizU besedilo;

            bstr = pot_datoteke.VrniBSTR();
            hr = zlivalnik->ExtractFilesEx(bstr, dolga_imena_datotek, &seznam_datotek);
            if (SUCCEEDED(hr))
                besedilo.Oblikuj(L"Succesfully extracted following module files to \"%.*ls\" (%ls names):", AOsn::locale_ACP, ::SysStringLen(bstr), bstr, dolga_imena_datotek ? L"long" : L"short");
            else
                besedilo.Oblikuj(L">> Error: Error %#010I32x extracting module files to \"%ls\" (%ls names):", AOsn::locale_ACP, hr, bstr, dolga_imena_datotek ? L"long" : L"short");
            zlivalnik->Log((BSTR)besedilo.Vrni());
            if (seznam_datotek)
                _IzpisiNize2(seznam_datotek, (IMsmMerge*)zlivalnik, _T("   o "));

            ::SysFreeString(bstr);
            if (seznam_datotek) seznam_datotek->Release();

            if (FAILED(hr)) {
                AOsn::IzpisiO(AOSN_STD_NAPAKA, _T("Pri izvozu datotek je prilo do napake (koda MS %#010I32x). Preberite datoteko z dnevnikom.\n"), AOsn::locale_OCP, hr);
                rezultat = 7;
                goto napaka8;
            }
        }
        
        rezultat = 0;

napaka8:
        napake->Release();
napaka7:
        verify(SUCCEEDED(zlivalnik->CloseModule()));
napaka6:
#ifdef _DEBUG
        // V diagnostini razliici nikoli ne shranjujemo sprememb v bazo.
        verify(SUCCEEDED(zlivalnik->CloseDatabase(FALSE)));
#else
        verify(SUCCEEDED(zlivalnik->CloseDatabase(shrani_spremembe)));
#endif
napaka5:
        if (!datoteka_dnevnik.JePrazen())
            verify(SUCCEEDED(zlivalnik->CloseLog()));
napaka4:
        zlivalnik->Release();
napaka3:
        nastavitve->Release();
napaka2:
        ::CoUninitialize();
napaka1:;
    }

    verify(USPESNO(AOsn::PocakajVzpostavitev()));
#ifndef AOSN_DLLIMP
    verify(USPESNO(AOsn::Zakljuci()));
#endif
    adumpheap();
    return rezultat;
}
