/*
    Copyright 1991-2015 Amebis

    This file is part of MSIMSM.

    MSIMSM is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    MSIMSM is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with MSIMSM. If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include "MSIMSM_h.h"
#include "AOsn.h"


////////////////////////////////////////////////////////////////////////////
// CNastavljalnik
////////////////////////////////////////////////////////////////////////////

class ATL_NO_VTABLE CNastavljalnik :
    public CComObjectRootEx<CComGlobalsThreadModel>,
    public CComCoClass<CNastavljalnik, &CLSID_Nastavljalnik>,
    public IDispatchImpl<IMsmConfigureModule, &IID_IMsmConfigureModule, &LIBID_MSIMSMLib, /*wMajor =*/ 1, /*wMinor =*/ 0>,
    public RSeznamNastavitev
{
public:
    DECLARE_PROTECT_FINAL_CONSTRUCT()

    BEGIN_COM_MAP(CNastavljalnik)
        COM_INTERFACE_ENTRY(IMsmConfigureModule)
        COM_INTERFACE_ENTRY(IDispatch)
    END_COM_MAP()

public:
    CNastavljalnik();
    HRESULT FinalConstruct();
    void FinalRelease();

public:
    // IMsmConfigureModule
    virtual HRESULT STDMETHODCALLTYPE ProvideTextData(const BSTR bsName, BSTR __RPC_FAR *pbsConfigData);
    virtual HRESULT STDMETHODCALLTYPE ProvideIntegerData(const BSTR bsName, long __RPC_FAR *plConfigData);

protected:
    inline RNizU* VrniVrednostParametra(const BSTR bsName);

protected:
    RNevarenOdsek kljucavnica;
};


////////////////////////////////////////////////////////////////////////////
// Metode inline
////////////////////////////////////////////////////////////////////////////

inline RNizU* CNastavljalnik::VrniVrednostParametra(const BSTR bsName)
{
    RSeznamNastavitev *parametri;

    if ((parametri = dynamic_cast<RSeznamNastavitev*>(Vrni(_T("parametri")))) != NULL) {
        return dynamic_cast<RNizU*>(parametri->Vrni(bsName));
    }

    return NULL;
}
