/*
    Copyright 1991-2015 Amebis

    This file is part of MSIMSM.

    MSIMSM is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    MSIMSM is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with MSIMSM. If not, see <http://www.gnu.org/licenses/>.
*/

#include "StdAfx.h"


RSeznamNastavitev::RSeznamNastavitev(T_UINT korak_povecevanja) : RUrejenSeznam<T_NASTZAPIS>(korak_povecevanja)
{
}


RSeznamNastavitev::~RSeznamNastavitev()
{
    Unici();
}


T_VOID RSeznamNastavitev::Unici()
{
    T_VOZELDVO<T_NASTZAPIS> *vozel;

    while (prvi) {
        vozel = (T_VOZELDVO<T_NASTZAPIS>*)prvi;
        prvi = ((T_VOZELDVO<T_NASTZAPIS>*)prvi)->naslednji;

        UniciVozel(vozel);
        st_elementov--;
    }

    zadnji = NULL;
    assert(!st_elementov);
}


T_VOID RSeznamNastavitev::UniciVozel(T_ROCICA rocica)
{
    T_NASTZAPIS &zapis = VrniElement(rocica);
    if (zapis.element)
        delete zapis.element;

    RUrejenSeznam<T_NASTZAPIS>::UniciVozel(rocica);
}


T_INT RSeznamNastavitev::Primerjaj(const T_NASTZAPIS &prvi, const T_NASTZAPIS &drugi) const
{
    return astrncmp(prvi.id, drugi.id, RSEZNAST_DOLZINA_ID);
}
