/*
    Copyright 1991-2015 Amebis

    This file is part of NovGUID.

    NovGUID is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    NovGUID is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with NovGUID. If not, see <http://www.gnu.org/licenses/>.
*/

#include "StdAfx.h"


T_REZULTAT amain(T_UINT argc, TK_NIZ argv[])
{
    // Nastavimo locale modulu.
    asetlocale(LC_ALL, _T(".OCP"));

    T_REZULTAT rezultat = 0;
    HRESULT hr;
    GUID guid;
    T_ZNAK buf[AOSN_GUID_MAX + 1];

    hr = ::CoInitialize(NULL);
    if (FAILED(hr)) {
        _ftprintf(stderr, _T("Napaka pri vzpostavljanju COM (koda MS %#010I32x)!\n"), hr);
        rezultat = 1;
        goto napaka1;
    }

    hr = ::CoCreateGuid(&guid);
    if (FAILED(hr)) {
        _ftprintf(stderr, _T("Napaka pri stvaritvi GUID (koda MS %#010I32x)!\n"), hr);
        rezultat = 2;
        goto napaka2;
    }

    buf[aguidtostr(&guid, buf, AOSN_GUID_MAX)] = 0;
    if (argc > 1) {
        T_UINT i;
        for (i = 1; i < argc; i++)
            _ftprintf(stdout, _T("set %s=%.*s\n"), argv[i], AOSN_GUID_MAX, buf);
    } else
        _ftprintf(stdout, buf);

    rezultat = 0;

napaka2:
    ::CoUninitialize();
napaka1:
    adumpheap();
    return rezultat;
}
