/*
    Copyright 1991-2015 Amebis

    This file is part of rcxgettext.

    rcxgettext is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    rcxgettext is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with rcxgettext. If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __RCXGETTEXT_H__
#define __RCXGETTEXT_H__


////////////////////////////////////////////////////////////////////////////
// Konstante
////////////////////////////////////////////////////////////////////////////

#define RCXGETTEXT_VERZIJA       0x010f0000

#define RCXGETTEXT_VERZIJA_MAJ   1
#define RCXGETTEXT_VERZIJA_MIN   15
#define RCXGETTEXT_VERZIJA_REV   0

#define RCXGETTEXT_VERZIJA_STR   "1.15"


////////////////////////////////////////////////////////////////////
// Kode virov
////////////////////////////////////////////////////////////////////

#define IDR_MAINFRAME 1

#ifndef RC_INVOKED

////////////////////////////////////////////////////////////////////
// Deklaracije
////////////////////////////////////////////////////////////////////

#include "AOsn.h"
#include "RSezPrev.hpp"


class RAnalizator {
public:
    RAnalizator();

    T_STANJE Analiziraj(TK_NIZ vhodna_datoteka, T_UINT dolzina_vh = T_UINT_MAX);
    T_STANJE Prevedi(TK_NIZ izhodna_datoteka, T_UINT dolzina_iz, TK_NIZ vhodna_datoteka, T_UINT dolzina_vh);

    T_STANJE NaloziKatalog(TK_NIZ ime_datoteke);
    T_STANJE ShraniKatalog(TK_NIZ ime_datoteke);

protected:
    virtual T_STANJE Obdelaj(T_BOOL prevedi) = 0;

protected:
    RNiz ime_izhodne_datoteke;
    RMedFizDatoteka izhod;
    RNiz ime_vhodne_datoteke;
    RMedFizDatoteka vhod;

    RSeznamPrevodov prevodi;
    RSeznam<RSeznamPrevodov> katalogi;
};


T_REZULTAT rc(T_UINT argc, TK_NIZ argv[]);
T_REZULTAT rcp(T_UINT argc, TK_NIZ argv[]);
T_REZULTAT mc(T_UINT argc, TK_NIZ argv[]);
T_REZULTAT mcp(T_UINT argc, TK_NIZ argv[]);
T_REZULTAT idt(T_UINT argc, TK_NIZ argv[]);
T_REZULTAT idtp(T_UINT argc, TK_NIZ argv[]);
T_REZULTAT idta(T_UINT argc, TK_NIZ argv[]);
T_REZULTAT html(T_UINT argc, TK_NIZ argv[]);
T_REZULTAT htmlp(T_UINT argc, TK_NIZ argv[]);

#endif // RC_INVOKED

#endif // __RCXGETTEXT_H__
