/*
    Copyright 1991-2015 Amebis

    This file is part of AOsn.

    AOsn is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    AOsn is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AOsn. If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __AOSN_H__
#define __AOSN_H__

#include "AOsnNast.h"


////////////////////////////////////////////////////////////////////////////
// Verzija
////////////////////////////////////////////////////////////////////////////

#define AOSN_VERZIJA       0x07030000

#define AOSN_VERZIJA_MAJ   7
#define AOSN_VERZIJA_MIN   3
#define AOSN_VERZIJA_REV   0

#define AOSN_VERZIJA_STR   "7.3"


//////////////////////////////////////////////////////////////////////
// Preverjanje in definicije odvisnosti
//////////////////////////////////////////////////////////////////////

#if defined(AOSN_DIAGNOSTIKA_AMALLOC)
#define AOSN_DIAGNOSTIKA
#endif
#if !defined(_WINSOCKAPI_)
#define _WINSOCKAPI_        // Prevent inclusion of winsock.h in windows.h
#endif
#if defined(AOSN_HTML) && defined(AOSN_BREZ_SGML)
#pragma message("Konstanta AOSN_HTML in AOSN_BREZ_SGML ne smeta biti definirani hkrati. Odstranjam slednjo!")
#undef AOSN_BREZ_SGML
#endif
#if defined(AOSN_CRC32)
#pragma message("Uporabi konstanto AOSN_ODTISNIK namesto AOSN_CRC32!")
#define AOSN_ODTISNIK
#endif
#if defined(AOSN_KRIPT)
#pragma message("Uporabi konstanto AOSN_ODTISNIK namesto AOSN_KRIPT!")
#define AOSN_ODTISNIK
#endif

#if defined(AOSN_ZVOK) || defined(AOSN_SERVIS) || defined(AOSN_IZJEMA)
#define AOSN_NIT
#endif
#if defined(AOSN_DNEVNIK) || defined(AOSN_NIT) || defined(AOSN_ZVOK) || defined(AOSN_SERVIS)
#define AOSN_SEMAFOR
#endif
#if defined(AOSN_VIRI)
#define AOSN_ISKDAT
#endif
#if defined(AOSN_DNEVNIK)
#define AOSN_REGISTER
#endif
#if defined(AOSN_HTML) || defined(AOSN_HTTP)
#define AOSN_REGIZR
#endif
#if defined(AOSN_ZLIB) || defined(AOSN_IZJEMA)
#define AOSN_ZLIB_DEFLATE
#endif
#if defined(AOSN_ZLIB)
#define AOSN_ZLIB_INFLATE
#endif
#if defined(AOSN_HTML)
#define AOSN_KAZNAP
#endif


//////////////////////////////////////////////////////////////////////
// Nastavitve
//////////////////////////////////////////////////////////////////////

#if defined(__GNUC__) && !defined(RSEZNAM_STDALLOC_VER)
// V verzijah Unix za sedaj podpiramo le standardno rezervacijo pomnilnika.
#define RSEZNAM_STDALLOC_VER
#endif
#ifdef RDAT_NE_PREVERJAJ_VER
#define RDAT_NE_PREVERJAJ_STANJA_VER
#define RDAT_NE_PREVERJAJ_EOF_VER
#endif

#define AQSORT_MIN_DOLZINA              16      // dolina tabele, pri kateri aqsort() preklopi iz bubble-sort na quick-sort
#define ABINSEARCH_MIN_DOLZINA          5       // dolina tabele, pri kateri abinsearch() preklopi iz linearnega iskanja na binarnega
#define DOLZINA_DELOVNOMESTO            0x100   // tevilo znakov za zapis delovnega mesta
//#define FD_SETSIZE                      128     // najveje tevilo vtinic v mnoici (privzeto 64)
#define AOSN_SGML_ENTITET               1017    // tevilo entitet SGML v tabelah sgml_unicode in unicode_sgml
#define RSEZNAM_KORAK_POVECEVANJA       0x40    // privzeto tevilo elementov poveevanja rezervacije pomnilnika
#define RSEZNAM_ZASTAVICE_KOPICE        0       // Ne uporabljaj HEAP_NO_SERIALIZE, ker pride do teav v ntdll.dll (AHroar #490).
#define RDINTABELA_KORAK_POVECEVANJA    0x80    // privzeto tevilo elementov poveevanja rezervacije pomnilnika
#ifdef AOSN_HITROST_POMEMBNEJSA_OD_POMNILNIKA_VER
#define RDINTABELA_TESNA_REZERVACIJA    FALSE
#else
#define RDINTABELA_TESNA_REZERVACIJA    TRUE
#endif
#define RNIZ_NEVELJAVEN_INDEKS          (T_UINT_MAX)
#define RNIZ_KORAK_POVECEVANJA          0x80    // privzeto tevilo elementov poveevanja rezervacije pomnilnika
#ifdef AOSN_HITROST_POMEMBNEJSA_OD_POMNILNIKA_VER
#define RNIZ_TESNA_REZERVACIJA          FALSE
#else
#define RNIZ_TESNA_REZERVACIJA          TRUE
#endif
#ifdef AOSN_NIT
#define RDOGNIT_PRIVZETA_DOLZINA_VRSTE  0x10
#ifndef RDOGNIT_KANAL_VER
#define RDOGNIT_KODA_SPOROCILA_ZACETEK  (WM_USER+0x010)
#define RDOGNIT_KODA_SPOROCILA_KONEC    (WM_USER+0x110)
#endif
#define RDIAGNIT_VELIKOST_PODATKI       0x1000  // velikost bloka T_DIAGNIT_PODATKI je vedno 4 kB
#define RDIAGNIT_VELIKOST_PODATKI_SPOROCILO (RDIAGNIT_VELIKOST_PODATKI - sizeof(DWORD))
#endif
#define RDAT_DOLZINA_IZRAVNALNIKA       0x200   // privzeta velikost izravnalnika
#define RDAT_DOLZINA_MEDPOMNILNIKA      0x400   // privzeta velikost medpomnilnika
#define RDAT_VELIKOST_ITERIRANJA        0x10
#define RDAT_VELIKOST_BLOKA             0x10000 // velikost bloka, ki ga uporabljamo pri kopiranju, oziroma razirjanju prostora
#define RKAN_CASOVNA_KONTROLA           RDTM_MINUTA
#define RKAN_DOLZINA_MEDPOMNILNIKA      0x100
#define ZLIB_DOLZINA_BLOKA              0x10000
#define KNJIZNICAVIROV_KONCNICA         _T("*.AJV")
#define IDS_JEZIK                       0
#define RZVOK_NAJVEC_BLOKOV             0x10
#define RHTTP_MAX_DOLZINA_GLAVE_ZAHTEVE 0x10000
#define RHTTP_MAX_DOLZINA_VRSTICE       0x1000
#ifdef _DEBUG
#define RHTTP_CASOVNA_KONTROLA_ZAHTEVE_SPREJEM  (RDTM_SEKUNDA * 10)
#define RHTTP_CASOVNA_KONTROLA_ZAHTEVE_OBDELAVA (RDTM_SEKUNDA * 10)
#else
#define RHTTP_CASOVNA_KONTROLA_ZAHTEVE_SPREJEM  RDTM_MINUTA
#define RHTTP_CASOVNA_KONTROLA_ZAHTEVE_OBDELAVA RDTM_MINUTA
#endif
#define AHROSCAR_VELIKOST_BLOKA             ((T_UINT)0x1000)    // Velikost bloka za poiljanje poroila
#define AHROSCAR_VELIKOST_VRSTE_ODGOVORA    ((T_UINT)0x100)     // Priakovana najveja velikost vrste MIME odgovora
#define AHROSCAR_VELIKOST_ODGOVORA          ((T_UINT)0x1000)    // Priakovana dolina besedila odgovora
#define AHROSCAR_VELIKOST_SPOROCILA         (AHROSCAR_VELIKOST_ODGOVORA + 0x100)
#define AHROSCAR_KONCANJE_NITI              (RDTM_SEKUNDA * 30) // Koliko asa akamo, da se nit za oddajo poroil o napakah kona
#define AHROSCAR_ZAGON_NITI                 (RDTM_SEKUNDA * 10) // Koliko asa akamo, da se nit za poiljanje zaene (detekcija DllMain())
#define AHROSCAR_DODATNI_OPIS_UI_MAX        100
#define AOSN_AHROSCAR_STREZNIK              _T("hroscar.amebis.si")
#define AOSN_AHROSCAR_STREZNIK_VRATA        80
#define AOSN_AHROSCAR_SKR_SPREJEM           _T("/sprejem/")


////////////////////////////////////////////////////////////////////
// Kode virov
////////////////////////////////////////////////////////////////////

//
// Nizi
//

#define IDS_AOSN_NASLOV                 1
#define IDS_AOSN_NAPAKA_VZPOSTAVITEV    2


#if !defined(RC_INVOKED) && !defined(MIDL_PASS) && defined(__cplusplus)

#include <assert.h>
#include <float.h>
#include <locale.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#ifdef _WIN32
#include <windows.h>

#ifndef WIN32_LEAN_AND_MEAN
#include <asptlb.h>
#endif
#include <basetyps.h>
#include <dbghelp.h>  // AOSN_IZJEMA
#include <lmcons.h>   // AOSN_KANAL
#include <mmsystem.h> // AOSN_ZVOK
#include <new.h>      // AOSN_IZJEMA
#include <objidl.h>
#include <oleauto.h>
#include <rpc.h>      // AOSN_HTTP
#include <tchar.h>
#include <winhttp.h>  // AOSN_IZJEMA
#include <winreg.h>   // AOSN_REGISTER
#include <winsock2.h> // AOSN_VTIC
#include <winsvc.h>   // AOSN_SERVIS
#endif


#pragma warning(disable: 4505)


////////////////////////////////////////////////////////////////////
// Nain klicanja funkcij
////////////////////////////////////////////////////////////////////

#if defined(AOSN_DLL)

#define AOSN_API            __declspec(dllexport)
#define AOSN_CLASS          __declspec(dllexport)
#define AOSN_INLINE_CLASS   __declspec(novtable)
#define AOSN_TEMPLATE

#elif defined(AOSN_DLLIMP)

#define AOSN_API            __declspec(dllimport)
#define AOSN_CLASS          __declspec(dllimport)
#define AOSN_INLINE_CLASS   __declspec(novtable)
#define AOSN_TEMPLATE

#else

#define AOSN_API
#define AOSN_CLASS
#define AOSN_INLINE_CLASS   __declspec(novtable)
#define AOSN_TEMPLATE

#endif

#if defined(_WIN64)
#define RNIT_API __cdecl
#elif defined(_WIN32)
#define RNIT_API __stdcall
#else
#define RNIT_API
#endif


//////////////////////////////////////////////////////////////////////
// Vrste parametrov funkcij in metod
//////////////////////////////////////////////////////////////////////

#ifndef _W64
#define _W64
#endif
#ifndef __in
#define __in IN
#endif
#ifndef __in_opt
#define __in_opt IN
#endif
#ifndef __out
#define __out OUT
#endif
#ifndef __out_opt
#define __out_opt OUT
#endif


//////////////////////////////////////////////////////////////////////
// Kode modulov za opisovanje napak
//////////////////////////////////////////////////////////////////////

#define A_OK                        0x00000000l

#define OPOZORILO_AOSN              0x00000000l
#define NAPAKA_AOSN                 0x80000000l
#define OPOZORILO_PRE_MODUL         0x00200000l
#define NAPAKA_PRE_MODUL            0x80200000l
#define OPOZORILO_PRE_JEDRO         0x00300000l
#define NAPAKA_PRE_JEDRO            0x80300000l
#define OPOZORILO_PRE_STREZNIK      0x00400000l
#define NAPAKA_PRE_STREZNIK         0x80400000l
#define OPOZORILO_PRE_ODJEMALEC     0x00500000l
#define NAPAKA_PRE_ODJEMALEC        0x80500000l
#define OPOZORILO_PRESKUPNO         0x00500000l
#define NAPAKA_PRESKUPNO            0x80500000l
#define OPOZORILO_AHTML             0x00600000l
#define NAPAKA_AHTML                0x80600000l
#define OPOZORILO_PRE_PIKI          0x00700000l
#define NAPAKA_PRE_PIKI             0x80700000l
#define OPOZORILO_PREIE             0x00700000l
#define NAPAKA_PREIE                0x80700000l
#define OPOZORILO_PRE_MINI          0x00800000l
#define NAPAKA_PRE_MINI             0x80800000l
#define OPOZORILO_PRE_SPLET         0x00900000l
#define NAPAKA_PRE_SPLET            0x80900000l
#define OPOZORILO_PRE_PREVGRD       0x01500000l
#define NAPAKA_PRE_PREVGR           0x81500000l
#define OPOZORILO_PR_OSN            0x00a00000l
#define NAPAKA_PR_OSN               0x80a00000l
#define OPOZORILO_PR_OZN            0x00b00000l
#define NAPAKA_PR_OZN               0x80b00000l
#define OPOZORILO_PR_REZ            0x00c00000l
#define NAPAKA_PR_REZ               0x80c00000l
#define OPOZORILO_PR_ZBR            0x00d00000l
#define NAPAKA_PR_ZBR               0x80d00000l
#define OPOZORILO_PR_ANA            0x00e00000l
#define NAPAKA_PR_ANA               0x80e00000l
#define OPOZORILO_PR_GEN            0x00f00000l
#define NAPAKA_PR_GEN               0x80f00000l
#define OPOZORILO_PR_PRA            0x01800000l
#define NAPAKA_PR_PRA               0x81800000l
#define OPOZORILO_ASES              0x01000000l
#define NAPAKA_ASES                 0x81000000l
#define OPOZORILO_IUS_DPR           0x01100000l
#define NAPAKA_IUS_DPR              0x81100000l
#define OPOZORILO_AJT               0x01200000l
#define NAPAKA_AJT                  0x81200000l
#define OPOZORILO_ANIGMA            0x01300000l
#define NAPAKA_ANIGMA               0x81300000l
#define OPOZORILO_HIPSIS            0x01400000l
#define NAPAKA_HIPSIS               0x81400000l
#define OPOZORILO_GOS               0x01600000l
#define NAPAKA_GOS                  0x81600000l
#define OPOZORILO_BESAX             0x01700000l
#define NAPAKA_BESAX                0x81700000l
#define OPOZORILO_BESSKUPNO         0x01900000l
#define NAPAKA_BESSKUPNO            0x81900000l
#define OPOZORILO_ALIC              0x01a00000l
#define NAPAKA_ALIC                 0x81a00000l
#define OPOZORILO_GOV               0x01b00000l
#define NAPAKA_GOV                  0x81b00000l
#define OPOZORILO_GOVMS             0x01c00000l
#define NAPAKA_GOVMS                0x81c00000l
#define OPOZORILO_GOVODJ            0x01d00000l
#define NAPAKA_GOVODJ               0x81d00000l
#define OPOZORILO_GOVMINI           0x01e00000l
#define NAPAKA_GOVMINI              0x81e00000l
#define OPOZORILO_ALINGUA           0x01f00000l
#define NAPAKA_ALINGUA              0x81f00000l
#define OPOZORILO_ASKUPNO           0x02100000l
#define NAPAKA_ASKUPNO              0x82100000l
#define OPOZORILO_GOVSAPI           0x02000000l
#define NAPAKA_GOVSAPI              0x82000000l
#define OPOZORILO_AJTODJ            0x02100000l
#define NAPAKA_AJTODJ               0x82100000l
#define OPOZORILO_FIDAANA           0x02200000l
#define NAPAKA_FIDAANA              0x82200000l
#define OPOZORILO_ALICSTR           0x02300000l
#define NAPAKA_ALICSTR              0x82300000l
#define OPOZORILO_AHROAX            0x02400000l
#define NAPAKA_AHROAX               0x82400000l
#define OPOZORILO_BESAPI            0x02500000l
#define NAPAKA_BESAPI               0x82500000l

// Stare konstante - definirane zaradi prenosljivosti
#define OPOZORILO_PRE_HTML          OPOZORILO_AHTML
#define NAPAKA_PRE_HTML             NAPAKA_AHTML

// Prva prosta koda modula: ko doda novo kodo modula uporabi to vrednost, to konstano pa poveaj za 1
#define OPOZORILO_PRVA_PROSTA_KODA_MOD 0x01b00000l

// Splone kode napak, neodvisnih od modula, ki jih z bitno operacijo ALI kombiniramo s kodo modula
#define __POMNILNIK                 0x00000001l     // napaka pri rezervaciji pomnilnika
#define __PARAMETER                 0x00000002l     // napaen parameter funkcije
#define __NI_PODPRTO                0x00000003l     // operacija ni podprta
#define __VIRI                      0x00000004l     // napaka pri nalaganju virov iz modula virov
#define __COM                       0x00000005l     // napaka pri delu s COM
#define __CASOVNA_KONTROLA          0x00000006l     // pri delu je potekla asovna kontrola
#define __NI_VZPOSTAVLJENO          0x00000007l     // funkcija/knjinica/modul ni vzpostavljen
#define __ZE_VZPOSTAVLJENO          0x00000008l     // funkcija/knjinica/modul ze vzpostavljen in ne omogoa vekratne vzpostavitve
#define __PREKINJENO                0x00000009l     // operacija je bila prekinjena
#define __NI_NAJDENO                0x0000000al     // elenega nismo nasli

// Splone kode opozoril, neodvisnih od modula, ki jih z bitno operacijo ALI kombiniramo s kodo modula
#define __NI_ZAKLJUCENO             0x00000001l     // niz ni zakljuen z zakljunim znakom

// Kode napak
#define AOSN_NAPAKA_WSASTARTUP              (NAPAKA_AOSN | 0x00000001)
#define AOSN_NAPAKA_WSACLEANUP              (NAPAKA_AOSN | 0x00000002)
#define AOSN_NAPAKA_GETVERSIONEX            (NAPAKA_AOSN | 0x00000057)
#define AOSN_NAPAKA_PARAMETER               (NAPAKA_AOSN | 0x00000003)
#define AOSN_NAPAKA_BRANJE                  (NAPAKA_AOSN | 0x00000004)
#define AOSN_NAPAKA_PISANJE                 (NAPAKA_AOSN | 0x00000005)
#define AOSN_NAPAKA_NI_DATOTEKE             (NAPAKA_AOSN | 0x00000045)
#define AOSN_NAPAKA_NI_DOSTOPA              (NAPAKA_AOSN | 0x00000042)
#define AOSN_NAPAKA_NI_PODPRTO              (NAPAKA_AOSN | 0x00000043)
#define AOSN_NAPAKA_NI_PRIPRAVLJEN          (NAPAKA_AOSN | 0x00000049)
#define AOSN_NAPAKA_NI_SEKTORJA             (NAPAKA_AOSN | 0x0000004b)
#define AOSN_NAPAKA_NEDELJIV                (NAPAKA_AOSN | 0x0000004a)
#define AOSN_NAPAKA_ZAKLENJEN               (NAPAKA_AOSN | 0x0000004c)
#define AOSN_NAPAKA_POT                     (NAPAKA_AOSN | 0x00000046)
#define AOSN_NAPAKA_PREVEC_DATOTEK          (NAPAKA_AOSN | 0x00000047)
#define AOSN_NAPAKA_CRC                     (NAPAKA_AOSN | 0x00000044)
#define AOSN_NAPAKA_ZASCITEN_MEDIJ          (NAPAKA_AOSN | 0x00000048)
#define AOSN_NAPAKA_ZMANJKALO_PROSTORA      (NAPAKA_AOSN | 0x0000004d)
#define AOSN_NAPAKA_POMNILNIK               (NAPAKA_AOSN | 0x00000006)
#define AOSN_NAPAKA_ODPIRANJE               (NAPAKA_AOSN | 0x00000007)
#define AOSN_NAPAKA_ZAPIRANJE               (NAPAKA_AOSN | 0x00000008)
#define AOSN_NAPAKA_PREMIK                  (NAPAKA_AOSN | 0x00000009)
#define AOSN_NAPAKA_ZAKLEP                  (NAPAKA_AOSN | 0x0000000a)
#define AOSN_NAPAKA_ODKLEP                  (NAPAKA_AOSN | 0x0000000b)
#define AOSN_NAPAKA_DOLZINA                 (NAPAKA_AOSN | 0x0000000c)
#define AOSN_NAPAKA_ODREZI                  (NAPAKA_AOSN | 0x0000000d)
#define AOSN_NAPAKA_NE_UPRAVLJAJ            (NAPAKA_AOSN | 0x0000000e)
#define AOSN_NAPAKA_IZPLAKNI                (NAPAKA_AOSN | 0x0000000f)
#define AOSN_NAPAKA_PRIVEZI                 (NAPAKA_AOSN | 0x00000010)
#define AOSN_NAPAKA_POVEZI                  (NAPAKA_AOSN | 0x00000011)
#define AOSN_NAPAKA_POSLUSAJ                (NAPAKA_AOSN | 0x00000012)
#define AOSN_NAPAKA_SPREJMI                 (NAPAKA_AOSN | 0x00000013)
#define AOSN_NAPAKA_ZAKLJUCI                (NAPAKA_AOSN | 0x00000061)
#define AOSN_NAPAKA_NASLOV_VTICNICE         (NAPAKA_AOSN | 0x00000014)
#define AOSN_NAPAKA_NASLOV_VRSTNIKA         (NAPAKA_AOSN | 0x00000015)
#define AOSN_NAPAKA_NASTAVI_PARAM_VTIC      (NAPAKA_AOSN | 0x00000016)
#define AOSN_NAPAKA_VRNI_PARAM_VTIC         (NAPAKA_AOSN | 0x00000017)
#define AOSN_NAPAKA_PREMALO                 (NAPAKA_AOSN | 0x00000018)
#define AOSN_NAPAKA_ISKANJE                 (NAPAKA_AOSN | 0x00000019)
#define AOSN_NAPAKA_NI_VEC_ZADETKOV         (NAPAKA_AOSN | 0x0000001a)
#define AOSN_NAPAKA_USTVARI                 (NAPAKA_AOSN | 0x0000001b)
#define AOSN_NAPAKA_UNICI                   (NAPAKA_AOSN | 0x0000001c)
#define AOSN_NAPAKA_ZAMRZNI                 (NAPAKA_AOSN | 0x0000001d)
#define AOSN_NAPAKA_ODMRZNI                 (NAPAKA_AOSN | 0x0000001e)
#define AOSN_NAPAKA_PREKINI                 (NAPAKA_AOSN | 0x0000001f)
#define AOSN_NAPAKA_NASTAVI_PRI             (NAPAKA_AOSN | 0x00000020)
#define AOSN_NAPAKA_BRISANJE                (NAPAKA_AOSN | 0x00000021)
#define AOSN_NAPAKA_PREIMENOVANJE           (NAPAKA_AOSN | 0x0000006b)
#define AOSN_NAPAKA_PREPISOVANJE            (NAPAKA_AOSN | 0x0000006c)
#define AOSN_NAPAKA_NAPACEN_TIP             (NAPAKA_AOSN | 0x00000022)
#define AOSN_NAPAKA_CAS_POTEKEL             (NAPAKA_AOSN | 0x00000023)
#define AOSN_NAPAKA_RESETIRAJ               (NAPAKA_AOSN | 0x00000025)
#define AOSN_NAPAKA_IMPULZ                  (NAPAKA_AOSN | 0x00000026)
#define AOSN_NAPAKA_NI_ZAKLENJEN            (NAPAKA_AOSN | 0x00000027)
#define AOSN_NAPAKA_NALAGANJE               (NAPAKA_AOSN | 0x00000028)
#define AOSN_NAPAKA_SPROSCANJE              (NAPAKA_AOSN | 0x0000002e)
#define AOSN_NAPAKA_MODUL                   (NAPAKA_AOSN | 0x00000029)
#define AOSN_NAPAKA_JEZIK_MODULA            (NAPAKA_AOSN | 0x0000002b)
#define AOSN_NAPAKA_MANJKA_JEZIK            (NAPAKA_AOSN | 0x0000002c)
#define AOSN_NAPAKA_NI_MODULOV              (NAPAKA_AOSN | 0x0000002a)
#define AOSN_NAPAKA_NI_IMENA                (NAPAKA_AOSN | 0x0000002d)
#define AOSN_NAPAKA_XML_NI_OZNAKA           (NAPAKA_AOSN | 0x0000002f)
#define AOSN_NAPAKA_XML_PRESLEDKI           (NAPAKA_AOSN | 0x00000030)
#define AOSN_NAPAKA_XML_IN_PRICAKOVAN       (NAPAKA_AOSN | 0x00000031)
#define AOSN_NAPAKA_XML_NI_VREDNOSTI        (NAPAKA_AOSN | 0x00000032)
#define AOSN_NAPAKA_XML_NI_NAREKOVAJEV      (NAPAKA_AOSN | 0x00000033)
#define AOSN_NAPAKA_XML_ZAKLJUCNA           (NAPAKA_AOSN | 0x00000034)
#define AOSN_NAPAKA_XML_NI_ZAKLJUCENA       (NAPAKA_AOSN | 0x00000069)
#define AOSN_NAPAKA_XML_NI_UVODNA           (NAPAKA_AOSN | 0x0000006a)
#define AOSN_NAPAKA_OSKRBNIK_SERVISOV       (NAPAKA_AOSN | 0x00000035)
#define AOSN_NAPAKA_DOSTOP_ZAVRNJEN         (NAPAKA_AOSN | 0x00000036)
#define AOSN_NAPAKA_NI_BAZE                 (NAPAKA_AOSN | 0x00000037)
#define AOSN_NAPAKA_ROCICA                  (NAPAKA_AOSN | 0x00000038)
#define AOSN_NAPAKA_IME                     (NAPAKA_AOSN | 0x00000039)
#define AOSN_NAPAKA_NI_SERVISA              (NAPAKA_AOSN | 0x0000003a)
#define AOSN_NAPAKA_KROZNA_ODVISNOST        (NAPAKA_AOSN | 0x0000003b)
#define AOSN_NAPAKA_ZE_OBSTAJA              (NAPAKA_AOSN | 0x0000003c)
#define AOSN_NAPAKA_NI_UPORABNIKA           (NAPAKA_AOSN | 0x0000003d)
#define AOSN_NAPAKA_ODPRI_SERVIS            (NAPAKA_AOSN | 0x0000003f)
#define AOSN_NAPAKA_USTVARI_SERVIS          (NAPAKA_AOSN | 0x0000003e)
#define AOSN_NAPAKA_BRISI_SERVIS            (NAPAKA_AOSN | 0x00000040)
#define AOSN_NAPAKA_OBVESCANJE_SERVISA      (NAPAKA_AOSN | 0x00000060)
#define AOSN_NAPAKA_VRNI_IME                (NAPAKA_AOSN | 0x00000041)
#define AOSN_NAPAKA_USTVARI_IMENIK          (NAPAKA_AOSN | 0x0000004e)
#define AOSN_NAPAKA_PODVAJANJE_ROCICE       (NAPAKA_AOSN | 0x0000004f)
#define AOSN_NAPAKA_NEZNANA_POT_MODULA      (NAPAKA_AOSN | 0x00000050)
#define AOSN_NAPAKA_MANJKAJO_ATRIBUTI       (NAPAKA_AOSN | 0x00000051)
#define AOSN_NAPAKA_NASTAVLJANJE_ATR        (NAPAKA_AOSN | 0x00000052)
#define AOSN_NAPAKA_ZE_OZNACEN_ZA_BRISANJE  (NAPAKA_AOSN | 0x00000053)
#define AOSN_NAPAKA_ZAGON_SERVISA           (NAPAKA_AOSN | 0x00000054)
#define AOSN_NAPAKA_ZE_ZAGNAN               (NAPAKA_AOSN | 0x00000055)
#define AOSN_NAPAKA_PRIJAVA_UPORABNIKA      (NAPAKA_AOSN | 0x00000056)
#define AOSN_NAPAKA_SNEMALNIK               (NAPAKA_AOSN | 0x00000057)
#define AOSN_NAPAKA_SPOROCI                 (NAPAKA_AOSN | 0x00000058)
#define AOSN_NAPAKA_NASTAVI                 (NAPAKA_AOSN | 0x0000006d)
#define AOSN_NAPAKA_VRNI_STATUS             (NAPAKA_AOSN | 0x00000085)
#define AOSN_NAPAKA_NI_NIT                  (NAPAKA_AOSN | 0x00000059)
#define AOSN_NAPAKA_VIRI                    (NAPAKA_AOSN | 0x0000005a)
#define AOSN_NAPAKA_RACUNANJE               (NAPAKA_AOSN | 0x0000005b)
#define AOSN_NAPAKA_STANJE                  (NAPAKA_AOSN | 0x0000005c)
#define AOSN_NAPAKA_NI_SKLADISCA            (NAPAKA_AOSN | 0x0000005d)
#define AOSN_NAPAKA_POKVARJENO_SKLADISCE    (NAPAKA_AOSN | 0x0000005e)
#define AOSN_NAPAKA_KONEC_TOKA              (NAPAKA_AOSN | 0x0000005f)
#define AOSN_NAPAKA_NASTAVI_CASOVNIK        (NAPAKA_AOSN | 0x00000062)
#define AOSN_NAPAKA_POVEZAVA_ZAVRNJENA      (NAPAKA_AOSN | 0x00000063)
#define AOSN_NAPAKA_SPREMLJANJE             (NAPAKA_AOSN | 0x00000064)
#define AOSN_NAPAKA_NEZNAN_TRENUTNI_IMENIK  (NAPAKA_AOSN | 0x00000065)
#define AOSN_NAPAKA_SPREMEMBA_TRENUTNEGA_IMENIKA    (NAPAKA_AOSN | 0x00000066)
#define AOSN_NAPAKA_REZULTAT                (NAPAKA_AOSN | 0x00000067)
#define AOSN_NAPAKA_VERZIJA_DATOTEKE        (NAPAKA_AOSN | 0x00000068)
#define AOSN_NAPAKA_NI_ZAPISA               (NAPAKA_AOSN | 0x0000006e)
#define AOSN_NAPAKA_HTTP_ZAHTEVA_NAPACNA    (NAPAKA_AOSN | 0x0000006f)
#define AOSN_NAPAKA_HTTP_GLAVA_ZAHTEVE_PREKRATKA    (NAPAKA_AOSN | 0x00000070)
#define AOSN_NAPAKA_HTTP_GLAVA_ZAHTEVE_PREDOLGA     (NAPAKA_AOSN | 0x00000071)
#define AOSN_NAPAKA_HTTP_METODA_NI_PODPRTA  (NAPAKA_AOSN | 0x00000072)
#define AOSN_NAPAKA_HTTP_MANJKA_GLAVA_HOST  (NAPAKA_AOSN | 0x00000073)
#define AOSN_NAPAKA_HTTP_VRSTICA_PREKRATKA  (NAPAKA_AOSN | 0x00000074)
#define AOSN_NAPAKA_HTTP_VRSTICA_PREDOLGA   (NAPAKA_AOSN | 0x00000075)
#define AOSN_NAPAKA_PREKINJENO              (NAPAKA_AOSN | 0x00000076)
#define AOSN_NAPAKA_GENERATOR_GUID          (NAPAKA_AOSN | 0x00000077)
#define AOSN_NAPAKA_NI_NAJDENO              (NAPAKA_AOSN | 0x00000078)
#define AOSN_NAPAKA_HTTP_NI_INTERNETA       (NAPAKA_AOSN | 0x00000079)
#define AOSN_NAPAKA_HTTP_PRIPRAVA_POVEZAVE  (NAPAKA_AOSN | 0x0000007a)
#define AOSN_NAPAKA_HTTP_POVEZAVA           (NAPAKA_AOSN | 0x0000007b)
#define AOSN_NAPAKA_HTTP_PRIPRAVA_GLAVE     (NAPAKA_AOSN | 0x0000007c)
#define AOSN_NAPAKA_HTTP_ZAHTEVA            (NAPAKA_AOSN | 0x0000007d)
#define AOSN_NAPAKA_HTTP_STATUS_ZAHTEVE     (NAPAKA_AOSN | 0x0000007e)
#define AOSN_NAPAKA_HTTP_NI_PODATKOV_ZA_PRIJAVO (NAPAKA_AOSN | 0x0000007f)
#define AOSN_NAPAKA_HTTP_ODGOVOR            (NAPAKA_AOSN | 0x00000080)
#define AOSN_NAPAKA_HTTP_KONEC_POSILJANJA   (NAPAKA_AOSN | 0x00000081)
#define AOSN_NAPAKA_SISTEMSKI_DNEVNIK       (NAPAKA_AOSN | 0x00000082)
#define AOSN_NAPAKA_BRANJE_IZJEMA           (NAPAKA_AOSN | 0x00000083)
#define AOSN_NAPAKA_PISANJE_IZJEMA          (NAPAKA_AOSN | 0x00000084)
#define AOSN_NAPAKA_NI_VZPOSTAVLJEN         (NAPAKA_AOSN | 0x00000086)
#define AOSN_NAPAKA_NASTAVITEV_CASA         (NAPAKA_AOSN | 0x00000087)
#define AOSN_NAPAKA_URL                     (NAPAKA_AOSN | 0x00000088)
#define AOSN_NAPAKA_SHEMA                   (NAPAKA_AOSN | 0x00000089)
// Prva naslednja prosta koda za napako:    0x0000008a

#define AOSN_OPOZORILO_ZE_ZAPRTA            (OPOZORILO_AOSN | 0x00000001)
#define AOSN_OPOZORILO_NEPOPOLNO            (OPOZORILO_AOSN | 0x00000002)
#define AOSN_OPOZORILO_NA_KONCU             (OPOZORILO_AOSN | 0x00000003)
#define AOSN_OPOZORILO_DRUGACEN_TIP         (OPOZORILO_AOSN | 0x00000004)
#define AOSN_OPOZORILO_NI_PRIVZET           (OPOZORILO_AOSN | 0x00000005)
#define AOSN_OPOZORILO_NI_ZELJEN            (OPOZORILO_AOSN | 0x00000006)
#define AOSN_OPOZORILO_ZE_NALOZEN           (OPOZORILO_AOSN | 0x00000007)
#define AOSN_OPOZORILO_ZE_SPROSCEN          (OPOZORILO_AOSN | 0x00000008)
#define AOSN_OPOZORILO_ZMANJKALO            (OPOZORILO_AOSN | 0x00000009)
#define AOSN_OPOZORILO_OMEJITEV             (OPOZORILO_AOSN | 0x0000000a)
#define AOSN_OPOZORILO_NEKAJ_NAPAK          (OPOZORILO_AOSN | 0x0000000b)
#define AOSN_OPOZORILO_NE_OBSTAJA           (OPOZORILO_AOSN | 0x0000000c)
#define AOSN_OPOZORILO_NI_VZPOSTAVLJEN      (OPOZORILO_AOSN | 0x0000000d)
// Prva naslednja prosta koda za opozorilo: 0x0000000e


//////////////////////////////////////////////////////////////////////
// Loilo imenikov
//////////////////////////////////////////////////////////////////////

#if defined(_WIN32)
#define LOCILO_IMENIKOV             '\\'
#define LOCILO_IMENIKOV_STR         "\\"
#elif defined(__GNUC__)
#define LOCILO_IMENIKOV             '/'
#define LOCILO_IMENIKOV_STR         "/"
#else
#error Neznana platforma!
#endif


//////////////////////////////////////////////////////////////////////
// NESKONCNO
//////////////////////////////////////////////////////////////////////

#define NESKONCNO                   INFINITE


//////////////////////////////////////////////////////////////////////
// amain
//////////////////////////////////////////////////////////////////////

#if _MSC_VER >= 1200 && defined(_UNICODE)
#define amain                       wmain
#else
#define amain                       main
#endif


//////////////////////////////////////////////////////////////////////
// assert
//////////////////////////////////////////////////////////////////////

#if !defined(_DEBUG) && defined(AOSN_DIAGNOSTIKA_ASSERT)
#undef assert
//#define assert(expr)               (void)((expr) || (::RaiseException(STATUS_ASSERTION_FAILURE, EXCEPTION_NONCONTINUABLE, 0, NULL), 0))
#define assert(expr)               (void)((expr) || (((int*)NULL)[0] = 1, 0))
#endif


//////////////////////////////////////////////////////////////////////
// verify
//////////////////////////////////////////////////////////////////////

#ifdef _DEBUG
#define verify(expr)                assert(expr)
#else
#define verify(expr)                ((void)(expr))
#endif


//////////////////////////////////////////////////////////////////////
// _countof
//////////////////////////////////////////////////////////////////////

#if !defined(_countof)
#define _countof(_Array)            (sizeof(_Array) / sizeof(_Array[0]))
#endif


//////////////////////////////////////////////////////////////////////
// GRPICONDIRENTRY
//////////////////////////////////////////////////////////////////////

#ifndef GRPICONDIRENTRY
#pragma pack(push)
#pragma pack(2)

typedef struct {
    BYTE bWidth;        // Width, in pixels, of the image
    BYTE bHeight;       // Height, in pixels, of the image
    BYTE bColorCount;   // Number of colors in image (0 if >=8bpp)
    BYTE bReserved;     // Reserved
    WORD wPlanes;       // Color Planes
    WORD wBitCount;     // Bits per pixel
    DWORD dwBytesInRes; // how many bytes in this resource?
    WORD nID;           // the ID
} GRPICONDIRENTRY, FAR *LPGRPICONDIRENTRY;
typedef const GRPICONDIRENTRY FAR* LPCGRPICONDIRENTRY;

#pragma pack(pop)
#endif


//////////////////////////////////////////////////////////////////////
// GRPICONDIR
//////////////////////////////////////////////////////////////////////

#ifndef GRPICONDIR
#pragma pack(push)
#pragma pack(2)

typedef struct {
    WORD idReserved;                // Reserved (must be 0)
    WORD idType;                    // Resource type (1 for icons)
    WORD idCount;                   // How many images?
    GRPICONDIRENTRY idEntries[1];   // The entries for each image
} GRPICONDIR, FAR *LPGRPICONDIR;
typedef const GRPICONDIR FAR* LPCGRPICONDIR;

#pragma pack(pop)
#endif


//////////////////////////////////////////////////////////////////////
// STATUS_SXS_INVALID_DEACTIVATION
//////////////////////////////////////////////////////////////////////

#ifndef STATUS_SXS_INVALID_DEACTIVATION
#define STATUS_SXS_INVALID_DEACTIVATION 0xC0150010
#endif

//////////////////////////////////////////////////////////////////////
// CONTEXTX86, PCONTEXTX86, CONTEXTAMD64, PCONTEXTAMD64
// Rabimo e definicije kontekstov drugih platform,
// da smo lahko cross-platform.
//////////////////////////////////////////////////////////////////////

#ifdef _M_IX86
#define CONTEXTX86                  CONTEXT
#define PCONTEXTX86                 PCONTEXT
#else
#define CONTEXTX86                  WOW64_CONTEXT
#define PCONTEXTX86                 PWOW64_CONTEXT
#define CONTEXT_EXTENDED_REGISTERS  WOW64_CONTEXT_EXTENDED_REGISTERS
#define MAXIMUM_SUPPORTED_EXTENSION WOW64_MAXIMUM_SUPPORTED_EXTENSION
#define SIZE_OF_80387_REGISTERS     WOW64_SIZE_OF_80387_REGISTERS
#endif
template <class TOK> inline TOK& operator >>(TOK &tok, CONTEXTX86 &x);

#if _MSC_VER >= 1200
#ifdef _M_X64
#define CONTEXTAMD64  CONTEXT
#define PCONTEXTAMD64 PCONTEXT
#else

#if _MSC_VER < 1600

//////////////////////////////////////////////////////////////////////
// M128A
//////////////////////////////////////////////////////////////////////

typedef struct DECLSPEC_ALIGN(16) _M128A {
    ULONGLONG Low;
    LONGLONG High;
} M128A, *PM128A;


//////////////////////////////////////////////////////////////////////
// XSAVE_FORMAT
//////////////////////////////////////////////////////////////////////

typedef struct DECLSPEC_ALIGN(16) _XSAVE_FORMAT {
    WORD  ControlWord;
    WORD  StatusWord;
    BYTE  TagWord;
    BYTE  Reserved1;
    WORD  ErrorOpcode;
    DWORD ErrorOffset;
    WORD  ErrorSelector;
    WORD  Reserved2;
    DWORD DataOffset;
    WORD  DataSelector;
    WORD  Reserved3;
    DWORD MxCsr;
    DWORD MxCsr_Mask;
    M128A FloatRegisters[8];

#if defined(_WIN64)
    M128A XmmRegisters[16];
    BYTE  Reserved4[96];
#else
    M128A XmmRegisters[8];
    BYTE  Reserved4[192];

    //
    // The fields below are not part of XSAVE/XRSTOR format.
    // They are written by the OS which is relying on a fact that
    // neither (FX)SAVE nor (F)XSTOR used this area.
    //

    DWORD   StackControl[7];    // KERNEL_STACK_CONTROL structure actualy
    DWORD   Cr0NpxState;
#endif
} XSAVE_FORMAT, *PXSAVE_FORMAT;
#endif
typedef XSAVE_FORMAT XMM_SAVE_AREA32, *PXMM_SAVE_AREA32;


//////////////////////////////////////////////////////////////////////
// CONTEXTAMD64
//////////////////////////////////////////////////////////////////////

//
// Context Frame
//
//  This frame has a several purposes: 1) it is used as an argument to
//  NtContinue, 2) it is used to constuct a call frame for APC delivery,
//  and 3) it is used in the user level thread creation routines.
//
//
// The flags field within this record controls the contents of a CONTEXT
// record.
//
// If the context record is used as an input parameter, then for each
// portion of the context record controlled by a flag whose value is
// set, it is assumed that that portion of the context record contains
// valid context. If the context record is being used to modify a threads
// context, then only that portion of the threads context is modified.
//
// If the context record is used as an output parameter to capture the
// context of a thread, then only those portions of the thread's context
// corresponding to set flags will be returned.
//
// CONTEXT_CONTROL specifies SegSs, Rsp, SegCs, Rip, and EFlags.
//
// CONTEXT_INTEGER specifies Rax, Rcx, Rdx, Rbx, Rbp, Rsi, Rdi, and R8-R15.
//
// CONTEXT_SEGMENTS specifies SegDs, SegEs, SegFs, and SegGs.
//
// CONTEXT_FLOATING_POINT specifies Xmm0-Xmm15.
//
// CONTEXT_DEBUG_REGISTERS specifies Dr0-Dr3 and Dr6-Dr7.
//

typedef struct DECLSPEC_ALIGN(16) _CONTEXT_AMD64 {

    //
    // Register parameter home addresses.
    //
    // N.B. These fields are for convience - they could be used to extend the
    //      context record in the future.
    //

    DWORD64 P1Home;
    DWORD64 P2Home;
    DWORD64 P3Home;
    DWORD64 P4Home;
    DWORD64 P5Home;
    DWORD64 P6Home;

    //
    // Control flags.
    //

    DWORD ContextFlags;
    DWORD MxCsr;

    //
    // Segment Registers and processor flags.
    //

    WORD   SegCs;
    WORD   SegDs;
    WORD   SegEs;
    WORD   SegFs;
    WORD   SegGs;
    WORD   SegSs;
    DWORD EFlags;

    //
    // Debug registers
    //

    DWORD64 Dr0;
    DWORD64 Dr1;
    DWORD64 Dr2;
    DWORD64 Dr3;
    DWORD64 Dr6;
    DWORD64 Dr7;

    //
    // Integer registers.
    //

    DWORD64 Rax;
    DWORD64 Rcx;
    DWORD64 Rdx;
    DWORD64 Rbx;
    DWORD64 Rsp;
    DWORD64 Rbp;
    DWORD64 Rsi;
    DWORD64 Rdi;
    DWORD64 R8;
    DWORD64 R9;
    DWORD64 R10;
    DWORD64 R11;
    DWORD64 R12;
    DWORD64 R13;
    DWORD64 R14;
    DWORD64 R15;

    //
    // Program counter.
    //

    DWORD64 Rip;

    //
    // Floating point state.
    //

    union {
        XMM_SAVE_AREA32 FltSave;
        struct _UNNAMED {
            M128A Header[2];
            M128A Legacy[8];
            M128A Xmm0;
            M128A Xmm1;
            M128A Xmm2;
            M128A Xmm3;
            M128A Xmm4;
            M128A Xmm5;
            M128A Xmm6;
            M128A Xmm7;
            M128A Xmm8;
            M128A Xmm9;
            M128A Xmm10;
            M128A Xmm11;
            M128A Xmm12;
            M128A Xmm13;
            M128A Xmm14;
            M128A Xmm15;
        };
    };

    //
    // Vector registers.
    //

    M128A VectorRegister[26];
    DWORD64 VectorControl;

    //
    // Special debug control registers.
    //

    DWORD64 DebugControl;
    DWORD64 LastBranchToRip;
    DWORD64 LastBranchFromRip;
    DWORD64 LastExceptionToRip;
    DWORD64 LastExceptionFromRip;
} CONTEXTAMD64, *PCONTEXTAMD64;

#endif // _M_X64
#endif // _MSC_VER >= 1400
template <class TOK> inline TOK& operator >>(TOK &tok, CONTEXTAMD64 &x);


//////////////////////////////////////////////////////////////////////
// Deklaracije predlog operatorjev za shranjevanje sistemskih struktur
//////////////////////////////////////////////////////////////////////

template <class TOK> inline TOK& operator <<(TOK &tok, const EXCEPTION_RECORD &x);
template <class TOK> inline TOK& operator <<(TOK &tok, const CONTEXT &x);
template <class TOK> inline TOK& operator >>(TOK &tok, EXCEPTION_RECORD32 &x);
template <class TOK> inline TOK& operator >>(TOK &tok, EXCEPTION_RECORD64 &x);


//////////////////////////////////////////////////////////////////////
// Makro za pretvarjanje nizov iz izvorne kode v Unicode
//////////////////////////////////////////////////////////////////////

#define __L(x)                      L ## x
#define _L(x)                       __L(x)


//////////////////////////////////////////////////////////////////////
// Makri za delo z nizi
//////////////////////////////////////////////////////////////////////

#ifndef CSTR_EQUAL
#define CSTR_EQUAL              2           // string 1 equal to string 2
#endif

#ifndef LANG_INVARIANT
#define LANG_INVARIANT          0x7f
#endif

#ifndef AOSN_PRIVZETI_LOCALE
#if defined(_WIN32)
#define AOSN_PRIVZETI_LOCALE    ".ACP"
#elif defined(__GNUC__)
#define AOSN_PRIVZETI_LOCALE    ".iso88592"
#else
#error Neznana platforma!
#endif
#endif // AOSN_PRIVZETI_LOCALE

#ifndef AOSN_PRIVZETI_JEZIK
#define AOSN_PRIVZETI_JEZIK     KODAJEZIKA2_UPORABNIKOV
#endif // AOSN_PRIVZETI_JEZIK

#ifndef AOSN_PRIVZETI_CP
#if defined(_WIN32)
#define AOSN_PRIVZETI_CP        KODNASTRAN_WIN1250
#elif defined(__GNUC__)
#define AOSN_PRIVZETI_CP        KODNASTRAN_ISO8859_2
#else
#define AOSN_PRIVZETI_CP        KODNASTRAN_ANSI
#endif
#endif // AOSN_PRIVZETI_CP


//////////////////////////////////////////////////////////////////////
// Makri za delo z nizi SGML
//////////////////////////////////////////////////////////////////////

#ifndef AOSN_BREZ_SGML

#define AOSN_SGML_ENTITETA_SGML_MAX    12
#define AOSN_SGML_ENTITETA_UNICODE_MAX 3

#define AOSN_SGML_POLNI         0x80000000
#define AOSN_SGML_NAREKOVAJ     0x00000001
#define AOSN_SGML_APOSTROF      0x00000002
#define AOSN_SGML_NAREKOVAJA    0x00000003
#define AOSN_SGML_IN            0x00000004
#define AOSN_SGML_MANJSE_VECJE  0x00000008
#define AOSN_SGML_POSEVNICA     0x00000010
#define AOSN_SGML_DOLAR         0x00000020
#define AOSN_SGML_ODSTOTEK      0x00000040
#define AOSN_SGML_AJKA          0x00000080
#define AOSN_SGML_LOJTRA        0x00000100
#define AOSN_SGML_OKLEPAJA      0x00000200
#define AOSN_SGML_ZAV_OKLEPAJA  0x00000400
#define AOSN_SGML_OGL_OKLEPAJA  0x00000800
#define AOSN_SGML_SGML          (AOSN_SGML_IN | AOSN_SGML_MANJSE_VECJE)
#define AOSN_SGML_ATRIBUT       (AOSN_SGML_IN | AOSN_SGML_NAREKOVAJA)
#define AOSN_SGML_C             (AOSN_SGML_IN | AOSN_SGML_POSEVNICA | AOSN_SGML_NAREKOVAJA)
#define AOSN_SGML_AJT_LEMA      (AOSN_SGML_IN | AOSN_SGML_NAREKOVAJ | AOSN_SGML_DOLAR | AOSN_SGML_ODSTOTEK)
#define AOSN_SGML_AJT_OBLIKA    (AOSN_SGML_IN | AOSN_SGML_NAREKOVAJ | AOSN_SGML_DOLAR | AOSN_SGML_ODSTOTEK)
#define AOSN_SGML_KOLOS         (AOSN_SGML_IN | AOSN_SGML_NAREKOVAJ | AOSN_SGML_DOLAR | AOSN_SGML_ODSTOTEK | AOSN_SGML_MANJSE_VECJE | AOSN_SGML_POSEVNICA/* | AOSN_SGML_AJKA | AOSN_SGML_LOJTRA*/ | AOSN_SGML_OKLEPAJA | AOSN_SGML_ZAV_OKLEPAJA | AOSN_SGML_OGL_OKLEPAJA)

#endif


//////////////////////////////////////////////////////////////////////
// GUID
//////////////////////////////////////////////////////////////////////

#define AOSN_GUID_MAX           38
#define AOSN_GUID_STR_MIN       (AOSN_GUID_MAX + 1)

#define GUID_PRINTF_A    "{%08"     T_U4_PRINTF_SIZE_PREFIX     "X-%04"     T_U4_PRINTF_SIZE_PREFIX     "X-%04"     T_U4_PRINTF_SIZE_PREFIX     "X-%02"     T_U4_PRINTF_SIZE_PREFIX     "X%02"     T_U4_PRINTF_SIZE_PREFIX     "X-%02"     T_U4_PRINTF_SIZE_PREFIX     "X%02"     T_U4_PRINTF_SIZE_PREFIX     "X%02"     T_U4_PRINTF_SIZE_PREFIX     "X%02"     T_U4_PRINTF_SIZE_PREFIX     "X%02"     T_U4_PRINTF_SIZE_PREFIX     "X%02"     T_U4_PRINTF_SIZE_PREFIX     "X}" 
#define GUID_PRINTF_U   L"{%08"  _L(T_U4_PRINTF_SIZE_PREFIX)   L"X-%04"  _L(T_U4_PRINTF_SIZE_PREFIX)   L"X-%04"  _L(T_U4_PRINTF_SIZE_PREFIX)   L"X-%02"  _L(T_U4_PRINTF_SIZE_PREFIX)   L"X%02"  _L(T_U4_PRINTF_SIZE_PREFIX)   L"X-%02"  _L(T_U4_PRINTF_SIZE_PREFIX)   L"X%02"  _L(T_U4_PRINTF_SIZE_PREFIX)   L"X%02"  _L(T_U4_PRINTF_SIZE_PREFIX)   L"X%02"  _L(T_U4_PRINTF_SIZE_PREFIX)   L"X%02"  _L(T_U4_PRINTF_SIZE_PREFIX)   L"X%02"  _L(T_U4_PRINTF_SIZE_PREFIX)   L"X}" 
#define GUID_PRINTF   _T("{%08") _T(T_U4_PRINTF_SIZE_PREFIX) _T("X-%04") _T(T_U4_PRINTF_SIZE_PREFIX) _T("X-%04") _T(T_U4_PRINTF_SIZE_PREFIX) _T("X-%02") _T(T_U4_PRINTF_SIZE_PREFIX) _T("X%02") _T(T_U4_PRINTF_SIZE_PREFIX) _T("X-%02") _T(T_U4_PRINTF_SIZE_PREFIX) _T("X%02") _T(T_U4_PRINTF_SIZE_PREFIX) _T("X%02") _T(T_U4_PRINTF_SIZE_PREFIX) _T("X%02") _T(T_U4_PRINTF_SIZE_PREFIX) _T("X%02") _T(T_U4_PRINTF_SIZE_PREFIX) _T("X%02") _T(T_U4_PRINTF_SIZE_PREFIX) _T("X}")
#define GUID_PRINTF_VAL(x) \
    (T_U4)(x).Data1, \
    (T_U4)(x).Data2, \
    (T_U4)(x).Data3, \
    (T_U4)(x).Data4[0], (T_U4)(x).Data4[1], \
    (T_U4)(x).Data4[2], (T_U4)(x).Data4[3], (T_U4)(x).Data4[4], (T_U4)(x).Data4[5], (T_U4)(x).Data4[6], (T_U4)(x).Data4[7]
inline VARIANT& operator <<(VARIANT &p, const GUID &dat);


//////////////////////////////////////////////////////////////////////
// IDispatch
//////////////////////////////////////////////////////////////////////

inline VARIANT& operator <<(VARIANT &p, IDispatch* dat);


//////////////////////////////////////////////////////////////////////
// Makri za delo z barvami
//////////////////////////////////////////////////////////////////////

#define ARGB(r,g,b)         ((COLORREF)(((BYTE)((r) & 0xff)|((WORD)((BYTE)((g) & 0xff))<<8))|(((DWORD)(BYTE)((b) & 0xff))<<16)))
#define APALETTERGB(r,g,b)  (0x02000000 | ARGB(r,g,b))
#define APALETTEINDEX(i)    ((COLORREF)(0x01000000 | ((i) & 0xffff)))

#define ARVAL(rgb)          ((BYTE)( (rgb)       & 0xff))
#define AGVAL(rgb)          ((BYTE)(((rgb) >> 8) & 0xff))
#define ABVAL(rgb)          ((BYTE)(((rgb) >>16) & 0xff))


//////////////////////////////////////////////////////////////////////
// Makri za delo z jeziki
//////////////////////////////////////////////////////////////////////

#define AOSN_KODA_ISO639_MAX        3
#define AOSN_KODA_ISO3166_MAX       9
#define MAX_DOLZINA_OZNAKE_ISO639   5


//////////////////////////////////////////////////////////////////////
// Konstante za delo z dnevnikom
//////////////////////////////////////////////////////////////////////

#define ADNE_AOSN   _T("AOsn: ")

#ifndef ADNE_PRIORITETA
#define ADNE_PRIORITETA ADNE_DIAG
#endif
#ifndef ADNE_LOCALE
#define ADNE_LOCALE     T_LOCALE_THREAD_DEFAULT
#endif


//////////////////////////////////////////////////////////////////////
// Makri za prestrezanje izjem
//////////////////////////////////////////////////////////////////////

#ifdef AOSN_IZJEMA
#define AOSN_TRY                __try
#define AOSN_CATCH              __except (AOsn::RokovalnikIzjem(GetExceptionInformation())) {}
#define AOSN_CATCH_RETURN(x)    __except (AOsn::RokovalnikIzjem(GetExceptionInformation())) { return (x); }
#else
#define AOSN_TRY
#define AOSN_CATCH
#define AOSN_CATCH_RETURN(x)
#endif


//////////////////////////////////////////////////////////////////////
// Podatkovni tipi za delo s pomnilnikom
//////////////////////////////////////////////////////////////////////

typedef void                        T_VOID;
typedef void*                       T_KAZALEC;
typedef const void*                 TK_KAZALEC;

typedef size_t                      T_SIZE;
#define T_SIZE_MIN                  T_UINT_MIN
#define T_SIZE_MAX                  T_UINT_MAX
#if defined(_WIN64) || defined(__LP64__)
#define T_SIZE_PRINTF_SIZE_PREFIX   T_8_PRINTF_SIZE_PREFIX
#else
#define T_SIZE_PRINTF_SIZE_PREFIX   T_4_PRINTF_SIZE_PREFIX
#endif
#ifdef _NATIVE_SIZE_T_DEFINED
template <class TOK> inline TOK& operator <<(TOK &tok, const T_SIZE  podatek);
template <class TOK> inline TOK& operator >>(TOK &tok,       T_SIZE &podatek);
#endif

struct T_BINBLOK;
template <class TIP> struct AOSN_TEMPLATE T_VOZEL;
template <class TIP> struct AOSN_TEMPLATE T_VOZELENO;
template <class TIP> struct AOSN_TEMPLATE T_VOZELDVO;


//////////////////////////////////////////////////////////////////////
// Podatkovni tip boolean
//////////////////////////////////////////////////////////////////////

typedef bool                        T_BOOL;
#ifndef TRUE
#define TRUE                        1
#endif
#ifndef FALSE
#define FALSE                       0
#endif

inline VARIANT& operator <<(VARIANT &p, const T_BOOL dat);


//////////////////////////////////////////////////////////////////////
// Podatkovni tipi za hranjenje celih tevil
//////////////////////////////////////////////////////////////////////

typedef signed char                 T_1;
#define T_1_MAX                     ((T_1)  127)
#define T_1_MIN                     ((T_1)(-127 - 1))
template <class TOK> inline TOK& operator <<(TOK &tok, const T_1  podatek);
template <class TOK> inline TOK& operator >>(TOK &tok,       T_1 &podatek);

typedef unsigned char               T_U1;
#define T_U1_MAX                    ((T_U1)0xff)
#define T_U1_MIN                    ((T_U1)0x00)
template <class TOK> inline TOK& operator <<(TOK &tok, const T_U1  podatek);
template <class TOK> inline TOK& operator >>(TOK &tok,       T_U1 &podatek);
inline VARIANT& operator <<(VARIANT &p, const T_U1 dat);

typedef signed short int            T_2;
#define T_2_MAX                     ((T_2)  32767)
#define T_2_MIN                     ((T_2)(-32767 - 1))
template <class TOK> inline TOK& operator <<(TOK &tok, const T_2  podatek);
template <class TOK> inline TOK& operator >>(TOK &tok,       T_2 &podatek);

typedef unsigned short int          T_U2;
#define T_U2_MAX                    ((T_U2)0xffff)
#define T_U2_MIN                    ((T_U2)0x0000)
template <class TOK> inline TOK& operator <<(TOK &tok, const T_U2  podatek);
template <class TOK> inline TOK& operator >>(TOK &tok,       T_U2 &podatek);
inline VARIANT& operator <<(VARIANT &p, const T_U2 dat);

typedef signed long int             T_4;
#define T_4_MAX                     ((T_4)  2147483647)
#define T_4_MIN                     ((T_4)(-2147483647 - 1))
#if defined(_WIN64) || defined(__LP64__)
#define T_4_PRINTF_SIZE_PREFIX      "I32"
#else
#define T_4_PRINTF_SIZE_PREFIX      ""
#endif
template <class TOK> inline TOK& operator <<(TOK &tok, const T_4  podatek);
template <class TOK> inline TOK& operator >>(TOK &tok,       T_4 &podatek);

typedef unsigned long int           T_U4;
#define T_U4_MAX                    ((T_U4)0xffffffff)
#define T_U4_MIN                    ((T_U4)0x00000000)
#define T_U4_PRINTF_SIZE_PREFIX     T_4_PRINTF_SIZE_PREFIX
template <class TOK> inline TOK& operator <<(TOK &tok, const T_U4  podatek);
template <class TOK> inline TOK& operator >>(TOK &tok,       T_U4 &podatek);
inline VARIANT& operator <<(VARIANT &p, const T_U4 dat);

typedef signed __int64              T_8;
#define T_8_MAX                     ((T_8)  9223372036854775807)
#define T_8_MIN                     ((T_8)(-9223372036854775807 - 1))
#define T_8_PRINTF_SIZE_PREFIX      "I64"
#define T_U8_PRINTF_SIZE_PREFIX     T_8_PRINTF_SIZE_PREFIX
template <class TOK> inline TOK& operator <<(TOK &tok, const T_8  podatek);
template <class TOK> inline TOK& operator >>(TOK &tok,       T_8 &podatek);

typedef unsigned __int64            T_U8;
#define T_U8_MAX                    ((T_U8)0xffffffffffffffff)
#define T_U8_MIN                    ((T_U8)0x0000000000000000)
template <class TOK> inline TOK& operator <<(TOK &tok, const T_U8  podatek);
template <class TOK> inline TOK& operator >>(TOK &tok,       T_U8 &podatek);
inline VARIANT& operator <<(VARIANT &p, const T_U8 dat);

typedef unsigned char               T_BYTE;
#define T_BYTE_MIN                  T_U1_MIN
#define T_BYTE_MAX                  T_U1_MAX

#if defined(_WIN64)
// Windows (64-bitna arhitektura)
typedef signed __int64              T_INT;
typedef unsigned __int64            T_UINT;
#elif defined(_WIN32)
// Windows (32-bitna arhitektura)
typedef _W64 signed int             T_INT;
typedef _W64 unsigned int           T_UINT;
#define _NATIVE_SIZE_T_DEFINED
#elif defined(__GNUC__)
#ifdef __LP64__
// GCC (64-bitna arhitektura)
typedef signed long int             T_INT;
typedef unsigned long int           T_UINT;
#else
// GCC (32-bitna arhitektura)
typedef signed int                  T_INT;
typedef unsigned int                T_UINT;
#endif
#else
#error Neznana platforma!
#endif
#if defined(_WIN64) || defined(__LP64__)
// 64-bitna arhitektura
#define T_INT_MAX                   T_8_MAX
#define T_INT_MIN                   T_8_MIN
#define T_INT_PRINTF_SIZE_PREFIX    T_8_PRINTF_SIZE_PREFIX
#define T_UINT_MAX                  T_U8_MAX
#define T_UINT_MIN                  T_U8_MIN
#else
// 32-bitna arhitektura
#define T_INT_MAX                   T_4_MAX
#define T_INT_MIN                   T_4_MIN
#define T_INT_PRINTF_SIZE_PREFIX    T_4_PRINTF_SIZE_PREFIX
#define T_UINT_MAX                  T_U4_MAX
#define T_UINT_MIN                  T_U4_MIN
inline VARIANT& operator <<(VARIANT &p, const T_UINT dat);
#endif
#define T_UINT_PRINTF_SIZE_PREFIX   T_INT_PRINTF_SIZE_PREFIX


//////////////////////////////////////////////////////////////////////
// Podatkovni tipi za hranjenje znakov in nizov
//////////////////////////////////////////////////////////////////////

typedef char                        T_AZNAK;     // en znak en bajt = single
#define T_AZNAK_MAX                 ((T_AZNAK)  127)
#define T_AZNAK_MIN                 ((T_AZNAK)(-127 - 1))
template <class TOK> inline TOK& operator <<(TOK &tok, const T_AZNAK  podatek);
template <class TOK> inline TOK& operator >>(TOK &tok,       T_AZNAK &podatek);

typedef wchar_t                     T_UZNAK;     // en znak dva bajta = unicode
#define T_UZNAK_MAX                 ((T_UZNAK)0xffff)
#define T_UZNAK_MIN                 ((T_UZNAK)0x0000)
#ifdef _NATIVE_WCHAR_T_DEFINED
template <class TOK> inline TOK& operator <<(TOK &tok, const T_UZNAK  podatek);
template <class TOK> inline TOK& operator >>(TOK &tok,       T_UZNAK &podatek);
#endif

typedef T_AZNAK*                    T_ASCII;
typedef const T_AZNAK*              TK_ASCII;
template <class TOK> inline TOK& operator <<(TOK &tok, TK_ASCII podatek);
inline VARIANT& operator <<(VARIANT &p, TK_ASCII dat);

typedef T_UZNAK*                    T_UNICODE;
typedef const T_UZNAK*              TK_UNICODE;
template <class TOK> inline TOK& operator <<(TOK &tok, TK_UNICODE podatek);
inline VARIANT& operator <<(VARIANT &p, TK_UNICODE dat);

#ifdef _UNICODE
#define T_ZNAK                      T_UZNAK
#define T_NIZ                       T_UNICODE
#define TK_NIZ                      TK_UNICODE
#define T_ZNAK_MAX                  T_UZNAK_MAX
#define T_ZNAK_MIN                  T_UZNAK_MIN
#else
#define T_ZNAK                      T_AZNAK
#define T_NIZ                       T_ASCII
#define TK_NIZ                      TK_ASCII
#define T_ZNAK_MAX                  T_AZNAK_MAX
#define T_ZNAK_MIN                  T_AZNAK_MIN
#endif


//////////////////////////////////////////////////////////////////////
// Podatkovni tipi za delo z roicami
//////////////////////////////////////////////////////////////////////

typedef T_VOID*                     T_ROCICA;
typedef const T_VOID*               TK_ROCICA;

#if defined(_WIN32)
typedef HANDLE                      T_ROCICAOS;
#define NEVELJAVNA_ROCICA           INVALID_HANDLE_VALUE
#define JE_VELJAVNA_ROCICA(rocica)  (((T_UINT)(rocica)) + 1 > 1)
#define NI_VELJAVNA_ROCICA(rocica)  (((T_UINT)(rocica)) + 1 <= 1)
#elif defined(__GNUC__)
typedef int                         T_ROCICAOS;
#define NEVELJAVNA_ROCICA           ((T_ROCICAOS)-1)
#define JE_VELJAVNA_ROCICA(rocica)  ((rocica) != NEVELJAVNA_ROCICA)
#define NI_VELJAVNA_ROCICA(rocica)  ((rocica) == NEVELJAVNA_ROCICA)
#else
#error Neznana platforma!
#endif


//////////////////////////////////////////////////////////////////////
// Podatkovni tipi za delo z datotekami
//////////////////////////////////////////////////////////////////////

typedef unsigned __int64            T_ODMIK;   // absolutni odmik
#define T_ODMIK_MAX                 T_U8_MAX
#define T_ODMIK_MIN                 T_U8_MIN
#define T_ODMIK_PRINTF_SIZE_PREFIX  T_U8_PRINTF_SIZE_PREFIX

typedef   signed __int64            T_RODMIK;  // relativni odmik (pri relativnih premikih)
#define T_RODMIK_MAX                T_8_MAX
#define T_RODMIK_MIN                T_8_MIN
#define T_RODMIK_PRINTF_SIZE_PREFIX T_8_PRINTF_SIZE_PREFIX

typedef unsigned __int64            T_DOLZINA; // dolzina
#define T_DOLZINA_MAX               T_U8_MAX
#define T_DOLZINA_MIN               T_U8_MIN
#define T_DOLZINA_PRINTF_SIZE_PREFIX T_U8_PRINTF_SIZE_PREFIX


//////////////////////////////////////////////////////////////////////
// Podatkovni tip za vraanje stanja funkcij
// in makri za preverjanje uspenosti
//////////////////////////////////////////////////////////////////////

typedef signed int                  T_STANJE;
#define T_STANJE_PRINTF             "%#010x"
#ifndef HRESULT_PRINTF
#define HRESULT_PRINTF              T_STANJE_PRINTF
#endif

#define OPOZORILO(stanje)           ((stanje)>0)
#define USPESNO(stanje)             ((stanje)>=0)
#define BREZHIBNO(stanje)           ((stanje)==0)
#define NEUSPESNO(stanje)           ((stanje)<0)
#define MODUL_STANJA(stanje)        (((stanje) & 0x7ff00000) >> 20)
#define KODA_STANJA(stanje)          ((stanje) & 0x000fffff)


//////////////////////////////////////////////////////////////////////
// Podatkovni tipi za hranjenje ure in datuma
//////////////////////////////////////////////////////////////////////

typedef signed __int64              T_TRENUTEK;
#define T_TRENUTEK_MIN              ((T_TRENUTEK)T_8_MIN)
#define T_TRENUTEK_MAX              ((T_TRENUTEK)T_8_MAX)

#define RDTM_FAKTOR_SEKUNDA         1000L // tevilo milisekund na sekundo
#define RDTM_FAKTOR_MINUTA          60L   // tevilo sekund na minuto
#define RDTM_FAKTOR_URA             60L   // tevilo minut na uro
#define RDTM_FAKTOR_DAN             24L   // tevilo ur na dan
#define RDTM_FAKTOR_TEDEN           7L    // tevilo dni v tednu

#define RDTM_SEKUNDA  RDTM_FAKTOR_SEKUNDA                 // tevilo milisekund na sekundo
#define RDTM_MINUTA   (RDTM_FAKTOR_MINUTA*RDTM_SEKUNDA)   // tevilo milisekund na minuto
#define RDTM_URA      (RDTM_FAKTOR_URA*RDTM_MINUTA)       // tevilo milisekund na uro
#define RDTM_DAN      (RDTM_FAKTOR_DAN*RDTM_URA)          // tevilo milisekund na dan
#define RDTM_TEDEN    (RDTM_FAKTOR_TEDEN*RDTM_DAN)        // tevilo milisekund na dan


//////////////////////////////////////////////////////////////////////
// Koda rezultata, ki jo vraa nit/proces
//////////////////////////////////////////////////////////////////////

typedef unsigned int                T_REZULTAT;


//////////////////////////////////////////////////////////////////////
// Podatkovni tipi za hranjenje realnih tevil
//////////////////////////////////////////////////////////////////////

typedef float                       T_FLOAT;
#define T_FLOAT_MAX                 FLT_MAX
#define T_FLOAT_MIN                 FLT_MIN
#define T_FLOAT_EPS                 FLT_EPS
#define T_FLOAT_PINF_BIN            ((T_U4)0x7f800000)
#define T_FLOAT_NINF_BIN            ((T_U4)0xff800000)
#define T_FLOAT_NAN_BIN             ((T_U4)0xffc00000)
#define T_FLOAT_PI                  3.141592653589793f
template <class TOK> inline TOK& operator <<(TOK &tok, const T_FLOAT  podatek);
template <class TOK> inline TOK& operator >>(TOK &tok,       T_FLOAT &podatek);

typedef double                      T_DOUBLE;
#define T_DOUBLE_MAX                DBL_MAX
#define T_DOUBLE_MIN                DBL_MIN
#define T_DOUBLE_EPS                DBL_EPS
#define T_DOUBLE_PINF_BIN           ((T_U8)0x7ff0000000000000)
#define T_DOUBLE_NINF_BIN           ((T_U8)0xfff0000000000000)
#define T_DOUBLE_NAN_BIN            ((T_U8)0xfff8000000000000)
#define T_DOUBLE_PI                 3.141592653589793
template <class TOK> inline TOK& operator <<(TOK &tok, const T_DOUBLE  podatek);
template <class TOK> inline TOK& operator >>(TOK &tok,       T_DOUBLE &podatek);

#ifdef _DOUBLE
#define T_REAL                      T_DOUBLE
#define T_REAL_BIN                  T_U4
#define T_REAL_MAX                  T_DOUBLE_MAX
#define T_REAL_MIN                  T_DOUBLE_MIN
#define T_REAL_EPS                  T_DOUBLE_EPS
#define T_REAL_PINF_BIN             T_DOUBLE_PINF_BIN
#define T_REAL_NINF_BIN             T_DOUBLE_NINF_BIN
#define T_REAL_NAN_BIN              T_DOUBLE_NAN_BIN
#define T_REAL_PI                   T_DOUBLE_PI
#else
#define T_REAL                      T_FLOAT
#define T_REAL_BIN                  T_U8
#define T_REAL_MAX                  T_FLOAT_MAX
#define T_REAL_MIN                  T_FLOAT_MIN
#define T_REAL_EPS                  T_FLOAT_EPS
#define T_REAL_PINF_BIN             T_FLOAT_PINF_BIN
#define T_REAL_NINF_BIN             T_FLOAT_NINF_BIN
#define T_REAL_NAN_BIN              T_FLOAT_NAN_BIN
#define T_REAL_PI                   T_FLOAT_PI
#endif


//////////////////////////////////////////////////////////////////////
// Podatkovni tipi za hranjenje imaginarnih tevil
//////////////////////////////////////////////////////////////////////

template <class TIP> struct AOSN_TEMPLATE T_KOMPLP;
typedef T_KOMPLP<T_DOUBLE>  T_KOMPLD;
typedef T_KOMPLP<T_FLOAT>   T_KOMPLF;
#ifdef _DOUBLE
#define T_KOMPL             T_KOMPLD
#else
#define T_KOMPL             T_KOMPLF
#endif

template <class TIP> struct AOSN_TEMPLATE T_KOMPLRP;
typedef T_KOMPLRP<T_DOUBLE> T_KOMPLRD;
typedef T_KOMPLRP<T_FLOAT>  T_KOMPLRF;
#ifdef _DOUBLE
#define T_KOMPLR            T_KOMPLRD
#else
#define T_KOMPLR            T_KOMPLRF
#endif


//////////////////////////////////////////////////////////////////////
// Podatkovni tipi za delo z intervali
//////////////////////////////////////////////////////////////////////

template <class TIP> struct AOSN_TEMPLATE T_INTERVAL;


//////////////////////////////////////////////////////////////////////
// Podatkovni tipi za delo s polimofrnimi podatki
//////////////////////////////////////////////////////////////////////

enum T_VRSTAVAR;
struct AOSN_INLINE_CLASS T_VAR;


//////////////////////////////////////////////////////////////////////
// Podatkovni tipi za delo z delovnimi mesti
//////////////////////////////////////////////////////////////////////

struct T_DELOVNOMESTO;


//////////////////////////////////////////////////////////////////////
// Podatkovni tipi za rezervacijo pomnilnika
//////////////////////////////////////////////////////////////////////

enum T_AMALLOC_OPERACIJA;
struct T_AMALLOC_ZAPIS_OPERACIJE;


//////////////////////////////////////////////////////////////////////
// Podatkovni tipi za delo z entitetami SGML
//////////////////////////////////////////////////////////////////////

#ifndef AOSN_BREZ_SGML
struct T_SGML_UNICODE_ENTITETA;
#endif


//////////////////////////////////////////////////////////////////////
// Podatkovni tipi za delo s kodnimi stranmi in jeziki
//////////////////////////////////////////////////////////////////////

enum T_KODNASTRAN;
enum T_KODAJEZIKA;
enum T_KODAJEZIKA2;
enum T_KODAUREDITVE;
enum T_KODALOCALE;
#if _MSC_VER >= 1400
typedef _locale_t T_LOCALE;
#else
typedef struct _T_LOCALE {
    int category;
    char *locale;
} *T_LOCALE;
#endif // _MSC_VER
#define T_LOCALE_THREAD_DEFAULT ((T_LOCALE)NULL)


//////////////////////////////////////////////////////////////////////
// Podatkovni tipi za delo z dnevnikom
//////////////////////////////////////////////////////////////////////

enum T_DNEVNIKPRIORITETA;


//////////////////////////////////////////////////////////////////////
// Podatkovni tipi za ugotavljanje verzije op. sistema
//////////////////////////////////////////////////////////////////////

enum T_PLATFORMAOS;
enum T_VERZIJAOS;
#define AOSN_PLATFORMA_OS(verzija) ((T_PLATFORMAOS)((verzija) & 0xffff0000))
#define AOSN_VERZIJA_OS(verzija)   ((T_UINT)       ((verzija) & 0x0000ffff))


//////////////////////////////////////////////////////////////////////
// Podatkovni tipi za delo s standardnimi podatkovnimi tokovi
//////////////////////////////////////////////////////////////////////

enum T_STD_ROCICA;


//////////////////////////////////////////////////////////////////////
// Podatkovni tipi za delo z vtinicami
//////////////////////////////////////////////////////////////////////

#ifdef AOSN_VTIC

#if defined(_WIN32)
typedef SOCKET              T_VTICNICA;
#elif defined(__GNUC__)
typedef int                 T_VTICNICA;
#endif
#if defined(_WIN32)
#define NEVELJAVNA_VTICNICA INVALID_SOCKET
#elif defined(__GNUC__)
#define NEVELJAVNA_VTICNICA (-1)
#endif
#define JE_VELJAVNA_VTICNICA(vticnica)  ((vticnica) != NEVELJAVNA_VTICNICA)
#define NI_VELJAVNA_VTICNICA(vticnica)  ((vticnica) == NEVELJAVNA_VTICNICA)

typedef struct sockaddr     T_SOCKADDR;
typedef struct sockaddr_in  T_SOCKADDR_IN;
typedef struct hostent      T_HOSTENT;
typedef struct protoent     T_PROTOENT;
typedef struct servent      T_SERVENT;
typedef struct in_addr      T_INADDR;
typedef struct fd_set       T_FDSET;

enum T_VTICDOMENA;
enum T_VTICVRSTA;
enum T_VTICPROTOKOL;
enum T_VTICNACINZAPIRANJA;
enum T_VTICNIVOPARAM;
enum T_VTICPARAMETER;
enum T_VTICNACIN;

#endif // AOSN_VTIC


//////////////////////////////////////////////////////////////////////
// Deklaracije razredov in predlog AOsn
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RElement;
class AOSN_CLASS RSisElement;
class AOSN_CLASS RIzpElement;

#ifdef AOSN_KAZNAP
class AOSN_CLASS RKazalnikNapredka;
class AOSN_CLASS RCasKazalnikNapredka;
class AOSN_CLASS RGlobalniKazalnikNapredka;
#endif // AOSN_KAZNAP

template <class TIP> class AOSN_TEMPLATE RKazalec;
template <class TIP> class AOSN_TEMPLATE RTabela;
template <class TIP> class AOSN_TEMPLATE RDinTabela;
template <class TIP> class AOSN_TEMPLATE RZbirka;
template <class TIP> class AOSN_TEMPLATE RSklad;
template <class TIP> class AOSN_TEMPLATE RSeznam;
template <class TIP> class AOSN_TEMPLATE RUrejenSeznam;
template <class TIP, T_UINT N> struct AOSN_TEMPLATE T_BVOZEL;
template <class TIP, T_UINT N> class AOSN_TEMPLATE RBIndeks;
template <class TIP, T_UINT N> class AOSN_TEMPLATE RBDrevo;

template <class TIP> class AOSN_TEMPLATE RNizP;
template <class TIP> class AOSN_TEMPLATE RNizNP;
template <class TIP> class AOSN_TEMPLATE RNizOP;
template <class TIP> class AOSN_TEMPLATE RNizVP;
class AOSN_CLASS RNizA;
class AOSN_CLASS RNizU;
#ifdef _UNICODE
#define RNiz RNizU
#else
#define RNiz RNizA
#endif

#ifdef AOSN_REGIZR
#define RREGIZR_NE_LOCUJ_VELIKIH_MALIH  0x00000001
#define RREGIZR_VECVRSTICNO             0x00000002

#define RREGIZR_PRIVZETO                0

#define RREGIZR_DATUM_DML               0x00000001
#define RREGIZR_DATUM_MDL               0x00000002
#define RREGIZR_DATUM_LMD               0x00000004
#define RREGIZR_DATUM_LM                0x00000008
#define RREGIZR_DATUM_ML                0x00000010
#define RREGIZR_DATUM_DM                0x00000020
#define RREGIZR_DATUM_MD                0x00000040

#define RREGIZR_LOCILO_BESED_PRESLEDKI  0x00000001  // presledki
#define RREGIZR_LOCILO_BESED_PIKE       0x00000002  // pike, vejice in druga loila
#define RREGIZR_LOCILO_BESED_STEVKE     0x00000004  // arabske tevke
#define RREGIZR_LOCILO_BESED_SIMBOLI    0x00000008  // vsi izpisljivi znaki, ki niso rka ali arabska tevka (vkljuno z loili)

template <class TIP> class AOSN_TEMPLATE RRegElementP;
template <class TIP> class AOSN_TEMPLATE RRegElZbirkaP;
template <class TIP> class AOSN_TEMPLATE RRegElNOPP;
template <class TIP> class AOSN_TEMPLATE RRegElPoljubenZnakP;
template <class TIP> class AOSN_TEMPLATE RRegElZnakP;
template <class TIP> class AOSN_TEMPLATE RRegElAlfanumericniZnakP;
template <class TIP> class AOSN_TEMPLATE RRegElPresledekP;
template <class TIP> class AOSN_TEMPLATE RRegElLociloP;
template <class TIP> class AOSN_TEMPLATE RRegElPresledekAliLociloP;
template <class TIP> class AOSN_TEMPLATE RRegElZacetekVrsticeP;
template <class TIP> class AOSN_TEMPLATE RRegElKonecVrsticeP;
template <class TIP> class AOSN_TEMPLATE RRegElZacetekBesedeP;
template <class TIP> class AOSN_TEMPLATE RRegElKonecBesedeP;
template <class TIP> class AOSN_TEMPLATE RRegElMaskaOsnP;
template <class TIP> class AOSN_TEMPLATE RRegElMaskaP;
template <class TIP> class AOSN_TEMPLATE RRegElNizP;
template <class TIP> class AOSN_TEMPLATE RRegElPonavljanjeP;
template <class TIP> class AOSN_TEMPLATE RRegElZaporedjeP;
template <class TIP> class AOSN_TEMPLATE RRegElVejitevP;
template <class TIP> class AOSN_TEMPLATE RRegElVejitevNizovP;
template <class TIP> class AOSN_TEMPLATE RRegElPermutacijaP;
template <class TIP> class AOSN_TEMPLATE RRegElStevnikCeliP;
template <class TIP> class AOSN_TEMPLATE RRegElStevnikCeli10P;
template <class TIP> class AOSN_TEMPLATE RRegElStevnikCeli10LTP;
template <class TIP> class AOSN_TEMPLATE RRegElStevnikCeli16P;
template <class TIP> class AOSN_TEMPLATE RRegElStevnikRimskiP;
template <class TIP> class AOSN_TEMPLATE RRegElUlomekP;
template <class TIP> class AOSN_TEMPLATE RRegElSteviloCeloP;
template <class TIP> class AOSN_TEMPLATE RRegElSteviloRacionalnoP;
template <class TIP> class AOSN_TEMPLATE RRegElSteviloDecimalnoP;
template <class TIP> class AOSN_TEMPLATE RRegElSteviloMonetarnoP;
template <class TIP> class AOSN_TEMPLATE RRegElIPv4NaslovP;
template <class TIP> class AOSN_TEMPLATE RRegElDNSNaslovZnakP;
template <class TIP> class AOSN_TEMPLATE RRegElDNSNaslovP;
template <class TIP> class AOSN_TEMPLATE RRegElURLUporabnikZnakP;
template <class TIP> class AOSN_TEMPLATE RRegElURLGesloZnakP;
template <class TIP> class AOSN_TEMPLATE RRegElURLPotZnakP;
template <class TIP> class AOSN_TEMPLATE RRegElURLPotP;
template <class TIP> class AOSN_TEMPLATE RRegElURLNaslovP;
template <class TIP> class AOSN_TEMPLATE RRegElEPostaNaslovP;
template <class TIP> class AOSN_TEMPLATE RRegElSmeskoP;
template <class TIP> class AOSN_TEMPLATE RRegElDatumP;
template <class TIP> class AOSN_TEMPLATE RRegElCasP;
template <class TIP> class AOSN_TEMPLATE RRegElKotP;
template <class TIP> class AOSN_TEMPLATE RRegElTelefonskaStevilkaP;
template <class TIP> class AOSN_TEMPLATE RRegElKemijskaSpojinaP;
template <class TIP> struct T_REGIZR_NASTAVITVEP;

typedef               RRegElementP<T_AZNAK> AOSN_CLASS RRegElementA;
typedef               RRegElementP<T_UZNAK> AOSN_CLASS RRegElementU;
typedef              RRegElZbirkaP<T_AZNAK> AOSN_CLASS RRegElZbirkaA;
typedef              RRegElZbirkaP<T_UZNAK> AOSN_CLASS RRegElZbirkaU;
typedef                RRegElNOPP<T_AZNAK> AOSN_CLASS RRegElNOPA;
typedef                RRegElNOPP<T_UZNAK> AOSN_CLASS RRegElNOPU;
typedef       RRegElPoljubenZnakP<T_AZNAK> AOSN_CLASS RRegElPoljubenZnakA;
typedef       RRegElPoljubenZnakP<T_UZNAK> AOSN_CLASS RRegElPoljubenZnakU;
typedef               RRegElZnakP<T_AZNAK> AOSN_CLASS RRegElZnakA;
typedef               RRegElZnakP<T_UZNAK> AOSN_CLASS RRegElZnakU;
typedef  RRegElAlfanumericniZnakP<T_AZNAK> AOSN_CLASS RRegElAlfanumericniZnakA;
typedef  RRegElAlfanumericniZnakP<T_UZNAK> AOSN_CLASS RRegElAlfanumericniZnakU;
typedef          RRegElPresledekP<T_AZNAK> AOSN_CLASS RRegElPresledekA;
typedef          RRegElPresledekP<T_UZNAK> AOSN_CLASS RRegElPresledekU;
typedef             RRegElLociloP<T_AZNAK> AOSN_CLASS RRegElLociloA;
typedef             RRegElLociloP<T_UZNAK> AOSN_CLASS RRegElLociloU;
typedef RRegElPresledekAliLociloP<T_AZNAK> AOSN_CLASS RRegElPresledekAliLociloA;
typedef RRegElPresledekAliLociloP<T_UZNAK> AOSN_CLASS RRegElPresledekAliLociloU;
typedef     RRegElZacetekVrsticeP<T_AZNAK> AOSN_CLASS RRegElZacetekVrsticeA;
typedef     RRegElZacetekVrsticeP<T_UZNAK> AOSN_CLASS RRegElZacetekVrsticeU;
typedef       RRegElKonecVrsticeP<T_AZNAK> AOSN_CLASS RRegElKonecVrsticeA;
typedef       RRegElKonecVrsticeP<T_UZNAK> AOSN_CLASS RRegElKonecVrsticeU;
typedef      RRegElZacetekBesedeP<T_AZNAK> AOSN_CLASS RRegElZacetekBesedeA;
typedef      RRegElZacetekBesedeP<T_UZNAK> AOSN_CLASS RRegElZacetekBesedeU;
typedef        RRegElKonecBesedeP<T_AZNAK> AOSN_CLASS RRegElKonecBesedeA;
typedef        RRegElKonecBesedeP<T_UZNAK> AOSN_CLASS RRegElKonecBesedeU;
typedef              RRegElMaskaP<T_AZNAK> AOSN_CLASS RRegElMaskaA;
typedef              RRegElMaskaP<T_UZNAK> AOSN_CLASS RRegElMaskaU;
typedef                RRegElNizP<T_AZNAK> AOSN_CLASS RRegElNizA;
typedef                RRegElNizP<T_UZNAK> AOSN_CLASS RRegElNizU;
typedef        RRegElPonavljanjeP<T_AZNAK> AOSN_CLASS RRegElPonavljanjeA;
typedef        RRegElPonavljanjeP<T_UZNAK> AOSN_CLASS RRegElPonavljanjeU;
typedef          RRegElZaporedjeP<T_AZNAK> AOSN_CLASS RRegElZaporedjeA;
typedef          RRegElZaporedjeP<T_UZNAK> AOSN_CLASS RRegElZaporedjeU;
typedef            RRegElVejitevP<T_AZNAK> AOSN_CLASS RRegElVejitevA;
typedef            RRegElVejitevP<T_UZNAK> AOSN_CLASS RRegElVejitevU;
typedef       RRegElVejitevNizovP<T_AZNAK> AOSN_CLASS RRegElVejitevNizovA;
typedef       RRegElVejitevNizovP<T_UZNAK> AOSN_CLASS RRegElVejitevNizovU;
typedef        RRegElPermutacijaP<T_AZNAK> AOSN_CLASS RRegElPermutacijaA;
typedef        RRegElPermutacijaP<T_UZNAK> AOSN_CLASS RRegElPermutacijaU;
typedef      RRegElStevnikCeli10P<T_AZNAK> AOSN_CLASS RRegElStevnikCeli10A;
typedef      RRegElStevnikCeli10P<T_UZNAK> AOSN_CLASS RRegElStevnikCeli10U;
typedef    RRegElStevnikCeli10LTP<T_AZNAK> AOSN_CLASS RRegElStevnikCeli10LTA;
typedef    RRegElStevnikCeli10LTP<T_UZNAK> AOSN_CLASS RRegElStevnikCeli10LTU;
typedef      RRegElStevnikCeli16P<T_AZNAK> AOSN_CLASS RRegElStevnikCeli16A;
typedef      RRegElStevnikCeli16P<T_UZNAK> AOSN_CLASS RRegElStevnikCeli16U;
typedef      RRegElStevnikRimskiP<T_AZNAK> AOSN_CLASS RRegElStevnikRimskiA;
typedef      RRegElStevnikRimskiP<T_UZNAK> AOSN_CLASS RRegElStevnikRimskiU;
typedef             RRegElUlomekP<T_AZNAK> AOSN_CLASS RRegElUlomekA;
typedef             RRegElUlomekP<T_UZNAK> AOSN_CLASS RRegElUlomekU;
typedef        RRegElSteviloCeloP<T_AZNAK> AOSN_CLASS RRegElSteviloCeloA;
typedef        RRegElSteviloCeloP<T_UZNAK> AOSN_CLASS RRegElSteviloCeloU;
typedef  RRegElSteviloRacionalnoP<T_AZNAK> AOSN_CLASS RRegElSteviloRacionalnoA;
typedef  RRegElSteviloRacionalnoP<T_UZNAK> AOSN_CLASS RRegElSteviloRacionalnoU;
typedef   RRegElSteviloDecimalnoP<T_AZNAK> AOSN_CLASS RRegElSteviloDecimalnoA;
typedef   RRegElSteviloDecimalnoP<T_UZNAK> AOSN_CLASS RRegElSteviloDecimalnoU;
typedef   RRegElSteviloMonetarnoP<T_AZNAK> AOSN_CLASS RRegElSteviloMonetarnoA;
typedef   RRegElSteviloMonetarnoP<T_UZNAK> AOSN_CLASS RRegElSteviloMonetarnoU;
typedef         RRegElIPv4NaslovP<T_AZNAK> AOSN_CLASS RRegElIPv4NaslovA;
typedef         RRegElIPv4NaslovP<T_UZNAK> AOSN_CLASS RRegElIPv4NaslovU;
typedef      RRegElDNSNaslovZnakP<T_AZNAK> AOSN_CLASS RRegElDNSNaslovZnakA;
typedef      RRegElDNSNaslovZnakP<T_UZNAK> AOSN_CLASS RRegElDNSNaslovZnakU;
typedef          RRegElDNSNaslovP<T_AZNAK> AOSN_CLASS RRegElDNSNaslovA;
typedef          RRegElDNSNaslovP<T_UZNAK> AOSN_CLASS RRegElDNSNaslovU;
typedef   RRegElURLUporabnikZnakP<T_AZNAK> AOSN_CLASS RRegElURLUporabnikZnakA;
typedef   RRegElURLUporabnikZnakP<T_UZNAK> AOSN_CLASS RRegElURLUporabnikZnakU;
typedef       RRegElURLGesloZnakP<T_AZNAK> AOSN_CLASS RRegElURLGesloZnakA;
typedef       RRegElURLGesloZnakP<T_UZNAK> AOSN_CLASS RRegElURLGesloZnakU;
typedef         RRegElURLPotZnakP<T_AZNAK> AOSN_CLASS RRegElURLPotZnakA;
typedef         RRegElURLPotZnakP<T_UZNAK> AOSN_CLASS RRegElURLPotZnakU;
typedef             RRegElURLPotP<T_AZNAK> AOSN_CLASS RRegElURLPotA;
typedef             RRegElURLPotP<T_UZNAK> AOSN_CLASS RRegElURLPotU;
typedef          RRegElURLNaslovP<T_AZNAK> AOSN_CLASS RRegElURLNaslovA;
typedef          RRegElURLNaslovP<T_UZNAK> AOSN_CLASS RRegElURLNaslovU;
typedef       RRegElEPostaNaslovP<T_AZNAK> AOSN_CLASS RRegElEPostaNaslovA;
typedef       RRegElEPostaNaslovP<T_UZNAK> AOSN_CLASS RRegElEPostaNaslovU;
typedef             RRegElSmeskoP<T_AZNAK> AOSN_CLASS RRegElSmeskoA;
typedef             RRegElSmeskoP<T_UZNAK> AOSN_CLASS RRegElSmeskoU;
typedef              RRegElDatumP<T_AZNAK> AOSN_CLASS RRegElDatumA;
typedef              RRegElDatumP<T_UZNAK> AOSN_CLASS RRegElDatumU;
typedef                RRegElCasP<T_AZNAK> AOSN_CLASS RRegElCasA;
typedef                RRegElCasP<T_UZNAK> AOSN_CLASS RRegElCasU;
typedef                RRegElKotP<T_AZNAK> AOSN_CLASS RRegElKotA;
typedef                RRegElKotP<T_UZNAK> AOSN_CLASS RRegElKotU;
typedef RRegElTelefonskaStevilkaP<T_AZNAK> AOSN_CLASS RRegElTelefonskaStevilkaA;
typedef RRegElTelefonskaStevilkaP<T_UZNAK> AOSN_CLASS RRegElTelefonskaStevilkaU;
typedef    RRegElKemijskaSpojinaP<T_AZNAK> AOSN_CLASS RRegElKemijskaSpojinaA;
typedef    RRegElKemijskaSpojinaP<T_UZNAK> AOSN_CLASS RRegElKemijskaSpojinaU;

#ifndef AOSN_BREZ_SGML
typedef              RRegElementP<T_AZNAK> AOSN_CLASS RRegElementSGML;
typedef             RRegElZbirkaP<T_AZNAK> AOSN_CLASS RRegElZbirkaSGML;
typedef                RRegElNOPP<T_AZNAK> AOSN_CLASS RRegElNOPSGML;
class                                      AOSN_CLASS RRegElPoljubenZnakSGML;
class                                      AOSN_CLASS RRegElZnakSGML;
class                                      AOSN_CLASS RRegElAlfanumericniZnakSGML;
class                                      AOSN_CLASS RRegElPresledekSGML;
class                                      AOSN_CLASS RRegElLociloSGML;
class                                      AOSN_CLASS RRegElPresledekAliLociloSGML;
typedef     RRegElZacetekVrsticeP<T_AZNAK> AOSN_CLASS RRegElZacetekVrsticeSGML;
typedef       RRegElKonecVrsticeP<T_AZNAK> AOSN_CLASS RRegElKonecVrsticeSGML;
class                                      AOSN_CLASS RRegElZacetekBesedeSGML;
class                                      AOSN_CLASS RRegElKonecBesedeSGML;
class                                      AOSN_CLASS RRegElMaskaSGML;
class                                      AOSN_CLASS RRegElNizSGML;
typedef        RRegElPonavljanjeP<T_AZNAK> AOSN_CLASS RRegElPonavljanjeSGML;
typedef          RRegElZaporedjeP<T_AZNAK> AOSN_CLASS RRegElZaporedjeSGML;
typedef            RRegElVejitevP<T_AZNAK> AOSN_CLASS RRegElVejitevSGML;
class                                      AOSN_CLASS RRegElVejitevNizovSGML;
typedef        RRegElPermutacijaP<T_AZNAK> AOSN_CLASS RRegElPermutacijaSGML;
typedef      RRegElStevnikCeli10P<T_AZNAK> AOSN_CLASS RRegElStevnikCeli10SGML;
typedef    RRegElStevnikCeli10LTP<T_AZNAK> AOSN_CLASS RRegElStevnikCeli10LTSGML;
typedef      RRegElStevnikCeli16P<T_AZNAK> AOSN_CLASS RRegElStevnikCeli16SGML;
typedef      RRegElStevnikRimskiP<T_AZNAK> AOSN_CLASS RRegElStevnikRimskiSGML;
typedef             RRegElUlomekP<T_AZNAK> AOSN_CLASS RRegElUlomekSGML;
typedef        RRegElSteviloCeloP<T_AZNAK> AOSN_CLASS RRegElSteviloCeloSGML;
typedef  RRegElSteviloRacionalnoP<T_AZNAK> AOSN_CLASS RRegElSteviloRacionalnoSGML;
typedef   RRegElSteviloDecimalnoP<T_AZNAK> AOSN_CLASS RRegElSteviloDecimalnoSGML;
typedef   RRegElSteviloMonetarnoP<T_AZNAK> AOSN_CLASS RRegElSteviloMonetarnoSGML;
typedef         RRegElIPv4NaslovP<T_AZNAK> AOSN_CLASS RRegElIPv4NaslovSGML;
class                                      AOSN_CLASS RRegElDNSNaslovZnakSGML;
typedef          RRegElDNSNaslovP<T_AZNAK> AOSN_CLASS RRegElDNSNaslovSGML;
class                                      AOSN_CLASS RRegElURLUporabnikZnakSGML;
class                                      AOSN_CLASS RRegElURLGesloZnakSGML;
class                                      AOSN_CLASS RRegElURLPotZnakSGML;
typedef             RRegElURLPotP<T_AZNAK> AOSN_CLASS RRegElURLPotSGML;
typedef          RRegElURLNaslovP<T_AZNAK> AOSN_CLASS RRegElURLNaslovSGML;
typedef       RRegElEPostaNaslovP<T_AZNAK> AOSN_CLASS RRegElEPostaNaslovSGML;
typedef             RRegElSmeskoP<T_AZNAK> AOSN_CLASS RRegElSmeskoSGML;
typedef              RRegElDatumP<T_AZNAK> AOSN_CLASS RRegElDatumSGML;
typedef                RRegElCasP<T_AZNAK> AOSN_CLASS RRegElCasSGML;
typedef                RRegElKotP<T_AZNAK> AOSN_CLASS RRegElKotSGML;
typedef RRegElTelefonskaStevilkaP<T_AZNAK> AOSN_CLASS RRegElTelefonskaStevilkaSGML;
typedef    RRegElKemijskaSpojinaP<T_AZNAK> AOSN_CLASS RRegElKemijskaSpojinaSGML;
#endif

#ifdef _UNICODE
#define RRegElement                 RRegElementU
#define RRegElZbirka                RRegElZbirkaU
#define RRegElNOP                   RRegElNOPU
#define RRegElPoljubenZnak          RRegElPoljubenZnakU
#define RRegElZnak                  RRegElZnakU
#define RRegElAlfanumericniZnak     RRegElAlfanumericniZnakU
#define RRegElPresledek             RRegElPresledekU
#define RRegElLocilo                RRegElLociloU
#define RRegElPresledekAliLocilo    RRegElPresledekAliLociloU
#define RRegElZacetekVrstice        RRegElZacetekVrsticeU
#define RRegElKonecVrstice          RRegElKonecVrsticeU
#define RRegElZacetekBesede         RRegElZacetekBesedeU
#define RRegElKonecBesede           RRegElKonecBesedeU
#define RRegElMaska                 RRegElMaskaU
#define RRegElNiz                   RRegElNizU
#define RRegElPonavljanje           RRegElPonavljanjeU
#define RRegElZaporedje             RRegElZaporedjeU
#define RRegElVejitev               RRegElVejitevU
#define RRegElVejitevNizov          RRegElVejitevNizovU
#define RRegElPermutacija           RRegElPermutacijaU
#define RRegElStevnikCeli10         RRegElStevnikCeli10U
#define RRegElStevnikCeli10LT       RRegElStevnikCeli10LTU
#define RRegElStevnikCeli16         RRegElStevnikCeli16U
#define RRegElStevnikRimski         RRegElStevnikRimskiU
#define RRegElUlomek                RRegElUlomekU
#define RRegElSteviloCelo           RRegElSteviloCeloU
#define RRegElSteviloRacionalno     RRegElSteviloRacionalnoU
#define RRegElSteviloDecimalno      RRegElSteviloDecimalnoU
#define RRegElSteviloMonetarno      RRegElSteviloMonetarnoU
#define RRegElIPv4Naslov            RRegElIPv4NaslovU
#define RRegElDNSNaslovZnak         RRegElDNSNaslovZnakU
#define RRegElDNSNaslov             RRegElDNSNaslovU
#define RRegElURLUporabnikZnak      RRegElURLUporabnikZnakU
#define RRegElURLGesloZnak          RRegElURLGesloZnakU
#define RRegElURLPotZnak            RRegElURLPotZnakU
#define RRegElURLPot                RRegElURLPotU
#define RRegElURLNaslov             RRegElURLNaslovU
#define RRegElEPostaNaslov          RRegElEPostaNaslovU
#define RRegElSmesko                RRegElSmeskoU
#define RRegElDatum                 RRegElDatumU
#define RRegElCas                   RRegElCasU
#define RRegElKot                   RRegElKotU
#define RRegElTelefonskaStevilka    RRegElTelefonskaStevilkaU
#define RRegElKemijskaSpojina       RRegElKemijskaSpojinaU
#else
#define RRegElement                 RRegElementA
#define RRegElZbirka                RRegElZbirkaA
#define RRegElNOP                   RRegElNOPA
#define RRegElPoljubenZnak          RRegElPoljubenZnakA
#define RRegElZnak                  RRegElZnakA
#define RRegElAlfanumericniZnak     RRegElAlfanumericniZnakA
#define RRegElPresledek             RRegElPresledekA
#define RRegElLocilo                RRegElLociloA
#define RRegElPresledekAliLocilo    RRegElPresledekAliLociloA
#define RRegElZacetekVrstice        RRegElZacetekVrsticeA
#define RRegElKonecVrstice          RRegElKonecVrsticeA
#define RRegElZacetekBesede         RRegElZacetekBesedeA
#define RRegElKonecBesede           RRegElKonecBesedeA
#define RRegElMaska                 RRegElMaskaA
#define RRegElNiz                   RRegElNizA
#define RRegElPonavljanje           RRegElPonavljanjeA
#define RRegElZaporedje             RRegElZaporedjeA
#define RRegElVejitev               RRegElVejitevA
#define RRegElVejitevNizov          RRegElVejitevNizovA
#define RRegElPermutacija           RRegElPermutacijaA
#define RRegElStevnikCeli10         RRegElStevnikCeli10A
#define RRegElStevnikCeli10LT       RRegElStevnikCeli10LTA
#define RRegElStevnikCeli16         RRegElStevnikCeli16A
#define RRegElStevnikRimski         RRegElStevnikRimskiA
#define RRegElUlomek                RRegElUlomekA
#define RRegElSteviloCelo           RRegElSteviloCeloA
#define RRegElSteviloRacionalno     RRegElSteviloRacionalnoA
#define RRegElSteviloDecimalno      RRegElSteviloDecimalnoA
#define RRegElSteviloMonetarno      RRegElSteviloMonetarnoA
#define RRegElIPv4Naslov            RRegElIPv4NaslovA
#define RRegElDNSNaslovZnak         RRegElDNSNaslovZnakA
#define RRegElDNSNaslov             RRegElDNSNaslovA
#define RRegElURLUporabnikZnak      RRegElURLUporabnikZnakA
#define RRegElURLGesloZnak          RRegElURLGesloZnakA
#define RRegElURLPotZnak            RRegElURLPotZnakA
#define RRegElURLPot                RRegElURLPotA
#define RRegElURLNaslov             RRegElURLNaslovA
#define RRegElEPostaNaslov          RRegElEPostaNaslovA
#define RRegElSmesko                RRegElSmeskoA
#define RRegElDatum                 RRegElDatumA
#define RRegElCas                   RRegElCasA
#define RRegElKot                   RRegElKotA
#define RRegElTelefonskaStevilka    RRegElTelefonskaStevilkaA
#define RRegElKemijskaSpojina       RRegElKemijskaSpojinaA
#endif
#endif // AOSN_REGIZR

struct AOSN_INLINE_CLASS T_DATUM;
class AOSN_CLASS RDatum;

#ifdef AOSN_SEMAFOR
enum T_RSEM_ZASTAVICE;
class AOSN_CLASS RSinhronizator;
class AOSN_CLASS RDogodek;
class AOSN_CLASS RNevarenOdsek;
class AOSN_CLASS RSemafor;
#ifndef _WIN32_WCE
class AOSN_CLASS RCasomer;
#endif
class AOSN_CLASS RCakalnik;
class AOSN_CLASS RMultiCakalnik;
#endif

#ifdef AOSN_NIT
typedef T_REZULTAT (RNIT_API *T_VSTOPNA_TOCKA)(T_KAZALEC);
enum T_NITZACETNOSTANJE;
enum T_NITPRIORITETA;
enum T_KODASPOROCILA;
struct T_SPOROCILO;
class AOSN_CLASS RNit;
class AOSN_CLASS RDogNit;
#ifdef RDOGNIT_KANAL_VER
class AOSN_CLASS RDogNitVN;
#else
// e ne uporabljamo kanalov za komunikacijo z nitmi ampak PostThreadMessage() in GetMessage(), potem sta RDogNit in RDogNitVN lahko ekvivalentna razreda.
#define RDogNitVN RDogNit
#endif
class AOSN_CLASS RStopnjaCevovoda;
#ifndef _WIN32_WCE
class AOSN_CLASS RCasovnaPast;
#endif
#endif // AOSN_NIT

#define RDAT_UNICODE_TXT_ID         ((T_UZNAK)0xfeff)   // identifikator vrstnega reda bajtov, ki se nahaja na zaetku vsake tekstovne datoteke UTF-16
#define RDAT_UTF8_TXT_ID            "\xef\xbb\xbf"      // identifikator datoteke UTF-8

enum T_DATNACINODMIKA;
enum T_DATNACINODPIRANJA;
enum T_DATATRIBUT;
class AOSN_CLASS RTokPodatkov;
class AOSN_CLASS RDatoteka;
class AOSN_CLASS RPretvornikToka;
class AOSN_CLASS RIzravnalnik;
class AOSN_CLASS RMedpomnilnik;
class AOSN_CLASS RSisTokPodatkov;
class AOSN_CLASS RIzrSisTokPodatkov;
class AOSN_CLASS RFizDatoteka;
class AOSN_CLASS RMedFizDatoteka;
class AOSN_CLASS RPomDatoteka;
#ifdef AOSN_FIFO
class AOSN_CLASS RFifoTokPodatkov;
#endif
#ifdef _DEBUG
class AOSN_CLASS RDiagDatoteka;
#endif
template <class TIP, class TIP_ID = T_U4, class TIP_DOLZINA = T_U4, unsigned int PORAVNAVA = 1> struct AOSN_TEMPLATE T_IDPODATKI;

#ifdef AOSN_BASE64
class AOSN_CLASS RBase64;
class AOSN_CLASS RBase64Tok;
#endif // AOSN_BASE64

#ifdef AOSN_VTIC
#if defined(_WIN32)
#define NAPAKA_VTICNICE     SOCKET_ERROR
#elif defined(__GNUC__)
#define NAPAKA_VTICNICE     (-1)
#endif
class AOSN_CLASS RVticnica;
#endif // AOSN_VTIC

#ifdef AOSN_KANAL
#define RKAN_NEOMEJENO PIPE_UNLIMITED_INSTANCES
enum T_KANNACINODPIRANJA;
enum T_KANNACINKANALA;
class AOSN_CLASS RKanal;
class AOSN_CLASS RImenovanKanal;
#endif // AOSN_KANAL

#ifdef AOSN_ODTISNIK
typedef T_U4 T_ODTIS_CRC32;
struct T_ODTIS_MD2;
#define T_ODTIS_MD5 T_ODTIS_MD2
struct T_ODTIS_SHA;
#define T_ODTIS_SHA1 T_ODTIS_SHA
class AOSN_CLASS ROdtisnik;
class AOSN_CLASS ROdtisnikToka;
class AOSN_CLASS RCRC32;
class AOSN_CLASS RBlokovniOdtisnik;
class AOSN_CLASS RMD5;
class AOSN_CLASS RSHA1;
#endif // AOSN_ODTISNIK

#ifdef AOSN_ZLIB_DEFLATE
enum T_ZLIB_STOPNJA_KOMPRESIJE;
class AOSN_CLASS RZLibKodirnikTokaPodatkov;
#endif
#ifdef AOSN_ZLIB_INFLATE
class AOSN_CLASS RZLibDekodirnikTokaPodatkov;
#endif

#ifdef AOSN_ISKDAT
struct T_NAJDENADATOTEKA;
class AOSN_CLASS RIskalnikDatotek;
#endif // AOSN_ISKDAT

#ifdef AOSN_VIRI
typedef T_STANJE(WINAPI *VrniJezikModulaF)(T_KODAJEZIKA *jezik, T_KODAJEZIKA2 *win_jezik);
struct T_KNJIZNICAVIROV;
class AOSN_CLASS RBazaVirov;
#endif // AOSN_VIRI

#ifdef AOSN_REGISTER
enum T_REGNACINDOSTOPA;
enum T_REGTIP;
enum T_REGSPREMEMBE;
class AOSN_CLASS RRegister;
#endif // AOSN_REGISTER

#ifdef AOSN_DNEVNIK
enum RDNE_PRIORITETE;
class AOSN_CLASS RDnevnik;
class AOSN_CLASS RDnevnikDat;
class AOSN_CLASS RDnevnikNT;
#endif // AOSN_DNEVNIK

#ifdef AOSN_SERVIS
enum T_SERDOSTOPOSKRBNIK;
enum T_SERDOSTOPSERVIS;
enum T_RSERVISIMPLKODASPOROCILA;
enum T_RSERVISSTDKODASPOROCILA;
enum T_VRSTASERVISA;
enum T_ZAGONSERVISA;
enum T_OBRAVNAVANAPAKESERVISA;
enum T_STATUSSERVISA;
enum T_VRSTADEJANJAOBOKVARISERVISA;
struct T_RAVNANJEOBOKVARISERVISA;
struct T_REGISTRACIJASERVISA;
class AOSN_CLASS ROskrbnikServisov;
class AOSN_CLASS RSistemskiServis;
class AOSN_CLASS RRegisterServisov;
#ifdef AOSN_DNEVNIK
template <class T_base> class AOSN_TEMPLATE RRegisterServisovDnevnikP;
#endif
class AOSN_CLASS RServisImpl;
template <class T_base> class AOSN_TEMPLATE RServisStdP;
template <class T_srv> class AOSN_TEMPLATE RServisOdjemalecP;
template <class T_srv, class T_odj_base> class RServisSprejemnikP;
#ifdef AOSN_KANAL
template <class T_srv, class T_base> class AOSN_TEMPLATE RServisOdjemalecKanalP;
template <class T_srv, class T_odj, class T_odj_base, class T_base> class RServisSprejemnikKanalP;
#endif
#ifdef AOSN_VTIC
template <class T_srv, class T_base> class AOSN_TEMPLATE RServisOdjemalecVticP;
template <class T_srv, class T_odj, class T_odj_base, class T_base> class RServisSprejemnikVticP;
#endif
#endif // AOSN_SERVIS

#ifdef AOSN_ZVOK
struct AOSN_INLINE_CLASS T_BLOKZVOKA;
class AOSN_CLASS RPredvajalnikZvoka;
class AOSN_CLASS RSnemalnikZvoka;
#endif // AOSN_ZVOK

#ifdef AOSN_HTML
enum T_HTMLKODAELEMENTA;
enum T_HTMLVRSTAODSEKA;
struct T_HTMLLASTNOST;

template <class TIP> class AOSN_TEMPLATE RHTMLRegElIdentP;
template <class TIP> class AOSN_TEMPLATE RHTMLRegElVrednostP;
template <class TIP> class AOSN_TEMPLATE RHTMLRegElOznakaP;
template <class TIP> class AOSN_TEMPLATE RHTMLRegElDeklaracijaPogojZacP;
template <class TIP> class AOSN_TEMPLATE RHTMLRegElDeklaracijaPogojKonP;
template <class TIP> class AOSN_TEMPLATE RCSSRegElKomentarP;
template <class TIP> class AOSN_TEMPLATE RCSSRegElCDOP;
template <class TIP> class AOSN_TEMPLATE RCSSRegElCDCP;
template <class TIP> class AOSN_TEMPLATE RCSSRegElStringP;
template <class TIP> class AOSN_TEMPLATE RCSSRegElURIP;
template <class TIP> class AOSN_TEMPLATE RCSSRegElImportP;
template <class TIP> class AOSN_TEMPLATE RMIMERegElContentTypeP;

typedef               RHTMLRegElIdentP<T_AZNAK> AOSN_CLASS RHTMLRegElIdentA;
typedef               RHTMLRegElIdentP<T_UZNAK> AOSN_CLASS RHTMLRegElIdentU;
typedef            RHTMLRegElVrednostP<T_AZNAK> AOSN_CLASS RHTMLRegElVrednostA;
typedef            RHTMLRegElVrednostP<T_UZNAK> AOSN_CLASS RHTMLRegElVrednostU;
typedef              RHTMLRegElOznakaP<T_AZNAK> AOSN_CLASS RHTMLRegElOznakaA;
typedef              RHTMLRegElOznakaP<T_UZNAK> AOSN_CLASS RHTMLRegElOznakaU;
typedef RHTMLRegElDeklaracijaPogojZacP<T_AZNAK> AOSN_CLASS RHTMLRegElDeklaracijaPogojZacA;
typedef RHTMLRegElDeklaracijaPogojZacP<T_UZNAK> AOSN_CLASS RHTMLRegElDeklaracijaPogojZacU;
typedef RHTMLRegElDeklaracijaPogojKonP<T_AZNAK> AOSN_CLASS RHTMLRegElDeklaracijaPogojKonA;
typedef RHTMLRegElDeklaracijaPogojKonP<T_UZNAK> AOSN_CLASS RHTMLRegElDeklaracijaPogojKonU;
typedef             RCSSRegElKomentarP<T_AZNAK> AOSN_CLASS RCSSRegElKomentarA;
typedef             RCSSRegElKomentarP<T_UZNAK> AOSN_CLASS RCSSRegElKomentarU;
typedef                  RCSSRegElCDOP<T_AZNAK> AOSN_CLASS RCSSRegElCDOA;
typedef                  RCSSRegElCDOP<T_UZNAK> AOSN_CLASS RCSSRegElCDOU;
typedef                  RCSSRegElCDCP<T_AZNAK> AOSN_CLASS RCSSRegElCDCA;
typedef                  RCSSRegElCDCP<T_UZNAK> AOSN_CLASS RCSSRegElCDCU;
typedef               RCSSRegElStringP<T_AZNAK> AOSN_CLASS RCSSRegElStringA;
typedef               RCSSRegElStringP<T_UZNAK> AOSN_CLASS RCSSRegElStringU;
typedef                  RCSSRegElURIP<T_AZNAK> AOSN_CLASS RCSSRegElURIA;
typedef                  RCSSRegElURIP<T_UZNAK> AOSN_CLASS RCSSRegElURIU;
typedef               RCSSRegElImportP<T_AZNAK> AOSN_CLASS RCSSRegElImportA;
typedef               RCSSRegElImportP<T_UZNAK> AOSN_CLASS RCSSRegElImportU;
typedef         RMIMERegElContentTypeP<T_AZNAK> AOSN_CLASS RMIMERegElContentTypeA;
typedef         RMIMERegElContentTypeP<T_UZNAK> AOSN_CLASS RMIMERegElContentTypeU;

#ifdef _UNICODE
#define RHTMLRegElIdent                 RHTMLRegElIdentU
#define RHTMLRegElVrednost              RHTMLRegElVrednostU
#define RHTMLRegElOznaka                RHTMLRegElOznakaU
#define RHTMLRegElDeklaracijaPogojZac   RHTMLRegElDeklaracijaPogojZacU
#define RHTMLRegElDeklaracijaPogojKon   RHTMLRegElDeklaracijaPogojKonU
#define RCSSRegElKomentar               RCSSRegElKomentarU
#define RCSSRegElCDO                    RCSSRegElCDOU
#define RCSSRegElCDC                    RCSSRegElCDCU
#define RCSSRegElString                 RCSSRegElStringU
#define RCSSRegElURI                    RCSSRegElURIU
#define RCSSRegElImport                 RCSSRegElImportU
#define RMIMERegElContentType           RMIMERegElContentTypeU
#else
#define RHTMLRegElIdent                 RHTMLRegElIdentA
#define RHTMLRegElVrednost              RHTMLRegElVrednostA
#define RHTMLRegElOznaka                RHTMLRegElOznakaA
#define RHTMLRegElDeklaracijaPogojZac   RHTMLRegElDeklaracijaPogojZacA
#define RHTMLRegElDeklaracijaPogojKon   RHTMLRegElDeklaracijaPogojKonA
#define RCSSRegElKomentar               RCSSRegElKomentarA
#define RCSSRegElCDO                    RCSSRegElCDOA
#define RCSSRegElCDC                    RCSSRegElCDCA
#define RCSSRegElString                 RCSSRegElStringA
#define RCSSRegElURI                    RCSSRegElURIA
#define RCSSRegElImport                 RCSSRegElImportA
#define RMIMERegElContentType           RMIMERegElContentTypeA
#endif

class AOSN_CLASS RHTMLOdsek;
class AOSN_CLASS RHTMLOznakaSamostojna;
class AOSN_CLASS RHTMLOznakaUvodna;
class AOSN_CLASS RHTMLOznakaZakljucna;
class AOSN_CLASS RHTMLDeklaracija;
class AOSN_CLASS RHTMLKomentar;
class AOSN_CLASS RHTMLNavodilo;
class AOSN_CLASS RHTMLEntiteta;

enum T_HTMLVRSTAZETONA;
enum T_HTMLVRSTABESEDILAZETONA;
enum T_HTMLZAPISURLZETONA;
#define HTML_OZNAKA_ZETONA_MAX  ((T_UINT)(sizeof(T_VOID*)*2 + 2 + 1))
#define PR_K_KOMENTAR_ZACETEK   18  // koda znaka, ki ga Petrovo jedro obravnava kot zaetek komentarja
#define PR_K_KOMENTAR_KONEC     19  // koda znaka, ki ga Petrovo jedro obravnava kot konec komentarja

class AOSN_CLASS RHTMLZeton;
class AOSN_CLASS RHTMLZetonBesedilo;
class AOSN_CLASS RHTMLZetonUvodni;
class AOSN_CLASS RHTMLZetonURL;
class AOSN_CLASS RHTMLZetonNapaka;
class AOSN_CLASS RHTMLDokument;
typedef RDinTabela<RHTMLZeton*> RHTMLTabelaZetonov;
typedef RSeznam<RHTMLZeton*>    RHTMLSeznamZetonov2;
struct T_HTMLVSTAVLJENZETON;
typedef RSeznam<T_HTMLVSTAVLJENZETON> RHTMLSeznamVstavljenihZetonov;
class AOSN_CLASS RHTMLAnalizator;
#endif // AOSN_HTML

#ifdef AOSN_HTTP
#define RHTTP_VERZIJA_HTTP_MAJ(verzija) ((T_U1)(((verzija) >> 8) & 0xff))
#define RHTTP_VERZIJA_HTTP_MIN(verzija) ((T_U1)( (verzija)       & 0xff))
class AOSN_CLASS RRegElHTTPPrelomVrstice;
class AOSN_CLASS RRegElHTTPZetonRFC2616;
class AOSN_CLASS RRegElHTTPNizRFC2616;
class AOSN_CLASS RRegElHTTPVrednostRFC2109;
class AOSN_CLASS RRegElHTTPStreznikURL;
class AOSN_CLASS RRegElHTTPVrataURL;
class AOSN_CLASS RRegElHTTPSegmentPotiURL;
class AOSN_CLASS RRegElHTTPPotURL;
class AOSN_CLASS RRegElHTTPParameterURL;
class AOSN_CLASS RRegElHTTPURL;
class AOSN_CLASS RRegElHTTPJezikRFC1766;
class AOSN_TEMPLATE RRegElHTTPFaktorUtezi;
template <class TIP> class AOSN_TEMPLATE RRegElHTTPUtezenZapis;
class AOSN_CLASS RRegElHTTPPiskotkiParameterRFC2109;
class AOSN_CLASS RRegElHTTPPiskotekRFC2109;
class AOSN_CLASS RRegElHTTPAgent;
class AOSN_CLASS RRegElHTTPProtokol;
class AOSN_CLASS RRegElHTTPZahteva;
class AOSN_CLASS RRegElHTTPGlava;
template <class TIP> class AOSN_TEMPLATE RSeznamElementovGlaveHTTP;
template <class TIP> class AOSN_TEMPLATE RSeznamUtezenihZapisovHTTP;
class AOSN_CLASS ROdjemalecHTTP;
class AOSN_CLASS RZapisovalnikHTTP;
#endif // AOSN_HTTP


#ifdef AOSN_IZJEMA
class AOSN_CLASS ROddajnikHTTP;
class AOSN_CLASS ROddajnikIzjem;
class AOSN_CLASS RRokovalnikIzjem;
class AOSN_CLASS RIzjemeGlobalnaNit;
#endif // AOSN_IZJEMA


#ifdef AOSN_WAV
#define T_WAV_ID        T_U4
#define T_WAV_DOLZINA   T_U4
#define WAV_PORAVNAVA   2

struct T_WAV_GLAVA;
typedef T_IDPODATKI<T_WAV_GLAVA, T_WAV_ID, T_WAV_DOLZINA, WAV_PORAVNAVA> T_WAV_GLAVA_ID;
struct T_WAV_WAVE;
typedef T_IDPODATKI<T_WAV_WAVE, T_WAV_ID, T_WAV_DOLZINA, WAV_PORAVNAVA> T_WAV_WAVE_ID;
struct T_WAV_FORMAT;
typedef T_IDPODATKI<T_WAV_FORMAT, T_WAV_ID, T_WAV_DOLZINA, WAV_PORAVNAVA> T_WAV_FORMAT_ID;
struct T_WAV_PODATKI;
typedef T_IDPODATKI<T_WAV_PODATKI, T_WAV_ID, T_WAV_DOLZINA, WAV_PORAVNAVA> T_WAV_PODATKI_ID;
struct T_WAV_TISINA;
typedef T_IDPODATKI<T_WAV_TISINA, T_WAV_ID, T_WAV_DOLZINA, WAV_PORAVNAVA> T_WAV_TISINA_ID;
struct T_WAV_OZNAKA;
struct T_WAV_OZNAKA_EX;
struct T_WAV_TABELA_OZNAK;
typedef T_IDPODATKI<T_WAV_TABELA_OZNAK, T_WAV_ID, T_WAV_DOLZINA, WAV_PORAVNAVA> T_WAV_OZNAKE_ID;
struct T_WAV_LTXT;
typedef T_IDPODATKI<T_WAV_LTXT, T_WAV_ID, T_WAV_DOLZINA, WAV_PORAVNAVA> T_WAV_LTXT_ID;
struct T_WAV_NASLOV;
typedef T_IDPODATKI<T_WAV_NASLOV, T_WAV_ID, T_WAV_DOLZINA, WAV_PORAVNAVA> T_WAV_NASLOV_ID;
struct T_WAV_OPOMBA;
typedef T_IDPODATKI<T_WAV_OPOMBA, T_WAV_ID, T_WAV_DOLZINA, WAV_PORAVNAVA> T_WAV_OPOMBA_ID;
struct T_WAV_SEZNAM;
typedef T_IDPODATKI<T_WAV_SEZNAM, T_WAV_ID, T_WAV_DOLZINA, WAV_PORAVNAVA> T_WAV_SEZNAM_ID;
struct T_WAV_TABELA_OZNAK_EX;
#endif // AOSN_WAV


//////////////////////////////////////////////////////////////////////
// T_BINBLOK
//////////////////////////////////////////////////////////////////////

struct T_BINBLOK {
    T_SIZE dolzina;
    T_KAZALEC podatki;
};


//////////////////////////////////////////////////////////////////////
// T_VOZEL - struktura, ki opisuje osnovno vozlie
//////////////////////////////////////////////////////////////////////

template <class TIP> struct AOSN_TEMPLATE T_VOZEL
{
    TIP element;            // element

    T_VOZEL<TIP>() {};
    T_VOZEL<TIP>(const TIP &el) : element(el) {};
};


//////////////////////////////////////////////////////////////////////
// T_VOZELENO - struktura, ki opisuje vozel enosmerno povezanega
//   linearnega seznama (vrste, skladi, enosmerni seznami itd.)
//////////////////////////////////////////////////////////////////////

template <class TIP> struct AOSN_TEMPLATE T_VOZELENO : public T_VOZEL<TIP>
{
    T_VOZELENO<TIP> *naslednji; // kazalec na naslednje vozlie

    T_VOZELENO<TIP>() {};
    T_VOZELENO<TIP>(const TIP &el) : T_VOZEL<TIP>(el) {};
};


//////////////////////////////////////////////////////////////////////
// T_VOZELDVO - struktura, ki opisuje vozel dvozmerno povezanega
//   linearnega seznama (dvosmerni seznami, binarna drevesa itd.)
//////////////////////////////////////////////////////////////////////

template <class TIP> struct AOSN_TEMPLATE T_VOZELDVO : public T_VOZELENO<TIP>
{
    T_ROCICA prejsnji;      // kazalec na prejnje vozlie

    T_VOZELDVO<TIP>() {};
    T_VOZELDVO<TIP>(const TIP &el) : T_VOZELENO<TIP>(el) {};
};


//////////////////////////////////////////////////////////////////////
// T_INTERVAL
//////////////////////////////////////////////////////////////////////

template <class TIP> struct AOSN_TEMPLATE T_INTERVAL {
    TIP zacetek;    // zaetek intervala
    TIP konec;      // konec intervala

    inline T_INTERVAL();
    inline T_INTERVAL(TIP x);
    inline T_INTERVAL(TIP zacetek, TIP konec);

    inline TIP VrniDolzino() const;
    inline T_BOOL JeVeljaven() const;

    inline const T_INTERVAL<TIP> operator =(TIP zacetek);
};

template <class TIP> inline const T_INTERVAL<TIP>  operator + (const T_INTERVAL<TIP> i1, const T_INTERVAL<TIP> i2);
template <class TIP> inline const T_INTERVAL<TIP>  operator + (const T_INTERVAL<TIP> i, TIP x);
template <class TIP> inline       T_INTERVAL<TIP>& operator ++(      T_INTERVAL<TIP> &o);
template <class TIP> inline const T_INTERVAL<TIP>  operator ++(      T_INTERVAL<TIP> &o, int);
template <class TIP> inline const T_INTERVAL<TIP>  operator - (const T_INTERVAL<TIP> i1, const T_INTERVAL<TIP> i2);
template <class TIP> inline const T_INTERVAL<TIP>  operator - (const T_INTERVAL<TIP> i, T_UINT x);
template <class TIP> inline       T_INTERVAL<TIP>& operator --(      T_INTERVAL<TIP> &o);
template <class TIP> inline const T_INTERVAL<TIP>  operator --(      T_INTERVAL<TIP> &o, int);
template <class TIP> inline       T_BOOL           operator ==(const T_INTERVAL<TIP> i1, const T_INTERVAL<TIP> i2);
template <class TIP> inline       T_BOOL           operator !=(const T_INTERVAL<TIP> i1, const T_INTERVAL<TIP> i2);


//////////////////////////////////////////////////////////////////////
// T_VRSTAVAR
//////////////////////////////////////////////////////////////////////

enum T_VRSTAVAR {
    VAR_NEVELJAVEN = 0xff,
    VAR_PRAZEN     = 0x00,
    VAR_AZNAK      = 0x10,
    VAR_UZNAK      = 0x11,
#ifdef _UNICODE
    VAR_ZNAK       = VAR_UZNAK,
#else
    VAR_ZNAK       = VAR_AZNAK,
#endif
    VAR_ASCII      = 0x20,
    VAR_UNICODE    = 0x21,
#ifdef _UNICODE
    VAR_NIZ        = VAR_UNICODE,
#else
    VAR_NIZ        = VAR_ASCII,
#endif
    VAR_BINBLOK    = 0x30,
    VAR_INT        = 0x40,
    VAR_UINT       = 0x41,
    VAR_FLOAT      = 0x42,
    VAR_DOUBLE     = 0x43,
#ifdef _DOUBLE
    VAR_REAL       = VAR_DOUBLE,
#else
    VAR_REAL       = VAR_FLOAT,
#endif
};


//////////////////////////////////////////////////////////////////////
// T_VAR
//////////////////////////////////////////////////////////////////////

struct AOSN_INLINE_CLASS T_VAR {
    T_VRSTAVAR vrsta;    // vrsta elementa
    union {
        T_ZNAK      znak;
        T_AZNAK     znak_a;
        T_UZNAK     znak_u;

        T_NIZ       niz;
        T_ASCII     niz_a;
        T_UNICODE   niz_u;

        T_BINBLOK   blok;

        T_INT       st_int;
        T_UINT      st_uint;

        T_REAL      st_real;
        T_FLOAT     st_float;
        T_DOUBLE    st_double;
    };

    inline T_VAR()                                      { vrsta = VAR_NEVELJAVEN; }
    inline T_VAR(const T_AZNAK znak)                    { vrsta = VAR_AZNAK;   this->znak_a    = znak;    }
    inline T_VAR(const T_UZNAK znak)                    { vrsta = VAR_UZNAK;   this->znak_u    = znak;    }
    inline T_VAR(const T_ASCII niz)                     { vrsta = VAR_ASCII;   this->niz_a     = niz;     }
    inline T_VAR(const T_UNICODE niz)                   { vrsta = VAR_UNICODE; this->niz_u     = niz;     }
    inline T_VAR(const T_SIZE dolzina, T_VOID* podatki) { vrsta = VAR_BINBLOK; this->blok.dolzina = dolzina; this->blok.podatki = podatki; }
    inline T_VAR(const T_BINBLOK blok)                  { vrsta = VAR_BINBLOK; this->blok      = blok;    }
    inline T_VAR(const T_INT stevilo)                   { vrsta = VAR_INT;     this->st_int    = stevilo; }
    inline T_VAR(const T_UINT stevilo)                  { vrsta = VAR_UINT;    this->st_uint   = stevilo; }
    inline T_VAR(const T_FLOAT stevilo)                 { vrsta = VAR_FLOAT;   this->st_float  = stevilo; }
    inline T_VAR(const T_DOUBLE stevilo)                { vrsta = VAR_DOUBLE;  this->st_double = stevilo; }

    inline const T_VAR operator=(const T_AZNAK znak)     { vrsta = VAR_AZNAK;   this->znak_a    = znak;    return *this; }
    inline const T_VAR operator=(const T_UZNAK znak)     { vrsta = VAR_UZNAK;   this->znak_u    = znak;    return *this; }
    inline const T_VAR operator=(const T_ASCII niz)      { vrsta = VAR_ASCII;   this->niz_a     = niz;     return *this; }
    inline const T_VAR operator=(const T_UNICODE niz)    { vrsta = VAR_UNICODE; this->niz_u     = niz;     return *this; }
    inline const T_VAR operator=(const T_BINBLOK blok)   { vrsta = VAR_BINBLOK; this->blok      = blok;    return *this; }
    inline const T_VAR operator=(const T_INT stevilo)    { vrsta = VAR_INT;     this->st_int    = stevilo; return *this; }
    inline const T_VAR operator=(const T_UINT stevilo)   { vrsta = VAR_UINT;    this->st_uint   = stevilo; return *this; }
    inline const T_VAR operator=(const T_FLOAT stevilo)  { vrsta = VAR_FLOAT;   this->st_float  = stevilo; return *this; }
    inline const T_VAR operator=(const T_DOUBLE stevilo) { vrsta = VAR_DOUBLE;  this->st_double = stevilo; return *this; }

    inline operator T_AZNAK()     const { assert(vrsta == VAR_AZNAK);   return znak_a;    }
    inline operator T_AZNAK&()          { assert(vrsta == VAR_AZNAK);   return znak_a;    }
    inline operator T_UZNAK()     const { assert(vrsta == VAR_UZNAK);   return znak_u;    }
    inline operator T_UZNAK&()          { assert(vrsta == VAR_UZNAK);   return znak_u;    }
    inline operator TK_ASCII()    const { assert(vrsta == VAR_ASCII);   return niz_a;     }
    inline operator T_ASCII&()          { assert(vrsta == VAR_ASCII);   return niz_a;     }
    inline operator TK_UNICODE()  const { assert(vrsta == VAR_UNICODE); return niz_u;     }
    inline operator T_UNICODE&()        { assert(vrsta == VAR_UNICODE); return niz_u;     }
    inline operator T_BINBLOK()   const { assert(vrsta == VAR_BINBLOK); return blok;      }
    inline operator T_BINBLOK&()        { assert(vrsta == VAR_BINBLOK); return blok;      }
    inline operator T_INT()       const { assert(vrsta == VAR_INT);     return st_int;    }
    inline operator T_INT&()            { assert(vrsta == VAR_INT);     return st_int;    }
    inline operator T_UINT()      const { assert(vrsta == VAR_UINT);    return st_uint;   }
    inline operator T_UINT&()           { assert(vrsta == VAR_UINT);    return st_uint;   }
    inline operator T_FLOAT()     const { assert(vrsta == VAR_FLOAT);   return st_float;  }
    inline operator T_FLOAT&()          { assert(vrsta == VAR_FLOAT);   return st_float;  }
    inline operator T_DOUBLE()    const { assert(vrsta == VAR_DOUBLE);  return st_double; }
    inline operator T_DOUBLE&()         { assert(vrsta == VAR_DOUBLE);  return st_double; }

    inline T_VOID Unici();
    inline T_VOID Razveljavi();
};

template <class TOK> inline TOK& operator <<(TOK &tok, const T_VAR &podatek);
template <class TOK> inline TOK& operator >>(TOK &tok,       T_VAR &podatek);


//////////////////////////////////////////////////////////////////////
// T_DELOVNOMESTO
//////////////////////////////////////////////////////////////////////

struct T_DELOVNOMESTO {
    T_UZNAK naziv[DOLZINA_DELOVNOMESTO]; // niz Unicode, ki predstavlja klienta
};


//////////////////////////////////////////////////////////////////////
// T_KOMPLP
//////////////////////////////////////////////////////////////////////

template <class TIP> struct AOSN_TEMPLATE T_KOMPLP
{
    TIP
        r,  // realni del
        i;  // imaginarni del

    inline T_KOMPLP<TIP>();
    inline T_KOMPLP<TIP>(const TIP r, const TIP i);
    inline T_KOMPLP<TIP>(const TIP r);

    inline const T_KOMPLP<TIP> operator =(const T_KOMPLP<TIP> z);
    inline const T_KOMPLP<TIP> operator =(const TIP r);

    inline const T_KOMPLP<TIP> operator +=(const T_KOMPLP<TIP> z);
    inline const T_KOMPLP<TIP> operator +=(const TIP r);

    inline const T_KOMPLP<TIP> operator -=(const T_KOMPLP<TIP> z);
    inline const T_KOMPLP<TIP> operator -=(const TIP r);

    inline const T_KOMPLP<TIP> operator *=(const T_KOMPLP<TIP> z);
    inline const T_KOMPLP<TIP> operator *=(const TIP r);

    inline const T_KOMPLP<TIP> operator /=(const T_KOMPLP<TIP> z);
    inline const T_KOMPLP<TIP> operator /=(const TIP r);

    inline operator const T_KOMPLP<T_FLOAT>() const;
    inline operator const T_KOMPLP<T_DOUBLE>() const;
    inline operator const T_KOMPLRP<TIP>() const;
};

template <class TIP> inline const T_KOMPLP<TIP> operator +(const T_KOMPLP<TIP> z);
template <class TIP> inline const T_KOMPLP<TIP> operator +(const T_KOMPLP<TIP> z1, const T_KOMPLP<TIP> z2);
template <class TIP> inline const T_KOMPLP<TIP> operator +(const T_KOMPLP<TIP> z, const TIP r);
template <class TIP> inline const T_KOMPLP<TIP> operator +(const TIP r, const T_KOMPLP<TIP> z);
template <class TIP> inline const T_KOMPLP<TIP> operator -(const T_KOMPLP<TIP> z);
template <class TIP> inline const T_KOMPLP<TIP> operator -(const T_KOMPLP<TIP> z1, const T_KOMPLP<TIP> z2);
template <class TIP> inline const T_KOMPLP<TIP> operator -(const T_KOMPLP<TIP> z, const TIP r);
template <class TIP> inline const T_KOMPLP<TIP> operator -(const TIP r, const T_KOMPLP<TIP> z);
template <class TIP> inline const T_KOMPLP<TIP> operator *(const T_KOMPLP<TIP> z1, const T_KOMPLP<TIP> z2);
template <class TIP> inline const T_KOMPLP<TIP> operator *(const T_KOMPLP<TIP> z, const TIP r);
template <class TIP> inline const T_KOMPLP<TIP> operator *(const TIP r, const T_KOMPLP<TIP> z);
template <class TIP> inline const T_KOMPLP<TIP> operator /(const T_KOMPLP<TIP> z1, const T_KOMPLP<TIP> z2);
template <class TIP> inline const T_KOMPLP<TIP> operator /(const T_KOMPLP<TIP> z, const TIP r);
template <class TIP> inline const T_KOMPLP<TIP> operator /(const TIP r, const T_KOMPLP<TIP> z);
template <class TIP> inline const T_KOMPLP<TIP> operator ~(const T_KOMPLP<TIP> z);


//////////////////////////////////////////////////////////////////////
// T_KOMPLRP
//////////////////////////////////////////////////////////////////////

template <class TIP> struct AOSN_TEMPLATE T_KOMPLRP
{
    TIP
        a,  // amplituda
        f;  // faza

    inline T_KOMPLRP<TIP>();
    inline T_KOMPLRP<TIP>(const TIP a, const TIP f);
    inline T_KOMPLRP<TIP>(const TIP a);

    inline const T_KOMPLRP<TIP> operator =(const T_KOMPLRP<TIP> z);
    inline const T_KOMPLRP<TIP> operator =(const TIP a);

    inline const T_KOMPLRP<TIP> operator *=(const T_KOMPLRP<TIP> z);
    inline const T_KOMPLRP<TIP> operator *=(const TIP a);

    inline const T_KOMPLRP<TIP> operator /=(const T_KOMPLRP<TIP> z);
    inline const T_KOMPLRP<TIP> operator /=(const TIP a);

    inline operator const T_KOMPLRP<T_FLOAT>() const;
    inline operator const T_KOMPLRP<T_DOUBLE>() const;
    inline operator const T_KOMPLP<TIP>() const;
};

template <class TIP> inline const T_KOMPLRP<TIP> operator *(const T_KOMPLRP<TIP> z1, const T_KOMPLRP<TIP> z2);
template <class TIP> inline const T_KOMPLRP<TIP> operator *(const T_KOMPLRP<TIP> z, const TIP a);
template <class TIP> inline const T_KOMPLRP<TIP> operator *(const TIP a, const T_KOMPLRP<TIP> z);
template <class TIP> inline const T_KOMPLRP<TIP> operator /(const T_KOMPLRP<TIP> z1, const T_KOMPLRP<TIP> z2);
template <class TIP> inline const T_KOMPLRP<TIP> operator /(const T_KOMPLRP<TIP> z, const TIP a);
template <class TIP> inline const T_KOMPLRP<TIP> operator /(const TIP a, const T_KOMPLRP<TIP> z);
template <class TIP> inline const T_KOMPLRP<TIP> operator ~(const T_KOMPLRP<TIP> z);


//////////////////////////////////////////////////////////////////////
// T_AMALLOC_OPERACIJA
//////////////////////////////////////////////////////////////////////

enum T_AMALLOC_OPERACIJA {
    AMALLOC_OPERACIJA_AALLOC     = 1,
    AMALLOC_OPERACIJA_AREALLOC   = 2,
    AMALLOC_OPERACIJA_AQREALLOC  = 3,
    AMALLOC_OPERACIJA_AFREE      = 4,
    AMALLOC_OPERACIJA_AMSIZE     = 5,
    AMALLOC_OPERACIJA_AHEAPVALID = 6,
};


//////////////////////////////////////////////////////////////////////
// T_AMALLOC_ZAPIS_OPERACIJE
//////////////////////////////////////////////////////////////////////

#pragma pack(push)
#pragma pack(1)

struct T_AMALLOC_ZAPIS_OPERACIJE {
    T_U1    operacija;
    T_U8    pom;
    T_AZNAK ime_izvorne_datoteke_rezervacije[MAX_PATH];
    T_U4    vrstica_rezervacije;
    T_AZNAK ime_izvorne_datoteke[MAX_PATH];
    T_U4    vrstica;
    T_U8    dolzina;
    T_U8    dolzina2;
};

#pragma pack(pop)


//////////////////////////////////////////////////////////////////////
// T_SGML_UNICODE_ENTITETA
//////////////////////////////////////////////////////////////////////

#ifndef AOSN_BREZ_SGML

struct T_SGML_UNICODE_ENTITETA {
    T_AZNAK sgml[AOSN_SGML_ENTITETA_SGML_MAX];          // ime entitete (pri SGML-ju brez & in ;)
    T_UZNAK unicode[AOSN_SGML_ENTITETA_UNICODE_MAX];    // niz Unicode, ki ga entiteta predstavlja
};

#endif


//////////////////////////////////////////////////////////////////////
// T_KODNASTRAN
//////////////////////////////////////////////////////////////////////

enum T_KODNASTRAN {
    KODNASTRAN_ANSI         = CP_ACP,
    KODNASTRAN_OEM          = CP_OEMCP,
    KODNASTRAN_WIN1250      = 1250,     // Central Europe
    KODNASTRAN_WIN1251      = 1251,     // Cyrillic
    KODNASTRAN_WIN1252      = 1252,     // Latin I
    KODNASTRAN_WIN1253      = 1253,     // Greek
    KODNASTRAN_WIN1254      = 1254,     // Turkish
    KODNASTRAN_WIN1255      = 1255,     // Hebrew
    KODNASTRAN_WIN1256      = 1256,     // Arabic
    KODNASTRAN_WIN1257      = 1257,     // Baltic
    KODNASTRAN_WIN1258      = 1258,     // Vietnam
    KODNASTRAN_WIN874       = 874,      // Thai
    KODNASTRAN_WIN949       = 949,      // Korean
    KODNASTRAN_SHIFTJIS     = 932,      // Japanese Shift-JIS
    KODNASTRAN_GBK          = 936,      // Simplified Chinese GBK
    KODNASTRAN_BIG5         = 950,      // Traditional Chinese Big5
    KODNASTRAN_IBM437       = 437,      // US
    KODNASTRAN_IBM852       = 852,      // Latin II
    KODNASTRAN_ISO8859_1    = 28591,    // Latin 1
    KODNASTRAN_ISO8859_2    = 28592,    // Latin 2
    KODNASTRAN_ISO8859_3    = 28593,    // Latin 3
    KODNASTRAN_ISO8859_4    = 28594,    // Baltic
    KODNASTRAN_ISO8859_5    = 28595,    // Cyrillic
    KODNASTRAN_ISO8859_6    = 28596,    // Arabic
    KODNASTRAN_ISO8859_8    = 28598,    // Hebrew
    KODNASTRAN_ISO8859_9    = 28598,    // Turkish
    KODNASTRAN_ISO8859_15   = 28605,    // Latin 9
    KODNASTRAN_UTF7         = CP_UTF7,
    KODNASTRAN_UTF8         = CP_UTF8,
    KODNASTRAN_UTF16        = 1200,

    KODNASTRAN_NEZNANA      = -1,
};


//////////////////////////////////////////////////////////////////////
// T_KODAJEZIKA
//////////////////////////////////////////////////////////////////////

enum T_KODAJEZIKA {
    KODAJEZIKA_NEVTRALNA        = 0x00000000,
    KODAJEZIKA_NEZNANA          = 0xffffffff,

    KODAJEZIKA_ALBANSCINA       = 0x00005153,
    KODAJEZIKA_ANGLESCINA       = 0x00004e45,
    KODAJEZIKA_ESPERANTO        = 0x00004f45,
    KODAJEZIKA_FRANCOSCINA      = 0x00005246,
    KODAJEZIKA_HRVASCINA        = 0x00005248,
    KODAJEZIKA_ITALIJANSCINA    = 0x00005449,
    KODAJEZIKA_LATINSCINA       = 0x0000414c,
    KODAJEZIKA_MADZARSCINA      = 0x00005548,
    KODAJEZIKA_MAKEDONSCINA     = 0x00004b4d,
    KODAJEZIKA_NEMSCINA         = 0x00004544,
    KODAJEZIKA_RUSCINA          = 0x00005552,
    KODAJEZIKA_SLOVENSCINA      = 0x00004c53,
    KODAJEZIKA_SPANSCINA        = 0x00005345,
    KODAJEZIKA_SRBSCINA         = 0x00005253,
    KODAJEZIKA_SRBOHRVASCINA    = 0x00004853,
    KODAJEZIKA_ZULUJSCINA       = 0x0000555a,
/*
    KODAJEZIKA_ABKHAZIAN      = 0x00004241,
    KODAJEZIKA_AFAN           = 0x00004d4f,
    KODAJEZIKA_AFAR           = 0x00004141,
    KODAJEZIKA_AFRIKAANS      = 0x00004641,
    KODAJEZIKA_AMERICAN       = 0x00004e45,
    KODAJEZIKA_AMHARIC        = 0x00004d41,
    KODAJEZIKA_ARABIC         = 0x00005241,
    KODAJEZIKA_ARMENIAN       = 0x00005948,
    KODAJEZIKA_ASSAMESE       = 0x00005341,
    KODAJEZIKA_AYMARA         = 0x00005941,
    KODAJEZIKA_AZERBAIJANI    = 0x00005a41,
    KODAJEZIKA_BANGLA         = 0x00004e42,
    KODAJEZIKA_BASHKIR        = 0x00004142,
    KODAJEZIKA_BASQUE         = 0x00005545,
    KODAJEZIKA_BENGALI        = 0x00004e42,
    KODAJEZIKA_BHUTANI        = 0x00005a44,
    KODAJEZIKA_BIHARI         = 0x00004842,
    KODAJEZIKA_BISLAMA        = 0x00004942,
    KODAJEZIKA_BRETON         = 0x00005242,
    KODAJEZIKA_BULGARIAN      = 0x00004742,
    KODAJEZIKA_BURMESE        = 0x0000594d,
    KODAJEZIKA_BYELORUSSIAN   = 0x00004542,
    KODAJEZIKA_CAMBODIAN      = 0x00004d4b,
    KODAJEZIKA_CATALAN        = 0x00004143,
    KODAJEZIKA_CHINESE        = 0x0000485a,
    KODAJEZIKA_CORSICAN       = 0x00004f43,
    KODAJEZIKA_CZECH          = 0x00005343,
    KODAJEZIKA_DANISH         = 0x00004144,
    KODAJEZIKA_DUTCH          = 0x00004c4e,
    KODAJEZIKA_ESTONIAN       = 0x00005445,
    KODAJEZIKA_FAEROESE       = 0x00004f46,
    KODAJEZIKA_FIJI           = 0x00004a46,
    KODAJEZIKA_FINNISH        = 0x00004946,
    KODAJEZIKA_FRISIAN        = 0x00005946,
    KODAJEZIKA_GAELIC         = 0x00004447,
    KODAJEZIKA_GALICIAN       = 0x00004c47,
    KODAJEZIKA_GEORGIAN       = 0x0000414b,
    KODAJEZIKA_GREEK          = 0x00004c45,
    KODAJEZIKA_GREENLANDIC    = 0x00004c4b,
    KODAJEZIKA_GUARANI        = 0x00004e47,
    KODAJEZIKA_GUJARATI       = 0x00005547,
    KODAJEZIKA_HAUSA          = 0x00004148,
    KODAJEZIKA_HEBREW         = 0x00005749,
    KODAJEZIKA_HINDI          = 0x00004948,
    KODAJEZIKA_ICELANDIC      = 0x00005349,
    KODAJEZIKA_INDONESIAN     = 0x00004e49,
    KODAJEZIKA_INTERLINGUA    = 0x00004149,
    KODAJEZIKA_INTERLINGUE    = 0x00004549,
    KODAJEZIKA_INUPIAK        = 0x00004b49,
    KODAJEZIKA_IRISH          = 0x00004147,
    KODAJEZIKA_ITALIAN        = 0x00005449,
    KODAJEZIKA_JAPANESE       = 0x0000414a,
    KODAJEZIKA_JAVANESE       = 0x0000574a,
    KODAJEZIKA_KANNADA        = 0x00004e4b,
    KODAJEZIKA_KASHMIRI       = 0x0000534b,
    KODAJEZIKA_KAZAKH         = 0x00004b4b,
    KODAJEZIKA_KINYARWANDA    = 0x00005752,
    KODAJEZIKA_KIRGHIZ        = 0x0000594b,
    KODAJEZIKA_KIRUNDI        = 0x00004e52,
    KODAJEZIKA_KOREAN         = 0x00004f4b,
    KODAJEZIKA_KURDISH        = 0x0000554b,
    KODAJEZIKA_LAOTHIAN       = 0x00004f4c,
    KODAJEZIKA_LATVIAN        = 0x0000564c,
    KODAJEZIKA_LETTISH        = 0x0000564c,
    KODAJEZIKA_LINGALA        = 0x00004e4c,
    KODAJEZIKA_LITHUANIAN     = 0x0000544c,
    KODAJEZIKA_MALAGASY       = 0x0000474d,
    KODAJEZIKA_MALAY          = 0x0000534d,
    KODAJEZIKA_MALAYALAM      = 0x00004c4d,
    KODAJEZIKA_MALTESE        = 0x0000544d,
    KODAJEZIKA_MAORI          = 0x0000494d,
    KODAJEZIKA_MARATHI        = 0x0000524d,
    KODAJEZIKA_MOLDAVIAN      = 0x00004f4d,
    KODAJEZIKA_MONGOLIAN      = 0x00004e4d,
    KODAJEZIKA_NAURU          = 0x0000414e,
    KODAJEZIKA_NEPALI         = 0x0000454e,
    KODAJEZIKA_NORWEGIAN      = 0x00004f4e,
    KODAJEZIKA_OCCITAN        = 0x0000434f,
    KODAJEZIKA_ORIYA          = 0x0000524f,
    KODAJEZIKA_OROMO          = 0x00004d4f,
    KODAJEZIKA_PASHTO         = 0x00005350,
    KODAJEZIKA_PERSIAN        = 0x00004146,
    KODAJEZIKA_POLISH         = 0x00004c50,
    KODAJEZIKA_PORTUGUESE     = 0x00005450,
    KODAJEZIKA_PUNJABI        = 0x00004150,
    KODAJEZIKA_PUSHTO         = 0x00005350,
    KODAJEZIKA_QUECHUA        = 0x00005551,
    KODAJEZIKA_RHAETO_ROMANCE = 0x00004d52,
    KODAJEZIKA_ROMANIAN       = 0x00004f52,
    KODAJEZIKA_SAMOAN         = 0x00004d53,
    KODAJEZIKA_SANGRO         = 0x00004753,
    KODAJEZIKA_SANSKRIT       = 0x00004153,
    KODAJEZIKA_SCOTS_GAELIC   = 0x00004447,
    KODAJEZIKA_SESOTHO        = 0x00005453,
    KODAJEZIKA_SETSWANA       = 0x00004e54,
    KODAJEZIKA_SHONA          = 0x00004e53,
    KODAJEZIKA_SINDHI         = 0x00004453,
    KODAJEZIKA_SINGHALESE     = 0x00004953,
    KODAJEZIKA_SISWATI        = 0x00005353,
    KODAJEZIKA_SLOVAK         = 0x00004b53,
    KODAJEZIKA_SOMALI         = 0x00004f53,
    KODAJEZIKA_SUDANESE       = 0x00005553,
    KODAJEZIKA_SWAHILI        = 0x00005753,
    KODAJEZIKA_SWEDISH        = 0x00005653,
    KODAJEZIKA_TAGALOG        = 0x00004c54,
    KODAJEZIKA_TAJIK          = 0x00004754,
    KODAJEZIKA_TAMIL          = 0x00004154,
    KODAJEZIKA_TATAR          = 0x00005454,
    KODAJEZIKA_TEGULU         = 0x00004554,
    KODAJEZIKA_THAI           = 0x00004854,
    KODAJEZIKA_TIBETAN        = 0x00004f42,
    KODAJEZIKA_TIGRINYA       = 0x00004954,
    KODAJEZIKA_TONGA          = 0x00004f54,
    KODAJEZIKA_TSONGA         = 0x00005354,
    KODAJEZIKA_TURKISH        = 0x00005254,
    KODAJEZIKA_TURKMEN        = 0x00004b54,
    KODAJEZIKA_TWI            = 0x00005754,
    KODAJEZIKA_UKRAINIAN      = 0x00004b55,
    KODAJEZIKA_URDU           = 0x00005255,
    KODAJEZIKA_UZBEK          = 0x00005a55,
    KODAJEZIKA_VIETNAMESE     = 0x00004956,
    KODAJEZIKA_VOLAPUK        = 0x00004f56,
    KODAJEZIKA_WELSH          = 0x00005943,
    KODAJEZIKA_WOLOF          = 0x00004f57,
    KODAJEZIKA_XHOSA          = 0x00004858,
    KODAJEZIKA_YIDDISH        = 0x0000494a,
    KODAJEZIKA_YORUBA         = 0x00004f59,
*/
};


//////////////////////////////////////////////////////////////////////
// T_KODAJEZIKA2
//////////////////////////////////////////////////////////////////////

enum T_KODAJEZIKA2 {
    KODAJEZIKA2_NEVTRALNA              = MAKELANGID(LANG_NEUTRAL,   SUBLANG_NEUTRAL),
    KODAJEZIKA2_UPORABNIKOV            = MAKELANGID(LANG_NEUTRAL,   SUBLANG_DEFAULT),
    KODAJEZIKA2_SISTEMSKI              = MAKELANGID(LANG_NEUTRAL,   SUBLANG_SYS_DEFAULT),
    KODAJEZIKA2_NEZNANA                = MAKELANGID(LANG_INVARIANT, SUBLANG_NEUTRAL),

    KODAJEZIKA2_ANGLESCINA             = MAKELANGID(LANG_ENGLISH,   SUBLANG_NEUTRAL),
    KODAJEZIKA2_ANGLESCINA_PRIVZETA    = MAKELANGID(LANG_ENGLISH,   SUBLANG_DEFAULT),
    KODAJEZIKA2_ANGLESCINA_UK          = MAKELANGID(LANG_ENGLISH,   SUBLANG_ENGLISH_UK),
    KODAJEZIKA2_ANGLESCINA_US          = MAKELANGID(LANG_ENGLISH,   SUBLANG_ENGLISH_US),
    KODAJEZIKA2_SLOVENSCINA            = MAKELANGID(LANG_SLOVENIAN, SUBLANG_NEUTRAL),
    KODAJEZIKA2_SLOVENSCINA_PRIVZETA   = MAKELANGID(LANG_SLOVENIAN, SUBLANG_DEFAULT),
#ifdef SUBLANG_SLOVENIAN_SLOVENIA
    KODAJEZIKA2_SLOVENSCINA_SI         = MAKELANGID(LANG_SLOVENIAN, SUBLANG_SLOVENIAN_SLOVENIA),
#else
    KODAJEZIKA2_SLOVENSCINA_SI         = MAKELANGID(LANG_SLOVENIAN, 1),
#endif
    KODAJEZIKA2_ALBANSCINA             = MAKELANGID(LANG_ALBANIAN,  SUBLANG_NEUTRAL),
    KODAJEZIKA2_ALBANSCINA_PRIVZETA    = MAKELANGID(LANG_ALBANIAN,  SUBLANG_DEFAULT),
#ifdef SUBLANG_ALBANIAN_ALBANIA
    KODAJEZIKA2_ALBANSCINA_AL          = MAKELANGID(LANG_ALBANIAN,  SUBLANG_ALBANIAN_ALBANIA),
#else
    KODAJEZIKA2_ALBANSCINA_AL          = MAKELANGID(LANG_ALBANIAN,  1),
#endif
    KODAJEZIKA2_NEMSCINA               = MAKELANGID(LANG_GERMAN,    SUBLANG_NEUTRAL),
    KODAJEZIKA2_NEMSCINA_PRIVZETA      = MAKELANGID(LANG_GERMAN,    SUBLANG_DEFAULT),
    KODAJEZIKA2_NEMSCINA_DE            = MAKELANGID(LANG_GERMAN,    SUBLANG_GERMAN),
    KODAJEZIKA2_FRANCOSCINA            = MAKELANGID(LANG_FRENCH,    SUBLANG_NEUTRAL),
    KODAJEZIKA2_FRANCOSCINA_PRIVZETA   = MAKELANGID(LANG_FRENCH,    SUBLANG_DEFAULT),
    KODAJEZIKA2_FRANCOSCINA_FR         = MAKELANGID(LANG_FRENCH,    SUBLANG_FRENCH),
    KODAJEZIKA2_ITALIJANSCINA          = MAKELANGID(LANG_ITALIAN,   SUBLANG_NEUTRAL),
    KODAJEZIKA2_ITALIJANSCINA_PRIVZETA = MAKELANGID(LANG_ITALIAN,   SUBLANG_DEFAULT),
    KODAJEZIKA2_ITALIJANSCINA_IT       = MAKELANGID(LANG_ITALIAN,   SUBLANG_ITALIAN),
};

#define OSNOVNI_JEZIK(koda)     ((T_KODAJEZIKA2)(koda & 0x3ff))


//////////////////////////////////////////////////////////////////////
// T_KODAUREDITVE
//////////////////////////////////////////////////////////////////////

enum T_KODAUREDITVE {
    KODAUREDITVE_PRIVZETA   = SORT_DEFAULT,
};


//////////////////////////////////////////////////////////////////////
// T_KODALOCALE
//////////////////////////////////////////////////////////////////////

enum T_KODALOCALE {
    KODALOCALE_NEVTRALNA    = MAKELCID(MAKELANGID(LANG_NEUTRAL, SUBLANG_NEUTRAL), SORT_DEFAULT),
    KODALOCALE_UPORABNIKOV  = MAKELCID(MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), SORT_DEFAULT),
    KODALOCALE_SISTEMSKI    = MAKELCID(MAKELANGID(LANG_NEUTRAL, SUBLANG_SYS_DEFAULT), SORT_DEFAULT),
    KODALOCALE_NEZNANA      = MAKELCID(MAKELANGID(LANG_INVARIANT, SUBLANG_NEUTRAL), SORT_DEFAULT),

    KODALOCALE_SLOVENSCINA  = MAKELCID(MAKELANGID(LANG_SLOVENIAN, SUBLANG_DEFAULT), SORT_DEFAULT),
};


//////////////////////////////////////////////////////////////////////
// T_DNEVNIKPRIORITETA
//////////////////////////////////////////////////////////////////////

enum T_DNEVNIKPRIORITETA {
    ADNE_PANIKA    = 0,
    ADNE_ALARM     = 1,
    ADNE_KRITICNO  = 2,
    ADNE_NAPAKA    = 3,
    ADNE_OPOZORILO = 4,
    ADNE_OBVESTILO = 5,
    ADNE_INFO      = 6,
    ADNE_DIAG      = 7,
};


//////////////////////////////////////////////////////////////////////
// T_PLATFORMAOS
//////////////////////////////////////////////////////////////////////

enum T_PLATFORMAOS {
    AOSN_PLAT_NEZNANA = 0x00000000,
    AOSN_PLAT_WIN16   = 0x00010000,
    AOSN_PLAT_WIN32   = 0x00020000,
    AOSN_PLAT_WINNT   = 0x00030000,
    AOSN_PLAT_WINCE   = 0x00040000,
    AOSN_PLAT_UNIX    = 0x80000000,
};


//////////////////////////////////////////////////////////////////////
// T_VERZIJAOS
//////////////////////////////////////////////////////////////////////

enum T_VERZIJAOS {
    AOSN_OS_NEZNAN      = AOSN_PLAT_NEZNANA | 0,

    AOSN_OS_WIN31       = AOSN_PLAT_WIN16 | 0x0100,

    AOSN_OS_WIN95       = AOSN_PLAT_WIN32 | 0x0100,
    AOSN_OS_WIN98       = AOSN_PLAT_WIN32 | 0x0200,
    AOSN_OS_WINME       = AOSN_PLAT_WIN32 | 0x0300,

    AOSN_OS_WINNT3      = AOSN_PLAT_WINNT | 0x0100,
    AOSN_OS_WINNT4      = AOSN_PLAT_WINNT | 0x0200,
    AOSN_OS_WIN2000     = AOSN_PLAT_WINNT | 0x0300,
    AOSN_OS_WINXP       = AOSN_PLAT_WINNT | 0x0400,
    AOSN_OS_WIN2003     = AOSN_PLAT_WINNT | 0x0500,
    AOSN_OS_WINVISTA    = AOSN_PLAT_WINNT | 0x0600,
    AOSN_OS_WINNT_NASL  = AOSN_PLAT_WINNT | 0xffff,

    AOSN_OS_WINCE1      = AOSN_PLAT_WINCE | 0x0100,
    AOSN_OS_WINCE2      = AOSN_PLAT_WINCE | 0x0200,
    AOSN_OS_WINCE3      = AOSN_PLAT_WINCE | 0x0300,
    AOSN_OS_WINCE_NASL  = AOSN_PLAT_WINCE | 0xffff,

    AOSN_OS_UNIX        = AOSN_PLAT_UNIX | 0x0000,
};

#define AOSN_PLATFORMA_OS(verzija) ((T_PLATFORMAOS)((verzija) & 0xffff0000))
#define AOSN_VERZIJA_OS(verzija)   ((T_UINT)       ((verzija) & 0x0000ffff))


//////////////////////////////////////////////////////////////////////
// T_STD_ROCICA
//////////////////////////////////////////////////////////////////////

enum T_STD_ROCICA {
    AOSN_STD_VHOD = 0,
    AOSN_STD_IZHOD,
    AOSN_STD_NAPAKA,
};


#ifdef AOSN_VTIC

//////////////////////////////////////////////////////////////////////
// T_VTICDOMENA
//////////////////////////////////////////////////////////////////////

enum T_VTICDOMENA {
    VTIC_UNIX           = PF_UNIX,
    VTIC_INET           = PF_INET,
    VTIC_INET6          = PF_INET6,
    VTIC_IPX            = PF_IPX,
    VTIC_OSIISO         = PF_OSI,
};


//////////////////////////////////////////////////////////////////////
// T_VTICVRSTA
//////////////////////////////////////////////////////////////////////

enum T_VTICVRSTA {
    VTIC_PRETOCNI   = SOCK_STREAM,
    VTIC_PAKETNI    = SOCK_DGRAM,
    VTIC_ZAPPAKETOV = SOCK_SEQPACKET,
    VTIC_SUROV      = SOCK_RAW,
};


//////////////////////////////////////////////////////////////////////
// T_VTICPROTOKOL
//////////////////////////////////////////////////////////////////////

enum T_VTICPROTOKOL {
    VTIC_PROTOKOL_IP        = IPPROTO_IP,
    VTIC_PROTOKOL_IP_TCP    = IPPROTO_TCP,
    VTIC_PROTOKOL_IP_UDP    = IPPROTO_UDP,
//    VTIC_PROTOKOL_IP_IPV4   = IPPROTO_IPV4,
//    VTIC_PROTOKOL_IP_IPV6   = IPPROTO_IPV6,
};


//////////////////////////////////////////////////////////////////////
// T_VTICNACINZAPIRANJA
//////////////////////////////////////////////////////////////////////

enum T_VTICNACINZAPIRANJA {
    VTIC_KONCAJ_BRANJE   = SD_RECEIVE,
    VTIC_KONCAJ_PISANJE  = SD_SEND,
    VTIC_KONCAJ_OBOJE    = SD_BOTH,
};


//////////////////////////////////////////////////////////////////////
// T_VTICNIVOPARAM
//////////////////////////////////////////////////////////////////////

enum T_VTICNIVOPARAM {
    VTIC_NP_VTICNICA       = SOL_SOCKET
};


//////////////////////////////////////////////////////////////////////
// T_VTICPARAMETER
//////////////////////////////////////////////////////////////////////

enum T_VTICPARAMETER {
    VTIC_PARA_RAZPRSENOODAJANJE   = SO_BROADCAST,
    VTIC_PARA_DIAGNOSTICNO        = SO_DEBUG,
    VTIC_PARA_NECAKAJNAKONEC      = SO_DONTLINGER,
    VTIC_PARA_NEUSMERJAJ          = SO_DONTROUTE,
    VTIC_PARA_BUJENJE             = SO_KEEPALIVE,
    VTIC_PARA_CAKAJNAKONEC        = SO_LINGER,
    VTIC_PARA_VKLJUCIZUNAJPASOVNO = SO_OOBINLINE,
    VTIC_PARA_RECIKLIRAJNASLOV    = SO_REUSEADDR,
    VTIC_PARA_SPMEDPOMNILNIK      = SO_RCVBUF,
    VTIC_PARA_ODMEDPOMNILNIK      = SO_SNDBUF,
    // definiraj ostale konstante za opcije TCP/IP po potrebi
};


//////////////////////////////////////////////////////////////////////
// T_VTICNACIN
//////////////////////////////////////////////////////////////////////

enum T_VTICNACIN {
    VTIC_PREDOGLED    = MSG_PEEK,
    VTIC_ZUNAJPASOVNO = MSG_OOB,
    VTIC_NEUSMERJAJ   = MSG_DONTROUTE,
};

#endif // AOSN_VTIC


//////////////////////////////////////////////////////////////////////
// RElement
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RElement
{
public:
    RElement();
    virtual ~RElement();
};


//////////////////////////////////////////////////////////////////////
// RSisElement
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RSisElement : virtual public RElement
{
public:
    RSisElement(T_ROCICAOS r = NEVELJAVNA_ROCICA);
    RSisElement(const RSisElement &el);
    virtual ~RSisElement();

    virtual T_STANJE Uporabi(T_ROCICAOS rocica);                            // Uporabi e narejeno roico
    virtual T_ROCICAOS Odpusti();                                           // Vrne roico in razpusti element
    virtual T_STANJE Zapri();                                               // Zapre roico
    virtual T_STANJE Podvoji(T_BOOL deduj, T_ROCICAOS *nova_rocica) const;  // Podvoji roico elementa

    inline T_BOOL JeVeljaven() const;                                       // Vrne TRUE, e je roica veljavna
    inline T_ROCICAOS VrniRocico() const;                                   // Vrne roico
    inline operator T_ROCICAOS() const;                                     // Vrne roico

    inline static T_STANJE Zapri(T_ROCICAOS rocica);                        // Zapre roico
    inline static T_STANJE Podvoji(T_ROCICAOS rocica, T_BOOL deduj, T_ROCICAOS *nova_rocica);  // Podvoji roico elementa

protected:
    T_ROCICAOS rocica;  // roica elementa
};


//////////////////////////////////////////////////////////////////////
// RIzpElement
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RIzpElement : virtual public RElement
{
public:
    virtual T_STANJE Izplakni() = 0;                    // Izplakne podatke elementa v medpomnilniku
};


#ifdef AOSN_KAZNAP

//////////////////////////////////////////////////////////////////////
// RKazalnikNapredka
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RKazalnikNapredka : public RElement
{
public:
    virtual T_VOID NastaviBesedilo(TK_NIZ besedilo);            // Nastavi besedilo za statusno vrstico
    virtual T_VOID NastaviBesedilo(T_UINT id_res);              // Naloi besedilo za statusno vrstico iz virov

    virtual T_VOID NastaviObmocje(T_INT zacetek, T_INT konec);  // Nastavi obmoje, v katerem bo proces potekal
    virtual T_VOID Nastavi(T_INT trenutni);                     // Nastavi trenutni poloaj procesa

    virtual T_VOID Prikazi(T_BOOL pokazi = TRUE);               // Prikae ali skrije kazalnik napredka

    virtual T_BOOL PrekiniPostopek();                           // Funkcija s katero spraujemo, ali prekinemo postopek
};


//////////////////////////////////////////////////////////////////////
// RCasKazalnikNapredka
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RCasKazalnikNapredka : public RKazalnikNapredka
{
public:
    RCasKazalnikNapredka(T_UINT casovna_kontrola = 500);

    virtual T_VOID NastaviObmocje(T_INT zacetek, T_INT konec);  // Nastavi obmoje, v katerem bo proces potekal
    virtual T_VOID Nastavi(T_INT trenutni);                     // Nastavi trenutni poloaj procesa

protected:
    virtual T_VOID PraviNastaviObmocje();                       // Prava funkcija za nastavitev obmoja napredka (uporabnik mora zamenjati to funkcijo)
    virtual T_VOID PraviNastavi();                              // Prava funkcija za nastavitev napredka (uporabnik mora zamenjati to funkcijo)

protected:
    T_UINT casovna_kontrola, zadnja_milisekunda;
    T_INT zacetek, konec, trenutni;
};


//////////////////////////////////////////////////////////////////////
// RGlobalniKazalnikNapredka
//////////////////////////////////////////////////////////////////////

#pragma warning(push)
#pragma warning(disable: 4251)

class AOSN_CLASS RGlobalniKazalnikNapredka : public RKazalnikNapredka
{
public:
    RGlobalniKazalnikNapredka(RKazalnikNapredka *kazalnik = NULL);

    inline T_VOID Uporabi(RKazalnikNapredka *kazalnik);                 // Nastavimo kazalnik, ki ga uporabljamo
    inline RKazalnikNapredka* Odpusti();                                // Odpustimo kazalnik iz uporabe
    inline T_VOID NastaviGlobalnoObmocje(T_INT zacetek, T_INT konec);   // Nastavi globalno obmoje, v katerem bo proces potekal
    inline T_VOID NastaviGlobalniOdsek(T_INT zacetek, T_INT konec);     // Nastavi globalni odsek, v katerem bo proces potekal

    virtual T_VOID NastaviBesedilo(TK_NIZ besedilo);                    // Nastavi besedilo za statusno vrstico
    virtual T_VOID NastaviBesedilo(T_UINT id_res);                      // Naloi besedilo za statusno vrstico iz virov

    virtual T_VOID NastaviObmocje(T_INT zacetek, T_INT konec);          // Nastavi obmoje, v katerem bo proces potekal
    virtual T_VOID Nastavi(T_INT trenutni);                             // Nastavi trenutni poloaj procesa

    virtual T_VOID Prikazi(T_BOOL pokazi = TRUE);                       // Prikae ali skrije kazalnik napredka
    virtual T_BOOL PrekiniPostopek();                                   // Funkcija s katero spraujemo, ali prekinemo postopek

protected:
    RKazalnikNapredka *kazalnik;
    T_INTERVAL<T_INT> kaz, glob, odsek;
};

#pragma warning(pop)

#endif // AOSN_KAZNAP


//////////////////////////////////////////////////////////////////////
// RKazalec
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RKazalec : public RElement
{
public:
    RKazalec(T_BOOL ustvari = TRUE);
    virtual ~RKazalec();

    virtual T_STANJE Ustvari();         // Eksplicitno ustvari kazalec
    virtual T_STANJE Unici();           // Eksplicitno unii kazalec

    inline TIP* Vrni() const;           // Vrne kazalec
    inline T_VOID Uporabi(TIP* p);      // Uporabi kazalec, ki ga je uporabnik naredil sam s funkcijo aalloc()!!!)
    inline TIP* Odpusti();              // Odpusti kazalec iz uporabe. Ne pozabi klicati afree()!!!

    inline operator TIP*() const;
    inline TIP& operator*() const;
    inline TIP* operator->() const;
    inline T_BOOL operator!() const;
    inline T_BOOL operator<(TIP* p) const;
    inline T_BOOL operator<=(TIP* p) const;
    inline T_BOOL operator==(TIP* p) const;
    inline T_BOOL operator>=(TIP* p) const;
    inline T_BOOL operator>(TIP* p) const;

protected:
    T_VOZEL<TIP> *p;
};


//////////////////////////////////////////////////////////////////////
// RTabela
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RTabela : public RElement
{
public:
    RTabela();
    RTabela(T_UINT stevilo);
    virtual ~RTabela();

    virtual T_STANJE Ustvari(T_UINT stevilo);
    virtual T_STANJE Unici();
    inline T_BOOL JeUstvarjena() const;

    inline T_UINT VrniStevilo() const;                                          // Vrne stevilo elementov v tabeli
    inline TIP* Vrni() const;                                                   // Vrne kazalec na tabelo
    inline T_VOID Uporabi(TIP* tabela, T_UINT stevilo, T_BOOL unici = TRUE);    // Uporabi tabelo, ki jo je uporabnik naredil sam - z operatorjem new!!!)
    inline TIP* Odpusti(T_BOOL ustvari = TRUE);                                 // Odpusti tabelo iz uporabe (stevilo elementov v tabeli ugotovi s predhodnjim klicem VrniStevilo - potem bo prepozno). Ne pozabi klicati delete []!!!

    inline TIP& operator [](T_UINT indeks) const;                               // Vrne element na indeksu
    inline TIP& operator [](int indeks) const;                                  // Vrne element na indeksu
    inline operator TIP*() const;                                               // Vrne kazalec na tabelo

#if _MSC_VER >= 1300
    template <T_INT(COMP)(const TIP &a, const TIP &b)> inline T_VOID Uredi() { aqsort<TIP, COMP>(podatki, st_elementov); }
    template <T_INT(COMP)(const TIP &a, const TIP &b)> inline T_UINT Poisci(const TIP &element) const { return alinsearch<TIP, COMP>(podatki, st_elementov, element); }
    template <T_INT(COMP)(const TIP &a, const TIP &b)> inline T_UINT PoisciUrejeno(const TIP &element) const { return abinsearch<TIP, COMP>(podatki, st_elementov, element); }
#endif

protected:
    TIP *podatki;
    T_UINT st_elementov;
};


template <class TOK, class TIP> inline TOK& operator <<(TOK &tok, const RTabela<TIP> &tabela);
template <class TOK, class TIP> inline TOK& operator >>(TOK &tok, RTabela<TIP> &tabela);


//////////////////////////////////////////////////////////////////////
// RDinTabela
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RDinTabela : public RElement
{
public:
    RDinTabela();
    RDinTabela(T_UINT koliko);
    RDinTabela(const TIP &element, T_UINT koliko);
    RDinTabela(const TIP *niz, T_UINT koliko);
    RDinTabela(const RDinTabela<TIP> &niz, T_UINT koliko = T_UINT_MAX);
    virtual ~RDinTabela();

    // funkcije za dostop do vsebine
    inline T_UINT VrniStevilo() const;                                              // Vrne tevilo elementov v tabeli
    inline T_BOOL JePrazna() const;                                                 // Vrne TRUE, e je tabela prazna
    inline T_VOID NastaviStevilo(T_UINT koliko);                                    // Nastavi tabelo na eleno tevilo elementov
    inline T_VOID Sprazni();                                                        // Sprazni tabelo
    inline const TIP* Vrni() const;                                                 // Vrne kazalec na tabelo (samo za branje)

    inline T_UINT Nastavi(const TIP &element, T_UINT koliko = 1);                   // Nastavi tabelo na doloeno tevilo enakih elementov (memset)
    inline T_UINT Nastavi(const TIP *niz, T_UINT koliko);                           // Nastavi tabelo na doloeno vrednost
    inline T_UINT Nastavi(const RDinTabela<TIP> &niz, T_UINT koliko = T_UINT_MAX);  // Nastavi tabelo na doloeno vrednost
    inline T_UINT Prilepi(const TIP &element, T_UINT koliko = 1);                   // Prilepi tabeli doloeno tevilo enakih elementov
    inline T_UINT Prilepi(const TIP *niz, T_UINT koliko);                           // Prilepi tabeli doloeno tabelo
    inline T_UINT Prilepi(const RDinTabela<TIP> &niz, T_UINT koliko = T_UINT_MAX);  // Prilepi tabeli doloeno tabelo

#if _MSC_VER >= 1300
    template <T_INT(COMP)(const TIP &a, const TIP &b)> inline T_VOID Uredi() { aqsort<TIP, COMP>(podatki, st_elementov); }
    template <T_INT(COMP)(const TIP &a, const TIP &b)> inline T_UINT Poisci(const TIP &element) const { return alinsearch<TIP, COMP>(podatki, st_elementov, element); }
    template <T_INT(COMP)(const TIP &a, const TIP &b)> inline T_UINT PoisciUrejeno(const TIP &element) const { return abinsearch<TIP, COMP>(podatki, st_elementov, element); }
#endif

    // neposreden dostop do pomnilnika
    inline T_VOID Uporabi(TIP *tabela, T_UINT stevilo, T_BOOL unici = TRUE);        // Uporabi tabelo, ki jo je uporabnik naredil sam
    inline TIP* Odpusti(T_UINT min_dolzina, T_BOOL ustvari = TRUE);                 // Odpusti tabelo iz uporabe (stevilo elementov v tabeli ugotovi s predhodnjim klicem VrniStevilo - potem bo prepozno). Ne pozabi klicati afree!!!
    inline T_VOID SprostiOdvecne();                                                 // Sprosti neuporabljen pomnilnik na koncu tabele

    // operatorji
    inline TIP& operator [](T_UINT indeks) const;                                   // Vrne element na indeksu
    inline TIP& operator [](int indeks) const;                                      // Vrne element na indeksu
    inline operator const TIP*() const;                                             // Vrne kazalec na tabelo

    inline const TIP* operator =(const TIP &element);
    inline const TIP* operator =(const RDinTabela<TIP> &niz);

    inline const TIP* operator +=(const TIP &element);
    inline const TIP* operator +=(const RDinTabela<TIP> &niz);

protected:
    virtual T_STANJE RezervirajDolzino(T_UINT zeljeno, T_BOOL tesno = FALSE);

protected:
    TIP *podatki;
    T_UINT
        st_elementov,
        max_elementov;
};


template <class TOK, class TIP> inline TOK& operator <<(TOK &tok, const RDinTabela<TIP> &tabela);
template <class TOK, class TIP> inline TOK& operator >>(TOK &tok, RDinTabela<TIP> &tabela);


//////////////////////////////////////////////////////////////////////
// RZbirka
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RZbirka : public RElement
{
public:
    RZbirka(T_UINT korak_povecevanja = RSEZNAM_KORAK_POVECEVANJA);
    virtual ~RZbirka();

    inline  T_ROCICA Dodaj();                                           // Doda v zbirko nov element in vrne roico njegovega vozlia
    inline  T_ROCICA Dodaj(const TIP &element);                         // Doda element v zbirko in vrne roico njegovega vozlia
    virtual T_ROCICA DodajVozel(T_ROCICA rocica) = 0;                   // Doda vozlie v zbirko
    virtual T_VOID Unici() = 0;                                         // Unii vsa vozlia v zbirki
    virtual T_ROCICA UstvariVozel() = 0;                                // Ustvari novo vozlie in vrne njegovo roico (a ga e ne doda v zbirko)
    virtual T_ROCICA UstvariVozel(const TIP &element) = 0;              // Ustvari novo vozlie, inicializira element in vrne roico vozlia (a ga e ne doda v zbirko)
    virtual T_VOID UniciVozel(T_ROCICA rocica) = 0;                     // Unii vozlie (mora biti nepovezano)

    inline TIP& VrniElement(T_ROCICA rocica) const;                     // Vrne element po referenci, e poznamo roico njegovega vozlia
    inline T_UINT VrniStevilo() const;                                  // Vrne tevilo elementov v zbirki
    inline T_BOOL JePrazen() const;                                     // Vrne TRUE, e je zbirka prazna

    inline TIP& operator [](T_ROCICA rocica) const;                     // Vrne element po referenci, e poznamo roico njegovega vozlia
    inline T_ROCICA operator +=(const TIP &element);                    // Doda element v zbirko

protected:
#ifndef RSEZNAM_STDALLOC_VER
    virtual T_STANJE RezervirajBlok() = 0;                              // Rezervira nov blok na kopici za shranjevanje vozli
    virtual T_BOOL JeVozelVKopici(T_ROCICA rocica) const = 0;           // Preveri, ali je dano vozlie prosto vozlie na kopici te zbirke

    T_ROCICAOS kopica;                                                  // roica zasebne kopice
    T_ROCICA prosti;                                                    // prvo prosto vozlie na kopici
    T_UINT korak_povecevanja;                                           // tevilo elementov, za koliko poveujemo kopico
#ifdef _DEBUG
    T_UINT st_zasedenih;                                                // tevilo zasedenih vozli => za garbage collection
#endif
#endif
    T_UINT st_elementov;                                                // tevilo elementov v zbirki
};

template <class TOK, class TIP> inline TOK& operator >>(TOK &tok, RZbirka<TIP> &zbirka);


//////////////////////////////////////////////////////////////////////
// RSklad
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RSklad : public RZbirka<TIP>
{
public:
    RSklad(T_UINT korak_povecevanja = RSEZNAM_KORAK_POVECEVANJA);
    RSklad(const RSklad<TIP> &sklad);
    virtual ~RSklad();

    inline  T_ROCICA DodajZa(T_ROCICA ref);                             // Doda v sklad nov element za referennim vozliem in vrne roico elementovega vozlia
    inline  T_ROCICA DodajZa(const TIP &element, T_ROCICA ref);         // Doda element v sklad za referennim vozliem in vrne roico elementovega vozlia
    virtual T_ROCICA DodajVozel(T_ROCICA rocica);                       // Doda vozlie na vrh sklada
    virtual T_ROCICA DodajVozelZa(T_ROCICA rocica, T_ROCICA ref);       // Doda vozlie za referenno vozlie sklada
    virtual T_VOID Brisi();                                             // Brie vrhnje vozlie sklada
    virtual T_VOID Unici();                                             // Unii vsa vozlia v skladu
    virtual T_ROCICA UstvariVozel();                                    // Ustvari novo vozlie in vrne njegovo roico (a ga e ne povee v sklad)
    virtual T_ROCICA UstvariVozel(const TIP &element);                  // Ustvari novo vozlie, inicializira element in vrne roico vozlia (a ga e ne povee v sklad)
    virtual T_VOID UniciVozel(T_ROCICA rocica);                         // Unii vozlie (mora biti nepovezano)

    inline T_UINT PrepisiVTabelo(TIP *tabela) const;                    // Prepie vse elemente seznama v tabelo

    inline T_ROCICA VrniPrvega() const;                                 // Vrne roico vrhnjega vozlia
    inline T_ROCICA VrniNaslednjega(T_ROCICA rocica) const;             // Vrne roico naslednjega vozlia
    inline TIP& VrniPrviElement() const;                                // Vrne vrhnji element po referenci

    inline const RSklad<TIP>& operator =(const RSklad<TIP> &sklad);     // Prepie vse elemente iz enega sklada v drugega

protected:
#ifndef RSEZNAM_STDALLOC_VER
    virtual T_STANJE RezervirajBlok();                                  // Rezervira nov blok na kopici za shranjevanje vozli
    virtual T_BOOL JeVozelVKopici(T_ROCICA rocica) const;               // Preveri, ali je dano vozlie prosto vozlie na kopici te zbirke
    inline T_ROCICA RezervirajVozel();                                  // Rezervira vozlie na kopici in vrne njegovo roico
    inline T_VOID SprostiVozel(T_ROCICA rocica);                        // Sprosti vozlie na kopici
#endif

    T_VOZELENO<TIP> *prvi;  // prvo vozlie sklada
};

template <class TOK, class TIP> inline TOK& operator <<(TOK &tok, const RSklad<TIP> &sklad);


//////////////////////////////////////////////////////////////////////
// RSeznam
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RSeznam : public RSklad<TIP>
{
public:
    RSeznam(T_UINT korak_povecevanja = RSEZNAM_KORAK_POVECEVANJA);
    RSeznam(const RSklad<TIP> &sklad);
    virtual ~RSeznam();

    inline  T_ROCICA DodajPred(T_ROCICA ref);                           // Doda v sklad nov element pred referenno vozlie in vrne roico elementovega vozlia
    inline  T_ROCICA DodajPred(const TIP &element, T_ROCICA ref);       // Doda element v sklad pred referenno vozlie in vrne roico elementovega vozlia
    virtual T_ROCICA DodajVozel(T_ROCICA rocica);                       // Doda vozlie na konec seznama
    virtual T_ROCICA DodajVozelZa(T_ROCICA rocica, T_ROCICA ref);       // Doda vozlie za referenno vozlie seznama
    virtual T_ROCICA DodajVozelPred(T_ROCICA rocica, T_ROCICA ref);     // Doda vozlie pred referenno vozlie seznama
    inline  T_VOID IzlociVozel(T_ROCICA rocica);                        // Izloi vozlie iz seznama a ga ne unii
    virtual T_VOID Brisi(T_ROCICA rocica);                              // Brie vozlie v seznamu
    virtual T_VOID Unici();                                             // Unii vse elemente seznama
    virtual T_ROCICA UstvariVozel();                                    // Ustvari novo vozlie in vrne njegovo roico (a ga e ne povee v seznam)
    virtual T_ROCICA UstvariVozel(const TIP &element);                  // Ustvari novo vozlie, inicializira element in vrne roico vozlia (a ga e ne povee v seznam)
    virtual T_VOID UniciVozel(T_ROCICA rocica);                         // Unii vozlie (mora biti nepovezano)

    inline T_ROCICA VrniZadnjega() const;                               // Vrne roico zadnjega vozlia
    inline T_ROCICA VrniPrejsnjega(T_ROCICA rocica) const;              // Vrne roico prejnjega vozlia
    inline TIP& VrniZadnjiElement() const;                              // Vrne zadnji element po referenci

protected:
#ifndef RSEZNAM_STDALLOC_VER
    virtual T_STANJE RezervirajBlok();                                  // Rezervira nov blok na kopici za shranjevanje vozli
#endif

    T_ROCICA zadnji;    // zadnje vozlie seznama
};


//////////////////////////////////////////////////////////////////////
// RUrejenSeznam
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RUrejenSeznam : public RSeznam<TIP>
{
public:
    RUrejenSeznam(T_UINT korak_povecevanja = RSEZNAM_KORAK_POVECEVANJA);

    virtual T_ROCICA DodajVozel(T_ROCICA rocica);                                               // Doda vozlie na ustrezno mesto v seznam
    inline  T_ROCICA DodajPogojno(const TIP &element);                                          // Doda element na ustrezno mesto v seznam, e tam e ni takega in vrne roico elementovega vozlia
    virtual T_ROCICA DodajVozelPogojno(T_ROCICA rocica);                                        // Doda vozlie na ustrezno mesto v seznam, e tam e ni takega, sicer vrne roico vozlia iz seznama
    virtual T_ROCICA PoisciOd(T_ROCICA rocica, const TIP &element, T_BOOL naprej = TRUE) const; // Poie in vrne roico prvega vozlia z enakim elementom od vozlia rocica naprej/nazaj
    inline  T_ROCICA PoisciOdPrvega(const TIP &element) const;                                  // Poie in vrne roico prvega vozlia z enakim elementom
    inline  T_ROCICA PoisciOdZadnjega(const TIP &element) const;                                // Poie in vrne roico zadnjega vozlia z enakim elementom
    virtual T_INT Primerjaj(const TIP &prvi, const TIP &drugi) const = 0;                       // Primerja enakost dveh elementov
};


//////////////////////////////////////////////////////////////////////
// T_BVOZEL - struktura, ki opisuje vozlie B-drevesa
//////////////////////////////////////////////////////////////////////

template <class TIP, T_UINT N> struct AOSN_TEMPLATE T_BVOZEL
{
    T_BVOZEL<TIP, N> *pred;                                 // kazalec na poddrevo z manjimi elementi (x < zapisi[0].element)
    struct T_TABZAPISI {
        T_UINT stevilo;                                     // tevilo zapisov tega vozlia
        struct T_ZAPIS {
            TIP* element;                                   // kazalec na element
            T_BVOZEL<TIP, N> *nasl;                         // kazalec na poddrevo z vmesnimi/vejimi elementi (zapisi[i].element <= x < zapisi[i + 1].element)
        } podatki[N];                                       // tabela zapisov (element, poddrevo) tega vozlia

        // Vrne i-ti zapis tega vozlia.
        inline T_ZAPIS& operator [](T_UINT indeks) const
        {
            assert(stevilo <= N);
            assert(indeks < stevilo);

            return (T_ZAPIS&)(podatki[indeks]);
        }

        // Premakne vse elemente od vkljuno i-tega za eno mesto desno.
        inline T_VOID PremakniDesno(T_UINT indeks)
        {
            assert(stevilo < N);
            assert(indeks <= stevilo);

            memcpy(podatki + indeks + 1, podatki + indeks, (stevilo - indeks) * sizeof(T_ZAPIS));
            stevilo++;
#ifdef _DEBUG
            memset(podatki + indeks, 0xcd, sizeof(T_ZAPIS));
#endif
        }

        // Premakne vse elemente od vkljuno i+1-tega naprej za eno mesto levo.
        inline T_VOID PremakniLevo(T_UINT indeks)
        {
            assert(stevilo && stevilo <= N);
            assert(indeks < stevilo);

            stevilo--;
            memcpy(podatki + indeks, podatki + indeks + 1, (stevilo - indeks) * sizeof(T_ZAPIS));
#ifdef _DEBUG
            memset(podatki + stevilo, 0xcd, sizeof(T_ZAPIS));
#endif
        }
    } zapisi;
};


//////////////////////////////////////////////////////////////////////
// RBIndeks
//////////////////////////////////////////////////////////////////////

template <class TIP, T_UINT N> class AOSN_TEMPLATE RBIndeks : public RElement
{
public:
    class AOSN_TEMPLATE RIterator : public RElement
    {
    public:
        RIterator();
        RIterator(const RBIndeks<TIP, N> &drevo);
        ~RIterator();

        inline T_VOID NastaviZacetek(const RBIndeks<TIP, N> &drevo);            // Nastavi iterator na zaetek danega drevesa
        inline T_VOID NastaviKonec(const RBIndeks<TIP, N> &drevo);              // Nastavi iterator na konec danega drevesa
        inline T_VOID Sprazni();                                                // Sprazni iterator

        inline TIP* VrniElement() const;                                        // Vrne trenutni element
        inline T_BOOL JeKonec() const;                                          // Vrne TRUE, e je iterator priel ez zunanji rob drevesa
        inline T_BOOL PrestaviNaprej();                                         // Prestavi iterator na naslednji element (vrne FALSE, e je priel ez zunanji rob drevesa)
        inline T_BOOL PrestaviNaprej(T_UINT stevilo);                           // Prestavi iterator za stevilo elementov naprej (vrne FALSE, e je priel ez zunanji rob drevesa)
        inline T_BOOL PrestaviNazaj();                                          // Prestavi iterator na prejnji element (vrne FALSE, e je priel ez zunanji rob drevesa)
        inline T_BOOL PrestaviNazaj(T_UINT stevilo);                            // Prestavi iterator za stevilo elementov nazaj (vrne FALSE, e je priel ez zunanji rob drevesa)

        friend class RBIndeks<TIP, N>;

    protected:
        inline T_VOID DodajKontekst(T_BVOZEL<TIP, N> *vozlisce, T_UINT indeks); // Vstavi dani kontekst na vrh sklada v iteratorju
        inline T_VOID NastaviZacetek(T_BVOZEL<TIP, N> *vozlisce);               // Sestavi zaporedje kontekstov in postavi iterator na najbolj levi zapis v drevesu
        inline T_VOID NastaviKonec(T_BVOZEL<TIP, N> *vozlisce);                 // Sestavi zaporedje kontekstov in postavi iterator na najbolj desni zapis v drevesu

    protected:
        struct T_KONTEKST {
            T_BVOZEL<TIP, N> *vozlisce;     // kazalec na vozlie konteksta
            T_UINT indeks;                  // indeks elementa v vozliu konteksta
            T_KONTEKST *pred;               // kazalec na prejnji kontekst rekurzije
        };

        T_KONTEKST *kontekst;               // kazalec na trenutni kontekst
    };

public:
    RBIndeks();
    virtual ~RBIndeks();

    inline T_VOID DodajElement(TIP *element);                               // Doda element v drevo
    inline TIP* DodajElementPogojno(TIP *element);                          // Doda element pogojno v drevo (e element e obstaja v drevesu, vrne kazalec na obstojeega, sicer pa na tega, ki ga je metoda dodala)
    inline T_VOID Unici();                                                  // Unii vse elemente v drevesu

    inline TIP* Poisci(const TIP *element) const;                           // Poie in vrne prvi element, ki je enak danemu (vrne NULL, e ne najde ujemajoega elementa)
    inline T_BOOL Poisci(const TIP *element, RIterator &iterator) const;    // Poie in nastavi iterator na prvi element, ki je enak danemu (vrne TRUE, e najde ali FALSE, e ne najde ujemajoega elementa)
    inline T_VOID IzlociElement(TIP *element);                              // Izloi element iz drevesa, a ga ne unii
    inline T_BVOZEL<TIP, N>* VrniKoren() const;                             // Vrne korensko vozlie
    inline T_UINT VrniStevilo() const;                                      // Vrne tevilo elementov v drevesu
    inline T_BOOL JePrazen() const;                                         // Vrne TRUE, e je drevo prazno

    virtual T_INT Primerjaj(const TIP *prvi, const TIP *drugi) const = 0;   // Primerja enakost dveh elementov

protected:
    virtual T_VOID UniciPoddrevo(T_BVOZEL<TIP, N> *vozlisce);
    TIP* DodajElement(T_BVOZEL<TIP, N> *vozlisce, TIP *element, T_BVOZEL<TIP, N> **vozlisce_r, TIP **element_n);
    T_BOOL IzlociElement(T_BVOZEL<TIP, N> *vozlisce, TIP *element);
    TIP* IzlociNajmanjsiElement(T_BVOZEL<TIP, N> *vozlisce);
    T_VOID UrediPoddrevo(T_BVOZEL<TIP, N> *vozlisce, T_UINT i);

protected:
    T_BVOZEL<TIP, N> *koren;        // korensko vozlie
    T_UINT st_elementov;            // tevilo elementov v zbirki

    T_ROCICAOS kopica_vozlisc;      // roica zasebne kopice vozli
};


//////////////////////////////////////////////////////////////////////
// RBDrevo
//////////////////////////////////////////////////////////////////////

template <class TIP, T_UINT N> class AOSN_TEMPLATE RBDrevo : public RBIndeks<TIP, N>
{
public:
    RBDrevo();
    virtual ~RBDrevo();

    inline TIP* UstvariElement();                                           // Ustvari element in vrne kazalec nanj
    inline T_VOID UniciElement(TIP *element);                               // Unii element (element ne sme biti dodan v drevo)

protected:
    virtual T_VOID UniciPoddrevo(T_BVOZEL<TIP, N> *vozlisce);

protected:
    T_ROCICAOS kopica_elementov;    // roica zasebne kopice elementov
};


//////////////////////////////////////////////////////////////////////
// RNizP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RNizP : public RElement
{
public:
    // konstruktorji
    RNizP(T_UINT koliko = 0);
    RNizP(TIP element, T_UINT koliko = 1);
    RNizP(const TIP *niz, T_UINT koliko = T_UINT_MAX);
    RNizP(const RNizP<TIP> &niz, T_UINT koliko = T_UINT_MAX);

    // destruktor
    virtual ~RNizP();

    // funkcije za dostop do vsebine
    inline T_UINT VrniDolzino() const;                                              // Vrne tevilo znakov v nizu
    inline T_BOOL JePrazen() const;                                                 // Vrne TRUE, e je niz prazen
    inline T_VOID Sprazni();                                                        // Sprazni niz
    inline TIP VrniZnak(T_UINT indeks) const;                                       // Vrne znak v nizu na izbranem mestu
    inline T_VOID NastaviZnak(T_UINT indeks, TIP znak);                             // Nastavi znak v nizu na izbranem mestu
    inline const TIP* Vrni() const;                                                 // Vrne kazalec na niz (samo za branje)

    inline T_UINT Nastavi(TIP element, T_UINT koliko = 1);                          // Nastavi niz na doloeno tevilo enakih elementov (memset)
    inline T_UINT Nastavi(const TIP *niz, T_UINT koliko = T_UINT_MAX);              // Nastavi niz na doloeno vrednost (memcpy)
    inline T_UINT Nastavi(const RNizP<TIP> &niz, T_UINT koliko = T_UINT_MAX);       // Nastavi niz na doloeno vrednost (memcpy)
    inline T_UINT Prilepi(TIP element, T_UINT koliko = 1);                          // Prilepi nizu doloeno tevilo enakih elementov
    inline T_UINT Prilepi(const TIP *niz, T_UINT koliko = T_UINT_MAX);              // Prilepi nizu doloen niz
    inline T_UINT Prilepi(const RNizP<TIP> &niz, T_UINT koliko = T_UINT_MAX);       // Prilepi nizu doloen niz

    // neposreden dostop do pomnilnika
    inline TIP* Odpusti(T_UINT min_dolzina, T_BOOL ustvari = TRUE);                 // Vrne niz v obdelavo, pri tem naj bo prostora za min_dolzina tevilo znakov (brez zakljuitvenega)
    inline T_UINT Uporabi(TIP *niz, T_UINT koliko = -1, T_BOOL unici = TRUE);       // Uporabi e narejen niz (niz mora biti narejen z uporabo funkcije aalloc())
    inline T_VOID SprostiOdvecne();                                                 // Sprosti neuporabljen pomnilnik na koncu niza

    // funkcije za primerjavo tabel
    inline T_INT Primerjaj(const TIP *niz, T_UINT zacetek = 0, T_UINT koliko = T_UINT_MAX) const;                                                   // Primerja niza
    inline T_INT PrimerjajI(const TIP *niz, T_UINT zacetek = 0, T_UINT koliko = T_UINT_MAX) const;                                                  // Primerja niza
    inline T_INT PrimerjajL(const TIP *niz, T_UINT zacetek = 0, T_UINT koliko = T_UINT_MAX, T_KODALOCALE locale = KODALOCALE_UPORABNIKOV) const;    // Primerja niza (z upotevanjem lokalne abecede)
    inline T_INT PrimerjajLI(const TIP *niz, T_UINT zacetek = 0, T_UINT koliko = T_UINT_MAX, T_KODALOCALE locale = KODALOCALE_UPORABNIKOV) const;   // Primerja niza (z upotevanjem lokalne abecede, brez razlikovanja velikih/malih rk)

    // funkcije za vracanje podtabel
    inline RNizP<TIP> Sredina(T_UINT zacetek, T_UINT koliko = T_UINT_MAX) const;    // Vrne sredino niza
    inline RNizP<TIP> Levo(T_UINT koliko) const;                                    // Vrne levi konec niza
    inline RNizP<TIP> Desno(T_UINT koliko) const;                                   // Vrne desni konec niza

    inline T_VOID Prezrcali();                                                      // Prezrcali niz "Peter" -> "reteP"
    inline T_UINT Zamenjaj(TIP iz, TIP v);                                          // Zamenja vse pojavitve znaka
    inline T_UINT ZamenjajI(TIP iz, TIP v);                                         // Zamenja vse pojavitve znaka (brez razlikovanja velikih/malihcrk)
    inline T_UINT Zamenjaj(const TIP *iz, const TIP *v);                            // Zamenja vse pojavitve niza
    inline T_UINT ZamenjajI(const TIP *iz, const TIP *v);                           // Zamenja vse pojavitve niza (brez razlikovanja velikih/malih rk)
    inline T_UINT Zamenjaj(T_UINT zacetek, T_UINT konec, const TIP *niz, T_UINT koliko = T_UINT_MAX);   // Zamenja vsebino od indeksa zaetek do konec z nizom
    inline T_UINT Odstrani(TIP element);                                            // Odstrani vse pojavitve znaka
    inline T_UINT OdstraniI(TIP znak);                                              // Odstrani vse pojavitve znaka (brez razlikovanja velikih/malih rk)
    inline T_UINT Vstavi(T_UINT zacetek, TIP element, T_UINT koliko = 1);           // Vrine element v niz na doloeno mesto
    inline T_UINT Vstavi(T_UINT zacetek, const TIP *niz, T_UINT koliko = T_UINT_MAX);   // Vrine niz v niz na doloeno mesto
    inline T_UINT Zbrisi(T_UINT zacetek, T_UINT koliko = T_UINT_MAX);               // Izbrie podniz

    inline T_UINT PoravnajLevo(TIP element);                                        // Izbrie vse dane znake na levem koncu
    inline T_UINT PoravnajLevo(const TIP *nabor);                                   // Izbrie vse dane znake iz niza na levem koncu
    inline T_UINT PoravnajDesno(TIP element);                                       // Izbrie vse dane znake na desnem koncu
    inline T_UINT PoravnajDesno(const TIP *nabor);                                  // Izbrie vse dane znake iz niza na desnem koncu
    inline T_UINT Poravnaj(TIP element);                                            // Izbrie vse dane znake na obeh koncih
    inline T_UINT Poravnaj(const TIP *nabor);                                       // Izbrie vse dane znake iz niza na obeh koncih
    inline T_UINT Skrajsaj(T_UINT dolzina);                                         // Skraja niz

    // iskanje po nizu
    inline T_UINT Najdi(TIP element, T_UINT zacetek = 0, T_UINT koliko = T_UINT_MAX) const;             // Iskanje znaka v nizu
    inline T_UINT Najdi(const TIP *niz, T_UINT zacetek = 0, T_UINT koliko = T_UINT_MAX) const;          // Iskanje podniza v nizu
    inline T_UINT NajdiI(TIP element, T_UINT zacetek = 0, T_UINT koliko = T_UINT_MAX) const;            // Iskanje znaka v nizu
    inline T_UINT NajdiI(const TIP *niz, T_UINT zacetek = 0, T_UINT koliko = T_UINT_MAX) const;         // Iskanje podniza v nizu
    inline T_UINT NajdiNazaj(TIP element, T_UINT zacetek = 0, T_UINT koliko = T_UINT_MAX) const;        // Iskanje znaka v nizu nazaj
    inline T_UINT NajdiNazaj(const TIP *niz, T_UINT zacetek = 0, T_UINT koliko = T_UINT_MAX) const;     // Iskanje podniza v nizu nazaj
    inline T_UINT NajdiNazajI(TIP element, T_UINT zacetek = 0, T_UINT koliko = T_UINT_MAX) const;       // Iskanje znaka v nizu nazaj
    inline T_UINT NajdiNazajI(const TIP *niz, T_UINT zacetek = 0, T_UINT koliko = T_UINT_MAX) const;    // Iskanje podniza v nizu nazaj

    // operatorji
    inline TIP& operator [](T_UINT indeks);
    inline TIP& operator [](int indeks);
    inline operator const TIP*() const;

    inline const TIP* operator =(TIP element);
    inline const TIP* operator =(const TIP* niz);
    inline const TIP* operator =(const RNizP<TIP> &niz);

    inline const TIP* operator +=(TIP element);
    inline const TIP* operator +=(const TIP* niz);
    inline const TIP* operator +=(const RNizP<TIP> &niz);

    friend class RNizU;

protected:
    virtual T_STANJE RezervirajDolzino(T_UINT zeljeno, T_BOOL tesno = FALSE);   // Podalja/skraja pomnilnik za podatke
    virtual T_STANJE RezervirajDolzinoQ(T_UINT zeljeno, T_BOOL tesno = FALSE);  // Podalja/skraja pomnilnik za podatke (ne ohrani nujno vsebine podatkov)
    virtual T_VOID Sprosti();

protected:
    TIP     *podatki;   // kazalec na niz
    T_UINT  st_znakov;  // tevilo znakov v nizu
    T_UINT  rez_znakov; // tevilo rezerviranih znakov v nizu
};

template <class TIP> inline T_BOOL operator ==(const RNizP<TIP> &niz1, const RNizP<TIP> &niz2);
template <class TIP> inline T_BOOL operator ==(const RNizP<TIP> &niz1, const       TIP  *niz2);
template <class TIP> inline T_BOOL operator ==(const       TIP  *niz1, const RNizP<TIP> &niz2);
template <class TIP> inline T_BOOL operator !=(const RNizP<TIP> &niz1, const RNizP<TIP> &niz2);
template <class TIP> inline T_BOOL operator !=(const RNizP<TIP> &niz1, const       TIP  *niz2);
template <class TIP> inline T_BOOL operator !=(const       TIP  *niz1, const RNizP<TIP> &niz2);
template <class TIP> inline T_BOOL operator > (const RNizP<TIP> &niz1, const RNizP<TIP> &niz2);
template <class TIP> inline T_BOOL operator > (const RNizP<TIP> &niz1, const       TIP  *niz2);
template <class TIP> inline T_BOOL operator > (const       TIP  *niz1, const RNizP<TIP> &niz2);
template <class TIP> inline T_BOOL operator >=(const RNizP<TIP> &niz1, const RNizP<TIP> &niz2);
template <class TIP> inline T_BOOL operator >=(const RNizP<TIP> &niz1, const       TIP  *niz2);
template <class TIP> inline T_BOOL operator >=(const       TIP  *niz1, const RNizP<TIP> &niz2);
template <class TIP> inline T_BOOL operator < (const RNizP<TIP> &niz1, const RNizP<TIP> &niz2);
template <class TIP> inline T_BOOL operator < (const RNizP<TIP> &niz1, const       TIP  *niz2);
template <class TIP> inline T_BOOL operator < (const       TIP  *niz1, const RNizP<TIP> &niz2);
template <class TIP> inline T_BOOL operator <=(const RNizP<TIP> &niz1, const RNizP<TIP> &niz2);
template <class TIP> inline T_BOOL operator <=(const RNizP<TIP> &niz1, const       TIP  *niz2);
template <class TIP> inline T_BOOL operator <=(const       TIP  *niz1, const RNizP<TIP> &niz2);
inline VARIANT& operator <<(VARIANT &p, const RNizP<T_AZNAK> &dat);
inline VARIANT& operator <<(VARIANT &p, const RNizP<T_UZNAK> &dat);
template <class TOK> inline TOK& operator >>(TOK &tok, RNizP<T_AZNAK> &podatek);
template <class TOK> inline TOK& operator >>(TOK &tok, RNizP<T_UZNAK> &podatek);


//////////////////////////////////////////////////////////////////////
// RNizNP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RNizNP : public RNizP<TIP>
{
public:
    // konstruktorji
    RNizNP(T_UINT koliko = 0);
    RNizNP(TIP element, T_UINT koliko = 1);
    RNizNP(const TIP *niz, T_UINT koliko = T_UINT_MAX);
    RNizNP(const RNizP<TIP> &niz, T_UINT koliko = T_UINT_MAX);

    inline T_VOID VVelike();            // Pretvori niz v same velike rke
    inline T_VOID VMale();              // Pretvori niz v same male rke

    inline T_UINT PoravnajLevo();       // Izbrie vse neizpisljive znake (presledke, tabulatorje) na levem koncu
    inline T_UINT PoravnajDesno();      // Izbrie vse neizpisljive znake (presledke, tabulatorje) na desnem koncu
    inline T_UINT Poravnaj();           // Izbrie vse neizpisljive znake (presledke, tabulatorje) na obeh koncih
};


//////////////////////////////////////////////////////////////////////
// RNizOP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RNizOP : public RNizNP<TIP>
{
public:
    // konstruktorji
    RNizOP(T_UINT koliko = 0);
    RNizOP(TIP element, T_UINT koliko = 1);
    RNizOP(const TIP *niz, T_UINT koliko = T_UINT_MAX);
    RNizOP(const RNizP<TIP> &niz, T_UINT koliko = T_UINT_MAX);

    // transformacije nad nizom
    inline T_UINT Oblikuj(const TIP *oblika, T_LOCALE locale, ...);                                          // Oblikuje niz (sprintf)
    inline T_UINT OblikujP(const TIP *oblika, T_LOCALE locale, va_list parametri);                           // Oblikuje niz (vsprintf)
    static RNizOP<TIP> OblikujS(const TIP *oblika, T_LOCALE locale, ...);                                    // Oblikuje niz (sprintf)
    inline static RNizOP<TIP> OblikujSP(const TIP *oblika, T_LOCALE locale, va_list parametri);              // Oblikuje niz (vsprintf)
    inline T_UINT PrilepiO(const TIP *oblika, T_LOCALE locale, ...);                                         // Prilepi oblikovan niz (sprintf)
    inline T_UINT PrilepiOP(const TIP *oblika, T_LOCALE locale, va_list parametri);                          // Prilepi oblikovan niz (vsprintf)
#ifndef _DLL
    inline T_UINT Razcleni(const TIP *oblika, T_LOCALE locale, ...) const;                                   // Razleni niz (sscanf)
    inline T_UINT RazcleniP(const TIP *oblika, T_LOCALE locale, va_list parametri) const;                    // Razleni niz (vsscanf)
    inline T_UINT RazcleniOd(const TIP *oblika, T_UINT zacetek, T_LOCALE locale, ...) const;                 // Razleni niz od danega znaka naprej (sscanf)
    inline T_UINT RazcleniOdP(const TIP *oblika, T_UINT zacetek, T_LOCALE locale, va_list parametri) const;  // Razleni niz od danega znaka naprej (vsscanf)
#endif
};


//////////////////////////////////////////////////////////////////////
// RNizVP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RNizVP : public RNizOP<TIP>
{
public:
    // konstruktorji
    RNizVP(T_UINT koliko = 0);
    RNizVP(TIP element, T_UINT koliko = 1);
    RNizVP(const TIP *niz, T_UINT koliko = T_UINT_MAX);
    RNizVP(const RNizP<TIP> &niz, T_UINT koliko = T_UINT_MAX);
    RNizVP(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik = AOSN_PRIVZETI_JEZIK);

    inline T_UINT NastaviV(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik = AOSN_PRIVZETI_JEZIK);                                            // Nalozi niz iz virov
    inline T_UINT PrilepiV(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik = AOSN_PRIVZETI_JEZIK);                                            // Prilepi niz iz virov
    inline T_UINT OblikujV(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_LOCALE locale, ...);                                            // Oblikuje niz iz virov (sprintf)
    inline T_UINT OblikujVP(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_LOCALE locale, va_list parametri);                             // Oblikuje niz iz virov (vsprintf)
    inline static RNizVP<TIP> OblikujVS(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_LOCALE locale, ...);                               // Oblikuje niz iz virov (sprintf)
    inline static RNizVP<TIP> OblikujVSP(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_LOCALE locale, va_list parametri);                // Oblikuje niz iz virov (vsprintf)
    inline T_UINT PrilepiVO(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_LOCALE locale, ...);                                           // Prilepi oblikovan niz iz virov (sprintf)
    inline T_UINT PrilepiVOP(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_LOCALE locale, va_list parametri);                            // Prilepi oblikovan niz iz virov (vsprintf)
#ifndef _DLL
    inline T_UINT RazcleniV(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_LOCALE locale, ...) const;                                     // Razleni niz iz virov (sscanf)
    inline T_UINT RazcleniVP(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_LOCALE locale, va_list parametri) const;                      // Razleni niz iz virov (vsscanf)
    inline T_UINT RazcleniOdV(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_UINT zacetek, T_LOCALE locale, ...) const;                   // Razleni niz iz virov od danega znaka naprej (sscanf)
    inline T_UINT RazcleniOdVP(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_UINT zacetek, T_LOCALE locale, va_list parametri) const;    // Razleni niz iz virov od danega znaka naprej (vsscanf)
#endif
};


//////////////////////////////////////////////////////////////////////
// RNizA
//////////////////////////////////////////////////////////////////////

#pragma warning(push)
#pragma warning(disable: 4275)

class AOSN_CLASS RNizA : public RNizVP<T_AZNAK>
{
public:
    // konstruktorji
    RNizA(T_UINT koliko = 0);
    RNizA(T_AZNAK znak, T_UINT koliko = 1);
    RNizA(T_UZNAK znak, T_UINT koliko = 1, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);
    RNizA(TK_ASCII niz, T_UINT koliko = T_UINT_MAX);
    RNizA(TK_UNICODE niz, T_UINT koliko = T_UINT_MAX, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);
    RNizA(const RNizP<T_AZNAK> &niz, T_UINT koliko = T_UINT_MAX);
    RNizA(const RNizP<T_UZNAK> &niz, T_UINT koliko = T_UINT_MAX, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);
    RNizA(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik = AOSN_PRIVZETI_JEZIK, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);

    // funkcije za dostop do vsebine
    inline T_UINT NastaviU(T_UZNAK znak, T_UINT koliko = 1, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);                                           // Nastavi niz na doloeno tevilo enakih znakov (memset)
    inline T_UINT NastaviU(TK_UNICODE niz, T_UINT koliko = T_UINT_MAX, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);                                // Nastavi niz na doloeno vrednost (memcpy)
    inline T_UINT NastaviU(const RNizP<T_UZNAK> &niz, T_UINT koliko = T_UINT_MAX, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);                     // Nastavi niz na doloeno vrednost (memcpy)
    inline T_UINT NastaviVU(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik = AOSN_PRIVZETI_JEZIK, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);    // Naloi niz iz virov
    inline T_UINT PrilepiU(T_UZNAK znak, T_UINT koliko = 1, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);                                           // Prilepi nizu doloeno tevilo enakih znakov
    inline T_UINT PrilepiU(TK_UNICODE niz, T_UINT koliko = T_UINT_MAX, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);                                // Prilepi nizu doloen niz
    inline T_UINT PrilepiU(const RNizP<T_UZNAK> &niz, T_UINT koliko = T_UINT_MAX, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);                     // Prilepi nizu doloen niz
    inline T_UINT PrilepiVU(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik = AOSN_PRIVZETI_JEZIK, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);   // Prilepi niz iz virov

#ifndef AOSN_BREZ_SGML
    inline T_UINT NastaviSGML(TK_ASCII sgml, T_UINT koliko = T_UINT_MAX, T_UINT kateri = 0, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);           // Nastavi niz na doloeno vrednost
    inline T_UINT PrilepiSGML(TK_ASCII sgml, T_UINT koliko = T_UINT_MAX, T_UINT kateri = 0, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);           // Prilepi nizu doloen niz
#endif
    inline T_UINT NastaviUTF8(TK_ASCII utf8, T_UINT koliko = T_UINT_MAX, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);                              // Nastavi niz na doloeno vrednost
    T_UINT PrilepiUTF8(TK_ASCII utf8, T_UINT koliko = T_UINT_MAX, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);                                     // Prilepi nizu doloen niz

    BSTR VrniBSTR(T_UINT koliko = T_UINT_MAX, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP) const;                                                   // Vrne niz BSTR - ko ve ne rabi, sprosti s SysFreeString()!

#ifndef AOSN_BREZ_SGML
    inline RNizA VrniSGML(T_UINT koliko = T_UINT_MAX, T_UINT kateri = 0, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP) const;                        // Vrne niz SGML
    static RNizA VrniSGML(TK_ASCII niz, T_UINT koliko = T_UINT_MAX, T_UINT kateri = 0, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);                // Vrne niz SGML
#endif
    inline RNizA VrniUTF8(T_UINT koliko = T_UINT_MAX, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP) const;                                           // Vrne niz UTF8
    static RNizA VrniUTF8(TK_ASCII niz, T_UINT koliko = T_UINT_MAX, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);                                   // Vrne niz UTF8
    static RNizA VrniHEX(TK_KAZALEC pom, T_SIZE dolzina);                                                                                           // Vrne zapis HEX binarnih podatkov

    inline T_UINT OblikujVU(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_KODNASTRAN kodna_stran, T_LOCALE locale, ...);                          // Oblikuje niz iz virov (sprintf)
    inline static RNizA OblikujVUS(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_KODNASTRAN kodna_stran, T_LOCALE locale, ...);                   // Oblikuje niz iz virov (sprintf)
    inline T_UINT PrilepiVUO(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_KODNASTRAN kodna_stran, T_LOCALE locale, ...);                         // Prilepi oblikovan niz iz virov (sprintf)
#ifndef _DLL
    inline T_UINT RazcleniVU(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_KODNASTRAN kodna_stran, T_LOCALE locale, ...) const;                   // Razleni niz iz virov (sscanf)
    inline T_UINT RazcleniOdVU(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_KODNASTRAN kodna_stran, T_UINT zacetek, T_LOCALE locale, ...) const; // Razleni niz iz virov od danega znaka dalje (sscanf)
#endif
    inline T_UINT OblikujVUP(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_KODNASTRAN kodna_stran, T_LOCALE locale, va_list parametri);           // Oblikuje niz iz virov (vsprintf)
    inline static RNizA OblikujVUSP(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_KODNASTRAN kodna_stran, T_LOCALE locale, va_list parametri);    // Oblikuje niz iz virov (vsprintf)
    inline T_UINT PrilepiVUOP(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_KODNASTRAN kodna_stran, T_LOCALE locale, va_list parametri);          // Prilepi oblikovan niz iz virov (vsprintf)
#ifndef _DLL
    inline T_UINT RazcleniVUP(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_KODNASTRAN kodna_stran, T_LOCALE locale, va_list parametri) const;    // Razleni niz iz virov (vsscanf)
    inline T_UINT RazcleniOdVUP(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_KODNASTRAN kodna_stran, T_UINT zacetek, T_LOCALE locale, va_list parametri) const;  // Razleni niz iz virov od danega znaka dalje (vsscanf)
#endif

    // funkcije za vracanje podnizov
    inline RNizA Sredina(T_UINT zacetek, T_UINT koliko = T_UINT_MAX) const;                                                             // Vrne sredino niza
    inline RNizA Levo(T_UINT koliko) const;                                                                                             // Vrne levi konec niza
    inline RNizA Desno(T_UINT koliko) const;                                                                                            // Vrne desni konec niza

    inline T_UINT PretvoriCRLFvNL();                                                                                                    // Pretvori CR-LF v '\n'
    inline T_UINT PretvoriLFCRvNL();                                                                                                    // Pretvori LF-CR v '\n'
    inline T_UINT PretvoriNLvCRLF();                                                                                                    // Pretvori '\n' v CR-LF
    inline T_UINT PretvoriNLvLFCR();                                                                                                    // Pretvori '\n' v CR-LF

    // operatorji
    inline TK_ASCII operator =(T_AZNAK znak);
    inline TK_ASCII operator =(T_UZNAK znak);
    inline TK_ASCII operator =(TK_ASCII niz);
    inline TK_ASCII operator =(TK_UNICODE niz);
    inline TK_ASCII operator =(const RNizP<T_AZNAK> &niz);
    inline TK_ASCII operator =(const RNizP<T_UZNAK> &niz);

    inline TK_ASCII operator +=(T_AZNAK znak);
    inline TK_ASCII operator +=(T_UZNAK znak);
    inline TK_ASCII operator +=(TK_ASCII niz);
    inline TK_ASCII operator +=(TK_UNICODE niz);
    inline TK_ASCII operator +=(const RNizP<T_AZNAK> &niz);
    inline TK_ASCII operator +=(const RNizP<T_UZNAK> &niz);
};

#pragma warning(pop)


//////////////////////////////////////////////////////////////////////
// RNizU
//////////////////////////////////////////////////////////////////////

#pragma warning(push)
#pragma warning(disable: 4275)

class AOSN_CLASS RNizU : public RNizVP<T_UZNAK>
{
public:
    // konstruktorji
    RNizU(T_UINT koliko = 0);
    RNizU(T_AZNAK znak, T_UINT koliko = 1, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);
    RNizU(T_UZNAK znak, T_UINT koliko = 1);
    RNizU(TK_ASCII niz, T_UINT koliko = T_UINT_MAX, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);
    RNizU(TK_UNICODE niz, T_UINT koliko = T_UINT_MAX);
    RNizU(const RNizP<T_AZNAK> &niz, T_UINT koliko = T_UINT_MAX, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);
    RNizU(const RNizP<T_UZNAK> &niz, T_UINT koliko = T_UINT_MAX);
    RNizU(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik = AOSN_PRIVZETI_JEZIK);

    // funkcije za dostop do vsebine
    inline T_UINT NastaviA(T_AZNAK znak, T_UINT koliko = 1, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);                           // Nastavi niz na doloeno tevilo enakih znakov (memset)
    inline T_UINT NastaviA(TK_ASCII niz, T_UINT koliko = T_UINT_MAX, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);                  // Nastavi niz na doloeno vrednost (memcpy)
    inline T_UINT NastaviA(const RNizP<T_AZNAK> &niz, T_UINT koliko = T_UINT_MAX, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);     // Nastavi niz na doloeno vrednost (memcpy)
    inline T_UINT PrilepiA(T_AZNAK znak, T_UINT koliko = 1, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);                           // Prilepi nizu doloeno tevilo enakih znakov
    inline T_UINT PrilepiA(TK_ASCII niz, T_UINT koliko = T_UINT_MAX, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);                  // Prilepi nizu doloen niz
    inline T_UINT PrilepiA(const RNizP<T_AZNAK> &niz, T_UINT koliko = T_UINT_MAX, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);     // Prilepi nizu doloen niz

#ifndef AOSN_BREZ_SGML
    inline T_UINT NastaviSGML(TK_ASCII sgml, T_UINT koliko = T_UINT_MAX, T_UINT kateri = 0);                                        // Nastavi niz na doloeno vrednost
    inline T_UINT NastaviSGML(TK_UNICODE sgml, T_UINT koliko = T_UINT_MAX, T_UINT kateri = 0);                                      // Nastavi niz na doloeno vrednost
    inline T_UINT PrilepiSGML(TK_ASCII sgml, T_UINT koliko = T_UINT_MAX, T_UINT kateri = 0);                                        // Prilepi nizu doloen niz
    inline T_UINT PrilepiSGML(TK_UNICODE sgml, T_UINT koliko = T_UINT_MAX, T_UINT kateri = 0);                                      // Prilepi nizu doloen niz
#endif
    inline T_UINT NastaviUTF8(TK_ASCII utf8, T_UINT koliko = T_UINT_MAX);                                                           // Nastavi niz na doloeno vrednost
    inline T_UINT PrilepiUTF8(TK_ASCII utf8, T_UINT koliko = T_UINT_MAX);                                                           // Prilepi nizu doloen niz
    inline T_UINT NastaviURLEncoded(TK_ASCII urlencoded, T_UINT koliko = T_UINT_MAX, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);  // Nastavi niz na doloeno vrednost
    T_UINT PrilepiURLEncoded(TK_ASCII urlencoded, T_UINT koliko = T_UINT_MAX, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);         // Prilepi nizu doloen niz

    BSTR VrniBSTR(T_UINT koliko = T_UINT_MAX) const;                                                                                // Vrne niz BSTR - ko ve ne rabi, sprosti s SysFreeString()!

#ifndef AOSN_BREZ_SGML
    inline RNizA VrniSGML(T_UINT koliko = T_UINT_MAX, T_UINT kateri = 0) const;                                                     // Vrne niz SGML
    static RNizA VrniSGML(TK_UNICODE niz, T_UINT koliko = T_UINT_MAX, T_UINT kateri = 0);                                           // Vrne niz SGML
#endif
    inline RNizA VrniUTF8(T_UINT koliko = T_UINT_MAX) const;                                                                        // Vrne niz UTF8
    static RNizA VrniUTF8(TK_UNICODE niz, T_UINT koliko = T_UINT_MAX);                                                              // Vrne niz UTF8

    // funkcije za vracanje podnizov
    inline RNizU Sredina(T_UINT zacetek, T_UINT koliko = T_UINT_MAX) const;                                                         // Vrne sredino niza
    inline RNizU Levo(T_UINT koliko) const;                                                                                         // Vrne levi konec niza
    inline RNizU Desno(T_UINT koliko) const;                                                                                        // Vrne desni konec niza

    inline T_UINT PretvoriCRLFvNL();                                                                                                // Pretvori CR-LF v '\n'
    inline T_UINT PretvoriLFCRvNL();                                                                                                // Pretvori LF-CR v '\n'
    inline T_UINT PretvoriNLvCRLF();                                                                                                // Pretvori '\n' v CR-LF
    inline T_UINT PretvoriNLvLFCR();                                                                                                // Pretvori '\n' v CR-LF

    // operatorji
    inline TK_UNICODE operator =(T_AZNAK znak);
    inline TK_UNICODE operator =(T_UZNAK znak);
    inline TK_UNICODE operator =(TK_ASCII niz);
    inline TK_UNICODE operator =(TK_UNICODE niz);
    inline TK_UNICODE operator =(const RNizP<T_AZNAK> &niz);
    inline TK_UNICODE operator =(const RNizP<T_UZNAK> &niz);

    inline TK_UNICODE operator +=(T_AZNAK znak);
    inline TK_UNICODE operator +=(T_UZNAK znak);
    inline TK_UNICODE operator +=(TK_ASCII niz);
    inline TK_UNICODE operator +=(TK_UNICODE niz);
    inline TK_UNICODE operator +=(const RNizP<T_AZNAK> &niz);
    inline TK_UNICODE operator +=(const RNizP<T_UZNAK> &niz);
};

#pragma warning(pop)


#ifdef AOSN_REGIZR

#pragma warning(disable: 4505)
#pragma warning(push)
#pragma warning(disable: 4251)
#if _MSC_VER < 1300
#pragma warning(disable: 4275)
#pragma warning(disable: 4786)
#endif


//////////////////////////////////////////////////////////////////////
// RRegElementP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElementP : public RElement
{
public:
    RRegElementP();

    T_BOOL Isci(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO) = 0;
    virtual T_VOID Razveljavi();
    virtual T_VOID Unici();

public:
    T_INTERVAL<T_UINT> interval;    // interval ujemanja, ki ga bomo nastavili z zadetkom
};


//////////////////////////////////////////////////////////////////////
// RRegElZbirkaP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElZbirkaP : public RRegElementP<TIP>
{
public:
    RRegElZbirkaP(RRegElementP<TIP> *el[] = NULL, T_UINT stevilo = 0);
    RRegElZbirkaP(RRegElementP<TIP> *el, ...);

    virtual T_VOID Razveljavi();
    virtual T_VOID Unici();

protected:
    T_VOID ZgradiTabelo(RRegElementP<TIP> *el[], T_UINT stevilo);
    T_VOID ZgradiTabelo(RRegElementP<TIP> *el, va_list parametri);

protected:
    RDinTabela<RRegElementP<TIP>*> tab;    // tabela zaporednih elementov
};


//////////////////////////////////////////////////////////////////////
// RRegElNOPP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElNOPP : public RRegElementP<TIP>
{
public:
    RRegElNOPP();

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
};


//////////////////////////////////////////////////////////////////////
// RRegElPoljubenZnakP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElPoljubenZnakP : public RRegElementP<TIP>
{
public:
    RRegElPoljubenZnakP();

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
};


//////////////////////////////////////////////////////////////////////
// RRegElPoljubenZnakSGML
//////////////////////////////////////////////////////////////////////

#ifndef AOSN_BREZ_SGML

class AOSN_CLASS RRegElPoljubenZnakSGML : public RRegElPoljubenZnakP<T_AZNAK>
{
public:
    virtual T_BOOL PreveriUjemanje(const T_AZNAK *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
};

#endif


//////////////////////////////////////////////////////////////////////
// RRegElZnakP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElZnakP : public RRegElementP<TIP>
{
public:
    RRegElZnakP(TIP znak, T_BOOL je_negirano = FALSE);

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);

protected:
    T_UZNAK znak;
    T_BOOL je_negirano;
};


//////////////////////////////////////////////////////////////////////
// RRegElZnakSGML
//////////////////////////////////////////////////////////////////////

#ifndef AOSN_BREZ_SGML

class AOSN_CLASS RRegElZnakSGML : public RRegElementP<T_AZNAK>
{
public:
    RRegElZnakSGML(TK_ASCII znak, T_UINT dolzina = T_UINT_MAX, T_BOOL je_negirano = FALSE);

    virtual T_BOOL PreveriUjemanje(const T_AZNAK *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);

protected:
    RNizU znak;
    T_BOOL je_negirano;
};

#endif


//////////////////////////////////////////////////////////////////////
// RRegElAlfanumericniZnakP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElAlfanumericniZnakP : public RRegElementP<TIP>
{
public:
    RRegElAlfanumericniZnakP(T_BOOL je_negirano = FALSE);

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);

protected:
    T_BOOL je_negirano;
};


//////////////////////////////////////////////////////////////////////
// RRegElAlfanumericniZnakSGML
//////////////////////////////////////////////////////////////////////

#ifndef AOSN_BREZ_SGML

class AOSN_CLASS RRegElAlfanumericniZnakSGML : public RRegElAlfanumericniZnakP<T_AZNAK>
{
public:
    virtual T_BOOL PreveriUjemanje(const T_AZNAK *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
};

#endif


//////////////////////////////////////////////////////////////////////
// RRegElPresledekP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElPresledekP : public RRegElementP<TIP>
{
public:
    RRegElPresledekP(T_BOOL je_negirano = FALSE);

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);

protected:
    T_BOOL je_negirano;
};


//////////////////////////////////////////////////////////////////////
// RRegElPresledekSGML
//////////////////////////////////////////////////////////////////////

#ifndef AOSN_BREZ_SGML

class AOSN_CLASS RRegElPresledekSGML : public RRegElPresledekP<T_AZNAK>
{
public:
    virtual T_BOOL PreveriUjemanje(const T_AZNAK *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
};

#endif


//////////////////////////////////////////////////////////////////////
// RRegElLociloP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElLociloP : public RRegElementP<TIP>
{
public:
    RRegElLociloP(T_BOOL je_negirano = FALSE);

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);

protected:
    T_BOOL je_negirano;
};


//////////////////////////////////////////////////////////////////////
// RRegElLociloSGML
//////////////////////////////////////////////////////////////////////

#ifndef AOSN_BREZ_SGML

class AOSN_CLASS RRegElLociloSGML : public RRegElLociloP<T_AZNAK>
{
public:
    virtual T_BOOL PreveriUjemanje(const T_AZNAK *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
};

#endif


//////////////////////////////////////////////////////////////////////
// RRegElPresledekAliLociloP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElPresledekAliLociloP : public RRegElementP<TIP>
{
public:
    RRegElPresledekAliLociloP(T_BOOL je_negirano = FALSE);

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);

protected:
    T_BOOL je_negirano;
};


//////////////////////////////////////////////////////////////////////
// RRegElPresledekAliLociloSGML
//////////////////////////////////////////////////////////////////////

#ifndef AOSN_BREZ_SGML

class AOSN_CLASS RRegElPresledekAliLociloSGML : public RRegElPresledekAliLociloP<T_AZNAK>
{
public:
    virtual T_BOOL PreveriUjemanje(const T_AZNAK *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
};

#endif


//////////////////////////////////////////////////////////////////////
// RRegElZacetekVrsticeP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElZacetekVrsticeP : public RRegElementP<TIP>
{
public:
    RRegElZacetekVrsticeP(T_BOOL je_negirano = FALSE);

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);

protected:
    T_BOOL je_negirano;
};


//////////////////////////////////////////////////////////////////////
// RRegElKonecVrsticeP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElKonecVrsticeP : public RRegElementP<TIP>
{
public:
    RRegElKonecVrsticeP(T_BOOL je_negirano = FALSE);

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);

protected:
    T_BOOL je_negirano;
};


//////////////////////////////////////////////////////////////////////
// RRegElZacetekBesedeP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElZacetekBesedeP : public RRegElementP<TIP>
{
public:
    RRegElZacetekBesedeP(T_UINT zastavice = RREGIZR_LOCILO_BESED_PRESLEDKI, T_BOOL je_negirano = FALSE);

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);

protected:
    T_UINT zastavice;
    T_BOOL je_negirano;
};


//////////////////////////////////////////////////////////////////////
// RRegElZacetekBesedeSGML
//////////////////////////////////////////////////////////////////////

#ifndef AOSN_BREZ_SGML

class AOSN_CLASS RRegElZacetekBesedeSGML : public RRegElZacetekBesedeP<T_AZNAK>
{
public:
    virtual T_BOOL PreveriUjemanje(const T_AZNAK *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
};

#endif


//////////////////////////////////////////////////////////////////////
// RRegElKonecBesedeP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElKonecBesedeP : public RRegElementP<TIP>
{
public:
    RRegElKonecBesedeP(T_UINT zastavice = RREGIZR_LOCILO_BESED_PRESLEDKI, T_BOOL je_negirano = FALSE);

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);

protected:
    T_UINT zastavice;
    T_BOOL je_negirano;
};


//////////////////////////////////////////////////////////////////////
// RRegElKonecBesedeSGML
//////////////////////////////////////////////////////////////////////

#ifndef AOSN_BREZ_SGML

class AOSN_CLASS RRegElKonecBesedeSGML : public RRegElKonecBesedeP<T_AZNAK>
{
public:
    virtual T_BOOL PreveriUjemanje(const T_AZNAK *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
};

#endif


//////////////////////////////////////////////////////////////////////
// RRegElMaskaOsnP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElMaskaOsnP : public RRegElementP<TIP>
{
public:
    RRegElMaskaOsnP(T_BOOL je_negirano = FALSE);

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO) = NULL;
    virtual T_VOID Razveljavi();

public:
    T_UINT odmik_zadetka;

protected:
    T_BOOL je_negirano;
};


//////////////////////////////////////////////////////////////////////
// RRegElMaskaP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElMaskaP : public RRegElMaskaOsnP<TIP>
{
public:
    RRegElMaskaP(const TIP *maska, T_UINT dolzina = T_UINT_MAX, T_BOOL je_negirano = FALSE);

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);

protected:
    RNizP<TIP> maska;
};


//////////////////////////////////////////////////////////////////////
// RRegElMaskaSGML
//////////////////////////////////////////////////////////////////////

#ifndef AOSN_BREZ_SGML

class AOSN_CLASS RRegElMaskaSGML : public RRegElMaskaOsnP<T_AZNAK>
{
public:
    RRegElMaskaSGML(TK_ASCII maska, T_UINT dolzina = T_UINT_MAX, T_BOOL je_negirano = FALSE);

    virtual T_BOOL PreveriUjemanje(const T_AZNAK *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);

protected:
    RNizU maska;
};

#endif


//////////////////////////////////////////////////////////////////////
// RRegElNizP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElNizP : public RRegElementP<TIP>
{
public:
    RRegElNizP(const TIP *niz, T_UINT dolzina = T_UINT_MAX);

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);

protected:
    RNizP<TIP> niz;
};


//////////////////////////////////////////////////////////////////////
// RRegElNizSGML
//////////////////////////////////////////////////////////////////////

#ifndef AOSN_BREZ_SGML

class AOSN_CLASS RRegElNizSGML : public RRegElementP<T_AZNAK>
{
public:
    RRegElNizSGML(TK_ASCII niz, T_UINT dolzina = T_UINT_MAX);

    virtual T_BOOL PreveriUjemanje(const T_AZNAK *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);

protected:
    RNizU niz;
};

#endif


//////////////////////////////////////////////////////////////////////
// RRegElPonavljanjeP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElPonavljanjeP : public RRegElementP<TIP>
{
public:
    RRegElPonavljanjeP(RRegElementP<TIP> *el, T_UINT min_iteracij = 0, T_UINT max_iteracij = T_UINT_MAX, T_BOOL je_pozresno = TRUE);

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
    virtual T_VOID Razveljavi();
    virtual T_VOID Unici();

protected:
    RRegElementP<TIP> *el;  // element, ki se mora ponavljati
    T_UINT min_iteracij;    // najmanje tevilo ponovitev
    T_UINT max_iteracij;    // najveje tevilo ponovitev
    T_BOOL je_pozresno;     // ali skuamo najti najdalji moni niz
};


//////////////////////////////////////////////////////////////////////
// RRegElZaporedjeP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElZaporedjeP : public RRegElZbirkaP<TIP>
{
public:
    RRegElZaporedjeP(RRegElementP<TIP> *el[] = NULL, T_UINT stevilo = 0);
    RRegElZaporedjeP(RRegElementP<TIP> *el, ...);

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
};


//////////////////////////////////////////////////////////////////////
// RRegElVejitevP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElVejitevP : public RRegElZbirkaP<TIP>
{
public:
    RRegElVejitevP(RRegElementP<TIP> *el[] = NULL, T_UINT stevilo = 0);
    RRegElVejitevP(RRegElementP<TIP> *el, ...);

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
    virtual T_VOID Razveljavi();

public:
    T_UINT odmik_zadetka;
};


//////////////////////////////////////////////////////////////////////
// RRegElVejitevNizovP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElVejitevNizovP : public RRegElVejitevP<TIP>
{
public:
    RRegElVejitevNizovP(const TIP *niziz = NULL, T_UINT dolzina = 0);
    RRegElVejitevNizovP(const TIP *niz, ...);
    virtual ~RRegElVejitevNizovP();

protected:
    T_VOID ZgradiTabelo(const TIP *niziz, T_UINT dolzina);
    T_VOID ZgradiTabelo(const TIP *niz, va_list parametri);
};


//////////////////////////////////////////////////////////////////////
// RRegElVejitevNizovSGML
//////////////////////////////////////////////////////////////////////

#ifndef AOSN_BREZ_SGML

class AOSN_CLASS RRegElVejitevNizovSGML : public RRegElVejitevP<T_AZNAK>
{
public:
    RRegElVejitevNizovSGML(TK_ASCII niziz = NULL, T_UINT dolzina = 0);
    RRegElVejitevNizovSGML(TK_ASCII niz, ...);
    virtual ~RRegElVejitevNizovSGML();

protected:
    T_VOID ZgradiTabelo(TK_ASCII niziz, T_UINT dolzina);
    T_VOID ZgradiTabelo(TK_ASCII niz, va_list parametri);
};

#endif


//////////////////////////////////////////////////////////////////////
// RRegElPermutacijaP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElPermutacijaP : public RRegElZbirkaP<TIP>
{
public:
    RRegElPermutacijaP(RRegElementP<TIP> *el[] = NULL, T_UINT stevilo = 0);
    RRegElPermutacijaP(RRegElementP<TIP> *el, ...);

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);

protected:
    T_BOOL PreveriUjemanjeRek(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
};


//////////////////////////////////////////////////////////////////////
// RRegElStevnikCeliP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElStevnikCeliP : public RRegElementP<TIP>
{
public:
    RRegElStevnikCeliP();

    virtual T_VOID Razveljavi();

public:
    T_UINT vrednost;   // izraunana vrednost tevnika
};


//////////////////////////////////////////////////////////////////////
// RRegElStevnikCeli10P
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElStevnikCeli10P : public RRegElStevnikCeliP<TIP>
{
public:
    RRegElStevnikCeli10P(
        RRegElementP<TIP> *stevka_0,
        RRegElementP<TIP> *stevka_1,
        RRegElementP<TIP> *stevka_2,
        RRegElementP<TIP> *stevka_3,
        RRegElementP<TIP> *stevka_4,
        RRegElementP<TIP> *stevka_5,
        RRegElementP<TIP> *stevka_6,
        RRegElementP<TIP> *stevka_7,
        RRegElementP<TIP> *stevka_8,
        RRegElementP<TIP> *stevka_9);

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
    virtual T_VOID Unici();

protected:
    RRegElementP<TIP>
        *stevka_0,
        *stevka_1,
        *stevka_2,
        *stevka_3,
        *stevka_4,
        *stevka_5,
        *stevka_6,
        *stevka_7,
        *stevka_8,
        *stevka_9;
};


//////////////////////////////////////////////////////////////////////
// RRegElStevnikCeli10LTP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElStevnikCeli10LTP : public RRegElStevnikCeliP<TIP>
{
public:
    RRegElStevnikCeli10LTP(RRegElStevnikCeli10P<TIP> *stevke, RRegElMaskaOsnP<TIP> *locilo);

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
    virtual T_VOID Razveljavi();
    virtual T_VOID Unici();

public:
    T_UINT st_mest;             // tevilo cifer v tevniku
    T_BOOL uporablja_locila;    // logina spremenljivka, ki doloa, ali je tevnik zapisan z loili ali brez

protected:
    RRegElStevnikCeli10P<TIP> *stevke;
    RRegElMaskaOsnP<TIP>      *locilo;
};


//////////////////////////////////////////////////////////////////////
// RRegElStevnikCeli16P
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElStevnikCeli16P : public RRegElStevnikCeliP<TIP>
{
public:
    RRegElStevnikCeli16P(
        RRegElementP<TIP> *stevka_0,
        RRegElementP<TIP> *stevka_1,
        RRegElementP<TIP> *stevka_2,
        RRegElementP<TIP> *stevka_3,
        RRegElementP<TIP> *stevka_4,
        RRegElementP<TIP> *stevka_5,
        RRegElementP<TIP> *stevka_6,
        RRegElementP<TIP> *stevka_7,
        RRegElementP<TIP> *stevka_8,
        RRegElementP<TIP> *stevka_9,
        RRegElementP<TIP> *stevka_10,
        RRegElementP<TIP> *stevka_11,
        RRegElementP<TIP> *stevka_12,
        RRegElementP<TIP> *stevka_13,
        RRegElementP<TIP> *stevka_14,
        RRegElementP<TIP> *stevka_15);

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
    virtual T_VOID Unici();

protected:
        RRegElementP<TIP>
            *stevka_0,
            *stevka_1,
            *stevka_2,
            *stevka_3,
            *stevka_4,
            *stevka_5,
            *stevka_6,
            *stevka_7,
            *stevka_8,
            *stevka_9,
            *stevka_10,
            *stevka_11,
            *stevka_12,
            *stevka_13,
            *stevka_14,
            *stevka_15;
};


//////////////////////////////////////////////////////////////////////
// RRegElStevnikRimskiP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElStevnikRimskiP : public RRegElStevnikCeliP<TIP>
{
public:
    RRegElStevnikRimskiP(
        RRegElementP<TIP> *stevka_1,
        RRegElementP<TIP> *stevka_5,
        RRegElementP<TIP> *stevka_10,
        RRegElementP<TIP> *stevka_50,
        RRegElementP<TIP> *stevka_100,
        RRegElementP<TIP> *stevka_500,
        RRegElementP<TIP> *stevka_1000,
        RRegElementP<TIP> *stevka_5000,
        RRegElementP<TIP> *stevka_10000);

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
    virtual T_VOID Unici();

protected:
    RRegElementP<TIP>
        *stevka_1,
        *stevka_5,
        *stevka_10,
        *stevka_50,
        *stevka_100,
        *stevka_500,
        *stevka_1000,
        *stevka_5000,
        *stevka_10000;
};


//////////////////////////////////////////////////////////////////////
// RRegElUlomekP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElUlomekP : public RRegElementP<TIP>
{
public:
    RRegElUlomekP(RRegElementP<TIP> *stevec, RRegElementP<TIP> *ulomkova_crta, RRegElementP<TIP> *imenovalec);

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
    virtual T_VOID Razveljavi();
    virtual T_VOID Unici();

public:
    RRegElementP<TIP> *stevec;
    RRegElementP<TIP> *ulomkova_crta;
    RRegElementP<TIP> *imenovalec;
};


//////////////////////////////////////////////////////////////////////
// RRegElSteviloCeloP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElSteviloCeloP : public RRegElementP<TIP>
{
public:
    RRegElSteviloCeloP(RRegElementP<TIP> *predznak_poz, RRegElementP<TIP> *predznak_neg, RRegElementP<TIP> *predznak_spec, RRegElementP<TIP> *stevilo);

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
    virtual T_VOID Razveljavi();
    virtual T_VOID Unici();

public:
    RRegElementP<TIP> *predznak_poz;    // predznak (pozitivni)
    RRegElementP<TIP> *predznak_neg;    // predznak (negativni)
    RRegElementP<TIP> *predznak_spec;   // predznak (posebni)
    RRegElementP<TIP> *stevilo;         // tevilo
};


//////////////////////////////////////////////////////////////////////
// RRegElSteviloRacionalnoP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElSteviloRacionalnoP : public RRegElementP<TIP>
{
public:
    RRegElSteviloRacionalnoP(RRegElementP<TIP> *predznak_poz, RRegElementP<TIP> *predznak_neg, RRegElementP<TIP> *predznak_spec, RRegElementP<TIP> *celi, RRegElementP<TIP> *presledek, RRegElementP<TIP> *ulomek);

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
    virtual T_VOID Razveljavi();
    virtual T_VOID Unici();

public:
    RRegElementP<TIP> *predznak_poz;    // predznak (pozitivni)
    RRegElementP<TIP> *predznak_neg;    // predznak (negativni)
    RRegElementP<TIP> *predznak_spec;   // predznak (posebni)
    RRegElementP<TIP> *celi;            // celi del
    RRegElementP<TIP> *ulomek;          // ulomek

protected:
    RRegElementP<TIP> *presledek;
};


//////////////////////////////////////////////////////////////////////
// RRegElSteviloDecimalnoP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElSteviloDecimalnoP : public RRegElementP<TIP>
{
public:
    RRegElSteviloDecimalnoP(
        RRegElementP<TIP>       *predznak_poz,
        RRegElementP<TIP>       *predznak_neg,
        RRegElementP<TIP>       *predznak_spec,
        RRegElStevnikCeliP<TIP> *celi,
        RRegElementP<TIP>       *locilo_decimalk,
        RRegElStevnikCeliP<TIP> *decimalke,
        RRegElementP<TIP>       *simbol_eksponenta,
        RRegElementP<TIP>       *predznak_eksponenta_poz,
        RRegElementP<TIP>       *predznak_eksponenta_neg,
        RRegElStevnikCeliP<TIP> *eksponent);

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
    virtual T_VOID Razveljavi();
    virtual T_VOID Unici();

public:
    RRegElementP<TIP>       *predznak_poz;            // predznak (pozitivni)
    RRegElementP<TIP>       *predznak_neg;            // predznak (negativni)
    RRegElementP<TIP>       *predznak_spec;           // predznak (posebni)
    RRegElStevnikCeliP<TIP> *celi;                    // celi del tevnika
    RRegElementP<TIP>       *locilo_decimalk;         // decimalna vejica
    RRegElStevnikCeliP<TIP> *decimalke;               // decimalke
    RRegElementP<TIP>       *simbol_eksponenta;       // simbol eksponenta
    RRegElementP<TIP>       *predznak_eksponenta_poz; // predznak eksponenta (pozitivni)
    RRegElementP<TIP>       *predznak_eksponenta_neg; // predznak eksponenta (negativni)
    RRegElStevnikCeliP<TIP> *eksponent;               // eksponent
    T_DOUBLE                vrednost;                 // izraunana vrednost tevnika
};


//////////////////////////////////////////////////////////////////////
// RRegElSteviloMonetarnoP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElSteviloMonetarnoP : public RRegElementP<TIP>
{
public:
    RRegElSteviloMonetarnoP(
        RRegElementP<TIP> *predznak_poz,
        RRegElementP<TIP> *predznak_neg,
        RRegElementP<TIP> *predznak_spec,
        RRegElementP<TIP> *valuta,
        RRegElementP<TIP> *celi,
        RRegElementP<TIP> *locilo_decimalk,
        RRegElementP<TIP> *decimalke);

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
    virtual T_VOID Razveljavi();
    virtual T_VOID Unici();

public:
    RRegElementP<TIP> *predznak_poz;    // predznak (pozitivni)
    RRegElementP<TIP> *predznak_neg;    // predznak (negativni)
    RRegElementP<TIP> *predznak_spec;   // predznak (posebni)
    RRegElementP<TIP> *valuta;          // valuta
    RRegElementP<TIP> *celi;            // celi del tevnika
    RRegElementP<TIP> *locilo_decimalk; // decimalna vejica
    RRegElementP<TIP> *decimalke;       // decimalke
};


//////////////////////////////////////////////////////////////////////
// RRegElIPv4NaslovP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElIPv4NaslovP : public RRegElementP<TIP>
{
public:
    RRegElIPv4NaslovP(
        RRegElementP<TIP> *stevka_0,
        RRegElementP<TIP> *stevka_1,
        RRegElementP<TIP> *stevka_2,
        RRegElementP<TIP> *stevka_3,
        RRegElementP<TIP> *stevka_4,
        RRegElementP<TIP> *stevka_5,
        RRegElementP<TIP> *stevka_6,
        RRegElementP<TIP> *stevka_7,
        RRegElementP<TIP> *stevka_8,
        RRegElementP<TIP> *stevka_9,
        RRegElementP<TIP> *locilo);

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
    virtual T_VOID Razveljavi();
    virtual T_VOID Unici();

public:
    T_INTERVAL<T_UINT> komponente[4];
    T_U4 vrednost;

protected:
    RRegElementP<TIP>
        *stevka_0,
        *stevka_1,
        *stevka_2,
        *stevka_3,
        *stevka_4,
        *stevka_5,
        *stevka_6,
        *stevka_7,
        *stevka_8,
        *stevka_9;
    RRegElementP<TIP> *locilo;
};


//////////////////////////////////////////////////////////////////////
// RRegElDNSNaslovZnakP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElDNSNaslovZnakP : public RRegElementP<TIP>
{
public:
    RRegElDNSNaslovZnakP(T_BOOL je_lahko_IDN);

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);

public:
    T_BOOL je_lahko_robni;

protected:
    T_BOOL je_lahko_IDN;   // ali lahko v imenu DNS nastopajo mednarodni znaki
};


//////////////////////////////////////////////////////////////////////
// RRegElDNSNaslovZnakSGML
//////////////////////////////////////////////////////////////////////

#ifndef AOSN_BREZ_SGML

class AOSN_CLASS RRegElDNSNaslovZnakSGML : public RRegElDNSNaslovZnakP<T_AZNAK>
{
public:
    RRegElDNSNaslovZnakSGML(T_BOOL je_lahko_IDN);

    virtual T_BOOL PreveriUjemanje(const T_AZNAK *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
};

#endif


//////////////////////////////////////////////////////////////////////
// RRegElDNSNaslovP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElDNSNaslovP : public RRegElementP<TIP>
{
public:
    RRegElDNSNaslovP(T_BOOL je_lahko_absolutni, RRegElDNSNaslovZnakP<TIP> *znak_komponente, RRegElementP<TIP> *locilo);

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
    virtual T_VOID Unici();

protected:
    T_BOOL              je_lahko_absolutni; // ali se lahko imena DNS konajo s piko (absolutno ime)
    RRegElDNSNaslovZnakP<TIP> *znak_komponente;
    RRegElementP<TIP>   *locilo;
};


//////////////////////////////////////////////////////////////////////
// RRegElURLUporabnikZnakP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElURLUporabnikZnakP : public RRegElementP<TIP>
{
public:
    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
};


//////////////////////////////////////////////////////////////////////
// RRegElURLUporabnikZnakSGML
//////////////////////////////////////////////////////////////////////

#ifndef AOSN_BREZ_SGML

class AOSN_CLASS RRegElURLUporabnikZnakSGML : public RRegElURLUporabnikZnakP<T_AZNAK>
{
public:
    virtual T_BOOL PreveriUjemanje(const T_AZNAK *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
};

#endif


//////////////////////////////////////////////////////////////////////
// RRegElURLGesloZnakP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElURLGesloZnakP : public RRegElementP<TIP>
{
public:
    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
};


//////////////////////////////////////////////////////////////////////
// RRegElURLGesloZnakSGML
//////////////////////////////////////////////////////////////////////

#ifndef AOSN_BREZ_SGML

class AOSN_CLASS RRegElURLGesloZnakSGML : public RRegElURLGesloZnakP<T_AZNAK>
{
public:
    virtual T_BOOL PreveriUjemanje(const T_AZNAK *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
};

#endif


//////////////////////////////////////////////////////////////////////
// RRegElURLPotZnakP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElURLPotZnakP : public RRegElementP<TIP>
{
public:
    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
};


//////////////////////////////////////////////////////////////////////
// RRegElURLPotZnakSGML
//////////////////////////////////////////////////////////////////////

#ifndef AOSN_BREZ_SGML

class AOSN_CLASS RRegElURLPotZnakSGML : public RRegElURLPotZnakP<T_AZNAK>
{
public:
    virtual T_BOOL PreveriUjemanje(const T_AZNAK *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
};

#endif


//////////////////////////////////////////////////////////////////////
// RRegElURLPotP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElURLPotP : public RRegElementP<TIP>
{
public:
    RRegElURLPotP(RRegElementP<TIP> *pot_znak, RRegElementP<TIP> *poizvedba_zacetek, RRegElementP<TIP> *zaznamek_zacetek);

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
    virtual T_VOID Razveljavi();
    virtual T_VOID Unici();

public:
    T_INTERVAL<T_UINT> pot;        // pot
    T_INTERVAL<T_UINT> poizvedba;  // poizvedba
    T_INTERVAL<T_UINT> zaznamek;   // zaznamek

protected:
    RRegElementP<TIP> *pot_znak;
    RRegElementP<TIP> *poizvedba_zacetek;
    RRegElementP<TIP> *zaznamek_zacetek;
};


//////////////////////////////////////////////////////////////////////
// RRegElURLNaslovP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElURLNaslovP : public RRegElementP<TIP>
{
public:
    RRegElURLNaslovP(
        RRegElementP<TIP> *shema_http,
        RRegElementP<TIP> *shema_ftp,
        RRegElementP<TIP> *shema_mailto,
        RRegElementP<TIP> *shema_file,
        RRegElementP<TIP> *dvopicje,
        RRegElementP<TIP> *posevnica,
        RRegElementP<TIP> *uporabnik,
        RRegElementP<TIP> *geslo,
        RRegElementP<TIP> *ajka,
        RRegElementP<TIP> *streznik_ip,
        RRegElementP<TIP> *streznik_dns,
        RRegElementP<TIP> *vrata,
        RRegElementP<TIP> *pot);

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
    virtual T_VOID Razveljavi();
    virtual T_VOID Unici();

public:
    RRegElementP<TIP> *shema_http;      // oznaka sheme (http)
    RRegElementP<TIP> *shema_ftp;       // oznaka sheme (http)
    RRegElementP<TIP> *shema_mailto;    // oznaka sheme (http)
    RRegElementP<TIP> *shema_file;      // oznaka sheme (http)
    RRegElementP<TIP> *uporabnik;       // uporabniko ime
    RRegElementP<TIP> *geslo;           // geslo
    RRegElementP<TIP> *streznik_ip;     // naslov IP strenika
    RRegElementP<TIP> *streznik_dns;    // naslov DNS strenika
    RRegElementP<TIP> *vrata;           // vrata
    RRegElementP<TIP> *pot;             // pot in poizvedba

protected:
    RRegElementP<TIP> *dvopicje;
    RRegElementP<TIP> *posevnica;
    RRegElementP<TIP> *ajka;
};


//////////////////////////////////////////////////////////////////////
// RRegElEPostaNaslovP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElEPostaNaslovP : public RRegElementP<TIP>
{
public:
    RRegElEPostaNaslovP(RRegElementP<TIP> *uporabnik, RRegElementP<TIP> *locilo, RRegElementP<TIP> *domena);

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
    virtual T_VOID Razveljavi();
    virtual T_VOID Unici();

public:
    RRegElementP<TIP> *uporabnik;   // ime uporabnika
    RRegElementP<TIP> *locilo;      // loilo med imenom uporabnika in domene
    RRegElementP<TIP> *domena;      // ime domene
};


//////////////////////////////////////////////////////////////////////
// RRegElSmeskoP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElSmeskoP : public RRegElementP<TIP>
{
public:
    RRegElSmeskoP(RRegElementP<TIP> *smesko, RRegElementP<TIP> *teme, RRegElementP<TIP> *oci, RRegElementP<TIP> *nos, RRegElMaskaOsnP<TIP> *usta);

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
    virtual T_VOID Razveljavi();
    virtual T_VOID Unici();

public:
    RRegElementP<TIP>    *smesko;   // cel smeko kot en sam znak (obiajno Unicode)
    RRegElementP<TIP>    *teme;     // teme smeka/obrvi/svetniki sij: O, 0
    RRegElementP<TIP>    *oci;      // oi smeka: :, ;, >, |, B
    RRegElementP<TIP>    *nos;      // nos smeka: -, o, lahko tudi solzica
    RRegElMaskaOsnP<TIP> *usta;     // usta smeka: ), ), (, (, |, P, D, p, d
};


//////////////////////////////////////////////////////////////////////
// RRegElDatumP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElDatumP : public RRegElementP<TIP>
{
public:
    RRegElDatumP(T_UINT zapis, RRegElStevnikCeliP<TIP> *dan, RRegElStevnikCeliP<TIP> *mesec, RRegElStevnikCeliP<TIP> *leto, RRegElMaskaOsnP<TIP> *locilo, RRegElementP<TIP> *presledek);

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
    virtual T_VOID Razveljavi();
    virtual T_VOID Unici();

protected:
    inline T_BOOL JeVeljaven(T_UINT dan, T_UINT mesec) const;

public:
    T_UINT najden_zapis;
    RRegElStevnikCeliP<TIP> *dan;   // dan v mesecu
    RRegElStevnikCeliP<TIP> *mesec; // mesec v letu
    RRegElStevnikCeliP<TIP> *leto;  // leto

protected:
    T_UINT               zapis;
    RRegElMaskaOsnP<TIP> *locilo;
    RRegElementP<TIP>    *presledek;
};


//////////////////////////////////////////////////////////////////////
// RRegElCasP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElCasP : public RRegElementP<TIP>
{
public:
    RRegElCasP(RRegElStevnikCeli10P<TIP> *ura, RRegElStevnikCeli10P<TIP> *minuta, RRegElStevnikCeli10P<TIP> *sekunda, RRegElStevnikCeli10P<TIP> *tisocinka, RRegElMaskaOsnP<TIP> *locilo, RRegElementP<TIP> *locilo_tisocink);

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
    virtual T_VOID Razveljavi();
    virtual T_VOID Unici();

public:
    RRegElStevnikCeli10P<TIP> *ura;
    RRegElStevnikCeli10P<TIP> *minuta;
    RRegElStevnikCeli10P<TIP> *sekunda;
    RRegElStevnikCeli10P<TIP> *tisocinka;

protected:
    RRegElMaskaOsnP<TIP> *locilo;
    RRegElementP<TIP> *locilo_tisocink;
};


//////////////////////////////////////////////////////////////////////
// RRegElKotP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElKotP : public RRegElementP<TIP>
{
public:
    RRegElKotP(RRegElStevnikCeli10P<TIP> *stopinja, RRegElementP<TIP> *locilo_stopinj, RRegElStevnikCeli10P<TIP> *minuta, RRegElementP<TIP> *locilo_minut, RRegElStevnikCeli10P<TIP> *sekunda, RRegElementP<TIP> *locilo_sekund, RRegElStevnikCeli10P<TIP> *decimalke);

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
    virtual T_VOID Razveljavi();
    virtual T_VOID Unici();

public:
    RRegElStevnikCeli10P<TIP> *stopinja;
    RRegElementP<TIP>         *locilo_stopinj;
    RRegElStevnikCeli10P<TIP> *minuta;
    RRegElementP<TIP>         *locilo_minut;
    RRegElStevnikCeli10P<TIP> *sekunda;
    RRegElementP<TIP>         *locilo_sekund;
    RRegElStevnikCeli10P<TIP> *decimalke;
};


//////////////////////////////////////////////////////////////////////
// RRegElTelefonskaStevilkaP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElTelefonskaStevilkaP : public RRegElementP<TIP>
{
public:
    RRegElTelefonskaStevilkaP(RRegElementP<TIP> *stevka, RRegElementP<TIP> *uvodno_locilo, RRegElMaskaOsnP<TIP> *oklepaj, RRegElMaskaOsnP<TIP> *zaklepaj, RRegElementP<TIP> *locilo, RRegElementP<TIP> *presledek);

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
    virtual T_VOID Razveljavi();
    virtual T_VOID Unici();

public:
    RNizP<TIP> stevilka;

protected:
    RRegElementP<TIP>    *stevka;
    RRegElementP<TIP>    *uvodno_locilo;
    RRegElMaskaOsnP<TIP> *oklepaj;
    RRegElMaskaOsnP<TIP> *zaklepaj;
    RRegElementP<TIP>    *locilo;
    RRegElementP<TIP>    *presledek;
};


//////////////////////////////////////////////////////////////////////
// RRegElKemijskaSpojinaP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElKemijskaSpojinaP : public RRegElementP<TIP>
{
public:
    RRegElKemijskaSpojinaP(RRegElementP<TIP> *element, RRegElementP<TIP> *stevka, RRegElementP<TIP> *predznak);

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
    virtual T_VOID Razveljavi();
    virtual T_VOID Unici();

public:
    T_BOOL ima_stevke;
    T_BOOL ima_naboj;

protected:
    RRegElementP<TIP> *element;
    RRegElementP<TIP> *stevka;
    RRegElementP<TIP> *predznak;
};


//////////////////////////////////////////////////////////////////////
// T_REGIZR_NASTAVITVEP
//////////////////////////////////////////////////////////////////////

template <class TIP> struct T_REGIZR_NASTAVITVEP
{
    struct {
        const TIP
            *predznaki_poz,             // niz z znaki, ki predstavljajo simbol za pozitiven predznak
            *predznaki_neg,             // niz z znaki, ki predstavljajo simbol za negativen predznak
            *predznaki_spec,            // niz z znaki, ki predstavljajo simbol za posebne predznake
            *ulomki,                    // niz z znaki, ki predstavljajo simbol za ulomkovo rto
            *locila_tisocic,            // niz z znaki, ki predstavljajo loila tisoic (pika, vejica, presledek)
            *locila_decimalk,           // niz z znaki, ki predstavljajo loila decimalk (vejica, pika)
            *eksponenti,                // niz z znaki, ki predstavljajo eksponent 10^
            *predznaki_eksponenta_poz,  // niz z znaki, ki predstavljajo pozitivni predznak eksponenta
            *predznaki_eksponenta_neg,  // niz z znaki, ki predstavljajo negativni predznak eksponenta
            *valutez;                   // nizi s simboli valut (ASCIIZZ)
    } globalno;

    struct {
        const TIP
            *stevke_0,          // niz z znaki, ki predstavljajo tevko ni
            *stevke_1,          // niz z znaki, ki predstavljajo tevko ena
            *stevke_2,          // niz z znaki, ki predstavljajo tevko dve
            *stevke_3,          // niz z znaki, ki predstavljajo tevko tri
            *stevke_4,          // niz z znaki, ki predstavljajo tevko tiri
            *stevke_5,          // niz z znaki, ki predstavljajo tevko pet
            *stevke_6,          // niz z znaki, ki predstavljajo tevko est
            *stevke_7,          // niz z znaki, ki predstavljajo tevko sedem
            *stevke_8,          // niz z znaki, ki predstavljajo tevko osem
            *stevke_9;          // niz z znaki, ki predstavljajo tevko devet
    } desetisko;

    struct {
        const TIP
            *stevke_1,          // niz z znaki, ki predstavljajo rimsko tevko ena
            *stevke_5,          // niz z znaki, ki predstavljajo rimsko tevko pet
            *stevke_10,         // niz z znaki, ki predstavljajo rimsko tevko deset
            *stevke_50,         // niz z znaki, ki predstavljajo rimsko tevko petdeset
            *stevke_100,        // niz z znaki, ki predstavljajo rimsko tevko sto
            *stevke_500,        // niz z znaki, ki predstavljajo rimsko tevko petsto
            *stevke_1000,       // niz z znaki, ki predstavljajo rimsko tevko tiso
            *stevke_5000,       // niz z znaki, ki predstavljajo rimsko tevko pettiso
            *stevke_10000;      // niz z znaki, ki predstavljajo rimsko tevko desettiso
    } rimsko;

    struct {
        const TIP
            *teme_znaki,        // niz z znaki, ki predstavljajo teme, elo, obrvi ali svetniki sij ("O0")
            *oci_znaki,         // niz z znaki, ki predstavljajo oi (":;=>|8BP")
            *nos_znaki,         // niz z znaki, ki predstavljajo nos ali solzico ("-'oxOX")
            *usta_znaki,        // niz z znaki, ki predstavljajo usta ("[(\\|/)]pdPD")
            *smeski_znaki;      // niz s posebnimi znaki, ki predstavljajo celotnega smeka (U2639, U263A U263B)
    } smesko;

    struct {
        T_UINT zapis;           // priakovani zapis datuma
        const TIP *locila;      // niz z znaki, ki predstavljajo loila komponent datuma ("./")
    } datum;

    struct {
        const TIP *locila;      // niz z znaki, ki predstavljajo loila komponent asa (":")
    } cas;

    struct {
        const TIP
            *locila_stopinj,    // niz z znaki, ki predstavljajo simbol za stopinje
            *locila_minut,      // niz z znaki, ki predstavljajo simbol za minute
            *locila_sekund;     // niz z znaki, ki predstavljajo simbol za sekunde
    } kot;

    struct {
        const TIP
            *stevke,            // niz z znaki, ki predstavljajo tevke tevilke
            *uvodna_locila,     // niz z znaki, ki predstavljajo uvodna loila ("+")
            *oklepaji,          // niz z znaki, ki predstavljajo oklepaje ("(")
            *zaklepaji,         // niz z znaki, ki predstavljajo zaklepaje (")")
            *locila;            // niz z znaki, ki predstavljajo obiajna loila, ki se uporabljajo pri telefonskih tevilkah ("/-")
    } tel_stevilka;

    struct {
        const TIP
            *elementiz,         // nizi s simboli kemijskih elementov (ASCIIZZ)
            *stevke,            // niz z znaki, ki predstavljajo tevke tevil elementov v spojini
            *predznaki;         // niz z znaki, ki predstavljajo polariteto ("+-")
    } kemijska_spojina;
};

#pragma warning(pop)

#endif // AOSN_REGIZR


//////////////////////////////////////////////////////////////////////
// T_DATUM
//////////////////////////////////////////////////////////////////////

struct AOSN_INLINE_CLASS T_DATUM {
    T_U2 milisekunda;   // milisekunda v sekundi (0 - 999)
    T_U1 sekunda;       // sekunda v minuti (0 - 59)
    T_U1 minuta;        // minuta v uri (0 - 59)
    T_U1 ura;           // ura v dnevu (0 - 23)
    T_U1 dan;           // dan v mesecu (1 - 31)
    T_U1 mesec;         // mesec v letu (1 - 12)
    T_4  leto;          // leto

    inline T_DATUM();
    inline T_DATUM(T_TRENUTEK datum);
    inline operator T_TRENUTEK() const;
    inline T_TRENUTEK operator =(T_TRENUTEK datum);
};


//////////////////////////////////////////////////////////////////////
// RDatum
// Pozor!!! Vsi datumi in ure so v UTC, e ni izrecno zapisano drugae
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RDatum : public RElement
{
public:
    RDatum();
    RDatum(T_TRENUTEK datum);
    RDatum(T_U1 dan, T_U1 mesec, T_4 leto, T_U1 ura=0, T_U1 minuta=0, T_U1 sekunda=0, T_U2 milisekunda=0);
    RDatum(const T_DATUM *datum);
    RDatum(const SYSTEMTIME *datum);
    RDatum(const FILETIME *datum);
    RDatum(DATE datum);

    inline T_TRENUTEK NastaviDatum(T_TRENUTEK datum);                   // Nastavi datum
    inline T_TRENUTEK NastaviDatum(T_U1 dan, T_U1 mesec, T_4 leto, T_U1 ura=0, T_U1 minuta=0, T_U1 sekunda=0, T_U2 milisekunda=0); // Nastavi datum
    inline T_TRENUTEK NastaviDatum(const T_DATUM *datum);               // Nastavi datum iz strukture
    inline T_TRENUTEK NastaviDatum(const SYSTEMTIME *datum);            // Nastavi datum iz strukture
    inline T_TRENUTEK NastaviDatum(const struct tm *datum);             // Nastavi datum iz strukture
    inline T_TRENUTEK NastaviDatum(const FILETIME *datum);              // Nastavi datum
    inline T_TRENUTEK NastaviDatum(DATE datum);                         // Nastavi datum

    inline T_TRENUTEK NastaviUro(T_U4 ura);                             // Nastavi samo uro

    inline T_TRENUTEK NastaviTrenutniCas();                             // Nastavi na trenutni as (UTC)

    inline T_TRENUTEK VrniDatum() const;                                // Vrne datum
    inline T_TRENUTEK VrniDatum(T_U1 *dan, T_U1 *mesec, T_4 *leto, T_U1 *ura = NULL, T_U1 *minuta = NULL, T_U1 *sekunda = NULL, T_U2 *milisekunda = NULL) const; // Vrne datum po komponentah
    inline T_TRENUTEK VrniDatum(T_DATUM *datum) const;                  // Vrne datum v strukturi
    inline T_TRENUTEK VrniDatum(SYSTEMTIME *datum) const;               // Vrne datum v strukturi
    inline T_TRENUTEK VrniDatum(FILETIME *datum) const;                 // Vrne datum
    inline T_TRENUTEK VrniDatum(DATE *datum) const;                     // Vrne datum

    inline T_4  VrniUro() const;                                        // Vrne tevilo milisekund od polnoi
    inline T_U1 VrniDan() const;                                        // Vrne dan v mesecu [1..31]
    inline T_U1 VrniMesec() const;                                      // Vrne mesec [1..12]
    inline T_4  VrniLeto() const;                                       // Vrne leto (npr. 1999, 2002 itd)
    inline T_U1 VrniDanVTednu() const;                                  // Vrne dan v tednu [0 - pon, 1 - tor .. 6 - ned]

    inline T_UINT VrniNiz(RNizP<T_AZNAK> &niz, TK_ASCII format, T_LOCALE locale) const;     // Vrne zapis datuma kot niz glede na lokalne nastavitve
    inline T_UINT VrniNiz(RNizP<T_UZNAK> &niz, TK_UNICODE format, T_LOCALE locale) const;   // Vrne zapis datuma kot niz glede na lokalne nastavitve
    inline RNizA  VrniNiz(TK_ASCII format, T_LOCALE locale) const;      // Vrne zapis datuma kot niz glede na lokalne nastavitve
    inline RNizU  VrniNiz(TK_UNICODE format, T_LOCALE locale) const;    // Vrne zapis datuma kot niz glede na lokalne nastavitve
    inline T_UINT VrniNizRFC822(RNizP<T_AZNAK> &niz) const;             // Vrne datum v zapisu RFC 822
    inline RNizA  VrniNizRFC822() const;                                // Vrne datum v zapisu RFC 822

    // operatorji za delo z datumi
    inline operator T_TRENUTEK() const;
    inline T_TRENUTEK operator =(T_TRENUTEK datum);
    inline T_TRENUTEK operator += (T_TRENUTEK datum);
    inline T_TRENUTEK operator -= (T_TRENUTEK datum);

    // staticne metode za preracunavanje datumov
    inline static T_4    PretvoriGreVJul(T_U1 dan, T_U1 mesec, T_4 leto);                  // pretvori gregorijanski zapis datuma v julijanskega
    inline static T_TRENUTEK    PretvoriGreVJul(const SYSTEMTIME *cas);                    // pretvori gregorijanski zapis datuma v julijanskega
    inline static T_TRENUTEK    PretvoriGreVJul(const struct tm *cas);                     // pretvori gregorijanski zapis datuma v julijanskega
    inline static T_TRENUTEK    Pretvori(const FILETIME *cas);                             // pretvori v julijanski zapis datuma
    inline static T_TRENUTEK    Pretvori(DATE datum);                                      // pretvori v julijanski zapis datuma
    inline static T_VOID PretvoriJulVGre(T_4 jul, T_U1 *dan, T_U1 *mesec, T_4 *leto);      // pretvori julijanski zapis datuma v gregorijanskega
    inline static T_VOID PretvoriJulVGre(T_TRENUTEK jul, T_U1 *dan, T_U1 *mesec, T_4 *leto, T_U1 *ura, T_U1 *minuta, T_U1 *sekunda, T_U2 *milisekunda); // pretvori julijanski zapis datuma v gregorijanskega
    inline static T_VOID PretvoriJulVGre(T_TRENUTEK jul, T_DATUM *datum);                  // pretvori julijanski zapis datuma v gregorijanskega
    inline static T_VOID PretvoriJulVGre(T_TRENUTEK jul, SYSTEMTIME *datum);               // pretvori julijanski zapis datuma v gregorijanskega
    inline static T_VOID PretvoriJulVGre(T_TRENUTEK jul, struct tm *datum);                // pretvori julijanski zapis datuma v gregorijanskega
    inline static T_VOID Pretvori(T_TRENUTEK jul, FILETIME *datum);                        // pretvori iz julijanskega zapisa
    inline static T_VOID Pretvori(T_TRENUTEK jul, DATE *datum);                            // pretvori iz julijanskega zapisa

    inline static T_TRENUTEK    PretvoriUTCVLokalni(T_TRENUTEK utc);                       // asovna korekcija iz UTC v lokalni as
    inline static T_TRENUTEK    PretvoriLokalniVUTC(T_TRENUTEK lokalni);                   // pretvori lokalni as v zapis UTC

    inline static T_U1   VrniDanVTednu(T_4 jul);                                           // vrne dan v tednu, e poznamo julijanski datum [0 - pon, 1 - tor .. 6 - ned]
    inline static T_U1   VrniDanVTednu(T_U1 dan, T_U1 mesec, T_4 leto);                    // vrne dan v tednu, e poznamo gregorijanski datum [0 - pon, 1 - tor .. 6 - ned]

    inline static T_UINT VrniNiz(T_TRENUTEK datum, RNizP<T_AZNAK> &niz, TK_ASCII format, T_LOCALE locale);   // pretvori datum v oblikovan niz
    inline static T_UINT VrniNiz(T_TRENUTEK datum, RNizP<T_UZNAK> &niz, TK_UNICODE format, T_LOCALE locale); // pretvori datum v oblikovan niz
    inline static RNizA  VrniNiz(T_TRENUTEK datum, TK_ASCII format, T_LOCALE locale);      // pretvori datum v oblikovan niz
    inline static RNizU  VrniNiz(T_TRENUTEK datum, TK_UNICODE format, T_LOCALE locale);    // pretvori datum v oblikovan niz
    inline static T_UINT VrniNizRFC822(T_TRENUTEK datum, RNizP<T_AZNAK> &niz);             // Vrne datum v zapisu RFC 822
    inline static RNizA  VrniNizRFC822(T_TRENUTEK datum);                                  // Vrne datum v zapisu RFC 822

    inline static T_4    DolociTrenutniJul(T_U4 *ura = NULL);                              // vrne trenutni datum in uro v julijanskem zapisu

    static T_TRENUTEK VrniTrenutniCas();                                                   // vrne trenutni as

    inline static T_U8 VrniProcCas();                                                      // vrne porabljeni as procesa v milisekundah

protected:
    T_TRENUTEK datum;
};


#ifdef AOSN_SEMAFOR

//////////////////////////////////////////////////////////////////////
// T_RSEM_ZASTAVICE
//////////////////////////////////////////////////////////////////////

enum T_RSEM_ZASTAVICE {
    RSEM_POSTAVLJEN  = 0x00000001,
    RSEM_ROCNI_RESET = 0x00000002,

    // Konstante za RNadzornikImenika
    RSEM_SPREMLJAJ_PODIMENIKE                 = 0x00010000,
    RSEM_SPREMLJAJ_SPREMEMBO_IMENA_DATOTEKE   = 0x00020000,
    RSEM_SPREMLJAJ_SPREMEMBO_IMENA_PODIMENIKA = 0x00040000,
    RSEM_SPREMLJAJ_SPREMEMBO_ATRIBUTOV        = 0x00080000,
    RSEM_SPREMLJAJ_SPREMEMBO_DOLZINE          = 0x00100000,
    RSEM_SPREMLJAJ_SPREMEMBO_VSEBINE          = 0x00200000,
    RSEM_SPREMLJAJ_SPREMEMBO_PRAVIC           = 0x00400000,
};


//////////////////////////////////////////////////////////////////////
// RSinhronizator
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RSinhronizator : public RSisElement
{
public:
    RSinhronizator(T_ROCICAOS r = NEVELJAVNA_ROCICA);
    virtual ~RSinhronizator();

    virtual T_STANJE Odkleni() = 0;                             // Odklene sinhronizator - sprosti/sprozi/pozene
    virtual T_STANJE Zakleni(T_UINT naj_cas = NESKONCNO) const; // Zaklene sinhronizator - caka na sprostitev/koncanje

    inline T_STANJE PogojnoZakleni();                           // Poskusa zakleniti sinhronizator, vendar se takoj vrne, ce uspe ali ne
    inline T_STANJE Postavi();                                  // Sinonim za Odkleni
    inline T_STANJE Pocakaj(T_UINT naj_cas = NESKONCNO) const;  // Sinonim za Zakleni
};


//////////////////////////////////////////////////////////////////////
// RDogodek
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RDogodek : public RSinhronizator
{
public:
    RDogodek(T_ROCICAOS r);
    RDogodek(T_UINT nacin = 0, TK_NIZ ime = NULL);

    T_STANJE Resetiraj();           // Resetira dogodek, ce je ta postavljen
    T_STANJE Impulz();              // Postavi dogodek za hip, da sprosti enega cakajocega (ali vse ce je rocni reset) in ga nazaj resetira

    virtual T_STANJE Odkleni();     // Postavi dogodek
};


//////////////////////////////////////////////////////////////////////
// RNevarenOdsek
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RNevarenOdsek : public RSinhronizator
{
public:
    RNevarenOdsek(T_ROCICAOS r);
    RNevarenOdsek(T_UINT nacin = 0, TK_NIZ ime = NULL);

    virtual T_STANJE Odkleni();     // Sprosti nevaren odsek
};


//////////////////////////////////////////////////////////////////////
// RSemafor
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RSemafor : public RSinhronizator
{
public:
    RSemafor(T_ROCICAOS r);
    RSemafor(T_UINT stevilo = 0, T_UINT maksimum = 1, TK_NIZ ime = NULL);

    virtual T_STANJE Odkleni();                     // Sprosti eno mesto v semaforju

    inline T_STANJE Odkleni(T_UINT stevilo);        // Sprosti dano stevilo mest v semaforju
};


//////////////////////////////////////////////////////////////////////
// RNadzornikImenika
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RNadzornikImenika : public RSinhronizator
{
public:
    RNadzornikImenika(T_ROCICAOS r);
    RNadzornikImenika(TK_NIZ pot, T_UINT nacin = 0);
    virtual ~RNadzornikImenika();

    virtual T_STANJE Zapri();       // Zapre roico
    virtual T_STANJE Odkleni();     // Pripravi nadzornik imenika za naslednje akanje
};


//////////////////////////////////////////////////////////////////////
// RCasomer
//////////////////////////////////////////////////////////////////////

#ifndef _WIN32_WCE

class AOSN_CLASS RCasomer : public RSinhronizator
{
public:
    RCasomer(T_ROCICAOS r);
    RCasomer(T_UINT nacin = 0, TK_NIZ ime = NULL);
    virtual ~RCasomer();

    T_STANJE Nastavi(T_TRENUTEK kdaj, T_UINT perioda);  // Nastavimo casomer (pozitiven parameter kdaj - absolutno, negativen parameter kdaj - relativno)
    T_STANJE Prekini();                                 // Prekinemo delovanje casomera

    virtual T_STANJE Odkleni();                         // Takoj sprozi alarm casomera
    virtual T_STANJE Zapri();                           // Zapre roico

protected:
    virtual T_VOID ObAlarmu(T_TRENUTEK cas);            // To metodo klice sistem ob vsaki sprozitvi casomera (ce je nit "alertable").

protected:
    static VOID CALLBACK Rokovalnik(LPVOID lpArgToCompletionRoutine, DWORD dwTimerLowValue, DWORD dwTimerHighValue);
};

#endif


//////////////////////////////////////////////////////////////////////
// RCakalnik
//////////////////////////////////////////////////////////////////////

#pragma warning(push)
#pragma warning(disable: 4512)

class AOSN_CLASS RCakalnik : public RElement
{
public:
    RCakalnik(RSinhronizator &sinhronizator, T_BOOL takoj_zakleni = TRUE);
    virtual ~RCakalnik();

    inline T_STANJE Zakleni(T_UINT naj_cas = NESKONCNO);    // Caka na sinhronizator
    inline T_STANJE Odkleni();                                // Sprosti sinhronizator
    inline T_STANJE PogojnoZakleni();                        // Poskusa zakleniti sinhronizator, vendar se takoj vrne, ce uspe ali ne

protected:
    RSinhronizator &sinhronizator;                  // kazalec na sinhronizator, ki ga spremljamo
    T_UINT zaklenjen;                               // ali ga je zaklenil ta razred
};

#pragma warning(pop)


//////////////////////////////////////////////////////////////////////
// RMultiCakalnik
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RMultiCakalnik : public RElement
{
public:
    RMultiCakalnik(RSinhronizator **sinhronizatorji, T_UINT stevilo, T_BOOL takoj_zakleni = TRUE);
    virtual ~RMultiCakalnik();

    inline T_STANJE Zakleni(T_UINT naj_cas = NESKONCNO, T_BOOL cakaj_vse = TRUE);    // Caka na sinhronizatorje
    inline T_STANJE Odkleni();                                                        // Sprosti zaklenjene sinhronizatorje
    inline T_STANJE PogojnoZakleni(T_UINT indeks);                                    // Poskusa zakleniti dolocen sinhronizator, vendar se takoj vrne, ce uspe ali ne

    inline static T_STANJE Pocakaj(const T_ROCICAOS sinhronizator[], T_UINT stevilo, T_BOOL cakaj_vse = TRUE, T_UINT naj_cas = NESKONCNO);

protected:
    RSinhronizator **sinhronizator;                 // tabela kazalcev na sinhronizatorje, ki jih spremljamo
    T_ROCICAOS *rocica;                             // tabela rocic na sinhronizatorje, ki jih spremljamo
    T_BOOL *zaklenjen;                              // tabela pogojev, kateri sinhronizator je zaklenil ta razred
    T_UINT stevilo;                                 // stevilo sinhronizatorjev, ki jih spremljamo
};

#endif // AOSN_SEMAFOR


#ifdef AOSN_NIT

//////////////////////////////////////////////////////////////////////
// T_NITZACETNOSTANJE
//////////////////////////////////////////////////////////////////////

enum T_NITZACETNOSTANJE {
    RNIT_NORMALNA   = 0,
    RNIT_ZAMRZNJENA = CREATE_SUSPENDED
};


//////////////////////////////////////////////////////////////////////
// T_NITPRIORITETA
//////////////////////////////////////////////////////////////////////

enum T_NITPRIORITETA {
    RNIT_PRI_KRITICNA  = THREAD_PRIORITY_TIME_CRITICAL,
    RNIT_PRI_NAJVISJA  = THREAD_PRIORITY_HIGHEST,
    RNIT_PRI_VISJA     = THREAD_PRIORITY_ABOVE_NORMAL,
    RNIT_PRI_NORMALNA  = THREAD_PRIORITY_NORMAL,
    RNIT_PRI_NIZJA     = THREAD_PRIORITY_BELOW_NORMAL,
    RNIT_PRI_NAJNIZJA  = THREAD_PRIORITY_LOWEST,
    RNIT_PRI_PROSTITEK = THREAD_PRIORITY_IDLE
};


//////////////////////////////////////////////////////////////////////
// T_NITSPOROCILO
// standardne konstante sporoil
//////////////////////////////////////////////////////////////////////

enum T_KODASPOROCILA {
    SP_KONEC = 0,

    SP_RDOGNIT_KONEC
};


//////////////////////////////////////////////////////////////////////
// T_SPOROCILO
//////////////////////////////////////////////////////////////////////

struct T_SPOROCILO {
    T_UINT koda;        // koda sporoila
    T_UINT param1;      // prvi parameter sporoila
    T_KAZALEC param2;   // drugi parameter sporoila
};


//////////////////////////////////////////////////////////////////////
// T_DIAGNIT_PODATKI
//////////////////////////////////////////////////////////////////////

struct T_DIAGNIT_PODATKI
{
    DWORD koda_procesa;                                     // koda procesa, ki je poslal sporoilo
    CHAR  sporocilo[RDIAGNIT_VELIKOST_PODATKI_SPOROCILO];   // vsebina sporoila v zapisu ASCII
};


//////////////////////////////////////////////////////////////////////
// RNit
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RNit : public RSinhronizator
{
public:
    RNit(T_ROCICAOS r = NEVELJAVNA_ROCICA);

    T_STANJE Odpri(T_KAZALEC param = NULL, T_NITZACETNOSTANJE zacetno_stanje = RNIT_NORMALNA, T_UINT sklad = 0);                                        // Ustvari nit
    inline static T_ROCICAOS Odpri(T_VSTOPNA_TOCKA vstopna_tocka, T_KAZALEC param = NULL, T_NITZACETNOSTANJE stanje = RNIT_NORMALNA, T_UINT sklad = 0); // Ustvari novo nit s poljubno izbrano vstopno toko

    T_STANJE Zamrzni();                                                                 // Zaasno zamrzne izvajanje niti
    T_STANJE Odmrzni();                                                                 // Odmrzne izvajanje niti
    T_STANJE Prekini(T_REZULTAT rezultat);                                              // Prekine izvajanje niti
    T_STANJE NastaviPrioriteto(T_NITPRIORITETA prioriteta);                             // Nastavi prioriteto izvajanja niti
    T_NITPRIORITETA VrniPrioriteto();                                                   // Vrne prioriteto izvajanja niti
    T_STANJE VrniRezultat(T_REZULTAT *rezultat);                                        // Vrne kodo rezultata niti
    inline T_UINT VrniKodo();                                                           // Vrne kodo niti

    virtual T_STANJE Uporabi(T_ROCICAOS rocica, T_UINT koda_niti);                      // Uporabi e narejeno nit
    virtual T_ROCICAOS Odpusti();                                                       // Vrne roico in razpusti nit
    virtual T_STANJE Zapri();                                                           // Unii nit

    virtual T_STANJE Odkleni();                                                         // Ustvari nit s privzetimi zaetnimi podatki - zaradi skladnosti z osnovnim razredom RSinhronizator

    inline static T_VOID PrekiniTrenutnoNit(T_REZULTAT rezultat);                       // Prekine izvajanje trenutne niti
    inline static T_VOID ZamrzniTrenutnoNit();                                          // Zamrzne izvajanje trenutne niti
    inline static T_STANJE NastaviPrioritetoTrenutneNiti(T_NITPRIORITETA prioriteta);   // Nastavi prioriteto izvajanja trenutne niti
    inline static T_NITPRIORITETA VrniPrioritetoTrenutneNiti();                         // Vrne prioriteto izvajanja trenutne niti
    inline static T_VOID Zaspi(T_UINT milisekund);                                      // Zaasno zamrzne izvajanje trenutne niti za doloen as
    inline static T_ROCICAOS VrniTrenutnoNit();                                         // Vrne kopijo roice trenutne niti
    inline static T_UINT VrniKodoTrenutneNiti();                                        // Vrne kodo trenutne niti

protected:
    virtual T_REZULTAT Izvedi(T_KAZALEC param) = 0;                                     // Osrednja metoda, ki predstavlja telo niti
    static T_REZULTAT RNIT_API VstopnaTocka(T_KAZALEC param);                           // Skupna vstopna toka za niti razreda RNit

protected:
    T_UINT koda_niti;   // koda niti
    T_KAZALEC param;    // parameter niti
};


// makri za samodejno izdelavo rokovalnikov
#define RDOGNIT_NAJAVI_ROKOVALNIKE virtual T_REZULTAT RokovalnikDogodkov(T_UINT koda_sporocila, T_UINT param1, T_KAZALEC param2);
#define RDOGNIT_ROKOVALNIKI(razred) \
T_REZULTAT razred::RokovalnikDogodkov(T_UINT koda_sporocila, T_UINT param1, T_KAZALEC param2) \
{ \
    switch (koda_sporocila) {
#define RDOGNIT_OB_DOGODKU(koda_sp, metoda) \
    case (koda_sp): return (metoda)(param1, param2);
#define RDOGNIT_KONEC_ROKOVALNIKOV(osnovni) \
    } \
    return osnovni::RokovalnikDogodkov(koda_sporocila, param1, param2); \
}


//////////////////////////////////////////////////////////////////////
// RDogNit
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RDogNit : public RNit
{
public:
    T_STANJE Odpri(T_UINT dolzina_vrste = RDOGNIT_PRIVZETA_DOLZINA_VRSTE, T_KAZALEC param = NULL, T_NITZACETNOSTANJE stanje = RNIT_NORMALNA, T_UINT sklad = 0);    // Ustvari nit
#ifdef RDOGNIT_KANAL_VER
    virtual T_STANJE Zapri();                                                           // Unii nit - pazi, da bo nit konana, preden klies (Predhodno uporabi Zakleni(), da poaka na konec)
    virtual T_STANJE Uporabi(T_ROCICAOS rocica, T_UINT koda_niti);                      // Uporabi e narejeno nit
    virtual T_ROCICAOS Odpusti();                                                       // Vrne roico niti in razpusti nit
    virtual T_STANJE Sporoci(T_UINT koda_sporocila, T_UINT param1, T_KAZALEC param2);   // Metoda, ki jo kliejo druge niti, da poljejo sporoilo tej niti
#else
    inline T_STANJE Sporoci(T_UINT koda_sporocila, T_UINT param1, T_KAZALEC param2);    // Metoda, ki jo kliejo druge niti, da poljejo sporoilo tej niti
#endif
    T_REZULTAT Pozeni(T_KAZALEC param = NULL);                                          // Prilepi dogodkovno nit na trenutno nit (Prej uporabi metodo Uporabi() in nato Odpusti(), ki pripravita vrsto za sporoila).

protected:
    virtual T_REZULTAT Izvedi(T_KAZALEC param);                                         // Osrednja metoda, ki predstavlja telo niti
    virtual T_REZULTAT ObZagonu(T_KAZALEC param);                                       // Metoda, ki jo nit klie, ko je vrsta za sporoila pripravljena, preden zane sprejemati sporoila
    virtual T_VOID ObZakljucku(T_KAZALEC param);                                        // Metoda, ki jo nit klie takoj ko neha sprejemati sporoila

    RDOGNIT_NAJAVI_ROKOVALNIKE

protected:
#ifdef RDOGNIT_KANAL_VER
    RKanal vrsta;   // vrsta sporoil
#endif
};


//////////////////////////////////////////////////////////////////////
// RDogNitVN
//////////////////////////////////////////////////////////////////////

#ifdef RDOGNIT_KANAL_VER

class AOSN_CLASS RDogNitVN : public RDogNit
{
public:
    virtual T_STANJE Sporoci(T_UINT koda_sporocila, T_UINT param1, T_KAZALEC param2);   // Metoda, ki jo kliejo druge niti, da poljejo sporoilo tej niti

protected:
    RNevarenOdsek kljucavnica;      // kljuavnica za zaklepanje, da ne pride do soasnih poiljanj sporoil s strani ve odjemalcev
};

#endif


//////////////////////////////////////////////////////////////////////
// RStopnjaCevovoda
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RStopnjaCevovoda : public RDogNit
{
public:
    RStopnjaCevovoda(RDogNit *naslednja = NULL);

    inline T_VOID UporabiNaslednjo(RDogNit *naslednja);

protected:
    RDogNit *naslednja;
};


//////////////////////////////////////////////////////////////////////
// RCasovnaPast
//////////////////////////////////////////////////////////////////////

#ifndef _WIN32_WCE

class AOSN_CLASS RCasovnaPast : public RNit
{
public:
    T_STANJE Odpri(T_KAZALEC param = NULL, T_NITZACETNOSTANJE zacetno_stanje = RNIT_NORMALNA, T_UINT sklad = 0);    // Ustvari nit

    inline T_STANJE Nastavi(T_TRENUTEK kdaj);
    inline T_STANJE Zakljuci();

protected:
    virtual T_REZULTAT ObAlarmu(T_KAZALEC param);   // To metodo klie sistem ob vsaki sproitvi pasti.
    virtual T_REZULTAT Izvedi(T_KAZALEC param);     // Osrednja metoda, ki predstavlja telo niti

protected:
    RCasomer casomer;
    volatile T_BOOL koncaj;
};

#endif


//////////////////////////////////////////////////////////////////////
// RDiagNit
//////////////////////////////////////////////////////////////////////

class RDiagNit : public RNit
{
public:
    RDiagNit();
    virtual ~RDiagNit();

    T_STANJE Odpri(T_KAZALEC param = NULL, T_NITZACETNOSTANJE zacetno_stanje = RNIT_NORMALNA, T_UINT sklad = 0);    // Ustvari nit
    inline T_STANJE Prekini();                                          // Konamo izvajanje niti
    inline T_STANJE PocakajPripravljenost(T_UINT naj_cas = NESKONCNO);  // Poakamo na pripravljenost niti.

    virtual T_STANJE Zapri();                                           // Unii nit

protected:
    virtual T_REZULTAT ObZagonu(T_KAZALEC param);                       // Metoda, ki jo nit klie, ko je vrsta za sporoila pripravljena, preden zane sprejemati sporoila
    virtual T_REZULTAT ObSporocilu(const T_DIAGNIT_PODATKI *podatki);   // Metoda, ki jo nit klie, kadar prispe sporoilo
    virtual T_VOID ObZakljucku(T_KAZALEC param);                        // Metoda, ki jo nit klie takoj ko neha sprejemati sporoila
    virtual T_REZULTAT Izvedi(T_KAZALEC param);                         // Osrednja metoda, ki predstavlja telo niti

protected:
    RDogodek dogodek_pripravljen;               // dogodek, ki doloa, ali je nit pripravljena na sprejem sporoil
    RDogodek dogodek_koncaj;                    // dogodek, s katerim zakljuujemo nit (mora biti dogodek, ker mora nit akati na enega izmed dveh dogodkov: dogodek_koncaj ali dogodek_podatki_pripravljeni)
    RDogodek dogodek_pomnilnik_pripravljen;     // globalni dogodek, s katerim nit sporoa, da je pomnilnik pripravljen na sprejem sporoil
    RDogodek dogodek_podatki_pripravljeni;      // globalni dogodek, s katerim je nit obveena, da je prispelo novo sporoilo
    T_ROCICAOS rocica_podatkov;                 // roica do pomnilnika, kjer so podatki o sporoilu
};

#endif // AOSN_NIT


//////////////////////////////////////////////////////////////////////
// T_DATNACINODMIKA
//////////////////////////////////////////////////////////////////////

enum T_DATNACINODMIKA {
    RDAT_OD_ZACETKA    = FILE_BEGIN,
    RDAT_OD_TRENUTNEGA = FILE_CURRENT,
    RDAT_OD_KONCA      = FILE_END
};


//////////////////////////////////////////////////////////////////////
// T_DATNACINODPIRANJA
//////////////////////////////////////////////////////////////////////

enum T_DATNACINODPIRANJA {
    RDAT_BRANJE           = 0x00000001,
    RDAT_PISANJE          = 0x00000002,
    RDAT_UPRAVLJANJE      = 0x00008000,
    RDAT_SH_EKSKLUZIVNO   = 0x00000000,
    RDAT_SH_BERI          = 0x00000004,
    RDAT_SH_PISI          = 0x00000008,
    RDAT_SH_BRISI         = 0x00000010,
    RDAT_SH_POLNO         = 0x0000001c,
    RDAT_NE_DEDUJ         = 0x00000020,
    RDAT_USTVARI          = 0x00000040,
    RDAT_NE_UNICI         = 0x00000080,
    RDAT_PRILEPI          = 0x00000100,
    RDAT_TEKSTOVNO        = 0x00000000,
    RDAT_BINARNO          = 0x00000200,
    RDAT_PISI_SKOZI       = 0x00000400,
    RDAT_BREZ_MEDPOMN     = 0x00000800,
    RDAT_DOSTOP_NAKLJUCEN = 0x00001000,
    RDAT_DOSTOP_ZAPOREDEN = 0x00002000,
    RDAT_IMENIK           = 0x00004000, // zastarelo, uporabi RDAT_MAPA
    RDAT_MAPA             = 0x00004000,
    RDAT_ZA_ARHIVIRANJE   = 0x00004000,
};


//////////////////////////////////////////////////////////////////////
// T_DATATRIBUT
//////////////////////////////////////////////////////////////////////

enum T_DATATRIBUT {
    RDAT_AT_NAVADEN     = FILE_ATTRIBUTE_NORMAL,
    RDAT_AT_IMENIK      = FILE_ATTRIBUTE_DIRECTORY,
#ifdef FILE_ATTRIBUTE_DEVICE
    RDAT_AT_NAPRAVA     = FILE_ATTRIBUTE_DEVICE,
#else
    RDAT_AT_NAPRAVA     = 0x00000040,
#endif
    RDAT_AT_ARHIVIRANJE = FILE_ATTRIBUTE_ARCHIVE,
    RDAT_AT_SAMO_BRANJE = FILE_ATTRIBUTE_READONLY,
    RDAT_AT_SKRIT       = FILE_ATTRIBUTE_HIDDEN,
    RDAT_AT_SISTEMSKI   = FILE_ATTRIBUTE_SYSTEM,
    RDAT_AT_KOMPRESIRAN = FILE_ATTRIBUTE_COMPRESSED,
#ifdef FILE_ATTRIBUTE_ENCRYPTED
    RDAT_AT_KRIPTIRAN   = FILE_ATTRIBUTE_ENCRYPTED,
#else
    RDAT_AT_KRIPTIRAN   = 0x00004000,
#endif
    RDAT_AT_NEDOSTOPEN  = FILE_ATTRIBUTE_OFFLINE,
#ifdef FILE_ATTRIBUTE_SPARSE_FILE
    RDAT_AT_REDEK       = FILE_ATTRIBUTE_SPARSE_FILE,
#else
    RDAT_AT_REDEK       = 0x00000200,
#endif
    RDAT_AT_ZACASEN     = FILE_ATTRIBUTE_TEMPORARY,
#ifdef FILE_ATTRIBUTE_NOT_CONTENT_INDEXED
    RDAT_AT_NEINDEKSIRAN = FILE_ATTRIBUTE_NOT_CONTENT_INDEXED,
#else
    RDAT_AT_NEINDEKSIRAN = 0x00002000,
#endif
};


//////////////////////////////////////////////////////////////////////
// RTokPodatkov
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RTokPodatkov : virtual public RIzpElement
{
public:
    RTokPodatkov();

    virtual T_SIZE Preberi(T_KAZALEC podatki, T_SIZE dolzina) = 0;                      // Prebere blok podatkov iz toka, vrne tevilo prebranih bajtov
    virtual T_SIZE Zapisi(TK_KAZALEC podatki, T_SIZE dolzina) = 0;                      // Zapie blok podatkov na tok, vrne tevilo zapisanih bajtov
    virtual T_SIZE PreberiOstanek(T_KAZALEC &p, T_SIZE dolzina_max = T_SIZE_MAX);       // Prebere ostanek toka v pomnilnik (Po uporabi sprosti pomnilnik z afree())

    virtual T_STANJE Zapri() = 0;                                                       // Zapre tok podatkov

    virtual T_STANJE Preskoci(T_DOLZINA koliko);                                        // Preskoi eleno tevilo bajtov na toku

    inline T_STANJE VrniStanje() const { return stanje; };                              // Vrne stanje po zadnji operaciji toka
    inline T_VOID ResetirajStanje() { stanje = A_OK; };                                 // Rono resetira stanje toka na brezhibno
    inline T_VOID NastaviStanje(T_STANJE stanje) { this->stanje = stanje; };            // Nastavi stanje na eleno.
    inline T_BOOL JeKonec() const { return NEUSPESNO(stanje); };                        // Preveri, ali smo pri zadnji operaciji naleteli na napako in moramo konati z branjem/pisanjem.

    inline T_U1 PreberiBajt();                                                          // Prebere en bajt podatkov
    inline T_UINT PreberiVrstico(RNizP<T_AZNAK> &niz);                                  // Prebere niz iz toka podatkov do prvega konca vrstice ali do konca datoteke, vrne tevilo prebranih znakov
    inline T_UINT PreberiVrstico(RNizP<T_UZNAK> &niz);                                  // Prebere niz iz toka podatkov do prvega konca vrstice ali do konca datoteke, vrne tevilo prebranih znakov
    inline T_UINT PreberiVrstico(RNizU &niz, T_KODNASTRAN kodna_stran);                 // Prebere niz iz toka podatkov do prvega konca vrstice ali do konca datoteke, vrne tevilo prebranih znakov
    inline T_UINT PreberiInPrilepiVrstico(RNizP<T_AZNAK> &niz);                         // Prebere niz iz toka podatkov do prvega konca vrstice ali do konca datoteke, vrne konno tevilo znakov
    inline T_UINT PreberiInPrilepiVrstico(RNizP<T_UZNAK> &niz);                         // Prebere niz iz toka podatkov do prvega konca vrstice ali do konca datoteke, vrne konno tevilo znakov
    inline T_UINT PreberiInPrilepiVrstico(RNizU &niz, T_KODNASTRAN kodna_stran);        // Prebere niz iz toka podatkov do prvega konca vrstice ali do konca datoteke, vrne konno tevilo znakov
    inline T_UINT PreberiTab(T_KAZALEC tabela, T_SIZE velikost, T_UINT stevilo);        // Zapie tabelo podatkov na tok, vrne tevilo prebranih elementov

    inline T_STANJE ZapisiBajt(T_U1 bajt, T_DOLZINA koliko = 1);                        // Zapie eleno tevilo bajtov
    inline T_UINT ZapisiNiz(TK_UNICODE niz, T_UINT znakov, T_KODNASTRAN kodna_stran);   // Zapie niz na tok podatkov, vrne tevilo zapisanih znakov
    inline T_SIZE ZapisiSAFEARRAY(LPSAFEARRAY sa);                                      // Zapie vsebino tabele SAFEARRAY, vrne tevilo zapisanih bajtov
    inline T_DOLZINA ZapisiTok(RTokPodatkov &tok, T_DOLZINA koliko = (T_DOLZINA)-1);    // Zapie vsebino drugega toka, vrne tevilo zapisanih bajtov
    inline T_UINT ZapisiTab(TK_KAZALEC tabela, T_SIZE velikost, T_UINT stevilo);        // Zapie tabelo podatkov na tok, vrne tevilo zapisanih elementov
    inline T_STANJE ZapisiKodnoStran(T_KODNASTRAN kodna_stran);                         // Zapie oznako kodne strani

    T_UINT ZapisiObl(TK_ASCII format, T_LOCALE locale, ...);                            // Zapie oblikovan niz na tok podatkov (podobno fprintf), vrne tevilo zapisanih znakov
    T_UINT ZapisiObl(TK_UNICODE format, T_LOCALE locale, ...);                          // Zapie oblikovan niz na tok podatkov (podobno fprintf), vrne tevilo zapisanih znakov
    T_UINT ZapisiOblP(TK_ASCII format, T_LOCALE locale, va_list parametri);             // Zapie oblikovan niz na tok podatkov (podobno fprintf), vrne tevilo zapisanih znakov
    T_UINT ZapisiOblP(TK_UNICODE format, T_LOCALE locale, va_list parametri);           // Zapie oblikovan niz na tok podatkov (podobno fprintf), vrne tevilo zapisanih znakov

    friend class RPretvornikToka;
    friend class RIzravnalnik;
    friend class RMedpomnilnik;
    friend class RSisTokPodatkov;
    friend class RPomDatoteka;

protected:
    T_STANJE stanje;    // stanje po zadnji operaciji
};


//////////////////////////////////////////////////////////////////////
// RDatoteka
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RDatoteka : virtual public RTokPodatkov
{
public:
    virtual T_SIZE PreberiOstanek(T_KAZALEC &p, T_SIZE dolzina_max = T_SIZE_MAX);               // Prebere ostanek toka v pomnilnik (Po uporabi sprosti pomnilnik z afree())

    virtual T_ODMIK Prestavi(T_RODMIK odmik, T_DATNACINODMIKA kako = RDAT_OD_ZACETKA) = 0;      // Prestavi relativni poloaj kazalca v datoteki, vrne nov absolutni odmik
    virtual T_STANJE Preskoci(T_DOLZINA koliko);                                                // Preskoi eleno tevilo bajtov v datoteki
    virtual T_ODMIK VrniOdmik() = 0;                                                            // Vrne absolutni odmik kazalca v datoteki

    virtual T_STANJE ZakleniObmocje(T_ODMIK odmik, T_DOLZINA dolzina);                          // Zaklene obmoje datoteke za vse dostope
    virtual T_STANJE OdkleniObmocje(T_ODMIK odmik, T_DOLZINA dolzina);                          // Odklene obmoje datoteke za vse dostope

    virtual T_DOLZINA VrniDolzino() const = 0;                                                  // Vrne dolino datoteke
    virtual T_STANJE PostaviKonec() = 0;                                                        // Postavi konec datoteke na trenutnemu kazalcu - odree datoteko od trenutnega kazalca do konca

    virtual T_TRENUTEK VrniDatumStvaritve() const;                                              // Vrne datum stvaritve datoteke
    virtual T_TRENUTEK VrniDatumDostopa() const;                                                // Vrne datum zadnjega dostopa do datoteke
    virtual T_TRENUTEK VrniDatumPisanja() const;                                                // Vrne datum zadnjega pisanja v datoteko

    virtual T_STANJE NastaviDatumStvaritve(T_TRENUTEK datum);                                   // Nastavi datum stvaritve datoteke
    virtual T_STANJE NastaviDatumDostopa(T_TRENUTEK datum);                                     // Nastavi datum zadnjega dostopa do datoteke
    virtual T_STANJE NastaviDatumPisanja(T_TRENUTEK datum);                                     // Nastavi datum zadnjega pisanja v datoteko

    inline LPSAFEARRAY VrniSAFEARRAY();                                                         // Ustvari tabelo SAFEARRAY(VT_UI1) in njeno vsebino napolni s celotno vsebino datoteke

    inline T_ODMIK PrestaviZac(T_ODMIK odmik)   { return Prestavi(odmik, RDAT_OD_ZACETKA); }    // Prestavi poloaj kazalca v datoteki od zaetka, vrne nov absolutni odmik
    inline T_ODMIK PrestaviTren(T_RODMIK odmik) { return Prestavi(odmik, RDAT_OD_TRENUTNEGA); } // Prestavi poloaj kazalca v datoteki relativno od trenutnega poloaja, vrne nov absolutni odmik
    inline T_ODMIK PrestaviKon(T_RODMIK odmik)  { return Prestavi(odmik, RDAT_OD_KONCA); }      // Prestavi poloaj kazalca v datoteki relativno od konca, vrne nov absolutni odmik

    inline T_KODNASTRAN DolociKodnoStran(T_KODNASTRAN privzeta_kodna_stran = AOSN_PRIVZETI_CP); // Skua doloiti kodno stran tekstovne datoteke glede na prisotnost zapisa RDAT_UNICODE_TXT_ID ali RDAT_UTF8_TXT_ID.
};


//////////////////////////////////////////////////////////////////////
// RPodvojevalnikToka
//////////////////////////////////////////////////////////////////////

#pragma warning(push)
#pragma warning(disable: 4251)

class AOSN_CLASS RPodvojevalnikToka : virtual public RTokPodatkov
{
public:
    RPodvojevalnikToka();
    virtual ~RPodvojevalnikToka();

    T_STANJE Dodaj(RTokPodatkov *cilj);                                     // Doda cilj na spisek za zapisovanje
    T_STANJE Odstrani(RTokPodatkov *cilj);                                  // Odstrani cilj s spiska za zapisovanje

    virtual T_SIZE Preberi(T_KAZALEC podatki, T_SIZE dolzina);              // Prebere blok podatkov iz toka, vrne tevilo prebranih bajtov
    virtual T_SIZE Zapisi(TK_KAZALEC podatki, T_SIZE dolzina);              // Zapie blok podatkov na tok, vrne tevilo zapisanih bajtov

    virtual T_STANJE Zapri();                                               // Zapre podvojevalnik

    virtual T_STANJE Izplakni();                                            // Izplakne podvojevalnik

protected:
#ifdef AOSN_NIT
    class RCiljnaNit : public RNit
    {
    public:
        RCiljnaNit(RTokPodatkov *cilj = NULL);

    protected:
        virtual T_REZULTAT Izvedi(T_KAZALEC param); // Osrednja metoda, ki predstavlja telo niti

    public:
        RTokPodatkov *cilj;             // kazalec na dejanski tok podatkov
        volatile T_SIZE zapisano;       // tevilo zapisanih bajtov
        volatile enum {
            KONCAJ = 0,
            ZAPISI,
            ZAPRI,
            IZPLAKNI,
        } ukaz;                         // ukaz za nit
        volatile TK_KAZALEC podatki;    // kazalec na podatke za zapisovanje
        volatile T_SIZE dolzina;        // dolina podatkov (v bajtih)
        RDogodek
            zacni,                      // dogodek, ki sporoa niti, naj zane (pisanje ali zakljuitev)
            koncano;                    // dogodek, s katerim nit pove, da je konala pisanje
    };

    RDinTabela<RCiljnaNit*> cilji;      // tabela kazalcev na niti, ki zapisujejo podatke
    RDinTabela<T_ROCICAOS> koncanje;    // tabela roic za akanje na konec zapisovanja
#else
    RSeznam<RTokPodatkov*> cilji;
#endif
};

#pragma warning(pop)


//////////////////////////////////////////////////////////////////////
// RPretvornikToka
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RPretvornikToka : virtual public RTokPodatkov
{
public:
    RPretvornikToka(RTokPodatkov *izvor = NULL);
    virtual ~RPretvornikToka();

    virtual T_STANJE Uporabi(RTokPodatkov *izvor);                          // Pripne pretvornik na dani tok podatkov
    virtual RTokPodatkov* Odpusti();                                        // Izplakne pretvornik in odpusti tok podatkov iz njegove uporabe

    virtual T_SIZE Preberi(T_KAZALEC podatki, T_SIZE dolzina);              // Prebere blok podatkov iz toka, vrne tevilo prebranih bajtov
    virtual T_SIZE Zapisi(TK_KAZALEC podatki, T_SIZE dolzina);              // Zapie blok podatkov na tok, vrne tevilo zapisanih bajtov

    virtual T_STANJE Zapri();                                               // Zapre pretvornik

    virtual T_STANJE Izplakni();                                            // Izplakne pretvornik

protected:
    RTokPodatkov *izvor;
};


//////////////////////////////////////////////////////////////////////
// RIzravnalnik
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RIzravnalnik : virtual public RPretvornikToka
{
public:
    RIzravnalnik(RTokPodatkov *izvor = NULL, T_SIZE dolzina_branja = RDAT_DOLZINA_IZRAVNALNIKA, T_SIZE dolzina_pisanja = RDAT_DOLZINA_IZRAVNALNIKA);
    virtual ~RIzravnalnik();

    inline T_STANJE NastaviDolzinoBranja(T_SIZE dolzina_branja);            // Nastavi dolino medpomnilnika za branje iz izvornega toka podatkov
    inline T_STANJE NastaviDolzinoPisanja(T_SIZE dolzina_pisanja);          // Nastavi dolino medpomnilnika za pisanje na izvorni tok podatkov

    virtual T_STANJE Uporabi(RTokPodatkov *izvor);                          // Pripne izravnalnik na dani tok podatkov
    virtual RTokPodatkov* Odpusti();                                        // Izplakne izravnalnik in odpusti tok podatkov iz njegove uporabe

    virtual T_SIZE Preberi(T_KAZALEC podatki, T_SIZE dolzina);              // Prebere blok podatkov iz toka, vrne tevilo prebranih bajtov
    virtual T_SIZE Zapisi(TK_KAZALEC podatki, T_SIZE dolzina);              // Zapie blok podatkov na tok, vrne tevilo zapisanih bajtov

    virtual T_STANJE Izplakni();                                            // Izplakne podatke v izravnalniku in izvoru

protected:
    T_STANJE IzplakniIzravnalnik();                                         // Izplakne podatke v izravnalniku

    struct {
        T_KAZALEC podatki;
        T_SIZE dolzina, zasedeno;
        T_UINT odmik;
    } izravnalnik[2];
};


//////////////////////////////////////////////////////////////////////
// ROmejenTokPodatkov
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS ROmejenTokPodatkov : virtual public RPretvornikToka
{
public:
    ROmejenTokPodatkov(RTokPodatkov *izvor = NULL, T_DOLZINA dolzina_branja = 0, T_DOLZINA dolzina_pisanja = 0);

    inline T_VOID NastaviDolzinoBranja(T_DOLZINA dolzina_branja);
    inline T_VOID NastaviDolzinoPisanja(T_DOLZINA dolzina_pisanja);
    inline T_DOLZINA VrniDolzinoBranja() const;
    inline T_DOLZINA VrniDolzinoPisanja() const;

    virtual T_SIZE Preberi(T_KAZALEC podatki, T_SIZE dolzina);              // Prebere blok podatkov iz toka, vrne tevilo prebranih bajtov
    virtual T_SIZE Zapisi(TK_KAZALEC podatki, T_SIZE dolzina);              // Zapie blok podatkov na tok, vrne tevilo zapisanih bajtov

protected:
    T_DOLZINA
        dolzina_branja,     // tevilo bajtov, ki jih uporabnik e lahko prebere s toka
        dolzina_pisanja;    // tevilo bajtov, ki jih uporabnik e lahko zapie na tok
};


//////////////////////////////////////////////////////////////////////
// RMedpomnilnik
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RMedpomnilnik : virtual public RDatoteka
{
public:
    RMedpomnilnik();
    RMedpomnilnik(RDatoteka *izvor, T_SIZE dolzina_bloka = RDAT_DOLZINA_MEDPOMNILNIKA);
    virtual ~RMedpomnilnik();

    T_STANJE Uporabi(RDatoteka *izvor, T_SIZE dolzina_bloka = RDAT_DOLZINA_MEDPOMNILNIKA);
    RDatoteka* Odpusti();

    virtual T_SIZE Preberi(T_KAZALEC podatki, T_SIZE dolzina);                  // Prebere blok podatkov iz toka, vrne tevilo prebranih bajtov
    virtual T_SIZE Zapisi(TK_KAZALEC podatki, T_SIZE dolzina);                  // Zapie blok podatkov na tok, vrne tevilo zapisanih bajtov

    virtual T_STANJE Zapri();                                                   // Zapre medpomnilnik

    virtual T_STANJE Izplakni();                                                // Izplakne podatke v medpomnilniku

    virtual T_ODMIK Prestavi(T_RODMIK odmik, T_DATNACINODMIKA kako = RDAT_OD_ZACETKA);    // Prestavi relativni poloaj kazalca v datoteki, vrne nov absolutni odmik
    virtual T_ODMIK VrniOdmik();                                                // Vrne absolutni odmik kazalca v datoteki

    virtual T_STANJE ZakleniObmocje(T_ODMIK odmik, T_DOLZINA dolzina);          // Zaklene obmoje datoteke za vse dostope
    virtual T_STANJE OdkleniObmocje(T_ODMIK odmik, T_DOLZINA dolzina);          // Odklene obmoje datoteke za vse dostope

    virtual T_DOLZINA VrniDolzino() const;                                      // Vrne dolino datoteke
    virtual T_STANJE PostaviKonec();                                            // Postavi konec datoteke na trenutnemu kazalcu - odree datoteko od trenutnega kazalca do konca

    virtual T_TRENUTEK VrniDatumStvaritve() const;                              // Vrne datum stvaritve datoteke
    virtual T_TRENUTEK VrniDatumDostopa() const;                                // Vrne datum zadnjega dostopa do datoteke
    virtual T_TRENUTEK VrniDatumPisanja() const;                                // Vrne datum zadnjega pisanja v datoteko

    virtual T_STANJE NastaviDatumStvaritve(T_TRENUTEK datum);                   // Nastavi datum stvaritve datoteke
    virtual T_STANJE NastaviDatumDostopa(T_TRENUTEK datum);                     // Nastavi datum zadnjega dostopa do datoteke
    virtual T_STANJE NastaviDatumPisanja(T_TRENUTEK datum);                     // Nastavi datum zadnjega pisanja v datoteko

protected:
    inline T_STANJE IzplakniMedpomnilnik();                                     // Izplakne podatke v medpomnilniku
    inline T_STANJE RazveljaviMedpomnilnik();                                   // Izplakne in razveljavi podatke v medpomnilniku
    inline T_STANJE ZamenjajMedpomnilnik(T_ODMIK zacetek);                      // Izplakne podatke v medpomnilniku in naloi nov blok

    RDatoteka *izvor;
    T_KAZALEC medpomnilnik;
    T_SIZE
        dolzina,        // dolina veljavnih podatkov v medpomnilniku
        dolzina_bloka;  // najveja dolina podatkov v medpomnilniku
    T_BOOL spremenjen;  // logina spremenljivka, ki doloa, ali je bil medpomnilnik spremenjen
    T_ODMIK
        zacetek,        // zaetek medpomnilnika v datoteki
        odmik;          // logini odmik datotenega kazalca v datoteki (merjeno od zaetka datoteke)
#ifdef RDAT_BELEZI_CAS_DOSTOPA_VER
    T_TRENUTEK
        datum_dostopa,  // datum zadnjega dostopa
        datum_pisanja;  // datum pisanja v datoteko
#endif
};


//////////////////////////////////////////////////////////////////////
// RSisTokPodatkov
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RSisTokPodatkov : virtual public RTokPodatkov, virtual public RSisElement
{
public:
    RSisTokPodatkov(T_ROCICAOS rocica = NEVELJAVNA_ROCICA);
    virtual ~RSisTokPodatkov();

    virtual T_STANJE Uporabi(T_ROCICAOS rocica);                            // Pripne tok podatkov na dano roico
    virtual T_ROCICAOS Odpusti();                                           // Vrne roico in razpusti tok podatkov

    virtual T_SIZE Preberi(T_KAZALEC podatki, T_SIZE dolzina);              // Prebere blok podatkov iz toka, vrne tevilo prebranih bajtov
    virtual T_SIZE Zapisi(TK_KAZALEC podatki, T_SIZE dolzina);              // Zapie blok podatkov na tok, vrne tevilo zapisanih bajtov

    virtual T_STANJE Zapri();                                               // Zapre tok podatkov

    virtual T_STANJE Izplakni();                                            // Izplakne podatke v medpomnilniku

    T_UINT VrniAtribute();                                                  // Vrne atribute sistemskega toka podatkov
    T_STANJE VrniAtribute(T_UINT *atributi, T_TRENUTEK *cas_stvaritve = NULL, T_TRENUTEK *cas_dostopa = NULL, T_TRENUTEK *cas_pisanja = NULL, T_DOLZINA *dolzina = NULL);                       // Vrne atribute sistemskega toka podatkov
    static T_UINT VrniAtribute(TK_NIZ ime);                                 // Vrne atribute sistemskega toka podatkov
    static T_STANJE VrniAtribute(TK_NIZ ime, T_UINT *atributi, T_TRENUTEK *cas_stvaritve = NULL, T_TRENUTEK *cas_dostopa = NULL, T_TRENUTEK *cas_pisanja = NULL, T_DOLZINA *dolzina = NULL);    // Vrne atribute sistemskega toka podatkov

    static T_STANJE NastaviAtribute(TK_NIZ ime, T_UINT maska, T_UINT atributi);    // Nastavi atribute sistemskemu toku podatkov
};


//////////////////////////////////////////////////////////////////////
// RIzrSisTokPodatkov
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RIzrSisTokPodatkov : virtual public RIzravnalnik
{
public:
    RIzrSisTokPodatkov(T_ROCICAOS rocica = NEVELJAVNA_ROCICA, T_SIZE dolzina_branja = RDAT_DOLZINA_IZRAVNALNIKA, T_SIZE dolzina_pisanja = RDAT_DOLZINA_IZRAVNALNIKA);
    virtual ~RIzrSisTokPodatkov();

    inline T_STANJE UporabiRocico(T_ROCICAOS rocica);                       // Pripne izvorni tok podatkov na dano roico
    inline T_ROCICAOS OdpustiRocico();                                      // Vrne roico izvornega toka podatkov in ga razpusti

protected:
    RSisTokPodatkov izvor;
};


//////////////////////////////////////////////////////////////////////
// RISequentialStream
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RISequentialStream : public RTokPodatkov
{
public:
    RISequentialStream();
    virtual ~RISequentialStream();

    virtual T_STANJE Uporabi(ISequentialStream *izvor);         // Pripne tok podatkov na dani vmesnik ISequentialStream objekta COM
    virtual ISequentialStream* Odpusti();                       // Vrne kazalec do vmesnika ISequentialStream objekta COM in razpusti tok podatkov

    virtual T_SIZE Preberi(T_KAZALEC podatki, T_SIZE dolzina);  // Prebere blok podatkov iz toka, vrne tevilo prebranih bajtov
    virtual T_SIZE Zapisi(TK_KAZALEC podatki, T_SIZE dolzina);  // Zapie blok podatkov na tok, vrne tevilo zapisanih bajtov

    virtual T_STANJE Zapri();                                   // Zapre tok podatkov

    virtual T_STANJE Izplakni();                                // Izplakne podatke elementa v medpomnilniku

    inline ISequentialStream* VrniIzvor() const;

protected:
    ISequentialStream *izvor;
};


//////////////////////////////////////////////////////////////////////
// RPovezavaASP
//////////////////////////////////////////////////////////////////////

#ifndef WIN32_LEAN_AND_MEAN

class RPovezavaASP : public RTokPodatkov
{
public:
    RPovezavaASP();
    virtual ~RPovezavaASP();

    virtual T_STANJE UporabiZahtevo(IRequest* zahteva);
    virtual IRequest* OdpustiZahtevo();
    virtual T_STANJE UporabiOdgovor(IResponse* odgovor);
    virtual IResponse* OdpustiOdgovor();

    virtual T_SIZE Preberi(T_KAZALEC podatki, T_SIZE dolzina);  // Prebere blok podatkov iz toka, vrne tevilo prebranih bajtov
    virtual T_SIZE Zapisi(TK_KAZALEC podatki, T_SIZE dolzina);  // Zapie blok podatkov na tok, vrne tevilo zapisanih bajtov

    virtual T_STANJE Zapri();                                   // Zapre tok podatkov

    virtual T_STANJE Izplakni();                                // Izplakne podatke v medpomnilniku

protected:
    IRequest* zahteva;
    IResponse* odgovor;
};

#endif // WIN32_LEAN_AND_MEAN


//////////////////////////////////////////////////////////////////////
// RFizDatoteka
//////////////////////////////////////////////////////////////////////

#pragma warning(push)
#pragma warning(disable: 4250)

class AOSN_CLASS RFizDatoteka : virtual public RDatoteka, virtual public RSisTokPodatkov
{
public:
    RFizDatoteka(T_ROCICAOS rocica = NEVELJAVNA_ROCICA);
    RFizDatoteka(TK_NIZ ime, T_UINT nacin);
    virtual ~RFizDatoteka();

    T_STANJE Odpri(TK_NIZ ime, T_UINT nacin);                               // Odpre datoteko z danim imenom

    virtual T_ODMIK Prestavi(T_RODMIK odmik, T_DATNACINODMIKA kako = RDAT_OD_ZACETKA);  // Prestavi relativni poloaj kazalca v datoteki, vrne nov absolutni odmik
    virtual T_ODMIK VrniOdmik();                                            // Vrne absolutni odmik kazalca v datoteki

    virtual T_STANJE ZakleniObmocje(T_ODMIK odmik, T_DOLZINA dolzina);      // Zaklene obmoje datoteke za vse dostope
    virtual T_STANJE OdkleniObmocje(T_ODMIK odmik, T_DOLZINA dolzina);      // Odklene obmoje datoteke za vse dostope

    virtual T_DOLZINA VrniDolzino() const;                                  // Vrne dolino datoteke
    virtual T_STANJE PostaviKonec();                                        // Postavi konec datoteke na trenutnemu kazalcu - odree datoteko od trenutnega kazalca do konca

    virtual T_TRENUTEK VrniDatumStvaritve() const;                          // Vrne datum stvaritve datoteke
    virtual T_TRENUTEK VrniDatumDostopa() const;                            // Vrne datum zadnjega dostopa do datoteke
    virtual T_TRENUTEK VrniDatumPisanja() const;                            // Vrne datum zadnjega pisanja v datoteko

    virtual T_STANJE NastaviDatumStvaritve(T_TRENUTEK datum);               // Nastavi datum stvaritve datoteke
    virtual T_STANJE NastaviDatumDostopa(T_TRENUTEK datum);                 // Nastavi datum zadnjega dostopa do datoteke
    virtual T_STANJE NastaviDatumPisanja(T_TRENUTEK datum);                 // Nastavi datum zadnjega pisanja v datoteko
};

#pragma warning(pop)


//////////////////////////////////////////////////////////////////////
// RMedFizDatoteka
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RMedFizDatoteka : virtual public RMedpomnilnik
{
public:
    RMedFizDatoteka(T_ROCICAOS rocica = NEVELJAVNA_ROCICA, T_SIZE dolzina_bloka = RDAT_DOLZINA_MEDPOMNILNIKA);
    RMedFizDatoteka(TK_NIZ ime, T_UINT nacin, T_SIZE dolzina_bloka = RDAT_DOLZINA_MEDPOMNILNIKA);
    virtual ~RMedFizDatoteka();

    inline T_STANJE Uporabi(T_ROCICAOS rocica);                            // Pripne e narejeno roico na datoteko
    inline T_ROCICAOS Odpusti();                                           // Vrne roico in razpusti datoteko

    inline T_STANJE Odpri(TK_NIZ ime, T_UINT nacin);                       // Odpre datoteko z danim imenom
    virtual T_STANJE Zapri();                                              // Zapre datoteko

    inline T_BOOL JeVeljaven() const;                                      // Vrne TRUE, e je roica veljavna

protected:
    RFizDatoteka izvor;
};


//////////////////////////////////////////////////////////////////////
// RPomDatoteka
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RPomDatoteka : virtual public RDatoteka
{
public:
    RPomDatoteka();
    RPomDatoteka(T_SIZE dolzina);
    RPomDatoteka(T_KAZALEC podatki, T_SIZE dolzina, T_BOOL upravljaj = FALSE);
    RPomDatoteka(TK_NIZ ime, T_UINT nacin);
    virtual ~RPomDatoteka();

    T_STANJE RezervirajDolzino(T_SIZE zeljeno, T_BOOL tesno = FALSE);       // Rezervira eleno delovnega pomnilnika
    T_STANJE Nalozi(TK_NIZ ime, T_UINT nacin);                              // Zaetni pomnilnik naloi iz datoteke
    T_STANJE Uporabi(T_KAZALEC podatki, T_SIZE dolzina, T_BOOL upravljaj);  // Pripne datoteko na e rezerviran kos pomnilnika
    T_STANJE Uporabi(LPSAFEARRAY sa);                                       // Pripne datoteko na tabelo SAFEARRAY (potem uporabi Odpusti(SAFEARRAY *sa) za odpuanje podatkov!!!)
    T_KAZALEC Odpusti();                                                    // Vrne kazalec na podatke in razpusti datoteko (predhodno klii VrniDolzino(), e potrebuje dolino podatkov)
    T_VOID Odpusti(LPSAFEARRAY sa);                                         // Vrne kazalec na podatke in razpusti datoteko (tudi odklene SAFEARRAY)
    inline const T_VOID* VrniPodatke() const;                               // Vrne kazalec na podatke, a jih ne odpusti

    virtual T_SIZE Preberi(T_KAZALEC podatki, T_SIZE dolzina);              // Prebere blok podatkov iz datoteke, vrne tevilo prebranih bajtov
    virtual T_SIZE Zapisi(TK_KAZALEC podatki, T_SIZE dolzina);              // Zapie blok podatkov v datoteko, vrne tevilo zapisanih bajtov

    virtual T_STANJE Zapri();                                               // Zapre datoteko

    virtual T_STANJE Izplakni();                                            // Izplakne podatke v medpomnilniku

    virtual T_ODMIK Prestavi(T_RODMIK odmik, T_DATNACINODMIKA kako = RDAT_OD_ZACETKA);  // Prestavi relativni poloaj kazalca v datoteki, vrne nov absolutni odmik
    virtual T_ODMIK VrniOdmik();                                            // Vrne absolutni odmik kazalca v datoteki

    virtual T_DOLZINA VrniDolzino() const;                                  // Vrne dolino datoteke
    virtual T_STANJE PostaviKonec();                                        // Postavi konec datoteke na trenutnemu kazalcu - odree datoteko od trenutnega kazalca do konca

#ifdef RDAT_BELEZI_CAS_DOSTOPA_VER
    virtual T_TRENUTEK VrniDatumStvaritve() const;                          // Vrne datum stvaritve datoteke
    virtual T_TRENUTEK VrniDatumDostopa() const;                            // Vrne datum zadnjega dostopa do datoteke
    virtual T_TRENUTEK VrniDatumPisanja() const;                            // Vrne datum zadnjega pisanja v datoteko

    virtual T_STANJE NastaviDatumStvaritve(T_TRENUTEK datum);               // Nastavi datum stvaritve datoteke
    virtual T_STANJE NastaviDatumDostopa(T_TRENUTEK datum);                 // Nastavi datum zadnjega dostopa do datoteke
    virtual T_STANJE NastaviDatumPisanja(T_TRENUTEK datum);                 // Nastavi datum zadnjega pisanja v datoteko
#endif

    inline T_ODMIK PrestaviZac(T_ODMIK odmik);                              // Prestavi poloaj kazalca v datoteki od zaetka, vrne nov absolutni odmik
    inline T_ODMIK PrestaviTren(T_RODMIK odmik);                            // Prestavi poloaj kazalca v datoteki relativno od trenutnega poloaja, vrne nov absolutni odmik
    inline T_ODMIK PrestaviKon(T_RODMIK odmik);                             // Prestavi poloaj kazalca v datoteki relativno od konca, vrne nov absolutni odmik

    inline T_STANJE ZapisiBajt(T_U1 bajt, T_SIZE koliko = 1);                           // Zapie eleno tevilo bajtov
    inline T_DOLZINA ZapisiTok(RTokPodatkov &tok, T_DOLZINA koliko = (T_DOLZINA)-1);    // Zapie vsebino drugega toka v datoteko, vrne tevilo zapisanih bajtov

    T_UINT ZapisiObl(TK_ASCII format, T_LOCALE locale, ...);                    // Zapie oblikovan niz na tok podatkov (podobno fprintf), vrne tevilo zapisanih znakov
    T_UINT ZapisiObl(TK_UNICODE format, T_LOCALE locale, ...);                  // Zapie oblikovan niz na tok podatkov (podobno fprintf), vrne tevilo zapisanih znakov
    T_UINT ZapisiOblP(TK_ASCII format, T_LOCALE locale, va_list parametri);     // Zapie oblikovan niz na tok podatkov (podobno fprintf), vrne tevilo zapisanih znakov
    T_UINT ZapisiOblP(TK_UNICODE format, T_LOCALE locale, va_list parametri);   // Zapie oblikovan niz na tok podatkov (podobno fprintf), vrne tevilo zapisanih znakov

    inline T_VOID Nastavi(T_ODMIK odmik, const T_1 podatek);
    inline T_VOID Nastavi(T_ODMIK odmik, const T_2 podatek);
    inline T_VOID Nastavi(T_ODMIK odmik, const T_4 podatek);
    inline T_VOID Nastavi(T_ODMIK odmik, const T_8 podatek);
    inline T_VOID Nastavi(T_ODMIK odmik, const T_U1 podatek);
    inline T_VOID Nastavi(T_ODMIK odmik, const T_U2 podatek);
    inline T_VOID Nastavi(T_ODMIK odmik, const T_U4 podatek);
    inline T_VOID Nastavi(T_ODMIK odmik, const T_U8 podatek);
#ifdef _NATIVE_SIZE_T_DEFINED
    inline T_VOID Nastavi(T_ODMIK odmik, const T_SIZE podatek);
#endif
    inline T_VOID Nastavi(T_ODMIK odmik, const T_FLOAT podatek);
    inline T_VOID Nastavi(T_ODMIK odmik, const T_DOUBLE podatek);
    inline T_VOID Nastavi(T_ODMIK odmik, const T_AZNAK podatek);
#ifdef _NATIVE_WCHAR_T_DEFINED
    inline T_VOID Nastavi(T_ODMIK odmik, const T_UZNAK podatek);
#endif

    inline T_VOID Vrni(T_ODMIK odmik, T_1 &podatek);
    inline T_VOID Vrni(T_ODMIK odmik, T_2 &podatek);
    inline T_VOID Vrni(T_ODMIK odmik, T_4 &podatek);
    inline T_VOID Vrni(T_ODMIK odmik, T_8 &podatek);
    inline T_VOID Vrni(T_ODMIK odmik, T_U1 &podatek);
    inline T_VOID Vrni(T_ODMIK odmik, T_U2 &podatek);
    inline T_VOID Vrni(T_ODMIK odmik, T_U4 &podatek);
    inline T_VOID Vrni(T_ODMIK odmik, T_U8 &podatek);
#ifdef _NATIVE_SIZE_T_DEFINED
    inline T_VOID Vrni(T_ODMIK odmik, T_SIZE &podatek);
#endif
    inline T_VOID Vrni(T_ODMIK odmik, T_FLOAT &podatek);
    inline T_VOID Vrni(T_ODMIK odmik, T_DOUBLE &podatek);
    inline T_VOID Vrni(T_ODMIK odmik, T_AZNAK &podatek);
#ifdef _NATIVE_WCHAR_T_DEFINED
    inline T_VOID Vrni(T_ODMIK odmik, T_UZNAK &podatek);
#endif

    template <class TIP> friend inline RPomDatoteka& _Zapisi(RPomDatoteka &tok, const TIP podatek);
    template <class TIP> friend inline RPomDatoteka& _Preberi(RPomDatoteka &tok, TIP &podatek);
    friend inline RPomDatoteka& _ZapisiNiz(RPomDatoteka &tok, TK_ASCII podatek);
    friend inline RPomDatoteka& _ZapisiNiz(RPomDatoteka &tok, TK_UNICODE podatek);
    friend inline RPomDatoteka& _PreberiNiz(RPomDatoteka &tok, RNizP<T_AZNAK> &podatek);
    friend inline RPomDatoteka& _PreberiNiz(RPomDatoteka &tok, RNizP<T_UZNAK> &podatek);
    template <class TIP> friend inline T_VOID _Vrni(RPomDatoteka &dat, T_ODMIK odmik, TIP &podatek);
    template <class TIP> friend inline T_VOID _Nastavi(RPomDatoteka &dat, T_ODMIK odmik, const TIP podatek);

#if 1200 <= _MSC_VER && _MSC_VER < 1300
protected:
#else
    // VC++ 5.0 in 7.0 ne znata pravilno upotevati navodila "friend" za predloge, zato v tem primeru nastavimo vse na public.
public:
#endif
    T_U1   *podatki;            // kazalec na podatke
    T_BOOL upravljaj;           // logina spremenljivka, ki doloa ali sme razred sam upravljati z blokom podatkov (arealloc)

    // Odmik in dolino definiramo le z 32 biti, eprav bi ju morali z 64, kot dediino razreda RDatoteka.
    // Uporabimo raje assert-e za preverjanje 4 GB meje. Popravili bomo, ko bodo na voljo 64-bitni procesorji.
    T_UINT odmik;               // odmik datotenega kazalca
    T_SIZE dolzina;             // dolina datoteke
    T_SIZE fiz_dolzina;         // fizina dolina rezerviranega bloka podatkov
#ifdef RDAT_BELEZI_CAS_DOSTOPA_VER
    T_TRENUTEK
        datum_stvaritve,        // datum stvaritve datoteke
        datum_dostopa,          // datum zadnjega dostopa do datoteke
        datum_pisanja;          // datum zadnjega pisanja v datoteko
#endif
};

inline RPomDatoteka& operator <<(RPomDatoteka &tok, const T_1       podatek);
inline RPomDatoteka& operator >>(RPomDatoteka &tok,       T_1      &podatek);
inline RPomDatoteka& operator <<(RPomDatoteka &tok, const T_2       podatek);
inline RPomDatoteka& operator >>(RPomDatoteka &tok,       T_2      &podatek);
inline RPomDatoteka& operator <<(RPomDatoteka &tok, const T_4       podatek);
inline RPomDatoteka& operator >>(RPomDatoteka &tok,       T_4      &podatek);
inline RPomDatoteka& operator <<(RPomDatoteka &tok, const T_8       podatek);
inline RPomDatoteka& operator >>(RPomDatoteka &tok,       T_8      &podatek);
inline RPomDatoteka& operator <<(RPomDatoteka &tok, const T_U1      podatek);
inline RPomDatoteka& operator >>(RPomDatoteka &tok,       T_U1     &podatek);
inline RPomDatoteka& operator <<(RPomDatoteka &tok, const T_U2      podatek);
inline RPomDatoteka& operator >>(RPomDatoteka &tok,       T_U2     &podatek);
inline RPomDatoteka& operator <<(RPomDatoteka &tok, const T_U4      podatek);
inline RPomDatoteka& operator >>(RPomDatoteka &tok,       T_U4     &podatek);
inline RPomDatoteka& operator <<(RPomDatoteka &tok, const T_U8      podatek);
inline RPomDatoteka& operator >>(RPomDatoteka &tok,       T_U8     &podatek);
#ifdef _NATIVE_SIZE_T_DEFINED
inline RPomDatoteka& operator <<(RPomDatoteka &tok, const T_SIZE    podatek);
inline RPomDatoteka& operator >>(RPomDatoteka &tok,       T_SIZE   &podatek);
#endif
inline RPomDatoteka& operator <<(RPomDatoteka &tok, const T_FLOAT   podatek);
inline RPomDatoteka& operator >>(RPomDatoteka &tok,       T_FLOAT  &podatek);
inline RPomDatoteka& operator <<(RPomDatoteka &tok, const T_DOUBLE  podatek);
inline RPomDatoteka& operator >>(RPomDatoteka &tok,       T_DOUBLE &podatek);
inline RPomDatoteka& operator <<(RPomDatoteka &tok, const T_AZNAK   podatek);
inline RPomDatoteka& operator >>(RPomDatoteka &tok,       T_AZNAK  &podatek);
#ifdef _NATIVE_WCHAR_T_DEFINED
inline RPomDatoteka& operator <<(RPomDatoteka &tok, const T_UZNAK  podatek);
inline RPomDatoteka& operator >>(RPomDatoteka &tok,       T_UZNAK &podatek);
#endif
inline RPomDatoteka& operator <<(RPomDatoteka &tok, TK_ASCII        podatek);
inline RPomDatoteka& operator >>(RPomDatoteka &tok, RNizP<T_AZNAK> &podatek);
inline RPomDatoteka& operator <<(RPomDatoteka &tok, TK_UNICODE      podatek);
inline RPomDatoteka& operator >>(RPomDatoteka &tok, RNizP<T_UZNAK> &podatek);


//////////////////////////////////////////////////////////////////////
// RFifoTokPodatkov
//////////////////////////////////////////////////////////////////////

#ifdef AOSN_FIFO

#pragma warning(push)
#pragma warning(disable: 4251)

class AOSN_CLASS RFifoTokPodatkov : public RTokPodatkov {
public:
    RFifoTokPodatkov();
    virtual ~RFifoTokPodatkov();

    virtual T_SIZE Preberi(T_KAZALEC podatki, T_SIZE dolzina);
    virtual T_SIZE Zapisi(TK_KAZALEC podatki, T_SIZE dolzina);
    virtual T_STANJE Zapri();
    virtual T_STANJE Izplakni();

    inline T_SIZE VrniDolzino() const { return dolzina; };  // Vrne skupno dolino podatkov v vrsti

protected:
    T_SIZE odmik, dolzina;
    RSeznam<T_BINBLOK> vrsta;
};

#pragma warning(pop)

#endif


//////////////////////////////////////////////////////////////////////
// RDiagDatoteka
//////////////////////////////////////////////////////////////////////

#ifdef _DEBUG

class AOSN_CLASS RDiagDatoteka : public RDatoteka {
public:
    RDiagDatoteka(RDatoteka * const *datoteke, T_UINT st_datotek);
    virtual ~RDiagDatoteka();

    virtual T_SIZE Preberi(T_KAZALEC podatki, T_SIZE dolzina);          // Prebere blok podatkov iz toka, vrne tevilo prebranih bajtov
    virtual T_SIZE Zapisi(TK_KAZALEC podatki, T_SIZE dolzina);          // Zapie blok podatkov na tok, vrne tevilo zapisanih bajtov
    virtual T_STANJE Izplakni();                                        // Izplakne podatke elementa v medpomnilniku

    virtual T_STANJE Zapri();                                           // Zapre tok podatkov

    virtual T_ODMIK Prestavi(T_RODMIK odmik, T_DATNACINODMIKA kako = RDAT_OD_ZACETKA);  // Prestavi relativni poloaj kazalca v datoteki, vrne nov absolutni odmik
    virtual T_ODMIK VrniOdmik();                                        // Vrne absolutni odmik kazalca v datoteki

    virtual T_STANJE ZakleniObmocje(T_ODMIK odmik, T_DOLZINA dolzina);  // Zaklene obmoje datoteke za vse dostope
    virtual T_STANJE OdkleniObmocje(T_ODMIK odmik, T_DOLZINA dolzina);  // Odklene obmoje datoteke za vse dostope

    virtual T_DOLZINA VrniDolzino() const;                              // Vrne dolino datoteke
    virtual T_STANJE PostaviKonec();                                    // Postavi konec datoteke na trenutnemu kazalcu - odree datoteko od trenutnega kazalca do konca

protected:
    RDatoteka **datoteke;   // tabela kazalcev na datoteke
    T_UINT st_datotek;      // tevilo datotek

    T_KAZALEC podatki;      // blok pomonih podatkov za delo
    T_SIZE dolzina;         // dolina bloka
};

#endif


//////////////////////////////////////////////////////////////////////
// T_IDPODATKI
//////////////////////////////////////////////////////////////////////

template <class TIP, class TIP_ID, class TIP_DOLZINA, unsigned int PORAVNAVA> struct AOSN_TEMPLATE T_IDPODATKI
{
    T_IDPODATKI(TIP &podatki);
    T_IDPODATKI(const TIP &podatki);

    inline const T_IDPODATKI<TIP, TIP_ID, TIP_DOLZINA, PORAVNAVA>& operator =(const T_IDPODATKI<TIP, TIP_ID, TIP_DOLZINA, PORAVNAVA> &zapis);

    inline static T_ODMIK OdpriGlavo(RDatoteka &dat);
    inline static T_ODMIK ZapriGlavo(RDatoteka &dat, T_ODMIK zacetek);
    template <class TOK> inline static T_STANJE NajdiGlavo(TOK &dat, T_ODMIK konec_bloka = T_ODMIK_MAX) { return _NajdiGlavo<TIP_ID, TIP_DOLZINA, PORAVNAVA, TOK>(dat, id, konec_bloka); }

    static const TIP_ID id; // id strukture za zapisovanje na tok podatkov
    TIP &podatki;           // referenca na podatke
};

template <class TIP, class TIP_ID, class TIP_DOLZINA, unsigned int PORAVNAVA> inline RTokPodatkov& operator <<(RTokPodatkov &tok, const T_IDPODATKI<TIP, TIP_ID, TIP_DOLZINA, PORAVNAVA> zapis);
template <class TIP, class TIP_ID, class TIP_DOLZINA, unsigned int PORAVNAVA> inline RDatoteka   & operator <<(RDatoteka    &tok, const T_IDPODATKI<TIP, TIP_ID, TIP_DOLZINA, PORAVNAVA> zapis);
template <class TIP, class TIP_ID, class TIP_DOLZINA, unsigned int PORAVNAVA> inline RTokPodatkov& operator >>(RTokPodatkov &tok,       T_IDPODATKI<TIP, TIP_ID, TIP_DOLZINA, PORAVNAVA> zapis);
template <class TIP, class TIP_ID, class TIP_DOLZINA, unsigned int PORAVNAVA> inline RDatoteka   & operator >>(RDatoteka    &tok,       T_IDPODATKI<TIP, TIP_ID, TIP_DOLZINA, PORAVNAVA> zapis);


#ifdef AOSN_BASE64

//////////////////////////////////////////////////////////////////////
// RBase64
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RBase64 : virtual public RElement
{
public:
    RBase64();

    T_UINT Kodiraj(TK_KAZALEC podatki, T_SIZE dolzina, RNizP<T_AZNAK> &izhod, T_BOOL zadnji = TRUE);    // Kodira blok podatkov in ga prilepi v niz in vrne stevilo znakov
    T_UINT Kodiraj(TK_KAZALEC podatki, T_SIZE dolzina, T_ASCII izhod, T_BOOL zadnji = TRUE);            // Kodira blok podatkov v niz in vrne stevilo znakov niza
    T_UINT Kodiraj(TK_KAZALEC podatki, T_SIZE dolzina, RTokPodatkov &izhod, T_BOOL zadnji = TRUE);      // Kodira blok podatkov in ga prilepi na tok podatkov in vrne stevilo znakov
    T_SIZE DeKodiraj(TK_ASCII podatki, RTokPodatkov &izhod, T_BOOL &zadnji);                            // Dekodira niz in ga prilepi na tok podatkov
    T_SIZE DeKodiraj(TK_ASCII podatki, T_KAZALEC izhod, T_BOOL &zadnji);                                // Dekodira niz v blok podatkov

    inline T_VOID Sprazni();                                // Resetira stanje kodeka

    // metode za izracun / oceno dolzine kodiranega / dekodiranega bloka
    inline T_UINT VrniKodDolzino(T_SIZE dolzina) const;     // Vrne dolzino niza kodiranega bloka, ce je znana dolzina nekodiranega bloka
    inline T_SIZE VrniDeKodDolzino(T_UINT dolzina) const;   // Vrne zgornjo mejo dolzine dekodiranega bloka, ce je znana dolzina niza kodiranega bloka

protected:
    T_BYTE k_pom[3];
    T_UINT k_stevilo;

    T_BYTE d_pom[4];
    T_UINT d_stevilo;
};


//////////////////////////////////////////////////////////////////////
// RBase64Tok
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RBase64Tok : virtual public RPretvornikToka, virtual protected RBase64
{
public:
    RBase64Tok(T_UINT max_blokov = 19, RTokPodatkov *izvor = NULL);

    virtual T_STANJE Uporabi(RTokPodatkov *izvor);
    virtual RTokPodatkov* Odpusti();

    virtual T_SIZE Preberi(T_KAZALEC podatki, T_SIZE dolzina);
    virtual T_SIZE Zapisi(TK_KAZALEC podatki, T_SIZE dolzina);

protected:
    T_BYTE
        pom[3];         // pomozni pomnilnik
    T_UINT
        pom_odmik,      // odmik, na katerem se zacnejo podatki v pomoznem pomnilniku
        pom_dolzina,    // stevilo bajtov podatkov v pomoznem pomnilniku
        max_blokov,     // najvecje stevilo blokov Base64 (4 znaki), ki jih zapisujemo brez preloma vrstice (T_UINT_MAX brez preloma vrstice)
        st_blokov;      // stevilo blokov Base64 (4 znaki), ki smo jih ze zapisali s prelomom vrstice
};

#endif // AOSN_BASE64


#ifdef AOSN_VTIC

//////////////////////////////////////////////////////////////////////
// RVticnica
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RVticnica : public RTokPodatkov
{
public:
    RVticnica(T_VTICNICA vticnica = NEVELJAVNA_VTICNICA);
    virtual ~RVticnica();

    T_STANJE Odpri(T_VTICDOMENA domena = VTIC_INET, T_VTICVRSTA vrsta = VTIC_PRETOCNI, T_INT protokol = VTIC_PROTOKOL_IP); // Odpre novo vticnico
    T_STANJE Uporabi(T_VTICNICA vticnica);                                                      // Uporabi narejeno vticnico
    T_VTICNICA Odpusti();                                                                       // Odpusti narejeno vticnico

    // metoda za prijavo odjemalca na streznik
    T_STANJE Povezi(const T_SOCKADDR *naslov, T_SIZE dolzina);                                  // Poveze narejeno vticnico z oddaljeno vticnico

    // metode za pripravo streznika in sprejem odjemalcev
    T_STANJE Privezi(const T_SOCKADDR *naslov, T_SIZE dolzina);                                 // Priveze narejeno vticnico na dani vmesnik
    T_STANJE Poslusaj(T_UINT najvec_klientov = NESKONCNO);                                      // Pripravi privezano vticnico za sprejemanje odjemalcev
    T_STANJE Sprejmi(RVticnica &odjemalec, T_SOCKADDR *naslov = NULL, T_SIZE *dolzina = NULL);  // Pocaka in sprejme prvega odjemalca
    T_STANJE Zakljuci(T_VTICNACINZAPIRANJA nacin);                                              // Zakljuci delo z vticnico

    // metode za delno izmenjavo podatkov
    T_SIZE Prejmi(T_KAZALEC podatki, T_SIZE dolzina, T_UINT nacin = 0);                         // Prejme podatke iz vticnice, kolikor jih je na voljo
    T_SIZE Poslji(TK_KAZALEC podatki, T_SIZE dolzina, T_UINT nacin = 0);                        // Poslje podatke na vticnico, kolikor jih bo sprejela

    T_STANJE VrniNaslovVticnice(T_SOCKADDR *naslov, T_SIZE *dolzina);                           // Vrne naslov, na kateremu je vticnica
    T_STANJE VrniNaslovVrstnika(T_SOCKADDR *naslov, T_SIZE *dolzina);                           // Vrne naslov, na katerega je povezana vticnica

    T_STANJE NastaviParameter(T_VTICPARAMETER parameter, const T_VOID* vrednost, T_SIZE dolzina, T_VTICNIVOPARAM nivo = VTIC_NP_VTICNICA); // Nastavi parameter vticnice
    T_STANJE VrniParameter(T_VTICPARAMETER parameter, T_KAZALEC vrednost, T_UINT *dolzina, T_VTICNIVOPARAM nivo = VTIC_NP_VTICNICA);       // Vrne parameter vticnica

    virtual T_SIZE Preberi(T_KAZALEC podatki, T_SIZE dolzina);                                  // Prebere blok iz vticnice
    virtual T_SIZE Zapisi(TK_KAZALEC podatki, T_SIZE dolzina);                                  // Zapise blok na vticnico

    virtual T_STANJE Zapri();                                                                   // Zapre vticnico

    virtual T_STANJE Izplakni();                                                                // Izplakne podatke v medpomnilniku

    inline T_STANJE Privezi(TK_NIZ vmesnik, T_UINT vrata);                                      // Priveze narejeno vticnico na dani vmesnik
    inline T_STANJE Povezi(TK_NIZ vmesnik, T_UINT vrata);                                       // Poveze narejeno vticnico z oddaljeno vticnico

    inline T_BOOL JeVeljaven() const;                                                           // Vrne TRUE, ce je vticnica veljavna
    inline T_VTICNICA Vrni() const;                                                             // Vrne rocico vticnice
    inline operator T_VTICNICA() const;                                                         // Vrne rocico vticnice

    static T_STANJE VrniIme(const T_SOCKADDR_IN *naslov, RNiz &vmesnik, T_UINT *vrata);         // Vrne ime vmesnika (naslov IP, ipd.)
    static T_STANJE VrniNaslov(TK_NIZ vmesnik, T_UINT vrata, T_SOCKADDR_IN *naslov);            // Vrne naslov vmesnika (ce je dan IP, ipd.)
    static T_STANJE PoisciNaslov(TK_NIZ ime, T_U4 *naslov);                                     // Poisce naslov vmesnika IP (DNS)

private:
    T_VTICNICA vticnica;    // rocica vticnice
};

#endif // AOSN_VTIC


#ifdef AOSN_KANAL

//////////////////////////////////////////////////////////////////////
// T_KANNACINODPIRANJA
//////////////////////////////////////////////////////////////////////

enum T_KANNACINODPIRANJA {
    RKAN_BRANJE     = PIPE_ACCESS_INBOUND,
    RKAN_PISANJE    = PIPE_ACCESS_OUTBOUND,
    RKAN_PISI_SKOZI = FILE_FLAG_WRITE_THROUGH
};


//////////////////////////////////////////////////////////////////////
// T_KANNACINKANALA
//////////////////////////////////////////////////////////////////////

enum T_KANNACINKANALA {
    RKAN_BAJT           = PIPE_TYPE_BYTE,
    RKAN_SPOROCILA      = PIPE_TYPE_MESSAGE,
    RKAN_BERI_BAJT      = PIPE_READMODE_BYTE,
    RKAN_BERI_SPOROCILO = PIPE_READMODE_MESSAGE
};


//////////////////////////////////////////////////////////////////////
// RKanal
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RKanal : public RElement
{
public:
    RKanal(T_ROCICAOS vh = NEVELJAVNA_ROCICA, T_ROCICAOS iz = NEVELJAVNA_ROCICA);

    T_STANJE Odpri(T_SIZE dolzina_medpomnilnika = 0);                                                       // Ustvari enosmerni kanal
    static T_STANJE Odpri(RSisTokPodatkov &vhod, RSisTokPodatkov &izhod, T_SIZE dolzina_medpomnilnika = 0); // Ustvari enosmerni kanal in uporabi roici za toka podatkov

    RSisTokPodatkov
        vhod,                       // vhodni konec kanala
        izhod;                      // izhodni konec kanala
};


//////////////////////////////////////////////////////////////////////
// RImenovanKanal
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RImenovanKanal : public RSisTokPodatkov
{
public:
    RImenovanKanal(T_ROCICAOS rocica = NEVELJAVNA_ROCICA);
    virtual ~RImenovanKanal();

    T_STANJE Ustvari(TK_NIZ ime, T_UINT nacin = RKAN_BRANJE | RKAN_PISANJE, T_UINT nacin_instance = RKAN_BAJT | RKAN_BERI_BAJT, T_UINT najvec_klientov = RKAN_NEOMEJENO, T_SIZE izhodni_medpomnilnik = RKAN_DOLZINA_MEDPOMNILNIKA, T_SIZE vhodni_medpomnilnik = RKAN_DOLZINA_MEDPOMNILNIKA, T_UINT naj_cas = RKAN_CASOVNA_KONTROLA);
    T_STANJE Sprejmi();
    T_STANJE Zakljuci();

    T_STANJE VrniNaslovVrstnika(RNiz &naslov) const;  // Vrne naslov, na katerega je povezan kanal
};

#endif // AOSN_KANAL


#ifdef AOSN_ODTISNIK

//////////////////////////////////////////////////////////////////////
// T_ODTIS_MD2
//////////////////////////////////////////////////////////////////////

struct T_ODTIS_MD2
{
    T_U1 podatki[16];
};

inline T_BOOL operator ==(const T_ODTIS_MD2 odtis1, const T_ODTIS_MD2 odtis2);
inline T_BOOL operator !=(const T_ODTIS_MD2 odtis1, const T_ODTIS_MD2 odtis2);
template <class TOK> inline TOK& operator <<(TOK &tok, const T_ODTIS_MD2  odtis);
template <class TOK> inline TOK& operator >>(TOK &tok,       T_ODTIS_MD2 &odtis);


//////////////////////////////////////////////////////////////////////
// T_ODTIS_SHA
//////////////////////////////////////////////////////////////////////

struct T_ODTIS_SHA
{
    T_U1 podatki[20];
};

inline T_BOOL operator ==(const T_ODTIS_SHA odtis1, const T_ODTIS_SHA odtis2);
inline T_BOOL operator !=(const T_ODTIS_SHA odtis1, const T_ODTIS_SHA odtis2);
template <class TOK> inline TOK& operator <<(TOK &tok, const T_ODTIS_SHA  odtis);
template <class TOK> inline TOK& operator >>(TOK &tok,       T_ODTIS_SHA &odtis);


//////////////////////////////////////////////////////////////////////
// ROdtisnik
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS ROdtisnik : public RElement
{
public:
    virtual T_VOID Resetiraj() = 0;
    virtual T_VOID Izracunaj(TK_KAZALEC blok, T_SIZE dolzina) = 0;
    virtual T_VOID Zakljuci() = 0;

    virtual T_STANJE Zapisi(RTokPodatkov &tok) const = 0;
    virtual T_STANJE Preberi(RTokPodatkov &tok) = 0;

    virtual T_SIZE VrniDolzinoOdtisa() = 0;
    virtual const T_VOID* VrniOdtis() = 0;
};


//////////////////////////////////////////////////////////////////////
// ROdtisnikToka
//////////////////////////////////////////////////////////////////////

#pragma warning(push)
#pragma warning(disable: 4512)

class AOSN_CLASS ROdtisnikToka : public RPretvornikToka
{
public:
    ROdtisnikToka(ROdtisnik &odtisnik, RTokPodatkov *izvor = NULL);

    virtual T_STANJE Uporabi(RTokPodatkov *izvor);
    virtual RTokPodatkov* Odpusti();

    virtual T_SIZE Preberi(T_KAZALEC podatki, T_SIZE dolzina);
    virtual T_SIZE Zapisi(TK_KAZALEC podatki, T_SIZE dolzina);

protected:
    ROdtisnik &odtisnik;
};

#pragma warning(pop)

template <class TOK> inline TOK& operator <<(TOK &tok, const RCRC32 &odtis);
template <class TOK> inline TOK& operator >>(TOK &tok,       RCRC32 &odtis);


//////////////////////////////////////////////////////////////////////
// RCRC32
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RCRC32 : public ROdtisnik
{
public:
    RCRC32(T_ODTIS_CRC32 crc = 0);

    virtual T_VOID Resetiraj();
    virtual T_VOID Izracunaj(TK_KAZALEC blok, T_SIZE dolzina);
    virtual T_VOID Zakljuci();

    virtual T_STANJE Zapisi(RTokPodatkov &tok) const;
    virtual T_STANJE Preberi(RTokPodatkov &tok);

    virtual T_SIZE VrniDolzinoOdtisa();
    virtual const T_VOID* VrniOdtis();

    inline const T_ODTIS_CRC32 Vrni() const { return crc; };
    inline operator const T_ODTIS_CRC32() const { return crc; };

protected:
    T_ODTIS_CRC32 crc;
};


//////////////////////////////////////////////////////////////////////
// RBlokovniOdtisnik
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RBlokovniOdtisnik : public ROdtisnik
{
public:
    virtual T_VOID Resetiraj();
    virtual T_VOID Izracunaj(TK_KAZALEC blok, T_SIZE dolzina);

protected:
    virtual T_VOID IzracunajBlok() = 0;

protected:
    T_U4 stevec[2];
    union {
        T_U1 vrsta[64];
        T_U4 delovni[16];
    };
};


//////////////////////////////////////////////////////////////////////
// RMD5
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RMD5 : public RBlokovniOdtisnik
{
public:
    RMD5();

    virtual T_VOID Resetiraj();
    virtual T_VOID Zakljuci();

    virtual T_STANJE Zapisi(RTokPodatkov &tok) const;
    virtual T_STANJE Preberi(RTokPodatkov &tok);

    virtual T_SIZE VrniDolzinoOdtisa();
    virtual const T_VOID* VrniOdtis();

    inline const T_ODTIS_MD5 Vrni() const { return odtis; };
    inline operator const T_ODTIS_MD5() const { return odtis; };

protected:
    virtual T_VOID IzracunajBlok();

protected:
    T_U4 stanje[4];
    T_ODTIS_MD5 odtis;
};

template <class TOK> inline TOK& operator <<(TOK &tok, const RMD5 &odtis);
template <class TOK> inline TOK& operator >>(TOK &tok,       RMD5 &odtis);


//////////////////////////////////////////////////////////////////////
// RSHA1
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RSHA1 : public RBlokovniOdtisnik
{
public:
    RSHA1();

    virtual T_VOID Resetiraj();
    virtual T_VOID Zakljuci();

    virtual T_STANJE Zapisi(RTokPodatkov &tok) const;
    virtual T_STANJE Preberi(RTokPodatkov &tok);

    virtual T_SIZE VrniDolzinoOdtisa();
    virtual const T_VOID* VrniOdtis();

    inline const T_ODTIS_SHA1 Vrni() const { return odtis; };
    inline operator const T_ODTIS_SHA1() const { return odtis; };

protected:
    virtual T_VOID IzracunajBlok();

protected:
    T_U4 stanje[5];
    T_ODTIS_SHA1 odtis;
};

template <class TOK> inline TOK& operator <<(TOK &tok, const RSHA1 &odtis);
template <class TOK> inline TOK& operator >>(TOK &tok,       RSHA1 &odtis);

#endif // AOSN_ODTISNIK


#ifdef AOSN_ZLIB_DEFLATE

//////////////////////////////////////////////////////////////////////
// T_ZLIB_STOPNJA_KOMPRESIJE
//////////////////////////////////////////////////////////////////////

enum T_ZLIB_STOPNJA_KOMPRESIJE {
    ZLIB_STOPNJA_KOMPRESIJE_PRIVZETA = -1,
    ZLIB_STOPNJA_KOMPRESIJE_BREZ     =  0,
    ZLIB_STOPNJA_KOMPRESIJE_NAJVECJA =  9,

    ZLIB_STOPNJA_KOMPRESIJE_0        =  0,
    ZLIB_STOPNJA_KOMPRESIJE_1        =  1,
    ZLIB_STOPNJA_KOMPRESIJE_2        =  2,
    ZLIB_STOPNJA_KOMPRESIJE_3        =  3,
    ZLIB_STOPNJA_KOMPRESIJE_4        =  4,
    ZLIB_STOPNJA_KOMPRESIJE_5        =  5,
    ZLIB_STOPNJA_KOMPRESIJE_6        =  6,
    ZLIB_STOPNJA_KOMPRESIJE_7        =  7,
    ZLIB_STOPNJA_KOMPRESIJE_8        =  8,
    ZLIB_STOPNJA_KOMPRESIJE_9        =  9,
};


//////////////////////////////////////////////////////////////////////
// RZLibKodirnikTokaPodatkov
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RZLibKodirnikTokaPodatkov : public RPretvornikToka
{
public:
    RZLibKodirnikTokaPodatkov(T_ZLIB_STOPNJA_KOMPRESIJE stopnja = ZLIB_STOPNJA_KOMPRESIJE_NAJVECJA, T_U4 dolzina_bloka = ZLIB_DOLZINA_BLOKA, RTokPodatkov *izvor = NULL);
    virtual ~RZLibKodirnikTokaPodatkov();

    virtual RTokPodatkov* Odpusti();                            // Izplakne pretvornik in odpusti tok podatkov iz njegove uporabe

    virtual T_SIZE Preberi(T_KAZALEC podatki, T_SIZE dolzina);  // Prebere blok podatkov iz toka, vrne tevilo prebranih bajtov
    virtual T_SIZE Zapisi(TK_KAZALEC podatki, T_SIZE dolzina);  // Zapie blok podatkov na tok, vrne tevilo zapisanih bajtov

    virtual T_STANJE Izplakni();                                // Izplakne pretvornik

protected:
    T_ROCICA kodirnik;
    T_U4 dolzina_bloka;
    T_KAZALEC pom;
};

#endif // AOSN_ZLIB_DEFLATE


#ifdef AOSN_ZLIB_INFLATE

//////////////////////////////////////////////////////////////////////
// RZLibDekodirnikTokaPodatkov
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RZLibDekodirnikTokaPodatkov : public RPretvornikToka
{
public:
    RZLibDekodirnikTokaPodatkov(T_U4 dolzina_bloka = ZLIB_DOLZINA_BLOKA, RTokPodatkov *izvor = NULL);
    virtual ~RZLibDekodirnikTokaPodatkov();

    virtual T_SIZE Preberi(T_KAZALEC podatki, T_SIZE dolzina);  // Prebere blok podatkov iz toka, vrne tevilo prebranih bajtov
    virtual T_SIZE Zapisi(TK_KAZALEC podatki, T_SIZE dolzina);  // Zapie blok podatkov na tok, vrne tevilo zapisanih bajtov

protected:
    T_ROCICA dekodirnik;
    T_U4 dolzina_bloka;
    T_KAZALEC pom;
};

#endif // AOSN_ZLIB_INFLATE


#ifdef AOSN_ISKDAT

//////////////////////////////////////////////////////////////////////
// T_NAJDENADATOTEKA
//////////////////////////////////////////////////////////////////////

struct T_NAJDENADATOTEKA
{
    T_UINT    atributi; // atributi datoteke
    T_DOLZINA dolzina;  // dolzina datoteke v bajtih

    struct {
        T_TRENUTEK  stvaritve;          // datum stvaritve datoteke
        T_TRENUTEK  zadnjega_dostopa;   // datum zadnjega dostopa
        T_TRENUTEK  zadnje_spremembe;   // datum zadnjega pisanja v datoteko
    } datum;

    T_ZNAK    kratko_ime_datoteke[14];  // ime datoteke "8+3"
    T_ZNAK    pot_datoteke[MAX_PATH];   // polna pot do datoteke
    TK_NIZ    ime_datoteke;             // kazalec na ime datoteke (v tabeli pot_datoteke)
};


//////////////////////////////////////////////////////////////////////
// RIskalnikDatotek
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RIskalnikDatotek : public RSisElement
{
public:
    T_STANJE Odpri(TK_NIZ pot);                     // Nastavi pot, kjer iscemo datoteke in zacne iskanje
    virtual T_STANJE Zapri();                       // Konca z iskanjem

    T_STANJE Poisci(T_NAJDENADATOTEKA *podatki);    // Vrne podatke o najdeni datoteki

protected:
    RNiz pot;                       // koren iskanja datoteke
    WIN32_FIND_DATA podatki;        // podatki zadnje najdene datoteke
    T_BOOL konec;                   // ali je konec seznama datotek
};

#endif // AOSN_ISKDAT


#ifdef AOSN_VIRI

//////////////////////////////////////////////////////////////////////
// T_KNJIZNICAVIROV
//////////////////////////////////////////////////////////////////////

struct T_KNJIZNICAVIROV {
    T_KODAJEZIKA jezik;         // koda jezika knjiznice
    T_KODAJEZIKA2 jezik_win;    // koda jezika knjiznice (Windows)
    HMODULE rocica;             // rocica do modula
    T_NIZ ime_jezika;           // niz, ki predstavlja ime jezika v katerem je knjiznica
    T_NIZ pot_modula;           // pot do datoteke modula
};


//////////////////////////////////////////////////////////////////////
// RBazaVirov
//////////////////////////////////////////////////////////////////////

#pragma warning(push)
#pragma warning(disable: 4275)

class AOSN_CLASS RBazaVirov : public RUrejenSeznam<T_KNJIZNICAVIROV>
{
public:
    RBazaVirov();
    virtual ~RBazaVirov();

    T_STANJE Dodaj(TK_NIZ pot_modula, T_KODAJEZIKA jezik, T_ROCICA &rocica);
    T_STANJE Dodaj(TK_NIZ pot, TK_NIZ maska, T_KODAJEZIKA jezik, T_ROCICA &rocica);
    T_STANJE Sprosti();
    T_STANJE Nalozi(T_ROCICA rocica, T_BOOL nalozi = TRUE);

    virtual T_INT Primerjaj(T_KNJIZNICAVIROV const &prvi, T_KNJIZNICAVIROV const &drugi) const;

    static T_STANJE NaloziPodatke(HMODULE rocica, TK_NIZ vrsta, UINT id, TK_KAZALEC *podatki, T_SIZE *dolzina, T_KODAJEZIKA2 jezik = KODAJEZIKA2_UPORABNIKOV);
    static T_STANJE NaloziPodatke(HMODULE rocica, TK_NIZ vrsta, UINT id, RTokPodatkov &dat, T_KODAJEZIKA2 jezik = KODAJEZIKA2_UPORABNIKOV);
    static T_STANJE NaloziNiz(HMODULE rocica, UINT id, TK_UNICODE &niz, T_KODAJEZIKA2 jezik = KODAJEZIKA2_UPORABNIKOV);  // Uporabljaj le za vire, ki so prevedeni z zastavico /n
    static T_STANJE NaloziNiz(HMODULE rocica, UINT id, RNizP<T_UZNAK> &niz, T_KODAJEZIKA2 jezik = KODAJEZIKA2_UPORABNIKOV);
    static T_STANJE NaloziNiz(HMODULE rocica, UINT id, T_ASCII niz, T_UINT znakov, T_KODAJEZIKA2 jezik = KODAJEZIKA2_UPORABNIKOV, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);
    static T_STANJE NaloziNiz(HMODULE rocica, UINT id, T_UNICODE niz, T_UINT znakov, T_KODAJEZIKA2 jezik = KODAJEZIKA2_UPORABNIKOV);
    inline static T_STANJE NaloziZbirkoIkone(HMODULE rocica, UINT id, LPCGRPICONDIR &podatki, T_SIZE *dolzina, T_KODAJEZIKA2 jezik = KODAJEZIKA2_UPORABNIKOV);
    inline static T_STANJE NaloziZbirkoIkone(HMODULE rocica, UINT id, RTokPodatkov &seznam, T_KODAJEZIKA2 jezik = KODAJEZIKA2_UPORABNIKOV);
    inline static T_STANJE NaloziIkono(HMODULE rocica, UINT id, TK_KAZALEC *podatki, T_SIZE *dolzina, T_KODAJEZIKA2 jezik = KODAJEZIKA2_UPORABNIKOV);
    inline static T_STANJE NaloziIkono(HMODULE rocica, UINT id, RTokPodatkov &ikona, T_KODAJEZIKA2 jezik = KODAJEZIKA2_UPORABNIKOV);
    inline static T_STANJE NaloziSliko(HMODULE rocica, UINT id, TK_KAZALEC *podatki, T_SIZE *dolzina, T_KODAJEZIKA2 jezik = KODAJEZIKA2_UPORABNIKOV);
    inline static T_STANJE NaloziSliko(HMODULE rocica, UINT id, RTokPodatkov &slika, T_KODAJEZIKA2 jezik = KODAJEZIKA2_UPORABNIKOV);

    static UINT PoisciNajblizjoIkono(LPCGRPICONDIR zbirka, T_UINT sirina, T_UINT visina, T_UINT bitov_na_piko); // V zbirki ikon poie ID ikone, ki je najblija elenim dimenzijam
};

#pragma warning(pop)

#endif // AOSN_VIRI


#ifdef AOSN_REGISTER

//////////////////////////////////////////////////////////////////////
// T_REGNACINDOSTOPA
//////////////////////////////////////////////////////////////////////

enum T_REGNACINDOSTOPA {
    RREG_USTVARJANJE_POVEZAV    = KEY_CREATE_LINK,
    RREG_USTVARJANJE_PODKLJUCEV = KEY_CREATE_SUB_KEY,
    RREG_VRACANJE_PODKLJUCEV    = KEY_ENUMERATE_SUB_KEYS,
    RREG_IZVRSEVANJE            = KEY_EXECUTE,
    RREG_OBVESCANJE             = KEY_NOTIFY,
    RREG_POIZVEDOVANJE          = KEY_QUERY_VALUE,
    RREG_NASTAVLJANJE           = KEY_SET_VALUE,

    RREG_UPORABI_32             = KEY_WOW64_32KEY,
    RREG_UPORABI_64             = KEY_WOW64_64KEY,
    RREG_UPORABI_64IN32         = KEY_WOW64_32KEY | KEY_WOW64_64KEY,

    RREG_BRANJE                 = KEY_READ,
    RREG_PISANJE                = KEY_WRITE,
    RREG_VSE                    = KEY_ALL_ACCESS
};


//////////////////////////////////////////////////////////////////////
// T_REGTIP
//////////////////////////////////////////////////////////////////////

enum T_REGTIP {
    RREG_NI        = REG_NONE,
    RREG_BINARNO   = REG_BINARY,
    RREG_U4        = REG_DWORD,
    RREG_U4_TK     = REG_DWORD_LITTLE_ENDIAN,
    RREG_U4_DK     = REG_DWORD_BIG_ENDIAN,
    RREG_POVEZAVA  = REG_LINK,
    RREG_NIZ       = REG_SZ,
    RREG_NIZ_V     = REG_EXPAND_SZ,
    RREG_ZAP_NIZOV = REG_MULTI_SZ,
    RREG_SEZ_VIROV = REG_RESOURCE_LIST,
};


//////////////////////////////////////////////////////////////////////
// T_REGSPREMEMBE
//////////////////////////////////////////////////////////////////////

enum T_REGSPREMEMBE {
    RREG_SPR_DODAJANJE_BRISANJE     = REG_NOTIFY_CHANGE_NAME,
    RREG_SPR_ATRIBUTI               = REG_NOTIFY_CHANGE_ATTRIBUTES,
    RREG_SPR_VREDNOST               = REG_NOTIFY_CHANGE_LAST_SET,
    RREG_SPR_ZASCITA                = REG_NOTIFY_CHANGE_SECURITY,

    RREG_SPR_SPREMLJAJ_PODKLJUCE    = 0x80000000,

    RREG_SPR_SIS_MASKA              = 0x7fffffff,
};


//////////////////////////////////////////////////////////////////////
// RRegister
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RRegister : virtual public RSisElement, virtual public RIzpElement
{
public:
    RRegister(T_ROCICAOS r = NEVELJAVNA_ROCICA);

    T_STANJE Odpri(T_ROCICAOS rocica_korena, TK_NIZ kljuc, T_UINT nacin);                   // Odpre klju v registru
    T_STANJE Odpri(T_ROCICAOS rocica_korena, TK_NIZ kljuc, T_UINT nacin, TK_NIZ vrednost);  // Odpre klju v registru (monost poskusa HKCU|HKLM, monost uporabe RREG_UPORABI_64IN32, monost preverjanja obstoja vrednosti v kljuu)
    T_STANJE Ustvari(T_ROCICAOS rocica_korena, TK_NIZ kljuc, T_UINT nacin);                 // Ustvari klju v registru
    virtual T_STANJE Zapri();                                                               // Zapre klju v registru

    virtual T_STANJE Izplakni();                                                            // Izplakne stanje registra v trajni pomnilnik

    T_STANJE Preberi(TK_NIZ vrednost, T_U4 &podatek);                                       // Prebere tevilo iz registra
    T_STANJE Preberi(TK_NIZ vrednost, T_U8 &podatek);                                       // Prebere tevilo iz registra
    T_STANJE Preberi(TK_NIZ vrednost, RNiz &niz);                                           // Prebere niz iz registra
    T_STANJE Preberi(TK_NIZ vrednost, RDinTabela<T_ZNAK> &nizz);                            // Prebere seznam nizov iz registra
    T_STANJE Preberi(TK_NIZ vrednost, T_REGTIP *tip, RTokPodatkov &datoteka);               // Prebere sploen podatek iz registra
    T_STANJE Preberi(TK_NIZ vrednost, T_KAZALEC podatki, T_SIZE dolzina, T_REGTIP *tip = NULL, T_SIZE *prebrano = NULL);    // Prebere sploen podatek iz registra

    T_STANJE Zapisi(TK_NIZ vrednost, T_U4 podatek);                                         // Zapie tevilo v register
    T_STANJE Zapisi(TK_NIZ vrednost, T_U8 podatek);                                         // Zapie tevilo v register
    T_STANJE Zapisi(TK_NIZ vrednost, TK_NIZ niz, T_BOOL reference = FALSE);                 // Zapie niz v register
    T_STANJE Zapisi(TK_NIZ vrednost, TK_KAZALEC podatki, T_SIZE dolzina);                   // Zapie sploen podatek v register
    T_STANJE ZapisiSeznam(TK_NIZ vrednost, TK_NIZ nizz);                                    // Zapie seznam nizov v register

    T_STANJE BrisiVrednost(TK_NIZ vrednost);                                                // Brie vrednost
    T_STANJE BrisiPodkljuc(TK_NIZ podKljuc);                                                // Rekurzivno pobrie cel podklju

    T_STANJE VrniPodkljuc(T_UINT indeks, RNiz &ime);                                        // Vrne podklju z doloenim indeksom (register moramo odpreti s pravico RREG_VRACANJE_PODKLJUCEV)

    T_STANJE SpremljajSpremembe(T_UINT filter);                                             // Zamrzne trenutno nit, dokler ne pride do elenih sprememb v registru
    T_STANJE SpremljajSpremembe(T_UINT filter, T_ROCICAOS dogodek);                         // Nastavi dogodek, ki ga sistem sproi ob eleni spremembi v registru

    inline T_REGTIP VrniTip(TK_NIZ vrednost) const;                                         // Vrne tip zapisa dane vrednosti v registru
    inline T_SIZE VrniDolzino(TK_NIZ vrednost) const;                                       // Vrne dolino zapisa dane vrednosti v registru

    inline operator HKEY() const;
};

#endif // AOSN_REGISTER


#ifdef AOSN_DNEVNIK

//////////////////////////////////////////////////////////////////////
// RDNE_PRIORITETE
//////////////////////////////////////////////////////////////////////

enum RDNE_PRIORITETE {
    RDNE_PRI_USPEH      = EVENTLOG_SUCCESS,
    RDNE_PRI_NAPAKA     = EVENTLOG_ERROR_TYPE,
    RDNE_PRI_OPOZORILO  = EVENTLOG_WARNING_TYPE,
    RDNE_PRI_OBVESTILO  = EVENTLOG_INFORMATION_TYPE,
    RDNE_PRI_REV_USPEH  = EVENTLOG_AUDIT_SUCCESS,
    RDNE_PRI_REV_NAPAKA = EVENTLOG_AUDIT_FAILURE,
};


//////////////////////////////////////////////////////////////////////
// RDnevnik
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RDnevnik : virtual public RElement
{
public:
    RDnevnik(T_UINT podrocje, TK_NIZ identifikacija, HMODULE modul = NULL, T_KODAJEZIKA2 jezik = AOSN_PRIVZETI_JEZIK);
    virtual ~RDnevnik();

    inline T_STANJE Zapisi(T_DNEVNIKPRIORITETA prioriteta, TK_NIZ sporocilo, T_LOCALE locale, ...);                          // Zapise oblikovan niz v dnevnik
    inline T_STANJE Zapisi(T_DNEVNIKPRIORITETA prioriteta, T_UINT koda_sporocila, T_LOCALE locale, ...);                     // Zapise oblikovan niz v dnevnik
    virtual T_STANJE ZapisiP(T_DNEVNIKPRIORITETA prioriteta, TK_NIZ sporocilo, T_LOCALE locale, va_list parametri) = 0;      // Zapise oblikovan niz v dnevnik

protected:
    T_UINT podrocje;
    T_NIZ identifikacija;
    HMODULE modul;
    T_KODAJEZIKA2 jezik;
};


//////////////////////////////////////////////////////////////////////
// RDnevnikDat
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RDnevnikDat : public RDnevnik
{
public:
#ifdef _UNICODE
    RDnevnikDat(T_UINT podrocje, TK_NIZ identifikacija, HMODULE modul = NULL, T_KODAJEZIKA2 jezik = AOSN_PRIVZETI_JEZIK);
#else
    RDnevnikDat(T_UINT podrocje, TK_NIZ identifikacija, HMODULE modul = NULL, T_KODAJEZIKA2 jezik = AOSN_PRIVZETI_JEZIK, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);
#endif

    RTokPodatkov* Uporabi(RTokPodatkov *dat);                                                                            // Nastavi datoteko, v katero pise dnevnik
    virtual T_STANJE ZapisiP(T_DNEVNIKPRIORITETA prioriteta, TK_NIZ sporocilo, T_LOCALE locale, va_list parametri);      // Zapise oblikovan niz v dnevnik

protected:
    RTokPodatkov *dat;
    RNevarenOdsek kljucavnica;
#ifndef _UNICODE
    T_KODNASTRAN kodna_stran;
#endif
};


//////////////////////////////////////////////////////////////////////
// RDnevnikNT
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RDnevnikNT : virtual public RDnevnik, virtual public RSisElement
{
public:
    RDnevnikNT(T_UINT podrocje, TK_NIZ identifikacija, HMODULE modul = NULL, T_KODAJEZIKA2 jezik = AOSN_PRIVZETI_JEZIK, T_ROCICAOS rocica = NEVELJAVNA_ROCICA);

    // Metode RSisElement
    T_STANJE Odpri(TK_NIZ streznik = NULL);             // Odpre dnevnik
    virtual T_STANJE Zapri();                           // Zapre rocico

    virtual T_STANJE ZapisiP(T_DNEVNIKPRIORITETA prioriteta, TK_NIZ sporocilo, T_LOCALE locale, va_list parametri);                 // Zapise oblikovan niz v dnevnik

    inline T_STANJE Zapisi(T_DNEVNIKPRIORITETA prioriteta, T_UINT koda_sporocila, ...);                                             // Zapise dogodek v dnevnik
    inline T_STANJE Zapisi(T_DNEVNIKPRIORITETA prioriteta, T_KAZALEC podatki, T_SIZE dolzina, T_UINT koda_sporocila, ...);          // Zapise dogodek v dnevnik
    T_STANJE ZapisiP(T_DNEVNIKPRIORITETA prioriteta, T_KAZALEC podatki, T_SIZE dolzina, T_UINT koda_sporocila, va_list parametri);  // Zapise dogodek v dnevnik

    // Metode za registracijo programa v registru.
    static T_STANJE Registriraj(TK_NIZ dnevnik, TK_NIZ identifikacija, T_UINT vrste_prioritet, TK_NIZ dat_sporocil, TK_NIZ dat_parametrov = NULL, TK_NIZ dat_podrocij = NULL, T_UINT st_podrocij = 0);
    static T_STANJE Odjavi(TK_NIZ dnevnik, TK_NIZ identifikacija);
};

#endif // AOSN_DNEVNIK


#ifdef AOSN_SERVIS

//////////////////////////////////////////////////////////////////////
// T_RAVNANJEOBOKVARISERVISA
//////////////////////////////////////////////////////////////////////

enum T_SERDOSTOPOSKRBNIK {
    RSER_OSKRBNIK_VES_DOSTOP   = SC_MANAGER_ALL_ACCESS,
    RSER_OSKRBNIK_BRANJE       = GENERIC_READ,
    RSER_OSKRBNIK_PISANJE      = GENERIC_WRITE,
    RSER_OSKRBNIK_IZVAJANJE    = GENERIC_EXECUTE,
    RSER_OSKRBNIK_PRIKLOP      = SC_MANAGER_CONNECT,
    RSER_OSKRBNIK_NOV_SERVIS   = SC_MANAGER_CREATE_SERVICE,
    RSER_OSKRBNIK_BRSKANJE     = SC_MANAGER_ENUMERATE_SERVICE,
    RSER_OSKRBNIK_ZAKLEP       = SC_MANAGER_LOCK,
    RSER_OSKRBNIK_UGOT_ZAKLEPA = SC_MANAGER_QUERY_LOCK_STATUS,
};


//////////////////////////////////////////////////////////////////////
// T_RAVNANJEOBOKVARISERVISA
//////////////////////////////////////////////////////////////////////

enum T_SERDOSTOPSERVIS {
    RSER_SERVIS_VES_DOSTOP      = SERVICE_ALL_ACCESS,
    RSER_SERVIS_ZACASNO_USTAVI  = SERVICE_PAUSE_CONTINUE,
    RSER_SERVIS_POZENI          = SERVICE_START,
    RSER_SERVIS_USTAVI          = SERVICE_STOP,
    RSER_SERVIS_BRISI           = DELETE,
    RSER_SERVIS_NASTAVI         = SERVICE_CHANGE_CONFIG,
    RSER_SERVIS_VRNI_NASTAVITVE = SERVICE_QUERY_CONFIG,
    RSER_SERVIS_SPOROCI         = SERVICE_USER_DEFINED_CONTROL,
    RSER_SERVIS_VRNI_STATUS     = SERVICE_QUERY_STATUS, // Neko je bila ta konstanta enaka SERVICE_INTERROGATE
    // TODO: definiraj e druge pravice za delo s servisi
};


//////////////////////////////////////////////////////////////////////
// T_RSERVISIMPLKODASPOROCILA
//////////////////////////////////////////////////////////////////////

enum T_RSERVISIMPLKODASPOROCILA {
    SP_RSERVISIMPL_KONEC = 0x80,    // Uporabnika sporoila se zanejo od 0x80 naprej.
};


//////////////////////////////////////////////////////////////////////
// T_RSERVISSTDKODASPOROCILA
//////////////////////////////////////////////////////////////////////

enum T_RSERVISSTDKODASPOROCILA {
    SP_RSERVISSTD_KONEC = SP_RSERVISIMPL_KONEC
};


//////////////////////////////////////////////////////////////////////
// T_VRSTASERVISA
//////////////////////////////////////////////////////////////////////

enum T_VRSTASERVISA {
    RSER_SAMOSTOJNI_PROCES  = SERVICE_WIN32_OWN_PROCESS,
    RSER_SKUPNI_PROCES      = SERVICE_WIN32_SHARE_PROCESS,
    RSER_GONILNIK           = SERVICE_KERNEL_DRIVER,
    RSER_GONILNIK_DAT_SIS   = SERVICE_FILE_SYSTEM_DRIVER,
    RSER_INTERAKTIVEN       = SERVICE_INTERACTIVE_PROCESS
};


//////////////////////////////////////////////////////////////////////
// T_ZAGONSERVISA
//////////////////////////////////////////////////////////////////////

enum T_ZAGONSERVISA {
    RSER_OB_ZAGONU          = SERVICE_BOOT_START,
    RSER_OB_ZAGONU_SISTEMA  = SERVICE_SYSTEM_START,
    RSER_SAMODEJNO          = SERVICE_AUTO_START,
    RSER_PO_POTREBI         = SERVICE_DEMAND_START,
    RSER_ONEMOGOCENO        = SERVICE_DISABLED
};


//////////////////////////////////////////////////////////////////////
// T_OBRAVNAVANAPAKESERVISA
//////////////////////////////////////////////////////////////////////

enum T_OBRAVNAVANAPAKESERVISA {
    RSER_IGNORIRAJ  = SERVICE_ERROR_IGNORE,
    RSER_OBICAJNO   = SERVICE_ERROR_NORMAL,
    RSER_RESNO      = SERVICE_ERROR_SEVERE,
    RSER_KRITICNO   = SERVICE_ERROR_CRITICAL
};


//////////////////////////////////////////////////////////////////////
// T_STATUSSERVISA
//////////////////////////////////////////////////////////////////////

enum T_STATUSSERVISA {
    RSER_ZAGANJA        = SERVICE_START_PENDING,
    RSER_ZAGNAN         = SERVICE_RUNNING,
    RSER_ZAUSTAVLJEN    = SERVICE_STOPPED,
    RSER_ZAUSTAVLJA     = SERVICE_STOP_PENDING,
    RSER_PREKINJA       = SERVICE_PAUSE_PENDING,
    RSER_PREKINJEN      = SERVICE_PAUSED,
    RSER_NADALJUJE      = SERVICE_CONTINUE_PENDING,
};


//////////////////////////////////////////////////////////////////////
// T_VRSTADEJANJAOBOKVARISERVISA
//////////////////////////////////////////////////////////////////////

enum T_VRSTADEJANJAOBOKVARISERVISA {
    RSER_NE_STORI_NICESAR          = SC_ACTION_NONE,
    RSER_PONOVNO_ZAZENI_RACUNALNIK = SC_ACTION_REBOOT,
    RSER_PONOVNO_ZAZENI_SERVIS     = SC_ACTION_RESTART,
    RSER_ZAZENI_UKAZNO_VRSTICO     = SC_ACTION_RUN_COMMAND,
};


//////////////////////////////////////////////////////////////////////
// T_RAVNANJEOBOKVARISERVISA
//////////////////////////////////////////////////////////////////////

struct T_RAVNANJEOBOKVARISERVISA {
    T_VRSTADEJANJAOBOKVARISERVISA vrsta_dejanja;    // vrsta dejanja, ki naj ga izvede oskrbnik servisov
    T_UINT zacetni_premor;                          // koliko asa naj oskrbnik servisov poaka, preden izvede dejanje
};


//////////////////////////////////////////////////////////////////////
// T_REGISTRACIJASERVISA
//////////////////////////////////////////////////////////////////////

struct T_REGISTRACIJASERVISA {
    TK_NIZ polno_ime;                               // polno ime servisa
    TK_NIZ opis;                                    // kazalec na niz z opisom servisa
    T_UINT vrsta;
    T_ZAGONSERVISA zagon;
    T_OBRAVNAVANAPAKESERVISA obravnava_napake;
    TK_NIZ skupina;
    T_U4 *id_skupine;
    TK_NIZ odvisnosti;                              // seznam nizov, z imeni servisov, od katerih je na servis odvisen
    TK_NIZ up_ime;                                  // uporabniko ime, ki ga bo uporabljal servis
    TK_NIZ geslo;                                   // geslo uporabnikega imena, ki ga bo uporabljal servis
    struct {
        T_UINT perioda;                             // perioda, po kateri se tevec okvar resetira
        TK_NIZ sporocilo;                           // kazalec na niz s sporoilom, ki ga sporoimo uporabniku ob okvari servisa
        TK_NIZ ukazna_vrstica;                      // kazalec na niz z ukazno vrstico, ki jo elimo pognati ob okvari
        T_UINT st_ravnanj;                          // tevilo ravnanj v tabeli ravnanje
        const T_RAVNANJEOBOKVARISERVISA *ravnanja;  // tabela ravnanj ob posamezni ponovitvi okvare
    } ravnanje_ob_okvari;
};


//////////////////////////////////////////////////////////////////////
// ROskrbnikServisov
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS ROskrbnikServisov : public RSisElement
{
public:
    T_STANJE Odpri(TK_NIZ racunalnik, TK_NIZ baza, T_UINT dostop);  // Odpre oskrbnika servisov
    virtual T_STANJE Zapri();                                       // Zapre oskrbnika servisov

    T_STANJE VrniDolgoIme(TK_NIZ ime, RNiz &dolgo_ime);             // Vrne dolgo ime servisa, ce poznamo kratkega
    T_STANJE VrniIme(TK_NIZ dolgo_ime, RNiz &ime);                  // Vrne ime servisa, ce poznamo dolgo ime
};


//////////////////////////////////////////////////////////////////////
// RSistemskiServis
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RSistemskiServis : public RSisElement
{
public:
    RSistemskiServis(T_ROCICAOS r = NEVELJAVNA_ROCICA);

    T_STANJE Odpri(T_ROCICAOS oskrbnik, TK_NIZ ime, T_UINT dostop); // Odpre servis
    T_STANJE Ustvari(T_ROCICAOS oskrbnik, TK_NIZ ime, TK_NIZ dolgo_ime, TK_NIZ ukazna_vrstica, T_UINT dostop, T_UINT vrsta, T_ZAGONSERVISA zagon, T_OBRAVNAVANAPAKESERVISA obravnava_napake = RSER_OBICAJNO, TK_NIZ skupina = NULL, T_U4 *id_skupine = NULL, TK_NIZ odvisnosti = NULL, TK_NIZ up_ime = NULL, TK_NIZ geslo = NULL);     // Ustvari nov servis
    T_STANJE Zbrisi();                                              // Zbrie servis
    virtual T_STANJE Zapri();                                       // Zapre servis

    T_STANJE Pozeni(T_UINT argc, TK_NIZ argv[]);                    // Poene servis
    T_STANJE Sporoci(T_UINT koda, SERVICE_STATUS *status);          // Polje ukaz servisu
    T_STANJE Nastavi(TK_NIZ dolgo_ime, TK_NIZ ukazna_vrstica, T_UINT vrsta, T_ZAGONSERVISA zagon, T_OBRAVNAVANAPAKESERVISA obravnava_napake = RSER_OBICAJNO, TK_NIZ skupina = NULL, T_U4 *id_skupine = NULL, TK_NIZ odvisnosti = NULL, TK_NIZ up_ime = NULL, TK_NIZ geslo = NULL);
    T_STANJE VrniStatus(SERVICE_STATUS_PROCESS *status);            // Vrne trenutni status servisa

    T_STANJE NastaviOpis(TK_NIZ opis);                              // Nastavi opis servisa
    T_STANJE NastaviRavnanjeObOkvari(T_UINT perioda, TK_NIZ sporocilo, TK_NIZ ukazna_vrstica, T_UINT st_ravnanj, const T_RAVNANJEOBOKVARISERVISA *ravnanja);
};


//////////////////////////////////////////////////////////////////////
// RRegisterServisov
//////////////////////////////////////////////////////////////////////

#pragma warning(push)
#pragma warning(disable: 4251)

class AOSN_CLASS RRegisterServisov : public RElement
{
public:
    RRegisterServisov();
    virtual ~RRegisterServisov();

    virtual T_STANJE ObRegistraciji();                                  // Metoda, ki jo nit klie ob registraciji registra
    virtual T_STANJE ObOdjavi();                                        // Metoda, ki jo nit klie ob odjavi registra
    virtual T_STANJE ObZagonu();                                        // Metoda, ki jo nit klie ob zagonu
    virtual T_STANJE ObZakljucku();                                     // Metoda, ki jo nit klie ob zakljuku
    virtual T_INT Pozeni(T_ROCICAOS modul, T_ROCICAOS prejsnji_modul, TK_NIZ ukazna_vrstica, T_INT zacetno_stanje);

    inline T_ROCICA DodajServis(RServisImpl *servis);
    inline T_STANJE OdstraniServis(T_ROCICA rocica);
    inline T_STANJE OdstraniServis(TK_NIZ ime);
    inline T_ROCICA VrniRocicoServisa(TK_NIZ ime) const;
    inline RServisImpl* VrniServis(T_ROCICA rocica) const;
    inline RServisImpl* VrniServis(TK_NIZ ime) const;
    inline static RRegisterServisov* VrniRegisterServisov();

protected:
    static VOID WINAPI RokovalnikServisov(DWORD argc, LPTSTR *argv);    // Rokovalnik servisov
    static RRegisterServisov *register_servisov;                        // kazalec na en in edini register servisov, ki ga potrebuje metoda RRegisterServisov::RokovalnikServisov()

public:
    T_ROCICAOS rocica_modula;       // roica modula
    RNiz pot_modula;                // polna pot do modula
    RNiz imenik_modula;             // imenik modula

protected:
    RSeznam<RServisImpl*> servisi;  // Seznam servisov
};

#pragma warning(pop)


//////////////////////////////////////////////////////////////////////
// RRegisterServisovDnevnikP
//////////////////////////////////////////////////////////////////////

#ifdef AOSN_DNEVNIK

template <class T_base> class AOSN_TEMPLATE RRegisterServisovDnevnikP : public T_base
{
public:
    RRegisterServisovDnevnikP(TK_NIZ ime_dnevnika, T_UINT podrocje, TK_NIZ identifikacija, T_UINT vrste_prioritet);

    virtual T_STANJE ObRegistraciji();  // Metoda, ki jo nit klie ob registraciji registra
    virtual T_STANJE ObOdjavi();        // Metoda, ki jo nit klie ob odjavi registra
    virtual T_STANJE ObZagonu();        // Metoda, ki jo nit klie ob zagonu
    virtual T_STANJE ObZakljucku();     // Metoda, ki jo nit klie ob zakljuku

public:
    RDnevnikNT dnevnik;                 // dnevnik, kjer beleimo dogodke

protected:
    RNiz ime_dnevnika;                  // ime dnevnika, v katerega zapisujemo dogodke ("Application", "System", ...)
    RNiz identifikacija;                // identifikacija vira dogodkov
    T_UINT vrste_prioritet;             // vrste dogodkov, ki jih zapisujemo (kombinacija konstant RDNE_PRI_*)
};

#endif // AOSN_DNEVNIK


//////////////////////////////////////////////////////////////////////
// RServisImpl
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RServisImpl : public RDogNitVN
{
public:
    RServisImpl();

    T_STANJE Odpri(T_UINT argc, TK_NIZ argv[], T_UINT dolzina_vrste = RDOGNIT_PRIVZETA_DOLZINA_VRSTE, T_NITZACETNOSTANJE stanje = RNIT_NORMALNA, T_UINT sklad = 0);    // Ustvari in zaene servis (fg)
    T_VOID Pozeni(T_UINT argc, TK_NIZ argv[]);                          // Vzpostavi in poene servis (SCM)

protected:
    // Metode, ki jih prepiemo za vsak servis posebej
    virtual T_VOID PredRegistracijoServisa();                           // Metoda, ki jo nit klie pred registracijo servisa in s katero lahko popravljamo parametre lana status
    virtual T_STANJE ObZagonu();                                        // Metoda, ki jo nit klie ob zagonu
    virtual T_STANJE ObZakljucku();                                     // Metoda, ki jo nit klie ob zakljuku
    virtual T_STANJE ObZaustavitvi(T_BOOL zaustavitev_sistema);         // Metoda, ki jo nit klie ob zaustavitvi servisa
    virtual T_STANJE ObPrekinitvi();                                    // Metoda, ki jo nit klie ob prekinitvi servisa
    virtual T_STANJE ObNadaljevanju();                                  // Metoda, ki jo nit klie ob nadaljevanju servisa
    virtual T_STANJE ObStatusu();                                       // Metoda, ki jo nit klie ob nastavitvi statusa

    // Metode, ki jih klie rokovalnik
    virtual T_REZULTAT ObZagonu(T_KAZALEC param);                                           // Rokovalnik klie to metodo ob zagonu servisa. Za uporabniki zagon prepii metodo ObZagonu() zgoraj.
    virtual T_VOID ObZakljucku(T_KAZALEC param);                                            // Rokovalnik klie to metodo ob zakljuku servisa. Za uporabniko zakljuitev prepii metodo ObZakljucku() zgoraj.
    virtual T_REZULTAT RokovalnikDogodkov(T_UINT koda, T_UINT param1, T_KAZALEC param2);    // Rokovalnik dogodkov (uporabljamo namesto RDOGNIT_NAJAVI_ROKOVALNIKE)

    virtual T_STANJE ObRegistraciji(RRegisterServisov &register_servisov, ROskrbnikServisov &oskrbnik_servisov);    // Metoda, ki jo klie register servisov, ko registrira servis
    virtual T_STANJE ObOdjavi(RRegisterServisov &register_servisov, ROskrbnikServisov &oskrbnik_servisov);          // Metoda, ki jo klie register servisov, ko odjavlja servis
    virtual T_VOID IzpolniPodatkeServisa(T_REGISTRACIJASERVISA *reg) const;                                         // Napolni podatke za registracijo servisa
    virtual TK_NIZ VrniIme() const = 0;                                                                             // Vrne ime servisa

    static DWORD WINAPI RokovalnikUkazov(DWORD ukaz, DWORD tip, LPVOID podatki, LPVOID instanca);   // Rokovalnik ukazov

    // Nizkonivojsko sporoanje statusa SCM-ju
    inline T_STANJE SporociNaslednjiKorak(T_UINT milisekund = RDTM_MINUTA);     // Sporoi SCM-ju, da se je zaela naslednja faza, ki bo trajala predvidoma podano tevilo milisekund
    inline T_STANJE SporociStatus();
    inline T_STANJE SporociStatus(T_STATUSSERVISA stanje);

    friend RRegisterServisov;

protected:
    SERVICE_STATUS_HANDLE statusna_rocica;          // roica, s pomojo katere sporoamo trenutno stanje servisa
    SERVICE_STATUS status;                          // struktura, ki opisuje trenutno stanje servisa
    struct {
        T_UINT stevilo;                             // tevilo parametrov ukazne vrstice servisa
        TK_NIZ *tabela;                             // tabela parametrov ukazne vrstice servisa
    } parametri;
};


//////////////////////////////////////////////////////////////////////
// RServisStdP
//////////////////////////////////////////////////////////////////////

template <class T_base> class AOSN_TEMPLATE RServisStdP : public T_base
{
public:
    RServisStdP();

    virtual T_VOID PredRegistracijoServisa();                           // Metoda, ki jo nit klie pred registracijo servisa in s katero lahko popravljamo parametre lana status.
    virtual T_STANJE ObZagonu();                                        // Metoda, ki jo nit klie, ko je vrsta za sporoila pripravljena
    virtual T_STANJE ObZaustavitvi(T_BOOL zaustavitev_sistema);         // Metoda, ki jo nit klie ob zaustavitvi
    virtual T_STANJE ObPrekinitvi();                                    // Metoda, ki jo nit klie ob prekinitvi servisa
    virtual T_STANJE ObNadaljevanju();                                  // Metoda, ki jo nit klie ob nadaljevanju servisa

public:
    RDogodek delaj;     // dogodek, ki naznanja, da lahko delamo (za upotevanje ukazov Pause/Continue)
    RDogodek koncaj;    // dogodek, ki naznanja, da elimo konati (za upotevanje ukazov Stop/Shutdown)
};


//////////////////////////////////////////////////////////////////////
// RServisOdjemalecP
//////////////////////////////////////////////////////////////////////

#pragma warning(push)
#pragma warning(disable: 4512)

template <class T_srv> class AOSN_TEMPLATE RServisOdjemalecP : public RNit
{
public:
    RServisOdjemalecP(T_srv &servis);

    virtual RTokPodatkov& VrniTokPodatkov() = 0;    // Vrne referenco na tok podatkov.
    virtual RNiz VrniImeOdjemalca() = 0;            // Vrne niz, ki opisuje ime odjemalca
    virtual T_STANJE Zakljuci() = 0;                // Sporoi odjemalcu, naj zakljui

protected:
    T_srv &servis;  // servis, kateremu odjemalec pripada
};

#pragma warning(pop)


//////////////////////////////////////////////////////////////////////
// RServisOdjemalecKanalP
//////////////////////////////////////////////////////////////////////

#ifdef AOSN_KANAL

#pragma warning(push)
#pragma warning(disable: 4512)

template <class T_srv, class T_base> class AOSN_TEMPLATE RServisOdjemalecKanalP : public T_base
{
public:
    RServisOdjemalecKanalP(T_srv &servis);

    virtual RTokPodatkov& VrniTokPodatkov();    // Vrne referenco na tok podatkov
    virtual RNiz VrniImeOdjemalca();            // Vrne niz, ki opisuje ime odjemalca
    virtual T_STANJE Zakljuci();                // Sporoi odjemalcu, naj zakljui
    virtual T_STANJE Zapri();                   // Zapre odjemalca

    RImenovanKanal kanal;   // komunikacijski kanal
};

#pragma warning(pop)

#endif // AOSN_KANAL


//////////////////////////////////////////////////////////////////////
// RServisOdjemalecVticP
//////////////////////////////////////////////////////////////////////

#ifdef AOSN_VTIC

#pragma warning(push)
#pragma warning(disable: 4512)

template <class T_srv, class T_base> class AOSN_TEMPLATE RServisOdjemalecVticP : public T_base
{
public:
    RServisOdjemalecVticP(T_srv &servis);

    virtual RTokPodatkov& VrniTokPodatkov();    // Vrne referenco na tok podatkov
    virtual RNiz VrniImeOdjemalca();            // Vrne niz, ki opisuje ime odjemalca
    virtual T_STANJE Zakljuci();                // Sporoi odjemalcu, naj zakljui
    virtual T_STANJE Zapri();                   // Zapre odjemalca

    RVticnica vticnica; // komunikacijska vtinica
};

#pragma warning(pop)

#endif // AOSN_VTIC


//////////////////////////////////////////////////////////////////////
// RServisSprejemnikP
//////////////////////////////////////////////////////////////////////

#pragma warning(push)
#pragma warning(disable: 4512)

template <class T_srv, class T_odj_base> class RServisSprejemnikP : public RNit
{
public:
    RServisSprejemnikP(T_srv &servis);

    virtual T_STANJE Zakljuci() = 0;                                // Metoda za zakljuevanje sprejemnika

protected:
    virtual T_STANJE SprejmiOdjemalca(T_odj_base *&odjemalec) = 0;  // Sprejme in poene enega odjemalca

protected:
    T_srv &servis;  // servis, kateremu sprejemnik pripada
};

#pragma warning(pop)


//////////////////////////////////////////////////////////////////////
// RServisSprejemnikKanalP
//////////////////////////////////////////////////////////////////////

#ifdef AOSN_KANAL

#pragma warning(push)
#pragma warning(disable: 4512)

template <class T_srv, class T_odj, class T_odj_base, class T_base> class RServisSprejemnikKanalP : public T_base
{
public:
    RServisSprejemnikKanalP(T_srv &servis);

    T_STANJE Vzpostavi(TK_NIZ ime_kanala);
    virtual T_STANJE Zakljuci();

protected:
    virtual T_STANJE SprejmiOdjemalca(T_odj_base *&odjemalec);      // Sprejme in poene enega odjemalca

protected:
    RNiz ime_kanala;    // polno ime kanala
};

#pragma warning(pop)

#endif // AOSN_KANAL


//////////////////////////////////////////////////////////////////////
// RServisSprejemnikVticP
//////////////////////////////////////////////////////////////////////

#ifdef AOSN_VTIC

#pragma warning(push)
#pragma warning(disable: 4512)

template <class T_srv, class T_odj, class T_odj_base, class T_base> class RServisSprejemnikVticP : public T_base
{
public:
    RServisSprejemnikVticP(T_srv &servis);

    inline T_STANJE Vzpostavi(TK_NIZ vmesnik, T_UINT vrata);
    T_STANJE Vzpostavi(const T_SOCKADDR *naslov, T_SIZE dolzina);
    virtual T_STANJE Zakljuci();

protected:
    virtual T_STANJE SprejmiOdjemalca(T_odj_base *&odjemalec);      // Sprejme in poene enega odjemalca

protected:
    RVticnica vticnica; // strenika vtinica
};

#pragma warning(pop)

#endif // AOSN_VTIC

#endif // AOSN_SERVIS


#ifdef AOSN_ZVOK

//////////////////////////////////////////////////////////////////////
// T_BLOKZVOKA
//////////////////////////////////////////////////////////////////////

struct AOSN_INLINE_CLASS T_BLOKZVOKA
{
    T_KAZALEC podatki;  // kazalec na podatke
    T_SIZE dolzina;     // dolzina bloka
    T_UINT instanca;    // poljuben podatek, ki ga nastavi uporabnik
    T_BOOL ne_unici;    // logicna spremenljivka, ki doloca, ali predvajalnik samodejno zbrise blok zvoka po predvajanju

    static T_BLOKZVOKA* Ustvari(T_UINT dolzina, T_UINT instanca = 0, T_BOOL ne_unici = FALSE);  // Metoda ustvari nov blok zvoka na kopici in vrne kazalec nanj
    static T_VOID Unici(T_BLOKZVOKA *blok);                                                     // Metoda unici blok zvoka na kopici

    friend class AOSN_CLASS RPredvajalnikZvoka;
    friend class AOSN_CLASS RSnemalnikZvoka;

protected:
    WAVEHDR opisnik;    // opisnik bloka za Windows
};


//////////////////////////////////////////////////////////////////////
// RPredvajalnikZvoka
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RPredvajalnikZvoka : public RNit
{
public:
    RPredvajalnikZvoka(T_ROCICAOS rocica = NEVELJAVNA_ROCICA, T_UINT max_blokov = RZVOK_NAJVEC_BLOKOV);
    virtual ~RPredvajalnikZvoka();

    T_STANJE Odpri(T_UINT vzorcevalna_frekvenca, T_UINT bitov, T_UINT kanalov); // odpremo predvajalnik za predvajanje
    virtual T_STANJE Zapri(T_BOOL pocakaj = TRUE);                              // zapremo predvajalnik
    T_STANJE Predvajaj(T_BLOKZVOKA *blok);                                      // postavimo blok zvoka v vrsto za predvajanje

protected:
    virtual T_REZULTAT Izvedi(T_KAZALEC param);                                 // telo niti, ki spremlja predvajanje
    virtual T_STANJE ObKoncuBloka(T_BLOKZVOKA *blok);                           // metoda, ki jo klice predvajalnik, ko je blok koncan

    RDogodek
        pripravljen,    // dogodek, ki doloca, ali je predvajalnik pripravljen
        prazen,         // dogodek, ki signalizira, kdaj je predvajalnik prazen
        prost;          // dogodek, ki doloca, ali je v vrsti se prostor za en blok
    T_ROCICAOS rocica;  // rocica do predvajalnika
    T_UINT max_blokov;  // najvecje stevilo blokov, ki jih uporabnik lahko poslje v predvajanje vnaprej
};


//////////////////////////////////////////////////////////////////////
// RSnemalnikZvoka
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RSnemalnikZvoka : public RNit
{
public:
    RSnemalnikZvoka(T_ROCICAOS rocica = NEVELJAVNA_ROCICA, T_UINT max_blokov = RZVOK_NAJVEC_BLOKOV);
    virtual ~RSnemalnikZvoka();

    T_STANJE Odpri(T_UINT vzorcevalna_frekvenca, T_UINT bitov, T_UINT kanalov); // odpremo snemalnik za snemanje
    virtual T_STANJE Zapri(T_BOOL pocakaj = TRUE);                              // zapremo snemalnik
    T_STANJE Posnemi(T_BLOKZVOKA *blok);                                        // postavimo blok zvoka v vrsto za snemanje
    T_STANJE Zacni();                                                           // zacnemo s snemanjem
    T_STANJE Koncaj();                                                          // koncamo s snemanjem

protected:
    virtual T_REZULTAT Izvedi(T_KAZALEC param);                                 // telo niti, ki spremlja predvajanje
    virtual T_STANJE ObKoncuBloka(T_BLOKZVOKA *blok);                           // metoda, ki jo klice snemalnik, ko je blok koncan

    RDogodek
        pripravljen,    // dogodek, ki doloca, ali je snemalnik pripravljen
        prazen,         // dogodek, ki signalizira, kdaj je snemalnik prazen
        prost;          // dogodek, ki doloca, ali je v vrsti se prostor za en blok
    T_ROCICAOS rocica;  // rocica do snemalnika
    T_UINT max_blokov;  // najvecje stevilo blokov, ki jih uporabnik lahko poslje v snemanje vnaprej
};

#endif // AOSN_ZVOK


#ifdef AOSN_HTML

#pragma warning(push)
#pragma warning(disable: 4251)
#if _MSC_VER < 1300
#pragma warning(disable: 4786)
#endif


//////////////////////////////////////////////////////////////////////
// T_HTMLKODAELEMENTA
//////////////////////////////////////////////////////////////////////

enum T_HTMLKODAELEMENTA {
    HTML_EL_PRAZEN  = 0,
    HTML_EL_PRVI    = 1,

    HTML_EL_A       = HTML_EL_PRVI,
    HTML_EL_ABBR,
    HTML_EL_ACRONYM,
    HTML_EL_ADDRESS,
    HTML_EL_APPLET,
    HTML_EL_AREA,
    HTML_EL_B,
    HTML_EL_BASE,
    HTML_EL_BASEFONT,
    HTML_EL_BDO,
    HTML_EL_BGSOUND,    // Microsoft Specific
    HTML_EL_BIG,
    HTML_EL_BLINK,      // Microsoft Specific
    HTML_EL_BLOCKQUOTE,
    HTML_EL_BODY,
    HTML_EL_BR,
    HTML_EL_BUTTON,
    HTML_EL_CAPTION,
    HTML_EL_CENTER,
    HTML_EL_CITE,
    HTML_EL_CODE,
    HTML_EL_COL,
    HTML_EL_COLGROUP,
    HTML_EL_COMMENT,    // Microsoft Specific
    HTML_EL_DD,
    HTML_EL_DEL,
    HTML_EL_DFN,
    HTML_EL_DIR,
    HTML_EL_DIV,
    HTML_EL_DL,
    HTML_EL_DT,
    HTML_EL_EM,
    HTML_EL_EMBED,      // Microsoft Specific
    HTML_EL_FIELDSET,
    HTML_EL_FONT,
    HTML_EL_FORM,
    HTML_EL_FRAME,
    HTML_EL_FRAMESET,
    HTML_EL_H1,
    HTML_EL_H2,
    HTML_EL_H3,
    HTML_EL_H4,
    HTML_EL_H5,
    HTML_EL_H6,
    HTML_EL_HEAD,
    HTML_EL_HR,
    HTML_EL_HTML,
    HTML_EL_I,
    HTML_EL_IFRAME,
    HTML_EL_IMG,
    HTML_EL_INPUT,
    HTML_EL_INS,
    HTML_EL_ISINDEX,
    HTML_EL_KBD,
    HTML_EL_LABEL,
    HTML_EL_LEGEND,
    HTML_EL_LI,
    HTML_EL_LINK,
    HTML_EL_LISTING,    // Microsoft Specific
    HTML_EL_MAP,
    HTML_EL_MARQUEE,    // Microsoft Specific
    HTML_EL_MENU,
    HTML_EL_META,
    HTML_EL_NEXTID,     // Microsoft Specific
    HTML_EL_NOBR,       // Microsoft Specific
    HTML_EL_NOEMBED,    // Microsoft Specific
    HTML_EL_NOFRAMES,
    HTML_EL_NOSCRIPT,
    HTML_EL_OBJECT,
    HTML_EL_OL,
    HTML_EL_OPTGROUP,
    HTML_EL_OPTION,
    HTML_EL_P,
    HTML_EL_PARAM,
    HTML_EL_PLAINTEXT,  // Microsoft Specific
    HTML_EL_PRE,
    HTML_EL_Q,
    HTML_EL_RT,         // Microsoft Specific
    HTML_EL_RUBY,       // Microsoft Specific
    HTML_EL_S,
    HTML_EL_SAMP,
    HTML_EL_SCRIPT,
    HTML_EL_SELECT,
    HTML_EL_SMALL,
    HTML_EL_SPAN,
    HTML_EL_STRIKE,
    HTML_EL_STRONG,
    HTML_EL_STYLE,
    HTML_EL_SUB,
    HTML_EL_SUP,
    HTML_EL_TABLE,
    HTML_EL_TBODY,
    HTML_EL_TD,
    HTML_EL_TEXTAREA,
    HTML_EL_TFOOT,
    HTML_EL_TH,
    HTML_EL_THEAD,
    HTML_EL_TITLE,
    HTML_EL_TR,
    HTML_EL_TT,
    HTML_EL_U,
    HTML_EL_UL,
    HTML_EL_VAR,
    HTML_EL_WBR,        // Microsoft Specific
    HTML_EL_XMP,        // Microsoft Specific

    HTML_EL_ZADNJI,
    HTML_EL_NEZNAN  = -1,
    HTML_EL_PCDATA  = -2,
    HTML_EL_CDATA   = -3,
};


//////////////////////////////////////////////////////////////////////
// T_HTMLVRSTAODSEKA
//////////////////////////////////////////////////////////////////////

enum T_HTMLVRSTAODSEKA {
    HTML_ODSEK_BESEDILO = 0,
    HTML_ODSEK_OZNAKA_SAMOSTOJNA,   // oznake vrste <.../>
    HTML_ODSEK_OZNAKA_UVODNA,       // oznake vrste <...>
    HTML_ODSEK_OZNAKA_ZAKLJUCNA,    // oznake vrste </...>
    HTML_ODSEK_DEKLARACIJA,         // oznake vrste <!...>
    HTML_ODSEK_KOMENTAR,            // oznaka vrste <!--...-->
    HTML_ODSEK_NAVODILO,            // oznake vrste <?...> in <?...?>
    HTML_ODSEK_PCDATA,              // oznaka vrste <![PCDATA[...]]>
    HTML_ODSEK_CDATA,               // oznaka vrste <![CDATA[...]]>

    HTML_ODSEK_NEZNAN = -1
};


//////////////////////////////////////////////////////////////////////
// T_HTMLLASTNOST
//////////////////////////////////////////////////////////////////////

struct T_HTMLLASTNOST {
    T_INTERVAL<T_UINT> ime;         // interval imena lastnosti
    T_INTERVAL<T_UINT> vrednost;    // interval vrednosti lastnosti
};


//////////////////////////////////////////////////////////////////////
// RHTMLRegElIdentP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RHTMLRegElIdentP : public RRegElementP<TIP>
{
public:
    RHTMLRegElIdentP();

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
};


//////////////////////////////////////////////////////////////////////
// RHTMLRegElVrednostP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RHTMLRegElVrednostP : public RRegElementP<TIP>
{
public:
    RHTMLRegElVrednostP();

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
    virtual T_VOID Razveljavi();

public:
    T_INTERVAL<T_UINT> vsebina;     // interval vsebine vrednosti
};


//////////////////////////////////////////////////////////////////////
// RHTMLRegElOznakaP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RHTMLRegElOznakaP : public RRegElementP<TIP>
{
public:
    RHTMLRegElOznakaP();

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_VECVRSTICNO);
    virtual T_VOID Razveljavi();

public:
    T_HTMLVRSTAODSEKA          vrsta;       // vrsta oznake
    T_INTERVAL<T_UINT>         ime;         // interval imena oznake
    RDinTabela<T_HTMLLASTNOST> lastnosti;   // tabela lastnosti

protected:
    RHTMLRegElIdentP<TIP>    ident;
    RHTMLRegElVrednostP<TIP> vrednost;
};


//////////////////////////////////////////////////////////////////////
// RHTMLRegElDeklaracijaPogojZacP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RHTMLRegElDeklaracijaPogojZacP : public RRegElementP<TIP>
{
public:
    RHTMLRegElDeklaracijaPogojZacP();

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_VECVRSTICNO);
    virtual T_VOID Razveljavi();

public:
    T_INTERVAL<T_UINT> pogoj; // interval pogoja
};


//////////////////////////////////////////////////////////////////////
// RHTMLRegElDeklaracijaPogojKonP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RHTMLRegElDeklaracijaPogojKonP : public RRegElementP<TIP>
{
public:
    RHTMLRegElDeklaracijaPogojKonP();

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_VECVRSTICNO);
};


//////////////////////////////////////////////////////////////////////
// RCSSRegElKomentarP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RCSSRegElKomentarP : public RRegElementP<TIP>
{
public:
    RCSSRegElKomentarP();

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_VECVRSTICNO);
    virtual T_VOID Razveljavi();

public:
    T_INTERVAL<T_UINT> vsebina; // interval vsebine komentarja
};


//////////////////////////////////////////////////////////////////////
// RCSSRegElCDOP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RCSSRegElCDOP : public RRegElementP<TIP>
{
public:
    RCSSRegElCDOP();

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_VECVRSTICNO);
};


//////////////////////////////////////////////////////////////////////
// RCSSRegElCDCP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RCSSRegElCDCP : public RRegElementP<TIP>
{
public:
    RCSSRegElCDCP();

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_VECVRSTICNO);
};


//////////////////////////////////////////////////////////////////////
// RCSSRegElStringP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RCSSRegElStringP : public RRegElementP<TIP>
{
public:
    RCSSRegElStringP();

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_VECVRSTICNO);
    virtual T_VOID Razveljavi();

public:
    T_INTERVAL<T_UINT> vsebina; // interval vsebine niza
};


//////////////////////////////////////////////////////////////////////
// RCSSRegElURIP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RCSSRegElURIP : public RRegElementP<TIP>
{
public:
    RCSSRegElURIP();

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_VECVRSTICNO);
    virtual T_VOID Razveljavi();

public:
    T_INTERVAL<T_UINT> vsebina; // interval vsebine niza
};


//////////////////////////////////////////////////////////////////////
// RCSSRegElImportP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RCSSRegElImportP : public RRegElementP<TIP>
{
public:
    RCSSRegElImportP();

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_VECVRSTICNO);
    virtual T_VOID Razveljavi();

public:
    T_INTERVAL<T_UINT> vsebina; // interval vsebine niza
};


//////////////////////////////////////////////////////////////////////
// RMIMERegElContentTypeP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RMIMERegElContentTypeP : public RRegElementP<TIP>
{
public:
    RMIMERegElContentTypeP();

    virtual T_BOOL PreveriUjemanje(const TIP *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_VECVRSTICNO);
    virtual T_VOID Razveljavi();

public:
    T_INTERVAL<T_UINT> mime_osnovni; // interval vsebine osnovnega tipa MIME (npr. text)
    T_INTERVAL<T_UINT> mime_dodatni; // interval vsebine dodatnega tipa MIME (npr. html)
    T_INTERVAL<T_UINT> kodna_stran;  // interval vsebine kodne strani
};


//////////////////////////////////////////////////////////////////////
// RHTMLOdsek
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RHTMLOdsek : public RElement
{
public:
    RHTMLOdsek(T_HTMLVRSTAODSEKA vrsta = HTML_ODSEK_NEZNAN, T_UINT zacetek = 0, T_UINT konec = 0, T_UINT nadrejeni = T_UINT_MAX);
    virtual ~RHTMLOdsek();          // Navidezni destruktor skrbi, da se pravilno uniijo vsi lani razreda, ko kliemo delete.

public:
    T_HTMLVRSTAODSEKA  vrsta;       // vrsta odseka
    T_INTERVAL<T_UINT> interval;    // interval odseka
    T_UINT             nadrejeni;   // indeks nadrejenega odseka
};


//////////////////////////////////////////////////////////////////////
// RHTMLOznakaSamostojna
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RHTMLOznakaSamostojna : public RHTMLOdsek
{
public:
    template <class TIP>     inline RHTMLOznakaSamostojna(RHTMLRegElOznakaP<TIP> &oznaka, TK_UNICODE besedilo, T_UINT nadrejeni) :
        RHTMLOdsek(HTML_ODSEK_OZNAKA_SAMOSTOJNA, oznaka.interval.zacetek, oznaka.interval.konec, nadrejeni),
        koda(VrniKodoElementa(besedilo + oznaka.ime.zacetek, oznaka.ime.VrniDolzino())),
        ime(oznaka.ime),
        lastnosti(oznaka.lastnosti)
    {
        // Ker konstruktor RDinTabela radodarno rezervira pomnilnik, lastnosti pa po navadi ni veliko,
        // pa e te so veinoma statine, sprostimo odveen prostor v pomnilniku.
        lastnosti.SprostiOdvecne();
    }
    virtual ~RHTMLOznakaSamostojna();       // Navidezni destruktor skrbi, da se pravilno uniijo vsi lani razreda, ko kliemo delete.

    static T_HTMLKODAELEMENTA VrniKodoElementa(TK_UNICODE ime, T_UINT dolzina);

public:
    T_HTMLKODAELEMENTA         koda;        // koda elementa, ki ga oznaka predstavlja
    T_INTERVAL<T_UINT>         ime;         // interval imena oznake
    RDinTabela<T_HTMLLASTNOST> lastnosti;   // tabela lastnosti oznake
};


//////////////////////////////////////////////////////////////////////
// RHTMLOznakaUvodna
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RHTMLOznakaUvodna : public RHTMLOznakaSamostojna
{
public:
    template <class TIP>     inline RHTMLOznakaUvodna(RHTMLRegElOznakaP<TIP> &oznaka, TK_UNICODE besedilo, T_UINT nadrejeni = T_UINT_MAX, T_UINT _zakljucna = T_UINT_MAX) :
        RHTMLOznakaSamostojna(oznaka, besedilo, nadrejeni),
        zakljucna(_zakljucna)
    {
        vrsta = HTML_ODSEK_OZNAKA_UVODNA;
    }

public:
    T_UINT zakljucna;   // indeks zakljune oznake
};


//////////////////////////////////////////////////////////////////////
// RHTMLOznakaZakljucna
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RHTMLOznakaZakljucna : public RHTMLOdsek
{
public:
    template <class TIP>     inline RHTMLOznakaZakljucna(RHTMLRegElOznakaP<TIP> &oznaka, TK_UNICODE besedilo, T_UINT nadrejeni = T_UINT_MAX, T_UINT _uvodna = T_UINT_MAX) :
        RHTMLOdsek(HTML_ODSEK_OZNAKA_ZAKLJUCNA, oznaka.interval.zacetek, oznaka.interval.konec, nadrejeni),
        koda(RHTMLOznakaSamostojna::VrniKodoElementa(besedilo + oznaka.ime.zacetek, oznaka.ime.VrniDolzino())),
        ime(oznaka.ime),
        uvodna(_uvodna) {}

public:
    T_HTMLKODAELEMENTA koda;    // koda elementa, ki ga oznaka predstavlja
    T_INTERVAL<T_UINT> ime;     // interval imena oznake
    T_UINT             uvodna;  // indeks uvodne oznake
};


//////////////////////////////////////////////////////////////////////
// RHTMLDeklaracija
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RHTMLDeklaracija : public RHTMLOdsek
{
public:
    template <class TIP>     inline RHTMLDeklaracija(RHTMLRegElOznakaP<TIP> &oznaka, T_UINT nadrejeni = T_UINT_MAX) :
        RHTMLOdsek(HTML_ODSEK_DEKLARACIJA, oznaka.interval.zacetek, oznaka.interval.konec, nadrejeni),
        ime(oznaka.ime),
        lastnosti(oznaka.lastnosti)
    {
        // Ker konstruktor RDinTabela radodarno rezervira pomnilnik, lastnosti pa po navadi ni veliko,
        // pa e te so veinoma statine, sprostimo odveen prostor v pomnilniku.
        lastnosti.SprostiOdvecne();
    }
    virtual ~RHTMLDeklaracija();            // Navidezni destruktor skrbi, da se pravilno uniijo vsi lani razreda, ko kliemo delete.

public:
    T_INTERVAL<T_UINT>         ime;         // interval imena deklaracije
    RDinTabela<T_HTMLLASTNOST> lastnosti;   // tabela lastnosti deklaracije
};


//////////////////////////////////////////////////////////////////////
// RHTMLKomentar
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RHTMLKomentar : public RHTMLOdsek
{
public:
    template <class TIP>     inline RHTMLKomentar(RHTMLRegElOznakaP<TIP> &oznaka, T_UINT nadrejeni = T_UINT_MAX) :
        RHTMLOdsek(HTML_ODSEK_KOMENTAR, oznaka.interval.zacetek, oznaka.interval.konec, nadrejeni),
        vsebina(oznaka.ime) {}

public:
    T_INTERVAL<T_UINT> vsebina; // interval vsebine komentarja
};


//////////////////////////////////////////////////////////////////////
// RHTMLNavodilo
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RHTMLNavodilo : public RHTMLOdsek
{
public:
    template <class TIP>     inline RHTMLNavodilo(RHTMLRegElOznakaP<TIP> &oznaka, T_UINT nadrejeni) :
        RHTMLOdsek(HTML_ODSEK_NAVODILO, oznaka.interval.zacetek, oznaka.interval.konec, nadrejeni),
        vsebina(oznaka.ime) {}

public:
    T_INTERVAL<T_UINT> vsebina; // vsebina navodila
};


//////////////////////////////////////////////////////////////////////
// RHTMLEntiteta
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RHTMLEntiteta : public RElement
{
public:
    RHTMLEntiteta();
    virtual ~RHTMLEntiteta();       // Navidezni destruktor skrbi, da se pravilno uniijo vsi lani razreda, ko kliemo delete.

public:
    T_INTERVAL<T_UINT> ime;         // ime entitete
    RNizU              vrednost;    // vrednost entitete
};


//////////////////////////////////////////////////////////////////////
// T_HTMLVRSTAZETONA
//////////////////////////////////////////////////////////////////////

enum T_HTMLVRSTAZETONA {
    HTML_ZETON_ZAPRTI = 0,  // => RHTMLZetonBesedilo
    HTML_ZETON_UVODNI,      // => RHTMLZetonUvodni
    HTML_ZETON_ZAKLJUCNI,   // => RHTMLZetonBesedilo
    HTML_ZETON_NASLOVURL,   // => RHTMLZetonURL
    HTML_ZETON_ZADNJI,      // => RHTMLZetonBesedilo
    HTML_ZETON_NAPAKA,      // => RHTMLZetonNapaka
    HTML_ZETON_PREKINITEV   // => RHTMLZeton
};


enum T_HTMLVRSTABESEDILAZETONA {
    HTML_BESEDILO_ZETONA_ZETONI     = 0x01,
    HTML_BESEDILO_ZETONA_BESEDILO   = 0x02,
    HTML_BESEDILO_ZETONA_NASLOV     = 0x04,
    HTML_BESEDILO_ZETONA_NASTEVANJE = 0x08,
};


enum T_HTMLZAPISURLZETONA {
    HTML_ZAPIS_URL_ZETONA_UNICODE = 0,  // Naslov URL je v izvornem besedilu zapisan tako, kot je
    HTML_ZAPIS_URL_ZETONA_HTML,         // Naslov URL je v izvornem besedilu zapisan z entitetami SGML
    HTML_ZAPIS_URL_ZETONA_CSS           // Naslov URL je v izvornem besedilu zapisan z ubenimi zaporedji CSS
};


//////////////////////////////////////////////////////////////////////
// RHTMLZeton
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RHTMLZeton : public RElement
{
protected:
    RHTMLZeton(T_HTMLVRSTAZETONA vrsta = HTML_ZETON_ZADNJI, T_UINT indeks_odseka = T_UINT_MAX, T_UINT instanca = 0);
    friend class RHTMLAnalizator;

public:
    virtual ~RHTMLZeton();      // Navidezni destruktor skrbi, da se pravilno uniijo vsi lani razreda, ko kliemo delete.
    inline T_UINT PrilepiOznako(RNizU &niz) const;
    static inline RHTMLZeton* AnalizirajOznako(TK_UNICODE niz, T_UINT &odmik);

public:
    T_HTMLVRSTAZETONA vrsta;    // vrsta etona
    T_UINT indeks_odseka;       // indeks odseka, ki ga eton predstavlja ali T_UINT_MAX, e ne predstavlja enolino enega odseka
    T_UINT instanca;            // poljuben podatek, ki ga nastavi uporabnik
};


//////////////////////////////////////////////////////////////////////
// RHTMLZetonBesedilo
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RHTMLZetonBesedilo : public RHTMLZeton
{
protected:
    RHTMLZetonBesedilo(T_HTMLVRSTAZETONA vrsta = HTML_ZETON_ZAPRTI, TK_UNICODE besedilo = NULL, T_UINT znakov = 0, T_UINT vrsta_besedila = 0, T_UINT indeks_odseka = T_UINT_MAX, T_UINT instanca = 0);
    friend class RHTMLAnalizator;

public:
    virtual ~RHTMLZetonBesedilo(); // Navidezni destruktor skrbi, da se pravilno uniijo vsi lani razreda, ko kliemo delete.

public:
    RNizU besedilo;         // besedilo etona
    T_UINT vrsta_besedila;  // maska zastavic T_HTMLVRSTABESEDILAZETONA, ki doloajo vrsto besedila
};


//////////////////////////////////////////////////////////////////////
// RHTMLZetonUvodni
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RHTMLZetonUvodni : public RHTMLZetonBesedilo
{
protected:
    RHTMLZetonUvodni(TK_UNICODE besedilo = NULL, T_UINT besedilo_znakov = 0, TK_UNICODE ime = NULL, T_UINT ime_znakov = 0, T_UINT vrsta_besedila = 0, T_UINT indeks_odseka = T_UINT_MAX, T_UINT indeks_konca = T_UINT_MAX, T_UINT instanca = 0);
    friend class RHTMLAnalizator;

public:
    virtual ~RHTMLZetonUvodni(); // Navidezni destruktor skrbi, da se pravilno uniijo vsi lani razreda, ko kliemo delete.

public:
    RNizU  ime_elementa;    // ime elementa, iz katerega lahko izdelamo zakljuno oznako
    T_UINT indeks_konca;    // indeks odseka, kjer se element s tem uvodnim etonom kona
};


//////////////////////////////////////////////////////////////////////
// RHTMLZetonURL
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RHTMLZetonURL : public RHTMLZeton
{
protected:
    RHTMLZetonURL(TK_UNICODE url = NULL, T_UINT znakov = 0, T_HTMLZAPISURLZETONA zapis = HTML_ZAPIS_URL_ZETONA_UNICODE, T_UINT indeks_odseka = T_UINT_MAX, T_UINT instanca = 0);
    friend class RHTMLAnalizator;

public:
    virtual ~RHTMLZetonURL();   // Navidezni destruktor skrbi, da se pravilno uniijo vsi lani razreda, ko kliemo delete.

public:
    RNizU url;                  // naslov URL
    T_HTMLZAPISURLZETONA zapis; // zapis naslova URL
};


//////////////////////////////////////////////////////////////////////
// RHTMLZetonNapaka
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RHTMLZetonNapaka : public RHTMLZeton
{
protected:
    RHTMLZetonNapaka(T_STANJE stanje, T_UINT instanca = 0);
    friend class RHTMLAnalizator;

public:
    T_STANJE stanje;            // koda napake, ki jo predstavlja eton
};


//////////////////////////////////////////////////////////////////////
// RHTMLDokument
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RHTMLDokument : public RElement
{
public:
    RHTMLDokument();
    virtual ~RHTMLDokument();

    T_VOID Sprazni();                                                       // Sprazne vsebino dokumenta.
    T_STANJE Prilepi(TK_UNICODE koda, T_UINT znakov = T_UINT_MAX);          // Analizira kodo HTML po blokih.
    T_STANJE Zakljuci();                                                    // Naznani konec dokumenta.
    T_STANJE Nalozi(RDatoteka &dat);                                        // Naloi dokument s toka podatkov

    inline T_STANJE Nastavi(TK_UNICODE koda, T_UINT znakov = T_UINT_MAX);   // Analizira kodo HTML v celoti.

#ifdef _DEBUG
    virtual T_VOID IzpisiDiag(T_UINT zamik = 0) const;                      // Izpie diagnostino informacijo.
#endif

    inline T_UINT ZamenjajEntitete(RNizU &izhod, TK_UNICODE vhod, T_UINT znakov) const; // Zamenja entitete v vhodnem nizu z njihovo vsebino.

    friend class RHTMLAnalizator;

protected:
    RNizU koda;                                     // koda HTML
    T_UINT znakov_analizirano;                      // koliko znakov kode HTML smo analizirali
    T_KODNASTRAN kodna_stran;                       // kodna stran dokumenta

    // Podatki za razpoznavo deklaracij
    T_UINT st_veljavnih_pogojev;                    // tevilo odprtih veljavnih pogojev
    T_UINT st_neveljavnih_pogojev;                  // tevilo odprtih neveljavnih pogojev
    T_BOOL je_cdata;                                // logina spremenljivka, ki doloa, ali smo znotraj odseka CDATA
    T_BOOL je_rcdata;                               // logina spremenljivka, ki doloa, ali smo znotraj odseka RCDATA
    RHTMLRegElDeklaracijaPogojZacU pogoj_zacetek;   // avtomat za prepoznavo pogojev DTD
    RHTMLRegElDeklaracijaPogojKonU pogoj_konec;     // avtomat za prepoznavo konca pogoja DTD
    RRegElPoljubenZnakU poljuben_znak;              // avtomat za prepoznavo poljubnega znaka
    RDinTabela<RHTMLEntiteta*> entitete;            // tabela entitet

    // Podatki za razpoznavo elementov
    RHTMLRegElOznakaU oznaka;                       // avtomat za prepoznavo oznak HTML
    RDinTabela<RHTMLOdsek*> odseki;                 // tabela odsekov
    RDinTabela<T_UINT> odprte_oznake;               // mnoica odprtih oznak
    T_UINT aktivni_element;                         // indeks uvodne oznake zadnjega odprtega elementa
    T_BOOL je_posebni_element;                      // logina spremenljivka, ki doloa, ali smo znotraj posebnega elementa (<SCRIPT>, <STYLE>, ...)
};


//////////////////////////////////////////////////////////////////////
// T_HTMLVSTAVLJENZETON
//////////////////////////////////////////////////////////////////////

struct T_HTMLVSTAVLJENZETON {
    RHTMLZeton *zeton;                  // kazalec na eton
    RHTMLSeznamZetonov2 odprti_zetoni;  // seznam odprtih etonov pri vstavljenem etonu
    T_UINT indeks_besede;               // indeks besede nosilke, ki se je dri eton
    T_BOOL za_besedo;                   // TRUE, e se eton dri besede nosilke na desni, FALSE e se dri na levi strani
};


//////////////////////////////////////////////////////////////////////
// RHTMLAnalizator
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RHTMLAnalizator : public RElement
{
public:
    RHTMLAnalizator();
    virtual ~RHTMLAnalizator();

    T_VOID Sprazni();                       // Sprazne vsebino analizatorja.
    RHTMLZetonBesedilo* Razcleni(const RHTMLDokument *dokument, TK_UNICODE naslov_url = NULL, T_UINT znakov = 0, T_BOOL razcleni_okvirje = FALSE, RKazalnikNapredka *kazalnik_napredka = NULL);    // Analizira dokument.
    static T_VOID Sestavi(RNizU &koda, const RHTMLZetonBesedilo *zeton);

#ifdef _DEBUG
    virtual T_VOID IzpisiDiag(T_UINT zamik = 0) const;                      // Izpie diagnostino informacijo.
#endif

    inline const RHTMLTabelaZetonov& VrniTabeloZetonov() const;
    inline RHTMLZeton* DodajZeton(RHTMLZeton *zeton);
    RHTMLZeton* DodajPrekinitveniZeton(T_UINT indeks_odseka = T_UINT_MAX, T_UINT instanca = 0);
    RHTMLZetonBesedilo* DodajZakljucniZeton(TK_UNICODE besedilo = NULL, T_UINT znakov = 0, T_UINT vrsta_besedila = 0, T_UINT indeks_odseka = T_UINT_MAX, T_UINT instanca = 0);
    RHTMLZetonNapaka* DodajZetonNapake(T_STANJE stanje, T_UINT instanca = 0);
    inline RHTMLZeton* DodajOznakoZetona(RHTMLZeton *zeton, RNizU &za_prevajanje);
    inline static T_VOID OdpriZetone(RNizU &besedilo_prevoda, RHTMLSeznamZetonov2 &odprti_zetoni, const RHTMLSeznamZetonov2 &novi_zetoni, T_ROCICA rocica);
    T_ROCICA ZapriZetone(RNizU &besedilo_prevoda, RHTMLSeznamZetonov2 &odprti_zetoni, const RHTMLSeznamZetonov2 &novi_zetoni);
    inline T_VOID ZapisiVstavljeneZetone(RNizU &besedilo_prevoda, RHTMLSeznamVstavljenihZetonov &vstavljeni_zetoni, T_UINT indeks, T_BOOL za_besedo, RHTMLSeznamZetonov2 &odprti_zetoni);
    inline static T_VOID Unija(RHTMLSeznamZetonov2 &a, const RHTMLSeznamZetonov2 &b);
    T_VOID PretvoriVAbsolutniURL(RNizU &rel);

protected:
    RHTMLZetonBesedilo* Razcleni(T_UINT konec, T_UINT vrsta_besedila = 0); // Rekurzivno analizira dokument.
    RHTMLZetonBesedilo* RazcleniCSS(T_UINT zacetek, T_UINT konec);         // Analizira navodilo CSS.

protected:
    const RHTMLDokument *dokument;          // kazalec na dokument, ki ga analiziramo
    T_BOOL razcleni_okvirje;                // logina spremenljivka, ki doloa, ali razlenjamo tudi okvirje
    RKazalnikNapredka *kazalnik_napredka;   // kazalec na kazalnik napredka (e ga uporabljamo)
    RHTMLTabelaZetonov zetoni;              // tabela kazalcev na etone
    T_UINT zacetek;                         // indeks aktivnega odseka, ki ga analiziramo
    TK_UNICODE koda;                        // koda HTML
    RNizU naslov_url;                       // absolutni naslov URL dokumenta

    // Za izloevanje naslovov URL iz CSS
    RCSSRegElCDOU       re_css_cdo;         // uvodna oznaka za zdruljivos s starejimi brskalniki <!--
    RCSSRegElCDCU       re_css_cdc;         // zakljuna oznaka za zdruljivost s starejimi brskalniki -->
    RCSSRegElKomentarU  re_css_komentar;    // komentar CSS
    RCSSRegElStringU    re_css_string;      // niz CSS
    RCSSRegElURIU       re_css_uri;         // niz URL
    RCSSRegElImportU    re_css_import;      // navodilo @import
    RRegElPoljubenZnakU poljuben_znak;
};

#pragma warning(pop)

#endif // AOSN_HTML


#ifdef AOSN_HTTP

#pragma warning(push)
#pragma warning(disable: 4251)
#if _MSC_VER < 1300
#pragma warning(disable: 4275)
#pragma warning(disable: 4786)
#endif

//////////////////////////////////////////////////////////////////////
// RRegElHTTPPrelomVrstice
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RRegElHTTPPrelomVrstice : public RRegElementA
{
public:
    RRegElHTTPPrelomVrstice();

    virtual T_BOOL PreveriUjemanje(const T_AZNAK *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
};


//////////////////////////////////////////////////////////////////////
// RRegElHTTPZetonRFC2616
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RRegElHTTPZetonRFC2616 : public RRegElementA
{
public:
    RRegElHTTPZetonRFC2616();

    virtual T_BOOL PreveriUjemanje(const T_AZNAK *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
};


//////////////////////////////////////////////////////////////////////
// RRegElHTTPNizRFC2616
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RRegElHTTPNizRFC2616 : public RRegElementA
{
public:
    RRegElHTTPNizRFC2616();

    virtual T_BOOL PreveriUjemanje(const T_AZNAK *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
    virtual T_VOID Razveljavi();

public:
    T_INTERVAL<T_UINT> vsebina;     // vsebina niza (brez narekovajev)
};


//////////////////////////////////////////////////////////////////////
// RRegElHTTPVrednostRFC2109
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RRegElHTTPVrednostRFC2109 : public RRegElementA
{
public:
    RRegElHTTPVrednostRFC2109();

    virtual T_BOOL PreveriUjemanje(const T_AZNAK *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
    virtual T_VOID Razveljavi();

public:
    RRegElHTTPNizRFC2616   niz;     // vrednost, zapisana kot niz
    RRegElHTTPZetonRFC2616 zeton;   // vrednost, zapisana kot ena beseda
};


//////////////////////////////////////////////////////////////////////
// RRegElHTTPStreznikURL
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RRegElHTTPStreznikURL : public RRegElementA
{
public:
    RRegElHTTPStreznikURL();

    virtual T_BOOL PreveriUjemanje(const T_AZNAK *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
};


//////////////////////////////////////////////////////////////////////
// RRegElHTTPVrataURL
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RRegElHTTPVrataURL : public RRegElementA
{
public:
    RRegElHTTPVrataURL();

    virtual T_BOOL PreveriUjemanje(const T_AZNAK *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
    virtual T_VOID Razveljavi();

public:
    T_U2 vrednost;
};


//////////////////////////////////////////////////////////////////////
// RRegElHTTPSegmentPotiURL
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RRegElHTTPSegmentPotiURL : public RRegElementA
{
public:
    RRegElHTTPSegmentPotiURL();

    virtual T_BOOL PreveriUjemanje(const T_AZNAK *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
};


//////////////////////////////////////////////////////////////////////
// RRegElHTTPPotURL
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RRegElHTTPPotURL : public RRegElementA
{
public:
    RRegElHTTPPotURL();

    virtual T_BOOL PreveriUjemanje(const T_AZNAK *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
    virtual T_VOID Razveljavi();

public:
    RDinTabela<RRegElHTTPSegmentPotiURL> segmenti; // segmenti poti
};


//////////////////////////////////////////////////////////////////////
// RRegElHTTPParameterURL
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RRegElHTTPParameterURL : public RRegElementA
{
public:
    RRegElHTTPParameterURL();

    virtual T_BOOL PreveriUjemanje(const T_AZNAK *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
    virtual T_VOID Razveljavi();

public:
    T_INTERVAL<T_UINT> ime;         // interval imena parametra
    T_INTERVAL<T_UINT> vrednost;    // interval vrednosti parametra
};


//////////////////////////////////////////////////////////////////////
// RRegElHTTPURL
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RRegElHTTPURL : public RRegElementA
{
public:
    RRegElHTTPURL();
    virtual ~RRegElHTTPURL();

    virtual T_BOOL PreveriUjemanje(const T_AZNAK *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
    virtual T_VOID Razveljavi();

public:
    RRegElHTTPStreznikURL           streznik;
    RRegElHTTPVrataURL              vrata;
    RRegElHTTPPotURL                pot;
    RSeznam<RRegElHTTPParameterURL> parametri;
};


//////////////////////////////////////////////////////////////////////
// RRegElHTTPJezikRFC1766
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RRegElHTTPJezikRFC1766 : public RRegElementA
{
public:
    RRegElHTTPJezikRFC1766();

    virtual T_BOOL PreveriUjemanje(const T_AZNAK *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
    virtual T_VOID Razveljavi();

public:
    RDinTabela< T_INTERVAL<T_UINT> > komponente; // intervali vsebin komponent jezika
};


//////////////////////////////////////////////////////////////////////
// RRegElHTTPFaktorUtezi
//////////////////////////////////////////////////////////////////////

class AOSN_TEMPLATE RRegElHTTPFaktorUtezi : public RRegElementA
{
public:
    RRegElHTTPFaktorUtezi();

    virtual T_BOOL PreveriUjemanje(const T_AZNAK *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
    virtual T_VOID Razveljavi();

public:
    T_FLOAT vrednost; // izraunana vrednost faktorja utei
};


//////////////////////////////////////////////////////////////////////
// RRegElHTTPUtezenZapis
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RRegElHTTPUtezenZapis : public RRegElementA
{
public:
    RRegElHTTPUtezenZapis();

    virtual T_BOOL PreveriUjemanje(const T_AZNAK *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
    virtual T_VOID Razveljavi();

public:
    T_INTERVAL<T_UINT>    zvezdica; // zvezdica, ki oznauje univerzalno vrednost
    TIP                   vrednost; // vrednost zapisa
    RRegElHTTPFaktorUtezi faktor;   // elena ute
};


//////////////////////////////////////////////////////////////////////
// RRegElHTTPPiskotkiParameterRFC2109
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RRegElHTTPPiskotkiParameterRFC2109 : public RRegElementA
{
public:
    RRegElHTTPPiskotkiParameterRFC2109();

    virtual T_BOOL PreveriUjemanje(const T_AZNAK *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
    virtual T_VOID Razveljavi();

public:
    RRegElHTTPZetonRFC2616    ime;      // ime pikotka
    RRegElHTTPVrednostRFC2109 vrednost; // vrednost pikotka
};


//////////////////////////////////////////////////////////////////////
// RRegElHTTPPiskotekRFC2109
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RRegElHTTPPiskotekRFC2109 : public RRegElementA
{
public:
    RRegElHTTPPiskotekRFC2109();
    virtual ~RRegElHTTPPiskotekRFC2109();

    virtual T_BOOL PreveriUjemanje(const T_AZNAK *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
    virtual T_VOID Razveljavi();

public:
    RRegElHTTPZetonRFC2616                      ime;        // ime pikotka
    RRegElHTTPVrednostRFC2109                   vrednost;   // vrednost pikotka
    RSeznam<RRegElHTTPPiskotkiParameterRFC2109> parametri;  // seznam parametrov pikotka
};


//////////////////////////////////////////////////////////////////////
// RRegElHTTPAgent
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RRegElHTTPAgent : public RRegElementA
{
public:
    RRegElHTTPAgent();

    virtual T_BOOL PreveriUjemanje(const T_AZNAK *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
    virtual T_VOID Razveljavi();

public:
    T_INTERVAL<T_UINT> vrsta;   // interval vsebine vrste protokola
    T_INTERVAL<T_UINT> verzija; // interval vsebine verzije protokola
};


//////////////////////////////////////////////////////////////////////
// RRegElHTTPProtokol
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RRegElHTTPProtokol : public RRegElementA
{
public:
    RRegElHTTPProtokol();

    virtual T_BOOL PreveriUjemanje(const T_AZNAK *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
    virtual T_VOID Razveljavi();

public:
    T_INTERVAL<T_UINT> vrsta;       // interval vsebine vrste protokola
    T_INTERVAL<T_UINT> verzija_maj; // interval vsebine verzije protokola (glavni del verzije)
    T_INTERVAL<T_UINT> verzija_min; // interval vsebine verzije protokola (podverzija)
    T_U2 verzija;                   // Verzija protokola HTTP (0x100 = 1.0, 0x101 = 1.1, ...)
};


//////////////////////////////////////////////////////////////////////
// RRegElHTTPZahteva
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RRegElHTTPZahteva : public RRegElementA
{
public:
    RRegElHTTPZahteva();

    virtual T_BOOL PreveriUjemanje(const T_AZNAK *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
    virtual T_VOID Razveljavi();

public:
    T_INTERVAL<T_UINT>   vrsta;         // interval vsebine vrste zahteve
    RRegElHTTPURL        url;           // pot zahteve
    RRegElHTTPProtokol   protokol;      // protokol

protected:
    RRegElHTTPPrelomVrstice prelom_vrstice;
};


//////////////////////////////////////////////////////////////////////
// RRegElHTTPGlava
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RRegElHTTPGlava : public RRegElementA
{
public:
    RRegElHTTPGlava();

    virtual T_BOOL PreveriUjemanje(const T_AZNAK *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
    virtual T_VOID Razveljavi();

public:
    T_INTERVAL<T_UINT>  ime;        // interval imena glave
    T_INTERVAL<T_UINT>  vrednost;   // interval vrednosti glave

protected:
    RRegElHTTPPrelomVrstice prelom_vrstice;
};


//////////////////////////////////////////////////////////////////////
// RSeznamElementovGlaveHTTP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RSeznamElementovGlaveHTTP : public TIP
{
public:
    RSeznamElementovGlaveHTTP();
    virtual ~RSeznamElementovGlaveHTTP();

    T_VOID DodajIzGlave(const T_AZNAK *besedilo, T_UINT zacetek = 0, T_UINT konec = T_UINT_MAX, T_UINT zastavice = RREGIZR_PRIVZETO);
};


//////////////////////////////////////////////////////////////////////
// RSeznamUtezenihZapisovHTTP
//////////////////////////////////////////////////////////////////////

template <class TIP> class AOSN_TEMPLATE RSeznamUtezenihZapisovHTTP : public RSeznamElementovGlaveHTTP< RUrejenSeznam<TIP> >
{
public:
    virtual T_INT Primerjaj(TIP const &prvi, TIP const &drugi) const;
};


//////////////////////////////////////////////////////////////////////
// ROdjemalecHTTP
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS ROdjemalecHTTP : public RElement
{
public:
    ROdjemalecHTTP();
    virtual ~ROdjemalecHTTP();

    T_STANJE ObdelajZahteve(RTokPodatkov *tok, T_TRENUTEK casovna_kontrola_sprejema_zahteve = -RHTTP_CASOVNA_KONTROLA_ZAHTEVE_SPREJEM, T_TRENUTEK casovna_kontrola_obdelave_zahteve = -RHTTP_CASOVNA_KONTROLA_ZAHTEVE_OBDELAVA);

protected:
    T_STANJE AnalizirajPiskotke();                                                                                      // Analizira pikotke, ki jih je poslal odjemalec in napolni seznama parametri_piskotkov in piskotki
    inline T_ROCICA NajdiGlavo(TK_ASCII ime_glave, T_UINT dolzina = T_UINT_MAX) const;                                  // Vrne roico prve glave, ki ustreza elenemu nizu
    inline T_ROCICA NajdiGlavo(T_ROCICA rocica, TK_ASCII ime_glave, T_UINT dolzina = T_UINT_MAX) const;                 // Vrne roico prve glave od vkljuno podane roice naprej, ki ustreza elenemu nizu
    inline T_ROCICA NajdiParameterURL(TK_ASCII ime_parametra, T_UINT dolzina = T_UINT_MAX) const;                       // Vrne roico prvega parametra, ki ustreza elenemu nizu
    inline T_ROCICA NajdiParameterURL(T_ROCICA rocica, TK_ASCII ime_parametra, T_UINT dolzina = T_UINT_MAX) const;      // Vrne roico prvega parametra od vkljuno podane roice naprej, ki ustreza elenemu nizu
    inline static T_STANJE PrilepiVrstico(RTokPodatkov &tok, RPomDatoteka &vsebina);                                    // Prebere vsebino toka podatkov do vkljuno prvega preloma vrstice
    inline T_STANJE PosljiOdgovor(T_UINT status);                                                                       // Polje prvo vrstico odgovora

    virtual T_STANJE SprejmiZahtevo();                                                                                  // Metoda, ki jo strenik klie, ko prejme prvo vrstico zahteve
    virtual T_STANJE PreberiZahtevo();                                                                                  // Metoda, ki jo strenik klie, ko prebere glavo zahteve in preden sledijo morebitni podatki
    virtual T_STANJE PosljiStatus(T_UINT status, TK_ASCII vsebina, T_UINT dolzina_vsebine, TK_ASCII dodatne_glave, T_UINT dolzina_dodatnih_glav);  // Metoda, ki jo strenik klie, kadar eli odjemalcu sporoiti status operacije oziroma napako
    virtual T_STANJE PosljiGlave(TK_ASCII dodatne_glave, T_UINT dolzina = T_UINT_MAX, T_TRENUTEK zadnja_sprememba = 0); // Metoda, ki jo strenik klie, kadar eli poslati glave
    virtual T_VOID   VrniOpisStatusa(T_UINT status, RNizP<T_AZNAK> &opis);                                              // Metoda, ki jo strenik klie, kadar rabi opis statusa

protected:
    class RCasomerZahteve : public RCasomer
    {
    public:
        RCasomerZahteve(ROdjemalecHTTP *odjemalec);

    protected:
        virtual T_VOID ObAlarmu(T_8 cas);                               // To metodo klie sistem ob vsaki sproitvi asomera (e je nit "alertable")

    protected:
        ROdjemalecHTTP *odjemalec;
    };

    friend class RCasomerZahteve;

protected:
    RCasomerZahteve casomer;                                            // asomer zahteve
    RTokPodatkov *tok;                                                  // tok podatkov, ki ga strenik obdeluje
    RPomDatoteka podatki_glave;                                         // glava zahteve, prebrana v pomnilnik
    RRegElHTTPZahteva zahteva;                                          // prva vrstica glave zahteve
    RSeznam<RRegElHTTPGlava> glave_zahteve;                             // seznam glav zahteve
    T_U2 verzija;                                                       // verzija protokola HTTP (0x100 = 1.0, 0x101 = 1.1, ...)
    RSeznam<RRegElHTTPPiskotkiParameterRFC2109> parametri_piskotkov;    // seznam skupnih parametrov pikotkov
    RSeznam<RRegElHTTPPiskotekRFC2109> piskotki;                        // seznam pikotkov
};


//////////////////////////////////////////////////////////////////////
// RZapisovalnikHTTP
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RZapisovalnikHTTP : public RPretvornikToka
{
public:
    RZapisovalnikHTTP(T_U2 verzija);

    virtual T_STANJE Uporabi(RTokPodatkov *izvor);                          // Pripne pretvornik na dani tok podatkov
    virtual RTokPodatkov* Odpusti();                                        // Izplakne pretvornik in odpusti tok podatkov iz njegove uporabe

    virtual T_SIZE Zapisi(TK_KAZALEC podatki, T_SIZE dolzina);              // Zapie blok podatkov na tok, vrne tevilo zapisanih bajtov

protected:
    T_U2 verzija;                                                           // verzija protokola HTTP (0x100 = 1.0, 0x101 = 1.1, ...)
};

#endif // AOSN_HTTP


#ifdef AOSN_IZJEMA

//////////////////////////////////////////////////////////////////////
// ROddajnikHTTP
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS ROddajnikHTTP : public RTokPodatkov
{
public:
    ROddajnikHTTP();
    virtual ~ROddajnikHTTP();

    inline T_BOOL JeVeljaven();

    T_STANJE Odpri(TK_NIZ streznik, T_U2 vrata, TK_NIZ dokument, TK_NIZ up_ime = NULL, TK_NIZ geslo = NULL, TK_NIZ tip_zahteve = _T("POST"), TK_NIZ agent = NULL, const TK_NIZ *zelena_vrsta_odgovora = NULL);
    T_STANJE DodajGlavo(TK_NIZ ime_glave, T_UINT st_znakov_imena, TK_NIZ vrednost_glave, T_UINT st_znakov_vrednosti);
    T_STANJE ZacniPosiljanje();                                                     // Zane poiljanje zahteve
    T_STANJE KoncajPosiljanje();                                                    // Kona poiljanje zahteve
    T_STANJE PreberiInformacijo(T_UINT vrsta, T_UINT &podatek);                     // Prebere dodatno informacijo o zahtevi
    T_STANJE PreberiInformacijo(T_UINT vrsta, RNiz &podatek);                       // Prebere dodatno informacijo o zahtevi
    T_STANJE PreberiOdgovor(TK_NIZ zelena_vrsta_odgovora, T_UINT &status, RNiz &vrsta_odgovora, RNizU &odgovor);  // Prebere status, vrsto in vsebino odgovora
    virtual T_STANJE Zapri();                                                       // Zapre tok podatkov

    virtual T_SIZE Preberi(T_KAZALEC podatki, T_SIZE dolzina);                      // Prebere blok podatkov iz toka, vrne tevilo prebranih bajtov
    virtual T_SIZE Zapisi(TK_KAZALEC podatki, T_SIZE dolzina);                      // Zapie blok podatkov na tok, vrne tevilo zapisanih bajtov

    virtual T_STANJE Izplakni();                                                    // Izplakne podatke elementa v medpomnilniku

protected:
    HINTERNET
        internet,
        povezava,
        zahteva;

    RNiz niz;
};


//////////////////////////////////////////////////////////////////////
// ROddajnikIzjem
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS ROddajnikIzjem : public ROddajnikHTTP
{
public:
    ROddajnikIzjem();

    inline T_STANJE Odpri();                                        // Odpre oddajnik za poiljanje
    T_STANJE PosljiPorocilo(TK_NIZ ime_datoteke, T_UINT &status);   // Polje datoteko s pripravljenim poroilom o napaki streniku
    inline T_STANJE PreberiOdgovor(T_UINT &status);                 // Prebere status, vrsto in vsebino odgovora

    friend class RRokovalnikIzjem;

protected:
    // Da im manj obremenjujemo kopico in sklad (v primeru napake "out of memory" ali "stack overflow"), preselimo izbrane lokalne spremenljivke v lane te strukture.
    RZLibKodirnikTokaPodatkov kodirnik;     // Kodirnik za kompresijo poroila o napaki

    RNiz vrsta_odgovora;                    // Vrsta MIME odgovora
    RNizU odgovor;                          // Besedilo odgovora, ki ga prejmemo od strenika

    static const TK_NIZ zelena_vrsta_odgovora[];
};


//////////////////////////////////////////////////////////////////////
// RRokovalnikIzjem
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RRokovalnikIzjem : public RNit
{
public:
    RRokovalnikIzjem();
    virtual ~RRokovalnikIzjem();

    T_STANJE Odpri(const struct _EXCEPTION_POINTERS *ep);
    inline T_STANJE UstvariDodatniOpis(TK_ASCII   niz, T_UINT znakov = T_UINT_MAX, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);
    inline T_STANJE UstvariDodatniOpis(TK_UNICODE niz, T_UINT znakov = T_UINT_MAX);
    inline T_STANJE UniciDodatniOpis();

protected:
    virtual T_REZULTAT Izvedi(T_KAZALEC param);
    T_STANJE ShraniPorocilo(T_BOOL je_dodatni_opis);
    T_STANJE ZapisiInPosljiPorocilo(T_BOOL je_razsirjeno, T_BOOL je_dodatni_opis, T_UINT &status);
    T_STANJE ZapisiPodatkeIzjeme(T_BOOL je_razsirjeno, T_BOOL je_dodatni_opis);
    T_STANJE ZapisiSklad(T_BOOL je_razsirjeno);

protected:
    T_STANJE stanje;                        // Stanje zadnje operacije

    RNevarenOdsek kljucavnica;              // kljuavnica za serializacijo dostopa do funkcij Sym...()

    DWORD indeks_tls_dodatnega_opisa;       // Indeks, kam niti shranjujejo dodatni opis v TLS

    // Da im manj obremenjujemo kopico in sklad (v primeru napake "out of memory" ali "stack overflow"), preselimo vse lokalne spremenljivke v lane te strukture.
    const struct _EXCEPTION_POINTERS *ep;   // Kazalec na podatke o izjemi
    HANDLE nit;                             // Roica trenutne niti
    HANDLE proces;                          // Roica trenutnega procesa
    RNizU dodatni_opis;                     // Dodatni opis k napaki, ki ga nastavi uporabnik (obiajno besedilo, ki je bilo nazadnje obdelovano ipd.)

    RDogodek pripravljen;                   // Dogodek, s katerim signaliziramo, da je nit filtra pripravljena

    RNiz sporocilo;                         // Besedilo sporoila, ki ga prikaemo uporabniku

    // ShraniPorocilo()
    T_UINT idx_datoteke;                    // Indeks datoteke poroila o napaki
    T_NIZ zacasni_niz;                      // Pomoni kazalec na niz
    RNizU ime_datoteke_modula;              // Ime datoteke trenutno izvajajoega modula
    RNiz ime_datoteke_porocila;             // Ime datoteke za zapisovanje poroila o napaki
    RMedFizDatoteka datoteka;               // Datoteka, s katero zapisujemo poroilo o napaki

    ROddajnikIzjem oddajnik;                // Oddajnik za poiljanje izjem
    RIzravnalnik izravnalnik;               // Izravnalnik za poiljanje poroila o napaki v blokih

    // ZapisiPodatkeIzjeme()
    PEXCEPTION_RECORD izjema;               // Kazalec na podatke o izjemi
    T_UINT st_izjem;                        // tevilo izjem v zaporedju

    // ZapisiSklad()
    T_BOOL je_prvic;                        // Ali smo na vrhu sklada?
    BOOL je_uspesno;                        // Ali je bila analiza skladovnega okvirja uspena?
    DWORD platforma;                        // Platforma modula
    CONTEXT kontekst;                       // Kontekst za sprehod po skladu
    STACKFRAME64 sklad_okvir;               // Podatki okvira sklada
    TK_KAZALEC zacetni_naslov_modula;       // Kazalec na zaetni naslov modula
    RNizU ime_datoteke2;                    // Ime datoteke modula, kjer smo trenutno med sprehodom po skladu
    TK_KAZALEC naslov_ukaza;                // Kazalec na naslov ukaza, kjer je izvajanje obstalo
    TK_KAZALEC modul_zacetek;               // Kazalec na zaetek modula
    TK_KAZALEC sklad_od;                    // Kazalec na zaetek sklada
    TK_KAZALEC sklad_do;                    // Kazalec na konec sklada
    TK_KAZALEC odmik;                       // Relativni naslov ukaza, kjer je izvajanje obstalo
    PIMAGE_NT_HEADERS glava_NT;             // Kazalec na glavo PE
    T_SIZE dolzina_sklada;                  // Dolina sklada v bajtih
    MEMORY_BASIC_INFORMATION mbi;           // Struktura za ugotavljanje zaetnega naslova modula
};


//////////////////////////////////////////////////////////////////////
// RIzjemeGlobalnaNit
//////////////////////////////////////////////////////////////////////

class AOSN_CLASS RIzjemeGlobalnaNit : public RNit
{
public:
    RIzjemeGlobalnaNit();

    friend class RRokovalnikIzjem;

protected:
    virtual T_REZULTAT Izvedi(T_KAZALEC param);

public:
    RRokovalnikIzjem rokovalnik_izjem;  // rokovalnik izjem, ki polje poroilo o izjemi streniku, ali pa ga shrani v zaasni imenik

protected:
    RNevarenOdsek kljucavnica;          // kljuavnica za serializacijo shranjevanja in poiljanja izjem
};

#endif // AOSN_IZJEMA


#ifdef AOSN_WAV

//////////////////////////////////////////////////////////////////////
// T_WAV_GLAVA
//////////////////////////////////////////////////////////////////////

struct T_WAV_GLAVA
{
    T_WAV_ID format;
};

template <class TOK> inline TOK& operator <<(TOK &tok, const T_WAV_GLAVA &glava);
template <class TOK> inline TOK& operator >>(TOK &tok,       T_WAV_GLAVA &glava);


//////////////////////////////////////////////////////////////////////
// T_WAV_WAVE
//////////////////////////////////////////////////////////////////////

struct T_WAV_WAVE : public T_WAV_GLAVA
{
};


//////////////////////////////////////////////////////////////////////
// T_WAV_FORMAT
//////////////////////////////////////////////////////////////////////

struct T_WAV_FORMAT
{
    enum ZAPIS {
        ZAPIS_NEZNAN          = 0x0000,
        ZAPIS_PCM             = 0x0001,
        ZAPIS_MICROSOFT_ADPCM = 0x0002,
        ZAPIS_ITU_G711_A_LAW  = 0x0006,
        ZAPIS_ITU_G711_MU_LAW = 0x0007,
        ZAPIS_IMA_ADPCM       = 0x0011,
        ZAPIS_ITU_G_723_ADPCM = 0x0016,
        ZAPIS_GSM_6_10        = 0x0031,
        ZAPIS_ITU_G_721_ADPCM = 0x0040,
        ZAPIS_MPEG            = 0x0050,
        ZAPIS_EXPERIMENTAL    = 0xffff,
    };

    ZAPIS zapis;                    // nain zapisa zvonih podatkov
    T_UINT st_kanalov;              // tevilo kanalov (1 - mono, 2 - stereo)
    T_UINT vz_frekvenca;            // vzorevalna frekvenca (vzorcev na sekundo oz. Hz)
    T_UINT bajtov_na_sekundo;       // tevilo bajtov za sekundo zvonega posnetka
    T_UINT bajtov_na_vzorec;        // tevilo bajtov za en vzorec (vsi kanali)
    T_UINT bitov_na_kanal;          // tevilo bitov na en kanal
    RPomDatoteka dodatni_podatki;   // dodatni podatki (za kompresirane zapise)
};

template <class TOK> inline TOK& operator <<(TOK &tok, const T_WAV_FORMAT &format);
template <class TOK> inline TOK& operator >>(TOK &tok,       T_WAV_FORMAT &format);


//////////////////////////////////////////////////////////////////////
// T_WAV_PODATKI
//////////////////////////////////////////////////////////////////////

struct T_WAV_PODATKI
{
    RPomDatoteka podatki;   // zvoni zapis
};


template <class TOK> inline TOK& operator <<(TOK &tok, const T_WAV_PODATKI &podatki);
template <class TOK> inline TOK& operator >>(TOK &tok,       T_WAV_PODATKI &podatki);


//////////////////////////////////////////////////////////////////////
// T_WAV_TISINA
//////////////////////////////////////////////////////////////////////

struct T_WAV_TISINA
{
    T_UINT dolzina; // dolina tiine (merjeno v tevilu vzorcev)
};


template <class TOK> inline TOK& operator <<(TOK &tok, const T_WAV_TISINA &tisina);
template <class TOK> inline TOK& operator >>(TOK &tok,       T_WAV_TISINA &tisina);


//////////////////////////////////////////////////////////////////////
// T_WAV_OZNAKA
//////////////////////////////////////////////////////////////////////

// Izklopimo poravnavo elementov v strukturi, da lahko beremo naenkrat celo tabelo elementov iz datoteke.
#pragma pack(push)
#pragma pack(1)

struct T_WAV_OZNAKA
{
    T_U4 id;            // ID oznake
    T_U4 vzorec;        // odmik oznake od zaetka zvoka (merjeno v vzorcih)
    T_U4 id_bloka;      // ID bloka, kjer je oznaka
    T_U4 odmik_bloka;   // odmik bloka v seznamu blokov, kjer je oznaka (merjeno v bajtih)
    T_U4 odmik_enote;   // odmik zaetka kompresijske enote, kjer je oznaka (merjeno v bajtih)
    T_U4 odmik_vzorca;  // odmik vzorca v kompresijski enoti (merjeno v bajtih ali vzorcih pri kompresiranih datotekah)
};

#pragma pack(pop)


//////////////////////////////////////////////////////////////////////
// T_WAV_OZNAKA_EX
//////////////////////////////////////////////////////////////////////

struct T_WAV_OZNAKA_EX : public T_WAV_OZNAKA
{
    inline T_WAV_OZNAKA_EX();
    inline const T_WAV_OZNAKA_EX& operator =(const T_WAV_OZNAKA_EX &oznaka);

    T_UINT dolzina;     // dolina obmoja (merjeno v vzorcih)
    T_WAV_ID id_namena; // ID namembnosti tega zapisa
    T_U2 drzava;        // koda drave
    T_U2 jezik;         // koda jezika
    T_U2 narecje;       // koda nareja
    T_U2 kodna_stran;   // kodna tabela
    RNizA opis;         // opis oznake
    RNizA naslov;       // naslov oznake
    RNizA opomba;       // opomba oznake
};


//////////////////////////////////////////////////////////////////////
// T_WAV_TABELA_OZNAK
//////////////////////////////////////////////////////////////////////

struct T_WAV_TABELA_OZNAK
{
    RDinTabela<T_WAV_OZNAKA> oznake;    // tabela oznak
};


template <class TOK> inline TOK& operator <<(TOK &tok, const T_WAV_TABELA_OZNAK &oznake);
template <class TOK> inline TOK& operator >>(TOK &tok,       T_WAV_TABELA_OZNAK &oznake);


//////////////////////////////////////////////////////////////////////
// T_WAV_LTXT
//////////////////////////////////////////////////////////////////////

struct T_WAV_LTXT
{
    T_U4 id;            // ID oznake
    T_UINT dolzina;     // dolina obmoja (merjeno v vzorcih)
    T_WAV_ID id_namena; // ID namembnosti tega zapisa
    T_U2 drzava;        // koda drave
    T_U2 jezik;         // koda jezika
    T_U2 narecje;       // koda nareja
    T_U2 kodna_stran;   // kodna tabela
    RNizA opis;         // opis
};

template <class TOK> inline TOK& operator <<(TOK &tok, const T_WAV_LTXT &ltxt);
template <class TOK> inline TOK& operator >>(TOK &tok,       T_WAV_LTXT &ltxt);


//////////////////////////////////////////////////////////////////////
// T_WAV_NASLOV
//////////////////////////////////////////////////////////////////////

struct T_WAV_NASLOV
{
    T_U4 id;            // ID oznake
    RNizA naslov;       // naslov oznake
};

template <class TOK> inline TOK& operator <<(TOK &tok, const T_WAV_NASLOV &naslov);
template <class TOK> inline TOK& operator >>(TOK &tok,       T_WAV_NASLOV &naslov);


//////////////////////////////////////////////////////////////////////
// T_WAV_OPOMBA
//////////////////////////////////////////////////////////////////////

struct T_WAV_OPOMBA
{
    T_U4 id;            // ID oznake
    RNizA opomba;       // opomba oznake
};

template <class TOK> inline TOK& operator <<(TOK &tok, const T_WAV_OPOMBA &opomba);
template <class TOK> inline TOK& operator >>(TOK &tok,       T_WAV_OPOMBA &opomba);


//////////////////////////////////////////////////////////////////////
// T_WAV_SEZNAM
//////////////////////////////////////////////////////////////////////

struct T_WAV_SEZNAM : public T_WAV_GLAVA
{
};


//////////////////////////////////////////////////////////////////////
// T_WAV_TABELA_OZNAK_EX
//////////////////////////////////////////////////////////////////////

struct T_WAV_TABELA_OZNAK_EX
{
    RDinTabela<T_WAV_OZNAKA_EX> oznake; // tabela oznak
};

template <class TOK> inline TOK& operator <<(TOK &dat, const T_WAV_TABELA_OZNAK_EX &oznake);

#endif // AOSN_WAV


//////////////////////////////////////////////////////////////////////
// Deklaracija funkcije za pretvorbe napak
//////////////////////////////////////////////////////////////////////

inline T_STANJE astanje(DWORD koda_win, T_STANJE privzeta);


//////////////////////////////////////////////////////////////////////
// Deklaraciji predlog amin in amax
//////////////////////////////////////////////////////////////////////

template <class TIP> inline TIP amin(const TIP v1, const TIP v2);
template <class TIP> inline TIP amax(const TIP v1, const TIP v2);


//////////////////////////////////////////////////////////////////////
// Deklaracije predlog in funkcij za raunanje
//////////////////////////////////////////////////////////////////////

template <class TIP> inline T_INT asign(TIP num);
inline T_INT asign(T_UINT num);

inline float  around(float  num);
inline double around(double num);

template <class TIP> inline TIP aabs(const TIP num);
inline T_UINT aabs(const T_UINT num);

template <class TIP> inline TIP adiff(const TIP v1, const TIP v2);

template <class TIP> inline T_VOID aswap(TIP &v1, TIP &v2);

// Predloge za delo z urejenimi tabelami (urejenost doloa funkcija COMP)
template <class TIP, T_INT(COMP)(const TIP &a, const TIP &b)> T_VOID aqsort(TIP *tabela, T_UINT st_elementov);
template <class TIP, T_INT(COMP)(const TIP &a, const TIP &b)> inline T_UINT alinsearch(const TIP *tabela, T_UINT st_elementov, const TIP &iskani);
template <class TIP, T_INT(COMP)(const TIP &a, const TIP &b)> inline T_UINT abinsearch(const TIP *tabela, T_UINT st_elementov, const TIP &iskani);

#if _MSC_VER >= 1300
// Predloge za delo z urejenimi tabelami (urejenost doloata operator <)
template <class TIP> T_VOID aqsort(TIP *tabela, T_UINT st_elementov);
template <class TIP> inline T_UINT alinsearch(const TIP *tabela, T_UINT st_elementov, const TIP &iskani);
template <class TIP> inline T_UINT abinsearch(const TIP *tabela, T_UINT st_elementov, const TIP &iskani);
#endif

inline T_INT  amuldiv(T_INT n, T_INT k, T_INT q);
inline T_UINT amuldiv(T_UINT n, T_UINT k, T_UINT q);

template <class TIP> inline TIP agcd(TIP a, TIP b, TIP *c = NULL, TIP *d = NULL);


//////////////////////////////////////////////////////////////////////
// Deklaracije predlog funkcij za raunanje z imaginarnimi tevili
//////////////////////////////////////////////////////////////////////

template <class TIP> inline const TIP           anorm(const T_KOMPLP<TIP> z);
template <class TIP> inline const TIP           anorm(const T_KOMPLRP<TIP> z);
template <class TIP> inline const TIP           aabs(const T_KOMPLP<TIP> z);
template <class TIP> inline const TIP           aabs(const T_KOMPLRP<TIP> z);
template <class TIP> inline const TIP           aarg(const T_KOMPLP<TIP> z);
template <class TIP> inline const TIP           aarg(const T_KOMPLRP<TIP> z);
template <class TIP> inline const T_KOMPLP<TIP> alog(const T_KOMPLP<TIP> z);
template <class TIP> inline const T_KOMPLP<TIP> alog(const T_KOMPLRP<TIP> z);
template <class TIP> inline const T_KOMPLP<TIP> aexp(const T_KOMPLP<TIP> z);
template <class TIP> inline const T_KOMPLP<TIP> apow(const T_KOMPLP<TIP> z1, const T_KOMPLP<TIP> z2);
template <class TIP> inline const T_KOMPLP<TIP> apow(const T_KOMPLP<TIP> z, const TIP e);
template <class TIP> inline const T_KOMPLP<TIP> apow(const TIP r, const T_KOMPLP<TIP> z);
template <class TIP> inline const T_KOMPLP<TIP> asin(const T_KOMPLP<TIP> z);
template <class TIP> inline const T_KOMPLP<TIP> acos(const T_KOMPLP<TIP> z);
template <class TIP> inline T_VOID              asincos(const T_KOMPLP<TIP> z, T_KOMPLP<TIP> &s, T_KOMPLP<TIP> &c);
template <class TIP> inline const T_KOMPLP<TIP> asinh(const T_KOMPLP<TIP> z);
template <class TIP> inline const T_KOMPLP<TIP> acosh(const T_KOMPLP<TIP> z);
template <class TIP> inline T_VOID              asincosh(const T_KOMPLP<TIP> z, T_KOMPLP<TIP> &s, T_KOMPLP<TIP> &c);


//////////////////////////////////////////////////////////////////////
// Deklaracije funkcij za rezervacijo pomnilnika
//////////////////////////////////////////////////////////////////////

#if defined(_DEBUG) || defined(AOSN_DIAGNOSTIKA)
#define aalloc(dolzina)                     _aalloc_diag(dolzina, _T(__FILE__), __LINE__)
#define arealloc(pom, dolzina)              _arealloc_diag(pom, dolzina, _T(__FILE__), __LINE__)
#define aqrealloc(pom, dolzina, ne_krajsaj) _aqrealloc_diag(pom, dolzina, ne_krajsaj, _T(__FILE__), __LINE__)
#define afree(pom)                          _afree_diag(pom, _T(__FILE__), __LINE__)
#define amsize(pom)                         _amsize_diag(pom, _T(__FILE__), __LINE__)
#define aheapvalid(pom, dolzina)            _aheapvalid_diag(pom, dolzina, _T(__FILE__), __LINE__)
#define adumpheap()                         _adumpheap()
#else
#define aalloc                              _aalloc
#define arealloc                            _arealloc
#define aqrealloc                           _aqrealloc
#define afree                               _afree
#define amsize                              _amsize
#define aheapvalid(pom, dolzina)            (1)
#define adumpheap()                         (0)
#endif
inline T_KAZALEC _aalloc(T_SIZE dolzina);
inline T_KAZALEC _arealloc(T_KAZALEC pom, T_SIZE dolzina);
inline T_KAZALEC _aqrealloc(T_KAZALEC pom, T_SIZE dolzina, T_BOOL ne_krajsaj);
inline T_VOID _afree(T_KAZALEC pom);
inline T_SIZE _amsize(T_KAZALEC pom);
inline T_BOOL _aheapvalid(T_KAZALEC pom, T_SIZE dolzina);
T_ROCICAOS AOSN_API agetheap();
#if defined(_DEBUG) || defined(AOSN_DIAGNOSTIKA)
T_KAZALEC AOSN_API _aalloc_diag(T_SIZE dolzina, TK_NIZ ime_izvorne_datoteke, T_UINT vrstica);
T_KAZALEC AOSN_API _arealloc_diag(T_KAZALEC pom, T_SIZE dolzina, TK_NIZ ime_izvorne_datoteke, T_UINT vrstica);
T_KAZALEC AOSN_API _aqrealloc_diag(T_KAZALEC pom, T_SIZE dolzina, T_BOOL ne_krajsaj, TK_NIZ ime_izvorne_datoteke, T_UINT vrstica);
T_VOID AOSN_API _afree_diag(T_KAZALEC pom, TK_NIZ ime_izvorne_datoteke, T_UINT vrstica);
T_SIZE AOSN_API _amsize_diag(T_KAZALEC pom, TK_NIZ ime_izvorne_datoteke, T_UINT vrstica);
T_BOOL AOSN_API _aheapvalid_diag(T_KAZALEC pom, T_SIZE dolzina, TK_NIZ ime_izvorne_datoteke, T_UINT vrstica);
T_BOOL AOSN_API _adumpheap();
#endif


//////////////////////////////////////////////////////////////////////
// Tabeli za preslikavo med entitetami SGML in Unicode
//////////////////////////////////////////////////////////////////////

#ifndef AOSN_BREZ_SGML
extern const T_SGML_UNICODE_ENTITETA AOSN_API sgml_unicode[AOSN_SGML_ENTITET];
extern const T_UINT                  AOSN_API unicode_sgml[AOSN_SGML_ENTITET];
#endif


//////////////////////////////////////////////////////////////////////
// Deklaracije funkcij in predlog za delo z nizi
//////////////////////////////////////////////////////////////////////

template <class TIP> inline TIP*   astrdup  (                 const TIP* izvor                                                            );
template <class TIP> inline TIP*   astrndup (                 const TIP* izvor, T_UINT znakov                                             );
template <class TIP> inline T_UINT astrdup2 (TIP**      cilj, const TIP* izvor                                                            );
                     inline T_UINT astrdup2 (T_ASCII*   cilj, TK_UNICODE izvor,                T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);
                     inline T_UINT astrdup2 (T_UNICODE* cilj, TK_ASCII   izvor,                T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);
template <class TIP> inline T_UINT astrndup2(TIP**      cilj, const TIP* izvor, T_UINT znakov                                             );
                     inline T_UINT astrndup2(T_ASCII*   cilj, TK_UNICODE izvor, T_UINT znakov, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);
                     inline T_UINT astrndup2(T_UNICODE* cilj, TK_ASCII   izvor, T_UINT znakov, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);

template <class TIP> inline TIP*      astrnset(TIP*      niz, TIP     znak, T_UINT znakov                                             );
                     inline T_ASCII   astrnset(T_ASCII   niz, T_UZNAK znak, T_UINT znakov, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);
                     inline T_UNICODE astrnset(T_UNICODE niz, T_AZNAK znak, T_UINT znakov, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);

template <class TIP> inline TIP*      astrcpy  (TIP*      cilj,                                                    const TIP* izvor                                                                  );
                     inline T_ASCII   astrcpy  (T_ASCII   cilj,                                                    TK_UNICODE izvor,                      T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);
                     inline T_UNICODE astrcpy  (T_UNICODE cilj,                                                    TK_ASCII   izvor,                      T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);
template <class TIP> inline TIP*      astrncpy (TIP*      cilj,                                                    const TIP* izvor, T_UINT znakov                                                   );
template <class TIP> inline TIP*      astrncpy (TIP*      cilj, T_UINT znakov_cilj,                                const TIP* izvor, T_UINT znakov_izvor                                             );
                     inline T_ASCII   astrncpy (T_ASCII   cilj, T_UINT znakov_cilj,                                TK_UNICODE izvor, T_UINT znakov_izvor, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);
                     inline T_UNICODE astrncpy (T_UNICODE cilj, T_UINT znakov_cilj,                                TK_ASCII   izvor, T_UINT znakov_izvor, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);
template <class TIP> inline T_UINT    astrcpy2 (TIP*      cilj,                                                    const TIP* izvor                                                                  );
                     inline T_UINT    astrcpy2 (T_ASCII   cilj,                                                    TK_UNICODE izvor,                      T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);
                     inline T_UINT    astrcpy2 (T_UNICODE cilj,                                                    TK_ASCII   izvor,                      T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);
template <class TIP> inline T_UINT    astrncpy2(TIP*      cilj,                                                    const TIP* izvor, T_UINT znakov                                                   );
template <class TIP> inline T_UINT    astrncpy2(TIP*      cilj, T_UINT znakov_cilj,                                const TIP* izvor, T_UINT znakov_izvor                                             );
                     inline T_UINT    astrncpy2(T_ASCII   cilj, T_UINT znakov_cilj,                                TK_UNICODE izvor, T_UINT znakov_izvor, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);
                     inline T_UINT    astrncpy2(T_UNICODE cilj, T_UINT znakov_cilj,                                TK_ASCII   izvor, T_UINT znakov_izvor, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);
                     inline T_UINT    astrncpy2(T_ASCII   cilj, T_UINT znakov_cilj, T_KODNASTRAN kodna_stran_cilj, TK_ASCII   izvor, T_UINT znakov_izvor, T_KODNASTRAN kodna_stran_izvor             );

template <class TIP> inline TIP*      astrcat  (TIP*      cilj,                     const TIP* izvor                                                                  );
                     inline T_ASCII   astrcat  (T_ASCII   cilj,                     TK_UNICODE izvor,                      T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);
                     inline T_UNICODE astrcat  (T_UNICODE cilj,                     TK_ASCII   izvor,                      T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);
template <class TIP> inline TIP*      astrncat (TIP*      cilj,                     const TIP* izvor, T_UINT znakov                                                   );
template <class TIP> inline TIP*      astrncat (TIP*      cilj, T_UINT znakov_cilj, const TIP* izvor, T_UINT znakov_izvor                                             );
                     inline T_ASCII   astrncat (T_ASCII   cilj, T_UINT znakov_cilj, TK_UNICODE izvor, T_UINT znakov_izvor, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);
                     inline T_UNICODE astrncat (T_UNICODE cilj, T_UINT znakov_cilj, TK_ASCII   izvor, T_UINT znakov_izvor, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);
template <class TIP> inline T_UINT    astrcat2 (TIP*      cilj,                     const TIP* izvor                                                                  );
                     inline T_UINT    astrcat2 (T_ASCII   cilj,                     TK_UNICODE izvor,                      T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);
                     inline T_UINT    astrcat2 (T_UNICODE cilj,                     TK_ASCII   izvor,                      T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);
template <class TIP> inline T_UINT    astrncat2(TIP*      cilj,                     const TIP* izvor, T_UINT znakov                                                   );
template <class TIP> inline T_UINT    astrncat2(TIP*      cilj, T_UINT znakov_cilj, const TIP* izvor, T_UINT znakov_izvor                                             );
                     inline T_UINT    astrncat2(T_ASCII   cilj, T_UINT znakov_cilj, TK_UNICODE izvor, T_UINT znakov_izvor, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);
                     inline T_UINT    astrncat2(T_UNICODE cilj, T_UINT znakov_cilj, TK_ASCII   izvor, T_UINT znakov_izvor, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);

template <class TIP> inline T_UINT astrlen (const TIP* niz                                         );
template <class TIP> inline T_UINT astrnlen(const TIP* niz, T_UINT znakov                          );
                     inline T_UINT astrnlen(TK_ASCII   niz, T_UINT znakov, T_KODNASTRAN kodna_stran);
                     inline T_UINT astrnlen(TK_UNICODE niz, T_UINT znakov, T_KODNASTRAN kodna_stran);

inline T_UINT achrlen (TK_ASCII   entiteta, T_UINT znakov, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);
inline T_UINT achrlen (TK_UNICODE entiteta, T_UINT znakov                                             );
inline T_UINT achrrlen(TK_ASCII   entiteta, T_UINT znakov, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);
inline T_UINT achrrlen(TK_UNICODE entiteta, T_UINT znakov                                             );

template <class TIP1, class TIP2> inline T_INT astrcmp   (const TIP1 *niz1,                 const TIP2 *niz2                );
template <class TIP1, class TIP2> inline T_INT astrncmp  (const TIP1 *niz1,                 const TIP2 *niz2, T_UINT znakov );
template <class TIP1, class TIP2> inline T_INT astrncmp  (const TIP1 *niz1, T_UINT znakov1, const TIP2 *niz2, T_UINT znakov2);
template <class TIP1, class TIP2> inline T_INT astricmp  (const TIP1 *niz1,                 const TIP2 *niz2                );
template <class TIP1, class TIP2> inline T_INT astrnicmp (const TIP1 *niz1,                 const TIP2 *niz2, T_UINT znakov );
template <class TIP1, class TIP2> inline T_INT astrnicmp (const TIP1 *niz1, T_UINT znakov1, const TIP2 *niz2, T_UINT znakov2);
template <class TIP1, class TIP2> inline T_INT astrrcmp  (const TIP1 *niz1,                 const TIP2 *niz2                );
template <class TIP1, class TIP2> inline T_INT astrrncmp (const TIP1 *niz1,                 const TIP2 *niz2, T_UINT znakov );
template <class TIP1, class TIP2> inline T_INT astrrncmp (const TIP1 *niz1, T_UINT znakov1, const TIP2 *niz2, T_UINT znakov2);
template <class TIP1, class TIP2> inline T_INT astrricmp (const TIP1 *niz1,                 const TIP2 *niz2                );
template <class TIP1, class TIP2> inline T_INT astrrnicmp(const TIP1 *niz1,                 const TIP2 *niz2, T_UINT znakov );
template <class TIP1, class TIP2> inline T_INT astrrnicmp(const TIP1 *niz1, T_UINT znakov1, const TIP2 *niz2, T_UINT znakov2);
template <class TIP1, class TIP2> inline T_INT astrercmp (const TIP1 *niz1,                 const TIP2 *niz2                );
template <class TIP1, class TIP2> inline T_INT astrericmp(const TIP1 *niz1,                 const TIP2 *niz2                );

template <class TIP> inline T_INT  astrcoll  (const TIP* niz1,                 const TIP* niz2,                 T_KODALOCALE locale);
template <         > inline T_INT  astrcoll  (TK_ASCII   niz1,                 TK_ASCII   niz2,                 T_KODALOCALE locale);
template <         > inline T_INT  astrcoll  (TK_UNICODE niz1,                 TK_UNICODE niz2,                 T_KODALOCALE locale);
template <class TIP> inline T_INT  astricoll (const TIP* niz1,                 const TIP* niz2,                 T_KODALOCALE locale);
template <         > inline T_INT  astricoll (TK_ASCII   niz1,                 TK_ASCII   niz2,                 T_KODALOCALE locale);
template <         > inline T_INT  astricoll (TK_UNICODE niz1,                 TK_UNICODE niz2,                 T_KODALOCALE locale);
template <class TIP> inline T_INT  astrncoll (const TIP* niz1,                 const TIP* niz2, T_UINT znakov,  T_KODALOCALE locale);
template <         > inline T_INT  astrncoll (TK_ASCII   niz1,                 TK_ASCII   niz2, T_UINT znakov,  T_KODALOCALE locale);
template <         > inline T_INT  astrncoll (TK_UNICODE niz1,                 TK_UNICODE niz2, T_UINT znakov,  T_KODALOCALE locale);
template <class TIP> inline T_INT  astrncoll (const TIP* niz1, T_UINT znakov1, const TIP* niz2, T_UINT znakov2, T_KODALOCALE locale);
template <         > inline T_INT  astrncoll (TK_ASCII   niz1, T_UINT znakov1, TK_ASCII   niz2, T_UINT znakov2, T_KODALOCALE locale);
template <         > inline T_INT  astrncoll (TK_UNICODE niz1, T_UINT znakov1, TK_UNICODE niz2, T_UINT znakov2, T_KODALOCALE locale);
template <class TIP> inline T_INT  astrnicoll(const TIP* niz1,                 const TIP* niz2, T_UINT znakov,  T_KODALOCALE locale);
template <         > inline T_INT  astrnicoll(TK_ASCII   niz1,                 TK_ASCII   niz2, T_UINT znakov,  T_KODALOCALE locale);
template <         > inline T_INT  astrnicoll(TK_UNICODE niz1,                 TK_UNICODE niz2, T_UINT znakov,  T_KODALOCALE locale);
template <class TIP> inline T_INT  astrnicoll(const TIP* niz1, T_UINT znakov1, const TIP* niz2, T_UINT znakov2, T_KODALOCALE locale);
template <         > inline T_INT  astrnicoll(TK_ASCII   niz1, T_UINT znakov1, TK_ASCII   niz2, T_UINT znakov2, T_KODALOCALE locale);
template <         > inline T_INT  astrnicoll(TK_UNICODE niz1, T_UINT znakov1, TK_UNICODE niz2, T_UINT znakov2, T_KODALOCALE locale);

template <class TIP> inline TIP*   astrchr    (const TIP* niz, TIP znak               );
template <class TIP> inline TIP*   astrnchr   (const TIP* niz, TIP znak, T_UINT znakov);
template <class TIP> inline TIP*   astrichr   (const TIP* niz, TIP znak               );
template <class TIP> inline TIP*   astrnichr  (const TIP* niz, TIP znak, T_UINT znakov);
template <class TIP> inline TIP*   astrrchr   (const TIP* niz, TIP znak               );
template <class TIP> inline TIP*   astrrnchr  (const TIP* niz, TIP znak, T_UINT znakov);
template <class TIP> inline TIP*   astrrichr  (const TIP* niz, TIP znak               );
template <class TIP> inline TIP*   astrrnichr (const TIP* niz, TIP znak, T_UINT znakov);
template <class TIP> inline T_UINT astrnchr2  (const TIP* niz, T_UINT znakov, TIP znak);
template <class TIP> inline T_UINT astrnichr2 (const TIP* niz, T_UINT znakov, TIP znak);
template <class TIP> inline T_UINT astrrnchr2 (const TIP* niz, T_UINT znakov, TIP znak);
template <class TIP> inline T_UINT astrrnichr2(const TIP* niz, T_UINT znakov, TIP znak);

template <class TIP> inline T_UINT astrcountchr  (const TIP* niz, TIP znak               );
template <class TIP> inline T_UINT astrncountchr (const TIP* niz, TIP znak, T_UINT znakov);
template <class TIP> inline T_UINT astricountchr (const TIP* niz, TIP znak               );
template <class TIP> inline T_UINT astrnicountchr(const TIP* niz, TIP znak, T_UINT znakov);

template <class TIP> inline TIP*   astrstr   (const TIP* niz, const TIP* vzorec               );
template <class TIP> inline TIP*   astrnstr  (const TIP* niz, const TIP* vzorec, T_UINT znakov);
template <class TIP> inline TIP*   astristr  (const TIP* niz, const TIP* vzorec               );
template <class TIP> inline TIP*   astrnistr (const TIP* niz, const TIP* vzorec, T_UINT znakov);
template <class TIP> inline TIP*   astrrstr  (const TIP* niz, const TIP* vzorec               );
template <class TIP> inline TIP*   astrrnstr (const TIP* niz, const TIP* vzorec, T_UINT znakov);
template <class TIP> inline TIP*   astrristr (const TIP* niz, const TIP* vzorec               );
template <class TIP> inline TIP*   astrrnistr(const TIP* niz, const TIP* vzorec, T_UINT znakov);

template <class TIP> inline T_UINT astrspn  (const TIP* niz, const TIP* nabor               );
template <class TIP> inline T_UINT astrnspn (const TIP* niz, const TIP* nabor, T_UINT znakov);
template <class TIP> inline T_UINT astrcspn (const TIP* niz, const TIP* nabor               );
template <class TIP> inline T_UINT astrcnspn(const TIP* niz, const TIP* nabor, T_UINT znakov);

template <class TIP> inline TIP     atolower(TIP     znak);
template <         > inline T_AZNAK atolower(T_AZNAK znak);
template <         > inline T_UZNAK atolower(T_UZNAK znak);
template <class TIP> inline TIP     atoupper(TIP     znak);
template <         > inline T_AZNAK atoupper(T_AZNAK znak);
template <         > inline T_UZNAK atoupper(T_UZNAK znak);

template <class TIP> inline TIP*   astrupr (TIP* niz               );
template <class TIP> inline TIP*   astrnupr(TIP* niz, T_UINT znakov);

template <class TIP> inline TIP*   astrlwr (TIP* niz               );
template <class TIP> inline TIP*   astrnlwr(TIP* niz, T_UINT znakov);

template <class TIP> inline T_UINT acrlf2nl(TIP* cilj, const TIP* izvor);

inline T_BOOL aisalnum(T_AZNAK znak);
inline T_BOOL aisalnum(T_AZNAK znak, T_LOCALE locale);
inline T_BOOL aisalnum(T_UZNAK znak);
inline T_BOOL aisalpha(T_AZNAK znak);
inline T_BOOL aisalpha(T_AZNAK znak, T_LOCALE locale);
inline T_BOOL aisalpha(T_UZNAK znak);
inline T_BOOL aiscntrl(T_AZNAK znak);
inline T_BOOL aiscntrl(T_AZNAK znak, T_LOCALE locale);
inline T_BOOL aiscntrl(T_UZNAK znak);
inline T_BOOL aisdigit(T_AZNAK znak);
inline T_BOOL aisdigit(T_AZNAK znak, T_LOCALE locale);
inline T_BOOL aisdigit(T_UZNAK znak);
inline T_BOOL aisgraph(T_AZNAK znak);
inline T_BOOL aisgraph(T_AZNAK znak, T_LOCALE locale);
inline T_BOOL aisgraph(T_UZNAK znak);
inline T_BOOL aislower(T_AZNAK znak);
inline T_BOOL aislower(T_AZNAK znak, T_LOCALE locale);
inline T_BOOL aislower(T_UZNAK znak);
inline T_BOOL aisprint(T_AZNAK znak);
inline T_BOOL aisprint(T_AZNAK znak, T_LOCALE locale);
inline T_BOOL aisprint(T_UZNAK znak);
inline T_BOOL aispunct(T_AZNAK znak);
inline T_BOOL aispunct(T_AZNAK znak, T_LOCALE locale);
inline T_BOOL aispunct(T_UZNAK znak);
inline T_BOOL aisspace(T_AZNAK znak);
inline T_BOOL aisspace(T_AZNAK znak, T_LOCALE locale);
inline T_BOOL aisspace(T_UZNAK znak);
inline T_BOOL aisupper(T_AZNAK znak);
inline T_BOOL aisupper(T_AZNAK znak, T_LOCALE locale);
inline T_BOOL aisupper(T_UZNAK znak);
inline T_BOOL aisxdigit(T_AZNAK znak);
inline T_BOOL aisxdigit(T_AZNAK znak, T_LOCALE locale);
inline T_BOOL aisxdigit(T_UZNAK znak);
inline T_BOOL aisrdigit(T_AZNAK znak);
inline T_BOOL aisrdigit(T_UZNAK znak);
inline T_BOOL aislbreak(T_AZNAK znak);
inline T_BOOL aislbreak(T_UZNAK znak);

template <class TIP> inline T_BOOL ais7bit (TIP* niz               );
template <class TIP> inline T_BOOL ais7bit (TIP* niz, T_UINT znakov);
template <class TIP> inline T_BOOL aisspace(TIP* niz, T_UINT znakov);

template <class TIP> inline T_UINT altrimspace(TIP* cilj,                     const TIP* izvor                     );
template <class TIP> inline T_UINT altrimspace(TIP* cilj,                     const TIP* izvor, T_UINT znakov      );
template <class TIP> inline T_UINT altrimspace(TIP* cilj, T_UINT znakov_cilj, const TIP* izvor, T_UINT znakov_izvor);
template <class TIP> inline T_UINT artrimspace(TIP* cilj,                     const TIP* izvor                     );
template <class TIP> inline T_UINT artrimspace(TIP* cilj,                     const TIP* izvor, T_UINT znakov      );
template <class TIP> inline T_UINT artrimspace(TIP* cilj, T_UINT znakov_cilj, const TIP* izvor, T_UINT znakov_izvor);
template <class TIP> inline T_UINT atrimspace (TIP* cilj,                     const TIP* izvor                     );
template <class TIP> inline T_UINT atrimspace (TIP* cilj,                     const TIP* izvor, T_UINT znakov      );
template <class TIP> inline T_UINT atrimspace (TIP* cilj, T_UINT znakov_cilj, const TIP* izvor, T_UINT znakov_izvor);

template<class TIP> inline T_BOOL astrtoguid(const TIP* niz, T_UINT znakov, GUID *id);

template <class TIP, class TIP2> inline TIP2 astrtoint (const TIP* niz, T_UINT znakov, T_UINT *konec, T_UINT osnova);
template <class TIP, class TIP2> inline TIP2 astrtouint(const TIP* niz, T_UINT znakov, T_UINT *konec, T_UINT osnova);
template <class TIP            > inline T_4  astrto4   (const TIP* niz, T_UINT znakov, T_UINT *konec, T_UINT osnova);
template <class TIP            > inline T_8  astrto8   (const TIP* niz, T_UINT znakov, T_UINT *konec, T_UINT osnova);
template <class TIP            > inline T_U4 astrtou4  (const TIP* niz, T_UINT znakov, T_UINT *konec, T_UINT osnova);
template <class TIP            > inline T_U8 astrtou8  (const TIP* niz, T_UINT znakov, T_UINT *konec, T_UINT osnova);
#ifdef _WIN64
#define astrtoi     (T_INT)astrto8
#define astrtoui    (T_UINT)astrtou8
#else
#define astrtoi     (T_INT)astrto4
#define astrtoui    (T_UINT)astrtou4
#endif

inline T_FLOAT  astrtof(TK_ASCII   niz, T_UINT znakov, T_UINT *konec, T_LOCALE locale);
inline T_FLOAT  astrtof(TK_UNICODE niz, T_UINT znakov, T_UINT *konec, T_LOCALE locale);
inline T_DOUBLE astrtod(TK_ASCII   niz, T_UINT znakov, T_UINT *konec, T_LOCALE locale);
inline T_DOUBLE astrtod(TK_UNICODE niz, T_UINT znakov, T_UINT *konec, T_LOCALE locale);
#ifdef _DOUBLE
#define astrtor astrtod
#else
#define astrtor astrtof
#endif

inline TK_ASCII   asetlocale(T_INT kategorija, TK_ASCII locale);
inline TK_UNICODE asetlocale(T_INT kategorija, TK_UNICODE locale);
inline T_LOCALE   acreatelocale(T_INT kategorija, TK_ASCII locale);
inline T_LOCALE   acreatelocale(T_INT kategorija, TK_UNICODE locale);
inline T_VOID     afreelocale(T_LOCALE locale);

inline T_UZNAK    aasctouni(TK_ASCII znak, T_UINT znakov, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);
inline T_UZNAK    ayuasctouni(T_AZNAK znak);
inline T_AZNAK    aunitoasc(T_UZNAK znak, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);
inline T_AZNAK    aunitoyuasc(T_UZNAK znak);

inline T_UINT     aguidtostr(const GUID *id, T_ASCII niz, T_UINT znakov);
inline T_UINT     aguidtostr(const GUID *id, T_UNICODE niz, T_UINT znakov);

#ifndef AOSN_BREZ_SGML
inline TK_UNICODE asgmltouni(TK_ASCII   entiteta, T_UINT znakov);
inline TK_UNICODE asgmltouni(TK_UNICODE entiteta, T_UINT znakov);
inline TK_ASCII   achrtosgml(TK_ASCII   entiteta, T_UINT znakov, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);
inline TK_ASCII   achrtosgml(TK_UNICODE entiteta, T_UINT znakov);

inline T_UINT asgmltostr(T_ASCII   cilj, T_UINT znakov_cilj, TK_ASCII   izvor, T_UINT znakov_izvor, T_UINT kateri = 0, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);
inline T_UINT asgmltostr(T_UNICODE cilj, T_UINT znakov_cilj, TK_ASCII   izvor, T_UINT znakov_izvor, T_UINT kateri = 0);
inline T_UINT asgmltostr(T_ASCII   cilj, T_UINT znakov_cilj, TK_UNICODE izvor, T_UINT znakov_izvor, T_UINT kateri = 0, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);
inline T_UINT asgmltostr(T_UNICODE cilj, T_UINT znakov_cilj, TK_UNICODE izvor, T_UINT znakov_izvor, T_UINT kateri = 0);

template <class TIP> inline TIP*   asgmlend(const TIP* niz, T_UINT znakov);
template <class TIP> inline T_UINT asgmlerr(const TIP* niz, T_UINT znakov);

inline T_UINT astrtosgml(T_ASCII cilj, T_UINT znakov_cilj, TK_UNICODE izvor, T_UINT znakov_izvor, T_UINT kateri = 0);
inline RNizA astrtosgml(TK_ASCII niz, T_UINT koliko = T_UINT_MAX, T_UINT kateri = 0, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);
inline RNizA astrtosgml(TK_UNICODE niz, T_UINT koliko = T_UINT_MAX, T_UINT kateri = 0);
#endif

inline T_VOID* amemcpy(T_KAZALEC dst, TK_KAZALEC src, T_SIZE n);

inline T_INT avsnprintf(T_ASCII niz, T_UINT znakov, TK_ASCII format, T_LOCALE locale, va_list parametri);
inline T_INT avsnprintf(T_UNICODE niz, T_UINT znakov, TK_UNICODE format, T_LOCALE locale, va_list parametri);
inline T_INT asnprintf(T_ASCII niz, T_UINT znakov, TK_ASCII format, T_LOCALE locale, ...);
inline T_INT asnprintf(T_UNICODE niz, T_UINT znakov, TK_UNICODE format, T_LOCALE locale, ...);

inline T_INT aascvfprintf(FILE *izhod, HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_KODNASTRAN kodna_stran, T_LOCALE locale, va_list parametri);
inline T_INT aunivfprintf(FILE *izhod, HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_LOCALE locale, va_list parametri);
inline T_INT aascfprintf(FILE *izhod, HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_KODNASTRAN kodna_stran, T_LOCALE locale, ...);
inline T_INT aunifprintf(FILE *izhod, HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_LOCALE locale, ...);

#ifdef _UNICODE
#define avfprintf   aunivfprintf
#define afprintf    aunifprintf
#else
inline T_INT avfprintf(FILE *izhod, HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_LOCALE locale, va_list parametri);
inline T_INT afprintf(FILE *izhod, HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_LOCALE locale, ...);
#endif

inline T_UINT aloadstringz(HMODULE modul, T_UINT koda, TK_UNICODE  *niz, T_KODAJEZIKA2 jezik = AOSN_PRIVZETI_JEZIK);
inline T_UINT aloadstring(HMODULE modul, T_UINT koda, TK_UNICODE  *niz, T_KODAJEZIKA2 jezik = AOSN_PRIVZETI_JEZIK);
inline T_UINT aloadstring(HMODULE modul, T_UINT koda, T_ASCII niz, T_UINT znakov, T_KODAJEZIKA2 jezik = AOSN_PRIVZETI_JEZIK, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);
inline T_UINT aloadstring(HMODULE modul, T_UINT koda, T_UNICODE niz, T_UINT znakov, T_KODAJEZIKA2 jezik = AOSN_PRIVZETI_JEZIK);

inline T_UINT alangtoiso639(T_KODAJEZIKA2 jezik,  T_AZNAK  iso639[AOSN_KODA_ISO639_MAX ]);
inline T_UINT alangtoiso639(T_KODAJEZIKA2 jezik,  T_UZNAK  iso639[AOSN_KODA_ISO639_MAX ]);
inline T_UINT alangtoiso3166(T_KODAJEZIKA2 jezik, T_AZNAK iso3166[AOSN_KODA_ISO3166_MAX]);
inline T_UINT alangtoiso3166(T_KODAJEZIKA2 jezik, T_UZNAK iso3166[AOSN_KODA_ISO3166_MAX]);

inline T_VOID aobfuscate(T_KAZALEC cilj, TK_KAZALEC izvor, T_SIZE dolzina, T_U1 zrno);

#ifndef _DLL
T_INT ainput(FILE *dat, TK_ASCII format, T_LOCALE locale, va_list parametri);
T_INT ainput(FILE *dat, TK_UNICODE format, T_LOCALE locale, va_list parametri);
#endif

inline RNizA astrtoutf8(TK_ASCII niz, T_UINT koliko = T_UINT_MAX, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP);
inline RNizA astrtoutf8(TK_UNICODE niz, T_UINT koliko = T_UINT_MAX);
#ifndef AOSN_BREZ_SGML
inline T_VOID html_unescape(RNizA &cilj, TK_ASCII izvor, T_UINT znakov = T_UINT_MAX);
inline T_VOID html_unescape(RNizU &cilj, TK_UNICODE izvor, T_UINT znakov = T_UINT_MAX);
#endif
inline T_VOID html_escape(RNizP<T_AZNAK> &cilj, TK_ASCII izvor, T_UINT znakov = T_UINT_MAX);
inline T_VOID html_escape(RNizP<T_UZNAK> &cilj, TK_UNICODE izvor, T_UINT znakov = T_UINT_MAX);
inline T_VOID html_escape_min(RNizP<T_AZNAK> &cilj, T_AZNAK znak);
inline T_VOID html_escape_min(RNizP<T_UZNAK> &cilj, T_UZNAK znak);
inline T_VOID html_escape_min(RNizP<T_AZNAK> &cilj, TK_ASCII izvor, T_UINT znakov = T_UINT_MAX);
inline T_VOID html_escape_min(RNizP<T_UZNAK> &cilj, TK_UNICODE izvor, T_UINT znakov = T_UINT_MAX);
template <class TIP> inline T_VOID css_unescape(RNizP<TIP> &cilj, const TIP *izvor, T_UINT znakov = T_UINT_MAX);
inline T_VOID css_escape(RNizP<T_AZNAK> &cilj, TK_ASCII izvor, T_UINT znakov = T_UINT_MAX);
inline T_VOID css_escape(RNizP<T_UZNAK> &cilj, TK_UNICODE izvor, T_UINT znakov = T_UINT_MAX);


//////////////////////////////////////////////////////////////////////
// Deklaracije predlog za delo z jeziki
//////////////////////////////////////////////////////////////////////

template <class TIP> inline T_KODAJEZIKA avrnikodojezika(const TIP *iso639);
template <class TIP> inline T_UINT avrnioznakojezika(T_KODAJEZIKA koda, TIP *iso639);


//////////////////////////////////////////////////////////////////////
// Deklaracije funkcij za pisanje dnevnika
//////////////////////////////////////////////////////////////////////

#if defined(_DEBUG) || defined(AOSN_DIAGNOSTIKA)

inline T_UINT adebugPA (T_DNEVNIKPRIORITETA prioriteta,                                      TK_ASCII   format, va_list parametri);
inline T_UINT adebugPU (T_DNEVNIKPRIORITETA prioriteta,                                      TK_UNICODE format, va_list parametri);
inline T_UINT adebugA  (T_DNEVNIKPRIORITETA prioriteta,                                      TK_ASCII   format, ...              );
inline T_UINT adebugU  (T_DNEVNIKPRIORITETA prioriteta,                                      TK_UNICODE format, ...              );
inline T_UINT adebugKPA(T_DNEVNIKPRIORITETA prioriteta, TK_ASCII   datoteka, T_UINT vrstica, TK_ASCII   format, va_list parametri);
inline T_UINT adebugKPU(T_DNEVNIKPRIORITETA prioriteta, TK_UNICODE datoteka, T_UINT vrstica, TK_UNICODE format, va_list parametri);
inline T_UINT adebugKA (T_DNEVNIKPRIORITETA prioriteta, TK_ASCII   datoteka, T_UINT vrstica, TK_ASCII   format, ...              );
inline T_UINT adebugKU (T_DNEVNIKPRIORITETA prioriteta, TK_UNICODE datoteka, T_UINT vrstica, TK_UNICODE format, ...              );

#ifdef AOSN_DIAGNOSTIKA_KODA
#ifdef _UNICODE
#define adebugP(prioriteta, format, parametri)  adebugKPU(prioriteta, _L(__FILE__), __LINE__, format, parametri    )
#define adebug(prioriteta, format, ...)         adebugKU (prioriteta, _L(__FILE__), __LINE__, format, ##__VA_ARGS__)
#else
#define adebugP(prioriteta, format, parametri)  adebugKPA(prioriteta,    __FILE__ , __LINE__, format, parametri    )
#define adebug(prioriteta, format, ...)         adebugKA (prioriteta,    __FILE__ , __LINE__, format, ##__VA_ARGS__)
#endif
#else
#ifdef _UNICODE
#define adebugP adebugPU
#define adebug  adebugU
#else
#define adebugP adebugPA
#define adebug  adebugA
#endif
#endif // AOSN_DIAGNOSTIKA_KODA

#else

#if _MSC_VER < 1300

// Stare verzije Visual C++ e ne podpirajo variadinih makrov (takih s spremenljivim tevilom parametrov).
// Samo razveljavimo klic funkcije. Parametri se bodo pa vseeno ovrednotili.
#define adebugPU
#define adebugU
#define adebugPA
#define adebugA
#define adebugP
#define adebug

#else

#define adebugPU(prioriteta, format, parametri) ((void)0)
#define adebugU(prioriteta, format, ...)        ((void)0)
#define adebugPA(prioriteta, format, parametri) ((void)0)
#define adebugA(prioriteta, format, ...)        ((void)0)
#define adebugP(prioriteta, format, parametri)  ((void)0)
#define adebug(prioriteta, format, ...)         ((void)0)

#endif

#endif // _DEBUG || AOSN_DIAGNOSTIKA


//////////////////////////////////////////////////////////////////////
// Deklaracije funkcij za delo z vtinicami
//////////////////////////////////////////////////////////////////////

#ifdef AOSN_VTIC

inline T_VTICNICA asocket(T_VTICDOMENA druzina, T_VTICVRSTA tip, T_INT protokol);
inline T_INT aclosesocket(T_VTICNICA vticnica);

inline T_INT abind(T_VTICNICA vticnica, const T_SOCKADDR *naslov, T_SIZE dolzina);
inline T_INT alisten(T_VTICNICA vticnica, T_INT stevilo);
inline T_VTICNICA aaccept(T_VTICNICA vticnica, T_SOCKADDR *naslov, T_SIZE *dolzina);
inline T_INT aconnect(T_VTICNICA vticnica, const T_SOCKADDR *naslov, T_SIZE dolzina);
inline T_INT ashutdown(T_VTICNICA vticnica, T_VTICNACINZAPIRANJA kako);

inline T_INT arecv(T_VTICNICA vticnica, T_KAZALEC buf, T_SIZE dolzina, T_INT zastavice);
inline T_INT arecvfrom(T_VTICNICA vticnica, T_KAZALEC podatki, T_SIZE dolzina, T_INT zastavice, T_SOCKADDR *naslov, T_SIZE *dolzina_naslova);
inline T_INT asend(T_VTICNICA vticnica, TK_KAZALEC podatki, T_SIZE dolzina, T_INT zastavice);
inline T_INT asendto(T_VTICNICA vticnica, TK_KAZALEC podatki, T_SIZE dolzina, T_INT zastavice, const T_SOCKADDR *naslov, T_SIZE dolzina_naslova);

inline T_INT agetsockname(T_VTICNICA vticnica, T_SOCKADDR *naslov, T_SIZE *dolzina);
inline T_INT agetpeername(T_VTICNICA vticnica, T_SOCKADDR *naslov, T_SIZE *dolzina);

inline T_INT agetsockopt(T_VTICNICA vticnica, T_VTICNIVOPARAM nivo, T_VTICPARAMETER opcija, T_VOID* vrednost, T_SIZE* dolzina);
inline T_INT asetsockopt(T_VTICNICA vticnica, T_VTICNIVOPARAM nivo, T_VTICPARAMETER opcija, TK_KAZALEC vrednost, T_SIZE dolzina);
inline T_INT aioctlsocket(T_VTICNICA vticnica, T_INT ukaz, T_UINT *parameter);
inline T_INT aselect(T_INT vticnic, T_FDSET *berljive_vticnice, T_FDSET *zapisljive_vticnice, T_FDSET *napacne_vticnice, T_UINT naj_cas = NESKONCNO);

inline T_INT agethostname(T_NIZ ime, T_UINT dolzina);
inline T_HOSTENT *agethostbyaddr(TK_NIZ naslov, T_UINT dolzina, T_INT tip);
inline T_HOSTENT *agethostbyname(TK_NIZ ime);
inline T_PROTOENT *agetprotobynumber(T_INT protokol);
inline T_PROTOENT *agetprotobyname(TK_NIZ ime);
inline T_SERVENT *agetservbyport(T_INT vrata, TK_NIZ protokol);
inline T_SERVENT *agetservbyname(TK_NIZ ime, TK_NIZ protokol);

inline TK_ASCII ainet_ntoa(const T_INADDR naslov);
inline T_NIZ ainet_ntoa(const T_INADDR naslov, T_NIZ ime, T_UINT dolzina);
inline T_U4 ainet_addr(TK_NIZ naslov);

inline T_U4 ahtonl(T_U4 stevilo);
inline T_U2 ahtons(T_U2 stevilo);
inline T_U4 antohl(T_U4 stevilo);
inline T_U2 antohs(T_U2 stevilo);

#endif // AOSN_VTIC


//////////////////////////////////////////////////////////////////////
// Deklaracije javnih funkcij imenskega prostora AOsn
//////////////////////////////////////////////////////////////////////

namespace AOsn
{
    T_STANJE AOSN_API VrniVerzijo(T_UINT *verzija, T_UINT *maj, T_UINT *min, T_UINT *rev, T_UINT *build, TK_ASCII *niz);  // vrne verzijo knjiznice AOsn
    T_STANJE AOSN_API Vzpostavi();                                                              // funkcija, ki jo klie proces ob vzpostavitvi
    T_STANJE AOSN_API PocakajVzpostavitev(T_UINT naj_cas = NESKONCNO);                          // poakamo, da je vzpostavitev konana
    T_STANJE AOSN_API Zakljuci();                                                               // funkcija, ki jo klie proces ob zakljuitvi
#ifdef AOSN_IZJEMA
    T_STANJE AOSN_API ZakljuciRokovalnikIzjem();                                                // predasno zakljui prestrezanje in poiljanje izjem
    T_STANJE AOSN_API UstvariDodatniOpisZaIzjemo(TK_ASCII niz, T_UINT znakov = T_UINT_MAX, T_KODNASTRAN kodna_stran = AOSN_PRIVZETI_CP); // nastavi dodatni opis za prilogo poroilu o izjemi
    T_STANJE AOSN_API UstvariDodatniOpisZaIzjemo(TK_UNICODE niz, T_UINT znakov = T_UINT_MAX);   // nastavi dodatni opis za prilogo poroilu o izjemi
    T_STANJE AOSN_API UniciDodatniOpisZaIzjemo();                                               // odstrani dodatni opis za prilogo poroilu o izjemi
    LONG RokovalnikIzjem(PEXCEPTION_POINTERS ep);                                               // Polje podatke o izjemi SEH na Amebisov strenik (uporabljamo v stavkih __try/__except kot filter)
#endif

    T_VERZIJAOS AOSN_API VrniVerzijoOS();                                                       // vrne verzijo OS (knjiznica AOsn mora biti vzpostavljena)

    T_STANJE AOSN_API UstvariImenik(TK_NIZ imenik, TK_NIZ predloga = NULL);                     // Ustvari nov imenik

#if defined(_DEBUG) || defined(AOSN_DIAGNOSTIKA)
    inline T_UINT AOSN_API IzpisiDiagnosticnoSp(TK_ASCII format, T_LOCALE locale, ...);             // oblikuje in izpie diagnosticno informacijo
    inline T_UINT AOSN_API IzpisiDiagnosticnoSp(TK_UNICODE format, T_LOCALE locale, ...);           // oblikuje in izpie diagnosticno informacijo
    T_UINT AOSN_API IzpisiDiagnosticnoSpP(TK_ASCII format, T_LOCALE locale, va_list parametri);     // oblikuje in izpie diagnosticno informacijo
    T_UINT AOSN_API IzpisiDiagnosticnoSpP(TK_UNICODE format, T_LOCALE locale, va_list parametri);   // oblikuje in izpie diagnosticno informacijo
#else
    inline T_UINT AOSN_API IzpisiDiagnosticnoSp(TK_ASCII, T_LOCALE, ...) { return 0; };             // oblikuje in izpie diagnosticno informacijo
    inline T_UINT AOSN_API IzpisiDiagnosticnoSp(TK_UNICODE, T_LOCALE, ...) { return 0; };           // oblikuje in izpie diagnosticno informacijo
    inline T_UINT IzpisiDiagnosticnoSpP(TK_ASCII, T_LOCALE, va_list) { return 0; };                 // oblikuje in izpie diagnosticno informacijo
    inline T_UINT IzpisiDiagnosticnoSpP(TK_UNICODE, T_LOCALE, va_list) { return 0; };               // oblikuje in izpie diagnosticno informacijo
#endif

    T_UINT AOSN_API Izpisi(T_STD_ROCICA izhod, TK_ASCII niz, T_UINT znakov = T_UINT_MAX);                                                   // izpie sporoilo na standardni izhod/napako
    T_UINT AOSN_API Izpisi(T_STD_ROCICA izhod, TK_UNICODE niz, T_UINT znakov = T_UINT_MAX);                                                 // izpie sporoilo na standardni izhod/napako
    T_UINT AOSN_API Izpisi(T_STD_ROCICA izhod, HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik = AOSN_PRIVZETI_JEZIK);                      // izpie sporoilo na standardni izhod/napako
    inline T_UINT IzpisiO(T_STD_ROCICA izhod, TK_ASCII format, T_LOCALE locale, ...);                                                       // oblikuje in izpie sporoilo na standardni izhod/napako
    inline T_UINT IzpisiO(T_STD_ROCICA izhod, TK_UNICODE format, T_LOCALE locale, ...);                                                     // oblikuje in izpie sporoilo na standardni izhod/napako
    inline T_UINT IzpisiO(T_STD_ROCICA izhod, HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_LOCALE locale, ...);                       // oblikuje in izpie sporoilo na standardni izhod/napako
    T_UINT AOSN_API IzpisiOP(T_STD_ROCICA izhod, TK_ASCII format, T_LOCALE locale, va_list parametri);                                      // oblikuje in izpie sporoilo na standardni izhod/napako
    T_UINT AOSN_API IzpisiOP(T_STD_ROCICA izhod, TK_UNICODE format, T_LOCALE locale, va_list parametri);                                    // oblikuje in izpie sporoilo na standardni izhod/napako
    T_UINT AOSN_API IzpisiOP(T_STD_ROCICA izhod, HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_LOCALE locale, va_list parametri);      // oblikuje in izpie sporoilo na standardni izhod/napako

    T_STANJE AOSN_API VrniPotModula(T_ROCICAOS rocica, RNizP<T_AZNAK> &pot);
    T_STANJE AOSN_API VrniPotModula(T_ROCICAOS rocica, RNizP<T_UZNAK> &pot);

    T_STANJE AOSN_API VrniTrenutniImenik(RNizP<T_AZNAK> &pot);
    T_STANJE AOSN_API VrniTrenutniImenik(RNizP<T_UZNAK> &pot);
    T_STANJE AOSN_API NastaviTrenutniImenik(TK_ASCII pot);
    T_STANJE AOSN_API NastaviTrenutniImenik(TK_UNICODE pot);

    T_ROCICA AOSN_API RezervirajPomnilnik(T_ROCICA stari, T_SIZE nova_dolzina);
    T_VOID AOSN_API SprostiPomnilnik(T_ROCICA blok);

    T_BOOL AOSN_API DatotekaObstaja(TK_ASCII ime_datoteke, T_UINT znakov = T_UINT_MAX);         // Vrne TRUE, e datoteka/imenik na disku obstaja, ali FALSE sicer
    T_BOOL AOSN_API DatotekaObstaja(TK_UNICODE ime_datoteke, T_UINT znakov = T_UINT_MAX);       // Vrne TRUE, e datoteka/imenik na disku obstaja, ali FALSE sicer
    T_UINT AOSN_API UrediImeDatoteke(T_ASCII ime_datoteke, T_UINT znakov = T_UINT_MAX);         // Uredi velike/male rke v imenu datoteke, da ustrezajo stanju na disku
    T_UINT AOSN_API UrediImeDatoteke(T_UNICODE ime_datoteke, T_UINT znakov = T_UINT_MAX);       // Uredi velike/male rke v imenu datoteke, da ustrezajo stanju na disku
    T_STANJE AOSN_API ZbrisiDatoteko(TK_ASCII ime_datoteke, T_UINT znakov = T_UINT_MAX);        // Izbrie datoteko na disku
    T_STANJE AOSN_API ZbrisiDatoteko(TK_UNICODE ime_datoteke, T_UINT znakov = T_UINT_MAX);      // Izbrie datoteko na disku
    T_STANJE AOSN_API PreimenujDatoteko(TK_ASCII ime_datoteke, TK_ASCII novo_ime_datoteke);     // Preimenuje datoteko na disku
    T_STANJE AOSN_API PreimenujDatoteko(TK_UNICODE ime_datoteke, TK_UNICODE novo_ime_datoteke); // Preimenuje datoteko na disku
    T_STANJE AOSN_API PrepisiDatoteko(TK_ASCII ime_datoteke, TK_ASCII novo_ime_datoteke);       // Prepie datoteko na disku
    T_STANJE AOSN_API PrepisiDatoteko(TK_UNICODE ime_datoteke, TK_UNICODE novo_ime_datoteke);   // Prepie datoteko na disku

    T_STANJE AOSN_API VrniVerzijoDatoteke(TK_ASCII ime_datoteke, T_UINT *maj, T_UINT *min = NULL, T_UINT *rev = NULL, T_UINT *build = NULL);    // Vrne verzijo datoteke, ki je zapisana v virih
    T_STANJE AOSN_API VrniVerzijoDatoteke(TK_UNICODE ime_datoteke, T_UINT *maj, T_UINT *min = NULL, T_UINT *rev = NULL, T_UINT *build = NULL);  // Vrne verzijo datoteke, ki je zapisana v virih

    TK_ASCII AOSN_API VrniNazivKodneStrani(T_KODNASTRAN kodna_stran);                                       // Vrne naziv kodne strani (utf-8, utf-16, windows-1250, ipd.)
    T_KODNASTRAN AOSN_API VrniKodoKodneStrani(TK_ASCII naziv_kodne_strani, T_UINT dolzina = T_UINT_MAX);    // Vrne kodo kodne strani glede na dan naziv
    T_KODAJEZIKA2 AOSN_API VrniKodoJezika(TK_ASCII naziv_rfc1766, T_UINT dolzina = T_UINT_MAX);             // Vrne kodo jezika glede na naziv RFC 1766

    T_BOOL AOSN_API JeProcesInteraktiven();
    T_BOOL AOSN_API JeUporabnikAdministrator();

#if defined(_WIN64) || defined(__LP64__)
    inline T_BOOL JeProcesWOW64();
#else
    T_BOOL AOSN_API JeProcesWOW64();
#endif

    inline LPSAFEARRAY VrniSAFEARRAY(VARTYPE vt, T_UINT polj, T_UINT zapisov, TK_KAZALEC tabela);
    inline HRESULT VrniVBARRAY(VARTYPE vt, TK_KAZALEC tabela, T_UINT polj, T_UINT zapisov, VARIANT *var);
    template<class T, int polj> inline HRESULT VrniVBARRAY(const T *tabela, T_UINT zapisov, VARIANT *var);
    inline HRESULT ZakleniVsebinoSAFEARRAY(LPSAFEARRAY sa, T_KAZALEC *podatki, T_SIZE *dolzina);
    inline HRESULT OdkleniVsebinoSAFEARRAY(LPSAFEARRAY sa);
    template<class T> inline T_VOID SproziDogodekIDispatch(T *cp, DISPID id, DISPPARAMS *param, LCID locale = LOCALE_USER_DEFAULT);
    template<class T> inline T_BOOL VrniSkalar(const VARIANT *var, T &dst);
    inline T_BOOL VrniLogicnoVrednost(const VARIANT *var, T_BOOL &dst);

#ifdef AOSN_BITMAP
    T_VOID AOSN_API ZapisiBitmap(HDC dc, HBITMAP slika, RTokPodatkov &datoteka);
    LPSAFEARRAY AOSN_API VrniBitmapSAFEARRAY(HDC dc, HBITMAP slika);
#endif // AOSN_BITMAP

#ifdef AOSN_WAV
    inline T_INT WavPrimerjajOznakiPoID(const T_WAV_OZNAKA &a, const T_WAV_OZNAKA &b);
    inline T_INT WavPrimerjajOznakiPoCasu(const T_WAV_OZNAKA &a, const T_WAV_OZNAKA &b);
    inline T_INT WavPrimerjajOznakiExPoID(const T_WAV_OZNAKA_EX &a, const T_WAV_OZNAKA_EX &b);
    inline T_INT WavPrimerjajOznakiExPoCasu(const T_WAV_OZNAKA_EX &a, const T_WAV_OZNAKA_EX &b);
    template <class TIP> inline T_STANJE WavNajdiPrviBlok(RDatoteka &dat, T_WAV_ID dodatni_id, T_ODMIK konec_bloka = T_ODMIK_MAX, T_ODMIK *konec_najdenega_bloka = NULL);
    template <class TIP> inline T_STANJE WavPreberiPrviBlok(RDatoteka &dat, TIP &podatki, T_ODMIK konec_bloka = T_ODMIK_MAX);
    inline T_STANJE WavNajdiVsebino(RDatoteka &dat, T_ODMIK konec_bloka = T_ODMIK_MAX, T_ODMIK *konec_vsebine = NULL);
    T_STANJE AOSN_API WavPreberiOznake(RDatoteka &dat, T_WAV_TABELA_OZNAK_EX &oznake, T_ODMIK konec_bloka = T_ODMIK_MAX);
    T_STANJE AOSN_API WavIzlociOznake(RDatoteka &vhod, RDatoteka &izhod, T_ODMIK konec_bloka = T_ODMIK_MAX);
#endif // AOSN_WAV

    extern T_LOCALE AOSN_API locale_C;   // kazalec na jezikovno neodvisni locale
    extern T_LOCALE AOSN_API locale_ACP; // kazalec na locale z uporabnikovo kodno stranjo
    extern T_LOCALE AOSN_API locale_OCP; // kazalec na locale z uporabnikovo kodno stranjo (za konzolne aplikacije)
} // namespace AOsn


//////////////////////////////////////////////////////////////////////
// Zasebni include
//////////////////////////////////////////////////////////////////////

#include <math.h>
#ifdef _WIN32
#include <process.h> // AOSN_NIT
#include <winhttp.h>
#endif

#ifdef AOSN_VTIC
#pragma comment(lib, "wsock32.lib")
#endif
#ifdef AOSN_NIT
#ifndef RDOGNIT_KANAL_VER
#pragma comment(lib, "user32.lib")
#endif
#endif


//////////////////////////////////////////////////////////////////////
// Deklaracije zasebnih funkcij in predlog funkcij
//////////////////////////////////////////////////////////////////////

template <class TOK, class TIP> inline TOK&          _Zapisi(TOK &tok,          const TIP  podatek);
template <           class TIP> inline RPomDatoteka& _Zapisi(RPomDatoteka &tok, const TIP  podatek);
template <class TOK, class TIP> inline TOK&          _Preberi(TOK &tok,                TIP &podatek);
template <           class TIP> inline RPomDatoteka& _Preberi(RPomDatoteka &tok,       TIP &podatek);
template <           class TIP> inline T_VOID _Vrni   (RPomDatoteka &dat, T_ODMIK odmik,       TIP &podatek);
template <           class TIP> inline T_VOID _Nastavi(RPomDatoteka &dat, T_ODMIK odmik, const TIP  podatek);

template <class TOK> inline TOK&          _ZapisiNiz(TOK &tok,           TK_ASCII    podatek);
template <class TOK> inline TOK&          _ZapisiNiz(TOK &tok,           TK_UNICODE  podatek);
                     inline RPomDatoteka& _ZapisiNiz(RPomDatoteka &tok,  TK_ASCII    podatek);
                     inline RPomDatoteka& _ZapisiNiz(RPomDatoteka &tok,  TK_UNICODE  podatek);
template <class TOK> inline TOK&          _PreberiNiz(TOK &tok,          RNizP<T_AZNAK> &podatek);
template <class TOK> inline TOK&          _PreberiNiz(TOK &tok,          RNizP<T_UZNAK> &podatek);
                     inline RPomDatoteka& _PreberiNiz(RPomDatoteka &tok, RNizP<T_AZNAK> &podatek);
                     inline RPomDatoteka& _PreberiNiz(RPomDatoteka &tok, RNizP<T_UZNAK> &podatek);

inline T_VOID _UrediOktete(T_2 *podatek);
inline T_VOID _UrediOktete(T_4 *podatek);
inline T_VOID _UrediOktete(T_8 *podatek);
inline T_VOID _UrediOktete(T_U2 *podatek);
inline T_VOID _UrediOktete(T_U4 *podatek);
inline T_VOID _UrediOktete(T_U8 *podatek);

inline T_2 _UrediOktete(T_2 podatek);
inline T_4 _UrediOktete(T_4 podatek);
inline T_8 _UrediOktete(T_8 podatek);
inline T_U2 _UrediOktete(T_U2 podatek);
inline T_U4 _UrediOktete(T_U4 podatek);
inline T_U8 _UrediOktete(T_U8 podatek);

#ifdef DEBELEJSI_KONEC_VER
#define _LE2HE(x)   _UrediOktete(x) // Little Endian => Host Endian
#define _BE2HE(x)   (x)             // Big Endian => Host Endian
#define _HE2LE(x)   _UrediOktete(x) // Host Endian => Little Endian
#define _HE2BE(x)   (x)             // Host Endian => Big Endian
#else
#define _LE2HE(x)   (x)             // Little Endian => Host Endian
#define _BE2HE(x)   _UrediOktete(x) // Big Endian => Host Endian
#define _HE2LE(x)   (x)             // Host Endian => Little Endian
#define _HE2BE(x)   _UrediOktete(x) // Host Endian => Big Endian
#endif // DEBELEJSI_KONEC_VER

template <              class TIP_DOLZINA, unsigned int PORAVNAVA, class TOK> inline T_STANJE _PreskociIdPodatke(TOK       &dat);
template <class TIP_ID, class TIP_DOLZINA                                   > inline T_ODMIK  _OdpriGlavo       (RDatoteka &dat, TIP_ID id);
template <class TIP_ID, class TIP_DOLZINA, unsigned int PORAVNAVA           > inline T_ODMIK  _ZapriGlavo       (RDatoteka &dat, T_ODMIK zacetek);
template <class TIP_ID, class TIP_DOLZINA, unsigned int PORAVNAVA, class TOK> inline T_STANJE _NajdiGlavo       (TOK       &dat, TIP_ID id, T_ODMIK konec_bloka = T_ODMIK_MAX);


//////////////////////////////////////////////////////////////////////
// EXCEPTION_RECORD
//////////////////////////////////////////////////////////////////////

template <class TOK> inline TOK& operator <<(TOK &tok, const EXCEPTION_RECORD &x)
{
    if (NEUSPESNO(tok.VrniStanje())) return tok;
    tok << (T_U4)x.ExceptionCode;

    if (NEUSPESNO(tok.VrniStanje())) return tok;
    tok << (T_U4)x.ExceptionFlags;

    if (NEUSPESNO(tok.VrniStanje())) return tok;
    tok << (T_UINT)x.ExceptionAddress;

    if (NEUSPESNO(tok.VrniStanje())) return tok;
    tok << (T_U4)x.NumberParameters;

    for (T_UINT i = 0; i < x.NumberParameters; i++) {
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_UINT)x.ExceptionInformation[i];
    }

    return tok;
}


//////////////////////////////////////////////////////////////////////
// CONTEXT
//////////////////////////////////////////////////////////////////////

template <class TOK> inline TOK& operator <<(TOK &tok, const CONTEXT &x)
{
    if (NEUSPESNO(tok.VrniStanje())) return tok;
    tok << (T_U4)x.ContextFlags;

#if defined(_M_IX86)
    if (x.ContextFlags & CONTEXT_INTEGER) {
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U4)x.Eax;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U4)x.Ebx;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U4)x.Ecx;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U4)x.Edx;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U4)x.Esi;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U4)x.Edi;
    }

    if (x.ContextFlags & CONTEXT_CONTROL) {
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U4)x.SegSs;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U4)x.Esp;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U4)x.Ebp;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U4)x.SegCs;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U4)x.Eip;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U4)x.EFlags;
    }

    if (x.ContextFlags & CONTEXT_SEGMENTS) {
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U4)x.SegDs;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U4)x.SegEs;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U4)x.SegFs;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U4)x.SegGs;
    }

    if (x.ContextFlags & CONTEXT_FLOATING_POINT) {
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U4)x.FloatSave.ControlWord;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U4)x.FloatSave.StatusWord;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U4)x.FloatSave.TagWord;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U4)x.FloatSave.ErrorOffset;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U4)x.FloatSave.ErrorSelector;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U4)x.FloatSave.DataOffset;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U4)x.FloatSave.DataSelector;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U4)x.FloatSave.Cr0NpxState;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok.Zapisi(x.FloatSave.RegisterArea, SIZE_OF_80387_REGISTERS);
    }

    if (x.ContextFlags & CONTEXT_EXTENDED_REGISTERS) {
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok.Zapisi(x.ExtendedRegisters, MAXIMUM_SUPPORTED_EXTENSION);
    }

    if (x.ContextFlags & CONTEXT_DEBUG_REGISTERS) {
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U4)x.Dr0;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U4)x.Dr1;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U4)x.Dr2;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U4)x.Dr3;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U4)x.Dr6;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U4)x.Dr7;
    }

#elif defined(_M_X64)

    if (NEUSPESNO(tok.VrniStanje())) return tok;
    tok << (T_U4)x.MxCsr;

    if (x.ContextFlags & CONTEXT_INTEGER) {
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U8)x.Rax;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U8)x.Rcx;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U8)x.Rdx;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U8)x.Rbx;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U8)x.Rbp;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U8)x.Rsi;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U8)x.Rdi;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U8)x.R8;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U8)x.R9;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U8)x.R10;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U8)x.R11;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U8)x.R12;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U8)x.R13;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U8)x.R14;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U8)x.R15;
    }

    if (x.ContextFlags & CONTEXT_CONTROL) {
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U2)x.SegSs;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U8)x.Rsp;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U2)x.SegCs;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U8)x.Rip;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U4)x.EFlags;
    }

    if (x.ContextFlags & CONTEXT_SEGMENTS) {
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U2)x.SegDs;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U2)x.SegEs;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U2)x.SegFs;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U2)x.SegGs;
    }

    if (x.ContextFlags & CONTEXT_FLOATING_POINT) {
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U2)x.FltSave.ControlWord;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U2)x.FltSave.StatusWord;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U1)x.FltSave.TagWord;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U2)x.FltSave.ErrorOpcode;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U4)x.FltSave.ErrorOffset;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U2)x.FltSave.ErrorSelector;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U4)x.FltSave.DataOffset;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U2)x.FltSave.DataSelector;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U4)x.FltSave.MxCsr;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U4)x.FltSave.MxCsr_Mask;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok.ZapisiTab(x.FltSave.FloatRegisters, sizeof(M128A), 8);

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok.ZapisiTab(x.FltSave.XmmRegisters, sizeof(M128A), 16);
    }

    if (x.ContextFlags & CONTEXT_DEBUG_REGISTERS) {
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U8)x.Dr0;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U8)x.Dr1;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U8)x.Dr2;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U8)x.Dr3;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U8)x.Dr6;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U8)x.Dr7;
    }

#else
    #error "Neznana platforma."
#endif

    return tok;
}


//////////////////////////////////////////////////////////////////////
// EXCEPTION_RECORD32
//////////////////////////////////////////////////////////////////////

template <class TOK> inline TOK& operator >>(TOK &tok, EXCEPTION_RECORD32 &x)
{
    T_U4 pom4;

    memset(&x, 0, sizeof(EXCEPTION_RECORD32));

    tok >> pom4;
    if (tok.JeKonec()) return tok;
    x.ExceptionCode = pom4;

    tok >> pom4;
    if (tok.JeKonec()) return tok;
    x.ExceptionFlags = pom4;

    tok >> pom4;
    if (tok.JeKonec()) return tok;
    x.ExceptionAddress = pom4;

    tok >> pom4;
    if (tok.JeKonec()) return tok;
    x.NumberParameters = pom4;

    for (T_UINT i = 0; i < x.NumberParameters; i++) {
        tok >> pom4;
        if (tok.JeKonec()) return tok;
        x.ExceptionInformation[i] = pom4;
    }

    return tok;
}


//////////////////////////////////////////////////////////////////////
// CONTEXTX86
//////////////////////////////////////////////////////////////////////

template <class TOK> inline TOK& operator >>(TOK &tok, CONTEXTX86 &x)
{
    T_U4 pom4;

    memset(&x, 0, sizeof(CONTEXTX86));

    tok >> pom4;
    if (NEUSPESNO(tok.VrniStanje())) return tok;
    x.ContextFlags = pom4;

    if (x.ContextFlags & CONTEXT_INTEGER) {
        tok >> pom4;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.Eax = pom4;

        tok >> pom4;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.Ebx = pom4;

        tok >> pom4;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.Ecx = pom4;

        tok >> pom4;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.Edx = pom4;

        tok >> pom4;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.Esi = pom4;

        tok >> pom4;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.Edi = pom4;
    }

    if (x.ContextFlags & CONTEXT_CONTROL) {
        tok >> pom4;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.SegSs = pom4;

        tok >> pom4;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.Esp = pom4;

        tok >> pom4;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.Ebp = pom4;

        tok >> pom4;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.SegCs = pom4;

        tok >> pom4;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.Eip = pom4;

        tok >> pom4;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.EFlags = pom4;
    }

    if (x.ContextFlags & CONTEXT_SEGMENTS) {
        tok >> pom4;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.SegDs = pom4;

        tok >> pom4;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.SegEs = pom4;

        tok >> pom4;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.SegFs = pom4;

        tok >> pom4;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.SegGs = pom4;
    }

    if (x.ContextFlags & CONTEXT_FLOATING_POINT) {
        tok >> pom4;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.FloatSave.ControlWord = pom4;

        tok >> pom4;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.FloatSave.StatusWord = pom4;

        tok >> pom4;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.FloatSave.TagWord = pom4;

        tok >> pom4;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.FloatSave.ErrorOffset = pom4;

        tok >> pom4;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.FloatSave.ErrorSelector = pom4;

        tok >> pom4;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.FloatSave.DataOffset = pom4;

        tok >> pom4;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.FloatSave.DataSelector = pom4;

        tok >> pom4;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.FloatSave.Cr0NpxState = pom4;

        tok.Preberi(x.FloatSave.RegisterArea, SIZE_OF_80387_REGISTERS);
        if (NEUSPESNO(tok.VrniStanje())) return tok;
    }

    if (x.ContextFlags & CONTEXT_EXTENDED_REGISTERS) {
        tok.Preberi(x.ExtendedRegisters, MAXIMUM_SUPPORTED_EXTENSION);
        if (NEUSPESNO(tok.VrniStanje())) return tok;
    }

    if (x.ContextFlags & CONTEXT_DEBUG_REGISTERS) {
        tok >> pom4;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.Dr0 = pom4;

        tok >> pom4;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.Dr1 = pom4;

        tok >> pom4;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.Dr2 = pom4;

        tok >> pom4;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.Dr3 = pom4;

        tok >> pom4;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.Dr6 = pom4;

        tok >> pom4;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.Dr7 = pom4;
    }

    return tok;
}


#if _MSC_VER >= 1400

//////////////////////////////////////////////////////////////////////
// EXCEPTION_RECORD64
//////////////////////////////////////////////////////////////////////

template <class TOK> inline TOK& operator >>(TOK &tok, EXCEPTION_RECORD64 &x)
{
    T_U4 pom4;
    T_U8 pom8;

    memset(&x, 0, sizeof(EXCEPTION_RECORD64));

    tok >> pom4;
    if (tok.JeKonec()) return tok;
    x.ExceptionCode = pom4;

    tok >> pom4;
    if (tok.JeKonec()) return tok;
    x.ExceptionFlags = pom4;

    tok >> pom8;
    if (tok.JeKonec()) return tok;
    x.ExceptionAddress = pom8;

    tok >> pom4;
    if (tok.JeKonec()) return tok;
    x.NumberParameters = pom4;

    for (T_UINT i = 0; i < x.NumberParameters; i++) {
        tok >> pom8;
        if (tok.JeKonec()) return tok;
        x.ExceptionInformation[i] = pom8;
    }

    return tok;
}


//////////////////////////////////////////////////////////////////////
// CONTEXTAMD64
//////////////////////////////////////////////////////////////////////

template <class TOK> inline TOK& operator >>(TOK &tok, CONTEXTAMD64 &x)
{
    T_U1 pom1;
    T_U2 pom2;
    T_U4 pom4;
    T_U8 pom8;

    memset(&x, 0, sizeof(CONTEXTX86));

    tok >> pom4;
    if (NEUSPESNO(tok.VrniStanje())) return tok;
    x.ContextFlags = pom4;

    tok >> pom4;
    if (NEUSPESNO(tok.VrniStanje())) return tok;
    x.MxCsr = pom4;

    if (x.ContextFlags & CONTEXT_INTEGER) {
        tok >> pom8;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.Rax = pom8;

        tok >> pom8;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.Rcx = pom8;

        tok >> pom8;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.Rdx = pom8;

        tok >> pom8;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.Rbx = pom8;

        tok >> pom8;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.Rbp = pom8;

        tok >> pom8;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.Rsi = pom8;

        tok >> pom8;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.Rdi = pom8;

        tok >> pom8;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.R8 = pom8;

        tok >> pom8;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.R9 = pom8;

        tok >> pom8;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.R10 = pom8;

        tok >> pom8;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.R11 = pom8;

        tok >> pom8;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.R12 = pom8;

        tok >> pom8;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.R13 = pom8;

        tok >> pom8;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.R14 = pom8;

        tok >> pom8;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.R15 = pom8;
    }

    if (x.ContextFlags & CONTEXT_CONTROL) {
        tok >> pom2;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.SegSs = pom2;

        tok >> pom8;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.Rsp = pom8;

        tok >> pom2;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.SegCs = pom2;

        tok >> pom8;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.Rip = pom8;

        tok >> pom4;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.EFlags = pom4;
    }

    if (x.ContextFlags & CONTEXT_SEGMENTS) {
        tok >> pom2;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.SegDs = pom2;

        tok >> pom2;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.SegEs = pom2;

        tok >> pom2;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.SegFs = pom2;

        tok >> pom2;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.SegGs = pom2;
    }

    if (x.ContextFlags & CONTEXT_FLOATING_POINT) {
        tok >> pom2;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.FltSave.ControlWord = pom2;

        tok >> pom2;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.FltSave.StatusWord = pom2;

        tok >> pom1;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.FltSave.TagWord = pom1;

        tok >> pom2;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.FltSave.ErrorOpcode = pom2;

        tok >> pom4;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.FltSave.ErrorOffset = pom4;

        tok >> pom2;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.FltSave.ErrorSelector = pom2;

        tok >> pom4;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.FltSave.DataOffset = pom4;

        tok >> pom2;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.FltSave.DataSelector = pom2;

        tok >> pom4;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.FltSave.MxCsr = pom4;

        tok >> pom4;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.FltSave.MxCsr_Mask = pom4;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok.PreberiTab(x.FltSave.FloatRegisters, sizeof(M128A), 8);

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok.PreberiTab(x.FltSave.XmmRegisters, sizeof(M128A), 16);
    }

    if (x.ContextFlags & CONTEXT_DEBUG_REGISTERS) {
        tok >> pom8;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.Dr0 = pom8;

        tok >> pom8;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.Dr1 = pom8;

        tok >> pom8;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.Dr2 = pom8;

        tok >> pom8;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.Dr3 = pom8;

        tok >> pom8;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.Dr6 = pom8;

        tok >> pom8;
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        x.Dr7 = pom8;
    }

    return tok;
}

#endif // _MSC_VER >= 1400


//////////////////////////////////////////////////////////////////////
// GUID
//////////////////////////////////////////////////////////////////////

inline VARIANT& operator <<(VARIANT &p, const GUID &dat)
{
    T_UZNAK guid_niz[AOSN_GUID_STR_MIN];

    V_VT(&p) = VT_BSTR;
    V_BSTR(&p) = ::SysAllocStringLen(guid_niz, (UINT)aguidtostr(&dat, guid_niz, AOSN_GUID_STR_MIN));
    return *(&p + 1);
}


//////////////////////////////////////////////////////////////////////
// IDispatch
//////////////////////////////////////////////////////////////////////

inline VARIANT& operator <<(VARIANT &p, IDispatch* dat)
{
    V_VT(&p) = VT_DISPATCH;
    V_DISPATCH(&p) = dat;
    dat->AddRef();
    return *(&p + 1);
}


//////////////////////////////////////////////////////////////////////
// Operatorji za shranjevanje osnovnih podatkovnih tipov
//////////////////////////////////////////////////////////////////////

template <class TOK> inline TOK         & operator <<(TOK          &tok, const T_1       podatek) { return _Zapisi           (tok, podatek); }
                     inline RPomDatoteka& operator <<(RPomDatoteka &tok, const T_1       podatek) { return _Zapisi <T_1     >(tok, podatek); }
template <class TOK> inline TOK         & operator >>(TOK          &tok,       T_1      &podatek) { return _Preberi          (tok, podatek); }
                     inline RPomDatoteka& operator >>(RPomDatoteka &tok,       T_1      &podatek) { return _Preberi<T_1     >(tok, podatek); }
template <class TOK> inline TOK         & operator <<(TOK          &tok, const T_2       podatek) { return _Zapisi           (tok, podatek); }
                     inline RPomDatoteka& operator <<(RPomDatoteka &tok, const T_2       podatek) { return _Zapisi <T_2     >(tok, podatek); }
template <class TOK> inline TOK         & operator >>(TOK          &tok,       T_2      &podatek) { return _Preberi          (tok, podatek); }
                     inline RPomDatoteka& operator >>(RPomDatoteka &tok,       T_2      &podatek) { return _Preberi<T_2     >(tok, podatek); }
template <class TOK> inline TOK         & operator <<(TOK          &tok, const T_4       podatek) { return _Zapisi           (tok, podatek); }
                     inline RPomDatoteka& operator <<(RPomDatoteka &tok, const T_4       podatek) { return _Zapisi <T_4     >(tok, podatek); }
template <class TOK> inline TOK         & operator >>(TOK          &tok,       T_4      &podatek) { return _Preberi          (tok, podatek); }
                     inline RPomDatoteka& operator >>(RPomDatoteka &tok,       T_4      &podatek) { return _Preberi<T_4     >(tok, podatek); }
template <class TOK> inline TOK         & operator <<(TOK          &tok, const T_8       podatek) { return _Zapisi           (tok, podatek); }
                     inline RPomDatoteka& operator <<(RPomDatoteka &tok, const T_8       podatek) { return _Zapisi <T_8     >(tok, podatek); }
template <class TOK> inline TOK         & operator >>(TOK          &tok,       T_8      &podatek) { return _Preberi          (tok, podatek); }
                     inline RPomDatoteka& operator >>(RPomDatoteka &tok,       T_8      &podatek) { return _Preberi<T_8     >(tok, podatek); }
template <class TOK> inline TOK         & operator <<(TOK          &tok, const T_U1      podatek) { return _Zapisi           (tok, podatek); }
                     inline RPomDatoteka& operator <<(RPomDatoteka &tok, const T_U1      podatek) { return _Zapisi <T_U1    >(tok, podatek); }
template <class TOK> inline TOK         & operator >>(TOK          &tok,       T_U1     &podatek) { return _Preberi          (tok, podatek); }
                     inline RPomDatoteka& operator >>(RPomDatoteka &tok,       T_U1     &podatek) { return _Preberi<T_U1    >(tok, podatek); }
template <class TOK> inline TOK         & operator <<(TOK          &tok, const T_U2      podatek) { return _Zapisi           (tok, podatek); }
                     inline RPomDatoteka& operator <<(RPomDatoteka &tok, const T_U2      podatek) { return _Zapisi <T_U2    >(tok, podatek); }
template <class TOK> inline TOK         & operator >>(TOK          &tok,       T_U2     &podatek) { return _Preberi          (tok, podatek); }
                     inline RPomDatoteka& operator >>(RPomDatoteka &tok,       T_U2     &podatek) { return _Preberi<T_U2    >(tok, podatek); }
template <class TOK> inline TOK         & operator <<(TOK          &tok, const T_U4      podatek) { return _Zapisi           (tok, podatek); }
                     inline RPomDatoteka& operator <<(RPomDatoteka &tok, const T_U4      podatek) { return _Zapisi <T_U4    >(tok, podatek); }
template <class TOK> inline TOK         & operator >>(TOK          &tok,       T_U4     &podatek) { return _Preberi          (tok, podatek); }
                     inline RPomDatoteka& operator >>(RPomDatoteka &tok,       T_U4     &podatek) { return _Preberi<T_U4    >(tok, podatek); }
template <class TOK> inline TOK         & operator <<(TOK          &tok, const T_U8      podatek) { return _Zapisi           (tok, podatek); }
                     inline RPomDatoteka& operator <<(RPomDatoteka &tok, const T_U8      podatek) { return _Zapisi <T_U8    >(tok, podatek); }
template <class TOK> inline TOK         & operator >>(TOK          &tok,       T_U8     &podatek) { return _Preberi          (tok, podatek); }
                     inline RPomDatoteka& operator >>(RPomDatoteka &tok,       T_U8     &podatek) { return _Preberi<T_U8    >(tok, podatek); }
#ifdef _NATIVE_SIZE_T_DEFINED
template <class TOK> inline TOK         & operator <<(TOK          &tok, const T_SIZE    podatek) { return _Zapisi           (tok, podatek); }
                     inline RPomDatoteka& operator <<(RPomDatoteka &tok, const T_SIZE    podatek) { return _Zapisi <T_SIZE  >(tok, podatek); }
template <class TOK> inline TOK         & operator >>(TOK          &tok,       T_SIZE   &podatek) { return _Preberi          (tok, podatek); }
                     inline RPomDatoteka& operator >>(RPomDatoteka &tok,       T_SIZE   &podatek) { return _Preberi<T_SIZE  >(tok, podatek); }
#endif
template <class TOK> inline TOK         & operator <<(TOK          &tok, const T_FLOAT   podatek) { return _Zapisi           (tok, podatek); }
                     inline RPomDatoteka& operator <<(RPomDatoteka &tok, const T_FLOAT   podatek) { return _Zapisi <T_FLOAT >(tok, podatek); }
template <class TOK> inline TOK         & operator >>(TOK          &tok,       T_FLOAT  &podatek) { return _Preberi          (tok, podatek); }
                     inline RPomDatoteka& operator >>(RPomDatoteka &tok,       T_FLOAT  &podatek) { return _Preberi<T_FLOAT >(tok, podatek); }
template <class TOK> inline TOK         & operator <<(TOK          &tok, const T_DOUBLE  podatek) { return _Zapisi           (tok, podatek); }
                     inline RPomDatoteka& operator <<(RPomDatoteka &tok, const T_DOUBLE  podatek) { return _Zapisi <T_DOUBLE>(tok, podatek); }
template <class TOK> inline TOK         & operator >>(TOK          &tok,       T_DOUBLE &podatek) { return _Preberi          (tok, podatek); }
                     inline RPomDatoteka& operator >>(RPomDatoteka &tok,       T_DOUBLE &podatek) { return _Preberi<T_DOUBLE>(tok, podatek); }
template <class TOK> inline TOK         & operator <<(TOK          &tok, const T_AZNAK   podatek) { return _Zapisi           (tok, podatek); }
                     inline RPomDatoteka& operator <<(RPomDatoteka &tok, const T_AZNAK   podatek) { return _Zapisi <T_AZNAK >(tok, podatek); }
template <class TOK> inline TOK         & operator >>(TOK          &tok,       T_AZNAK  &podatek) { return _Preberi          (tok, podatek); }
                     inline RPomDatoteka& operator >>(RPomDatoteka &tok,       T_AZNAK  &podatek) { return _Preberi<T_AZNAK >(tok, podatek); }
#ifdef _NATIVE_WCHAR_T_DEFINED
template <class TOK> inline TOK         & operator <<(TOK          &tok, const T_UZNAK   podatek) { return _Zapisi           (tok, podatek); }
                     inline RPomDatoteka& operator <<(RPomDatoteka &tok, const T_UZNAK   podatek) { return _Zapisi <T_UZNAK >(tok, podatek); }
template <class TOK> inline TOK         & operator >>(TOK          &tok,       T_UZNAK  &podatek) { return _Preberi          (tok, podatek); }
                     inline RPomDatoteka& operator >>(RPomDatoteka &tok,       T_UZNAK  &podatek) { return _Preberi<T_UZNAK >(tok, podatek); }
#endif
template <class TOK> inline TOK         & operator <<(TOK          &tok, TK_ASCII        podatek) { return  _ZapisiNiz(tok, podatek); }
                     inline RPomDatoteka& operator <<(RPomDatoteka &tok, TK_ASCII        podatek) { return  _ZapisiNiz(tok, podatek); }
template <class TOK> inline TOK         & operator >>(TOK          &tok, RNizP<T_AZNAK> &podatek) { return _PreberiNiz(tok, podatek); }
                     inline RPomDatoteka& operator >>(RPomDatoteka &tok, RNizP<T_AZNAK> &podatek) { return _PreberiNiz(tok, podatek); }
template <class TOK> inline TOK         & operator <<(TOK          &tok, TK_UNICODE      podatek) { return  _ZapisiNiz(tok, podatek); }
                     inline RPomDatoteka& operator <<(RPomDatoteka &tok, TK_UNICODE      podatek) { return  _ZapisiNiz(tok, podatek); }
template <class TOK> inline TOK         & operator >>(TOK          &tok, RNizP<T_UZNAK> &podatek) { return _PreberiNiz(tok, podatek); }
                     inline RPomDatoteka& operator >>(RPomDatoteka &tok, RNizP<T_UZNAK> &podatek) { return _PreberiNiz(tok, podatek); }


//////////////////////////////////////////////////////////////////////
// Operatorji za shranjevanje v VARIANT
//////////////////////////////////////////////////////////////////////

inline VARIANT& operator <<(VARIANT &p, const T_U1 dat)
{
    V_VT(&p) = VT_UI1;
    V_UI1(&p) = dat;
    return *(&p + 1);
}


inline VARIANT& operator <<(VARIANT &p, const T_U2 dat)
{
    V_VT(&p) = VT_UI2;
    V_UI2(&p) = dat;
    return *(&p + 1);
}


inline VARIANT& operator <<(VARIANT &p, const T_U4 dat)
{
    V_VT(&p) = VT_UI4;
    V_UI4(&p) = dat;
    return *(&p + 1);
}


inline VARIANT& operator <<(VARIANT &p, const T_U8 dat)
{
    V_VT(&p) = VT_UI8;
    V_UI8(&p) = dat;
    return *(&p + 1);
}


#ifndef _WIN64

inline VARIANT& operator <<(VARIANT &p, const T_UINT dat)
{
    return p << (const T_U4)dat;
}

#endif // _WIN64


inline VARIANT& operator <<(VARIANT &p, const T_BOOL dat)
{
    V_VT(&p) = VT_BOOL;
    V_BOOL(&p) = dat ? VARIANT_TRUE : VARIANT_FALSE;
    return *(&p + 1);
}


inline VARIANT& operator <<(VARIANT &p, TK_ASCII dat)
{
    T_UINT dolzina = astrlen(dat);

    V_VT(&p) = VT_BSTR;
    V_BSTR(&p) = ::SysAllocStringLen(NULL, (UINT)dolzina);
    astrncpy2(V_BSTR(&p), dolzina, dat, dolzina);
    V_BSTR(&p)[dolzina] = 0;
    return *(&p + 1);
}


inline VARIANT& operator <<(VARIANT &p, TK_UNICODE dat)
{
    V_VT(&p) = VT_BSTR;
    V_BSTR(&p) = ::SysAllocString(dat);
    return *(&p + 1);
}


//////////////////////////////////////////////////////////////////////
// T_INTERVAL
//////////////////////////////////////////////////////////////////////

template <class TIP> inline T_INTERVAL<TIP>::T_INTERVAL() :
    zacetek(1),
    konec(0)
{
}


template <class TIP> inline T_INTERVAL<TIP>::T_INTERVAL(TIP x) :
    zacetek(x),
    konec(x)
{
}


template <class TIP> inline T_INTERVAL<TIP>::T_INTERVAL(TIP _zacetek, TIP _konec) :
    zacetek(_zacetek),
    konec(_konec)
{
}


template <class TIP> inline TIP T_INTERVAL<TIP>::VrniDolzino() const
{
    return zacetek <= konec ? konec - zacetek : 0;
}


template <class TIP> inline T_BOOL T_INTERVAL<TIP>::JeVeljaven() const
{
    return zacetek <= konec ? TRUE : FALSE;
}


template <class TIP> inline const T_INTERVAL<TIP> T_INTERVAL<TIP>::operator =(TIP _zacetek)
{
    zacetek = konec = _zacetek;
    return *this;
};


template <class TIP> inline const T_INTERVAL<TIP> operator +(const T_INTERVAL<TIP> i1, const T_INTERVAL<TIP> i2)
{
    return T_INTERVAL<TIP>(i1.zacetek + i2.zacetek, i1.konec + i2.konec);
}


template <class TIP> inline const T_INTERVAL<TIP> operator +(const T_INTERVAL<TIP> i, TIP x)
{
    return T_INTERVAL<TIP>(i.zacetek + x, i.konec + x);
}


template <class TIP> inline T_INTERVAL<TIP>& operator ++(T_INTERVAL<TIP> &o) // Prefix increment operator.
{
    o.zacetek++;
    o.konec++;
    return o;
}


template <class TIP> inline const T_INTERVAL<TIP> operator ++(T_INTERVAL<TIP> &o, int) // Postfix increment operator.
{
    T_INTERVAL<TIP> pom = o;
    o.zacetek++;
    o.konec++;
    return pom;
}


template <class TIP> inline const T_INTERVAL<TIP> operator -(const T_INTERVAL<TIP> i1, const T_INTERVAL<TIP> i2)
{
    return T_INTERVAL<TIP>(i1.zacetek - i2.zacetek, i1.konec - i2.konec);
}


template <class TIP> inline const T_INTERVAL<TIP> operator -(const T_INTERVAL<TIP> i, T_UINT x)
{
    return T_INTERVAL<TIP>(i.zacetek - x, i.konec - x);
}


template <class TIP> inline T_INTERVAL<TIP>& operator --(T_INTERVAL<TIP> &o) // Prefix decrement operator.
{
    o.zacetek--;
    o.konec--;
    return o;
}


template <class TIP> inline const T_INTERVAL<TIP> operator --(T_INTERVAL<TIP> &o, int) // Postfix decrement operator.
{
    T_INTERVAL<TIP> pom = o;
    o.zacetek--;
    o.konec--;
    return pom;
}


template <class TIP> inline T_BOOL operator ==(const T_INTERVAL<TIP> i1, const T_INTERVAL<TIP> i2)
{
    return i1.zacetek == i2.zacetek && i1.konec == i2.konec;
}


template <class TIP> inline T_BOOL operator !=(const T_INTERVAL<TIP> i1, const T_INTERVAL<TIP> i2)
{
    return i1.zacetek != i2.zacetek || i1.konec != i2.konec;
}


//////////////////////////////////////////////////////////////////////
// T_VAR
//////////////////////////////////////////////////////////////////////

inline T_VOID T_VAR::Unici()
{
    switch (vrsta) {
    case VAR_ASCII:
        if (niz_a) afree(niz_a);
        break;
    case VAR_UNICODE:
        if (niz_u) afree(niz_u);
        break;
    case VAR_BINBLOK:
        if (blok.podatki) afree(blok.podatki);
        break;
    }
}


inline T_VOID T_VAR::Razveljavi()
{
    vrsta = VAR_NEVELJAVEN;
}


template <class TOK> inline TOK& operator <<(TOK &tok, const T_VAR &podatek)
{
    T_U4 dolzina;

    tok << (T_U1)podatek.vrsta;
    if (NEUSPESNO(tok.VrniStanje()))
        goto napaka;

    switch (podatek.vrsta) {
    case VAR_PRAZEN:
        break;
    case VAR_AZNAK:
        tok << podatek.znak_a;
        break;
    case VAR_UZNAK:
        tok << podatek.znak_u;
        break;
    case VAR_ASCII:
        tok << (dolzina = (T_U4)astrlen(podatek.niz_a));
        if (dolzina && USPESNO(tok.VrniStanje()))
            verify(tok.ZapisiTab(podatek.niz_a, sizeof(T_AZNAK), dolzina) == dolzina);
        break;
    case VAR_UNICODE:
        tok << (dolzina = (T_U4)astrlen(podatek.niz_u));
        if (dolzina && USPESNO(tok.VrniStanje()))
            verify(tok.ZapisiTab(podatek.niz_u, sizeof(T_UZNAK), dolzina) == dolzina);
        break;
    case VAR_BINBLOK:
        tok << (T_U4)podatek.blok.dolzina;
        if (podatek.blok.dolzina && USPESNO(tok.VrniStanje()))
            verify(tok.ZapisiTab(podatek.blok.podatki, 1, podatek.blok.dolzina) == podatek.blok.dolzina);
        break;
    case VAR_INT:
        tok << (T_4)podatek.st_int;
        break;
    case VAR_UINT:
        tok << (T_U4)podatek.st_uint;
        break;
    case VAR_FLOAT:
        tok << podatek.st_float;
        break;
    case VAR_DOUBLE:
        tok << podatek.st_double;
        break;
    default:
        assert(0);
    }

napaka:
    return tok;
}


template <class TOK> inline TOK& operator >>(TOK &tok, T_VAR &podatek)
{
    T_U1 vrsta;
    T_U4 dolzina, st_uint;
    T_4  st_int;

    tok >> vrsta;
    if (tok.JeKonec()) goto napaka;
    podatek.vrsta = (T_VRSTAVAR)vrsta;

    switch (podatek.vrsta) {
    case VAR_PRAZEN:
        break;
    case VAR_AZNAK:
        tok >> podatek.znak_a;
        if (tok.JeKonec()) goto napaka;
        break;
    case VAR_UZNAK:
        tok >> podatek.znak_u;
        if (tok.JeKonec()) goto napaka;
        break;
    case VAR_ASCII:
        tok >> dolzina;
        if (tok.JeKonec()) goto napaka;
        verify(podatek.niz_a = (T_ASCII)aalloc((dolzina+1)*sizeof(T_AZNAK)));
        if (dolzina) {
            verify(tok.PreberiTab(podatek.niz_a, sizeof(T_AZNAK), dolzina) == dolzina);
            if (tok.JeKonec()) {
                afree(podatek.niz_a);
                goto napaka;
            }
        }
        podatek.niz_a[dolzina] = 0;
        break;
    case VAR_UNICODE:
        tok >> dolzina;
        if (tok.JeKonec()) goto napaka;
        verify(podatek.niz_u = (T_UNICODE)aalloc((dolzina+1)*sizeof(T_UZNAK)));
        if (dolzina) {
            verify(tok.PreberiTab(podatek.niz_u, sizeof(T_UZNAK), dolzina) == dolzina);
            if (tok.JeKonec()) {
                afree(podatek.niz_u);
                goto napaka;
            }
        }
        podatek.niz_u[dolzina] = 0;
        break;
    case VAR_BINBLOK:
        tok >> dolzina;
        if (tok.JeKonec()) goto napaka;
        verify(podatek.blok.podatki = aalloc(podatek.blok.dolzina = dolzina));
        if (podatek.blok.dolzina) {
            verify(tok.PreberiTab(podatek.blok.podatki, 1, podatek.blok.dolzina) == podatek.blok.dolzina);
            if (tok.JeKonec()) {
                afree(podatek.blok.podatki);
                goto napaka;
            }
        }
        break;
    case VAR_INT:
        tok >> st_int;
        if (tok.JeKonec()) goto napaka;
        podatek.st_int = st_int;
        break;
    case VAR_UINT:
        tok >> st_uint;
        if (tok.JeKonec()) goto napaka;
        podatek.st_uint = st_uint;
        break;
    case VAR_FLOAT:
        tok >> podatek.st_float;
        if (tok.JeKonec()) goto napaka;
        break;
    case VAR_DOUBLE:
        tok >> podatek.st_double;
        if (tok.JeKonec()) goto napaka;
        break;
    default:
        assert(0);
    }

    return tok;

napaka:
    podatek.vrsta = VAR_NEVELJAVEN;
    return tok;
}


//////////////////////////////////////////////////////////////////////
// T_KOMPLP
//////////////////////////////////////////////////////////////////////

template <class TIP> inline T_KOMPLP<TIP>::T_KOMPLP()
{
#ifdef _DEBUG
    // e uporabljamo prazen konstruktor, inicializiramo r in i na NaN.
    TIP nic = 0;
    i = r = nic/nic;
#endif
}


template <class TIP> inline T_KOMPLP<TIP>::T_KOMPLP(const TIP _r, const TIP _i) :
    r(_r),
    i(_i)
{
}


template <class TIP> inline T_KOMPLP<TIP>::T_KOMPLP(const TIP _r) :
    r(_r),
    i(0)
{
}


template <class TIP> inline const T_KOMPLP<TIP> T_KOMPLP<TIP>::operator =(const T_KOMPLP<TIP> z)
{
    this->r = z.r;
    this->i = z.i;
    return *this;
}


template <class TIP> inline const T_KOMPLP<TIP> T_KOMPLP<TIP>::operator =(const TIP r)
{
    this->r = r;
    this->i = 0;
    return *this;
}


template <class TIP> inline const T_KOMPLP<TIP> T_KOMPLP<TIP>::operator +=(const T_KOMPLP<TIP> z)
{
    this->r += z.r;
    this->i += z.i;
    return *this;
}


template <class TIP> inline const T_KOMPLP<TIP> T_KOMPLP<TIP>::operator +=(const TIP r)
{
    this->r += r;
    return *this;
}


template <class TIP> inline const T_KOMPLP<TIP> T_KOMPLP<TIP>::operator -=(const T_KOMPLP<TIP> z)
{
    this->r -= z.r;
    this->i -= z.i;
    return *this;
}


template <class TIP> inline const T_KOMPLP<TIP> T_KOMPLP<TIP>::operator -=(const TIP r)
{
    this->r -= r;
    return *this;
}


template <class TIP> inline const T_KOMPLP<TIP> T_KOMPLP<TIP>::operator *=(const T_KOMPLP<TIP> z)
{
    register TIP
        r = this->r*z.r - this->i*z.i,
        i = this->r*z.i + this->i*z.r;

    this->r = r;
    this->i = i;
    return *this;
}


template <class TIP> inline const T_KOMPLP<TIP> T_KOMPLP<TIP>::operator *=(const TIP r)
{
    this->r *= r;
    this->i *= r;
    return *this;
}


template <class TIP> inline const T_KOMPLP<TIP> T_KOMPLP<TIP>::operator /=(const T_KOMPLP<TIP> z)
{
    register TIP
        r = this->r*z.r + this->i*z.i,
        i = this->i*z.r - this->r*z.i,
        c = z.r*z.r + z.i*z.i;

    this->r = r/c;
    this->i = i/c;
    return *this;
}


template <class TIP> inline const T_KOMPLP<TIP> T_KOMPLP<TIP>::operator /=(const TIP r)
{
    this->r /= r;
    this->i /= r;
    return *this;
}


template <class TIP> inline T_KOMPLP<TIP>::operator const T_KOMPLP<T_FLOAT>() const
{
    return T_KOMPLP<T_FLOAT>((T_FLOAT)this->r, (T_FLOAT)this->i);
}


template <class TIP> inline T_KOMPLP<TIP>::operator const T_KOMPLP<T_DOUBLE>() const
{
    return T_KOMPLP<T_DOUBLE>((T_DOUBLE)this->r, (T_DOUBLE)this->i);
}


template <class TIP> inline T_KOMPLP<TIP>::operator const T_KOMPLRP<TIP>() const
{
    return T_KOMPLRP<TIP>(aabs(*this), aarg(*this));
}


template <class TIP> inline const T_KOMPLP<TIP> operator +(const T_KOMPLP<TIP> z)
{
    return z;
}


template <class TIP> inline const T_KOMPLP<TIP> operator +(const T_KOMPLP<TIP> z1, const T_KOMPLP<TIP> z2)
{
    return T_KOMPLP<TIP>(z1.r+z2.r, z1.i+z2.i);
}


template <class TIP> inline const T_KOMPLP<TIP> operator +(const T_KOMPLP<TIP> z, const TIP r)
{
    return T_KOMPLP<TIP>(z.r+r, z.i);
}


template <class TIP> inline const T_KOMPLP<TIP> operator +(const TIP r, const T_KOMPLP<TIP> z)
{
    return T_KOMPLP<TIP>(r+z.r, z.i);
}


template <class TIP> inline const T_KOMPLP<TIP> operator -(const T_KOMPLP<TIP> z)
{
    return T_KOMPLP<TIP>(-z.r, -z.i);
}


template <class TIP> inline const T_KOMPLP<TIP> operator -(const T_KOMPLP<TIP> z1, const T_KOMPLP<TIP> z2)
{
    return T_KOMPLP<TIP>(z1.r-z2.r, z1.i-z2.i);
}


template <class TIP> inline const T_KOMPLP<TIP> operator -(const T_KOMPLP<TIP> z, const TIP r)
{
    return T_KOMPLP<TIP>(z.r-r, z.i);
}


template <class TIP> inline const T_KOMPLP<TIP> operator -(const TIP r, const T_KOMPLP<TIP> z)
{
    return T_KOMPLP<TIP>(r-z.r, -z.i);
}


template <class TIP> inline const T_KOMPLP<TIP> operator *(const T_KOMPLP<TIP> z1, const T_KOMPLP<TIP> z2)
{
    return T_KOMPLP<TIP>(
        z1.r*z2.r - z1.i*z2.i,
        z1.r*z2.i + z1.i*z2.r);
}


template <class TIP> inline const T_KOMPLP<TIP> operator *(const T_KOMPLP<TIP> z, const TIP r)
{
    return T_KOMPLP<TIP>(z.r*r, z.i*r);
}


template <class TIP> inline const T_KOMPLP<TIP> operator *(const TIP r, const T_KOMPLP<TIP> z)
{
    return T_KOMPLP<TIP>(r*z.r, r*z.i);
}


template <class TIP> inline const T_KOMPLP<TIP> operator /(const T_KOMPLP<TIP> z1, const T_KOMPLP<TIP> z2)
{
    register TIP c = z2.r*z2.r + z2.i*z2.i;

    return T_KOMPLP<TIP>(
        (z1.r*z2.r + z1.i*z2.i)/c,
        (z1.i*z2.r - z1.r*z2.i)/c);
}


template <class TIP> inline const T_KOMPLP<TIP> operator /(const T_KOMPLP<TIP> z, const TIP r)
{
    return T_KOMPLP<TIP>(z.r/r, z.i/r);
}


template <class TIP> inline const T_KOMPLP<TIP> operator /(const TIP r, const T_KOMPLP<TIP> z)
{
    register TIP c = r/(z.r*z.r + z.i*z.i);
    return T_KOMPLP<TIP>(
        z.r*c,
        -z.i*c);
}


template <class TIP> inline const T_KOMPLP<TIP> operator ~(const T_KOMPLP<TIP> z)
{
    return T_KOMPLP<TIP>(z.r, -z.i);
}


//////////////////////////////////////////////////////////////////////
// T_KOMPLRP
//////////////////////////////////////////////////////////////////////

template <class TIP> inline T_KOMPLRP<TIP>::T_KOMPLRP()
{
#ifdef _DEBUG
    // e uporabljamo prazen konstruktor, inicializiramo a in f na NaN.
    TIP nic = 0;
    f = a = nic/nic;
#endif
}


template <class TIP> inline T_KOMPLRP<TIP>::T_KOMPLRP(const TIP _a, const TIP _f) :
    a(_a),
    f(_f)
{
}


template <class TIP> inline T_KOMPLRP<TIP>::T_KOMPLRP(const TIP _a) :
    a(_a),
    f(0)
{
}


template <class TIP> inline const T_KOMPLRP<TIP> T_KOMPLRP<TIP>::operator =(const T_KOMPLRP<TIP> z)
{
    this->a = z.a;
    this->f = z.f;
    return *this;
}


template <class TIP> inline const T_KOMPLRP<TIP> T_KOMPLRP<TIP>::operator =(const TIP a)
{
    this->a = a;
    this->f = 0;
    return *this;
}


template <class TIP> inline const T_KOMPLRP<TIP> T_KOMPLRP<TIP>::operator *=(const T_KOMPLRP<TIP> z)
{
    this->a *= z.a;
    this->f += z.f;
    return *this;
}


template <class TIP> inline const T_KOMPLRP<TIP> T_KOMPLRP<TIP>::operator *=(const TIP a)
{
    this->a *= a;
    return *this;
}


template <class TIP> inline const T_KOMPLRP<TIP> T_KOMPLRP<TIP>::operator /=(const T_KOMPLRP<TIP> z)
{
    this->a /= z.a;
    this->f -= z.f;
    return *this;
}


template <class TIP> inline const T_KOMPLRP<TIP> T_KOMPLRP<TIP>::operator /=(const TIP a)
{
    this->a /= a;
    return *this;
}


template <class TIP> inline T_KOMPLRP<TIP>::operator const T_KOMPLRP<T_FLOAT>() const
{
    return T_KOMPLRP<T_FLOAT>((T_FLOAT)this->a, (T_FLOAT)this->f);
}


template <class TIP> inline T_KOMPLRP<TIP>::operator const T_KOMPLRP<T_DOUBLE>() const
{
    return T_KOMPLRP<T_DOUBLE>((T_DOUBLE)this->a, (T_DOUBLE)this->f);
}


template <class TIP> inline T_KOMPLRP<TIP>::operator const T_KOMPLP<TIP>() const
{
    return T_KOMPLP<TIP>(this->a * (TIP)cos(this->f), this->a * (TIP)sin(this->f));
}


template <class TIP> inline const T_KOMPLRP<TIP> operator *(const T_KOMPLRP<TIP> z1, const T_KOMPLRP<TIP> z2)
{
    return T_KOMPLRP<TIP>(z1.a * z2.a, z1.f + z2.f);
}


template <class TIP> inline const T_KOMPLRP<TIP> operator *(const T_KOMPLRP<TIP> z, const TIP a)
{
    return T_KOMPLRP<TIP>(z.a * a, z.f);
}


template <class TIP> inline const T_KOMPLRP<TIP> operator *(const TIP a, const T_KOMPLRP<TIP> z)
{
    return T_KOMPLRP<TIP>(a * z.a, z.f);
}


template <class TIP> inline const T_KOMPLRP<TIP> operator /(const T_KOMPLRP<TIP> z1, const T_KOMPLRP<TIP> z2)
{
    return T_KOMPLRP<TIP>(z1.a / z2.a, z1.f - z2.f);
}


template <class TIP> inline const T_KOMPLRP<TIP> operator /(const T_KOMPLRP<TIP> z, const TIP a)
{
    return T_KOMPLRP<TIP>(z.a / a, z.f);
}


template <class TIP> inline const T_KOMPLRP<TIP> operator /(const TIP a, const T_KOMPLRP<TIP> z)
{
    return T_KOMPLRP<TIP>(a / z.a, -z.f);
}


template <class TIP> inline const T_KOMPLRP<TIP> operator ~(const T_KOMPLRP<TIP> z)
{
    return T_KOMPLRP<TIP>(z.a, -z.f);
}


//////////////////////////////////////////////////////////////////////
// RSisElement
//////////////////////////////////////////////////////////////////////

inline T_BOOL RSisElement::JeVeljaven() const
{
    return JE_VELJAVNA_ROCICA(rocica);
}


inline T_ROCICAOS RSisElement::VrniRocico() const
{
    return rocica;
}


inline RSisElement::operator T_ROCICAOS() const
{
    return rocica;
}


inline T_STANJE RSisElement::Zapri(T_ROCICAOS rocica)
{
    assert(JE_VELJAVNA_ROCICA(rocica));

    if (::CloseHandle(rocica))
        return A_OK;
    else {
        DWORD rezultat = ::GetLastError();
        if (rezultat == ERROR_INVALID_HANDLE) {
            // Element s to roico v bistvu ne obstaja (ve), oz. je e zaprt. Pravzaprav je stanje, ki smo ga s klicem te funkcije eleli dosei, e doseeno.
            return AOSN_OPOZORILO_ZE_ZAPRTA;
        } else
            return astanje(rezultat, AOSN_NAPAKA_ZAPIRANJE);
    }
}


inline T_STANJE RSisElement::Podvoji(T_ROCICAOS rocica, T_BOOL deduj, T_ROCICAOS *nova_rocica)
{
    assert(nova_rocica);

    T_ROCICAOS proces = ::GetCurrentProcess();

    if (::DuplicateHandle(proces, rocica, proces, nova_rocica, 0, deduj, DUPLICATE_SAME_ACCESS))
        return A_OK;
    else {
        *nova_rocica = NEVELJAVNA_ROCICA;
        return astanje(::GetLastError(), AOSN_NAPAKA_PODVAJANJE_ROCICE);
    }
}


#ifdef AOSN_KAZNAP

//////////////////////////////////////////////////////////////////////
// RGlobalniKazalnikNapredka
//////////////////////////////////////////////////////////////////////

inline T_VOID RGlobalniKazalnikNapredka::Uporabi(RKazalnikNapredka *kazalnik)
{
    this->kazalnik = kazalnik;
}


inline RKazalnikNapredka* RGlobalniKazalnikNapredka::Odpusti()
{
    RKazalnikNapredka *k = kazalnik;
    kazalnik = NULL;
    return k;
}


inline T_VOID RGlobalniKazalnikNapredka::NastaviGlobalnoObmocje(T_INT zacetek, T_INT konec)
{
    glob.zacetek = zacetek;
    glob.konec   = konec;
    if (kazalnik)
        kazalnik->NastaviObmocje(glob.zacetek, glob.konec);
}


inline T_VOID RGlobalniKazalnikNapredka::NastaviGlobalniOdsek(T_INT zacetek, T_INT konec)
{
    odsek.zacetek = zacetek;
    odsek.konec   = konec;
}

#endif // AOSN_KAZNAP


//////////////////////////////////////////////////////////////////////
// RKazalec
//////////////////////////////////////////////////////////////////////

template <class TIP> RKazalec<TIP>::RKazalec(T_BOOL ustvari) :
    RElement(),
    p(NULL)
{
    if (ustvari)
        verify(USPESNO(Ustvari()));
}


template <class TIP> RKazalec<TIP>::~RKazalec()
{
    if (p)
        Unici();
}


template <class TIP> T_STANJE RKazalec<TIP>::Ustvari()
{
    assert(!p);

    p = (T_VOZEL<TIP>*)aalloc(sizeof(T_VOZEL<TIP>));
    if (p) {
        p->T_VOZEL<TIP>::T_VOZEL();
        return A_OK;
    } else {
        return AOSN_NAPAKA_POMNILNIK;
    }
}


template <class TIP> T_STANJE RKazalec<TIP>::Unici()
{
    if (p) {
        p->T_VOZEL<TIP>::~T_VOZEL();
        afree(p);
        p = NULL;
        return A_OK;
    } else
        return AOSN_OPOZORILO_ZE_SPROSCEN;
}


template <class TIP> inline TIP* RKazalec<TIP>::Vrni() const
{
    return &(p->element);
}


template <class TIP> inline T_VOID RKazalec<TIP>::Uporabi(TIP* p)
{
    assert(!this->p);

    this->p = (T_VOZEL<TIP>*)p;
}


template <class TIP> inline TIP* RKazalec<TIP>::Odpusti()
{
    TIP *p = &(this->p->element);
    this->p = NULL;
    return p;
}


template <class TIP> inline RKazalec<TIP>::operator TIP*() const
{
    return &(p->element);
}


template <class TIP> inline TIP& RKazalec<TIP>::operator*() const
{
    return p->element;
}

template <class TIP> inline TIP* RKazalec<TIP>::operator->() const
{
    return &(p->element);
}


template <class TIP> inline T_BOOL RKazalec<TIP>::operator!() const
{
    return !&(p->element);
}


template <class TIP> inline T_BOOL RKazalec<TIP>::operator<(TIP* p) const
{
    return &(this->p->element) < &(p->element);
}


template <class TIP> inline T_BOOL RKazalec<TIP>::operator<=(TIP* p) const
{
    return &(this->p->element) <= &(p->element);
}


template <class TIP> inline T_BOOL RKazalec<TIP>::operator==(TIP* p) const
{
    return &(this->p->element) == &(p->element);
}


template <class TIP> inline T_BOOL RKazalec<TIP>::operator>=(TIP* p) const
{
    return &(this->p->element) >= &(p->element);
}


template <class TIP> inline T_BOOL RKazalec<TIP>::operator>(TIP* p) const
{
    return &(this->p->element) > &(p->element);
}


//////////////////////////////////////////////////////////////////////
// RTabela
//////////////////////////////////////////////////////////////////////

template <class TIP> RTabela<TIP>::RTabela() :
    RElement(),
    podatki(NULL),
    st_elementov(0)
{
}


template <class TIP> RTabela<TIP>::RTabela(T_UINT stevilo) :
    RElement(),
    podatki(NULL)
{
    Ustvari(stevilo);
}


template <class TIP> RTabela<TIP>::~RTabela()
{
    if (podatki)
        Unici();
}


template <class TIP> T_STANJE RTabela<TIP>::Ustvari(T_UINT stevilo)
{
    assert(!podatki);

    if (stevilo) {
        podatki = new TIP[stevilo];
        if (podatki) {
            st_elementov = stevilo;
            return A_OK;
        } else
            return AOSN_NAPAKA_POMNILNIK;
    } else {
        podatki = NULL;
        st_elementov = 0;
        return A_OK;
    }
}


template <class TIP> T_STANJE RTabela<TIP>::Unici()
{
    st_elementov = 0;

    if (podatki) {
        delete [] podatki;
        podatki = NULL;
        return A_OK;
    } else
        return AOSN_OPOZORILO_ZE_SPROSCEN;
}


template <class TIP> inline T_BOOL RTabela<TIP>::JeUstvarjena() const
{
    return podatki ? TRUE : FALSE;
}


template <class TIP> inline T_UINT RTabela<TIP>::VrniStevilo() const
{
    return st_elementov;
}


template <class TIP> inline TIP* RTabela<TIP>::Vrni() const
{
    return podatki;
}


template <class TIP> inline T_VOID RTabela<TIP>::Uporabi(TIP* tabela, T_UINT stevilo, T_BOOL unici)
{
    assert(!podatki);
    assert(tabela || !stevilo);

    if (unici && podatki)
        Unici();

    podatki = tabela;
    st_elementov = stevilo;
}


template <class TIP> inline TIP* RTabela<TIP>::Odpusti(T_BOOL ustvari)
{
    TIP *t = podatki;

    if (ustvari)
        this->RTabela<TIP>::RTabela();

    return t;
}


template <class TIP> inline TIP& RTabela<TIP>::operator [](T_UINT indeks) const
{
    assert(podatki);
    assert(indeks < st_elementov);

    return podatki[indeks];
}


template <class TIP> inline TIP& RTabela<TIP>::operator [](int indeks) const
{
    assert(podatki);
    assert((T_UINT)indeks < st_elementov);

    return podatki[indeks];
}


template <class TIP> inline RTabela<TIP>::operator TIP*() const
{
    return podatki;
}


template <class TOK, class TIP> inline TOK& operator <<(TOK &tok, const RTabela<TIP> &tabela)
{
    T_UINT i, stevilo = tabela.VrniStevilo();

    assert(stevilo <= T_U4_MAX);

    // Najprej zapiemo tevilo elementov v tabeli.
    if (NEUSPESNO(tok.VrniStanje())) return tok;
    tok << (T_U4)stevilo;

    // Sedaj zapiemo vse elemente.
    for (i = 0; i < stevilo; i++) {
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << tabela[i];
    }

    return tok;
}


template <class TOK, class TIP> inline TOK& operator >>(TOK &tok, RTabela<TIP> &tabela)
{
    T_UINT i;
    T_U4 stevilo;

    // Najprej preberemo tevilo elementov na toku.
    tok >> stevilo;
    if (tok.JeKonec()) return tok;

    // Sedaj preberemo vse elemente iz toka podatkov.
    verify(USPESNO(tabela.Ustvari(stevilo)));
    for (i = 0; i < stevilo; i++) {
        tok >> tabela[i];
        if (tok.JeKonec()) break;
    }
    // TODO: e smo prebrali manj elementov, kot pa smo jih ustvarili v tabeli, moramo odvene sprostiti.
    assert(i == stevilo);

    return tok;
}


//////////////////////////////////////////////////////////////////////
// RDinTabela
//////////////////////////////////////////////////////////////////////

template <class TIP> RDinTabela<TIP>::RDinTabela() :
    RElement(),
    st_elementov(0),
    max_elementov(0),
    podatki(NULL)
{
}


template <class TIP> RDinTabela<TIP>::RDinTabela(T_UINT koliko) :
    RElement(),
    st_elementov(0),
    max_elementov(0),
    podatki(NULL)
{
    verify(USPESNO(RezervirajDolzino(koliko, RDINTABELA_TESNA_REZERVACIJA)));
}


template <class TIP> RDinTabela<TIP>::RDinTabela(const TIP &element, T_UINT koliko) :
    RElement(),
    st_elementov(0),
    max_elementov(0),
    podatki(NULL)
{
    Nastavi(element, koliko);
}


template <class TIP> RDinTabela<TIP>::RDinTabela(const TIP *niz, T_UINT koliko) :
    RElement(),
    st_elementov(0),
    max_elementov(0),
    podatki(NULL)
{
    Nastavi(niz, koliko);
}


template <class TIP> RDinTabela<TIP>::RDinTabela(const RDinTabela<TIP> &niz, T_UINT koliko) :
    RElement(),
    st_elementov(0),
    max_elementov(0),
    podatki(NULL)
{
    Nastavi(niz, koliko);
}


template <class TIP> RDinTabela<TIP>::~RDinTabela()
{
    if (podatki) {
        T_UINT i;

        // Kliemo destruktorje vseh elementov.
        for (i = 0; i < max_elementov; i++)
            ((T_VOZEL<TIP>*)(podatki + i))->T_VOZEL<TIP>::~T_VOZEL();

        afree(podatki);
    }
}


template <class TIP> inline T_UINT RDinTabela<TIP>::VrniStevilo() const
{
    return st_elementov;
}


template <class TIP> inline T_BOOL RDinTabela<TIP>::JePrazna() const
{
    return st_elementov == 0;
}


template <class TIP> inline T_VOID RDinTabela<TIP>::NastaviStevilo(T_UINT koliko)
{
    st_elementov = koliko;
    if (st_elementov > max_elementov) verify(USPESNO(RezervirajDolzino(st_elementov)));
}


template <class TIP> inline T_VOID RDinTabela<TIP>::Sprazni()
{
    st_elementov = 0;
}


template <class TIP> inline const TIP* RDinTabela<TIP>::Vrni() const
{
    return podatki;
}


template <class TIP> inline T_UINT RDinTabela<TIP>::Nastavi(const TIP &element, T_UINT koliko)
{
    T_UINT i;

    st_elementov = koliko;
    if (st_elementov > max_elementov) verify(USPESNO(RezervirajDolzino(st_elementov, RDINTABELA_TESNA_REZERVACIJA)));

    for (i = 0; i < st_elementov; i++)
        podatki[i] = element;

    return st_elementov;
}


template <class TIP> inline T_UINT RDinTabela<TIP>::Nastavi(const TIP *niz, T_UINT koliko)
{
    T_UINT i;

    st_elementov = koliko;
    if (st_elementov > max_elementov) verify(USPESNO(RezervirajDolzino(st_elementov, RDINTABELA_TESNA_REZERVACIJA)));

    for (i = 0; i < st_elementov; i++)
        podatki[i] = niz[i];

    return st_elementov;
}


template <class TIP> inline T_UINT RDinTabela<TIP>::Nastavi(const RDinTabela<TIP> &niz, T_UINT koliko)
{
    T_UINT i;

    st_elementov = amin(niz.st_elementov, koliko);
    if (st_elementov > max_elementov) verify(USPESNO(RezervirajDolzino(st_elementov, RDINTABELA_TESNA_REZERVACIJA)));

    for (i = 0; i < st_elementov; i++)
        podatki[i] = niz.podatki[i];

    return st_elementov;
}


template <class TIP> inline T_UINT RDinTabela<TIP>::Prilepi(const TIP &element, T_UINT koliko)
{
    T_UINT i = st_elementov;

    st_elementov += koliko;
    if (st_elementov > max_elementov) verify(USPESNO(RezervirajDolzino(st_elementov)));

    for (; i < st_elementov; i++)
        podatki[i] = element;

    return st_elementov;
}


template <class TIP> inline T_UINT RDinTabela<TIP>::Prilepi(const TIP *niz, T_UINT koliko)
{
    T_UINT i = st_elementov, j;

    st_elementov += koliko;
    if (st_elementov > max_elementov) verify(USPESNO(RezervirajDolzino(st_elementov)));

    for (j = 0; j < koliko; i++, j++)
        podatki[i] = niz[j];

    return st_elementov;
}


template <class TIP> inline T_UINT RDinTabela<TIP>::Prilepi(const RDinTabela<TIP> &niz, T_UINT koliko)
{
    T_UINT i = st_elementov, j;

    st_elementov += koliko = amin(niz.st_elementov, koliko);
    if (st_elementov > max_elementov) verify(USPESNO(RezervirajDolzino(st_elementov)));

    for (j = 0; j < koliko; i++, j++)
        podatki[i] = niz.podatki[j];

    return st_elementov;
}


template <class TIP> inline T_VOID RDinTabela<TIP>::Uporabi(TIP *tabela, T_UINT stevilo, T_BOOL unici)
{
    assert(tabela || !stevilo);

    // Sprostimo tabelo, ki je trenutno v uporabi
    if (unici && podatki) {
        T_UINT i;

        // Kliemo destruktorje vseh elementov.
        for (i = 0; i < max_elementov; i++)
            ((T_VOZEL<TIP>*)(podatki + i))->T_VOZEL<TIP>::~T_VOZEL();

        afree(podatki);
    }

    podatki       = tabela;
    st_elementov  = stevilo;
    max_elementov = podatki ? amsize(podatki) / sizeof(TIP) : 0;
}


template <class TIP> inline TIP* RDinTabela<TIP>::Odpusti(T_UINT min_dolzina, T_BOOL ustvari)
{
    T_UINT i;
    TIP *_podatki;

    if (min_dolzina != T_UINT_MAX && min_dolzina > max_elementov) verify(USPESNO(RezervirajDolzino(min_dolzina, RDINTABELA_TESNA_REZERVACIJA)));

    // Kliemo destruktorje za vse elemente, ki presegajo konec, saj uporabnik, ki je klical Odpusti() tako ne bo vedel zanje.
    for (i = min_dolzina; i < max_elementov; i++)
        ((T_VOZEL<TIP>*)(podatki + i))->T_VOZEL<TIP>::~T_VOZEL();

    // Zapomnimo si tabelo
    _podatki = podatki;

    // Pripravimo razred za nove podatke
    if (ustvari)
        this->RDinTabela<TIP>::RDinTabela();

    return _podatki;
}


template <class TIP> inline T_VOID RDinTabela<TIP>::SprostiOdvecne()
{
    RezervirajDolzino(st_elementov, TRUE);
}


template <class TIP> inline TIP& RDinTabela<TIP>::operator [](T_UINT indeks) const
{
    assert(podatki);
    assert(indeks < st_elementov);

    return podatki[indeks];
}


template <class TIP> inline TIP& RDinTabela<TIP>::operator [](int indeks) const
{
    assert(podatki);
    assert((T_UINT)indeks < st_elementov);

    return podatki[indeks];
}


template <class TIP> inline RDinTabela<TIP>::operator const TIP*() const
{
    return podatki;
}


template <class TIP> inline const TIP* RDinTabela<TIP>::operator =(const TIP &element)
{
    Nastavi(element);
    return podatki;
}


template <class TIP> inline const TIP* RDinTabela<TIP>::operator =(const RDinTabela<TIP> &niz)
{
    Nastavi(niz);
    return podatki;
}


template <class TIP> inline const TIP* RDinTabela<TIP>::operator +=(const TIP &element)
{
    Prilepi(element);
    return podatki;
}


template <class TIP> inline const TIP* RDinTabela<TIP>::operator +=(const RDinTabela<TIP> &niz)
{
    Prilepi(niz);
    return podatki;
}


template <class TIP> T_STANJE RDinTabela<TIP>::RezervirajDolzino(T_UINT zeljeno, T_BOOL tesno)
{
    if (tesno || zeljeno >= max_elementov) {
        // Realociramo le, kadar to izrecno elimo (tesno), ali pa je protrebno podaljati dolino.
        T_UINT i, max_elementov2;
        max_elementov2 = tesno ? zeljeno : ((zeljeno + RDINTABELA_KORAK_POVECEVANJA) / RDINTABELA_KORAK_POVECEVANJA) * RDINTABELA_KORAK_POVECEVANJA;
        assert(max_elementov2 >= zeljeno);

        // Kliemo destruktorje za vse elemente, ki jih bomo uniili.
        for (i = max_elementov2; i < max_elementov; i++)
            ((T_VOZEL<TIP>*)(podatki + i))->T_VOZEL<TIP>::~T_VOZEL();

        podatki = (TIP*)arealloc(podatki, max_elementov2 * sizeof(TIP));
        assert(podatki || !max_elementov2);

        // Kliemo konstruktorje za vse elemente, ki smo jih ustvarili.
        for (i = max_elementov; i < max_elementov2; i++)
            ((T_VOZEL<TIP>*)(podatki + i))->T_VOZEL<TIP>::T_VOZEL();

        max_elementov = max_elementov2;
    }

    // e smo preve skrajali, popravimo tudi virtualno dolino.
    if (max_elementov < st_elementov)
        st_elementov = max_elementov;

    return A_OK;
}


template <class TOK, class TIP> inline TOK& operator <<(TOK &tok, const RDinTabela<TIP> &tabela)
{
    T_UINT i, stevilo = tabela.VrniStevilo();

    assert(stevilo <= T_U4_MAX);

    // Najprej zapiemo tevilo elementov v tabeli.
    if (NEUSPESNO(tok.VrniStanje())) return tok;
    tok << (T_U4)stevilo;

    // Sedaj zapiemo vse elemente.
    for (i = 0; i < stevilo; i++) {
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << tabela[i];
    }

    return tok;
}


template <class TOK, class TIP> inline TOK& operator >>(TOK &tok, RDinTabela<TIP> &tabela)
{
    T_UINT i, stevilo_prej;
    T_U4 stevilo;
    TIP *p;

    // Najprej preberemo tevilo elementov na toku.
    tok >> stevilo;
    if (tok.JeKonec()) return tok;

    stevilo_prej = tabela.VrniStevilo();

    // Sedaj preberemo vse elemente iz toka podatkov.
    p = tabela.Odpusti(stevilo_prej + stevilo, FALSE);
    for (i = 0; i < stevilo; i++) {
        tok >> p[stevilo_prej + i];
        if (tok.JeKonec()) break;
    }
    tabela.Uporabi(p, stevilo_prej + i, FALSE);

    return tok;
}


//////////////////////////////////////////////////////////////////////
// RZbirka
//////////////////////////////////////////////////////////////////////

template <class TIP> RZbirka<TIP>::RZbirka(T_UINT k_p) :
     RElement()
    ,st_elementov(0)
#ifndef RSEZNAM_STDALLOC_VER
    ,prosti(NULL)
    ,korak_povecevanja(k_p)
#ifdef _DEBUG
    ,st_zasedenih(0)
#endif
#endif
{
#ifndef RSEZNAM_STDALLOC_VER
    // Korak poveevanja ne sme biti 0!
    assert(korak_povecevanja);

    // Ustvarimo kopico (z malo rezerve predpostavimo, da gre za najpotratneji moni primer => dvosmerno povezan seznam).
    kopica = ::HeapCreate(RSEZNAM_ZASTAVICE_KOPICE, korak_povecevanja * sizeof(T_VOZELDVO<TIP>), 0);
    assert(kopica);

    /*
    // Nastavimo kopico na nain dela Low Fragmentation Heap.
    // Zaenkrat deluje le na Windows XP in Windows 2003!!!
    ULONG lfh = 2;
    verify(::HeapSetInformation(kopica, HeapCompatibilityInformation, &lfh, sizeof(ULONG)));
    */
#endif
}


template <class TIP> RZbirka<TIP>::~RZbirka()
{
    assert(!st_elementov);
#ifndef RSEZNAM_STDALLOC_VER
#ifdef _DEBUG
    assert(!st_zasedenih);
#endif
    verify(::HeapDestroy(kopica));
#endif
}


template <class TIP> inline T_ROCICA RZbirka<TIP>::Dodaj()
{
    return DodajVozel(UstvariVozel());
}


template <class TIP> inline T_ROCICA RZbirka<TIP>::Dodaj(const TIP &element)
{
    return DodajVozel(UstvariVozel(element));
}


template <class TIP> inline TIP& RZbirka<TIP>::VrniElement(T_ROCICA rocica) const
{
    assert(rocica);
    return ((T_VOZEL<TIP>*)rocica)->element;
}


template <class TIP> inline T_UINT RZbirka<TIP>::VrniStevilo() const
{
    return st_elementov;
}


template <class TIP> inline T_BOOL RZbirka<TIP>::JePrazen() const
{
    return st_elementov == 0;
}


template <class TIP> inline TIP& RZbirka<TIP>::operator [](T_ROCICA rocica) const
{
    assert(rocica);

    return ((T_VOZEL<TIP>*)rocica)->element;
}


template <class TIP> inline T_ROCICA RZbirka<TIP>::operator +=(const TIP &element)
{
    return DodajVozel(UstvariVozel(element));
}


template <class TOK, class TIP> inline TOK& operator >>(TOK &tok, RZbirka<TIP> &zbirka)
{
    T_ROCICA rocica;
    T_U4 i, stevilo;

    // Najprej preberemo tevilo elementov na toku.
    tok >> stevilo;
    if (tok.JeKonec()) return tok;

    // Sedaj preberemo vse elemente iz toka podatkov.
    for (i = 0; i < stevilo; i++) {
        rocica = zbirka.UstvariVozel();
        assert(rocica);
        tok >> zbirka[rocica];
        if (tok.JeKonec()) {
            zbirka.UniciVozel(rocica);
            return tok;
        }
        zbirka.DodajVozel(rocica);
    }

    return tok;
}


//////////////////////////////////////////////////////////////////////
// RSklad
//////////////////////////////////////////////////////////////////////

template <class TIP> RSklad<TIP>::RSklad(T_UINT korak_povecevanja) :
    RZbirka<TIP>(korak_povecevanja),
    prvi(NULL)
{
}


template <class TIP> RSklad<TIP>::RSklad(const RSklad<TIP> &sklad) :
    RZbirka<TIP>(RSEZNAM_KORAK_POVECEVANJA),
    prvi(NULL)
{
    assert(0); // TODO: Preizkusi ta del kode.

    T_ROCICA rocica;

    // Prepiemo sklad.
    for (rocica = sklad.VrniPrvega(); rocica; rocica = sklad.VrniNaslednjega(rocica))
        Dodaj(sklad[rocica]);
}


template <class TIP> RSklad<TIP>::~RSklad()
{
    if (st_elementov)
        Unici();
    assert(!prvi);
}


template <class TIP> inline T_ROCICA RSklad<TIP>::DodajZa(T_ROCICA ref)
{
    return DodajVozelZa(UstvariVozel(), ref);
}


template <class TIP> inline T_ROCICA RSklad<TIP>::DodajZa(const TIP &element, T_ROCICA ref)
{
    return DodajVozelZa(UstvariVozel(element), ref);
}


template <class TIP> T_ROCICA RSklad<TIP>::DodajVozel(T_ROCICA rocica)
{
    assert(rocica);
#ifndef RSEZNAM_STDALLOC_VER
    assert(JeVozelVKopici(rocica)); // Preverimo, ali je vozlie res iz kopice tega seznama.
#endif

    T_VOZELENO<TIP> *vozel = (T_VOZELENO<TIP>*)rocica;

    // Dodamo vozlie na zaetek sklada.
    vozel->naslednji = prvi;
    prvi = vozel;
    st_elementov++;

    return vozel;
}


template <class TIP> T_ROCICA RSklad<TIP>::DodajVozelZa(T_ROCICA rocica, T_ROCICA ref)
{
    assert(rocica);
#ifndef RSEZNAM_STDALLOC_VER
    assert(JeVozelVKopici(rocica)); // Preverimo, ali je vozlie res iz kopice tega seznama.
#endif

    T_VOZELENO<TIP> *vozel = (T_VOZELENO<TIP>*)rocica;

    if (ref) {
        T_VOZELENO<TIP> *el = (T_VOZELENO<TIP>*)ref;

        // Dodamo vozlie vozel za vozlie el.
        vozel->naslednji = el->naslednji;
        el->naslednji = vozel;
    } else {
        // ref == NULL => dodajamo na zaetek sklada.

        assert(0); // TODO: Preizkusi ta del kode.
        vozel->naslednji = prvi;
        prvi = vozel;
    }
    st_elementov++;

    return vozel;
}


template <class TIP> T_VOID RSklad<TIP>::Brisi()
{
    assert(prvi);
    T_VOZELENO<TIP> *vozel = (T_VOZELENO<TIP>*)prvi;

    // Prestavimo zaetek sklada.
    prvi = ((T_VOZELENO<TIP>*)prvi)->naslednji;

    // Sprostimo vozlie.
    UniciVozel(vozel);
    st_elementov--;
}


template <class TIP> T_VOID RSklad<TIP>::Unici()
{
    T_VOZELENO<TIP> *vozel;

    while (prvi) {
        vozel = (T_VOZELENO<TIP>*)prvi;
        prvi = ((T_VOZELENO<TIP>*)prvi)->naslednji;

        UniciVozel(vozel);
        st_elementov--;
    }

    assert(!st_elementov);
}


template <class TIP> T_ROCICA RSklad<TIP>::UstvariVozel()
{
    T_VOZELENO<TIP> *vozel;
#ifdef RSEZNAM_STDALLOC_VER
    vozel = new T_VOZELENO<TIP>;
    assert(vozel);
#else
    vozel = (T_VOZELENO<TIP>*)RezervirajVozel();
    assert(vozel);
    vozel->T_VOZELENO<TIP>::T_VOZELENO();
#endif
    return vozel;
}


template <class TIP> T_ROCICA RSklad<TIP>::UstvariVozel(const TIP &element)
{
    T_VOZELENO<TIP> *vozel;
#ifdef RSEZNAM_STDALLOC_VER
    vozel = new T_VOZELENO<TIP>(element);
    assert(vozel);
#else
    vozel = (T_VOZELENO<TIP>*)RezervirajVozel();
    assert(vozel);
    vozel->T_VOZELENO<TIP>::T_VOZELENO(element);
#endif
    return vozel;
}


template <class TIP> T_VOID RSklad<TIP>::UniciVozel(T_ROCICA rocica)
{
    assert(rocica);
#ifdef RSEZNAM_STDALLOC_VER
    delete (T_VOZELENO<TIP>*)rocica;
#else
    assert(JeVozelVKopici(rocica));
    ((T_VOZELENO<TIP>*)rocica)->T_VOZELENO<TIP>::~T_VOZELENO();
    SprostiVozel(rocica);
#endif
}


template <class TIP> inline T_UINT RSklad<TIP>::PrepisiVTabelo(TIP *tabela) const
{
    T_UINT i;
    T_ROCICA rocica;

    for (i = 0, rocica = prvi; i < st_elementov && rocica; i++, rocica = ((T_VOZELENO<TIP>*)rocica)->naslednji)
        tabela[i] = ((T_VOZELENO<TIP>*)rocica)->element;

    return i;
}


template <class TIP> inline T_ROCICA RSklad<TIP>::VrniPrvega() const
{
    return prvi;
}


template <class TIP> inline T_ROCICA RSklad<TIP>::VrniNaslednjega(T_ROCICA rocica) const
{
    assert(rocica);
    return ((T_VOZELENO<TIP>*)rocica)->naslednji;
}


template <class TIP> inline TIP& RSklad<TIP>::VrniPrviElement() const
{
    assert(prvi);
    return ((T_VOZELENO<TIP>*)prvi)->element;
}


#ifndef RSEZNAM_STDALLOC_VER

template <class TIP> T_STANJE RSklad<TIP>::RezervirajBlok()
{
    T_ROCICA blok;
    T_UINT i;

    blok = ::HeapAlloc(kopica, RSEZNAM_ZASTAVICE_KOPICE, korak_povecevanja * sizeof(T_VOZELENO<TIP>));
    if (!blok)
        return AOSN_NAPAKA_POMNILNIK;

    // Sedaj poveemo v seznam prostih vsa novo dodana vozlia.
    i = korak_povecevanja - 1;
    ((T_VOZELENO<TIP>*)blok)[i].naslednji = (T_VOZELENO<TIP>*)prosti;

    for (; i > 0; i--)
        ((T_VOZELENO<TIP>*)blok)[i - 1].naslednji = (T_VOZELENO<TIP>*)blok + i;

    prosti = blok;

    return A_OK;
}


template <class TIP> T_BOOL RSklad<TIP>::JeVozelVKopici(T_ROCICA rocica) const
{
    assert(kopica);
    assert(rocica);

    if (AOSN_PLATFORMA_OS(AOsn::VrniVerzijoOS()) == AOSN_PLAT_WINNT) {
        PROCESS_HEAP_ENTRY he;
        T_BOOL najden = FALSE;

        he.lpData = NULL;
        verify(::HeapLock(kopica));
        while (::HeapWalk(kopica, &he)) {
            if (he.wFlags & PROCESS_HEAP_ENTRY_BUSY && he.lpData <= rocica && rocica < (T_U1*)he.lpData + he.cbData) {
                najden = TRUE;
                break;
            }
        }
        verify(::HeapUnlock(kopica));
        return najden;
    } else
        return TRUE;
}


template <class TIP> inline T_ROCICA RSklad<TIP>::RezervirajVozel()
{
    if (!prosti) verify(USPESNO(RezervirajBlok()));

    T_ROCICA r = prosti;
    prosti = ((T_VOZELENO<TIP>*)prosti)->naslednji;

#ifdef _DEBUG
    st_zasedenih++;
#endif

    return r;
}


template <class TIP> inline T_VOID RSklad<TIP>::SprostiVozel(T_ROCICA rocica)
{
    assert(rocica);

    ((T_VOZELENO<TIP>*)rocica)->naslednji = (T_VOZELENO<TIP>*)prosti;
    prosti = rocica;

#ifdef _DEBUG
    st_zasedenih--;
#endif
}

#endif


template <class TIP> inline const RSklad<TIP>& RSklad<TIP>::operator =(const RSklad<TIP> &sklad)
{
    T_ROCICA rocica;

    // Prepiemo sklad.
    for (rocica = sklad.VrniPrvega(); rocica; rocica = sklad.VrniNaslednjega(rocica))
        Dodaj(sklad[rocica]);

    return *this;
}


template <class TOK, class TIP> inline TOK& operator <<(TOK &tok, const RSklad<TIP> &sklad)
{
    T_ROCICA rocica;
    T_UINT stevilo = sklad.VrniStevilo();

    assert(stevilo <= T_U4_MAX);

    // Najprej zapiemo tevilo elementov v skladu.
    if (NEUSPESNO(tok.VrniStanje())) return tok;
    tok << (T_U4)stevilo;

    // Sedaj zapiemo vse elemente.
    for (rocica = sklad.VrniPrvega(); rocica; rocica = sklad.VrniNaslednjega(rocica)) {
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << sklad[rocica];
    }

    return tok;
}


//////////////////////////////////////////////////////////////////////
// RSeznam
//////////////////////////////////////////////////////////////////////

template <class TIP> RSeznam<TIP>::RSeznam(T_UINT korak_povecevanja) :
    RSklad<TIP>(korak_povecevanja),
    zadnji(NULL)
{
}


template <class TIP> RSeznam<TIP>::RSeznam(const RSklad<TIP> &sklad) :
    zadnji(NULL),
    RSklad<TIP>(sklad)
{
}


template <class TIP> RSeznam<TIP>::~RSeznam()
{
    if (st_elementov)
        Unici();
    assert(!zadnji);
}


template <class TIP> inline T_ROCICA RSeznam<TIP>::DodajPred(T_ROCICA ref)
{
    return DodajVozelPred(UstvariVozel(), ref);
}


template <class TIP> inline T_ROCICA RSeznam<TIP>::DodajPred(const TIP &element, T_ROCICA ref)
{
    return DodajVozelPred(UstvariVozel(element), ref);
}


template <class TIP> T_ROCICA RSeznam<TIP>::DodajVozel(T_ROCICA rocica)
{
    assert(rocica);
#ifndef RSEZNAM_STDALLOC_VER
    assert(JeVozelVKopici(rocica)); // Preverimo, ali je vozlie res iz kopice tega seznama.
#endif

    T_VOZELDVO<TIP> *vozel = (T_VOZELDVO<TIP>*)rocica;

    vozel->naslednji = NULL;

    if (zadnji) {
        ((T_VOZELDVO<TIP>*)zadnji)->naslednji = vozel;
        vozel->prejsnji = zadnji;
    } else {
        prvi = vozel;
        vozel->prejsnji = NULL;
    }

    zadnji = vozel;
    st_elementov++;

    return vozel;
}


template <class TIP> T_ROCICA RSeznam<TIP>::DodajVozelZa(T_ROCICA rocica, T_ROCICA ref)
{
    assert(rocica);
#ifndef RSEZNAM_STDALLOC_VER
    assert(JeVozelVKopici(rocica)); // Preverimo, ali je vozlie res iz kopice tega seznama.
#endif

    T_VOZELDVO<TIP> *vozel = (T_VOZELDVO<TIP>*)rocica;

    if (ref) {
        T_VOZELDVO<TIP> *el = (T_VOZELDVO<TIP>*)ref;

        // Dodamo vozlie vozel za vozlie el.
        vozel->naslednji = el->naslednji;
        vozel->prejsnji  = el;

        // e je za novim vozliem e kakno, preveemo kazalec prejsnji.
        if (vozel->naslednji)
            ((T_VOZELDVO<TIP>*)vozel->naslednji)->prejsnji = vozel;
        else
            // e za novim vozliem ni bilo nobenega ve, je to novi zadnji element seznama!
            zadnji = vozel;

        el->naslednji = vozel;
    } else {
        // ref == NULL => dodajamo na zaetek seznama.

        assert(0); // TODO: Preizkusi ta del kode.
        vozel->naslednji = prvi;
        vozel->prejsnji = NULL;
        prvi = vozel;
        if (!zadnji)
            zadnji = vozel;
    }
    st_elementov++;

    return vozel;
}


template <class TIP> T_ROCICA RSeznam<TIP>::DodajVozelPred(T_ROCICA rocica, T_ROCICA ref)
{
    assert(rocica);
#ifndef RSEZNAM_STDALLOC_VER
    assert(JeVozelVKopici(rocica)); // Preverimo, ali je vozlie res iz kopice tega seznama.
#endif

    T_VOZELDVO<TIP> *vozel = (T_VOZELDVO<TIP>*)rocica;

    if (ref) {
        T_VOZELDVO<TIP> *el = (T_VOZELDVO<TIP>*)ref;

        // Dodamo vozlie vozel pred vozlie el.
        vozel->prejsnji  = el->prejsnji;
        vozel->naslednji = el;

        // e je pred novim vozliem e kakno, preveemo kazalec naslednji.
        if (vozel->prejsnji)
            ((T_VOZELDVO<TIP>*)vozel->prejsnji)->naslednji = vozel;
        else
            // e za novim vozliem ni bilo nobenega ve, je to novi prvi element seznama!
            prvi = vozel;

        el->prejsnji = vozel;
    } else {
        // ref == NULL => dodajamo na konec seznama.
        vozel->prejsnji = zadnji;
        vozel->naslednji = NULL;
        zadnji = vozel;
        if (!prvi)
            prvi = vozel;
    }
    st_elementov++;

    return vozel;
}


template <class TIP> inline T_VOID RSeznam<TIP>::IzlociVozel(T_ROCICA rocica)
{
    assert(rocica);
    T_VOZELDVO<TIP> *vozel = (T_VOZELDVO<TIP>*)rocica;

    // Izloimo vozlie iz seznama.
    if (vozel->prejsnji)
        ((T_VOZELDVO<TIP>*)vozel->prejsnji)->naslednji = vozel->naslednji;
    else
        prvi = vozel->naslednji;

    if (vozel->naslednji)
        ((T_VOZELDVO<TIP>*)vozel->naslednji)->prejsnji = vozel->prejsnji;
    else
        zadnji = vozel->prejsnji;

    st_elementov--;
}


template <class TIP> T_VOID RSeznam<TIP>::Brisi(T_ROCICA rocica)
{
    // Izloimo in uniimo vozel.
    IzlociVozel(rocica);
    UniciVozel(rocica);
}


template <class TIP> T_VOID RSeznam<TIP>::Unici()
{
    RSklad<TIP>::Unici();
    zadnji = NULL;
}


template <class TIP> T_ROCICA RSeznam<TIP>::UstvariVozel()
{
    T_VOZELDVO<TIP> *vozel;
#ifdef RSEZNAM_STDALLOC_VER
    vozel = new T_VOZELDVO<TIP>;
    assert(vozel);
#else
    vozel = (T_VOZELDVO<TIP>*)RezervirajVozel();
    assert(vozel);
    vozel->T_VOZELDVO<TIP>::T_VOZELDVO();
#endif
    return vozel;
}


template <class TIP> T_ROCICA RSeznam<TIP>::UstvariVozel(const TIP &element)
{
    T_VOZELDVO<TIP> *vozel;
#ifdef RSEZNAM_STDALLOC_VER
    vozel = new T_VOZELDVO<TIP>(element)
    assert(vozel);
#else
    vozel = (T_VOZELDVO<TIP>*)RezervirajVozel();
    assert(vozel);
    vozel->T_VOZELDVO<TIP>::T_VOZELDVO(element);
#endif
    return vozel;
}


template <class TIP> T_VOID RSeznam<TIP>::UniciVozel(T_ROCICA rocica)
{
    assert(rocica);
#ifdef RSEZNAM_STDALLOC_VER
    delete (T_VOZELDVO<TIP>*)rocica;
#else
    assert(JeVozelVKopici(rocica));
    ((T_VOZELDVO<TIP>*)rocica)->T_VOZELDVO<TIP>::~T_VOZELDVO();
    SprostiVozel(rocica);
#endif
}


template <class TIP> inline T_ROCICA RSeznam<TIP>::VrniZadnjega() const
{
    return zadnji;
}


template <class TIP> inline T_ROCICA RSeznam<TIP>::VrniPrejsnjega(T_ROCICA rocica) const
{
    assert(rocica);
    return ((T_VOZELDVO<TIP>*)rocica)->prejsnji;
}


template <class TIP> inline TIP& RSeznam<TIP>::VrniZadnjiElement() const
{
    assert(zadnji);
    return ((T_VOZELDVO<TIP>*)zadnji)->element;
}


#ifndef RSEZNAM_STDALLOC_VER

template <class TIP> T_STANJE RSeznam<TIP>::RezervirajBlok()
{
    T_ROCICA blok;
    T_UINT i;

    blok = ::HeapAlloc(kopica, RSEZNAM_ZASTAVICE_KOPICE, korak_povecevanja * sizeof(T_VOZELDVO<TIP>));
    if (!blok)
        return AOSN_NAPAKA_POMNILNIK;

    // Sedaj poveemo v seznam prostih vsa novo dodana vozlia.
    i = korak_povecevanja - 1;
    ((T_VOZELDVO<TIP>*)blok)[i].naslednji = (T_VOZELDVO<TIP>*)prosti;

    for (; i > 0; i--)
        ((T_VOZELDVO<TIP>*)blok)[i - 1].naslednji = (T_VOZELDVO<TIP>*)blok + i;

    prosti = blok;

    return A_OK;
}

#endif


//////////////////////////////////////////////////////////////////////
// RUrejenSeznam
//////////////////////////////////////////////////////////////////////

template <class TIP> RUrejenSeznam<TIP>::RUrejenSeznam(T_UINT korak_povecevanja) : RSeznam<TIP>(korak_povecevanja)
{
}


template <class TIP> T_ROCICA RUrejenSeznam<TIP>::DodajVozel(T_ROCICA rocica)
{
    assert(rocica);
#ifndef RSEZNAM_STDALLOC_VER
    assert(JeVozelVKopici(rocica)); // Preverimo, ali je vozlie res iz kopice tega seznama.
#endif

    T_VOZELDVO<TIP> *p, *vozel = (T_VOZELDVO<TIP>*)rocica;

    // e je seznam e prazen, ali pa element sodi na sam konec, ga tja tudi dodamo.
    if (!zadnji || Primerjaj(((T_VOZELDVO<TIP>*)zadnji)->element, vozel->element) < 0) {
        vozel->naslednji = NULL;
        vozel->prejsnji  = zadnji;

        if (zadnji)
            ((T_VOZELDVO<TIP>*)zadnji)->naslednji = vozel;
        else
            prvi = vozel;

        zadnji = vozel;
    } else {
        // Najdemo pravo mesto za vozlie v seznamu (zanemo od zadaj, glej razlago v dokumentaciji).
        for (p = (T_VOZELDVO<TIP>*)zadnji;
            p->prejsnji && Primerjaj(vozel->element, ((T_VOZELDVO<TIP>*)p->prejsnji)->element) < 0;
            p = (T_VOZELDVO<TIP>*)p->prejsnji);

        // Vrinemo elementovo vozlie v seznam.
        vozel->prejsnji  = p->prejsnji;
        vozel->naslednji = p;

        if (p->prejsnji)
            ((T_VOZELDVO<TIP>*)p->prejsnji)->naslednji = vozel;
        else
            // e je bilo to prvo vozlie v seznamu, popravimo kazalec na prvega.
            prvi = vozel;

        p->prejsnji = vozel;
    }

    st_elementov++;

    return vozel;
}


template <class TIP> inline T_ROCICA RUrejenSeznam<TIP>::DodajPogojno(const TIP &element)
{
    T_VOZELDVO<TIP> *vozel = (T_VOZELDVO<TIP>*)UstvariVozel(element);
    assert(vozel);

    // Dodamo in preverimo, ali je bil to duplikat.
    T_ROCICA rocica = DodajVozelPogojno(vozel);
    if (rocica == vozel)
        // Ni bil duplikat.
        return rocica;
    else {
        // DodajPogojno je nael enak element v seznamu, zato uniimo nae vozlie in vrnemo NULL.
        UniciVozel(vozel);
        return NULL;
    }
}


template <class TIP> T_ROCICA RUrejenSeznam<TIP>::DodajVozelPogojno(T_ROCICA rocica)
{
    assert(rocica);
    T_VOZELDVO<TIP> *p, *vozel = (T_VOZELDVO<TIP>*)rocica;
    T_INT status;

    // e je seznam e prazen, ali pa element sodi na sam konec, ga tja tudi dodamo.
    if (!zadnji || (status = Primerjaj(((T_VOZELDVO<TIP>*)zadnji)->element, vozel->element)) < 0) {
        vozel->naslednji = NULL;
        vozel->prejsnji  = zadnji;

        if (zadnji)
            ((T_VOZELDVO<TIP>*)zadnji)->naslednji = vozel;
        else
            prvi = vozel;

        zadnji = vozel;
    } else if (status == 0) {
        // Zadnji je duplikat, zato ga vrnemo.
        return (T_VOZELDVO<TIP>*)zadnji;
    } else {
        // Poiemo pravo mesto za elementovo vozlie v seznamu.
        for (p = (T_VOZELDVO<TIP>*)zadnji; p->prejsnji; p = (T_VOZELDVO<TIP>*)p->prejsnji) {
            status = Primerjaj(vozel->element, ((T_VOZELDVO<TIP>*)p->prejsnji)->element);

            if (status > 0)
                break;
            else if (status == 0)
                // Nali smo duplikat, zato ga vrnemo.
                return (T_VOZELDVO<TIP>*)p->prejsnji;
        }

        // Vrinemo elementovo vozlie v seznam.
        vozel->prejsnji  = p->prejsnji;
        vozel->naslednji = p;

        if (p->prejsnji)
            ((T_VOZELDVO<TIP>*)p->prejsnji)->naslednji = vozel;
        else
            prvi = vozel;

        p->prejsnji = vozel;
    }

    st_elementov++;

    return vozel;
}


template <class TIP> T_ROCICA RUrejenSeznam<TIP>::PoisciOd(T_ROCICA rocica, const TIP &element, T_BOOL naprej) const
{
    T_VOZELDVO<TIP> *p;
    T_INT rezultat;

    for (p = (T_VOZELDVO<TIP>*)rocica; p; p = (T_VOZELDVO<TIP>*)(naprej ? p->naslednji : p->prejsnji)) {
        rezultat = Primerjaj(p->element, element);
        if (!rezultat)  // Nali smo element.
            return p;
        else if (rezultat > 0) // Ne moremo ve najti tega elementa, ker je seznam urejen.
            return NULL;
    }

    return NULL;
}


template <class TIP> inline T_ROCICA RUrejenSeznam<TIP>::PoisciOdPrvega(const TIP &element) const
{
    return PoisciOd(VrniPrvega(), element, TRUE);
}


template <class TIP> inline T_ROCICA RUrejenSeznam<TIP>::PoisciOdZadnjega(const TIP &element) const
{
    return PoisciOd(VrniZadnjega(), element, FALSE);
}


//////////////////////////////////////////////////////////////////////
// RBIndeks<>::RIterator
//////////////////////////////////////////////////////////////////////

template <class TIP, T_UINT N> RBIndeks<TIP, N>::RIterator::RIterator() :
    RElement(),
    kontekst(NULL)
{
}


template <class TIP, T_UINT N> RBIndeks<TIP, N>::RIterator::RIterator(const RBIndeks<TIP, N> &drevo) :
    RElement(),
    kontekst(NULL)
{
    NastaviZacetek(drevo.VrniKoren());
}


template <class TIP, T_UINT N> RBIndeks<TIP, N>::RIterator::~RIterator()
{
    Sprazni();
}


template <class TIP, T_UINT N> T_VOID RBIndeks<TIP, N>::RIterator::NastaviZacetek(const RBIndeks<TIP, N> &drevo)
{
    if (kontekst) Sprazni();
    NastaviZacetek(drevo.VrniKoren());
}


template <class TIP, T_UINT N> T_VOID RBIndeks<TIP, N>::RIterator::NastaviKonec(const RBIndeks<TIP, N> &drevo)
{
    if (kontekst) Sprazni();
    NastaviKonec(drevo.VrniKoren());
}


template <class TIP, T_UINT N> inline T_VOID RBIndeks<TIP, N>::RIterator::Sprazni()
{
    while (kontekst) {
        T_KONTEKST *p = kontekst;
        kontekst = kontekst->pred;
        afree(p);
    }
}


template <class TIP, T_UINT N> inline TIP* RBIndeks<TIP, N>::RIterator::VrniElement() const
{
    assert(kontekst);
    assert(kontekst->vozlisce);
    return kontekst->vozlisce->zapisi[kontekst->indeks].element;
}


template <class TIP, T_UINT N> inline T_BOOL RBIndeks<TIP, N>::RIterator::JeKonec() const
{
    return !kontekst;
}


template <class TIP, T_UINT N> inline T_BOOL RBIndeks<TIP, N>::RIterator::PrestaviNaprej()
{
    assert(kontekst);
    assert(kontekst->vozlisce);

    T_BVOZEL<TIP, N> *vozlisce_x = kontekst->vozlisce->zapisi[kontekst->indeks++].nasl;

    if (vozlisce_x) {
        // Prestavimo se na najbolj levi element iz poddrevesa naslednjega elementa.
        NastaviZacetek(vozlisce_x);
        return TRUE;
    }

    while (kontekst->indeks >= kontekst->vozlisce->zapisi.stevilo) {
        // To je bil zadnji element v tem vozliu.
        T_KONTEKST *p = kontekst;
        kontekst = kontekst->pred;
        afree(p);

        if (!kontekst) return FALSE;
    }

    return TRUE;
}


template <class TIP, T_UINT N> inline T_BOOL RBIndeks<TIP, N>::RIterator::PrestaviNaprej(T_UINT stevilo)
{
    while (stevilo--) {
        if (!PrestaviNaprej())
            return FALSE;
    }

    return TRUE;
}


template <class TIP, T_UINT N> inline T_BOOL RBIndeks<TIP, N>::RIterator::PrestaviNazaj()
{
    assert(kontekst);
    assert(kontekst->vozlisce);

    T_BVOZEL<TIP, N> *vozlisce_x = kontekst->indeks-- ? kontekst->vozlisce->zapisi[kontekst->indeks].nasl : kontekst->vozlisce->pred;

    if (vozlisce_x) {
        // Prestavimo se na najbolj levi element iz poddrevesa naslednjega elementa.
        NastaviKonec(vozlisce_x);
        return TRUE;
    }

    while (kontekst->indeks == T_UINT_MAX) {
        // To je bil zadnji element v tem vozliu.
        T_KONTEKST *p = kontekst;
        kontekst = kontekst->pred;
        afree(p);

        if (!kontekst) return FALSE;
    }

    return TRUE;
}


template <class TIP, T_UINT N> inline T_BOOL RBIndeks<TIP, N>::RIterator::PrestaviNazaj(T_UINT stevilo)
{
    while (stevilo--) {
        if (!PrestaviNazaj())
            return FALSE;
    }

    return TRUE;
}


template <class TIP, T_UINT N> inline T_VOID RBIndeks<TIP, N>::RIterator::DodajKontekst(T_BVOZEL<TIP, N> *vozlisce, T_UINT indeks)
{
    T_KONTEKST *p = (T_KONTEKST*)aalloc(sizeof(T_KONTEKST));
    assert(p);

    p->vozlisce = vozlisce;
    p->indeks   = indeks;
    p->pred     = kontekst;
    kontekst    = p;
}


template <class TIP, T_UINT N> inline T_VOID RBIndeks<TIP, N>::RIterator::NastaviZacetek(T_BVOZEL<TIP, N> *vozlisce)
{
    for (; vozlisce; vozlisce = vozlisce->pred) {
        // Vstavimo kontekst za dano vozlie.
        DodajKontekst(vozlisce, 0);
    }
}


template <class TIP, T_UINT N> inline T_VOID RBIndeks<TIP, N>::RIterator::NastaviKonec(T_BVOZEL<TIP, N> *vozlisce)
{
    for (; vozlisce; vozlisce = vozlisce->zapisi[vozlisce->zapisi.stevilo - 1].nasl) {
        // Vstavimo kontekst za dano vozlie.
        DodajKontekst(vozlisce, vozlisce->zapisi.stevilo - 1);
    }
}


//////////////////////////////////////////////////////////////////////
// RBIndeks
//////////////////////////////////////////////////////////////////////

template <class TIP, T_UINT N> RBIndeks<TIP, N>::RBIndeks() :
    RElement(),
    koren(NULL),
    st_elementov(0)
{
    // Ustvarimo kopico vozli.
    kopica_vozlisc = ::HeapCreate(RSEZNAM_ZASTAVICE_KOPICE, 0, 0);
    assert(kopica_vozlisc);
}


template <class TIP, T_UINT N> RBIndeks<TIP, N>::~RBIndeks()
{
    if (st_elementov)
        Unici();

    assert(!koren);
    assert(!st_elementov);

    assert(::HeapValidate(kopica_vozlisc, RSEZNAM_ZASTAVICE_KOPICE, NULL));
    verify(::HeapDestroy(kopica_vozlisc));
}


template <class TIP, T_UINT N> inline T_VOID RBIndeks<TIP, N>::DodajElement(TIP *element)
{
    if (!koren) {
        // Drevo je e prazno.
        koren = (T_BVOZEL<TIP, N>*)::HeapAlloc(kopica_vozlisc, RSEZNAM_ZASTAVICE_KOPICE, sizeof(T_BVOZEL<TIP, N>));
        assert(koren);

        koren->zapisi.stevilo    = 1;
        koren->pred              = NULL;
        koren->zapisi[0].element = element;
        koren->zapisi[0].nasl    = NULL;
    } else {
        TIP *element_r;
        T_BVOZEL<TIP, N> *vozlisce_r;

        element_r = DodajElement(koren, element, &vozlisce_r, NULL);
        if (element_r) {
            // Poveati moramo globino drevesa in narediti nov koren.
            T_BVOZEL<TIP, N> *koren_novi = (T_BVOZEL<TIP, N>*)::HeapAlloc(kopica_vozlisc, RSEZNAM_ZASTAVICE_KOPICE, sizeof(T_BVOZEL<TIP, N>));
            assert(koren_novi);

            koren_novi->zapisi.stevilo    = 1;
            koren_novi->pred              = koren;
            koren_novi->zapisi[0].element = element_r;
            koren_novi->zapisi[0].nasl    = vozlisce_r;

            koren = koren_novi;
        }
    }

    st_elementov++;
}


template <class TIP, T_UINT N> inline TIP* RBIndeks<TIP, N>::DodajElementPogojno(TIP *element)
{
    if (!koren) {
        // Drevo je e prazno.
        koren = (T_BVOZEL<TIP, N>*)::HeapAlloc(kopica_vozlisc, RSEZNAM_ZASTAVICE_KOPICE, sizeof(T_BVOZEL<TIP, N>));
        assert(koren);

        koren->zapisi.stevilo    = 1;
        koren->pred              = NULL;
        koren->zapisi[0].element = element;
        koren->zapisi[0].nasl    = NULL;

        st_elementov++;

        return element;
    } else {
        TIP *element_r, *element_n = NULL;
        T_BVOZEL<TIP, N> *vozlisce_r;

        element_r = DodajElement(koren, element, &vozlisce_r, &element_n);
        if (element_r) {
            // Poveati moramo globino drevesa in narediti nov koren.
            T_BVOZEL<TIP, N> *koren_novi = (T_BVOZEL<TIP, N>*)::HeapAlloc(kopica_vozlisc, RSEZNAM_ZASTAVICE_KOPICE, sizeof(T_BVOZEL<TIP, N>));
            assert(koren_novi);

            koren_novi->zapisi.stevilo    = 1;
            koren_novi->pred              = koren;
            koren_novi->zapisi[0].element = element_r;
            koren_novi->zapisi[0].nasl    = vozlisce_r;

            koren = koren_novi;
        }

        if (element_n == element)
            st_elementov++;

        return element_n;
    }
}


template <class TIP, T_UINT N> inline T_VOID RBIndeks<TIP, N>::Unici()
{
    if (koren) {
        UniciPoddrevo(koren);
#ifdef _DEBUG
        // V razvojni razliici med unievanjem drevesa zmanjujemo tevec elementov.
        assert(st_elementov == 0);
#endif
        koren = NULL;
        st_elementov = 0;
    }
}


template <class TIP, T_UINT N> inline TIP* RBIndeks<TIP, N>::Poisci(const TIP *element) const
{
    assert(element);

    T_BVOZEL<TIP, N> *p = koren;
    T_UINT i, j, m;
    T_INT r;

    while (p) {
        // Z bisekcijo poiemo element v vozliu.
        i = 0;
        j = p->zapisi.stevilo;
        assert(p->zapisi.stevilo <= N);

        for (;;) {
            if (i < j) {
                // Primerjamo element s sredinskim.
                m = (i + j) / 2;
                r = Primerjaj(p->zapisi[m].element, element);

                if (r < 0)
                    i = m + 1;
                else if (r > 0)
                    j = m;
                else {
                    // Element je enak m-temu elementu tega vozlia.
                    if (m <= i || Primerjaj(p->zapisi[m - 1].element, element) < 0) {
                        // Levega elementa ni ve, oziroma je ta e manji od najdenega. Vrnemo najdenega.
                        return p->zapisi[m].element;
                    } else {
                        // Z bisekcijo poiemo prvi element v vozliu, ki je enak iskanemu in ga vrnemo.
                        for (j = m - 1; i < j;) {
                            m = (i + j) / 2;
                            if (Primerjaj(p->zapisi[m].element, element) < 0)
                                i = m + 1;
                            else
                                j = m;
                        }
                        return p->zapisi[j].element;
                    }
                }
            } else {
                // Elementa ne bomo nali v tem vozliu. Nadaljujemo v poddrevesu.
                p = i ? p->zapisi[i - 1].nasl : p->pred;
                break;
            }
        }
    }

    return NULL;
}


template <class TIP, T_UINT N> inline T_BOOL RBIndeks<TIP, N>::Poisci(const TIP *element, RIterator &iterator) const
{
    assert(element);

    T_BVOZEL<TIP, N> *p = koren;
    T_UINT i, j, m;
    T_INT r;

    iterator.Sprazni();

    while (p) {
        // Z bisekcijo poiemo element v vozliu.
        i = 0;
        j = p->zapisi.stevilo;
        assert(p->zapisi.stevilo <= N);

        for (;;) {
            if (i < j) {
                // Primerjamo element s sredinskim.
                m = (i + j) / 2;
                r = Primerjaj(p->zapisi[m].element, element);

                if (r < 0)
                    i = m + 1;
                else if (r > 0)
                    j = m;
                else {
                    // Element je enak m-temu elementu tega vozlia.
                    if (m <= i || Primerjaj(p->zapisi[m - 1].element, element) < 0) {
                        // Levega elementa ni ve, oziroma je ta e manji od najdenega. Nastavimo iterator na najdenega in konamo.
                        iterator.DodajKontekst(p, m);
                    } else {
                        // Z bisekcijo poiemo prvi element v vozliu, ki je enak iskanemu, nastavimo iterator nanj in konamo.
                        for (j = m - 1; i < j;) {
                            m = (i + j) / 2;
                            if (Primerjaj(p->zapisi[m].element, element) < 0)
                                i = m + 1;
                            else
                                j = m;
                        }
                        iterator.DodajKontekst(p, j);
                    }
                    return TRUE;
                }
            } else {
                // Elementa ne bomo nali v tem vozliu. Dodamo vozlie v kontekst iteratorja in nadaljujemo v poddrevesu.
                iterator.DodajKontekst(p, i);
                p = i ? p->zapisi[i - 1].nasl : p->pred;
                break;
            }
        }
    }

    return FALSE;
}



template <class TIP, T_UINT N> inline T_VOID RBIndeks<TIP, N>::IzlociElement(TIP *element)
{
    assert(element);
    assert(koren);
    assert(::HeapValidate(kopica_vozlisc, RSEZNAM_ZASTAVICE_KOPICE, koren));

    if (IzlociElement(koren, element)) {
        if (koren->zapisi.stevilo == 0) {
            // Zmanjamo nivo drevesa.
            T_BVOZEL<TIP, N> *koren_novi = koren->pred;
            verify(::HeapFree(kopica_vozlisc, RSEZNAM_ZASTAVICE_KOPICE, koren));
            koren = koren_novi;
        }

        st_elementov--;
    }
}


template <class TIP, T_UINT N> inline T_BVOZEL<TIP, N>* RBIndeks<TIP, N>::VrniKoren() const
{
    return koren;
}


template <class TIP, T_UINT N> inline T_UINT RBIndeks<TIP, N>::VrniStevilo() const
{
    return st_elementov;
}


template <class TIP, T_UINT N> inline T_BOOL RBIndeks<TIP, N>::JePrazen() const
{
    return koren == NULL;
}


template <class TIP, T_UINT N> T_VOID RBIndeks<TIP, N>::UniciPoddrevo(T_BVOZEL<TIP, N> *vozlisce)
{
    assert(vozlisce);
    assert(::HeapValidate(kopica_vozlisc, RSEZNAM_ZASTAVICE_KOPICE, vozlisce));

    T_UINT i;

    if (vozlisce->pred) {
        // Izbriemo najbolj levo poddrevo.
        UniciPoddrevo(vozlisce->pred);
    }

    for (i = 0; i < vozlisce->zapisi.stevilo; i++) {
#ifdef _DEBUG
        st_elementov--;
#endif

        if (vozlisce->zapisi[i].nasl) {
            // Izbriemo poddrevo.
            UniciPoddrevo(vozlisce->zapisi[i].nasl);
        }
    }

    verify(::HeapFree(kopica_vozlisc, RSEZNAM_ZASTAVICE_KOPICE, vozlisce));
}


template <class TIP, T_UINT N> TIP* RBIndeks<TIP, N>::DodajElement(T_BVOZEL<TIP, N> *vozlisce, TIP *element, T_BVOZEL<TIP, N> **_vozlisce_r, TIP **element_n)
{
    assert(vozlisce);
    assert(::HeapValidate(kopica_vozlisc, RSEZNAM_ZASTAVICE_KOPICE, vozlisce));
    assert(_vozlisce_r);

    T_UINT i = 0, j = vozlisce->zapisi.stevilo;
    TIP *element_r = NULL;
    T_BVOZEL<TIP, N> *vozlisce_r = NULL;

    // Z bisekcijo poiemo mesto za element v vozliu.
    for (;;) {
        if (i < j) {
            // Primerjamo element s sredinskim.
            T_UINT m = (i + j) / 2;
            T_INT r = Primerjaj(vozlisce->zapisi[m].element, element);
            if (r < 0)
                i = m + 1;
            else if (r > 0)
                j = m;
            else {
                // Element je enak m-temu elementu tega vozlia.

                if (element_n) {
                    // Dodajanje elementa je pogojno, mi pa smo nali e en tak element v drevesu.
                    if (m <= i || Primerjaj(vozlisce->zapisi[m - 1].element, element) < 0) {
                        // Levega elementa ni ve, oziroma je ta e manji od najdenega. Vrnemo najdenega.
                        *element_n = vozlisce->zapisi[m].element;
                    } else {
                        // Z bisekcijo poiemo prvi element v vozliu, ki je enak iskanemu in ga vrnemo.
                        for (j = m - 1; i < j;) {
                            m = (i + j) / 2;
                            if (Primerjaj(vozlisce->zapisi[m].element, element) < 0)
                                i = m + 1;
                            else
                                j = m;
                        }
                        *element_n = vozlisce->zapisi[j].element;
                    }
                    return NULL;
                }

                if (m + 1 >= j || Primerjaj(vozlisce->zapisi[m + 1].element, element) > 0) {
                    // Desnega elementa ni ve, oziroma je ta e veji od najdenega.
                    i = j = m + 1;
                } else {
                    // Z bisekcijo poiemo zadnji tak element, e je ve enakih v vozliu.
                    for (i = m + 2; i < j;) {
                        m = (i + j) / 2;
                        if (Primerjaj(vozlisce->zapisi[m].element, element) > 0)
                            j = m;
                        else
                            i = m + 1;
                    }
                }
            }
        } else {
            vozlisce_r = i ? vozlisce->zapisi[i - 1].nasl : vozlisce->pred;
            if (vozlisce_r) {
                // Nismo e dosegli najveje globine. Element bomo vstavili v i-to poddrevo tega vozlia.
                element_r = DodajElement(vozlisce_r, element, &vozlisce_r, element_n);
            } else {
                // Dosegli smo najvejo globino. Element dodamo v to vozlie.
                element_r = element;
            }
            break;
        }
    }

    if (element_r) {
        if (element_n && !*element_n) {
            assert(element_r == element);
            *element_n = element_r;
        }

        if (vozlisce->zapisi.stevilo < N) {
            // V tem vozliu je e prostor za vsaj en element.

            // Prepiemo vse elemente za i-tim za eno mesto desno.
            vozlisce->zapisi.PremakniDesno(i);

            // Dodamo element.
            vozlisce->zapisi[i].element = element_r;
            vozlisce->zapisi[i].nasl    = vozlisce_r;

            return NULL;
        } else {
            // V tem vozliu ni ve prostora. Razbijemo ga na dve.
            assert(N/2 <= vozlisce->zapisi.stevilo && vozlisce->zapisi.stevilo <= N);
            assert(element_r);

            T_BVOZEL<TIP, N> *vozlisce2;
            TIP *element_r2;
            T_UINT koncno_stevilo = N/2;

            // Ustvarimo novo vozlie.
            vozlisce2 = (T_BVOZEL<TIP, N>*)::HeapAlloc(kopica_vozlisc, RSEZNAM_ZASTAVICE_KOPICE, sizeof(T_BVOZEL<TIP, N>));
            assert(vozlisce2);

            vozlisce2->zapisi.stevilo = vozlisce->zapisi.stevilo - koncno_stevilo;

            if (i < koncno_stevilo) {
                // Novi element bo del starega vozlia.

                // Prepiemo elemente v novo vozlie.
                memcpy(vozlisce2->zapisi.podatki, vozlisce->zapisi.podatki + koncno_stevilo, vozlisce2->zapisi.stevilo * sizeof(T_BVOZEL<TIP, N>::T_TABZAPISI::T_ZAPIS));

                // Odvzamemo zadnji element iz vozlia.
                vozlisce2->pred = vozlisce->zapisi[koncno_stevilo - 1].nasl;
                element_r2      = vozlisce->zapisi[koncno_stevilo - 1].element;

                // Prepiemo vse elemente za i-tim za eno mesto desno.
                memcpy(vozlisce->zapisi.podatki + i + 1, vozlisce->zapisi.podatki + i, (koncno_stevilo - i - 1) * sizeof(T_BVOZEL<TIP, N>::T_TABZAPISI::T_ZAPIS));

                // Zapiemo element, ki ga dodajamo.
                vozlisce->zapisi[i].element = element_r;
                vozlisce->zapisi[i].nasl    = vozlisce_r;
            } else if (i == koncno_stevilo) {
                // Novi element bo pivot.

                // Pripravimo podatke pivota.
                element_r2  = element_r;

                // Prepiemo presene elemente v novo vozlie.
                vozlisce2->pred = vozlisce_r;
                memcpy(vozlisce2->zapisi.podatki, vozlisce->zapisi.podatki + koncno_stevilo, vozlisce2->zapisi.stevilo * sizeof(T_BVOZEL<TIP, N>::T_TABZAPISI::T_ZAPIS));
            } else {
                // Novi element bo del novega vozlia.

                // Prepiemo elemente v novo vozlie (1. del).
                memcpy(vozlisce2->zapisi.podatki, vozlisce->zapisi.podatki + koncno_stevilo + 1, (i - koncno_stevilo - 1) * sizeof(T_BVOZEL<TIP, N>::T_TABZAPISI::T_ZAPIS));

                // Odvzamemo srednji element iz vozlia.
                vozlisce2->pred = vozlisce->zapisi[koncno_stevilo].nasl;
                element_r2      = vozlisce->zapisi[koncno_stevilo].element;

                // Zapiemo element, ki ga dodajamo.
                vozlisce2->zapisi[i - koncno_stevilo - 1].element = element_r;
                vozlisce2->zapisi[i - koncno_stevilo - 1].nasl    = vozlisce_r;

                // Prepiemo elemente v novo vozlie (2. del).
                memcpy(vozlisce2->zapisi.podatki + i - koncno_stevilo, vozlisce->zapisi.podatki + i, (N - i) * sizeof(T_BVOZEL<TIP, N>::T_TABZAPISI::T_ZAPIS));
            }

            vozlisce->zapisi.stevilo = koncno_stevilo;
#ifdef _DEBUG
            memset(vozlisce->zapisi.podatki + koncno_stevilo, 0xcd, vozlisce2->zapisi.stevilo * sizeof(T_BVOZEL<TIP, N>::T_TABZAPISI::T_ZAPIS));
#endif
            assert(element_r2);
            assert(::HeapValidate(kopica_vozlisc, RSEZNAM_ZASTAVICE_KOPICE, vozlisce));
            assert(::HeapValidate(kopica_vozlisc, RSEZNAM_ZASTAVICE_KOPICE, vozlisce2));

            (*_vozlisce_r) = vozlisce2;
            return element_r2;
        }
    } else
        return NULL;
}


template <class TIP, T_UINT N> T_BOOL RBIndeks<TIP, N>::IzlociElement(T_BVOZEL<TIP, N> *vozlisce, TIP *element)
{
    T_UINT i = 0, j = vozlisce->zapisi.stevilo;

    // Z bisekcijo poiemo eleni element v vozliu.
    for (;;) {
        if (i < j) {
            // Primerjamo element s sredinskim.
            T_UINT m = (i + j) / 2;
            if (vozlisce->zapisi[m].element == element) {
                // Nali smo eleni element.
                i = m;
                goto najden;
            }

            T_INT r = Primerjaj(vozlisce->zapisi[m].element, element);
            if (r < 0)
                i = m + 1;
            else if (r > 0)
                j = m;
            else {
                // Element je enak m-temu elementu tega vozlia. Ni pa tono tisti, ki ga elimo izbrisati (kazalca se razlikujeta).
                for (i = m; i && Primerjaj(vozlisce->zapisi[i - 1].element, element) == 0;)
                    if (vozlisce->zapisi[--i].element == element) goto najden;
                for (j = m + 1; j < vozlisce->zapisi.stevilo && Primerjaj(vozlisce->zapisi[j].element, element) == 0; j++) {
                    if (vozlisce->zapisi[j].element == element) {
                        i = j;
                        goto najden;
                    }
                }

                // Na intervalu [i, j) so vsi elementi po vrednosti enaki elenemu, ampak noben med njimi ni tisti pravi. Zato iemo rekurzivno v njihovih poddrevesih.
                for (m = i; m < j; m++) {
                    if (vozlisce->zapisi[m].nasl && IzlociElement(vozlisce->zapisi[m].nasl, element)) {
                        UrediPoddrevo(vozlisce, m);
                        return TRUE;
                    }
                }
            }
        } else {
            // Elementa ne bomo nali v tem vozliu. Nadaljujemo v poddrevesu.
            if (i) {
                if (vozlisce->zapisi[i - 1].nasl && IzlociElement(vozlisce->zapisi[i - 1].nasl, element)) {
                    UrediPoddrevo(vozlisce, i - 1);
                    return TRUE;
                }
            } else {
                if (vozlisce->pred && IzlociElement(vozlisce->pred, element)) {
                    UrediPoddrevo(vozlisce, T_UINT_MAX);
                    return TRUE;
                }
            }

            // Tega elementa nismo nali
            return FALSE;
        }
    }

najden:
    if (!vozlisce->zapisi[i].nasl) {
        // Element, ki ga briemo, nima poddrevesa.
        vozlisce->zapisi.PremakniLevo(i);
    } else {
        vozlisce->zapisi[i].element = IzlociNajmanjsiElement(vozlisce->zapisi[i].nasl);
        UrediPoddrevo(vozlisce, i);
    }

    return TRUE;
}


template <class TIP, T_UINT N> TIP* RBIndeks<TIP, N>::IzlociNajmanjsiElement(T_BVOZEL<TIP, N> *vozlisce)
{
    assert(vozlisce);
    assert(::HeapValidate(kopica_vozlisc, RSEZNAM_ZASTAVICE_KOPICE, vozlisce));

    TIP *element_r;

    if (vozlisce->pred) {
        // Nadaljujemo rekurzivno v najbolj levem poddrevesu.
        element_r = IzlociNajmanjsiElement(vozlisce->pred);
        UrediPoddrevo(vozlisce, vozlisce->zapisi.stevilo - 1);
        return element_r;
    } else {
        // To vozlie nima ve poddrevesa in je zadnje.
        assert(vozlisce->zapisi.stevilo);
        element_r = vozlisce->zapisi[0].element;
        vozlisce->zapisi.PremakniLevo(0);
        return element_r;
    }
}


template <class TIP, T_UINT N> T_VOID RBIndeks<TIP, N>::UrediPoddrevo(T_BVOZEL<TIP, N> *vozlisce, T_UINT i)
{
    assert(vozlisce);
    assert(::HeapValidate(kopica_vozlisc, RSEZNAM_ZASTAVICE_KOPICE, vozlisce));
    assert(i < vozlisce->zapisi.stevilo && vozlisce->zapisi[i].nasl || i == T_UINT_MAX && vozlisce->pred);

    T_BVOZEL<TIP, N> *vozlisce_x = i != T_UINT_MAX ? vozlisce->zapisi[i].nasl : vozlisce->pred;
    assert(vozlisce_x);
    assert(::HeapValidate(kopica_vozlisc, RSEZNAM_ZASTAVICE_KOPICE, vozlisce_x));

    if (vozlisce_x->zapisi.stevilo < N/2) {
        // Poddrevo ima premalo elementov.
        T_BVOZEL<TIP, N>
            *vozlisce_l = i != T_UINT_MAX ? i                                ? vozlisce->zapisi[i - 1].nasl : vozlisce->pred : NULL                    ,
            *vozlisce_d = i != T_UINT_MAX ? i < vozlisce->zapisi.stevilo - 1 ? vozlisce->zapisi[i + 1].nasl : NULL           : vozlisce->zapisi[0].nasl;

        assert(!vozlisce_l || ::HeapValidate(kopica_vozlisc, RSEZNAM_ZASTAVICE_KOPICE, vozlisce_l));
        assert(!vozlisce_d || ::HeapValidate(kopica_vozlisc, RSEZNAM_ZASTAVICE_KOPICE, vozlisce_d));

        if (vozlisce_l && vozlisce_l->zapisi.stevilo > N/2) {
            // Levi brat poddrevesa ima dovolj elementov. Odtujili mu bomo enega.
            vozlisce_x->zapisi.PremakniDesno(0);
            vozlisce_x->zapisi[0].element = vozlisce->zapisi[i].element;
            vozlisce_x->zapisi[0].nasl    = vozlisce_x->pred;
            vozlisce->zapisi[i].element   = vozlisce_l->zapisi[vozlisce_l->zapisi.stevilo - 1].element;
            vozlisce_x->pred              = vozlisce_l->zapisi[vozlisce_l->zapisi.stevilo - 1].nasl;
                                                               vozlisce_l->zapisi.stevilo--;
#ifdef _DEBUG
            memset(vozlisce_l->zapisi.podatki + vozlisce_l->zapisi.stevilo, 0xcd, sizeof(T_BVOZEL<TIP, N>::T_TABZAPISI::T_ZAPIS));
#endif
            verify(::HeapValidate(kopica_vozlisc, RSEZNAM_ZASTAVICE_KOPICE, vozlisce  ));
            verify(::HeapValidate(kopica_vozlisc, RSEZNAM_ZASTAVICE_KOPICE, vozlisce_x));
            verify(::HeapValidate(kopica_vozlisc, RSEZNAM_ZASTAVICE_KOPICE, vozlisce_l));
            return;
        }

        if (vozlisce_d && vozlisce_d->zapisi.stevilo > N/2) {
            // Desni brat poddrevesa ima dovolj elementov. Odtujili mu bomo enega.
                               vozlisce_x->zapisi.stevilo++;
            vozlisce_x->zapisi[vozlisce_x->zapisi.stevilo - 1].element = vozlisce->zapisi[i + 1].element;
            vozlisce_x->zapisi[vozlisce_x->zapisi.stevilo - 1].nasl    = vozlisce_d->pred;
            vozlisce->zapisi[i + 1].element                            = vozlisce_d->zapisi[0].element;
            vozlisce_d->pred                                           = vozlisce_d->zapisi[0].nasl;
            vozlisce_d->zapisi.PremakniLevo(0);
            verify(::HeapValidate(kopica_vozlisc, RSEZNAM_ZASTAVICE_KOPICE, vozlisce  ));
            verify(::HeapValidate(kopica_vozlisc, RSEZNAM_ZASTAVICE_KOPICE, vozlisce_x));
            verify(::HeapValidate(kopica_vozlisc, RSEZNAM_ZASTAVICE_KOPICE, vozlisce_l));
            return;
        }

        if (vozlisce_l && vozlisce_l->zapisi.stevilo <= N/2) {
            // Levi brat poddrevesa ima dovolj malo elementov, da ga lahko zdruimo s poddrevesom in nato uniimo poddrevo.
                               vozlisce_l->zapisi.stevilo++;
            vozlisce_l->zapisi[vozlisce_l->zapisi.stevilo - 1].element = vozlisce->zapisi[i].element;
            vozlisce_l->zapisi[vozlisce_l->zapisi.stevilo - 1].nasl    = vozlisce_x->pred;
            memcpy(vozlisce_l->zapisi.podatki + vozlisce_l->zapisi.stevilo, vozlisce_x->zapisi.podatki, vozlisce_x->zapisi.stevilo * sizeof(T_BVOZEL<TIP, N>::T_TABZAPISI::T_ZAPIS));
            vozlisce_l->zapisi.stevilo += vozlisce_x->zapisi.stevilo;
            vozlisce->zapisi.PremakniLevo(i);
            verify(    ::HeapFree(kopica_vozlisc, RSEZNAM_ZASTAVICE_KOPICE, vozlisce_x));
            verify(::HeapValidate(kopica_vozlisc, RSEZNAM_ZASTAVICE_KOPICE, vozlisce  ));
            verify(::HeapValidate(kopica_vozlisc, RSEZNAM_ZASTAVICE_KOPICE, vozlisce_l));
            return;
        }

        if (vozlisce_d && vozlisce_d->zapisi.stevilo <= N/2) {
            // Desni brat poddrevesa ima dovolj malo elementov, da ga lahko zdruimo s poddrevesom in nato uniimo poddrevo.
                               vozlisce_x->zapisi.stevilo++;
            vozlisce_x->zapisi[vozlisce_x->zapisi.stevilo - 1].element = vozlisce->zapisi[i + 1].element;
            vozlisce_x->zapisi[vozlisce_x->zapisi.stevilo - 1].nasl    = vozlisce_d->pred;
            memcpy(vozlisce_x->zapisi.podatki + vozlisce_x->zapisi.stevilo, vozlisce_d->zapisi.podatki, vozlisce_d->zapisi.stevilo * sizeof(T_BVOZEL<TIP, N>::T_TABZAPISI::T_ZAPIS));
            vozlisce_x->zapisi.stevilo += vozlisce_d->zapisi.stevilo;
            vozlisce->zapisi.PremakniLevo(i + 1);
            verify(    ::HeapFree(kopica_vozlisc, RSEZNAM_ZASTAVICE_KOPICE, vozlisce_d));
            verify(::HeapValidate(kopica_vozlisc, RSEZNAM_ZASTAVICE_KOPICE, vozlisce  ));
            verify(::HeapValidate(kopica_vozlisc, RSEZNAM_ZASTAVICE_KOPICE, vozlisce_x));
            return;
        }

        // Ne vemo, kako poenostaviti to vozlie.
        assert(0);
    }
}


//////////////////////////////////////////////////////////////////////
// RBDrevo
//////////////////////////////////////////////////////////////////////

template <class TIP, T_UINT N> RBDrevo<TIP, N>::RBDrevo() : RBIndeks<TIP, N>()
{
    // Ustvarimo kopico elementov.
    kopica_elementov = ::HeapCreate(RSEZNAM_ZASTAVICE_KOPICE, 0, 0);
    assert(kopica_elementov);
}


template <class TIP, T_UINT N> RBDrevo<TIP, N>::~RBDrevo()
{
    if (st_elementov)
        Unici();

    assert(!koren);
    assert(!st_elementov);

    assert(::HeapValidate(kopica_elementov, RSEZNAM_ZASTAVICE_KOPICE, NULL));
    verify(::HeapDestroy(kopica_elementov));
}


template <class TIP, T_UINT N> inline TIP* RBDrevo<TIP, N>::UstvariElement()
{
    T_VOZEL<TIP> *element = (T_VOZEL<TIP>*)::HeapAlloc(kopica_elementov, RSEZNAM_ZASTAVICE_KOPICE, sizeof(T_VOZEL<TIP>));
    assert(element);

    element->T_VOZEL<TIP>::T_VOZEL();
    assert(::HeapValidate(kopica_elementov, RSEZNAM_ZASTAVICE_KOPICE, element));
    return &(element->element);
}


template <class TIP, T_UINT N> inline T_VOID RBDrevo<TIP, N>::UniciElement(TIP *element)
{
    assert(element);
    assert(::HeapValidate(kopica_elementov, RSEZNAM_ZASTAVICE_KOPICE, element));

    element->TIP::~TIP();
    verify(::HeapFree(kopica_elementov, RSEZNAM_ZASTAVICE_KOPICE, element));
}


template <class TIP, T_UINT N> T_VOID RBDrevo<TIP, N>::UniciPoddrevo(T_BVOZEL<TIP, N> *vozlisce)
{
    assert(vozlisce);
    assert(::HeapValidate(kopica_vozlisc, RSEZNAM_ZASTAVICE_KOPICE, vozlisce));

    T_UINT i;

    if (vozlisce->pred) {
        // Izbriemo najbolj levo poddrevo.
        UniciPoddrevo(vozlisce->pred);
    }

    for (i = 0; i < vozlisce->zapisi.stevilo; i++) {
        assert(vozlisce->zapisi[i].element);
        assert(::HeapValidate(kopica_elementov, RSEZNAM_ZASTAVICE_KOPICE, vozlisce->zapisi[i].element));

        vozlisce->zapisi[i].element->TIP::~TIP();
        verify(::HeapFree(kopica_elementov, RSEZNAM_ZASTAVICE_KOPICE, vozlisce->zapisi[i].element));
#ifdef _DEBUG
        st_elementov--;
#endif

        if (vozlisce->zapisi[i].nasl) {
            // Izbriemo poddrevo.
            UniciPoddrevo(vozlisce->zapisi[i].nasl);
        }
    }

    verify(::HeapFree(kopica_vozlisc, RSEZNAM_ZASTAVICE_KOPICE, vozlisce));
}


//////////////////////////////////////////////////////////////////////
// RNizP
//////////////////////////////////////////////////////////////////////

template <class TIP> RNizP<TIP>::RNizP(T_UINT koliko) :
    RElement(),
    st_znakov(0),
    rez_znakov(0),
    podatki(NULL)
{
    verify(USPESNO(RezervirajDolzinoQ(koliko, RNIZ_TESNA_REZERVACIJA)));
    podatki[0] = (TIP)0;
}


template <class TIP> RNizP<TIP>::RNizP(TIP znak, T_UINT koliko) :
    RElement(),
    st_znakov(0),
    rez_znakov(0),
    podatki(NULL)
{
    Nastavi(znak, koliko);
}


template <class TIP> RNizP<TIP>::RNizP(const TIP *niz, T_UINT koliko) :
    RElement(),
    st_znakov(0),
    rez_znakov(0),
    podatki(NULL)
{
    Nastavi(niz, koliko);
}


template <class TIP> RNizP<TIP>::RNizP(const RNizP<TIP> &niz, T_UINT koliko) :
    RElement(),
    st_znakov(0),
    rez_znakov(0),
    podatki(NULL)
{
    Nastavi(niz, koliko);
}


template <class TIP> RNizP<TIP>::~RNizP()
{
    Sprosti();
}


template <class TIP> inline T_UINT RNizP<TIP>::VrniDolzino() const
{
    return st_znakov;
}


template <class TIP> inline T_BOOL RNizP<TIP>::JePrazen() const
{
    return st_znakov == 0;
}


template <class TIP> inline T_VOID RNizP<TIP>::Sprazni()
{
    assert(podatki);

    st_znakov = 0;
    podatki[0] = (TIP)0;
}


template <class TIP> inline TIP RNizP<TIP>::VrniZnak(T_UINT indeks) const
{
    assert(podatki);
    assert(indeks <= st_znakov);

    return podatki[indeks];
}


template <class TIP> inline T_VOID RNizP<TIP>::NastaviZnak(T_UINT indeks, TIP znak)
{
    assert(podatki);
    assert(indeks < st_znakov);
    assert(znak); // ne sme biti terminator

    podatki[indeks] = znak;
}


template <class TIP> inline const TIP* RNizP<TIP>::Vrni() const
{
    assert(podatki);

    return podatki;
}


template <class TIP> inline TIP* RNizP<TIP>::Odpusti(T_UINT min_dolzina, T_BOOL ustvari)
{
    assert(podatki);

    if (min_dolzina >= rez_znakov) verify(USPESNO(RezervirajDolzino(min_dolzina, RNIZ_TESNA_REZERVACIJA)));

    TIP *niz = podatki;

    // Pripravimo razred za nove podatke
    if (ustvari) {
        this->RNizP<TIP>::RNizP();
    } else {
        // Razveljavimo niz.
        podatki    = NULL;
        st_znakov  = 0;
        rez_znakov = 0;
    }

    return niz;
}


template <class TIP> inline T_UINT RNizP<TIP>::Uporabi(TIP *niz, T_UINT koliko, T_BOOL unici)
{
    assert(niz || !koliko);

    if (unici) {
        // Uniimo trenutne podatke in nastavimo nove.
        Sprosti();
    } else {
        assert(!podatki);
    }

    podatki = niz;
    if (podatki) {
        // Uporabimo nove namesto njih.
        st_znakov  = astrnlen(podatki, koliko);
        rez_znakov = amsize(podatki) / sizeof(TIP);
    } else {
        st_znakov  = 0;
        rez_znakov = 0;
        verify(USPESNO(RezervirajDolzinoQ(0, RNIZ_TESNA_REZERVACIJA)));
    }
    podatki[st_znakov] = (TIP)0;

    return st_znakov;
}


template <class TIP> inline T_VOID RNizP<TIP>::SprostiOdvecne()
{
    verify(USPESNO(RezervirajDolzino(st_znakov, TRUE)));
}


template <class TIP> inline T_INT RNizP<TIP>::Primerjaj(const TIP *niz, T_UINT zacetek, T_UINT koliko) const
{
    assert(niz);
    assert(podatki);
    assert(zacetek <= st_znakov);

    return astrncmp(podatki + zacetek, niz, koliko);
}


template <class TIP> inline T_INT RNizP<TIP>::PrimerjajI(const TIP *niz, T_UINT zacetek, T_UINT koliko) const
{
    assert(niz);
    assert(podatki);
    assert(zacetek <= st_znakov);

    return astrnicmp(podatki + zacetek, niz, koliko);
}


template <class TIP> inline T_INT RNizP<TIP>::PrimerjajL(const TIP *niz, T_UINT zacetek, T_UINT koliko, T_KODALOCALE locale) const
{
    assert(niz);
    assert(podatki);
    assert(zacetek <= st_znakov);

    return astrncoll(podatki + zacetek, niz, koliko, locale);
}


template <class TIP> inline T_INT RNizP<TIP>::PrimerjajLI(const TIP *niz, T_UINT zacetek, T_UINT koliko, T_KODALOCALE locale) const
{
    assert(niz);
    assert(podatki);
    assert(zacetek <= st_znakov);

    return astrnicoll(podatki + zacetek, niz, koliko, locale);
}


template <class TIP> inline T_VOID RNizP<TIP>::Prezrcali()
{
    assert(podatki);

    TIP c;

    if (st_znakov) {
        register T_UINT i, j;

        for (i = 0, j = st_znakov - 1; i < j; i++, j--) {
            c = podatki[i];
            podatki[i] = podatki[j];
            podatki[j] = c;
        }
    }
}


template <class TIP> inline T_UINT RNizP<TIP>::Zamenjaj(TIP iz, TIP v)
{
    assert(podatki);

    register T_UINT i;
    T_UINT c = 0;

    for (i = 0; podatki[i]; i++) {
        if (podatki[i] == iz)
            podatki[i] = v, c++;
    }

    return c;
}


template <class TIP> inline T_UINT RNizP<TIP>::ZamenjajI(TIP iz, TIP v)
{
    assert(podatki);

    register T_UINT i;
    T_UINT c = 0;
    TIP _iz = atolower(iz);

    for (i = 0; podatki[i]; i++)
        if (atolower(podatki[i]) == _iz)
            podatki[i] = v, c++;

    return c;
}


template <class TIP> inline T_UINT RNizP<TIP>::Zamenjaj(const TIP *iz, const TIP *v)
{
    assert(podatki);
    assert(iz);
    assert(v);

    T_UINT
        c = 0,           // stevilo ujemanj
        m = astrlen(iz), // dolzina niza 'iz'
        n = astrlen(v);  // dolzina niza 'v'

    T_UINT
        i,  // odmik izvornega znaka v delovnem nizu
        ii, // koncni odmik znaka
        j,  // odmik znaka v nizu 'iz', kasneje odmik v nizu 'v', spet
            // kasneje stevilo mest, ki smo jih od konca ze prekopirali
        jj; // odmik izvornega znaka v delovnem nizu, ko ga primerjamo z nizom 'iz'

    // ce je niz, ki ga iscemo prazen niz, privzamemo, da ga nismo nasli,
    // sicer se bomo v nadaljevanju zaciklali
    if (!m) return 0;

    // ali se bo niz daljsal, ali krajsal?
    if (m>=n) {
        for (i=0,ii=0; podatki[i];) {
            // poiscemo, do kam se niza ujemata
            for (j=0,jj=i; iz[j] && iz[j]==podatki[jj]; j++, jj++);

            // ali smo dobili popolno ujemanje?
            if (iz[j]==0) {
                for (j=0; v[j]; j++, ii++)
                    podatki[ii] = v[j];
                i += m, c++;
            } else
                podatki[ii++] = podatki[i++];
        }
        podatki[st_znakov = ii] = (TIP)0;
    } else {
        // najprej poiscemo, koliko ujemanj se bo pojavilo med postopkom,
        // da za ustrezno mest povecamo pomnilnik
        for (i=0,ii=0; podatki[i];) {
            for (j=0,jj=i; iz[j] && iz[j]==podatki[jj]; j++, jj++);

            if (iz[j]==0)
                ii += n, i += m, c++;
            else
                ii++, i++;
        }

        // ali sploh imamo kje ujemanje
        if (c) {
            T_BOOL ujemanje;

            // zapomnimo si konec niza
            i = st_znakov;

            // rezerviramo dovolj pomnilnika
            verify(USPESNO(RezervirajDolzino(st_znakov += c*(n-m))));
            podatki[st_znakov] = (TIP)0;

            // zacnemo zadaj in se pomikamo proti zacetku, dokler ii ne ujame i-ja
            for (ii = st_znakov; i<ii;) {
                // poiscemo, do kam se niza ujemata
                ujemanje = TRUE;
                for (j = m, jj = i; j;)
                    if (iz[--j]!=podatki[--jj]) {
                        ujemanje = FALSE;
                        break;
                    }

                // ali smo dobili popolno ujemanje?
                if (ujemanje) {
                    for (j = n; j;)
                        podatki[--ii] = v[--j];
                    i -= m;
                } else
                    podatki[--ii] = podatki[--i];
            }
        }
    }

    return c;
}


template <class TIP> inline T_UINT RNizP<TIP>::ZamenjajI(const TIP *iz, const TIP *v)
{
    assert(podatki);
    assert(iz);
    assert(v);

    T_UINT
        c = 0,           // stevilo ujemanj
        m = astrlen(iz), // dolzina niza 'iz'
        n = astrlen(v);  // dolzina niza 'v'

    T_UINT
        i,  // odmik izvornega znaka v delovnem nizu
        ii, // koncni odmik znaka
        j,  // odmik znaka v nizu 'iz', kasneje odmik v nizu 'v', spet
            // kasneje stevilo mest, ki smo jih od konca ze prekopirali
        jj; // odmik izvornega znaka v delovnem nizu, ko ga primerjamo z nizom 'iz'

    // ce je niz, ki ga iscemo prazen niz, privzamemo, da ga nismo nasli,
    // sicer se bomo v nadaljevanju zaciklali
    if (!m) return 0;

    // ali se bo niz daljsal, ali krajsal?
    if (m>=n) {
        for (i=0,ii=0; podatki[i];) {
            // poiscemo, do kam se niza ujemata
            for (j=0,jj=i; iz[j] && atolower(iz[j])==atolower(podatki[jj]); j++, jj++);

            // ali smo dobili popolno ujemanje?
            if (iz[j]==0) {
                for (j=0; v[j]; j++, ii++)
                    podatki[ii] = v[j];
                i += m, c++;
            } else
                podatki[ii++] = podatki[i++];
        }
        podatki[st_znakov = ii] = (TIP)0;
    } else {
        // najprej poiscemo, koliko ujemanj se bo pojavilo med postopkom,
        // da za ustrezno mest povecamo pomnilnik
        for (i=0,ii=0; podatki[i];) {
            for (j=0,jj=i; iz[j] && atolower(iz[j])==atolower(podatki[jj]); j++, jj++);

            if (iz[j]==0)
                ii += n, i += m, c++;
            else
                ii++, i++;
        }

        // ali sploh imamo kje ujemanje
        if (c) {
            T_BOOL ujemanje;

            // zapomnimo si konec niza
            i = st_znakov;

            // rezerviramo dovolj pomnilnika
            verify(USPESNO(RezervirajDolzino(st_znakov += c*(n-m))));
            podatki[st_znakov] = (TIP)0;

            // zacnemo zadaj in se pomikamo proti zacetku, dokler ii ne ujame i-ja
            for (ii = st_znakov; i<ii;) {
                // poiscemo, do kam se niza ujemata
                ujemanje = TRUE;
                for (j = m, jj = i; j;)
                    if (atolower(iz[--j])!=atolower(podatki[--jj])) {
                        ujemanje = FALSE;
                        break;
                    }

                // ali smo dobili popolno ujemanje?
                if (ujemanje) {
                    for (j = n; j;)
                        podatki[--ii] = v[--j];
                    i -= m;
                } else
                    podatki[--ii] = podatki[--i];
            }
        }
    }

    return c;
}


template <class TIP> inline T_UINT RNizP<TIP>::Zamenjaj(T_UINT zacetek, T_UINT konec, const TIP *niz, T_UINT koliko)
{
    assert(podatki);
    assert(zacetek <= st_znakov);
    assert(konec <= st_znakov);
    assert(zacetek <= konec);
    assert(niz || !koliko);

    T_UINT
        i, ii = st_znakov;

    st_znakov -= konec - zacetek;
    st_znakov += koliko = astrnlen(niz, koliko);
    if (st_znakov >= rez_znakov) verify(USPESNO(RezervirajDolzino(st_znakov)));

    if (ii < st_znakov) {
        // Niz se bo podaljal.
        assert(0); // TODO: Preizkusi ta del kode.
        podatki[st_znakov] = (TIP)0;
        for (i = st_znakov; ii > konec; )
            podatki[--i] = podatki[--ii];
    } else if (st_znakov < ii) {
        // Niz se bo skrajal.
        assert(0); // TODO: Preizkusi ta del kode.
        for (i = zacetek + koliko, ii = konec; i < st_znakov; i++, ii++)
            podatki[i] = podatki[ii];
        podatki[st_znakov] = (TIP)0;
    }

    astrncpy2(podatki + zacetek, koliko, niz, koliko);

    return st_znakov;
}


template <class TIP> inline T_UINT RNizP<TIP>::Odstrani(TIP znak)
{
    assert(podatki);

    T_UINT i, ii, c = 0;

    for (i = 0, ii = 0; podatki[i]; i++)
        if (podatki[i] != znak)
            podatki[ii++] = podatki[i];
        else
            c++;

    podatki[st_znakov = ii] = (TIP)0;

    return c;
}


template <class TIP> inline T_UINT RNizP<TIP>::OdstraniI(TIP znak)
{
    assert(podatki);

    T_UINT i, ii, c = 0;
    TIP _znak = atolower(znak);

    for (i = 0, ii = 0; podatki[i]; i++)
        if (atolower(podatki[i]) != _znak)
            podatki[ii++] = podatki[i];
        else
            c++;

    podatki[st_znakov = ii] = (TIP)0;

    return c;
}


template <class TIP> inline T_UINT RNizP<TIP>::Vstavi(T_UINT zacetek, TIP znak, T_UINT koliko)
{
    assert(podatki);
    assert(zacetek <= st_znakov);

    T_UINT
        i, ii = st_znakov;

    st_znakov += koliko;
    if (st_znakov >= rez_znakov) verify(USPESNO(RezervirajDolzino(st_znakov)));

    podatki[st_znakov] = (TIP)0;
    for (i = st_znakov; ii > zacetek; )
        podatki[--i] = podatki[--ii];

    for (; ii < i; ii++)
        podatki[ii] = znak;

    return st_znakov;
}


template <class TIP> inline T_UINT RNizP<TIP>::Vstavi(T_UINT zacetek, const TIP *niz, T_UINT koliko)
{
    assert(podatki);
    assert(zacetek <= st_znakov);
    assert(niz || !koliko);

    T_UINT
        i, ii = st_znakov;

    st_znakov += koliko = astrnlen(niz, koliko);
    if (st_znakov >= rez_znakov) verify(USPESNO(RezervirajDolzino(st_znakov)));

    podatki[st_znakov] = (TIP)0;
    for (i = st_znakov; ii > zacetek; )
        podatki[--i] = podatki[--ii];

    astrncpy2(podatki + zacetek, koliko, niz, koliko);

    return st_znakov;
}


template <class TIP> inline T_UINT RNizP<TIP>::Zbrisi(T_UINT zacetek, T_UINT koliko)
{
    assert(podatki);
    assert(zacetek <= st_znakov);

    if (zacetek + koliko < st_znakov) {
        st_znakov -= koliko;
        memcpy(podatki + zacetek, podatki + zacetek + koliko, (st_znakov - zacetek)*sizeof(TIP));
        podatki[st_znakov] = (TIP)0;
    } else
        podatki[st_znakov = zacetek] = (TIP)0;

    return st_znakov;
}


template <class TIP> inline T_UINT RNizP<TIP>::PoravnajLevo(TIP znak)
{
    assert(0); // TODO: Preizkusi ta del kode.
    assert(podatki);

    register T_UINT i;

    for (i = 0; podatki[i] == znak; i++);
    if (i) {
        st_znakov -= i;
        memcpy(podatki, podatki + i, st_znakov*sizeof(TIP));
        podatki[st_znakov] = (TIP)0;
    }
    return st_znakov;
}


template <class TIP> inline T_UINT RNizP<TIP>::PoravnajLevo(const TIP *znaki)
{
    assert(0); // TODO: Preizkusi ta del kode.
    assert(podatki);
    assert(znaki);

    register T_UINT i;

    for (i = 0; astrchr<TIP>(znaki, podatki[i]); i++);
    if (i) {
        st_znakov -= i;
        memcpy(podatki, podatki + i, st_znakov*sizeof(TIP));
        podatki[st_znakov] = (TIP)0;
    }
    return st_znakov;
}


template <class TIP> inline T_UINT RNizP<TIP>::PoravnajDesno(TIP znak)
{
    assert(podatki);

    register T_UINT i;

    for (i = st_znakov; i && podatki[--i]==znak; )
        st_znakov = i;

    podatki[st_znakov] = (TIP)0;
    return st_znakov;
}


template <class TIP> inline T_UINT RNizP<TIP>::PoravnajDesno(const TIP *znaki)
{
    assert(podatki);
    assert(znaki);

    register T_UINT i;

    for (i = st_znakov; i && astrchr<TIP>(znaki, podatki[--i]); )
        st_znakov = i;

    podatki[st_znakov] = (TIP)0;
    return st_znakov;
}


template <class TIP> inline T_UINT RNizP<TIP>::Poravnaj(TIP znak)
{
    PoravnajDesno(znak);
    PoravnajLevo(znak);

    return st_znakov;
}


template <class TIP> inline T_UINT RNizP<TIP>::Poravnaj(const TIP *znaki)
{
    PoravnajDesno(znaki);
    PoravnajLevo(znaki);

    return st_znakov;
}


template <class TIP> inline T_UINT RNizP<TIP>::Skrajsaj(T_UINT dolzina)
{
    assert(podatki);
    assert(dolzina <= st_znakov);

    podatki[st_znakov = dolzina] = (TIP)0;
#ifndef AOSN_HITROST_POMEMBNEJSA_OD_POMNILNIKA_VER
    // Sprostimo odvene znake.
    verify(USPESNO(RezervirajDolzino(st_znakov, TRUE)));
#endif
    return st_znakov;
}


template <class TIP> inline T_UINT RNizP<TIP>::Najdi(TIP znak, T_UINT zacetek, T_UINT koliko) const
{
    assert(podatki);

    if (zacetek < st_znakov) {
        koliko = amin(st_znakov - zacetek, koliko);
        TIP *zadetek = astrnchr(podatki + zacetek, znak, koliko);
        return zadetek ? zadetek - podatki : RNIZ_NEVELJAVEN_INDEKS;
    } else
        return RNIZ_NEVELJAVEN_INDEKS;
}


template <class TIP> inline T_UINT RNizP<TIP>::Najdi(const TIP *niz, T_UINT zacetek, T_UINT koliko) const
{
    assert(podatki);

    if (zacetek < st_znakov) {
        koliko = amin(st_znakov - zacetek, koliko);
        TIP *zadetek = astrnstr(podatki + zacetek, niz, koliko);
        return zadetek ? zadetek - podatki : RNIZ_NEVELJAVEN_INDEKS;
    } else
        return RNIZ_NEVELJAVEN_INDEKS;
}


template <class TIP> inline T_UINT RNizP<TIP>::NajdiI(TIP znak, T_UINT zacetek, T_UINT koliko) const
{
    assert(podatki);

    if (zacetek < st_znakov) {
        koliko = amin(st_znakov - zacetek, koliko);
        TIP *zadetek = astrnichr(podatki + zacetek, znak, koliko);
        return zadetek ? zadetek - podatki : RNIZ_NEVELJAVEN_INDEKS;
    } else
        return RNIZ_NEVELJAVEN_INDEKS;
}


template <class TIP> inline T_UINT RNizP<TIP>::NajdiI(const TIP *niz, T_UINT zacetek, T_UINT koliko) const
{
    assert(podatki);

    if (zacetek < st_znakov) {
        koliko = amin(st_znakov - zacetek, koliko);
        TIP *zadetek = astrnistr(podatki + zacetek, niz, koliko);
        return zadetek ? zadetek - podatki : RNIZ_NEVELJAVEN_INDEKS;
    } else
        return RNIZ_NEVELJAVEN_INDEKS;
}


template <class TIP> inline T_UINT RNizP<TIP>::NajdiNazaj(TIP znak, T_UINT zacetek, T_UINT koliko) const
{
    assert(podatki);

    if (zacetek < st_znakov) {
        koliko = amin(st_znakov - zacetek, koliko);
        TIP *zadetek = astrrnchr(podatki + zacetek, znak, koliko);
        return zadetek ? zadetek - podatki : RNIZ_NEVELJAVEN_INDEKS;
    } else
        return RNIZ_NEVELJAVEN_INDEKS;
}


template <class TIP> inline T_UINT RNizP<TIP>::NajdiNazaj(const TIP *niz, T_UINT zacetek, T_UINT koliko) const
{
    assert(podatki);

    if (zacetek < st_znakov) {
        koliko = amin(st_znakov - zacetek, koliko);
        TIP *zadetek = astrrnstr(podatki + zacetek, niz, koliko);
        return zadetek ? zadetek - podatki : RNIZ_NEVELJAVEN_INDEKS;
    } else
        return RNIZ_NEVELJAVEN_INDEKS;
}


template <class TIP> inline T_UINT RNizP<TIP>::NajdiNazajI(TIP znak, T_UINT zacetek, T_UINT koliko) const
{
    assert(podatki);

    if (zacetek < st_znakov) {
        koliko = amin(st_znakov - zacetek, koliko);
        TIP *zadetek = astrrnichr(podatki + zacetek, znak, koliko);
        return zadetek ? zadetek - podatki : RNIZ_NEVELJAVEN_INDEKS;
    } else
        return RNIZ_NEVELJAVEN_INDEKS;
}


template <class TIP> inline T_UINT RNizP<TIP>::NajdiNazajI(const TIP *niz, T_UINT zacetek, T_UINT koliko) const
{
    assert(podatki);

    if (zacetek < st_znakov) {
        koliko = amin(st_znakov - zacetek, koliko);
        TIP *zadetek = astrrnistr(podatki + zacetek, niz, koliko);
        return zadetek ? zadetek - podatki : RNIZ_NEVELJAVEN_INDEKS;
    } else
        return RNIZ_NEVELJAVEN_INDEKS;
}


template <class TIP> T_STANJE RNizP<TIP>::RezervirajDolzino(T_UINT zeljeno, T_BOOL tesno)
{
    if (tesno || zeljeno >= rez_znakov) {
        // Ponovno rezerviramo le, kadar to izrecno elimo (tesno), ali pa je protrebno podaljati dolino.
        rez_znakov = tesno ? zeljeno + 1 : ((zeljeno + RNIZ_KORAK_POVECEVANJA) / RNIZ_KORAK_POVECEVANJA) * RNIZ_KORAK_POVECEVANJA;
        assert(rez_znakov > zeljeno);
        podatki = (TIP*)arealloc(podatki, rez_znakov * sizeof(TIP));
        assert(podatki || !rez_znakov);
    }

    // e smo niz skrajali, popravimo tudi tevilo znakov in uredimo zakljuitev.
    if (rez_znakov <= st_znakov) {
        st_znakov = rez_znakov - 1;
        podatki[st_znakov] = (TIP)0;
    }

    return A_OK;
}


template <class TIP> T_STANJE RNizP<TIP>::RezervirajDolzinoQ(T_UINT zeljeno, T_BOOL tesno)
{
    if (tesno || zeljeno >= rez_znakov) {
        // Ponovno rezerviramo le, kadar to izrecno elimo (tesno), ali pa je protrebno podaljati dolino.
        rez_znakov = tesno ? zeljeno + 1 : ((zeljeno + RNIZ_KORAK_POVECEVANJA) / RNIZ_KORAK_POVECEVANJA) * RNIZ_KORAK_POVECEVANJA;
        assert(rez_znakov > zeljeno);
        podatki = (TIP*)aqrealloc(podatki, rez_znakov * sizeof(TIP), FALSE);
        assert(podatki || !rez_znakov);
    }

    return A_OK;
}


template <class TIP> T_VOID RNizP<TIP>::Sprosti()
{
    assert(podatki);
    afree(podatki);
}


template <class TIP> inline TIP& RNizP<TIP>::operator [](T_UINT indeks)
{
    assert(podatki);
    assert(indeks <= st_znakov);

    return podatki[indeks];
}


template <class TIP> inline TIP& RNizP<TIP>::operator [](int indeks)
{
    assert(podatki);
    assert((T_UINT)indeks <= st_znakov);

    return podatki[indeks];
}


template <class TIP> inline RNizP<TIP>::operator const TIP*() const
{
    assert(podatki);
    return podatki;
}


template <class TIP> inline T_BOOL operator ==(const RNizP<TIP> &niz1, const RNizP<TIP> &niz2)
{
    return niz1.Primerjaj(niz2)==0;
}


template <class TIP> inline T_BOOL operator ==(const RNizP<TIP> &niz1, const TIP *niz2)
{
    return niz1.Primerjaj(niz2)==0;
}


template <class TIP> inline T_BOOL operator ==(const TIP *niz1, const RNizP<TIP> &niz2)
{
    return niz2.Primerjaj(niz1)==0;
}


template <class TIP> inline T_BOOL operator !=(const RNizP<TIP> &niz1, const RNizP<TIP> &niz2)
{
    return niz1.Primerjaj(niz2)!=0;
}


template <class TIP> inline T_BOOL operator !=(const RNizP<TIP> &niz1, const TIP *niz2)
{
    return niz1.Primerjaj(niz2)!=0;
}


template <class TIP> inline T_BOOL operator !=(const TIP *niz1, const RNizP<TIP> &niz2)
{
    return niz2.Primerjaj(niz1)!=0;
}


template <class TIP> inline T_BOOL operator >(const RNizP<TIP> &niz1, const RNizP<TIP> &niz2)
{
    return niz1.Primerjaj(niz2)>0;
}


template <class TIP> inline T_BOOL operator >(const RNizP<TIP> &niz1, const TIP *niz2)
{
    return niz1.Primerjaj(niz2)>0;
}


template <class TIP> inline T_BOOL operator >(const TIP *niz1, const RNizP<TIP> &niz2)
{
    return niz2.Primerjaj(niz1)<=0;
}


template <class TIP> inline T_BOOL operator >=(const RNizP<TIP> &niz1, const RNizP<TIP> &niz2)
{
    return niz1.Primerjaj(niz2)>=0;
}


template <class TIP> inline T_BOOL operator >=(const RNizP<TIP> &niz1, const TIP *niz2)
{
    return niz1.Primerjaj(niz2)>=0;
}


template <class TIP> inline T_BOOL operator >=(const TIP *niz1, const RNizP<TIP> &niz2)
{
    return niz2.Primerjaj(niz1)<0;
}


template <class TIP> inline T_BOOL operator <(const RNizP<TIP> &niz1, const RNizP<TIP> &niz2)
{
    return niz1.Primerjaj(niz2)<0;
}


template <class TIP> inline T_BOOL operator <(const RNizP<TIP> &niz1, const TIP *niz2)
{
    return niz1.Primerjaj(niz2)<0;
}


template <class TIP> inline T_BOOL operator <(const TIP *niz1, const RNizP<TIP> &niz2)
{
    return niz2.Primerjaj(niz1)>=0;
}


template <class TIP> inline T_BOOL operator <=(const RNizP<TIP> &niz1, const RNizP<TIP> &niz2)
{
    return niz1.Primerjaj(niz2)<=0;
}


template <class TIP> inline T_BOOL operator <=(const RNizP<TIP> &niz1, const TIP *niz2)
{
    return niz1.Primerjaj(niz2)<=0;
}


template <class TIP> inline T_BOOL operator <=(const TIP *niz1, const RNizP<TIP> &niz2)
{
    return niz2.Primerjaj(niz1)>0;
}


inline VARIANT& operator <<(VARIANT &p, const RNizP<T_AZNAK> &dat)
{
    T_UINT dolzina = dat.VrniDolzino();

    V_VT(&p) = VT_BSTR;
    V_BSTR(&p) = ::SysAllocStringLen(NULL, (UINT)dolzina);
    astrncpy2(V_BSTR(&p), dolzina, dat.Vrni(), dolzina);
    V_BSTR(&p)[dolzina] = 0;
    return *(&p + 1);
}


inline VARIANT& operator <<(VARIANT &p, const RNizP<T_UZNAK> &dat)
{
    V_VT(&p) = VT_BSTR;
    V_BSTR(&p) = ::SysAllocStringLen(dat.Vrni(), (UINT)dat.VrniDolzino());
    return *(&p + 1);
}


//////////////////////////////////////////////////////////////////////
// RNizNP
//////////////////////////////////////////////////////////////////////

template <class TIP> RNizNP<TIP>::RNizNP(T_UINT koliko) : RNizP<TIP>(koliko)
{
}


template <class TIP> RNizNP<TIP>::RNizNP(TIP element, T_UINT koliko) : RNizP<TIP>(element, koliko)
{
}


template <class TIP> RNizNP<TIP>::RNizNP(const TIP *niz, T_UINT koliko) : RNizP<TIP>(niz, koliko)
{
}


template <class TIP> RNizNP<TIP>::RNizNP(const RNizP<TIP> &niz, T_UINT koliko) : RNizP<TIP>(niz, koliko)
{
}


template <class TIP> inline T_VOID RNizNP<TIP>::VVelike()
{
    assert(podatki);
    astrupr(podatki);
}


template <class TIP> inline T_VOID RNizNP<TIP>::VMale()
{
    assert(podatki);
    astrlwr(podatki);
}


template <class TIP> inline T_UINT RNizNP<TIP>::PoravnajLevo()
{
    assert(podatki);

    register T_UINT i;

    for (i = 0; aisspace(podatki[i]); i++);
    if (i) {
        st_znakov -= i;
        memcpy(podatki, podatki + i, st_znakov*sizeof(TIP));
        podatki[st_znakov] = (TIP)0;
    }
    return st_znakov;
}


template <class TIP> inline T_UINT RNizNP<TIP>::PoravnajDesno()
{
    assert(podatki);

    register T_UINT i;

    for (i = st_znakov; i && aisspace(podatki[--i]); )
        st_znakov = i;

    podatki[st_znakov] = (TIP)0;
    return st_znakov;
}


template <class TIP> inline T_UINT RNizNP<TIP>::Poravnaj()
{
    PoravnajDesno();
    PoravnajLevo();

    return st_znakov;
}


//////////////////////////////////////////////////////////////////////
// RNizOP
//////////////////////////////////////////////////////////////////////

template <class TIP> RNizOP<TIP>::RNizOP(T_UINT koliko) : RNizNP<TIP>(koliko)
{
}


template <class TIP> RNizOP<TIP>::RNizOP(TIP element, T_UINT koliko) : RNizNP<TIP>(element, koliko)
{
}


template <class TIP> RNizOP<TIP>::RNizOP(const TIP *niz, T_UINT koliko) : RNizNP<TIP>(niz, koliko)
{
}


template <class TIP> RNizOP<TIP>::RNizOP(const RNizP<TIP> &niz, T_UINT koliko) : RNizNP<TIP>(niz, koliko)
{
}


template <class TIP> inline T_UINT RNizOP<TIP>::Oblikuj(const TIP *oblika, T_LOCALE locale, ...)
{
    va_list parametri;

    va_start(parametri, locale);
    OblikujP(oblika, locale, parametri);
    va_end(parametri);

    return st_znakov;
}


template <class TIP> inline T_UINT RNizOP<TIP>::OblikujP(const TIP *oblika, T_LOCALE locale, va_list parametri)
{
    assert(podatki);
    assert(oblika);

    T_INT st_znakov_nov;

    for (;;) {
        st_znakov_nov = avsnprintf(podatki, rez_znakov - 1, oblika, locale, parametri);
        if (st_znakov_nov < 0) {
            // Poveamo prostor v pomnilniku.
            verify(USPESNO(RezervirajDolzinoQ(rez_znakov - 1 + RNIZ_KORAK_POVECEVANJA)));
        } else {
            st_znakov = (T_UINT)st_znakov_nov;
            podatki[st_znakov] = (TIP)0;
#ifndef AOSN_HITROST_POMEMBNEJSA_OD_POMNILNIKA_VER
            // Sprostimo odvene znake.
            verify(USPESNO(RezervirajDolzinoQ(st_znakov, TRUE)));
#endif
            break;
        }
    }

    return st_znakov;
}


template <class TIP> RNizOP<TIP> RNizOP<TIP>::OblikujS(const TIP *oblika, T_LOCALE locale, ...)
{
    va_list parametri;

    va_start(parametri, locale);
    RNizOP<TIP> niz = OblikujSP(oblika, locale, parametri);
    va_end(parametri);

    return niz;
}


template <class TIP> inline RNizOP<TIP> RNizOP<TIP>::OblikujSP(const TIP *oblika, T_LOCALE locale, va_list parametri)
{
    RNizOP<TIP> niz;
    niz.OblikujP(oblika, locale, parametri);
    return niz;
}


template <class TIP> inline T_UINT RNizOP<TIP>::PrilepiO(const TIP *oblika, T_LOCALE locale, ...)
{
    va_list parametri;

    va_start(parametri, locale);
    PrilepiOP(oblika, locale, parametri);
    va_end(parametri);

    return st_znakov;
}


template <class TIP> inline T_UINT RNizOP<TIP>::PrilepiOP(const TIP *oblika, T_LOCALE locale, va_list parametri)
{
    assert(podatki);
    assert(oblika);

    T_INT st_znakov_nov;

    for (;;) {
        st_znakov_nov = avsnprintf(podatki + st_znakov, rez_znakov - 1 - st_znakov, oblika, locale, parametri);
        if (st_znakov_nov < 0) {
            // Poveamo prostor v pomnilniku.
            verify(USPESNO(RezervirajDolzino(rez_znakov - 1 + RNIZ_KORAK_POVECEVANJA)));
        } else {
            st_znakov += (T_UINT)st_znakov_nov;
            podatki[st_znakov] = (TIP)0;
#ifndef AOSN_HITROST_POMEMBNEJSA_OD_POMNILNIKA_VER
            // Sprostimo odvene znake.
            verify(USPESNO(RezervirajDolzino(st_znakov, TRUE)));
#endif
            break;
        }
    }

    return st_znakov;
}


#ifndef _DLL

template <class TIP> inline T_UINT RNizOP<TIP>::Razcleni(const TIP *oblika, T_LOCALE locale, ...) const
{
    va_list parametri;

    va_start(parametri, locale);
    RazcleniP(oblika, locale, parametri);
    va_end(parametri);

    return st_znakov;
}


template <class TIP> inline T_UINT RNizOP<TIP>::RazcleniP(const TIP *oblika, T_LOCALE locale, va_list parametri) const
{
    assert(podatki);
    assert(oblika);

    FILE str;
    T_INT rez;

    str._flag = _IOREAD|_IOSTRG|_IOMYBUF;
    str._ptr = str._base = (char *)podatki;
    str._cnt = (int)st_znakov;

    rez = ainput(&str, oblika, locale, parametri);
    return rez != EOF ? rez : 0;
}


template <class TIP> inline T_UINT RNizOP<TIP>::RazcleniOd(const TIP *oblika, T_UINT zacetek, T_LOCALE locale, ...) const
{
    va_list parametri;

    va_start(parametri, locale);
    RazcleniOdP(oblika, zacetek, locale, parametri);
    va_end(parametri);

    return st_znakov;
}


template <class TIP> inline T_UINT RNizOP<TIP>::RazcleniOdP(const TIP *oblika, T_UINT zacetek, T_LOCALE locale, va_list parametri) const
{
    assert(zacetek < st_znakov);
    assert(podatki);
    assert(oblika);

    FILE str;
    T_INT rez;

    str._flag = _IOREAD|_IOSTRG|_IOMYBUF;
    str._ptr = str._base = (char *)(podatki + zacetek);
    str._cnt = (int)(st_znakov - zacetek);

    rez = ainput(&str, oblika, locale, parametri);
    return rez != EOF ? rez : 0;
}

#endif


//////////////////////////////////////////////////////////////////////
// RNizVP
//////////////////////////////////////////////////////////////////////

template <class TIP> RNizVP<TIP>::RNizVP(T_UINT koliko) : RNizOP<TIP>(koliko)
{
}


template <class TIP> RNizVP<TIP>::RNizVP(TIP znak, T_UINT koliko) : RNizOP<TIP>(znak, koliko)
{
}


template <class TIP> RNizVP<TIP>::RNizVP(const TIP *niz, T_UINT koliko) : RNizOP<TIP>(niz, koliko)
{
}


template <class TIP> RNizVP<TIP>::RNizVP(const RNizP<TIP> &niz, T_UINT koliko) : RNizOP<TIP>(niz, koliko)
{
}


template <class TIP> RNizVP<TIP>::RNizVP(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik) : RNizOP<TIP>()
{
    NastaviV(modul, koda, jezik);
}


inline T_UINT RNizVP<T_AZNAK>::NastaviV(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik)
{
    TK_UNICODE niz;
    T_UINT koliko = aloadstring(modul, koda, &niz, jezik);

    st_znakov = astrnlen(niz, koliko, AOSN_PRIVZETI_CP);
    if (st_znakov >= rez_znakov) verify(USPESNO(RezervirajDolzinoQ(st_znakov, RNIZ_TESNA_REZERVACIJA)));
    verify(astrncpy2(podatki, st_znakov, niz, koliko, AOSN_PRIVZETI_CP) == st_znakov);
    podatki[st_znakov] = (T_AZNAK)0;
    return st_znakov;
}


inline T_UINT RNizVP<T_UZNAK>::NastaviV(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik)
{
    TK_UNICODE niz;

    st_znakov = aloadstring(modul, koda, &niz, jezik);
    if (st_znakov >= rez_znakov) verify(USPESNO(RezervirajDolzinoQ(st_znakov, RNIZ_TESNA_REZERVACIJA)));
    memcpy(podatki, niz, st_znakov*sizeof(T_UZNAK));
    podatki[st_znakov] = (T_UZNAK)0;
    return st_znakov;
}


inline T_UINT RNizVP<T_AZNAK>::PrilepiV(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik)
{
    TK_UNICODE niz;
    T_UINT zacetek = st_znakov, koliko = aloadstring(modul, koda, &niz, jezik), koliko2;

    st_znakov += koliko2 = astrnlen(niz, koliko, AOSN_PRIVZETI_CP);
    if (st_znakov >= rez_znakov) verify(USPESNO(RezervirajDolzino(st_znakov)));
    verify(astrncpy2(podatki + zacetek, koliko2, niz, koliko, AOSN_PRIVZETI_CP) == koliko2);
    podatki[st_znakov] = (T_AZNAK)0;
    return st_znakov;
}


inline T_UINT RNizVP<T_UZNAK>::PrilepiV(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik)
{
    TK_UNICODE niz;
    T_UINT zacetek = st_znakov, koliko;

    st_znakov += koliko = aloadstring(modul, koda, &niz, jezik);
    if (st_znakov >= rez_znakov) verify(USPESNO(RezervirajDolzino(st_znakov)));
    memcpy(podatki + zacetek, niz, koliko*sizeof(T_UZNAK));
    podatki[st_znakov] = (T_UZNAK)0;
    return st_znakov;
}


template <class TIP> inline T_UINT RNizVP<TIP>::OblikujV(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_LOCALE locale, ...)
{
    va_list parametri;

    va_start(parametri, locale);
    OblikujVP(modul, koda, jezik, locale, parametri);
    va_end(parametri);

    return st_znakov;
}


template <class TIP> inline T_UINT RNizVP<TIP>::OblikujVP(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_LOCALE locale, va_list parametri)
{
    return OblikujP(RNizVP<TIP>(modul, koda, jezik), locale, parametri);
}


template <class TIP> inline RNizVP<TIP> RNizVP<TIP>::OblikujVS(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_LOCALE locale, ...)
{
    RNizVP<TIP> niz;
    va_list parametri;

    va_start(parametri, locale);
    niz.OblikujVP(modul, koda, jezik, locale, parametri);
    va_end(parametri);

    return niz;
}


template <class TIP> inline RNizVP<TIP> RNizVP<TIP>::OblikujVSP(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_LOCALE locale, va_list parametri)
{
    RNizVP<TIP> niz;
    niz.OblikujVP(modul, koda, jezik, locale, parametri);
    return niz;
}


template <class TIP> inline T_UINT RNizVP<TIP>::PrilepiVO(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_LOCALE locale, ...)
{
    va_list parametri;

    va_start(parametri, locale);
    PrilepiVOP(modul, koda, jezik, locale, parametri);
    va_end(parametri);

    return st_znakov;
}


template <class TIP> inline T_UINT RNizVP<TIP>::PrilepiVOP(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_LOCALE locale, va_list parametri)
{
    return PrilepiOP(RNizVP<TIP>(modul, koda, jezik), locale, parametri);
}


#ifndef _DLL

template <class TIP> inline T_UINT RNizVP<TIP>::RazcleniV(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_LOCALE locale, ...) const
{
    T_UINT rez;
    va_list parametri;

    va_start(parametri, locale);
    rez = RazcleniVP(modul, koda, jezik, locale, parametri);
    va_end(parametri);

    return rez;
}


template <class TIP> inline T_UINT RNizVP<TIP>::RazcleniVP(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_LOCALE locale, va_list parametri) const
{
    return RazcleniP(RNizVP<TIP>(modul, koda, jezik), locale, parametri);
}


template <class TIP> inline T_UINT RNizVP<TIP>::RazcleniOdV(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_UINT zacetek, T_LOCALE locale, ...) const
{
    T_UINT rez;
    va_list parametri;

    va_start(parametri, locale);
    rez = RazcleniOdVP(modul, koda, jezik, zacetek, locale, parametri);
    va_end(parametri);

    return rez;
}


template <class TIP> inline T_UINT RNizVP<TIP>::RazcleniOdVP(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_UINT zacetek, T_LOCALE locale, va_list parametri) const
{
    return RazcleniOdP(RNizVP<TIP>(modul, koda, jezik), zacetek, locale, parametri);
}

#endif


//////////////////////////////////////////////////////////////////////
// RNizA
//////////////////////////////////////////////////////////////////////

inline T_UINT RNizA::OblikujVU(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_KODNASTRAN kodna_stran, T_LOCALE locale, ...)
{
    va_list parametri;

    va_start(parametri, locale);
    OblikujVUP(modul, koda, jezik, kodna_stran, locale, parametri);
    va_end(parametri);

    return st_znakov;
}

inline T_UINT RNizA::OblikujVUP(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_KODNASTRAN kodna_stran, T_LOCALE locale, va_list parametri)
{
    return OblikujP(RNizA(modul, koda, jezik, kodna_stran), locale, parametri);
}


inline RNizA RNizA::OblikujVUS(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_KODNASTRAN kodna_stran, T_LOCALE locale, ...)
{
    RNizA niz;
    va_list parametri;

    va_start(parametri, locale);
    niz.OblikujVUP(modul, koda, jezik, kodna_stran, locale, parametri);
    va_end(parametri);

    return niz;
}


inline RNizA RNizA::OblikujVUSP(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_KODNASTRAN kodna_stran, T_LOCALE locale, va_list parametri)
{
    RNizA niz;
    niz.OblikujVUP(modul, koda, jezik, kodna_stran, locale, parametri);
    return niz;
}


inline T_UINT RNizA::PrilepiVUO(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_KODNASTRAN kodna_stran, T_LOCALE locale, ...)
{
    va_list parametri;

    va_start(parametri, locale);
    PrilepiVUOP(modul, koda, jezik, kodna_stran, locale, parametri);
    va_end(parametri);

    return st_znakov;
}


inline T_UINT RNizA::PrilepiVUOP(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_KODNASTRAN kodna_stran, T_LOCALE locale, va_list parametri)
{
    return PrilepiOP(RNizA(modul, koda, jezik, kodna_stran), locale, parametri);
}


#ifndef _DLL

inline T_UINT RNizA::RazcleniVU(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_KODNASTRAN kodna_stran, T_LOCALE locale, ...) const
{
    T_UINT rez;
    va_list parametri;

    va_start(parametri, locale);
    rez = RazcleniVUP(modul, koda, jezik, kodna_stran, locale, parametri);
    va_end(parametri);

    return rez;
}


inline T_UINT RNizA::RazcleniVUP(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_KODNASTRAN kodna_stran, T_LOCALE locale, va_list parametri) const
{
    return RazcleniP(RNizA(modul, koda, jezik, kodna_stran), locale, parametri);
}


inline T_UINT RNizA::RazcleniOdVU(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_KODNASTRAN kodna_stran, T_UINT zacetek, T_LOCALE locale, ...) const
{
    T_UINT rez;
    va_list parametri;

    va_start(parametri, locale);
    rez = RazcleniOdVUP(modul, koda, jezik, kodna_stran, zacetek, locale, parametri);
    va_end(parametri);

    return rez;
}


inline T_UINT RNizA::RazcleniOdVUP(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_KODNASTRAN kodna_stran, T_UINT zacetek, T_LOCALE locale, va_list parametri) const
{
    return RazcleniOdP(RNizA(modul, koda, jezik, kodna_stran), zacetek, locale, parametri);
}

#endif


//////////////////////////////////////////////////////////////////////
// Metode inline za delo z nizi RNiz
//////////////////////////////////////////////////////////////////////

template <class TIP> inline T_UINT RNizP<TIP>::Nastavi(TIP znak, T_UINT koliko)
{
    assert(znak); // ne sme biti terminator

    st_znakov = koliko;
    if (st_znakov >= rez_znakov) verify(USPESNO(RezervirajDolzinoQ(st_znakov, RNIZ_TESNA_REZERVACIJA)));
    astrnset(podatki, znak, koliko);
    podatki[st_znakov] = (TIP)0;
    return st_znakov;
}


inline T_UINT RNizA::NastaviU(T_UZNAK znak, T_UINT koliko, T_KODNASTRAN kodna_stran)
{
    return RNizP<T_AZNAK>::Nastavi(aunitoasc(znak, kodna_stran), koliko);
}


inline T_UINT RNizU::NastaviA(T_AZNAK znak, T_UINT koliko, T_KODNASTRAN kodna_stran)
{
    return RNizP<T_UZNAK>::Nastavi(aasctouni(&znak, 1, kodna_stran), koliko);
}


template <class TIP> inline T_UINT RNizP<TIP>::Nastavi(const TIP *niz, T_UINT koliko)
{
    assert(niz || !koliko);

    st_znakov = astrnlen(niz, koliko);
    if (st_znakov >= rez_znakov) verify(USPESNO(RezervirajDolzinoQ(st_znakov, RNIZ_TESNA_REZERVACIJA)));
    memcpy(podatki, niz, st_znakov*sizeof(TIP));
    podatki[st_znakov] = (TIP)0;
    return st_znakov;
}


inline T_UINT RNizA::NastaviU(TK_UNICODE niz, T_UINT koliko, T_KODNASTRAN kodna_stran)
{
    assert(niz || !koliko);

    st_znakov = astrnlen(niz, koliko, kodna_stran);
    if (st_znakov >= rez_znakov) verify(USPESNO(RezervirajDolzinoQ(st_znakov, RNIZ_TESNA_REZERVACIJA)));
    verify(astrncpy2(podatki, st_znakov, niz, koliko, kodna_stran) == st_znakov);
    podatki[st_znakov] = 0;
    return st_znakov;
}


inline T_UINT RNizU::NastaviA(TK_ASCII niz, T_UINT koliko, T_KODNASTRAN kodna_stran)
{
    assert(niz || !koliko);

    st_znakov = astrnlen(niz, koliko, kodna_stran);
    if (st_znakov >= rez_znakov) verify(USPESNO(RezervirajDolzinoQ(st_znakov, RNIZ_TESNA_REZERVACIJA)));
    verify(astrncpy2(podatki, st_znakov, niz, koliko, kodna_stran) == st_znakov);
    podatki[st_znakov] = 0;
    return st_znakov;
}


template <class TIP> inline T_UINT RNizP<TIP>::Nastavi(const RNizP<TIP> &niz, T_UINT koliko)
{
    st_znakov = amin(niz.st_znakov, koliko);
    if (st_znakov >= rez_znakov) verify(USPESNO(RezervirajDolzinoQ(st_znakov, RNIZ_TESNA_REZERVACIJA)));
    memcpy(podatki, niz.podatki, st_znakov*sizeof(TIP));
    podatki[st_znakov] = (TIP)0;
    return st_znakov;
}


inline T_UINT RNizA::NastaviU(const RNizP<T_UZNAK> &niz, T_UINT koliko, T_KODNASTRAN kodna_stran)
{
    koliko = amin(niz.VrniDolzino(), koliko);
    st_znakov = astrnlen(niz.Vrni(), koliko, kodna_stran);
    if (st_znakov >= rez_znakov) verify(USPESNO(RezervirajDolzinoQ(st_znakov, RNIZ_TESNA_REZERVACIJA)));
    verify(astrncpy2(podatki, st_znakov, niz, koliko, kodna_stran) == st_znakov);
    podatki[st_znakov] = (T_AZNAK)0;
    return st_znakov;
}


inline T_UINT RNizU::NastaviA(const RNizP<T_AZNAK> &niz, T_UINT koliko, T_KODNASTRAN kodna_stran)
{
    koliko = amin(niz.VrniDolzino(), koliko);
    st_znakov = astrnlen(niz.Vrni(), koliko, kodna_stran);
    if (st_znakov >= rez_znakov) verify(USPESNO(RezervirajDolzinoQ(st_znakov, RNIZ_TESNA_REZERVACIJA)));
    verify(astrncpy2(podatki, st_znakov, niz, koliko, kodna_stran) == st_znakov);
    podatki[st_znakov] = (T_UZNAK)0;
    return st_znakov;
}


inline T_UINT RNizA::NastaviVU(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_KODNASTRAN kodna_stran)
{
    TK_UNICODE niz;
    T_UINT koliko = aloadstring(modul, koda, &niz, jezik);

    st_znakov = astrnlen(niz, koliko, kodna_stran);
    if (st_znakov >= rez_znakov) verify(USPESNO(RezervirajDolzinoQ(st_znakov, RNIZ_TESNA_REZERVACIJA)));
    verify(astrncpy2(podatki, st_znakov, niz, koliko, kodna_stran) == st_znakov);
    podatki[st_znakov] = (T_AZNAK)0;
    return st_znakov;
}


template <class TIP> inline T_UINT RNizP<TIP>::Prilepi(TIP znak, T_UINT koliko)
{
    assert(znak); // ne sme biti terminator

    T_UINT d = st_znakov;

    st_znakov += koliko;
    if (st_znakov >= rez_znakov) verify(USPESNO(RezervirajDolzino(st_znakov)));
    astrnset(podatki + d, znak, koliko);
    podatki[st_znakov] = (TIP)0;
    return st_znakov;
}


inline T_UINT RNizA::PrilepiU(T_UZNAK znak, T_UINT koliko, T_KODNASTRAN kodna_stran)
{
    assert(znak); // ne sme biti terminator

    T_UINT d = st_znakov;

    st_znakov += koliko;
    if (st_znakov >= rez_znakov) verify(USPESNO(RezervirajDolzino(st_znakov)));
    astrnset(podatki + d, znak, koliko, kodna_stran);
    podatki[st_znakov] = (T_AZNAK)0;
    return st_znakov;
}


inline T_UINT RNizU::PrilepiA(T_AZNAK znak, T_UINT koliko, T_KODNASTRAN kodna_stran)
{
    assert(znak); // ne sme biti terminator

    T_UINT d = st_znakov;

    st_znakov += koliko;
    if (st_znakov >= rez_znakov) verify(USPESNO(RezervirajDolzino(st_znakov)));
    astrnset(podatki + d, znak, koliko, kodna_stran);
    podatki[st_znakov] = (T_UZNAK)0;
    return st_znakov;
}


template <class TIP> inline T_UINT RNizP<TIP>::Prilepi(const TIP *niz, T_UINT koliko)
{
    assert(niz || !koliko);

    T_UINT zacetek = st_znakov;

    st_znakov += koliko = astrnlen(niz, koliko);
    if (st_znakov >= rez_znakov) verify(USPESNO(RezervirajDolzino(st_znakov)));
    memcpy(podatki + zacetek, niz, koliko*sizeof(TIP));
    podatki[st_znakov] = (TIP)0;
    return st_znakov;
}


inline T_UINT RNizA::PrilepiU(TK_UNICODE niz, T_UINT koliko, T_KODNASTRAN kodna_stran)
{
    assert(niz || !koliko);

    T_UINT zacetek = st_znakov;
    T_UINT koliko2 = astrnlen(niz, koliko, kodna_stran);

    st_znakov += koliko2;
    if (st_znakov >= rez_znakov) verify(USPESNO(RezervirajDolzino(st_znakov)));
    verify(astrncpy2(podatki + zacetek, koliko2, niz, koliko, kodna_stran) == koliko2);
    podatki[st_znakov] = (T_AZNAK)0;
    return st_znakov;
}


inline T_UINT RNizU::PrilepiA(TK_ASCII niz, T_UINT koliko, T_KODNASTRAN kodna_stran)
{
    assert(niz || !koliko);

    T_UINT zacetek = st_znakov;
    T_UINT koliko2 = astrnlen(niz, koliko, kodna_stran);

    st_znakov += koliko2;
    if (st_znakov >= rez_znakov) verify(USPESNO(RezervirajDolzino(st_znakov)));
    verify(astrncpy2(podatki + zacetek, koliko2, niz, koliko, kodna_stran) == koliko2);
    podatki[st_znakov] = (T_UZNAK)0;
    return st_znakov;
}


template <class TIP> inline T_UINT RNizP<TIP>::Prilepi(const RNizP<TIP> &niz, T_UINT koliko)
{
    T_UINT zacetek = st_znakov;

    st_znakov += koliko = amin(niz.st_znakov, koliko);
    if (st_znakov >= rez_znakov) verify(USPESNO(RezervirajDolzino(st_znakov)));
    memcpy(podatki + zacetek, niz.podatki, koliko*sizeof(TIP));
    podatki[st_znakov] = (TIP)0;
    return st_znakov;
}


inline T_UINT RNizA::PrilepiU(const RNizP<T_UZNAK> &niz, T_UINT koliko, T_KODNASTRAN kodna_stran)
{
    assert(niz || !koliko);

    T_UINT zacetek = st_znakov;
    T_UINT koliko2;

    koliko = amin(niz.VrniDolzino(), koliko);
    st_znakov += koliko2 = astrnlen(niz, koliko, kodna_stran);
    if (st_znakov >= rez_znakov) verify(USPESNO(RezervirajDolzino(st_znakov)));
    verify(astrncpy2(podatki + zacetek, koliko2, niz, koliko, kodna_stran) == koliko2);
    podatki[st_znakov] = (T_AZNAK)0;
    return st_znakov;
}


inline T_UINT RNizU::PrilepiA(const RNizP<T_AZNAK> &niz, T_UINT koliko, T_KODNASTRAN kodna_stran)
{
    assert(niz || !koliko);

    T_UINT zacetek = st_znakov;
    T_UINT koliko2;

    koliko = amin(niz.VrniDolzino(), koliko);
    st_znakov += koliko2 = astrnlen(niz, koliko, kodna_stran);
    if (st_znakov >= rez_znakov) verify(USPESNO(RezervirajDolzino(st_znakov)));
    verify(astrncpy2(podatki + zacetek, koliko2, niz, koliko, kodna_stran) == koliko2);
    podatki[st_znakov] = (T_UZNAK)0;
    return st_znakov;
}


inline T_UINT RNizA::PrilepiVU(HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_KODNASTRAN kodna_stran)
{
    TK_UNICODE niz;
    T_UINT zacetek = st_znakov, koliko = aloadstring(modul, koda, &niz, jezik), koliko2;

    st_znakov += koliko2 = astrnlen(niz, koliko, kodna_stran);
    if (st_znakov >= rez_znakov) verify(USPESNO(RezervirajDolzino(st_znakov)));
    verify(astrncpy2(podatki + zacetek, koliko2, niz, koliko, kodna_stran) == koliko2);
    podatki[st_znakov] = (T_AZNAK)0;
    return st_znakov;
}


#ifndef AOSN_BREZ_SGML

inline T_UINT RNizA::NastaviSGML(TK_ASCII sgml, T_UINT koliko, T_UINT kateri, T_KODNASTRAN kodna_stran)
{
    koliko = astrnlen(sgml, koliko);
    verify(USPESNO(RezervirajDolzinoQ(koliko, RNIZ_TESNA_REZERVACIJA)));
    return st_znakov = asgmltostr(podatki, koliko + 1, sgml, koliko, kateri, kodna_stran);
}


inline T_UINT RNizU::NastaviSGML(TK_ASCII sgml, T_UINT koliko, T_UINT kateri)
{
    koliko = astrnlen(sgml, koliko);
    verify(USPESNO(RezervirajDolzinoQ(koliko, RNIZ_TESNA_REZERVACIJA)));
    return st_znakov = asgmltostr(podatki, koliko + 1, sgml, koliko, kateri);
}


inline T_UINT RNizU::NastaviSGML(TK_UNICODE sgml, T_UINT koliko, T_UINT kateri)
{
    koliko = astrnlen(sgml, koliko);
    verify(USPESNO(RezervirajDolzinoQ(koliko, RNIZ_TESNA_REZERVACIJA)));
    return st_znakov = asgmltostr(podatki, koliko + 1, sgml, koliko, kateri);
}


inline T_UINT RNizA::PrilepiSGML(TK_ASCII sgml, T_UINT koliko, T_UINT kateri, T_KODNASTRAN kodna_stran)
{
    koliko = astrnlen(sgml, koliko);
    verify(USPESNO(RezervirajDolzino(st_znakov + koliko)));
    return st_znakov += asgmltostr(podatki + st_znakov, koliko + 1, sgml, koliko, kateri, kodna_stran);
}


inline T_UINT RNizU::PrilepiSGML(TK_ASCII sgml, T_UINT koliko, T_UINT kateri)
{
    koliko = astrnlen(sgml, koliko);
    verify(USPESNO(RezervirajDolzino(st_znakov + koliko)));
    return st_znakov += asgmltostr(podatki + st_znakov, koliko + 1, sgml, koliko, kateri);
}


inline T_UINT RNizU::PrilepiSGML(TK_UNICODE sgml, T_UINT koliko, T_UINT kateri)
{
    koliko = astrnlen(sgml, koliko);
    verify(USPESNO(RezervirajDolzino(st_znakov + koliko)));
    return st_znakov += asgmltostr(podatki + st_znakov, koliko + 1, sgml, koliko, kateri);
}


inline RNizA  RNizA::VrniSGML(T_UINT koliko, T_UINT kateri, T_KODNASTRAN kodna_stran) const
{
    return RNizA::VrniSGML(podatki, koliko, kateri, kodna_stran);
}


inline RNizA  RNizU::VrniSGML(T_UINT koliko, T_UINT kateri) const
{
    return RNizU::VrniSGML(podatki, koliko, kateri);
}

#endif


inline T_UINT RNizA::NastaviUTF8(TK_ASCII utf8, T_UINT koliko, T_KODNASTRAN kodna_stran)
{
    koliko = astrnlen(utf8, koliko);
    verify(USPESNO(RezervirajDolzinoQ(koliko, RNIZ_TESNA_REZERVACIJA)));
    st_znakov = astrncpy2(podatki, koliko, kodna_stran, utf8, koliko, KODNASTRAN_UTF8);
    podatki[st_znakov] = 0;
    return st_znakov;
}


inline T_UINT RNizU::NastaviUTF8(TK_ASCII utf8, T_UINT koliko)
{
    return NastaviA(utf8, koliko, KODNASTRAN_UTF8);
}


inline T_UINT RNizA::PrilepiUTF8(TK_ASCII utf8, T_UINT koliko, T_KODNASTRAN kodna_stran)
{
    koliko = astrnlen(utf8, koliko);
    verify(USPESNO(RezervirajDolzino(st_znakov + koliko)));
    st_znakov += astrncpy2(podatki + st_znakov, koliko, kodna_stran, utf8, koliko, KODNASTRAN_UTF8);
    podatki[st_znakov] = 0;
    return st_znakov;
}


inline T_UINT RNizU::PrilepiUTF8(TK_ASCII utf8, T_UINT koliko)
{
    return PrilepiA(utf8, koliko, KODNASTRAN_UTF8);
}


inline RNizA  RNizA::VrniUTF8(T_UINT koliko, T_KODNASTRAN kodna_stran) const
{
    return RNizA::VrniUTF8(podatki, koliko, kodna_stran);
}


inline RNizA  RNizU::VrniUTF8(T_UINT koliko) const
{
    return RNizU::VrniUTF8(podatki, koliko);
}


inline T_UINT RNizU::NastaviURLEncoded(TK_ASCII urlencoded, T_UINT koliko, T_KODNASTRAN kodna_stran)
{
    Sprazni();
    return PrilepiURLEncoded(urlencoded, koliko, kodna_stran);
}


template <class TIP> inline RNizP<TIP> RNizP<TIP>::Sredina(T_UINT zacetek, T_UINT koliko) const
{
    assert(podatki);
    assert(zacetek <= st_znakov);

    return RNizP<TIP>(podatki + zacetek, koliko);
}


inline RNizA RNizA::Sredina(T_UINT zacetek, T_UINT koliko) const
{
    assert(podatki);
    assert(zacetek <= st_znakov);

    return RNizA(podatki + zacetek, koliko);
}


inline RNizU RNizU::Sredina(T_UINT zacetek, T_UINT koliko) const
{
    assert(podatki);
    assert(zacetek <= st_znakov);

    return RNizU(podatki + zacetek, koliko);
}


template <class TIP> inline RNizP<TIP> RNizP<TIP>::Levo(T_UINT koliko) const
{
    assert(podatki);
    assert(koliko <= st_znakov);

    return RNizP<TIP>(podatki, koliko);
}


inline RNizA RNizA::Levo(T_UINT koliko) const
{
    assert(podatki);
    assert(koliko <= st_znakov);

    return RNizA(podatki, koliko);
}


inline RNizU RNizU::Levo(T_UINT koliko) const
{
    assert(podatki);
    assert(koliko <= st_znakov);

    return RNizU(podatki, koliko);
}


template <class TIP> inline RNizP<TIP> RNizP<TIP>::Desno(T_UINT koliko) const
{
    assert(podatki);
    assert(koliko <= st_znakov);

    return RNizP<TIP>(podatki + (st_znakov - koliko), koliko);
}


inline RNizA RNizA::Desno(T_UINT koliko) const
{
    assert(podatki);
    assert(koliko <= st_znakov);

    return RNizA(podatki + (st_znakov - koliko), koliko);
}


inline RNizU RNizU::Desno(T_UINT koliko) const
{
    assert(podatki);
    assert(koliko <= st_znakov);

    return RNizU(podatki + (st_znakov - koliko), koliko);
}


inline T_UINT RNizA::PretvoriCRLFvNL()
{
    return Zamenjaj("\r\n", "\n");
}


inline T_UINT RNizA::PretvoriLFCRvNL()
{
    return Zamenjaj("\n\r", "\n");
}


inline T_UINT RNizA::PretvoriNLvCRLF()
{
    return Zamenjaj("\n", "\r\n");
}


inline T_UINT RNizA::PretvoriNLvLFCR()
{
    return Zamenjaj("\n", "\n\r");
}


/////////////////////////////////////////////////////////////////////
// Operatorji prirejanja nizov RNiz
//////////////////////////////////////////////////////////////////////

template <class TIP> inline const TIP* RNizP<TIP>::operator =(TIP znak)
{
    Nastavi(znak);
    return podatki;
}


inline TK_ASCII RNizA::operator =(T_AZNAK znak)
{
    Nastavi(znak);
    return podatki;
}


inline TK_UNICODE RNizU::operator =(T_AZNAK znak)
{
    NastaviA(znak);
    return podatki;
}


inline TK_ASCII RNizA::operator =(T_UZNAK znak)
{
    NastaviU(znak);
    return podatki;
}


inline TK_UNICODE RNizU::operator =(T_UZNAK znak)
{
    Nastavi(znak);
    return podatki;
}


template <class TIP> inline const TIP* RNizP<TIP>::operator =(const TIP *niz)
{
    Nastavi(niz);
    return podatki;
}


inline TK_ASCII RNizA::operator =(TK_ASCII niz)
{
    Nastavi(niz);
    return podatki;
}


inline TK_UNICODE RNizU::operator =(TK_ASCII niz)
{
    NastaviA(niz);
    return podatki;
}


inline TK_ASCII RNizA::operator =(TK_UNICODE niz)
{
    NastaviU(niz);
    return podatki;
}


inline TK_UNICODE RNizU::operator =(TK_UNICODE niz)
{
    Nastavi(niz);
    return podatki;
}


template <class TIP> inline const TIP* RNizP<TIP>::operator =(const RNizP<TIP> &niz)
{
    Nastavi(niz);
    return podatki;
}


inline TK_ASCII RNizA::operator =(const RNizP<T_AZNAK> &niz)
{
    Nastavi(niz);
    return podatki;
}


inline TK_UNICODE RNizU::operator =(const RNizP<T_AZNAK> &niz)
{
    NastaviA(niz);
    return podatki;
}


inline TK_ASCII RNizA::operator =(const RNizP<T_UZNAK> &niz)
{
    NastaviU(niz);
    return podatki;
}


inline TK_UNICODE RNizU::operator =(const RNizP<T_UZNAK> &niz)
{
    Nastavi(niz);
    return podatki;
}


template <class TIP> inline const TIP* RNizP<TIP>::operator +=(TIP znak)
{
    Prilepi(znak);
    return podatki;
}


inline TK_ASCII RNizA::operator +=(T_AZNAK znak)
{
    Prilepi(znak);
    return podatki;
}


inline TK_UNICODE RNizU::operator +=(T_AZNAK znak)
{
    PrilepiA(znak);
    return podatki;
}


inline TK_ASCII RNizA::operator +=(T_UZNAK znak)
{
    PrilepiU(znak);
    return podatki;
}


inline TK_UNICODE RNizU::operator +=(T_UZNAK znak)
{
    Prilepi(znak);
    return podatki;
}


template <class TIP> inline const TIP* RNizP<TIP>::operator +=(const TIP *niz)
{
    Prilepi(niz);
    return podatki;
}


inline TK_ASCII RNizA::operator +=(TK_ASCII niz)
{
    Prilepi(niz);
    return podatki;
}


inline TK_UNICODE RNizU::operator +=(TK_ASCII niz)
{
    PrilepiA(niz);
    return podatki;
}


inline TK_ASCII RNizA::operator +=(TK_UNICODE niz)
{
    PrilepiU(niz);
    return podatki;
}


inline TK_UNICODE RNizU::operator +=(TK_UNICODE niz)
{
    Prilepi(niz);
    return podatki;
}


template <class TIP> inline const TIP* RNizP<TIP>::operator +=(const RNizP<TIP> &niz)
{
    Prilepi(niz);
    return podatki;
}


inline TK_ASCII RNizA::operator +=(const RNizP<T_AZNAK> &niz)
{
    Prilepi(niz);
    return podatki;
}


inline TK_UNICODE RNizU::operator +=(const RNizP<T_AZNAK> &niz)
{
    PrilepiA(niz);
    return podatki;
}


inline TK_ASCII RNizA::operator +=(const RNizP<T_UZNAK> &niz)
{
    PrilepiU(niz);
    return podatki;
}


inline TK_UNICODE RNizU::operator +=(const RNizP<T_UZNAK> &niz)
{
    Prilepi(niz);
    return podatki;
}


#ifdef AOSN_REGIZR

//////////////////////////////////////////////////////////////////////
// RRegElementP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElementP<TIP>::RRegElementP() :
    RElement(),
    interval(1, 0)
{
}


template <class TIP> T_BOOL RRegElementP<TIP>::Isci(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    T_UINT i;

    // Iemo po nizu, dokler ne najdemo prvega ujemanja z regularnim izrazom.
    for (i = zacetek; i < konec && besedilo[i]; i++) {
        if (PreveriUjemanje(besedilo, i, konec, zastavice))
            return TRUE;
    }

    return FALSE;
}


template <class TIP> T_VOID RRegElementP<TIP>::Razveljavi()
{
    interval.zacetek = 1;
    interval.konec = 0;
}


template <class TIP> T_VOID RRegElementP<TIP>::Unici()
{
    // Sprostimo element na kopici.
    delete this;
}


//////////////////////////////////////////////////////////////////////
// RRegElZbirkaP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElZbirkaP<TIP>::RRegElZbirkaP(RRegElementP<TIP> *el[], T_UINT stevilo) : RRegElementP<TIP>()
{
    ZgradiTabelo(el, stevilo);
}


template <class TIP> RRegElZbirkaP<TIP>::RRegElZbirkaP(RRegElementP<TIP> *el, ...) : RRegElementP<TIP>()
{
    va_list parametri;
    va_start(parametri, el);
    ZgradiTabelo(el, parametri);
    va_end(parametri);
}


template <class TIP> T_VOID RRegElZbirkaP<TIP>::Razveljavi()
{
    T_UINT i, n = tab.VrniStevilo();

    // Razveljavimo podelemente.
    for (i = 0; i < n; i++) {
        RRegElementP<TIP> *el = tab[i];
        assert(el);
        el->Razveljavi();
    }

    RRegElementP<TIP>::Razveljavi();
}


template <class TIP> T_VOID RRegElZbirkaP<TIP>::Unici()
{
    T_UINT i, n = tab.VrniStevilo();

    // Uniimo podelemente.
    for (i = 0; i < n; i++) {
        RRegElementP<TIP> *el = tab[i];
        assert(el);
        el->Unici();
    }

    RRegElementP<TIP>::Unici();
}


template <class TIP> T_VOID RRegElZbirkaP<TIP>::ZgradiTabelo(RRegElementP<TIP> *el[], T_UINT stevilo)
{
    assert(el || !stevilo);
    assert(tab.JePrazna());

    if (stevilo) {
        T_UINT i;
        RRegElementP<TIP> **p;

        // Ustvarimo tabelo in vanjo prepiemo kazalce na elemente.
        p = tab.Odpusti(stevilo, FALSE);
        assert(p || !stevilo);
        for (i = 0; i < stevilo; i++)
            p[i] = el[i];
        tab.Uporabi(p, stevilo, FALSE);
    }
}


template <class TIP> T_VOID RRegElZbirkaP<TIP>::ZgradiTabelo(RRegElementP<TIP> *el, va_list parametri)
{
    assert(tab.JePrazna());

    RRegElementP<TIP> *p;

    // Kazalce na elemente prepiemo v tabelo.
    for (tab += el; (p = va_arg(parametri, RRegElementP<TIP>*)) != NULL; tab += p);
}


//////////////////////////////////////////////////////////////////////
// RRegElNOPP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElNOPP<TIP>::RRegElNOPP() : RRegElementP<TIP>()
{
}


template <class TIP> T_BOOL RRegElNOPP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    UNREFERENCED_PARAMETER(besedilo);
    UNREFERENCED_PARAMETER(konec);
    UNREFERENCED_PARAMETER(zastavice);

    if (zacetek < konec && besedilo[zacetek]) {
        interval.zacetek = interval.konec = zacetek;
        return TRUE;
    } else {
        interval.zacetek = (interval.konec = zacetek) + 1;
        return FALSE;
    }
}


//////////////////////////////////////////////////////////////////////
// RRegElPoljubenZnakP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElPoljubenZnakP<TIP>::RRegElPoljubenZnakP() : RRegElementP<TIP>()
{
}


template <class TIP> T_BOOL RRegElPoljubenZnakP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    UNREFERENCED_PARAMETER(zastavice);

    if (zacetek < konec && besedilo[zacetek]) {
        interval.konec = (interval.zacetek = zacetek) + 1;
        return TRUE;
    } else {
        interval.zacetek = (interval.konec = zacetek) + 1;
        return FALSE;
    }
}


//////////////////////////////////////////////////////////////////////
// RRegElZnakP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElZnakP<TIP>::RRegElZnakP(TIP _znak, T_BOOL _je_negirano) :
    RRegElementP<TIP>(),
    znak(_znak),
    je_negirano(_je_negirano)
{
}


template <class TIP> T_BOOL RRegElZnakP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);

    if (zacetek < konec && besedilo[zacetek]) {
        T_BOOL r = (zastavice & RREGIZR_NE_LOCUJ_VELIKIH_MALIH) ?
            atolower(besedilo[zacetek]) == atolower(znak) :
                     besedilo[zacetek]  ==          znak;

        if (r && !je_negirano || !r && je_negirano) {
            interval.konec = (interval.zacetek = zacetek) + 1;
            return TRUE;
        }
    }

    interval.zacetek = (interval.konec = zacetek) + 1;
    return FALSE;
}


//////////////////////////////////////////////////////////////////////
// RRegElAlfanumericniZnakP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElAlfanumericniZnakP<TIP>::RRegElAlfanumericniZnakP(T_BOOL _je_negirano) :
    RRegElementP<TIP>(),
    je_negirano(_je_negirano)
{
}


template <class TIP> T_BOOL RRegElAlfanumericniZnakP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    UNREFERENCED_PARAMETER(zastavice);

    if (zacetek < konec && besedilo[zacetek]) {
        T_BOOL r = aisalnum(besedilo[zacetek]);

        if (r && !je_negirano || !r && je_negirano) {
            interval.konec = (interval.zacetek = zacetek) + 1;
            return TRUE;
        }
    }

    interval.zacetek = (interval.konec = zacetek) + 1;
    return FALSE;
}


//////////////////////////////////////////////////////////////////////
// RRegElPresledekP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElPresledekP<TIP>::RRegElPresledekP(T_BOOL _je_negirano) :
    RRegElementP<TIP>(),
    je_negirano(_je_negirano)
{
}


template <class TIP> T_BOOL RRegElPresledekP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);

    if (zacetek < konec && besedilo[zacetek]) {
        T_BOOL r = (zastavice & RREGIZR_VECVRSTICNO) ?
                                             aisspace(besedilo[zacetek]) :
            !aislbreak(besedilo[zacetek]) && aisspace(besedilo[zacetek]);

        if (r && !je_negirano || !r && je_negirano) {
            interval.konec = (interval.zacetek = zacetek) + 1;
            return TRUE;
        }
    }

    interval.zacetek = (interval.konec = zacetek) + 1;
    return FALSE;
}


//////////////////////////////////////////////////////////////////////
// RRegElLociloP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElLociloP<TIP>::RRegElLociloP(T_BOOL _je_negirano) :
    RRegElementP<TIP>(),
    je_negirano(_je_negirano)
{
}


template <class TIP> T_BOOL RRegElLociloP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    UNREFERENCED_PARAMETER(zastavice);

    if (zacetek < konec && besedilo[zacetek]) {
        T_BOOL r = aispunct(besedilo[zacetek]);

        if (r && !je_negirano || !r && je_negirano) {
            interval.konec = (interval.zacetek = zacetek) + 1;
            return TRUE;
        }
    }

    interval.zacetek = (interval.konec = zacetek) + 1;
    return FALSE;
}


//////////////////////////////////////////////////////////////////////
// RRegElPresledekAliLociloP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElPresledekAliLociloP<TIP>::RRegElPresledekAliLociloP(T_BOOL _je_negirano) :
    RRegElementP<TIP>(),
    je_negirano(_je_negirano)
{
}


template <class TIP> T_BOOL RRegElPresledekAliLociloP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);

    if (zacetek < konec && besedilo[zacetek]) {
        T_BOOL r = (zastavice & RREGIZR_VECVRSTICNO) ?
                                              aisspace(besedilo[zacetek]) || aispunct(besedilo[zacetek]) :
            !aislbreak(besedilo[zacetek]) && (aisspace(besedilo[zacetek]) || aispunct(besedilo[zacetek]));

        if (r && !je_negirano || !r && je_negirano) {
            interval.konec = (interval.zacetek = zacetek) + 1;
            return TRUE;
        }
    }

    interval.zacetek = (interval.konec = zacetek) + 1;
    return FALSE;
}


//////////////////////////////////////////////////////////////////////
// RRegElZacetekVrsticeP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElZacetekVrsticeP<TIP>::RRegElZacetekVrsticeP(T_BOOL _je_negirano) :
    RRegElementP<TIP>(),
    je_negirano(_je_negirano)
{
}


template <class TIP> T_BOOL RRegElZacetekVrsticeP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    UNREFERENCED_PARAMETER(konec);
    UNREFERENCED_PARAMETER(zastavice);

    T_BOOL r = zacetek == 0 || aislbreak(besedilo[zacetek - 1]);

    if (r && !je_negirano || !r && je_negirano) {
        interval.konec = (interval.zacetek = zacetek);
        return TRUE;
    } else {
        interval.zacetek = (interval.konec = zacetek) + 1;
        return FALSE;
    }
}


//////////////////////////////////////////////////////////////////////
// RRegElKonecVrsticeP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElKonecVrsticeP<TIP>::RRegElKonecVrsticeP(T_BOOL _je_negirano) :
    RRegElementP<TIP>(),
    je_negirano(_je_negirano)
{
}


template <class TIP> T_BOOL RRegElKonecVrsticeP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    UNREFERENCED_PARAMETER(zastavice);

    T_BOOL r = zacetek >= konec || !besedilo[zacetek] || aislbreak(besedilo[zacetek]);

    if (r && !je_negirano || !r && je_negirano) {
        interval.konec = (interval.zacetek = zacetek);
        return TRUE;
    } else {
        interval.zacetek = (interval.konec = zacetek) + 1;
        return FALSE;
    }
}


//////////////////////////////////////////////////////////////////////
// RRegElZacetekBesedeP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElZacetekBesedeP<TIP>::RRegElZacetekBesedeP(T_UINT _zastavice, T_BOOL _je_negirano) :
    RRegElementP<TIP>(),
    zastavice(_zastavice),
    je_negirano(_je_negirano)
{
}


template <class TIP> T_BOOL RRegElZacetekBesedeP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT _zastavice)
{
    assert(besedilo || !konec);
    UNREFERENCED_PARAMETER(_zastavice);

    TIP
        znak_l = zacetek         ? besedilo[zacetek - 1] : 0,
        znak_d = zacetek < konec ? besedilo[zacetek    ] : 0;
    T_BOOL r =
         (!znak_l ||
          (zastavice & RREGIZR_LOCILO_BESED_PRESLEDKI) && aisspace(znak_l) ||
          (zastavice & RREGIZR_LOCILO_BESED_PIKE)      && aispunct(znak_l) ||
          (zastavice & RREGIZR_LOCILO_BESED_STEVKE)    && aisdigit(znak_l) ||
          (zastavice & RREGIZR_LOCILO_BESED_SIMBOLI)   && aisgraph(znak_l) && !aisalnum(znak_l)) &&
        !(!znak_d ||
          (zastavice & RREGIZR_LOCILO_BESED_PRESLEDKI) && aisspace(znak_d) ||
          (zastavice & RREGIZR_LOCILO_BESED_PIKE)      && aispunct(znak_d) ||
          (zastavice & RREGIZR_LOCILO_BESED_STEVKE)    && aisdigit(znak_d) ||
          (zastavice & RREGIZR_LOCILO_BESED_SIMBOLI)   && aisgraph(znak_d) && !aisalnum(znak_d));

    if (r && !je_negirano || !r && je_negirano) {
        // Prejnji znak je bil presledek, loilo, tevka ipd., trenutni pa ni od tega.
        interval.konec = (interval.zacetek = zacetek);
        return TRUE;
    } else {
        interval.zacetek = (interval.konec = zacetek) + 1;
        return FALSE;
    }
}


//////////////////////////////////////////////////////////////////////
// RRegElKonecBesedeP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElKonecBesedeP<TIP>::RRegElKonecBesedeP(T_UINT _zastavice, T_BOOL _je_negirano) :
    RRegElementP<TIP>(),
    zastavice(_zastavice),
    je_negirano(_je_negirano)
{
}


template <class TIP> T_BOOL RRegElKonecBesedeP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT _zastavice)
{
    assert(besedilo || !konec);
    UNREFERENCED_PARAMETER(_zastavice);

    TIP
        znak_l = zacetek         ? besedilo[zacetek - 1] : 0,
        znak_d = zacetek < konec ? besedilo[zacetek    ] : 0;
    T_BOOL r =
        !(!znak_l ||
          (zastavice & RREGIZR_LOCILO_BESED_PRESLEDKI) && aisspace(znak_l) ||
          (zastavice & RREGIZR_LOCILO_BESED_PIKE)      && aispunct(znak_l) ||
          (zastavice & RREGIZR_LOCILO_BESED_STEVKE)    && aisdigit(znak_l) ||
          (zastavice & RREGIZR_LOCILO_BESED_SIMBOLI)   && aisgraph(znak_l) && !aisalnum(znak_l)) &&
         (!znak_d ||
          (zastavice & RREGIZR_LOCILO_BESED_PRESLEDKI) && aisspace(znak_d) ||
          (zastavice & RREGIZR_LOCILO_BESED_PIKE)      && aispunct(znak_d) ||
          (zastavice & RREGIZR_LOCILO_BESED_STEVKE)    && aisdigit(znak_d) ||
          (zastavice & RREGIZR_LOCILO_BESED_SIMBOLI)   && aisgraph(znak_d) && !aisalnum(znak_d));

    if (r && !je_negirano || !r && je_negirano) {
        // Trenutni znak je presledek, loilo, tevka ipd., prejnji pa ni od tega.
        interval.konec = (interval.zacetek = zacetek);
        return TRUE;
    } else {
        interval.zacetek = (interval.konec = zacetek) + 1;
        return FALSE;
    }
}


//////////////////////////////////////////////////////////////////////
// RRegElMaskaOsnP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElMaskaOsnP<TIP>::RRegElMaskaOsnP(T_BOOL _je_negirano) :
    RRegElementP<TIP>(),
    odmik_zadetka(T_UINT_MAX),
    je_negirano(_je_negirano)
{
}


template <class TIP> T_VOID RRegElMaskaOsnP<TIP>::Razveljavi()
{
    odmik_zadetka = T_UINT_MAX;
    RRegElementP<TIP>::Razveljavi();
}


//////////////////////////////////////////////////////////////////////
// RRegElMaskaP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElMaskaP<TIP>::RRegElMaskaP(const TIP *_maska, T_UINT dolzina, T_BOOL je_negirano) : RRegElMaskaOsnP<TIP>(je_negirano)
{
    if (_maska)
        maska.Nastavi(_maska, dolzina);
}


template <class TIP> T_BOOL RRegElMaskaP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);

    if (zacetek < konec && besedilo[zacetek]) {
        const TIP
            *_maska = maska.Vrni(),
            *r = (zastavice & RREGIZR_NE_LOCUJ_VELIKIH_MALIH) ?
                astrnichr(_maska, besedilo[zacetek], maska.VrniDolzino()) :
                astrnchr (_maska, besedilo[zacetek], maska.VrniDolzino());
        odmik_zadetka = r ? r - _maska : T_UINT_MAX;

        if (r && !je_negirano || !r && je_negirano) {
            interval.konec = (interval.zacetek = zacetek) + 1;
            return TRUE;
        }
    }

    odmik_zadetka = T_UINT_MAX;
    interval.zacetek = (interval.konec = zacetek) + 1;
    return FALSE;
}


//////////////////////////////////////////////////////////////////////
// RRegElNizP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElNizP<TIP>::RRegElNizP(const TIP *_niz, T_UINT dolzina) :
    RRegElementP<TIP>(),
    niz(_niz, dolzina)
{
}


template <class TIP> T_BOOL RRegElNizP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);

    T_UINT
        m = niz.VrniDolzino(),
        n = amin<T_UINT>(konec - zacetek, m);
    T_INT r = (zastavice & RREGIZR_NE_LOCUJ_VELIKIH_MALIH) ?
        astrnicmp(besedilo + zacetek, n, niz.Vrni(), m) :
         astrncmp(besedilo + zacetek, n, niz.Vrni(), m);

    if (!r) {
        interval.konec = (interval.zacetek = zacetek) + niz.VrniDolzino();
        return TRUE;
    } else {
        interval.zacetek = (interval.konec = zacetek) + 1;
        return FALSE;
    }
}


//////////////////////////////////////////////////////////////////////
// RRegElPonavljanjeP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElPonavljanjeP<TIP>::RRegElPonavljanjeP(RRegElementP<TIP> *_el, T_UINT _min_iteracij, T_UINT _max_iteracij, T_BOOL _je_pozresno) :
    RRegElementP<TIP>(),
    el(_el),
    min_iteracij(_min_iteracij),
    max_iteracij(_max_iteracij),
    je_pozresno(_je_pozresno)
{
}


template <class TIP> T_BOOL RRegElPonavljanjeP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    assert(el);

    T_UINT i;

    interval.konec = zacetek;

    // Pretejemo, kolikokrat zaporedno se element el ujema z besedilom.
    for (i = 0; (je_pozresno || i < min_iteracij) && i < max_iteracij; i++) {
        if (!el->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
            assert(el->interval.zacetek > el->interval.konec);
            break;
        }
        if (el->interval.zacetek < el->interval.konec) {
            // Podelement se je ujemal. Prestavimo se naprej in ponovimo.
            interval.konec = el->interval.konec;
        } else {
            // Podelement se je sicer ujemal, vendar je doline 0. Zato konamo, preden pride do neskonne zanke.
            break;
        }
    }

    if (i >= min_iteracij) {
        interval.zacetek = zacetek;
        return TRUE;
    } else {
        el->Razveljavi();
        interval.zacetek = (interval.konec = zacetek) + 1;
        return FALSE;
    }
}


template <class TIP> T_VOID RRegElPonavljanjeP<TIP>::Razveljavi()
{
    assert(el);

    // Razveljavimo podelement.
    el->Razveljavi();

    RRegElementP<TIP>::Razveljavi();
}


template <class TIP> T_VOID RRegElPonavljanjeP<TIP>::Unici()
{
    // Uniimo podelement.
    assert(el);
    el->Unici();

    RRegElementP<TIP>::Unici();
}


//////////////////////////////////////////////////////////////////////
// RRegElZaporedjeP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElZaporedjeP<TIP>::RRegElZaporedjeP(RRegElementP<TIP> *el[], T_UINT stevilo) : RRegElZbirkaP<TIP>(el, stevilo)
{
}


template <class TIP> RRegElZaporedjeP<TIP>::RRegElZaporedjeP(RRegElementP<TIP> *el, ...) : RRegElZbirkaP<TIP>()
{
    va_list parametri;
    va_start(parametri, el);
    ZgradiTabelo(el, parametri);
    va_end(parametri);
}


template <class TIP> T_BOOL RRegElZaporedjeP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);

    T_UINT i, n = tab.VrniStevilo();

    interval.konec = zacetek;

    // Poiemo, e se cela serija elementov ujema z besedilom.
    for (i = 0; i < n; i++) {
        RRegElementP<TIP> *el = tab[i];
        if (!el->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
            assert(el->interval.zacetek > el->interval.konec);
            // Razveljavimo podelemente.
            for (i = 0; i < n; i++) {
                RRegElementP<TIP> *el = tab[i];
                assert(el);
                el->Razveljavi();
            }
            interval.zacetek = (interval.konec = zacetek) + 1;
            return FALSE;
        }
        interval.konec = el->interval.konec;
    }

    interval.zacetek = zacetek;
    return TRUE;
}


//////////////////////////////////////////////////////////////////////
// RRegElVejitevP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElVejitevP<TIP>::RRegElVejitevP(RRegElementP<TIP> *el[], T_UINT stevilo) :
    RRegElZbirkaP<TIP>(el, stevilo),
    odmik_zadetka(T_UINT_MAX)
{
}


template <class TIP> RRegElVejitevP<TIP>::RRegElVejitevP(RRegElementP<TIP> *el, ...) :
    RRegElZbirkaP<TIP>(),
    odmik_zadetka(T_UINT_MAX)
{
    va_list parametri;
    va_start(parametri, el);
    ZgradiTabelo(el, parametri);
    va_end(parametri);
}


template <class TIP> T_BOOL RRegElVejitevP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);

    T_UINT i, n = tab.VrniStevilo();

    // Poiemo, e se kaken element iz tabele tab ujema z besedilom.
    for (i = 0; i < n; i++) {
        RRegElementP<TIP> *el = tab[i];
        assert(el);
        if (el->PreveriUjemanje(besedilo, zacetek, konec, zastavice)) {
            interval = el->interval;
            // Vse elemente do konce vejitve razveljavimo, saj ujemanja nismo nali zanje.
            for (i++; i < n; i++) {
                RRegElementP<TIP> *el = tab[i];
                assert(el);
                el->Razveljavi();
            }
            odmik_zadetka = i;
            return TRUE;
        } else {
            assert(el->interval.zacetek > el->interval.konec);
        }
    }

    // Ni potrebno razveljavljati podelementov, saj smo jih razveljavljali sproti med preverjanjem ujemanja. Razveljavimo le e vejitev.
    odmik_zadetka = T_UINT_MAX;
    interval.zacetek = (interval.konec = zacetek) + 1;
    return FALSE;
}


template <class TIP> T_VOID RRegElVejitevP<TIP>::Razveljavi()
{
    odmik_zadetka = T_UINT_MAX;
    RRegElZbirkaP<TIP>::Razveljavi();
}


//////////////////////////////////////////////////////////////////////
// RRegElVejitevNizovP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElVejitevNizovP<TIP>::RRegElVejitevNizovP(const TIP *niziz, T_UINT dolzina) : RRegElVejitevP<TIP>()
{
    ZgradiTabelo(niziz, dolzina);
}


template <class TIP> RRegElVejitevNizovP<TIP>::RRegElVejitevNizovP(const TIP *niz, ...) : RRegElVejitevP<TIP>()
{
    va_list parametri;
    va_start(parametri, niz);
    ZgradiTabelo(niz, parametri);
    va_end(parametri);
}


template <class TIP> RRegElVejitevNizovP<TIP>::~RRegElVejitevNizovP()
{
    T_UINT i, stevilo = tab.VrniStevilo();

    // Nize smo alocirali mi v metodi ZgradiTabelo(), zato jih moramo tudi uniiti.
    for (i = 0; i < stevilo; i++) {
        RRegElNizP<TIP> *el = (RRegElNizP<TIP>*)tab[i];
        assert(el);
        delete (RRegElNizP<TIP>*)el;
    }
}


template <class TIP> T_VOID RRegElVejitevNizovP<TIP>::ZgradiTabelo(const TIP *niziz, T_UINT dolzina)
{
    assert(niziz || !dolzina);

    if (dolzina) {
        T_UINT i, zacetek, stevilo;
        RRegElementP<TIP> **p;

        // Najprej pretejemo tevilo nizov.
        for (zacetek = stevilo = 0; zacetek < dolzina && niziz[zacetek]; zacetek += astrnlen(niziz + zacetek, dolzina - zacetek) + 1, stevilo++);

        // Ustvarimo tabelo in naredimo nize.
        p = tab.Odpusti(stevilo, FALSE);
        assert(p || !stevilo);
        for (zacetek = i = 0; i < stevilo; zacetek += astrnlen(niziz + zacetek, dolzina - zacetek) + 1, i++) {
            // Vzpostavimo nize z alternativami.
            p[i] = new RRegElNizP<TIP>(niziz + zacetek, dolzina - zacetek);
        }
        tab.Uporabi(p, stevilo, FALSE);
    }
}


template <class TIP> T_VOID RRegElVejitevNizovP<TIP>::ZgradiTabelo(const TIP *niz, va_list parametri)
{
    assert(tab.JePrazna());

    const TIP *p;

    // Nize prepiemo v tabelo.
    for (tab += new RRegElNizP<TIP>(niz); (p = va_arg(parametri, const TIP *)) != NULL; tab += new RRegElNizP<TIP>(p));
}


//////////////////////////////////////////////////////////////////////
// RRegElPermutacijaP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElPermutacijaP<TIP>::RRegElPermutacijaP(RRegElementP<TIP> *el[], T_UINT stevilo) : RRegElZbirkaP<TIP>(el, stevilo)
{
}


template <class TIP> RRegElPermutacijaP<TIP>::RRegElPermutacijaP(RRegElementP<TIP> *el, ...) : RRegElZbirkaP<TIP>()
{
    va_list parametri;
    va_start(parametri, el);
    ZgradiTabelo(el, parametri);
    va_end(parametri);
}


template <class TIP> T_BOOL RRegElPermutacijaP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);

    T_UINT i, n = tab.VrniStevilo();

    // Najprej razveljavimo vse podelemente.
    for (i = 0; i < n; i++) {
        RRegElementP<TIP> *el = tab[i];
        assert(el);
        el->Razveljavi();
    }

    // Poiemo permutacijo rekurzivno.
    if (PreveriUjemanjeRek(besedilo, zacetek, konec, zastavice)) {
        interval.zacetek = zacetek;
        return TRUE;
    } else {
        // Podelementov ni potrebno ponovno razveljaviti, saj jih je rekurzija, ker je njihovo veljavnost uporabila za oznaevanje, kateri element je bil prepoznan in kateri ne.
        interval.zacetek = (interval.konec = zacetek) + 1;
        return FALSE;
    }
}


template <class TIP> T_BOOL RRegElPermutacijaP<TIP>::PreveriUjemanjeRek(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    T_UINT i, n = tab.VrniStevilo();
    T_BOOL vsi_najdeni = TRUE;

    for (i = 0; i < n; i++) {
        RRegElementP<TIP> *el = tab[i];
        assert(el);
        if (!el->interval.JeVeljaven()) {
            // Element e ni bil prepoznan v permutaciji.
            vsi_najdeni = FALSE;
            if (el->PreveriUjemanje(besedilo, zacetek, konec, zastavice)) {
                // Nali smo element, ki se je pojavil prvi.
                if (PreveriUjemanjeRek(besedilo, el->interval.konec, konec, zastavice)) {
                    // Tudi ostanek se je izel.
                    return TRUE;
                } else {
                    // Ponovno razveljavimo element.
                    el->Razveljavi();
                }
            }
        }
    }

    if (vsi_najdeni) {
        // Vsi elementi so bili najdeni, zato je na zaetek konec permutacije.
        interval.konec = zacetek;
        return TRUE;
    } else {
        return FALSE;
    }
}


//////////////////////////////////////////////////////////////////////
// RRegElStevnikCeliP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElStevnikCeliP<TIP>::RRegElStevnikCeliP() :
    RRegElementP<TIP>(),
    vrednost(0)
{
}


template <class TIP> T_VOID RRegElStevnikCeliP<TIP>::Razveljavi()
{
    vrednost = 0;
    RRegElementP<TIP>::Razveljavi();
}


//////////////////////////////////////////////////////////////////////
// RRegElStevnikCeli10P
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElStevnikCeli10P<TIP>::RRegElStevnikCeli10P(
    RRegElementP<TIP> *_stevka_0,
    RRegElementP<TIP> *_stevka_1,
    RRegElementP<TIP> *_stevka_2,
    RRegElementP<TIP> *_stevka_3,
    RRegElementP<TIP> *_stevka_4,
    RRegElementP<TIP> *_stevka_5,
    RRegElementP<TIP> *_stevka_6,
    RRegElementP<TIP> *_stevka_7,
    RRegElementP<TIP> *_stevka_8,
    RRegElementP<TIP> *_stevka_9) :
    RRegElStevnikCeliP<TIP>(),
    stevka_0(_stevka_0),
    stevka_1(_stevka_1),
    stevka_2(_stevka_2),
    stevka_3(_stevka_3),
    stevka_4(_stevka_4),
    stevka_5(_stevka_5),
    stevka_6(_stevka_6),
    stevka_7(_stevka_7),
    stevka_8(_stevka_8),
    stevka_9(_stevka_9)
{
}


template <class TIP> T_BOOL RRegElStevnikCeli10P<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    assert(stevka_0);
    assert(stevka_1);
    assert(stevka_2);
    assert(stevka_3);
    assert(stevka_4);
    assert(stevka_5);
    assert(stevka_6);
    assert(stevka_7);
    assert(stevka_8);
    assert(stevka_9);

    T_UINT st;

    for (interval.konec = zacetek, vrednost = 0; interval.konec < konec && besedilo[interval.konec];) {
             if (stevka_0->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st = 0; interval.konec = stevka_0->interval.konec; }
        else if (stevka_1->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st = 1; interval.konec = stevka_1->interval.konec; }
        else if (stevka_2->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st = 2; interval.konec = stevka_2->interval.konec; }
        else if (stevka_3->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st = 3; interval.konec = stevka_3->interval.konec; }
        else if (stevka_4->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st = 4; interval.konec = stevka_4->interval.konec; }
        else if (stevka_5->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st = 5; interval.konec = stevka_5->interval.konec; }
        else if (stevka_6->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st = 6; interval.konec = stevka_6->interval.konec; }
        else if (stevka_7->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st = 7; interval.konec = stevka_7->interval.konec; }
        else if (stevka_8->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st = 8; interval.konec = stevka_8->interval.konec; }
        else if (stevka_9->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st = 9; interval.konec = stevka_9->interval.konec; }
        else break;

        vrednost = vrednost * 10 + st;
    }

    if (zacetek < interval.konec) {
        interval.zacetek = zacetek;
        return TRUE;
    } else {
        // tevilka ni vsebovala nobene tevke in verjetno ne predstavlja desetikega tevnika.
        interval.zacetek = (interval.konec = zacetek) + 1;
        return FALSE;
    }
}


template <class TIP> T_VOID RRegElStevnikCeli10P<TIP>::Unici()
{
    // Uniimo podelemente.
    assert(stevka_0);
    stevka_0->Unici();

    assert(stevka_1);
    stevka_1->Unici();

    assert(stevka_2);
    stevka_2->Unici();

    assert(stevka_3);
    stevka_3->Unici();

    assert(stevka_4);
    stevka_4->Unici();

    assert(stevka_5);
    stevka_5->Unici();

    assert(stevka_6);
    stevka_6->Unici();

    assert(stevka_7);
    stevka_7->Unici();

    assert(stevka_8);
    stevka_8->Unici();

    assert(stevka_9);
    stevka_9->Unici();

    RRegElStevnikCeliP<TIP>::Unici();
}


//////////////////////////////////////////////////////////////////////
// RRegElStevnikCeli10LTP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElStevnikCeli10LTP<TIP>::RRegElStevnikCeli10LTP(RRegElStevnikCeli10P<TIP> *_stevke, RRegElMaskaOsnP<TIP> *_locilo) :
    RRegElStevnikCeliP<TIP>(),
    st_mest(0),
    uporablja_locila(FALSE),
    stevke(_stevke),
    locilo(_locilo)
{
}


template <class TIP> T_BOOL RRegElStevnikCeli10LTP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    assert(stevke);
    assert(locilo);

    T_UINT odmik_zadetka = T_UINT_MAX;

    // Najprej poiemo tevilo.
    if (stevke->PreveriUjemanje(besedilo, zacetek, konec, zastavice)) {
        // Nali smo tevilo.
        vrednost         = stevke->vrednost;
        st_mest          = stevke->interval.VrniDolzino();
        uporablja_locila = FALSE;
        interval.zacetek = zacetek;
        interval.konec   = stevke->interval.konec;

        if (stevke->interval.VrniDolzino() <= 3) {
            // tevilo je najve trimestno. Mogoe je razdeljeno z loili tisoic.
            while (locilo->PreveriUjemanje(besedilo, interval.konec, konec, zastavice) &&
                (odmik_zadetka == T_UINT_MAX || odmik_zadetka == locilo->odmik_zadetka) && // Vsa loila tisoic v zaporedju morajo biti enaka, ne meana.
                stevke->PreveriUjemanje(besedilo, locilo->interval.konec, konec, zastavice) &&
                stevke->interval.VrniDolzino() == 3)
            {
                // Sledilo je loilo tisoic in tri tevke.
                vrednost          = vrednost * 1000 + stevke->vrednost;
                st_mest          += 3;
                uporablja_locila  = TRUE;
                interval.konec    = stevke->interval.konec;
                odmik_zadetka     = locilo->odmik_zadetka;
            }
        }

        return TRUE;
    } else {
        // Ni tevila ni tevnika.
        vrednost = 0;
        interval.zacetek = (interval.konec = zacetek) + 1;
        return FALSE;
    }
}


template <class TIP> T_VOID RRegElStevnikCeli10LTP<TIP>::Razveljavi()
{
    st_mest = 0;
    uporablja_locila = FALSE;
    RRegElStevnikCeliP<TIP>::Razveljavi();
}


template <class TIP> T_VOID RRegElStevnikCeli10LTP<TIP>::Unici()
{
    // Uniimo podelemente.
    assert(stevke);
    stevke->Unici();

    assert(locilo);
    locilo->Unici();

    RRegElStevnikCeliP<TIP>::Unici();
}


//////////////////////////////////////////////////////////////////////
// RRegElStevnikCeli16P
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElStevnikCeli16P<TIP>::RRegElStevnikCeli16P(
    RRegElementP<TIP> *_stevka_0,
    RRegElementP<TIP> *_stevka_1,
    RRegElementP<TIP> *_stevka_2,
    RRegElementP<TIP> *_stevka_3,
    RRegElementP<TIP> *_stevka_4,
    RRegElementP<TIP> *_stevka_5,
    RRegElementP<TIP> *_stevka_6,
    RRegElementP<TIP> *_stevka_7,
    RRegElementP<TIP> *_stevka_8,
    RRegElementP<TIP> *_stevka_9,
    RRegElementP<TIP> *_stevka_10,
    RRegElementP<TIP> *_stevka_11,
    RRegElementP<TIP> *_stevka_12,
    RRegElementP<TIP> *_stevka_13,
    RRegElementP<TIP> *_stevka_14,
    RRegElementP<TIP> *_stevka_15) :
    RRegElStevnikCeliP<TIP>(),
    stevka_0(_stevka_0),
    stevka_1(_stevka_1),
    stevka_2(_stevka_2),
    stevka_3(_stevka_3),
    stevka_4(_stevka_4),
    stevka_5(_stevka_5),
    stevka_6(_stevka_6),
    stevka_7(_stevka_7),
    stevka_8(_stevka_8),
    stevka_9(_stevka_9),
    stevka_10(_stevka_10),
    stevka_11(_stevka_11),
    stevka_12(_stevka_12),
    stevka_13(_stevka_13),
    stevka_14(_stevka_14),
    stevka_15(_stevka_15)
{
}


template <class TIP> T_BOOL RRegElStevnikCeli16P<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    assert( stevka_0);
    assert( stevka_1);
    assert( stevka_2);
    assert( stevka_3);
    assert( stevka_4);
    assert( stevka_5);
    assert( stevka_6);
    assert( stevka_7);
    assert( stevka_8);
    assert( stevka_9);
    assert(stevka_10);
    assert(stevka_11);
    assert(stevka_12);
    assert(stevka_13);
    assert(stevka_14);
    assert(stevka_15);

    T_UINT st;

    for (interval.konec = zacetek, vrednost = 0; interval.konec < konec && besedilo[interval.konec];) {
             if ( stevka_0->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st =  0; interval.konec =  stevka_0->interval.konec; }
        else if ( stevka_1->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st =  1; interval.konec =  stevka_1->interval.konec; }
        else if ( stevka_2->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st =  2; interval.konec =  stevka_2->interval.konec; }
        else if ( stevka_3->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st =  3; interval.konec =  stevka_3->interval.konec; }
        else if ( stevka_4->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st =  4; interval.konec =  stevka_4->interval.konec; }
        else if ( stevka_5->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st =  5; interval.konec =  stevka_5->interval.konec; }
        else if ( stevka_6->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st =  6; interval.konec =  stevka_6->interval.konec; }
        else if ( stevka_7->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st =  7; interval.konec =  stevka_7->interval.konec; }
        else if ( stevka_8->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st =  8; interval.konec =  stevka_8->interval.konec; }
        else if ( stevka_9->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st =  9; interval.konec =  stevka_9->interval.konec; }
        else if (stevka_10->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st = 10; interval.konec = stevka_10->interval.konec; }
        else if (stevka_11->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st = 11; interval.konec = stevka_11->interval.konec; }
        else if (stevka_12->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st = 12; interval.konec = stevka_12->interval.konec; }
        else if (stevka_13->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st = 13; interval.konec = stevka_13->interval.konec; }
        else if (stevka_14->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st = 14; interval.konec = stevka_14->interval.konec; }
        else if (stevka_15->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st = 15; interval.konec = stevka_15->interval.konec; }
        else break;

        vrednost = vrednost * 16 + st;
    }

    if (zacetek < interval.konec) {
        interval.zacetek = zacetek;
        return TRUE;
    } else {
        // tevilka ni vsebovala nobene tevke in verjetno ne predstavlja desetikega tevnika.
        interval.zacetek = (interval.konec = zacetek) + 1;
        return FALSE;
    }
}


template <class TIP> T_VOID RRegElStevnikCeli16P<TIP>::Unici()
{
    // Uniimo podelemente.
    assert(stevka_0);
    stevka_0->Unici();

    assert(stevka_1);
    stevka_1->Unici();

    assert(stevka_2);
    stevka_2->Unici();

    assert(stevka_3);
    stevka_3->Unici();

    assert(stevka_4);
    stevka_4->Unici();

    assert(stevka_5);
    stevka_5->Unici();

    assert(stevka_6);
    stevka_6->Unici();

    assert(stevka_7);
    stevka_7->Unici();

    assert(stevka_8);
    stevka_8->Unici();

    assert(stevka_9);
    stevka_9->Unici();

    assert(stevka_10);
    stevka_10->Unici();

    assert(stevka_11);
    stevka_11->Unici();

    assert(stevka_12);
    stevka_12->Unici();

    assert(stevka_13);
    stevka_13->Unici();

    assert(stevka_14);
    stevka_14->Unici();

    assert(stevka_15);
    stevka_15->Unici();

    RRegElStevnikCeliP<TIP>::Unici();
}


//////////////////////////////////////////////////////////////////////
// RRegElStevnikRimskiP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElStevnikRimskiP<TIP>::RRegElStevnikRimskiP(
    RRegElementP<TIP> *_stevka_1,
    RRegElementP<TIP> *_stevka_5,
    RRegElementP<TIP> *_stevka_10,
    RRegElementP<TIP> *_stevka_50,
    RRegElementP<TIP> *_stevka_100,
    RRegElementP<TIP> *_stevka_500,
    RRegElementP<TIP> *_stevka_1000,
    RRegElementP<TIP> *_stevka_5000,
    RRegElementP<TIP> *_stevka_10000) :
    RRegElStevnikCeliP<TIP>(),
        stevka_1(_stevka_1),
        stevka_5(_stevka_5),
       stevka_10(_stevka_10),
       stevka_50(_stevka_50),
      stevka_100(_stevka_100),
      stevka_500(_stevka_500),
     stevka_1000(_stevka_1000),
     stevka_5000(_stevka_5000),
    stevka_10000(_stevka_10000)
{
}


template <class TIP> T_BOOL RRegElStevnikRimskiP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);

    T_UINT
        st[5] = { T_UINT_MAX, T_UINT_MAX, T_UINT_MAX, T_UINT_MAX, T_UINT_MAX },
        konec2;

    for (interval.konec = zacetek, vrednost = 0; interval.konec < konec && besedilo[interval.konec]; st[3] = st[2], st[2] = st[1], st[1] = st[0], interval.konec = konec2) {
             if (    stevka_1 &&     stevka_1->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st[0] = 1;     konec2 =     stevka_1->interval.konec; }
        else if (    stevka_5 &&     stevka_5->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st[0] = 5;     konec2 =     stevka_5->interval.konec; }
        else if (   stevka_10 &&    stevka_10->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st[0] = 10;    konec2 =    stevka_10->interval.konec; }
        else if (   stevka_50 &&    stevka_50->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st[0] = 50;    konec2 =    stevka_50->interval.konec; }
        else if (  stevka_100 &&   stevka_100->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st[0] = 100;   konec2 =   stevka_100->interval.konec; }
        else if (  stevka_500 &&   stevka_500->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st[0] = 500;   konec2 =   stevka_500->interval.konec; }
        else if ( stevka_1000 &&  stevka_1000->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st[0] = 1000;  konec2 =  stevka_1000->interval.konec; }
        else if ( stevka_5000 &&  stevka_5000->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st[0] = 5000;  konec2 =  stevka_5000->interval.konec; }
        else if (stevka_10000 && stevka_10000->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st[0] = 10000; konec2 = stevka_10000->interval.konec; }
        else break;

        // Zapomnimo si prvo tevko.
        if (st[4] == T_UINT_MAX) st[4] = st[0];

        if (st[3] == st[2] && st[2] == st[1] && st[1] == st[0] && st[0] != st[4]) {
            // Nali smo etrto enako zaporedno tevko. Razen pri prvi tevki v tevniku tega ne toleriramo. Npr. XIIII namesto XIV. Lahko pa MMMMMCD. Tudi IIII.
            break;
        } else if (st[0] <= st[1]) {
            // Nova tevka je manja ali enaka prejnji. Pritejemo jo.
            vrednost += st[0];
        } else if (
            st[1] == 1    && (st[0] == 5    || st[0] == 10)   ||
            st[1] == 10   && (st[0] == 50   || st[0] == 100)  ||
            st[1] == 100  && (st[0] == 500  || st[0] == 1000) ||
            st[1] == 1000 && (st[0] == 5000 || st[0] == 10000))
        {
            // Kombinacija prejnje in nove tevke je taka, da jo odtevamo. Zato bi morali prejnjo odteti in ne priteti.

            if (st[2] < st[0]) {
                // Nova tevka je veja od predprejnje tevke. Vrstni red tevk je neveljaven. Npr. VIX (V < X => napaka)
                break;
            }

            vrednost -= st[1]; // Prejnjo tevko odtejemo, da izniimo pritevanje v prejnjem koraku.
            st[0]    -= st[1]; // Zdruimo vrednosti zadnjih dveh tevk.
            st[1]     = st[2]; // Prava prejnja tevka je sedaj tista predprejnja. :)
            st[2]     = st[3]; // Prava predprejnja tevka je sedaj tista predpredprejnja. :)
            vrednost += st[0]; // Pritejemo zdrueno vrednost.
        } else {
            // Nova tevka je veja od prejnje in ne gre za odtevanje. Vrstni red tevk je neveljaven. Npr. VX (V < X => napaka)
            break;
        }
    }

    if (vrednost) {
        interval.zacetek = zacetek;
        return TRUE;
    } else {
        // tevilka ni vsebovala nobene tevke in verjetno ne predstavlja rimskega tevnika.
        interval.zacetek = (interval.konec = zacetek) + 1;
        return FALSE;
    }
}


template <class TIP> T_VOID RRegElStevnikRimskiP<TIP>::Unici()
{
    // Uniimo podelemente.
    assert(stevka_1);
    stevka_1->Unici();

    assert(stevka_5);
    stevka_5->Unici();

    assert(stevka_10);
    stevka_10->Unici();

    assert(stevka_50);
    stevka_50->Unici();

    assert(stevka_100);
    stevka_100->Unici();

    assert(stevka_500);
    stevka_500->Unici();

    assert(stevka_1000);
    stevka_1000->Unici();

    assert(stevka_5000);
    stevka_5000->Unici();

    assert(stevka_10000);
    stevka_10000->Unici();

    RRegElStevnikCeliP<TIP>::Unici();
}


//////////////////////////////////////////////////////////////////////
// RRegElUlomekP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElUlomekP<TIP>::RRegElUlomekP(RRegElementP<TIP> *_stevec, RRegElementP<TIP> *_ulomkova_crta, RRegElementP<TIP> *_imenovalec) :
    RRegElementP<TIP>(),
    stevec(_stevec),
    ulomkova_crta(_ulomkova_crta),
    imenovalec(_imenovalec)
{
}


template <class TIP> T_BOOL RRegElUlomekP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    assert(stevec);
    assert(ulomkova_crta);
    assert(imenovalec);

    interval.konec = zacetek;

    if (stevec->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
        // Nali smo tevec.
        assert(stevec->interval.JeVeljaven());
        interval.konec = stevec->interval.konec;
    } else {
        // Nismo nali tevca, zato konamo.
        assert(!stevec->interval.JeVeljaven());
        goto konec;
    }

    if (ulomkova_crta->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
        // Nali smo ulomkovo rto.
        assert(ulomkova_crta->interval.JeVeljaven());
        interval.konec = ulomkova_crta->interval.konec;
    } else {
        // Nismo nali ulomkove rte, zato konamo.
        assert(!ulomkova_crta->interval.JeVeljaven());
        goto konec;
    }

    if (imenovalec->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
        // Nali smo imenovalec->
        assert(imenovalec->interval.JeVeljaven());
        interval.konec = imenovalec->interval.konec;
    } else {
        // Nismo nali imenovalca, zato konamo.
        assert(!imenovalec->interval.JeVeljaven());
        goto konec;
    }

    interval.zacetek = zacetek;
    return TRUE;

konec:
    stevec->Razveljavi();
    ulomkova_crta->Razveljavi();
    imenovalec->Razveljavi();
    interval.zacetek = (interval.konec = zacetek) + 1;
    return FALSE;
}


template <class TIP> T_VOID RRegElUlomekP<TIP>::Razveljavi()
{
    // Razveljavimo podelemente.
    stevec->Razveljavi();
    ulomkova_crta->Razveljavi();
    imenovalec->Razveljavi();

    RRegElementP<TIP>::Razveljavi();
}


template <class TIP> T_VOID RRegElUlomekP<TIP>::Unici()
{
    // Uniimo podelemente.
    assert(stevec);
    stevec->Unici();

    assert(ulomkova_crta);
    ulomkova_crta->Unici();

    assert(imenovalec);
    imenovalec->Unici();

    RRegElementP<TIP>::Unici();
}


//////////////////////////////////////////////////////////////////////
// RRegElSteviloCeloP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElSteviloCeloP<TIP>::RRegElSteviloCeloP(RRegElementP<TIP> *_predznak_poz, RRegElementP<TIP> *_predznak_neg, RRegElementP<TIP> *_predznak_spec, RRegElementP<TIP> *_stevilo) :
    RRegElementP<TIP>(),
    predznak_poz(_predznak_poz),
    predznak_neg(_predznak_neg),
    predznak_spec(_predznak_spec),
    stevilo(_stevilo)
{
}


template <class TIP> T_BOOL RRegElSteviloCeloP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    assert(stevilo);

    interval.konec = zacetek;

    // Najprej preverimo predznak.
    if (predznak_poz && predznak_poz->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
        assert(predznak_poz->interval.JeVeljaven());
        interval.konec = predznak_poz->interval.konec;
        if (predznak_neg)   predznak_neg->Razveljavi();
        if (predznak_spec) predznak_spec->Razveljavi();
    } else if (predznak_neg && predznak_neg->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
        assert(predznak_neg->interval.JeVeljaven());
        interval.konec = predznak_neg->interval.konec;
        if (predznak_poz)   predznak_poz->Razveljavi();
        if (predznak_spec) predznak_spec->Razveljavi();
    } else if (predznak_spec && predznak_spec->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
        assert(predznak_spec->interval.JeVeljaven());
        interval.konec = predznak_spec->interval.konec;
        if (predznak_poz) predznak_poz->Razveljavi();
        if (predznak_neg) predznak_neg->Razveljavi();
    } else {
        // Ni hudega, e predznaka ni.
        if (predznak_poz)   predznak_poz->Razveljavi();
        if (predznak_neg)   predznak_neg->Razveljavi();
        if (predznak_spec) predznak_spec->Razveljavi();
    }

    if (stevilo->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
        interval.zacetek = zacetek;
        interval.konec   = stevilo->interval.konec;
        return TRUE;
    } else {
        if (predznak_poz)   predznak_poz->Razveljavi();
        if (predznak_neg)   predznak_neg->Razveljavi();
        if (predznak_spec) predznak_spec->Razveljavi();
        stevilo->Razveljavi();
        interval.zacetek = (interval.konec = zacetek) + 1;
        return FALSE;
    }
}


template <class TIP> T_VOID RRegElSteviloCeloP<TIP>::Razveljavi()
{
    // Razveljavimo podelemente.
    if (predznak_poz)   predznak_poz->Razveljavi();
    if (predznak_neg)   predznak_neg->Razveljavi();
    if (predznak_spec) predznak_spec->Razveljavi();
    stevilo->Razveljavi();

    RRegElementP<TIP>::Razveljavi();
}


template <class TIP> T_VOID RRegElSteviloCeloP<TIP>::Unici()
{
    // Uniimo podelemente.
    if (predznak_poz)   predznak_poz->Unici();
    if (predznak_neg)   predznak_neg->Unici();
    if (predznak_spec) predznak_spec->Unici();

    assert(stevilo);
    stevilo->Unici();

    RRegElementP<TIP>::Unici();
}


//////////////////////////////////////////////////////////////////////
// RRegElSteviloRacionalnoP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElSteviloRacionalnoP<TIP>::RRegElSteviloRacionalnoP(RRegElementP<TIP> *_predznak_poz, RRegElementP<TIP> *_predznak_neg, RRegElementP<TIP> *_predznak_spec, RRegElementP<TIP> *_celi, RRegElementP<TIP> *_presledek, RRegElementP<TIP> *_ulomek) :
    RRegElementP<TIP>(),
    predznak_poz(_predznak_poz),
    predznak_neg(_predznak_neg),
    predznak_spec(_predznak_spec),
    celi(_celi),
    ulomek(_ulomek),
    presledek(_presledek)
{
}


template <class TIP> T_BOOL RRegElSteviloRacionalnoP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    assert(celi);
    assert(ulomek);
    assert(presledek);

    interval.konec = zacetek;

    // Najprej preverimo predznak.
    if (predznak_poz && predznak_poz->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
        assert(predznak_poz->interval.JeVeljaven());
        interval.konec = predznak_poz->interval.konec;
        if (predznak_neg)   predznak_neg->Razveljavi();
        if (predznak_spec) predznak_spec->Razveljavi();
    } else if (predznak_neg && predznak_neg->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
        assert(predznak_neg->interval.JeVeljaven());
        interval.konec = predznak_neg->interval.konec;
        if (predznak_poz)   predznak_poz->Razveljavi();
        if (predznak_spec) predznak_spec->Razveljavi();
    } else if (predznak_spec && predznak_spec->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
        assert(predznak_spec->interval.JeVeljaven());
        interval.konec = predznak_spec->interval.konec;
        if (predznak_poz) predznak_poz->Razveljavi();
        if (predznak_neg) predznak_neg->Razveljavi();
    } else {
        // Ni hudega, e predznaka ni.
        if (predznak_poz)   predznak_poz->Razveljavi();
        if (predznak_neg)   predznak_neg->Razveljavi();
        if (predznak_spec) predznak_spec->Razveljavi();
    }

    // Pogledamo, e imamo zaporedje <celi> <ulomek>
    if (celi->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
        // Imamo celi del. Ali sledijo presledki?

        T_UINT zastavice_presledek = zastavice & ~RREGIZR_VECVRSTICNO;  // Presledki v ulomkih nikoli ne smejo segati v novo vrstico.

        if (presledek->PreveriUjemanje(besedilo, celi->interval.konec, konec, zastavice_presledek)) {
            // Preskoimo vse presledke, e je e kaken.
            for (interval.konec = presledek->interval.konec; presledek->PreveriUjemanje(besedilo, interval.konec, konec, zastavice_presledek); interval.konec = presledek->interval.konec);

            // Ali sledi ulomek?
            if (ulomek->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
                // Nali smo zaporedje <celi> <ulomek>.
                interval.zacetek = zacetek;
                interval.konec   = ulomek->interval.konec;
                return TRUE;
            } else {
                // Ni ulomka, smo pa imeli vsaj en presledek, zato je zagotovo samo celi del.
                ulomek->Razveljavi();
                interval.zacetek = zacetek;
                interval.konec   = celi->interval.konec;
                return TRUE;
            }
        }
    }

    // Pogledamo, e imamo zaporedje <ulomek>.
    if (ulomek->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
        celi->Razveljavi();
        interval.zacetek = zacetek;
        interval.konec   = ulomek->interval.konec;
        return TRUE;
    }

    // Pogledamo, e imamo samo celi del.
    if (celi->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
        ulomek->Razveljavi();
        interval.zacetek = zacetek;
        interval.konec   = celi->interval.konec;
        return TRUE;
    }

    // Nismo nali ni pametnega.
    if (predznak_poz)   predznak_poz->Razveljavi();
    if (predznak_neg)   predznak_neg->Razveljavi();
    if (predznak_spec) predznak_spec->Razveljavi();
    celi->Razveljavi();
    ulomek->Razveljavi();
    interval.zacetek = (interval.konec = zacetek) + 1;
    return FALSE;
}


template <class TIP> T_VOID RRegElSteviloRacionalnoP<TIP>::Razveljavi()
{
    // Razveljavimo podelemente.
    if (predznak_poz)   predznak_poz->Razveljavi();
    if (predznak_neg)   predznak_neg->Razveljavi();
    if (predznak_spec) predznak_spec->Razveljavi();
    celi->Razveljavi();
    ulomek->Razveljavi();

    RRegElementP<TIP>::Razveljavi();
}


template <class TIP> T_VOID RRegElSteviloRacionalnoP<TIP>::Unici()
{
    // Uniimo podelemente.
    if (predznak_poz)   predznak_poz->Unici();
    if (predznak_neg)   predznak_neg->Unici();
    if (predznak_spec) predznak_spec->Unici();

    assert(celi);
    celi->Unici();

    assert(ulomek);
    ulomek->Unici();

    assert(presledek);
    presledek->Unici();

    RRegElementP<TIP>::Unici();
}


//////////////////////////////////////////////////////////////////////
// RRegElSteviloDecimalnoP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElSteviloDecimalnoP<TIP>::RRegElSteviloDecimalnoP(
    RRegElementP<TIP>       *_predznak_poz,
    RRegElementP<TIP>       *_predznak_neg,
    RRegElementP<TIP>       *_predznak_spec,
    RRegElStevnikCeliP<TIP> *_celi,
    RRegElementP<TIP>       *_locilo_decimalk,
    RRegElStevnikCeliP<TIP> *_decimalke,
    RRegElementP<TIP>       *_simbol_eksponenta,
    RRegElementP<TIP>       *_predznak_eksponenta_poz,
    RRegElementP<TIP>       *_predznak_eksponenta_neg,
    RRegElStevnikCeliP<TIP> *_eksponent) :
    RRegElementP<TIP>(),
    predznak_poz(_predznak_poz),
    predznak_neg(_predznak_neg),
    predznak_spec(_predznak_spec),
    celi(_celi),
    locilo_decimalk(_locilo_decimalk),
    decimalke(_decimalke),
    simbol_eksponenta(_simbol_eksponenta),
    predznak_eksponenta_poz(_predznak_eksponenta_poz),
    predznak_eksponenta_neg(_predznak_eksponenta_neg),
    eksponent(_eksponent)
{
    *((T_U8*)&vrednost) = T_DOUBLE_NAN_BIN;
}


template <class TIP> T_BOOL RRegElSteviloDecimalnoP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    assert(celi);
    assert(locilo_decimalk);
    assert(decimalke);

    interval.konec = zacetek;

    // Najprej preverimo predznak.
    if (predznak_poz && predznak_poz->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
        assert(predznak_poz->interval.JeVeljaven());
        interval.konec = predznak_poz->interval.konec;
        if (predznak_neg)   predznak_neg->Razveljavi();
        if (predznak_spec) predznak_spec->Razveljavi();
    } else if (predznak_neg && predznak_neg->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
        assert(predznak_neg->interval.JeVeljaven());
        interval.konec = predznak_neg->interval.konec;
        if (predznak_poz)   predznak_poz->Razveljavi();
        if (predznak_spec) predznak_spec->Razveljavi();
    } else if (predznak_spec && predznak_spec->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
        assert(predznak_spec->interval.JeVeljaven());
        interval.konec = predznak_spec->interval.konec;
        if (predznak_poz) predznak_poz->Razveljavi();
        if (predznak_neg) predznak_neg->Razveljavi();
    } else {
        // Ni hudega, e predznaka ni.
        if (predznak_poz)   predznak_poz->Razveljavi();
        if (predznak_neg)   predznak_neg->Razveljavi();
        if (predznak_spec) predznak_spec->Razveljavi();
    }

    // Pogledamo, do kje je celi del.
    if (celi->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
        interval.konec = celi->interval.konec;
    } else {
        // Ni hudega, e celega dela ni. Panika bo, e ne bo niti vejice in decimalk.
    }

    if (locilo_decimalk->PreveriUjemanje(besedilo, interval.konec, konec, zastavice) &&
        decimalke->PreveriUjemanje(besedilo, locilo_decimalk->interval.konec, konec, zastavice))
    {
        // Nali smo decimalno vejico in decimalke.
        interval.konec = decimalke->interval.konec;
    } else {
        locilo_decimalk->Razveljavi();
        decimalke->Razveljavi();
    }

    // e ni niti celega dela, niti decimalk, potem gre za napako.
    if (celi->interval.zacetek >= celi->interval.konec &&
        decimalke->interval.zacetek >= decimalke->interval.konec)
    {
        if (predznak_poz)   predznak_poz->Razveljavi();
        if (predznak_neg)   predznak_neg->Razveljavi();
        if (predznak_spec) predznak_spec->Razveljavi();
        celi->Razveljavi();
        locilo_decimalk->Razveljavi();
        decimalke->Razveljavi();
        if (simbol_eksponenta) simbol_eksponenta->Razveljavi();
        if (predznak_eksponenta_poz) predznak_eksponenta_poz->Razveljavi();
        if (predznak_eksponenta_neg) predznak_eksponenta_neg->Razveljavi();
        if (eksponent) eksponent->Razveljavi();
        interval.zacetek = (interval.konec = zacetek) + 1;
        return FALSE;
    }

    if (simbol_eksponenta && simbol_eksponenta->PreveriUjemanje(besedilo, interval.konec, konec, zastavice) &&
        predznak_eksponenta_poz && predznak_eksponenta_poz->PreveriUjemanje(besedilo, simbol_eksponenta->interval.konec, konec, zastavice) &&
        eksponent && eksponent->PreveriUjemanje(besedilo, predznak_eksponenta_poz->interval.konec, konec, zastavice))
    {
        // Nali smo pozitivni eksponentni zapis.
        interval.konec = eksponent->interval.konec;
        if (predznak_eksponenta_neg) predznak_eksponenta_neg->Razveljavi();
    } else if (simbol_eksponenta && simbol_eksponenta->PreveriUjemanje(besedilo, interval.konec, konec, zastavice) &&
        predznak_eksponenta_neg && predznak_eksponenta_neg->PreveriUjemanje(besedilo, simbol_eksponenta->interval.konec, konec, zastavice) &&
        eksponent && eksponent->PreveriUjemanje(besedilo, predznak_eksponenta_neg->interval.konec, konec, zastavice))
    {
        // Nali smo negativni eksponentni zapis.
        interval.konec = eksponent->interval.konec;
        if (predznak_eksponenta_poz) predznak_eksponenta_poz->Razveljavi();
    } else {
        if (simbol_eksponenta) simbol_eksponenta->Razveljavi();
        if (predznak_eksponenta_poz) predznak_eksponenta_poz->Razveljavi();
        if (predznak_eksponenta_neg) predznak_eksponenta_neg->Razveljavi();
        if (eksponent) eksponent->Razveljavi();
    }

    interval.zacetek = zacetek;

    // Izraunamo e vrednost realnega tevila.
    vrednost = (T_DOUBLE)celi->vrednost;
    if (decimalke->interval.JeVeljaven())
        vrednost += (T_DOUBLE)decimalke->vrednost * pow(10.0, -(double)decimalke->interval.VrniDolzino());
    if (predznak_neg->interval.JeVeljaven())
        vrednost = -vrednost;
    if (eksponent && eksponent->interval.JeVeljaven())
        vrednost *= pow(10.0, predznak_eksponenta_neg->interval.JeVeljaven() ? -(double)eksponent->vrednost : (double)eksponent->vrednost);

    return TRUE;
}


template <class TIP> T_VOID RRegElSteviloDecimalnoP<TIP>::Razveljavi()
{
    // Razveljavimo podelemente.
    if (predznak_poz)   predznak_poz->Razveljavi();
    if (predznak_neg)   predznak_neg->Razveljavi();
    if (predznak_spec) predznak_spec->Razveljavi();
    celi->Razveljavi();
    locilo_decimalk->Razveljavi();
    decimalke->Razveljavi();
    if (simbol_eksponenta)             simbol_eksponenta->Razveljavi();
    if (predznak_eksponenta_poz) predznak_eksponenta_poz->Razveljavi();
    if (predznak_eksponenta_neg) predznak_eksponenta_neg->Razveljavi();
    if (eksponent)                             eksponent->Razveljavi();
    *((T_U8*)&vrednost) = T_DOUBLE_NAN_BIN;

    RRegElementP<TIP>::Razveljavi();
}


template <class TIP> T_VOID RRegElSteviloDecimalnoP<TIP>::Unici()
{
    // Uniimo podelemente.
    if (predznak_poz)   predznak_poz->Unici();
    if (predznak_neg)   predznak_neg->Unici();
    if (predznak_spec) predznak_spec->Unici();

    assert(celi);
    celi->Unici();

    assert(locilo_decimalk);
    locilo_decimalk->Unici();

    assert(decimalke);
    decimalke->Unici();

    if (simbol_eksponenta)             simbol_eksponenta->Unici();
    if (predznak_eksponenta_poz) predznak_eksponenta_poz->Unici();
    if (predznak_eksponenta_neg) predznak_eksponenta_neg->Unici();
    if (eksponent)                             eksponent->Unici();

    RRegElementP<TIP>::Unici();
}


//////////////////////////////////////////////////////////////////////
// RRegElSteviloMonetarnoP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElSteviloMonetarnoP<TIP>::RRegElSteviloMonetarnoP(
    RRegElementP<TIP> *_predznak_poz,
    RRegElementP<TIP> *_predznak_neg,
    RRegElementP<TIP> *_predznak_spec,
    RRegElementP<TIP> *_valuta,
    RRegElementP<TIP> *_celi,
    RRegElementP<TIP> *_locilo_decimalk,
    RRegElementP<TIP> *_decimalke) :
    RRegElementP<TIP>(),
    predznak_poz(_predznak_poz),
    predznak_neg(_predznak_neg),
    predznak_spec(_predznak_spec),
    valuta(_valuta),
    celi(_celi),
    locilo_decimalk(_locilo_decimalk),
    decimalke(_decimalke)
{
}


template <class TIP> T_BOOL RRegElSteviloMonetarnoP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    assert(valuta);
    assert(celi);
    assert(locilo_decimalk);
    assert(decimalke);

    interval.konec = zacetek;

    // Najprej preverimo predznak.
    if (predznak_poz->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
        assert(predznak_poz->interval.JeVeljaven());
        interval.konec = predznak_poz->interval.konec;
        if (predznak_neg)   predznak_neg->Razveljavi();
        if (predznak_spec) predznak_spec->Razveljavi();
    } else if (predznak_neg->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
        assert(predznak_neg->interval.JeVeljaven());
        interval.konec = predznak_neg->interval.konec;
        if (predznak_poz)   predznak_poz->Razveljavi();
        if (predznak_spec) predznak_spec->Razveljavi();
    } else if (predznak_spec->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
        assert(predznak_spec->interval.JeVeljaven());
        interval.konec = predznak_spec->interval.konec;
        if (predznak_poz) predznak_poz->Razveljavi();
        if (predznak_neg) predznak_neg->Razveljavi();
    } else {
        // Ni hudega, e predznaka ni.
        if (predznak_poz)   predznak_poz->Razveljavi();
        if (predznak_neg)   predznak_neg->Razveljavi();
        if (predznak_spec) predznak_spec->Razveljavi();
    }

    if (valuta->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
        // Sledi oznaka valute.
        interval.konec = valuta->interval.konec;
    } else {
        // e ni valute, potem ne gre za monetarno tevilo.
        if (predznak_poz)   predznak_poz->Razveljavi();
        if (predznak_neg)   predznak_neg->Razveljavi();
        if (predznak_spec) predznak_spec->Razveljavi();
        celi->Razveljavi();
        locilo_decimalk->Razveljavi();
        decimalke->Razveljavi();
        interval.zacetek = (interval.konec = zacetek) + 1;
        return FALSE;
    }

    // Pogledamo, do kje je celi del.
    if (celi->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
        interval.konec = celi->interval.konec;
    } else {
        // Ni hudega, e celega dela ni. Panika bo, e ne bo niti vejice in decimalk.
    }

    if (locilo_decimalk->PreveriUjemanje(besedilo, interval.konec, konec, zastavice) &&
        decimalke->PreveriUjemanje(besedilo, locilo_decimalk->interval.konec, konec, zastavice))
    {
        // Nali smo decimalno vejico in decimalke.
        interval.konec = decimalke->interval.konec;
    } else {
        locilo_decimalk->Razveljavi();
        decimalke->Razveljavi();
    }

    // e ni ne celega dela, ne decimalk, potem gre za napako.
    if (celi->interval.zacetek >= celi->interval.konec &&
        decimalke->interval.zacetek >= decimalke->interval.konec)
    {
        if (predznak_poz)   predznak_poz->Razveljavi();
        if (predznak_neg)   predznak_neg->Razveljavi();
        if (predznak_spec) predznak_spec->Razveljavi();
        valuta->Razveljavi();
        celi->Razveljavi();
        locilo_decimalk->Razveljavi();
        decimalke->Razveljavi();
        interval.zacetek = (interval.konec = zacetek) + 1;
        return FALSE;
    }

    interval.zacetek = zacetek;
    return TRUE;
}


template <class TIP> T_VOID RRegElSteviloMonetarnoP<TIP>::Razveljavi()
{
    // Razveljavimo podelemente.
    if (predznak_poz)   predznak_poz->Razveljavi();
    if (predznak_neg)   predznak_neg->Razveljavi();
    if (predznak_spec) predznak_spec->Razveljavi();
    valuta->Razveljavi();
    celi->Razveljavi();
    locilo_decimalk->Razveljavi();
    decimalke->Razveljavi();

    RRegElementP<TIP>::Razveljavi();
}


template <class TIP> T_VOID RRegElSteviloMonetarnoP<TIP>::Unici()
{
    // Uniimo podelemente.
    if (predznak_poz)   predznak_poz->Unici();
    if (predznak_neg)   predznak_neg->Unici();
    if (predznak_spec) predznak_spec->Unici();

    assert(valuta);
    valuta->Unici();

    assert(celi);
    celi->Unici();

    assert(locilo_decimalk);
    locilo_decimalk->Unici();

    assert(decimalke);
    decimalke->Unici();

    RRegElementP<TIP>::Unici();
}


//////////////////////////////////////////////////////////////////////
// RRegElIPv4NaslovP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElIPv4NaslovP<TIP>::RRegElIPv4NaslovP(
    RRegElementP<TIP> *_stevka_0,
    RRegElementP<TIP> *_stevka_1,
    RRegElementP<TIP> *_stevka_2,
    RRegElementP<TIP> *_stevka_3,
    RRegElementP<TIP> *_stevka_4,
    RRegElementP<TIP> *_stevka_5,
    RRegElementP<TIP> *_stevka_6,
    RRegElementP<TIP> *_stevka_7,
    RRegElementP<TIP> *_stevka_8,
    RRegElementP<TIP> *_stevka_9,
    RRegElementP<TIP> *_locilo) :
    RRegElementP<TIP>(),
    vrednost(0),
    stevka_0(_stevka_0),
    stevka_1(_stevka_1),
    stevka_2(_stevka_2),
    stevka_3(_stevka_3),
    stevka_4(_stevka_4),
    stevka_5(_stevka_5),
    stevka_6(_stevka_6),
    stevka_7(_stevka_7),
    stevka_8(_stevka_8),
    stevka_9(_stevka_9),
    locilo(_locilo)
{
    vrednost = 0;
}


template <class TIP> T_BOOL RRegElIPv4NaslovP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    assert(stevka_0);
    assert(stevka_1);
    assert(stevka_2);
    assert(stevka_3);
    assert(stevka_4);
    assert(stevka_5);
    assert(stevka_6);
    assert(stevka_7);
    assert(stevka_8);
    assert(stevka_9);
    assert(locilo);

    T_UINT i;

    interval.konec = zacetek;
    vrednost = 0;

    for (i = 0; i < 4; i++) {
        // Doloimo komponento IP.
        T_UINT x;
        T_BOOL je_prazna = TRUE;

        if (i) {
            if (locilo->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
                // Nali smo loilo med komponentama.
                interval.konec = locilo->interval.konec;
            } else {
                // Manjka loilo.
                goto napaka;
            }
        }

        komponente[i].zacetek = interval.konec;
        for (x = 0; interval.konec < konec && besedilo[interval.konec];) {
            T_UINT st, j, x_n;

                 if (stevka_0->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st = 0; j = stevka_0->interval.konec; }
            else if (stevka_1->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st = 1; j = stevka_1->interval.konec; }
            else if (stevka_2->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st = 2; j = stevka_2->interval.konec; }
            else if (stevka_3->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st = 3; j = stevka_3->interval.konec; }
            else if (stevka_4->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st = 4; j = stevka_4->interval.konec; }
            else if (stevka_5->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st = 5; j = stevka_5->interval.konec; }
            else if (stevka_6->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st = 6; j = stevka_6->interval.konec; }
            else if (stevka_7->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st = 7; j = stevka_7->interval.konec; }
            else if (stevka_8->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st = 8; j = stevka_8->interval.konec; }
            else if (stevka_9->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) { st = 9; j = stevka_9->interval.konec; }
            else break;

            x_n = x * 10 + st;
            if (x_n <= 0xff) {
                x = x_n;
                interval.konec = j;
                je_prazna = FALSE;
            } else {
                // Cifra je prevelika.
                break;
            }
        }
        if (je_prazna) {
            // Komponenta je bila prazna.
            goto napaka;
        }

        komponente[i].konec = interval.konec;
        vrednost = (vrednost << 8) | (T_U1)x;
    }

    if (i < 4) {
        // Nismo nali vseh komponent.
        goto napaka;
    }

    interval.zacetek = zacetek;
    return TRUE;

napaka:
    komponente[0].zacetek = 1;
    komponente[0].konec   = 0;
    komponente[1].zacetek = 1;
    komponente[1].konec   = 0;
    komponente[2].zacetek = 1;
    komponente[2].konec   = 0;
    komponente[3].zacetek = 1;
    komponente[3].konec   = 0;
    vrednost = 0;
    interval.zacetek = (interval.konec = zacetek) + 1;
    return FALSE;
}


template <class TIP> T_VOID RRegElIPv4NaslovP<TIP>::Razveljavi()
{
    // Razveljavimo podelemente.
    komponente[0].zacetek = 1;
    komponente[0].konec   = 0;
    komponente[1].zacetek = 1;
    komponente[1].konec   = 0;
    komponente[2].zacetek = 1;
    komponente[2].konec   = 0;
    komponente[3].zacetek = 1;
    komponente[3].konec   = 0;
    vrednost = 0;

    RRegElementP<TIP>::Razveljavi();
}


template <class TIP> T_VOID RRegElIPv4NaslovP<TIP>::Unici()
{
    // Uniimo podelemente.
    assert(stevka_0);
    stevka_0->Unici();

    assert(stevka_1);
    stevka_1->Unici();

    assert(stevka_2);
    stevka_2->Unici();

    assert(stevka_3);
    stevka_3->Unici();

    assert(stevka_4);
    stevka_4->Unici();

    assert(stevka_5);
    stevka_5->Unici();

    assert(stevka_6);
    stevka_6->Unici();

    assert(stevka_7);
    stevka_7->Unici();

    assert(stevka_8);
    stevka_8->Unici();

    assert(stevka_9);
    stevka_9->Unici();

    assert(locilo);
    locilo->Unici();

    RRegElementP<TIP>::Unici();
}


//////////////////////////////////////////////////////////////////////
// RRegElDNSNaslovZnakP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElDNSNaslovZnakP<TIP>::RRegElDNSNaslovZnakP(T_BOOL _je_lahko_IDN) :
    RRegElementP<TIP>(),
    je_lahko_IDN(_je_lahko_IDN),
    je_lahko_robni(TRUE)
{
}


template <class TIP> T_BOOL RRegElDNSNaslovZnakP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    UNREFERENCED_PARAMETER(zastavice);

    if (zacetek < konec && besedilo[zacetek]) {
        if (('A' <= besedilo[zacetek] && besedilo[zacetek] <= 'Z') ||
            ('a' <= besedilo[zacetek] && besedilo[zacetek] <= 'z') ||
            ('0' <= besedilo[zacetek] && besedilo[zacetek] <= '9'))
        {
            je_lahko_robni = TRUE;
        } else if (besedilo[zacetek] == '-') {
            je_lahko_robni = FALSE;
        } else if (je_lahko_IDN && aisalnum(besedilo[zacetek])) {
            je_lahko_robni = TRUE;
        } else {
            interval.zacetek = (interval.konec = zacetek) + 1;
            return FALSE;
        }

        interval.konec = (interval.zacetek = zacetek) + 1;
        return TRUE;
    }

    interval.zacetek = (interval.konec = zacetek) + 1;
    return FALSE;
}


//////////////////////////////////////////////////////////////////////
// RRegElDNSNaslovP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElDNSNaslovP<TIP>::RRegElDNSNaslovP(T_BOOL _je_lahko_absolutni, RRegElDNSNaslovZnakP<TIP> *_znak_komponente, RRegElementP<TIP> *_locilo) :
    RRegElementP<TIP>(),
    je_lahko_absolutni(_je_lahko_absolutni),
    znak_komponente(_znak_komponente),
    locilo(_locilo)
{
}


template <class TIP> T_BOOL RRegElDNSNaslovP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    assert(znak_komponente);
    assert(locilo);

    T_UINT
        i = zacetek,
        st_komponent;

    for (st_komponent = 0; i < konec && besedilo[i] && st_komponent < 127; st_komponent++) {
        if (znak_komponente->PreveriUjemanje(besedilo, i, konec, zastavice) &&
            znak_komponente->je_lahko_robni)
        {
            // Nali smo zaetek komponente.
            interval.konec = i = znak_komponente->interval.konec;

            // Poiemo e konec komponente.
            while (i < konec && besedilo[i]) {
                if (znak_komponente->je_lahko_robni &&
                    locilo->PreveriUjemanje(besedilo, i, konec, zastavice))
                {
                    // Nali smo konec komponente.
                    if (je_lahko_absolutni)
                        interval.konec = i = locilo->interval.konec;
                    else {
                        interval.konec = i;
                        i = locilo->interval.konec;
                    }
                    break;
                } else if (znak_komponente->PreveriUjemanje(besedilo, i, konec, zastavice)) {
                    if (znak_komponente->je_lahko_robni) {
                        // Nali smo znak, ki pripada komponenti naslova DNS.
                        interval.konec = i = znak_komponente->interval.konec;
                    } else {
                        // Nali smo vezaj, ki pa ne sme stati na koncu komponente. Zato ga e ne razglasimo za del komponente.
                        i = znak_komponente->interval.konec;
                    }
                } else {
                    // Nali smo neznani znak.
                    interval.zacetek = zacetek;
                    return TRUE;
                }
            }
        } else {
            // Nali smo neznani znak.
            break;
        }
    }

    if (st_komponent) {
        // Nali smo vsaj eno komponento.
        interval.zacetek = zacetek;
        return TRUE;
    } else {
        // Nimamo nobene komponente. To ni veljaven naslov DNS.
        interval.zacetek = (interval.konec = zacetek) + 1;
        return FALSE;
    }
}


template <class TIP> T_VOID RRegElDNSNaslovP<TIP>::Unici()
{
    // Uniimo podelemente.
    assert(znak_komponente);
    znak_komponente->Unici();

    assert(locilo);
    locilo->Unici();

    RRegElementP<TIP>::Unici();
}


//////////////////////////////////////////////////////////////////////
// RRegElURLUporabnikZnakP
//////////////////////////////////////////////////////////////////////

template <class TIP> T_BOOL RRegElURLUporabnikZnakP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    UNREFERENCED_PARAMETER(zastavice);

    if (zacetek < konec && besedilo[zacetek]) {
        if (besedilo[zacetek] == '-'  ||
            besedilo[zacetek] == '.'  ||
            besedilo[zacetek] == '_'  ||
            besedilo[zacetek] == '~'  ||
            besedilo[zacetek] == '%'  ||
            besedilo[zacetek] == '!'  ||
            besedilo[zacetek] == '$'  ||
            besedilo[zacetek] == '&'  ||
            besedilo[zacetek] == '\'' ||
            besedilo[zacetek] == '('  ||
            besedilo[zacetek] == ')'  ||
            besedilo[zacetek] == '*'  ||
            besedilo[zacetek] == '+'  ||
            besedilo[zacetek] == ','  ||
            besedilo[zacetek] == ';'  ||
            besedilo[zacetek] == '='  ||
            aisalnum(besedilo[zacetek]))
        {
            interval.konec = (interval.zacetek = zacetek) + 1;
            return TRUE;
        }
    }

    interval.zacetek = (interval.konec = zacetek) + 1;
    return FALSE;
}


//////////////////////////////////////////////////////////////////////
// RRegElURLGesloZnakP
//////////////////////////////////////////////////////////////////////

template <class TIP> T_BOOL RRegElURLGesloZnakP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    UNREFERENCED_PARAMETER(zastavice);

    if (zacetek < konec && besedilo[zacetek]) {
        if (besedilo[zacetek] == '-'  ||
            besedilo[zacetek] == '.'  ||
            besedilo[zacetek] == '_'  ||
            besedilo[zacetek] == '~'  ||
            besedilo[zacetek] == '%'  ||
            besedilo[zacetek] == '!'  ||
            besedilo[zacetek] == '$'  ||
            besedilo[zacetek] == '&'  ||
            besedilo[zacetek] == '\'' ||
            besedilo[zacetek] == '('  ||
            besedilo[zacetek] == ')'  ||
            besedilo[zacetek] == '*'  ||
            besedilo[zacetek] == '+'  ||
            besedilo[zacetek] == ','  ||
            besedilo[zacetek] == ';'  ||
            besedilo[zacetek] == '='  ||
            besedilo[zacetek] == ':'  ||
            aisalnum(besedilo[zacetek]))
        {
            interval.konec = (interval.zacetek = zacetek) + 1;
            return TRUE;
        }
    }

    interval.zacetek = (interval.konec = zacetek) + 1;
    return FALSE;
}


//////////////////////////////////////////////////////////////////////
// RRegElURLPotZnakP
//////////////////////////////////////////////////////////////////////

template <class TIP> T_BOOL RRegElURLPotZnakP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    UNREFERENCED_PARAMETER(zastavice);

    if (zacetek < konec && besedilo[zacetek]) {
        if (besedilo[zacetek] == '/'  ||
            besedilo[zacetek] == '-'  ||
            besedilo[zacetek] == '.'  ||
            besedilo[zacetek] == '_'  ||
            besedilo[zacetek] == '~'  ||
            besedilo[zacetek] == '%'  ||
            besedilo[zacetek] == '!'  ||
            besedilo[zacetek] == '$'  ||
            besedilo[zacetek] == '&'  ||
            besedilo[zacetek] == '\'' ||
            besedilo[zacetek] == '('  ||
            besedilo[zacetek] == ')'  ||
            besedilo[zacetek] == '*'  ||
            besedilo[zacetek] == '+'  ||
            besedilo[zacetek] == ','  ||
            besedilo[zacetek] == ';'  ||
            besedilo[zacetek] == '='  ||
            besedilo[zacetek] == ':'  ||
            besedilo[zacetek] == '@'  ||
            besedilo[zacetek] == '?'  ||
            besedilo[zacetek] == '#'  ||
            aisalnum(besedilo[zacetek]))
        {
            interval.konec = (interval.zacetek = zacetek) + 1;
            return TRUE;
        }
    }

    interval.zacetek = (interval.konec = zacetek) + 1;
    return FALSE;
}


//////////////////////////////////////////////////////////////////////
// RRegElURLPot
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElURLPotP<TIP>::RRegElURLPotP(RRegElementP<TIP> *_pot_znak, RRegElementP<TIP> *_poizvedba_zacetek, RRegElementP<TIP> *_zaznamek_zacetek) :
    RRegElementP<TIP>(),
    pot_znak(_pot_znak),
    poizvedba_zacetek(_poizvedba_zacetek),
    zaznamek_zacetek(_zaznamek_zacetek)
{
}


template <class TIP> T_BOOL RRegElURLPotP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    assert(pot_znak);
    assert(poizvedba_zacetek);
    assert(zaznamek_zacetek);

    // Pojdimo lepo od zaetka.
    interval.konec    = zacetek;
    pot.zacetek       = zacetek;
    poizvedba.zacetek = 1;
    poizvedba.konec   = 0;
    zaznamek.zacetek  = 1;
    zaznamek.konec    = 0;

    for (;;) {
        if (interval.konec >= konec || !besedilo[interval.konec]) {
            // Zmanjkalo je znakov.
            break;
        } else if (poizvedba_zacetek->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
            // Nali smo konec poti in zaetek poizvedbe.
            pot.konec         = interval.konec;
            poizvedba.zacetek = interval.konec = poizvedba_zacetek->interval.konec;
            for (;;) {
                if (interval.konec >= konec || !besedilo[interval.konec]) {
                    // Zmanjkalo je znakov.
                    poizvedba.konec = interval.konec;
                    break;
                } else if (zaznamek_zacetek->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
                    // Nali smo konec poizvedbe in zaetek zaznamka.
                    poizvedba.konec  = interval.konec;
                    zaznamek.zacetek = interval.konec = zaznamek_zacetek->interval.konec;
                    for (;;) {
                        if (interval.konec >= konec || !besedilo[interval.konec]) {
                            // Zmanjkalo je znakov.
                            zaznamek.konec = interval.konec;
                            break;
                        } else if (pot_znak->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
                            // Znak je del zaznamka.
                            interval.konec = pot_znak->interval.konec;
                        } else {
                            // Znak ni ve del zaznamka.
                            zaznamek.konec = interval.konec;
                            break;
                        }
                    }
                    interval.zacetek = zacetek;
                    return TRUE;
                } else if (pot_znak->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
                    // Znak je del poizvedbe.
                    interval.konec = pot_znak->interval.konec;
                } else {
                    // Znak ni ve del poizvedbe.
                    poizvedba.konec = interval.konec;
                    break;
                }
            }
            interval.zacetek = zacetek;
            return TRUE;
        } else if (zaznamek_zacetek->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
            // Nali smo konec poti in zaetek zaznamka.
            pot.konec        = interval.konec;
            zaznamek.zacetek = interval.konec = zaznamek_zacetek->interval.konec;
            for (;;) {
                if (interval.konec >= konec || !besedilo[interval.konec]) {
                    // Zmanjkalo je znakov.
                    zaznamek.konec = interval.konec;
                    break;
                } else if (pot_znak->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
                    // Znak je del zaznamka.
                    interval.konec = pot_znak->interval.konec;
                } else {
                    // Znak ni ve del zaznamka.
                    zaznamek.konec = interval.konec;
                    break;
                }
            }
            interval.zacetek = zacetek;
            return TRUE;
        } else if (pot_znak->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
            // Znak je del poti.
            interval.konec = pot_znak->interval.konec;
        } else {
            // Znak ni ve del poti.
            break;
        }
    }

    if (zacetek < interval.konec) {
        pot.konec        = interval.konec;
        interval.zacetek = zacetek;
        return TRUE;
    } else {
        // Nismo nali niesar uporabnega.
        pot.zacetek      = 1;
        pot.konec        = 0;
        zaznamek.zacetek = 1;
        zaznamek.konec   = 0;
        interval.zacetek = (interval.konec = zacetek) + 1;
        return FALSE;
    }
}


template <class TIP> T_VOID RRegElURLPotP<TIP>::Razveljavi()
{
    // Razveljavimo podelemente.
    pot.zacetek       = 1;
    pot.konec         = 0;
    poizvedba.zacetek = 1;
    poizvedba.konec   = 0;
    zaznamek.zacetek  = 1;
    zaznamek.konec    = 0;

    RRegElementP<TIP>::Razveljavi();
}


template <class TIP> T_VOID RRegElURLPotP<TIP>::Unici()
{
    // Uniimo podelemente.
    assert(pot_znak);
    pot_znak->Unici();

    assert(poizvedba_zacetek);
    poizvedba_zacetek->Unici();

    assert(zaznamek_zacetek);
    zaznamek_zacetek->Unici();

    RRegElementP<TIP>::Unici();
}


//////////////////////////////////////////////////////////////////////
// RRegElURLNaslovP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElURLNaslovP<TIP>::RRegElURLNaslovP(
    RRegElementP<TIP> *_shema_http,
    RRegElementP<TIP> *_shema_ftp,
    RRegElementP<TIP> *_shema_mailto,
    RRegElementP<TIP> *_shema_file,
    RRegElementP<TIP> *_dvopicje,
    RRegElementP<TIP> *_posevnica,
    RRegElementP<TIP> *_uporabnik,
    RRegElementP<TIP> *_geslo,
    RRegElementP<TIP> *_ajka,
    RRegElementP<TIP> *_streznik_ip,
    RRegElementP<TIP> *_streznik_dns,
    RRegElementP<TIP> *_vrata,
    RRegElementP<TIP> *_pot) :
    RRegElementP<TIP>(),
    shema_http(_shema_http),
    shema_ftp(_shema_ftp),
    shema_mailto(_shema_mailto),
    shema_file(_shema_file),
    dvopicje(_dvopicje),
    posevnica(_posevnica),
    uporabnik(_uporabnik),
    geslo(_geslo),
    ajka(_ajka),
    streznik_ip(_streznik_ip),
    streznik_dns(_streznik_dns),
    vrata(_vrata),
    pot(_pot)
{
}


template <class TIP> T_BOOL RRegElURLNaslovP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    assert(shema_http);
    assert(shema_ftp);
    assert(shema_mailto);
    assert(shema_file);
    assert(dvopicje);
    assert(posevnica);
    assert(uporabnik);
    assert(geslo);
    assert(ajka);
    assert(streznik_ip);
    assert(streznik_dns);
    assert(vrata);
    assert(pot);

    // Pojdimo lepo od zaetka.
    interval.konec = zacetek;

    // Poiemo shemo.
    if (shema_http->PreveriUjemanje(besedilo, interval.konec, konec, zastavice) &&
        dvopicje->PreveriUjemanje(besedilo, shema_http->interval.konec, konec, zastavice) &&
        posevnica->PreveriUjemanje(besedilo, dvopicje->interval.konec, konec, zastavice) &&
        posevnica->PreveriUjemanje(besedilo, posevnica->interval.konec, konec, zastavice))
    {
        // Nali smo "http://".
        interval.konec = posevnica->interval.konec;
        shema_ftp->Razveljavi();
        shema_mailto->Razveljavi();
        shema_file->Razveljavi();
    } else if (shema_ftp->PreveriUjemanje(besedilo, interval.konec, konec, zastavice) &&
        dvopicje->PreveriUjemanje(besedilo, shema_ftp->interval.konec, konec, zastavice) &&
        posevnica->PreveriUjemanje(besedilo, dvopicje->interval.konec, konec, zastavice) &&
        posevnica->PreveriUjemanje(besedilo, posevnica->interval.konec, konec, zastavice))
    {
        // Nali smo shemo "ftp://".
        interval.konec = posevnica->interval.konec;
        shema_http->Razveljavi();
        shema_mailto->Razveljavi();
        shema_file->Razveljavi();
    } else if (shema_mailto->PreveriUjemanje(besedilo, interval.konec, konec, zastavice) &&
        dvopicje->PreveriUjemanje(besedilo, shema_mailto->interval.konec, konec, zastavice))
    {
        // Nali smo shemo "mailto:".
        interval.konec = dvopicje->interval.konec;
        shema_http->Razveljavi();
        shema_ftp->Razveljavi();
        shema_file->Razveljavi();
    } else if (shema_file->PreveriUjemanje(besedilo, interval.konec, konec, zastavice) &&
        dvopicje->PreveriUjemanje(besedilo, shema_file->interval.konec, konec, zastavice) &&
        posevnica->PreveriUjemanje(besedilo, dvopicje->interval.konec, konec, zastavice) &&
        posevnica->PreveriUjemanje(besedilo, posevnica->interval.konec, konec, zastavice))
    {
        // Nali smo shemo "file://".
        interval.konec = posevnica->interval.konec;
        shema_http->Razveljavi();
        shema_ftp->Razveljavi();
        shema_mailto->Razveljavi();
    } else {
        // Nismo nali nobene znane sheme. V nadaljevanju bomo obravnavali naslov URL po shemi "http:".
        shema_http->Razveljavi();
        shema_ftp->Razveljavi();
        shema_mailto->Razveljavi();
        shema_file->Razveljavi();
    }

    if (shema_ftp->interval.JeVeljaven()) {
        // Nali smo shemo "ftp://".

        // Poiemo uporabnika in geslo.
        if (uporabnik->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
            if (dvopicje->PreveriUjemanje(besedilo, uporabnik->interval.konec, konec, zastavice) &&
                geslo->PreveriUjemanje(besedilo, dvopicje->interval.konec, konec, zastavice) &&
                ajka->PreveriUjemanje(besedilo, geslo->interval.konec, konec, zastavice))
            {
                // Nali smo tako uporabnika, kot geslo.
                interval.konec = ajka->interval.konec;
            } else if (ajka->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
                // Nali smo samo uporabnika, geslo pa je prazno.
                interval.konec = ajka->interval.konec;
                geslo->Razveljavi();
            } else {
                // Uporabnik ni bil pravilno zakljuen, torej ni uporabnika, niti gesla.
                uporabnik->Razveljavi();
                geslo->Razveljavi();
            }
        } else {
            // Nimamo niti uporabnika, niti gesla. Oitno gre za anonimno prijavo.
            uporabnik->Razveljavi();
            geslo->Razveljavi();
        }

        // Poiemo naslov strenika.
        if (streznik_ip->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
            // Naslov je v zapisu IP.
            interval.konec = streznik_ip->interval.konec;
            streznik_dns->Razveljavi();
        } else if (streznik_dns->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
            // Naslov je v zapisu DNS.
            interval.konec = streznik_dns->interval.konec;
            streznik_ip->Razveljavi();
        } else {
            // Nismo nali naslova strenika, kar pri shemi "ftp://" ni dovoljeno.
            Razveljavi();
            return FALSE;
        }

        // Ali sledi zapis vrat?
        if (dvopicje->PreveriUjemanje(besedilo, interval.konec, konec, zastavice) &&
            vrata->PreveriUjemanje(besedilo, dvopicje->interval.konec, konec, zastavice))
        {
            // Nali smo zapis o vratih.
            interval.konec = vrata->interval.konec;
        } else
            vrata->Razveljavi();

        // Poiemo pot.
        if (pot->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
            // Nali smo pot.
            interval.konec = pot->interval.konec;
        }

        interval.zacetek = zacetek;
        return TRUE;
    } else if (shema_mailto->interval.JeVeljaven()) {
        // Nali smo shemo "mailto:".

        // Poiemo uporabnika.
        if (uporabnik->PreveriUjemanje(besedilo, interval.konec, konec, zastavice) &&
            ajka->PreveriUjemanje(besedilo, uporabnik->interval.konec, konec, zastavice))
        {
            // Nali smo uporabnika.
            interval.konec = ajka->interval.konec;
        } else {
            // Nimamo uporabnika, kar pri shemi "mailto:" ni dovoljeno.
            Razveljavi();
            return FALSE;
        }

        // Poiemo naslov strenika.
        if (streznik_ip->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
            // Naslov je v zapisu IP.
            interval.konec = streznik_ip->interval.konec;
            streznik_dns->Razveljavi();
        } else if (streznik_dns->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
            // Naslov je v zapisu DNS.
            interval.konec = streznik_dns->interval.konec;
            streznik_ip->Razveljavi();
        } else {
            // Nismo nali naslova strenika, kar pri shemi "ftp://" ni dovoljeno.
            Razveljavi();
            return FALSE;
        }

        // Razveljavimo podelemente, ki jih ta shema ne predvideva.
        geslo->Razveljavi();
        vrata->Razveljavi();
        pot->Razveljavi();

        interval.zacetek = zacetek;
        return TRUE;
    } else if (shema_file->interval.JeVeljaven()) {
        // Nali smo shemo "file:".

        // Poiemo pot.
        if (pot->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
            // Nali smo pot.
            interval.konec = pot->interval.konec;
        }

        // Razveljavimo podelemente, ki jih ta shema ne predvideva.
        uporabnik->Razveljavi();
        geslo->Razveljavi();
        streznik_ip->Razveljavi();
        streznik_dns->Razveljavi();
        vrata->Razveljavi();

        interval.zacetek = zacetek;
        return TRUE;
    } else {
        // Nali (oziroma privzeli) smo shemo "http:".

        // Poiemo uporabnika in geslo. Vendar le, e je bila shema "http://" izrecno navedena.
        if (shema_http->interval.JeVeljaven() &&
            uporabnik->PreveriUjemanje(besedilo, interval.konec, konec, zastavice))
        {
            if (dvopicje->PreveriUjemanje(besedilo, uporabnik->interval.konec, konec, zastavice) &&
                geslo->PreveriUjemanje(besedilo, dvopicje->interval.konec, konec, zastavice) &&
                ajka->PreveriUjemanje(besedilo, geslo->interval.konec, konec, zastavice))
            {
                // Nali smo tako uporabnika, kot geslo.
                interval.konec = ajka->interval.konec;
            } else if (ajka->PreveriUjemanje(besedilo, uporabnik->interval.konec, konec, zastavice)) {
                // Nali smo samo uporabnika, geslo pa je prazno.
                interval.konec = ajka->interval.konec;
                geslo->Razveljavi();
            } else {
                // Uporabnik ni bil pravilno zakljuen, torej ni uporabnika, niti gesla.
                uporabnik->Razveljavi();
                geslo->Razveljavi();
            }
        } else {
            // Nimamo niti uporabnika, niti gesla. Oitno gre za anonimno prijavo.
            uporabnik->Razveljavi();
            geslo->Razveljavi();
        }

        // Poiemo naslov strenika.
        if (streznik_ip->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
            // Naslov je v zapisu IP.
            interval.konec = streznik_ip->interval.konec;
            streznik_dns->Razveljavi();
        } else if (streznik_dns->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
            // Naslov je v zapisu DNS.
            interval.konec = streznik_dns->interval.konec;
            streznik_ip->Razveljavi();
        } else {
            // Nismo nali naslova strenika, kar pri shemi "http:" ni dovoljeno.
            Razveljavi();
            return FALSE;
        }

        // Ali sledi zapis vrat?
        if (dvopicje->PreveriUjemanje(besedilo, interval.konec, konec, zastavice) &&
            vrata->PreveriUjemanje(besedilo, dvopicje->interval.konec, konec, zastavice))
        {
            // Nali smo zapis o vratih.
            interval.konec = vrata->interval.konec;
        } else
            vrata->Razveljavi();

        // Poiemo pot.
        if (pot->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
            // Nali smo pot.
            interval.konec = pot->interval.konec;
        }

        interval.zacetek = zacetek;
        return TRUE;
    }
}


template <class TIP> T_VOID RRegElURLNaslovP<TIP>::Razveljavi()
{
    // Razveljavimo podelemente.
    shema_http->Razveljavi();
    shema_ftp->Razveljavi();
    shema_mailto->Razveljavi();
    shema_file->Razveljavi();
    uporabnik->Razveljavi();
    geslo->Razveljavi();
    streznik_ip->Razveljavi();
    streznik_dns->Razveljavi();
    vrata->Razveljavi();
    pot->Razveljavi();

    RRegElementP<TIP>::Razveljavi();
}


template <class TIP> T_VOID RRegElURLNaslovP<TIP>::Unici()
{
    // Uniimo podelemente.
    assert(shema_http);
    shema_http->Unici();

    assert(shema_ftp);
    shema_ftp->Unici();

    assert(shema_mailto);
    shema_mailto->Unici();

    assert(shema_file);
    shema_file->Unici();

    assert(uporabnik);
    uporabnik->Unici();

    assert(geslo);
    geslo->Unici();

    assert(streznik_ip);
    streznik_ip->Unici();

    assert(streznik_dns);
    streznik_dns->Unici();

    assert(vrata);
    vrata->Unici();

    assert(pot);
    pot->Unici();

    assert(dvopicje);
    dvopicje->Unici();

    assert(posevnica);
    posevnica->Unici();

    assert(ajka);
    ajka->Unici();

    RRegElementP<TIP>::Unici();
}


//////////////////////////////////////////////////////////////////////
// RRegElEPostaNaslovP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElEPostaNaslovP<TIP>::RRegElEPostaNaslovP(RRegElementP<TIP> *_uporabnik, RRegElementP<TIP> *_locilo, RRegElementP<TIP> *_domena) :
    RRegElementP<TIP>(),
    uporabnik(_uporabnik),
    locilo(_locilo),
    domena(_domena)
{
}


template <class TIP> T_BOOL RRegElEPostaNaslovP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    assert(uporabnik);
    assert(locilo);
    assert(domena);

    if (uporabnik->PreveriUjemanje(besedilo, zacetek, konec, zastavice) &&
        locilo->PreveriUjemanje(besedilo, uporabnik->interval.konec, konec, zastavice) &&
        domena->PreveriUjemanje(besedilo, locilo->interval.konec, konec, zastavice))
    {
        // Nali smo veljaven e-naslov.
        interval.zacetek = zacetek;
        interval.konec   = domena->interval.konec;
        return TRUE;
    }

    uporabnik->Razveljavi();
    locilo->Razveljavi();
    domena->Razveljavi();
    interval.zacetek = (interval.konec = zacetek) + 1;
    return FALSE;
}


template <class TIP> T_VOID RRegElEPostaNaslovP<TIP>::Razveljavi()
{
    // Razveljavimo podelemente.
    uporabnik->Razveljavi();
    locilo->Razveljavi();
    domena->Razveljavi();

    RRegElementP<TIP>::Razveljavi();
}


template <class TIP> T_VOID RRegElEPostaNaslovP<TIP>::Unici()
{
    // Uniimo podelemente.
    assert(uporabnik);
    uporabnik->Unici();

    assert(locilo);
    locilo->Unici();

    assert(domena);
    domena->Unici();

    RRegElementP<TIP>::Unici();
}


//////////////////////////////////////////////////////////////////////
// RRegElSmeskoP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElSmeskoP<TIP>::RRegElSmeskoP(RRegElementP<TIP> *_smesko, RRegElementP<TIP> *_teme, RRegElementP<TIP> *_oci, RRegElementP<TIP> *_nos, RRegElMaskaOsnP<TIP> *_usta) :
    RRegElementP<TIP>(),
    smesko(_smesko),
    teme(_teme),
    oci(_oci),
    nos(_nos),
    usta(_usta)
{
}


template <class TIP> T_BOOL RRegElSmeskoP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    assert(oci);
    assert(usta);

    if (smesko && smesko->PreveriUjemanje(besedilo, zacetek, konec, zastavice)) {
        // Cel smeko je zapisan kot en sam znak.
        if (teme) teme->Razveljavi();
        oci->Razveljavi();
        if (nos) nos->Razveljavi();
        usta->Razveljavi();
        interval.zacetek = zacetek;
        interval.konec   = smesko->interval.konec;
        return TRUE;
    }

    interval.konec = zacetek;

    if (teme && teme->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
        // Nali smo teme/svetniki sij.
        interval.konec = teme->interval.konec;
    }

    if (oci->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
        // Nali smo oi.

        if (nos && nos->PreveriUjemanje(besedilo, oci->interval.konec, konec, zastavice) &&
            usta->PreveriUjemanje(besedilo, nos->interval.konec, konec, zastavice))
        {
            // Nali smo nos in usta.
            T_UINT
                zacetek_usta  = usta->interval.zacetek,
                odmik_zadetka = usta->odmik_zadetka;

            // Pretejemo, kolikokrat se usta ponovijo. :-)))))))
            for (interval.konec = usta->interval.konec; usta->PreveriUjemanje(besedilo, interval.konec, konec, zastavice) && usta->odmik_zadetka == odmik_zadetka; interval.konec = usta->interval.konec);

            usta->interval.zacetek = zacetek_usta;
            usta->interval.konec   = interval.konec;
            interval.zacetek = zacetek;
            return TRUE;
        } else if (usta->PreveriUjemanje(besedilo, oci->interval.konec, konec, zastavice)) {
            // Nali smo samo e usta.
            T_UINT
                zacetek_usta  = usta->interval.zacetek,
                odmik_zadetka = usta->odmik_zadetka;

            // Pretejemo, kolikokrat se usta ponovijo. :-)))))))
            for (interval.konec = usta->interval.konec; usta->PreveriUjemanje(besedilo, interval.konec, konec, zastavice) && usta->odmik_zadetka == odmik_zadetka; interval.konec = usta->interval.konec);

            if (nos) nos->Razveljavi();
            usta->interval.zacetek = zacetek_usta;
            usta->interval.konec   = interval.konec;
            interval.zacetek = zacetek;
            return TRUE;
        }
    }

    // Nismo nali ni uporabnega.
    if (smesko) smesko->Razveljavi();
    if (teme) teme->Razveljavi();
    oci->Razveljavi();
    if (nos) nos->Razveljavi();
    usta->Razveljavi();
    interval.zacetek = (interval.konec = zacetek) + 1;
    return FALSE;
}


template <class TIP> T_VOID RRegElSmeskoP<TIP>::Razveljavi()
{
    // Razveljavimo podelemente.
    if (smesko) smesko->Razveljavi();
    if (teme) teme->Razveljavi();
    oci->Razveljavi();
    if (nos) nos->Razveljavi();
    usta->Razveljavi();

    RRegElementP<TIP>::Razveljavi();
}


template <class TIP> T_VOID RRegElSmeskoP<TIP>::Unici()
{
    // Uniimo podelemente.
    if (smesko) smesko->Unici();
    if (teme) teme->Unici();

    assert(oci);
    oci->Unici();

    if (nos) nos->Unici();

    assert(usta);
    usta->Unici();

    RRegElementP<TIP>::Unici();
}


//////////////////////////////////////////////////////////////////////
// RRegElDatumP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElDatumP<TIP>::RRegElDatumP(T_UINT _zapis, RRegElStevnikCeliP<TIP> *_dan, RRegElStevnikCeliP<TIP> *_mesec, RRegElStevnikCeliP<TIP> *_leto, RRegElMaskaOsnP<TIP> *_locilo, RRegElementP<TIP> *_presledek) :
    RRegElementP<TIP>(),
    najden_zapis(0),
    zapis(_zapis),
    dan(_dan),
    mesec(_mesec),
    leto(_leto),
    locilo(_locilo),
    presledek(_presledek)
{
}


template <class TIP> T_BOOL RRegElDatumP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    assert(locilo);
    assert(((zapis & RREGIZR_DATUM_DML) == 0 && (zapis & RREGIZR_DATUM_MDL) == 0 && (zapis & RREGIZR_DATUM_LMD) == 0 && (zapis & RREGIZR_DATUM_DM) == 0 && (zapis & RREGIZR_DATUM_MD) == 0                                                                      ) || dan);
    assert(((zapis & RREGIZR_DATUM_DML) == 0 && (zapis & RREGIZR_DATUM_MDL) == 0 && (zapis & RREGIZR_DATUM_LMD) == 0 && (zapis & RREGIZR_DATUM_LM) == 0 && (zapis & RREGIZR_DATUM_ML) == 0 && (zapis & RREGIZR_DATUM_DM) == 0 && (zapis & RREGIZR_DATUM_MD) == 0) || mesec);
    assert(((zapis & RREGIZR_DATUM_DML) == 0 && (zapis & RREGIZR_DATUM_MDL) == 0 && (zapis & RREGIZR_DATUM_LMD) == 0 && (zapis & RREGIZR_DATUM_LM) == 0 && (zapis & RREGIZR_DATUM_ML) == 0                                                                      ) || leto);

    T_UINT odmik_zadetka;
    T_UINT zastavice_presledek = zastavice & ~RREGIZR_VECVRSTICNO; // Presledki v datumih nikoli ne smejo segati v novo vrstico.

    if ((zapis & RREGIZR_DATUM_DML) != 0) {
        if (dan->PreveriUjemanje(besedilo, zacetek, konec, zastavice)) {
            for (interval.konec = dan->interval.konec; presledek->PreveriUjemanje(besedilo, interval.konec, konec, zastavice_presledek); interval.konec = presledek->interval.konec);
            if (locilo->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
                odmik_zadetka = locilo->odmik_zadetka;
                for (interval.konec = locilo->interval.konec; presledek->PreveriUjemanje(besedilo, interval.konec, konec, zastavice_presledek); interval.konec = presledek->interval.konec);
                if (mesec->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
                    for (interval.konec = mesec->interval.konec; presledek->PreveriUjemanje(besedilo, interval.konec, konec, zastavice_presledek); interval.konec = presledek->interval.konec);
                    if (locilo->PreveriUjemanje(besedilo, interval.konec, konec, zastavice) &&
                        locilo->odmik_zadetka == odmik_zadetka) // Obe loili morata biti enaki.
                    {
                        for (interval.konec = locilo->interval.konec; presledek->PreveriUjemanje(besedilo, interval.konec, konec, zastavice_presledek); interval.konec = presledek->interval.konec);
                        if (leto->PreveriUjemanje(besedilo, interval.konec, konec, zastavice) &&
                            JeVeljaven(dan->vrednost, mesec->vrednost))
                        {
                            // Nali smo datum v priakovanem zapisu. :)
                            interval.zacetek = zacetek;
                            interval.konec   = leto->interval.konec;
                            najden_zapis     = RREGIZR_DATUM_DML;
                            return TRUE;
                        }
                    }
                }
            }
        }
    }

    if ((zapis & RREGIZR_DATUM_MDL) != 0) {
        if (mesec->PreveriUjemanje(besedilo, zacetek, konec, zastavice)) {
            for (interval.konec = mesec->interval.konec; presledek->PreveriUjemanje(besedilo, interval.konec, konec, zastavice_presledek); interval.konec = presledek->interval.konec);
            if (locilo->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
                odmik_zadetka = locilo->odmik_zadetka;
                for (interval.konec = locilo->interval.konec; presledek->PreveriUjemanje(besedilo, interval.konec, konec, zastavice_presledek); interval.konec = presledek->interval.konec);
                if (dan->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
                    for (interval.konec = dan->interval.konec; presledek->PreveriUjemanje(besedilo, interval.konec, konec, zastavice_presledek); interval.konec = presledek->interval.konec);
                    if (locilo->PreveriUjemanje(besedilo, interval.konec, konec, zastavice) &&
                        locilo->odmik_zadetka == odmik_zadetka) // Obe loili morata biti enaki.
                    {
                        for (interval.konec = locilo->interval.konec; presledek->PreveriUjemanje(besedilo, interval.konec, konec, zastavice_presledek); interval.konec = presledek->interval.konec);
                        if (leto->PreveriUjemanje(besedilo, interval.konec, konec, zastavice) &&
                            JeVeljaven(dan->vrednost, mesec->vrednost))
                        {
                            // Nali smo datum v priakovanem zapisu. :)
                            interval.zacetek = zacetek;
                            interval.konec   = leto->interval.konec;
                            najden_zapis     = RREGIZR_DATUM_MDL;
                            return TRUE;
                        }
                    }
                }
            }
        }
    }

    if ((zapis & RREGIZR_DATUM_LMD) != 0) {
        if (leto->PreveriUjemanje(besedilo, zacetek, konec, zastavice)) {
            for (interval.konec = leto->interval.konec; presledek->PreveriUjemanje(besedilo, interval.konec, konec, zastavice_presledek); interval.konec = presledek->interval.konec);
            if (locilo->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
                odmik_zadetka = locilo->odmik_zadetka;
                for (interval.konec = locilo->interval.konec; presledek->PreveriUjemanje(besedilo, interval.konec, konec, zastavice_presledek); interval.konec = presledek->interval.konec);
                if (mesec->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
                    for (interval.konec = mesec->interval.konec; presledek->PreveriUjemanje(besedilo, interval.konec, konec, zastavice_presledek); interval.konec = presledek->interval.konec);
                    if (locilo->PreveriUjemanje(besedilo, interval.konec, konec, zastavice) &&
                        locilo->odmik_zadetka == odmik_zadetka) // Obe loili morata biti enaki.
                    {
                        for (interval.konec = locilo->interval.konec; presledek->PreveriUjemanje(besedilo, interval.konec, konec, zastavice_presledek); interval.konec = presledek->interval.konec);
                        if (dan->PreveriUjemanje(besedilo, interval.konec, konec, zastavice) &&
                            JeVeljaven(dan->vrednost, mesec->vrednost))
                        {
                            // Nali smo datum v priakovanem zapisu. :)
                            interval.zacetek = zacetek;
                            interval.konec   = dan->interval.konec;
                            najden_zapis     = RREGIZR_DATUM_LMD;
                            return TRUE;
                        }
                    }
                }
            }
        }
    }

    if ((zapis & RREGIZR_DATUM_LM) != 0) {
        if (leto->PreveriUjemanje(besedilo, zacetek, konec, zastavice)) {
            for (interval.konec = leto->interval.konec; presledek->PreveriUjemanje(besedilo, interval.konec, konec, zastavice_presledek); interval.konec = presledek->interval.konec);
            if (locilo->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
                for (interval.konec = locilo->interval.konec; presledek->PreveriUjemanje(besedilo, interval.konec, konec, zastavice_presledek); interval.konec = presledek->interval.konec);
                if (mesec->PreveriUjemanje(besedilo, interval.konec, konec, zastavice) &&
                    JeVeljaven(T_UINT_MAX, mesec->vrednost))
                {
                    // Nali smo datum v priakovanem zapisu. :)
                    if (dan) dan->Razveljavi();
                    interval.zacetek = zacetek;
                    interval.konec   = mesec->interval.konec;
                    najden_zapis     = RREGIZR_DATUM_LM;
                    return TRUE;
                }
            }
        }
    }

    if ((zapis & RREGIZR_DATUM_ML) != 0) {
        if (mesec->PreveriUjemanje(besedilo, zacetek, konec, zastavice)) {
            for (interval.konec = mesec->interval.konec; presledek->PreveriUjemanje(besedilo, interval.konec, konec, zastavice_presledek); interval.konec = presledek->interval.konec);
            if (locilo->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
                for (interval.konec = locilo->interval.konec; presledek->PreveriUjemanje(besedilo, interval.konec, konec, zastavice_presledek); interval.konec = presledek->interval.konec);
                if (leto->PreveriUjemanje(besedilo, interval.konec, konec, zastavice) &&
                    JeVeljaven(T_UINT_MAX, mesec->vrednost))
                {
                    // Nali smo datum v priakovanem zapisu. :)
                    if (dan) dan->Razveljavi();
                    interval.zacetek = zacetek;
                    interval.konec   = leto->interval.konec;
                    najden_zapis     = RREGIZR_DATUM_ML;
                    return TRUE;
                }
            }
        }
    }

    if ((zapis & RREGIZR_DATUM_DM) != 0) {
        if (dan->PreveriUjemanje(besedilo, zacetek, konec, zastavice)) {
            for (interval.konec = dan->interval.konec; presledek->PreveriUjemanje(besedilo, interval.konec, konec, zastavice_presledek); interval.konec = presledek->interval.konec);
            if (locilo->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
                odmik_zadetka = locilo->odmik_zadetka;
                for (interval.konec = locilo->interval.konec; presledek->PreveriUjemanje(besedilo, interval.konec, konec, zastavice_presledek); interval.konec = presledek->interval.konec);
                if (mesec->PreveriUjemanje(besedilo, interval.konec, konec, zastavice) &&
                    JeVeljaven(dan->vrednost, mesec->vrednost))
                {
                    // Nali smo datum v priakovanem zapisu. :)
                    if (leto) leto->Razveljavi();
                    interval.zacetek = zacetek;
                    for (interval.konec = mesec->interval.konec; presledek->PreveriUjemanje(besedilo, interval.konec, konec, zastavice_presledek); interval.konec = presledek->interval.konec);
                    if (locilo->PreveriUjemanje(besedilo, interval.konec, konec, zastavice) &&
                        locilo->odmik_zadetka == odmik_zadetka) // Obe loili morata biti enaki.
                    {
                        // Nali smo e zakljuno loilo.
                        interval.konec = locilo->interval.konec;
                    } else
                        interval.konec = mesec->interval.konec;
                    najden_zapis = RREGIZR_DATUM_DM;
                    return TRUE;
                }
            }
        }
    }

    if ((zapis & RREGIZR_DATUM_MD) != 0) {
        if (mesec->PreveriUjemanje(besedilo, zacetek, konec, zastavice)) {
            for (interval.konec = mesec->interval.konec; presledek->PreveriUjemanje(besedilo, interval.konec, konec, zastavice_presledek); interval.konec = presledek->interval.konec);
            if (locilo->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
                odmik_zadetka = locilo->odmik_zadetka;
                for (interval.konec = locilo->interval.konec; presledek->PreveriUjemanje(besedilo, interval.konec, konec, zastavice_presledek); interval.konec = presledek->interval.konec);
                if (dan->PreveriUjemanje(besedilo, interval.konec, konec, zastavice) &&
                    JeVeljaven(dan->vrednost, mesec->vrednost))
                {
                    // Nali smo datum v priakovanem zapisu. :)
                    if (leto) leto->Razveljavi();
                    interval.zacetek = zacetek;
                    for (interval.konec = dan->interval.konec; presledek->PreveriUjemanje(besedilo, interval.konec, konec, zastavice_presledek); interval.konec = presledek->interval.konec);
                    if (locilo->PreveriUjemanje(besedilo, interval.konec, konec, zastavice) &&
                        locilo->odmik_zadetka == odmik_zadetka) // Obe loili morata biti enaki.
                    {
                        // Nali smo e zakljuno loilo.
                        interval.konec = locilo->interval.konec;
                    } else
                        interval.konec = dan->interval.konec;
                    najden_zapis = RREGIZR_DATUM_MD;
                    return TRUE;
                }
            }
        }
    }

    // Datuma v elenem zapisu nismo nali.
    if (dan)   dan->Razveljavi();
    if (mesec) mesec->Razveljavi();
    if (leto)  leto->Razveljavi();
    najden_zapis = 0;
    interval.zacetek = (interval.konec = zacetek) + 1;
    return FALSE;
}


template <class TIP> T_VOID RRegElDatumP<TIP>::Razveljavi()
{
    // Razveljavimo podelemente.
    if (dan)     dan->Razveljavi();
    if (mesec) mesec->Razveljavi();
    if (leto)   leto->Razveljavi();
    najden_zapis = 0;

    RRegElementP<TIP>::Razveljavi();
}


template <class TIP> T_VOID RRegElDatumP<TIP>::Unici()
{
    // Uniimo podelemente.
    if (dan)   dan->Unici();
    if (mesec) mesec->Unici();
    if (leto)  leto->Unici();

    assert(locilo);
    locilo->Unici();

    assert(presledek);
    presledek->Unici();

    RRegElementP<TIP>::Unici();
}


template <class TIP> inline T_BOOL RRegElDatumP<TIP>::JeVeljaven(T_UINT dan, T_UINT mesec) const
{
    if (mesec == T_UINT_MAX) {
        // e mesec ni podan, privzamemo januar. Tako preverjamo le e dan, e je med 1 in 31, saj ima januar vseh 31 dni.
        mesec = 1;
    }
    if (dan == T_UINT_MAX) {
        // e dan ni podan, privzamemo 1. v mesecu. Tako preverjamo le e mesec, e je med 1 in 12, saj ima vsak mesec prvi dan.
        dan = 1;
    }

    switch (mesec) {
        case 1:
        case 3:
        case 5:
        case 7:
        case 8:
        case 10:
        case 12:
            return 1 <= dan && dan <= 31;
        case 2:
            return 1 <= dan && dan <= 29;
        case 4:
        case 6:
        case 9:
        case 11:
            return 1 <= dan && dan <= 30;
        default:
            return FALSE;
    }
}


//////////////////////////////////////////////////////////////////////
// RRegElCasP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElCasP<TIP>::RRegElCasP(RRegElStevnikCeli10P<TIP> *_ura, RRegElStevnikCeli10P<TIP> *_minuta, RRegElStevnikCeli10P<TIP> *_sekunda, RRegElStevnikCeli10P<TIP> *_tisocinka, RRegElMaskaOsnP<TIP> *_locilo, RRegElementP<TIP> *_locilo_tisocink) :
    RRegElementP<TIP>(),
    ura(_ura),
    minuta(_minuta),
    sekunda(_sekunda),
    tisocinka(_tisocinka),
    locilo(_locilo),
    locilo_tisocink(_locilo_tisocink)
{
}


template <class TIP> T_BOOL RRegElCasP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    assert(ura);
    assert(minuta);
    assert(locilo);

    T_UINT odmik_zadetka;

    if (ura->PreveriUjemanje(besedilo, zacetek, konec, zastavice) &&
        locilo->PreveriUjemanje(besedilo, ura->interval.konec, konec, zastavice) &&
        minuta->PreveriUjemanje(besedilo, locilo->interval.konec, konec, zastavice) &&
        minuta->vrednost < 60)
    {
        // Nali smo osnovni zapis asa. Poiemo, e imamo mogoe tudi sekunde.
        odmik_zadetka = locilo->odmik_zadetka;
        if (locilo->PreveriUjemanje(besedilo, minuta->interval.konec, konec, zastavice) &&
            locilo->odmik_zadetka == odmik_zadetka && // Obe loili morata biti enaki.
            sekunda && sekunda->PreveriUjemanje(besedilo, locilo->interval.konec, konec, zastavice) &&
            sekunda->vrednost < 60)
        {
            // Nali smo tudi sekunde. Mogoe bomo nali e tisoinke.
            if (locilo_tisocink && locilo_tisocink->PreveriUjemanje(besedilo, sekunda->interval.konec, konec, zastavice) &&
                tisocinka && tisocinka->PreveriUjemanje(besedilo, locilo_tisocink->interval.konec, konec, zastavice) &&
                tisocinka->vrednost < 1000)
            {
                // Nali smo tudi tisoinke.
                interval.konec = tisocinka->interval.konec;
            } else {
                // Nismo nali tisoink.
                if (tisocinka) tisocinka->Razveljavi();
                interval.konec = sekunda->interval.konec;
            }
        } else {
            // Nismo nali sekund, tisoink nismo ve niti iskali.
            if (sekunda)   sekunda->Razveljavi();
            if (tisocinka) tisocinka->Razveljavi();
            interval.konec = minuta->interval.konec;
        }

        interval.zacetek = zacetek;
        return TRUE;
    } else {
        // Nismo nali ni uporabnega.
        ura->Razveljavi();
        minuta->Razveljavi();
        if (sekunda)   sekunda->Razveljavi();
        if (tisocinka) tisocinka->Razveljavi();
        interval.zacetek = (interval.konec = zacetek) + 1;
        return FALSE;
    }
}


template <class TIP> T_VOID RRegElCasP<TIP>::Razveljavi()
{
    // Razveljavimo podelemente.
    ura->Razveljavi();
    minuta->Razveljavi();
    if (sekunda)   sekunda->Razveljavi();
    if (tisocinka) tisocinka->Razveljavi();

    RRegElementP<TIP>::Razveljavi();
}


template <class TIP> T_VOID RRegElCasP<TIP>::Unici()
{
    // Uniimo podelemente.
    ura->Unici();
    minuta->Unici();
    if (sekunda)     sekunda->Unici();
    if (tisocinka) tisocinka->Unici();

    assert(locilo);
    locilo->Unici();

    if (locilo_tisocink) locilo_tisocink->Unici();

    RRegElementP<TIP>::Unici();
}


//////////////////////////////////////////////////////////////////////
// RRegElKotP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElKotP<TIP>::RRegElKotP(RRegElStevnikCeli10P<TIP> *_stopinja, RRegElementP<TIP> *_locilo_stopinj, RRegElStevnikCeli10P<TIP> *_minuta, RRegElementP<TIP> *_locilo_minut, RRegElStevnikCeli10P<TIP> *_sekunda, RRegElementP<TIP> *_locilo_sekund, RRegElStevnikCeli10P<TIP> *_decimalke) :
    RRegElementP<TIP>(),
    stopinja(_stopinja),
    locilo_stopinj(_locilo_stopinj),
    minuta(_minuta),
    locilo_minut(_locilo_minut),
    sekunda(_sekunda),
    locilo_sekund(_locilo_sekund),
    decimalke(_decimalke)
{
}


template <class TIP> T_BOOL RRegElKotP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    assert(stopinja);
    assert(locilo_stopinj);
    assert(minuta);
    assert(locilo_minut);

    interval.konec = zacetek;

    if (stopinja->PreveriUjemanje(besedilo, interval.konec, konec, zastavice) &&
        locilo_stopinj->PreveriUjemanje(besedilo, stopinja->interval.konec, konec, zastavice))
    {
        // Nali smo stopinje.
        interval.konec = locilo_stopinj->interval.konec;
    } else {
        stopinja->Razveljavi();
        locilo_stopinj->Razveljavi();
    }

    if (minuta->PreveriUjemanje(besedilo, interval.konec, konec, zastavice) &&
        minuta->vrednost < 60 &&
        locilo_minut->PreveriUjemanje(besedilo, minuta->interval.konec, konec, zastavice))
    {
        // Nali smo minute.
        interval.konec = locilo_minut->interval.konec;
    } else {
        minuta->Razveljavi();
        locilo_minut->Razveljavi();
    }

    if (sekunda && sekunda->PreveriUjemanje(besedilo, interval.konec, konec, zastavice) &&
        sekunda->vrednost < 60)
    {
        // Nali smo sekunde
        interval.konec = sekunda->interval.konec;

        if (locilo_sekund && locilo_sekund->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
            // Nali smo e zakljuno loilo sekund.
            interval.konec = locilo_sekund->interval.konec;
        } else {
            // Zakljuno loilo sekund manjka.
            if (locilo_sekund) locilo_sekund->Razveljavi();
        }
    } else {
        if (sekunda)       sekunda->Razveljavi();
        if (locilo_sekund) locilo_sekund->Razveljavi();
    }

    if (           stopinja->interval.zacetek < stopinja->interval.konec ||
                     minuta->interval.zacetek <   minuta->interval.konec ||
        sekunda &&  sekunda->interval.zacetek <  sekunda->interval.konec)
    {
        // Nali smo kot, mogoe sledijo e decimalke.
        if (decimalke && decimalke->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
            // Nali smo decimalke.
            interval.konec = decimalke->interval.konec;
        } else if (decimalke)
            decimalke->Razveljavi();

        interval.zacetek = zacetek;
        return TRUE;
    } else {
        // Nismo nali ni kotu podobnega.
        if (decimalke) decimalke->Razveljavi();
        interval.zacetek = (interval.konec = zacetek) + 1;
        return FALSE;
    }
}


template <class TIP> T_VOID RRegElKotP<TIP>::Razveljavi()
{
    // Razveljavimo podelemente.
    stopinja->Razveljavi();
    locilo_stopinj->Razveljavi();
    minuta->Razveljavi();
    locilo_minut->Razveljavi();
    if (sekunda)       sekunda->Razveljavi();
    if (locilo_sekund) locilo_sekund->Razveljavi();
    if (decimalke)     decimalke->Razveljavi();

    RRegElementP<TIP>::Razveljavi();
}


template <class TIP> T_VOID RRegElKotP<TIP>::Unici()
{
    // Uniimo podelemente.
    assert(stopinja);
    stopinja->Unici();

    assert(locilo_stopinj);
    locilo_stopinj->Unici();

    assert(minuta);
    minuta->Unici();

    assert(locilo_minut);
    locilo_minut->Unici();

    if (sekunda)             sekunda->Unici();
    if (locilo_sekund) locilo_sekund->Unici();
    if (decimalke)         decimalke->Unici();

    RRegElementP<TIP>::Unici();
}


//////////////////////////////////////////////////////////////////////
// RRegElTelefonskaStevilkaP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElTelefonskaStevilkaP<TIP>::RRegElTelefonskaStevilkaP(RRegElementP<TIP> *_stevka, RRegElementP<TIP> *_uvodno_locilo, RRegElMaskaOsnP<TIP> *_oklepaj, RRegElMaskaOsnP<TIP> *_zaklepaj, RRegElementP<TIP> *_locilo, RRegElementP<TIP> *_presledek) :
    RRegElementP<TIP>(),
    stevka(_stevka),
    uvodno_locilo(_uvodno_locilo),
    oklepaj(_oklepaj),
    zaklepaj(_zaklepaj),
    locilo(_locilo),
    presledek(_presledek)
{
}


template <class TIP> T_BOOL RRegElTelefonskaStevilkaP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    assert(stevka);

    T_UINT varni_konec_stevk = zacetek, varna_dolzina_stevilke = 0;
    T_BOOL ima_stevke = FALSE, je_za_stevko = FALSE, je_v_oklepaju = FALSE, je_za_zaklepajem = FALSE;
    T_UINT zastavice_presledek = zastavice & ~RREGIZR_VECVRSTICNO;  // Presledki v telefonskih tevilkah nikoli ne smejo segati v novo vrstico.

    interval.konec = zacetek;
    stevilka.Sprazni();
    oklepaj->Razveljavi();
    zaklepaj->Razveljavi();

    if (uvodno_locilo && uvodno_locilo->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
        // Nali smo uvodno loilo.
        stevilka.Prilepi(besedilo + uvodno_locilo->interval.zacetek, uvodno_locilo->interval.VrniDolzino());
        varna_dolzina_stevilke = stevilka.VrniDolzino();
        interval.konec = uvodno_locilo->interval.konec;
    }

    for (;;) {
        if (interval.konec >= konec || !besedilo[interval.konec]) {
            // Zmanjkalo nam je znakov.
            break;
        } else if (stevka->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
            // Nali smo tevko.
            stevilka.Prilepi(besedilo + stevka->interval.zacetek, stevka->interval.VrniDolzino());
            interval.konec = stevka->interval.konec;
            if (!je_v_oklepaju) {
                // Oklepaj ni odprt, zato bo ta tevka zagotovo del telefonske tevilke.
                varni_konec_stevk      = interval.konec;
                varna_dolzina_stevilke = stevilka.VrniDolzino();
                ima_stevke             = TRUE;
            }
            je_za_stevko     = TRUE;
            je_za_zaklepajem = FALSE;
        } else if (
            oklepaj  &&  !oklepaj->interval.JeVeljaven() && // Oklepaj e ni nastopil prej.
            zaklepaj && !zaklepaj->interval.JeVeljaven() && // Zaklepaj ne sme nastopiti pred oklepajem.
            oklepaj->PreveriUjemanje(besedilo, interval.konec, konec, zastavice))
        {
            // Nali smo oklepaj.
            stevilka.Prilepi(besedilo + oklepaj->interval.zacetek, oklepaj->interval.VrniDolzino());
            interval.konec   = oklepaj->interval.konec;
            je_v_oklepaju    = TRUE;
            je_za_stevko     = FALSE;
            je_za_zaklepajem = FALSE;
        } else if (
            je_v_oklepaju && // Oklepaj je e odprt.
            zaklepaj && !zaklepaj->interval.JeVeljaven() && // Zaklepaj e ni nastopil.
            zaklepaj->PreveriUjemanje(besedilo, interval.konec, konec, zastavice) &&
            oklepaj->odmik_zadetka == zaklepaj->odmik_zadetka) // Zaklepaj mora ustrezati oklepaju.
        {
            // Nali smo ustrezen zaklepaj.
            stevilka.Prilepi(besedilo + zaklepaj->interval.zacetek, zaklepaj->interval.VrniDolzino());
            interval.konec         = zaklepaj->interval.konec;
            varni_konec_stevk      = interval.konec;
            varna_dolzina_stevilke = stevilka.VrniDolzino();
            je_v_oklepaju    = FALSE;
            je_za_stevko     = FALSE;
            je_za_zaklepajem = TRUE;
        } else if (
            je_za_stevko &&
            !je_v_oklepaju && // V oklepajih ne smejo nastopati loila.
            !je_za_zaklepajem && // Za zaklepajem ne sme biti loilo.
            locilo && locilo->PreveriUjemanje(besedilo, interval.konec, konec, zastavice))
        {
            // Nali smo loilo.
            interval.konec   = locilo->interval.konec;
            je_za_stevko     = FALSE;
            je_za_zaklepajem = FALSE;
        } else if (
            (je_za_stevko || je_za_zaklepajem) &&
            presledek && presledek->PreveriUjemanje(besedilo, interval.konec, konec, zastavice_presledek))
        {
            // Nali smo presledek.
            interval.konec   = presledek->interval.konec;
            je_za_stevko     = FALSE;
            je_za_zaklepajem = FALSE;
        } else
            break;
    }

    if (ima_stevke) {
        // Nali smo vsaj eno tevko. Loila in presledke na koncu ignoriramo.
        stevilka.Skrajsaj(varna_dolzina_stevilke);
        stevilka.SprostiOdvecne();
        interval.zacetek = zacetek;
        interval.konec   = varni_konec_stevk;
        return TRUE;
    } else {
        // tevilka ni vsebovala nobene tevke in verjetno ne predstavlja telefonske tevilke.
        stevilka.Sprazni();
        interval.zacetek = (interval.konec = zacetek) + 1;
        return FALSE;
    }
}


template <class TIP> T_VOID RRegElTelefonskaStevilkaP<TIP>::Razveljavi()
{
    // Razveljavimo podelemente.
    stevilka.Sprazni();

    RRegElementP<TIP>::Razveljavi();
}


template <class TIP> T_VOID RRegElTelefonskaStevilkaP<TIP>::Unici()
{
    // Uniimo podelemente.
    assert(stevka);
    stevka->Unici();

    if (uvodno_locilo) uvodno_locilo->Unici();
    if (oklepaj)             oklepaj->Unici();
    if (zaklepaj)           zaklepaj->Unici();
    if (locilo)               locilo->Unici();
    if (presledek)         presledek->Unici();

    RRegElementP<TIP>::Razveljavi();
}


//////////////////////////////////////////////////////////////////////
// RRegElKemijskaSpojinaP
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElKemijskaSpojinaP<TIP>::RRegElKemijskaSpojinaP(RRegElementP<TIP> *_element, RRegElementP<TIP> *_stevka, RRegElementP<TIP> *_predznak) :
    RRegElementP<TIP>(),
    element(_element),
    stevka(_stevka),
    predznak(_predznak),
    ima_stevke(FALSE),
    ima_naboj(FALSE)
{
}


template <class TIP> T_BOOL RRegElKemijskaSpojinaP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    assert(element);
    assert(stevka);
    assert(predznak);

    ima_stevke = FALSE;
    ima_naboj  = FALSE;
    interval.konec = zacetek;

    for (;;) {
        // Pri preverjanju kemijskega elementa moramo vedno razlikovati med velikimi in malimi rkami.
        // e je uporabnik sluajno navedel zastavico RREGIZR_NE_LOCUJ_VELIKIH_MALIH, jo izloimo.
        if (element->PreveriUjemanje(besedilo, interval.konec, konec, zastavice & (~RREGIZR_NE_LOCUJ_VELIKIH_MALIH))) {
            // Nali smo kemijski element. Pogledamo, e mu sledijo tevke.
            interval.konec = element->interval.konec;

            // Obdelamo vse tevke.
            while (stevka->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
                interval.konec = stevka->interval.konec;
                ima_stevke = TRUE;
            }
        } else
            break;
    }

    if (zacetek < interval.konec) {
        // Nali smo vsaj en element.

        // Pogledamo, e na koncu stoji e predznak, ki doloa ione.
        if (predznak->PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
            interval.konec = predznak->interval.konec;
            ima_naboj = TRUE;
        }

        interval.zacetek = zacetek;
        return TRUE;
    } else {
        // Nismo nali niesar uporabnega.
        interval.zacetek = (interval.konec = zacetek) + 1;
        return FALSE;
    }
}


template <class TIP> T_VOID RRegElKemijskaSpojinaP<TIP>::Razveljavi()
{
    // Razveljavimo podelemente.
    ima_stevke = FALSE;
    ima_naboj  = FALSE;

    RRegElementP<TIP>::Razveljavi();
}


template <class TIP> T_VOID RRegElKemijskaSpojinaP<TIP>::Unici()
{
    // Uniimo podelemente.
    assert(element);
    element->Unici();

    assert(stevka);
    stevka->Unici();

    assert(predznak);
    predznak->Unici();

    RRegElementP<TIP>::Unici();
}

#endif // AOSN_REGIZR


//////////////////////////////////////////////////////////////////////
// T_DATUM
//////////////////////////////////////////////////////////////////////

inline T_DATUM::T_DATUM()
{
}


inline T_DATUM::T_DATUM(T_TRENUTEK datum)
{
    (*this) = datum;
}


inline T_DATUM::operator T_TRENUTEK() const
{
    return
        ((T_TRENUTEK)RDatum::PretvoriGreVJul(dan, mesec, leto)) * RDTM_DAN +
        (ura * RDTM_URA + minuta * RDTM_MINUTA + sekunda * RDTM_SEKUNDA + milisekunda);
}


inline T_TRENUTEK T_DATUM::operator = (T_TRENUTEK datum)
{
    RDatum::PretvoriJulVGre((T_4)(datum / RDTM_DAN), &this->dan, &this->mesec, &this->leto);
    T_4 u = (T_4)(datum % RDTM_DAN);

    this->milisekunda = (T_U2)(u % RDTM_FAKTOR_SEKUNDA);
    u = u / RDTM_FAKTOR_SEKUNDA;
    this->sekunda     = (T_U1)(u % RDTM_FAKTOR_MINUTA);
    u = u / RDTM_FAKTOR_MINUTA;
    this->minuta      = (T_U1)(u % RDTM_FAKTOR_URA);
    u = u / RDTM_FAKTOR_URA;
    this->ura         = (T_U1)u;

    return datum;
}


//////////////////////////////////////////////////////////////////////
// RDatum
//////////////////////////////////////////////////////////////////////

inline T_TRENUTEK RDatum::NastaviDatum(T_TRENUTEK datum)
{
    return this->datum = datum;
}


inline T_TRENUTEK RDatum::NastaviDatum(T_U1 dan, T_U1 mesec, T_4 leto, T_U1 ura, T_U1 minuta, T_U1 sekunda, T_U2 milisekunda)
{
    return datum =
        ((T_TRENUTEK)RDatum::PretvoriGreVJul(dan, mesec, leto)) * RDTM_DAN +
        (ura * RDTM_URA + minuta * RDTM_MINUTA + sekunda * RDTM_SEKUNDA + milisekunda);
}


inline T_TRENUTEK RDatum::NastaviDatum(const T_DATUM *datum)
{
    assert(datum);
    return this->datum = NastaviDatum(datum->dan, datum->mesec, datum->leto, datum->ura, datum->minuta, datum->sekunda, datum->milisekunda);
}


inline T_TRENUTEK RDatum::NastaviDatum(const SYSTEMTIME *cas)
{
    return this->datum = PretvoriGreVJul(cas);
}


inline T_TRENUTEK RDatum::NastaviDatum(const struct tm *cas)
{
    return this->datum = PretvoriGreVJul(cas);
}


inline T_TRENUTEK RDatum::NastaviDatum(const FILETIME *cas)
{
    return this->datum = Pretvori(cas);
}


inline T_TRENUTEK RDatum::NastaviDatum(DATE cas)
{
    return this->datum = Pretvori(cas);
}


inline T_TRENUTEK RDatum::NastaviUro(T_U4 ura)
{
    return datum = (datum - (datum % RDTM_DAN)) + ura;
}


inline T_TRENUTEK RDatum::NastaviTrenutniCas()
{
    return datum = RDatum::VrniTrenutniCas();
}


inline T_TRENUTEK RDatum::VrniDatum() const
{
    return datum;
}


inline T_TRENUTEK RDatum::VrniDatum(T_U1 *dan, T_U1 *mesec, T_4 *leto, T_U1 *ura, T_U1 *minuta, T_U1 *sekunda, T_U2 *milisekunda) const
{
    PretvoriJulVGre(datum, dan, mesec, leto, ura, minuta, sekunda, milisekunda);
    return datum;
}


inline T_TRENUTEK RDatum::VrniDatum(T_DATUM *datum) const
{
    assert(datum);
    PretvoriJulVGre(this->datum, &datum->dan, &datum->mesec, &datum->leto, &datum->ura, &datum->minuta, &datum->sekunda, &datum->milisekunda);
    return this->datum;
}


inline T_TRENUTEK RDatum::VrniDatum(SYSTEMTIME *datum) const
{
    assert(datum);
    PretvoriJulVGre(this->datum, datum);
    return this->datum;
}


inline T_TRENUTEK RDatum::VrniDatum(FILETIME *datum) const
{
    assert(datum);
    Pretvori(this->datum, datum);
    return this->datum;
}


inline T_TRENUTEK RDatum::VrniDatum(DATE *datum) const
{
    assert(datum);
    Pretvori(this->datum, datum);
    return this->datum;
}


inline T_4 RDatum::VrniUro() const
{
    return (T_4)(datum % RDTM_DAN);
}


inline T_U1 RDatum::VrniDan() const
{
    T_U1 dan, mesec;
    T_4 leto;
    VrniDatum(&dan, &mesec, &leto);
    return dan;
}


inline T_U1 RDatum::VrniMesec() const
{
    T_U1 dan, mesec;
    T_4 leto;
    VrniDatum(&dan, &mesec, &leto);
    return mesec;
}


inline T_4  RDatum::VrniLeto() const
{
    T_U1 dan, mesec;
    T_4 leto;
    VrniDatum(&dan, &mesec, &leto);
    return leto;
}


inline T_U1 RDatum::VrniDanVTednu() const
{
    return RDatum::VrniDanVTednu((T_4)(datum/RDTM_DAN));
}


inline T_UINT RDatum::VrniNiz(RNizP<T_AZNAK> &niz, TK_ASCII format, T_LOCALE locale) const
{
    return VrniNiz(datum, niz, format, locale);
}


inline T_UINT RDatum::VrniNiz(RNizP<T_UZNAK> &niz, TK_UNICODE format, T_LOCALE locale) const
{
    return VrniNiz(datum, niz, format, locale);
}


inline RNizA RDatum::VrniNiz(TK_ASCII format, T_LOCALE locale) const
{
    return VrniNiz(datum, format, locale);
}


inline RNizU RDatum::VrniNiz(TK_UNICODE format, T_LOCALE locale) const
{
    return VrniNiz(datum, format, locale);
}


inline T_UINT RDatum::VrniNizRFC822(RNizP<T_AZNAK> &niz) const
{
    return VrniNizRFC822(datum, niz);
}


inline RNizA RDatum::VrniNizRFC822() const
{
    return VrniNizRFC822(datum);
}


inline RDatum::operator T_TRENUTEK() const
{
    return datum;
}


inline T_TRENUTEK RDatum::operator = (T_TRENUTEK datum)
{
    return this->datum = datum;
}


inline T_TRENUTEK RDatum::operator += (T_TRENUTEK datum)
{
    return this->datum += datum;
}


inline T_TRENUTEK RDatum::operator -= (T_TRENUTEK datum)
{
    return this->datum -= datum;
}


inline T_4 RDatum::PretvoriGreVJul(T_U1 dan, T_U1 mesec, T_4 leto)
{
    T_4    ctmp, dtmp, mtmp, ytmp;
    T_4    result1, result2, result3;

    if (mesec > 2) {
        mtmp = mesec - 3;
        ytmp = leto;
    } else {
        mtmp = mesec + 9;
        ytmp = leto - 1;
    }

    ctmp = (ytmp / 100);
    dtmp = ytmp - (100 * ctmp);
    result1 = 146097L * ctmp/4;
    result2 = (1461 * dtmp)/4;
    result3 = (153 * mtmp + 2)/5;

    return( (T_4) result1 + dan + result2 + 1721119L + result3 );
}


inline T_TRENUTEK RDatum::PretvoriGreVJul(const SYSTEMTIME *cas)
{
    assert(cas);
    return
        ((T_TRENUTEK)RDatum::PretvoriGreVJul((T_U1)cas->wDay, (T_U1)cas->wMonth, (T_4)cas->wYear)) * RDTM_DAN +
        (cas->wHour * RDTM_URA + cas->wMinute * RDTM_MINUTA + cas->wSecond * RDTM_SEKUNDA + cas->wMilliseconds);
}


inline T_TRENUTEK RDatum::PretvoriGreVJul(const struct tm *cas)
{
    assert(cas);
    return
        ((T_TRENUTEK)RDatum::PretvoriGreVJul((T_U1)cas->tm_mday, (T_U1)(cas->tm_mon + 1), (T_4)(cas->tm_year + 1900))) * RDTM_DAN +
        (cas->tm_hour * RDTM_URA + cas->tm_min * RDTM_MINUTA + cas->tm_sec * RDTM_SEKUNDA);
}


inline T_TRENUTEK RDatum::Pretvori(const FILETIME *cas)
{
    assert(cas);
    T_TRENUTEK x = (((T_TRENUTEK)cas->dwHighDateTime) << 32) | cas->dwLowDateTime;

    return x/10000 + 199222329600000; // pretvorimo iz 100 ns v 1 ms interval in popravimo zamik med zapisoma
}


inline T_TRENUTEK RDatum::Pretvori(DATE cas)
{
    SYSTEMTIME st;
    verify(::VariantTimeToSystemTime(cas, &st));
    return RDatum::PretvoriGreVJul(&st);
}


inline T_VOID RDatum::PretvoriJulVGre(T_4 jul, T_U1 *dan, T_U1 *mesec, T_4 *leto)
{
    T_4 yr, mo, da, mtmp;

    mtmp = jul - 1721119L;
    yr = (4*mtmp-1)/146097L;
    mtmp = 4*mtmp-1-146097L*yr;
    da = mtmp/4;
    mtmp = (4*da+3)/1461;
    da = 4 * da + 3 - 1461 * mtmp;
    da = (da+4)/4;
    mo = (5*da-3)/153;
    da = 5*da-3-153*mo;
    da = (da+5)/5;
    yr = 100 * yr + mtmp;

    if (mo < 10)
        mo += 3;
    else {
        mo -= 9;
        yr++;
    }

    if (dan)   (*dan) = (T_U1)da;
    if (mesec) (*mesec) = (T_U1)mo;
    if (leto)  (*leto) = yr;
}


inline T_VOID RDatum::PretvoriJulVGre(T_TRENUTEK jul, T_U1 *dan, T_U1 *mesec, T_4 *leto, T_U1 *ura, T_U1 *minuta, T_U1 *sekunda, T_U2 *milisekunda)
{
    RDatum::PretvoriJulVGre((T_4)(jul/RDTM_DAN), dan, mesec, leto);

    if (ura || minuta || sekunda || milisekunda) {
        T_4 u = (T_4)(jul % RDTM_DAN);

        if (milisekunda) (*milisekunda) = (T_U2)(u % RDTM_FAKTOR_SEKUNDA);
        u = u / RDTM_FAKTOR_SEKUNDA;
        if (sekunda)     (*sekunda)     = (T_U1)(u % RDTM_FAKTOR_MINUTA);
        u = u / RDTM_FAKTOR_MINUTA;
        if (minuta)      (*minuta)      = (T_U1)(u % RDTM_FAKTOR_URA);
        u = u / RDTM_FAKTOR_URA;
        if (ura)         (*ura)         = (T_U1)u;
    }
}


inline T_VOID RDatum::PretvoriJulVGre(T_TRENUTEK jul, T_DATUM *datum)
{
    assert(datum);
    PretvoriJulVGre(jul, &datum->dan, &datum->mesec, &datum->leto, &datum->ura, &datum->minuta, &datum->sekunda, &datum->milisekunda);
}


inline T_VOID RDatum::PretvoriJulVGre(T_TRENUTEK jul, SYSTEMTIME *datum)
{
    assert(datum);

    T_U1 dan, mesec, ura, minuta, sekunda;
    T_U2 milisekunda;
    T_4 leto;
    PretvoriJulVGre(jul, &dan, &mesec, &leto, &ura, &minuta, &sekunda, &milisekunda);

    datum->wDay          = (WORD)dan;
    datum->wMonth        = (WORD)mesec;
    datum->wYear         = (WORD)leto;
    datum->wDayOfWeek    = (WORD)VrniDanVTednu((T_4)(jul / RDTM_DAN));

    datum->wHour         = (WORD)ura;
    datum->wMinute       = (WORD)minuta;
    datum->wSecond       = (WORD)sekunda;
    datum->wMilliseconds = (WORD)milisekunda;
}


inline T_VOID RDatum::PretvoriJulVGre(T_TRENUTEK jul, struct tm *datum)
{
    assert(datum);

    T_U1 dan, mesec, ura, minuta, sekunda;
    T_U2 milisekunda;
    T_4 leto;
    PretvoriJulVGre(jul, &dan, &mesec, &leto, &ura, &minuta, &sekunda, &milisekunda);

    memset(datum, 0, sizeof(struct tm));

    datum->tm_mday       = dan;
    datum->tm_mon        = mesec - 1;
    datum->tm_year       = leto - 1900;
    datum->tm_wday       = (VrniDanVTednu((T_4)(jul / RDTM_DAN)) + 1) % RDTM_FAKTOR_TEDEN;

    datum->tm_hour       = ura;
    datum->tm_min        = minuta;
    datum->tm_sec        = sekunda;
}


inline T_VOID RDatum::Pretvori(T_TRENUTEK jul, FILETIME *datum)
{
    assert(datum);

    T_TRENUTEK x = (jul - 199222329600000)*10000;

    datum->dwHighDateTime = (DWORD)((x >> 32) & 0xffffffff);
    datum->dwLowDateTime  = (DWORD)( x        & 0xffffffff);
}


inline T_VOID RDatum::Pretvori(T_TRENUTEK jul, DATE *datum)
{
    assert(datum);
    SYSTEMTIME st;
    RDatum::PretvoriJulVGre(jul, &st);
    verify(::SystemTimeToVariantTime(&st, datum));
}


inline T_TRENUTEK RDatum::PretvoriUTCVLokalni(T_TRENUTEK utc)
{
    FILETIME _utc, _lokalni;
    T_TRENUTEK x = (utc - 199222329600000)*10000;

    _utc.dwHighDateTime = (DWORD)((x >> 32) & 0xffffffff);
    _utc.dwLowDateTime  = (DWORD)( x        & 0xffffffff);

    if (FileTimeToLocalFileTime(&_utc, &_lokalni))
        return Pretvori(&_lokalni);
    else
        return utc; // ce nam ne uspe potiho vrnemo kar isti datum
}


inline T_TRENUTEK RDatum::PretvoriLokalniVUTC(T_TRENUTEK lokalni)
{
    FILETIME _utc, _lokalni;
    T_TRENUTEK x = (lokalni - 199222329600000)*10000;

    _lokalni.dwHighDateTime = (DWORD)((x >> 32) & 0xffffffff);
    _lokalni.dwLowDateTime  = (DWORD)( x        & 0xffffffff);

    if (LocalFileTimeToFileTime(&_lokalni, &_utc))
        return Pretvori(&_utc);
    else
        return lokalni; // ce nam ne uspe potiho vrnemo kar isti datum
}


inline T_U1 RDatum::VrniDanVTednu(T_4 jul)
{
    return (T_U1)(jul % RDTM_FAKTOR_TEDEN);
}


inline T_U1 RDatum::VrniDanVTednu(T_U1 dan, T_U1 mesec, T_4 leto)
{
    return (T_U1)(PretvoriGreVJul(dan, mesec, leto) % RDTM_FAKTOR_TEDEN);
}


inline T_UINT RDatum::VrniNiz(T_TRENUTEK datum, RNizP<T_AZNAK> &niz, TK_ASCII format, T_LOCALE locale)
{
    struct tm dat;
    T_UINT znakov = RNIZ_KORAK_POVECEVANJA, zapisanih;

    PretvoriJulVGre(datum, &dat);

#if _MSC_VER < 1400
    char *locale_prej;

    if (locale) {
        locale_prej = astrdup(setlocale(LC_ALL, NULL));
        setlocale(locale->category, locale->locale);
    } else
        locale_prej = NULL;
#endif

    for (;;) {
        // odpustimo niz, da bomo pisali vanj
        T_ASCII n = niz.Odpusti(znakov, FALSE);
        assert(n);

        // poskusimo zapisati cas
#if _MSC_VER >= 1400
        zapisanih = _strftime_l(n, znakov+1, format, &dat, locale);
#else
        zapisanih = strftime(n, znakov+1, format, &dat);
#endif
        if (zapisanih) {
            // uspelo je, uporabimo niz in zakljucimo
            niz.Uporabi(n, zapisanih, FALSE);
            break;
        } else {
            // ni uspelo, podaljsamo dolzino in ponovimo
            niz.Uporabi(n, 0, FALSE);
            znakov += RNIZ_KORAK_POVECEVANJA;
        }
    };

#if _MSC_VER < 1400
    if (locale_prej) {
        setlocale(LC_ALL, locale_prej);
        afree(locale_prej);
    }
#endif

    return zapisanih;
}


inline T_UINT RDatum::VrniNiz(T_TRENUTEK datum, RNizP<T_UZNAK> &niz, TK_UNICODE format, T_LOCALE locale)
{
    struct tm dat;
    T_UINT znakov = RNIZ_KORAK_POVECEVANJA, zapisanih;

    PretvoriJulVGre(datum, &dat);

#if _MSC_VER < 1400
    char *locale_prej;

    if (locale) {
        locale_prej = astrdup(setlocale(LC_ALL, NULL));
        setlocale(locale->category, locale->locale);
    } else
        locale_prej = NULL;
#endif

    for (;;) {
        // odpustimo niz, da bomo pisali vanj
        T_UNICODE n = niz.Odpusti(znakov, FALSE);
        assert(n);

        // poskusimo zapisati cas
#if _MSC_VER >= 1400
        zapisanih = _wcsftime_l(n, znakov+1, format, &dat, locale);
#else
        zapisanih = wcsftime(n, znakov+1, format, &dat);
#endif
        if (zapisanih) {
            // uspelo je, uporabimo niz in zakljucimo
            niz.Uporabi(n, zapisanih, FALSE);
            break;
        } else {
            // ni uspelo, podaljsamo dolzino in ponovimo
            niz.Uporabi(n, 0, FALSE);
            znakov += RNIZ_KORAK_POVECEVANJA;
        }
    };

#if _MSC_VER < 1400
    if (locale_prej) {
        setlocale(LC_ALL, locale_prej);
        afree(locale_prej);
    }
#endif

    return zapisanih;
}


inline RNizA RDatum::VrniNiz(T_TRENUTEK datum, TK_ASCII format, T_LOCALE locale)
{
    struct tm dat;
    T_UINT znakov = RNIZ_KORAK_POVECEVANJA, zapisanih;
    RNizA niz;

    PretvoriJulVGre(datum, &dat);

#if _MSC_VER < 1400
    char *locale_prej;

    if (locale) {
        locale_prej = astrdup(setlocale(LC_ALL, NULL));
        setlocale(locale->category, locale->locale);
    } else
        locale_prej = NULL;
#endif

    for (;;) {
        // odpustimo niz, da bomo pisali vanj
        T_ASCII n = niz.Odpusti(znakov, FALSE);
        assert(n);

        // poskusimo zapisati cas
#if _MSC_VER >= 1400
        zapisanih = _strftime_l(n, znakov+1, format, &dat, locale);
#else
        zapisanih = strftime(n, znakov+1, format, &dat);
#endif
        if (zapisanih) {
            // uspelo je, uporabimo niz in zakljucimo
            niz.Uporabi(n, zapisanih, FALSE);
            break;
        } else {
            // ni uspelo, podaljsamo dolzino in ponovimo
            niz.Uporabi(n, 0, FALSE);
            znakov += RNIZ_KORAK_POVECEVANJA;
        }
    };

#if _MSC_VER < 1400
    if (locale_prej) {
        setlocale(LC_ALL, locale_prej);
        afree(locale_prej);
    }
#endif

    return niz;
}


inline RNizU RDatum::VrniNiz(T_TRENUTEK datum, TK_UNICODE format, T_LOCALE locale)
{
    struct tm dat;
    T_UINT znakov = RNIZ_KORAK_POVECEVANJA, zapisanih;
    RNizU niz;

#if _MSC_VER < 1400
    char *locale_prej;

    if (locale) {
        locale_prej = astrdup(setlocale(LC_ALL, NULL));
        setlocale(locale->category, locale->locale);
    } else
        locale_prej = NULL;
#endif

    PretvoriJulVGre(datum, &dat);

    for (;;) {
        // odpustimo niz, da bomo pisali vanj
        T_UNICODE n = niz.Odpusti(znakov, FALSE);
        assert(n);

        // poskusimo zapisati cas
#if _MSC_VER >= 1400
        zapisanih = _wcsftime_l(n, znakov+1, format, &dat, locale);
#else
        zapisanih = wcsftime(n, znakov+1, format, &dat);
#endif
        if (zapisanih) {
            // uspelo je, uporabimo niz in zakljucimo
            niz.Uporabi(n, zapisanih, FALSE);
            break;
        } else {
            // ni uspelo, podaljsamo dolzino in ponovimo
            niz.Uporabi(n, 0, FALSE);
            znakov += RNIZ_KORAK_POVECEVANJA;
        }
    };

#if _MSC_VER < 1400
    if (locale_prej) {
        setlocale(LC_ALL, locale_prej);
        afree(locale_prej);
    }
#endif

    return niz;
}


inline T_UINT RDatum::VrniNizRFC822(T_TRENUTEK datum, RNizP<T_AZNAK> &niz)
{
    return VrniNiz(datum, niz, "%a, %d %b %Y %H:%M:%S GMT", AOsn::locale_C);
}


inline RNizA RDatum::VrniNizRFC822(T_TRENUTEK datum)
{
    return VrniNiz(datum, "%a, %d %b %Y %H:%M:%S GMT", AOsn::locale_C);
}


inline T_4 RDatum::DolociTrenutniJul(T_U4 *ura)
{
    SYSTEMTIME cas;

    GetSystemTime(&cas);
    T_U8 datum = PretvoriGreVJul(&cas);
    if (ura)
        *ura = (T_U4)(datum % RDTM_DAN);

    return (T_U4)(datum / RDTM_DAN);
}


inline T_U8 RDatum::VrniProcCas()
{
    return (T_U8)1000 * clock() / CLOCKS_PER_SEC;
}


#ifdef AOSN_SEMAFOR

//////////////////////////////////////////////////////////////////////
// RSinhronizator
//////////////////////////////////////////////////////////////////////

inline T_STANJE RSinhronizator::PogojnoZakleni()
{
    return Zakleni(0);
}


inline T_STANJE RSinhronizator::Postavi()
{
    return Odkleni();
}


inline T_STANJE RSinhronizator::Pocakaj(T_UINT naj_cas) const
{
    return Zakleni(naj_cas);
}


//////////////////////////////////////////////////////////////////////
// RSemafor
//////////////////////////////////////////////////////////////////////

inline T_STANJE RSemafor::Odkleni(T_UINT stevilo)
{
    assert(rocica);
    return ::ReleaseSemaphore(rocica, (LONG)stevilo, NULL) ? A_OK: astanje(::GetLastError(), AOSN_NAPAKA_ODKLEP);
}


//////////////////////////////////////////////////////////////////////
// RCakalnik
//////////////////////////////////////////////////////////////////////

inline T_STANJE RCakalnik::Zakleni(T_UINT naj_cas)
{
    T_STANJE stanje = sinhronizator.Zakleni(naj_cas);
    if (USPESNO(stanje)) zaklenjen++;
    return stanje;
}


inline T_STANJE RCakalnik::Odkleni()
{
    if (zaklenjen) {
        T_STANJE stanje = sinhronizator.Odkleni();
        if (USPESNO(stanje)) zaklenjen--;
        return stanje;
    } else
        return AOSN_NAPAKA_NI_ZAKLENJEN;
}


inline T_STANJE RCakalnik::PogojnoZakleni()
{
    T_STANJE stanje = sinhronizator.PogojnoZakleni();
    if (USPESNO(stanje)) zaklenjen++;
    return stanje;
}


//////////////////////////////////////////////////////////////////////
// RMultiCakalnik
//////////////////////////////////////////////////////////////////////

inline T_STANJE RMultiCakalnik::Zakleni(T_UINT naj_cas, T_BOOL cakaj_vse)
{
    assert(rocica);
    assert(zaklenjen);

    DWORD rezultat;
    T_STANJE stanje;

    rezultat = ::WaitForMultipleObjects((DWORD)stevilo, rocica, cakaj_vse, (DWORD)naj_cas);
    if (WAIT_OBJECT_0 <= rezultat && rezultat < (WAIT_OBJECT_0 + stevilo))
        stanje = A_OK;
    else if (WAIT_ABANDONED_0 <= rezultat && rezultat < (WAIT_ABANDONED_0 + stevilo))
        stanje = AOSN_OPOZORILO_ZE_ZAPRTA;
    else if (rezultat == WAIT_TIMEOUT)
        stanje = AOSN_NAPAKA_CAS_POTEKEL;
    else
        stanje = astanje(::GetLastError(), AOSN_NAPAKA_ZAKLEP);

    if (USPESNO(stanje)) {
        if (cakaj_vse) {
            for (T_UINT i = 0; i < stevilo; i++)
                zaklenjen[i] = TRUE;
        } else
            zaklenjen[rezultat - WAIT_OBJECT_0] = TRUE;
    }

    return stanje;
}


inline T_STANJE RMultiCakalnik::Odkleni()
{
    assert(sinhronizator);
    assert(zaklenjen);

    T_STANJE stanje = A_OK;

    for (T_UINT i = 0; i < stevilo; i++) {
        assert(sinhronizator[i]);
        if (zaklenjen[i]) {
            if (NEUSPESNO(sinhronizator[i]->Odkleni()))
                stanje = AOSN_OPOZORILO_NEKAJ_NAPAK;
            zaklenjen[i] = FALSE;
        }
    }

    return stanje;
}


inline T_STANJE RMultiCakalnik::PogojnoZakleni(T_UINT indeks)
{
    assert(sinhronizator);
    assert(indeks < stevilo);
    assert(sinhronizator[indeks]);
    return sinhronizator[indeks]->PogojnoZakleni();
}


inline T_STANJE RMultiCakalnik::Pocakaj(const T_ROCICAOS sinhronizator[], T_UINT stevilo, T_BOOL cakaj_vse, T_UINT naj_cas)
{
    DWORD rezultat;

    rezultat = ::WaitForMultipleObjects((DWORD)stevilo, sinhronizator, cakaj_vse, (DWORD)naj_cas);
    if (WAIT_OBJECT_0 <= rezultat && rezultat < (WAIT_OBJECT_0 + stevilo))
        return A_OK;
    else if (WAIT_ABANDONED_0 <= rezultat && rezultat < (WAIT_ABANDONED_0 + stevilo))
        return AOSN_OPOZORILO_ZE_ZAPRTA;
    else if (rezultat == WAIT_TIMEOUT)
        return AOSN_NAPAKA_CAS_POTEKEL;
    else
        return astanje(::GetLastError(), AOSN_NAPAKA_ZAKLEP);
}

#endif // AOSN_SEMAFOR


#ifdef AOSN_NIT

//////////////////////////////////////////////////////////////////////
// RNit
//////////////////////////////////////////////////////////////////////

inline T_UINT RNit::VrniKodo()
{
    return koda_niti;
}


inline T_VOID RNit::PrekiniTrenutnoNit(T_REZULTAT rezultat)
{
    ::_endthreadex(rezultat);
}


inline T_VOID RNit::ZamrzniTrenutnoNit()
{
    T_ROCICAOS rocica = ::GetCurrentThread();
    assert(rocica);
    ::SuspendThread(rocica);
}


inline T_STANJE RNit::NastaviPrioritetoTrenutneNiti(T_NITPRIORITETA prioriteta)
{
    T_ROCICAOS rocica = ::GetCurrentThread();
    assert(rocica);
    return ::SetThreadPriority(rocica, prioriteta) ? A_OK : astanje(::GetLastError(), AOSN_NAPAKA_NASTAVI_PRI);
}


inline T_NITPRIORITETA RNit::VrniPrioritetoTrenutneNiti()
{
    T_ROCICAOS rocica = ::GetCurrentThread();
    assert(rocica);
    return (T_NITPRIORITETA)::GetThreadPriority(rocica);
}


inline T_VOID RNit::Zaspi(T_UINT milisekund)
{
    ::Sleep((DWORD)milisekund);
}


inline T_ROCICAOS RNit::VrniTrenutnoNit()
{
    T_ROCICAOS
        rocica,
        psevdo_rocica = ::GetCurrentThread();

    verify(USPESNO(RSisElement::Podvoji(psevdo_rocica, TRUE, &rocica)));
    return rocica;
}


inline T_UINT RNit::VrniKodoTrenutneNiti()
{
    return ::GetCurrentThreadId();
}


inline T_ROCICAOS RNit::Odpri(T_VSTOPNA_TOCKA vstopna_tocka, T_KAZALEC param, T_NITZACETNOSTANJE stanje, T_UINT sklad)
{
    unsigned koda_niti;
    return (T_ROCICAOS)::_beginthreadex(NULL, (unsigned int)sklad, vstopna_tocka, param, stanje, &koda_niti);
}


//////////////////////////////////////////////////////////////////////
// RDogNit
//////////////////////////////////////////////////////////////////////

#ifndef RDOGNIT_KANAL_VER

inline T_STANJE RDogNit::Sporoci(T_UINT koda_sporocila, T_UINT param1, T_KAZALEC param2)
{
    assert(koda_sporocila < RDOGNIT_KODA_SPOROCILA_KONEC - RDOGNIT_KODA_SPOROCILA_ZACETEK);
    return ::PostThreadMessage((DWORD)koda_niti, (UINT)(koda_sporocila + RDOGNIT_KODA_SPOROCILA_ZACETEK), (WPARAM)param1, (LPARAM)param2) ?
        A_OK :
        astanje(::GetLastError(), AOSN_NAPAKA_NI_NIT);
}

#endif


//////////////////////////////////////////////////////////////////////
// RStopnjaCevovoda
//////////////////////////////////////////////////////////////////////

inline T_VOID RStopnjaCevovoda::UporabiNaslednjo(RDogNit *naslednja)
{
    this->naslednja = naslednja;
}


//////////////////////////////////////////////////////////////////////
// RCasovnaPast
//////////////////////////////////////////////////////////////////////

#ifndef _WIN32_WCE

inline T_STANJE RCasovnaPast::Nastavi(T_TRENUTEK kdaj)
{
    koncaj = FALSE;
    return casomer.Nastavi(kdaj, 0);
}


inline T_STANJE RCasovnaPast::Zakljuci()
{
    // Nastavimo zastavico, da elimo konati in predasno sproimo asomer.
    koncaj = TRUE;
    return casomer.Odkleni();
}

#endif


//////////////////////////////////////////////////////////////////////
// RDiagNit
//////////////////////////////////////////////////////////////////////

inline T_STANJE RDiagNit::Prekini()
{
    return dogodek_koncaj.Postavi();
}


inline T_STANJE RDiagNit::PocakajPripravljenost(T_UINT naj_cas)
{
    return dogodek_pripravljen.Pocakaj(naj_cas);
}

#endif // AOSN_NIT


//////////////////////////////////////////////////////////////////////
// RTokPodatkov
//////////////////////////////////////////////////////////////////////

inline T_U1 RTokPodatkov::PreberiBajt()
{
    T_U1 bajt;
    verify(PreberiTab(&bajt, sizeof(T_U1), 1) == 1);
    return bajt;
}


inline T_UINT RTokPodatkov::PreberiVrstico(RNizP<T_AZNAK> &niz)
{
    niz.Sprazni();
    return PreberiInPrilepiVrstico(niz);
}


inline T_UINT RTokPodatkov::PreberiVrstico(RNizP<T_UZNAK> &niz)
{
    niz.Sprazni();
    return PreberiInPrilepiVrstico(niz);
}


inline T_UINT RTokPodatkov::PreberiVrstico(RNizU &niz, T_KODNASTRAN kodna_stran)
{
    if (kodna_stran == KODNASTRAN_UTF16) {
        return PreberiVrstico(niz);
    } else {
        RNizA niz_a;
        PreberiVrstico(niz_a);
        niz.NastaviA(niz_a, T_UINT_MAX, kodna_stran);
        return niz.VrniDolzino();
    }
}


inline T_UINT RTokPodatkov::PreberiInPrilepiVrstico(RNizP<T_AZNAK> &niz)
{
    T_BOOL prvic = TRUE;
    T_AZNAK znak, prejsnji = (T_AZNAK)0;

    do {
        PreberiTab(&znak, sizeof(T_AZNAK), 1);

        if (!prvic && !(prejsnji == '\r' && znak == '\n'))
            niz += prejsnji;
        else
            prvic = FALSE;

        prejsnji = znak;
    } while (USPESNO(stanje) && znak != '\n');

    return niz.VrniDolzino();
}


inline T_UINT RTokPodatkov::PreberiInPrilepiVrstico(RNizP<T_UZNAK> &niz)
{
    T_BOOL prvic = TRUE;
    T_UZNAK znak, prejsnji = (T_UZNAK)0;

    do {
        PreberiTab(&znak, sizeof(T_UZNAK), 1);

        if (!prvic && !(prejsnji == L'\r' && znak == L'\n'))
            niz += prejsnji;
        else
            prvic = FALSE;

        prejsnji = znak;
    } while (USPESNO(stanje) && znak != L'\n');

    return niz.VrniDolzino();
}


inline T_UINT RTokPodatkov::PreberiInPrilepiVrstico(RNizU &niz, T_KODNASTRAN kodna_stran)
{
    if (kodna_stran == KODNASTRAN_UTF16) {
        return PreberiInPrilepiVrstico(niz);
    } else {
        RNizA niz_a;
        PreberiVrstico(niz_a);
        niz.PrilepiA(niz_a, T_UINT_MAX, kodna_stran);
        return niz.VrniDolzino();
    }
}


inline T_UINT RTokPodatkov::PreberiTab(T_KAZALEC tabela, T_SIZE dolzina, T_UINT stevilo)
{
    T_SIZE
        blok,
        ostanek  = dolzina * stevilo,
        prebrano = 0;

    // V zanki beremo, dokler ne dobimo elenega tevila zapisov, ali pa je konec podatkov.
    while (ostanek) {
        blok = Preberi(((T_U1*)tabela) + prebrano, ostanek);
        prebrano += blok;

        // e smo prebrali celo tevilo zapisov, ali pa je toka konec, konamo.
        if (/*(prebrano % dolzina == 0) ||*/ NEUSPESNO(stanje)) goto konec;

        ostanek  -= blok;
    }

konec:
    return prebrano / dolzina;
}


inline T_STANJE RTokPodatkov::ZapisiBajt(T_U1 bajt, T_DOLZINA koliko)
{
    if (koliko == 1) {
        // Zapisujemo le en bajt, zato ne kompliciramo.
        Zapisi(&bajt, sizeof(T_U1));
    } else if (koliko < RDAT_VELIKOST_ITERIRANJA) {
        // eleno tevilo bajtov je dovolj kratko, da jih zapiemo v zanki.
        for (T_UINT i = 0; i < (T_UINT)koliko; i++) {
#ifdef RDAT_NE_PREVERJAJ_STANJA_VER
            assert(USPESNO(stanje));
#else
            if (NEUSPESNO(stanje)) return stanje;
#endif
            Zapisi(&bajt, sizeof(T_U1));
        }
    } else {
        // Bajtov je ve. Rezerviramo blok v pomnilniku in zapiemo po blokih.
        T_SIZE blok = (T_SIZE)amin<T_DOLZINA>(koliko, RDAT_VELIKOST_BLOKA);
        T_KAZALEC dummy = aalloc(blok);
        assert(dummy);
        memset(dummy, bajt, blok);
        // Obvezno preverjamo stanje, sicer se lahko ujamemo v neskonno zanko, e se pisanje kona zaradi napake.
        while (koliko && USPESNO(stanje))
            koliko -= ZapisiTab(dummy, 1, (T_SIZE)amin<T_DOLZINA>(koliko, blok));
        afree(dummy);
    }

    return stanje;
}


inline T_UINT RTokPodatkov::ZapisiNiz(TK_UNICODE niz, T_UINT znakov, T_KODNASTRAN kodna_stran)
{
    assert(niz || !znakov);

#ifdef RDAT_NE_PREVERJAJ_STANJA_VER
    assert(USPESNO(stanje));
#else
    if (NEUSPESNO(stanje)) return 0;
#endif

    znakov = astrnlen(niz, znakov);
    if (kodna_stran != KODNASTRAN_UTF16) {
        RNizA niz_a;
        niz_a.NastaviU(niz, znakov, kodna_stran);
        return ZapisiTab(niz_a.Vrni(), sizeof(T_AZNAK), niz_a.VrniDolzino());
    } else
        return ZapisiTab(niz, sizeof(T_UZNAK), znakov);
}


inline T_SIZE RTokPodatkov::ZapisiSAFEARRAY(LPSAFEARRAY sa)
{
    T_VOID* podatki;
    HRESULT rezultat;
    T_SIZE prepisanih, dolzina;
    long zgornja_meja, spodnja_meja;

    rezultat = SafeArrayAccessData(sa, &podatki);
    if (SUCCEEDED(rezultat)) {

        // Doloimo dolino vektorja.
        verify(SUCCEEDED(SafeArrayGetUBound(sa, 1, &zgornja_meja)));
        verify(SUCCEEDED(SafeArrayGetLBound(sa, 1, &spodnja_meja)));

        dolzina = zgornja_meja - spodnja_meja + 1;
        prepisanih = Zapisi(podatki, dolzina);

        SafeArrayUnaccessData(sa);
    } else {
        stanje = AOSN_NAPAKA_PARAMETER;
        prepisanih = 0;
    }

    return prepisanih;
}


inline T_DOLZINA RTokPodatkov::ZapisiTok(RTokPodatkov &dat, T_DOLZINA koliko)
{
    T_SIZE prebranih, zapisanih;
    T_DOLZINA prepisanih, ostanek = koliko;

    // Rezerviramo pomnilniki blok za prepisovanje.
    T_KAZALEC podatki = aalloc(koliko <= RDAT_VELIKOST_BLOKA ? (T_SIZE)koliko : RDAT_VELIKOST_BLOKA);
    assert(podatki);

    // Prepiemo vsebino.
    prepisanih = 0;
    stanje = A_OK;

    while (ostanek) {
        // Beremo podatke iz toka podatkov, dokler ne naletimo na konec toka.
        prebranih = dat.Preberi(podatki, (T_DOLZINA)RDAT_VELIKOST_BLOKA <= ostanek ? RDAT_VELIKOST_BLOKA : (T_SIZE)ostanek);

        // e smo naleteli na konec toka, to ni napaka.
        stanje = dat.stanje != AOSN_NAPAKA_KONEC_TOKA ? dat.stanje : A_OK;
        if (NEUSPESNO(dat.stanje))
            break;

        zapisanih = Zapisi(podatki, prebranih);
        prepisanih += zapisanih;
        ostanek    -= zapisanih;

        if (NEUSPESNO(stanje))
            break;
    }

    afree(podatki);

    return prepisanih;
}


inline T_UINT RTokPodatkov::ZapisiTab(TK_KAZALEC tabela, T_SIZE dolzina, T_UINT stevilo)
{
    return Zapisi(tabela, stevilo * dolzina) / dolzina;
}


inline T_STANJE RTokPodatkov::ZapisiKodnoStran(T_KODNASTRAN kodna_stran)
{
#ifdef RDAT_NE_PREVERJAJ_STANJA_VER
    assert(USPESNO(stanje));
#else
    if (NEUSPESNO(stanje)) return stanje;
#endif

    if (kodna_stran == KODNASTRAN_UTF16)
        *this << RDAT_UNICODE_TXT_ID;
    else if (kodna_stran == KODNASTRAN_UTF8)
        ZapisiTab(RDAT_UTF8_TXT_ID, sizeof(RDAT_UTF8_TXT_ID) - sizeof(T_AZNAK), 1);

    return stanje;
}


//////////////////////////////////////////////////////////////////////
// RDatoteka
//////////////////////////////////////////////////////////////////////

inline LPSAFEARRAY RDatoteka::VrniSAFEARRAY()
{
    LPSAFEARRAY sa;
    T_KAZALEC podatki; // kazalec do podatkov tabele SAFEARRAY
    T_SIZE dolzina;

    // Preverimo 4 GB mejo.
    assert(VrniDolzino() <= T_SIZE_MAX);
    dolzina = (T_SIZE)VrniDolzino();

    // Naredimo tabelo.
    sa = SafeArrayCreateVector(VT_UI1, 0, (ULONG)dolzina);
    if (sa) {
        if (SUCCEEDED(SafeArrayAccessData(sa, &podatki))) {
            verify(Prestavi(0) == 0);
            verify(PreberiTab(podatki, 1, dolzina) == dolzina);
            SafeArrayUnaccessData(sa);
        } else {
            SafeArrayDestroy(sa);
            sa = NULL;
            stanje = AOSN_NAPAKA_POMNILNIK;
        }
    } else
        stanje = AOSN_NAPAKA_POMNILNIK;

    return sa;
}


inline T_KODNASTRAN RDatoteka::DolociKodnoStran(T_KODNASTRAN privzeta_kodna_stran)
{
    T_UZNAK id_utf16;
    T_AZNAK id_utf8[3] = { 0 };

    verify(Prestavi(0) == 0);
    PreberiTab(&id_utf16, sizeof(T_UZNAK), 1);
    if (JeKonec()) return privzeta_kodna_stran;
    if (id_utf16 == RDAT_UNICODE_TXT_ID) {
        // Vhodna datoteka je v zapisu UTF-16.
        return KODNASTRAN_UTF16;
    }

    verify(Prestavi(0) == 0);
    PreberiTab(id_utf8, sizeof(id_utf8), 1);
    if (JeKonec()) return privzeta_kodna_stran;
    if (!astrncmp(id_utf8, RDAT_UTF8_TXT_ID, _countof(id_utf8))) {
        // Vhodna datoteka je v zapisu UTF-8.
        return KODNASTRAN_UTF8;
    }

    // Neznana kodna stran, privzamemo privzeto. :)
    verify(Prestavi(0) == 0);
    return privzeta_kodna_stran;
}



//////////////////////////////////////////////////////////////////////
// RIzravnalnik
//////////////////////////////////////////////////////////////////////

inline T_STANJE RIzravnalnik::NastaviDolzinoBranja(T_SIZE dolzina_branja)
{
    if (!izvor && !izravnalnik[0].podatki) {
        izravnalnik[0].dolzina = dolzina_branja;
        return stanje = A_OK;
    } else
        return stanje = AOSN_NAPAKA_ZE_ZAGNAN;
}


inline T_STANJE RIzravnalnik::NastaviDolzinoPisanja(T_SIZE dolzina_pisanja)
{
    if (!izvor && !izravnalnik[1].podatki) {
        izravnalnik[1].dolzina = dolzina_pisanja;
        return stanje = A_OK;
    } else
        return stanje = AOSN_NAPAKA_ZE_ZAGNAN;
}


//////////////////////////////////////////////////////////////////////
// ROmejenTokPodatkov
//////////////////////////////////////////////////////////////////////

inline T_VOID ROmejenTokPodatkov::NastaviDolzinoBranja(T_DOLZINA _dolzina_branja)
{
    dolzina_branja = _dolzina_branja;
}


inline T_VOID ROmejenTokPodatkov::NastaviDolzinoPisanja(T_DOLZINA _dolzina_pisanja)
{
    dolzina_pisanja = _dolzina_pisanja;
}


inline T_DOLZINA ROmejenTokPodatkov::VrniDolzinoBranja() const
{
    return dolzina_branja;
}


inline T_DOLZINA ROmejenTokPodatkov::VrniDolzinoPisanja() const
{
    return dolzina_pisanja;
}


//////////////////////////////////////////////////////////////////////
// RIzrSisTokPodatkov
//////////////////////////////////////////////////////////////////////

inline T_STANJE RIzrSisTokPodatkov::UporabiRocico(T_ROCICAOS rocica)
{
    return stanje = izvor.Uporabi(rocica);
}


inline T_ROCICAOS RIzrSisTokPodatkov::OdpustiRocico()
{
    IzplakniIzravnalnik();
    return izvor.Odpusti();
}


//////////////////////////////////////////////////////////////////////
// RISequentialStream
//////////////////////////////////////////////////////////////////////

inline ISequentialStream* RISequentialStream::VrniIzvor() const
{
    assert(izvor);
    return izvor;
}


//////////////////////////////////////////////////////////////////////
// RMedFizDatoteka
//////////////////////////////////////////////////////////////////////

inline T_STANJE RMedFizDatoteka::Uporabi(T_ROCICAOS rocica)
{
#ifdef RDAT_BELEZI_CAS_DOSTOPA_VER
    datum_dostopa = datum_pisanja = T_TRENUTEK_MIN;
#endif
    return stanje = izvor.Uporabi(rocica);
}


inline T_ROCICAOS RMedFizDatoteka::Odpusti()
{
    RazveljaviMedpomnilnik();
#ifdef RDAT_BELEZI_CAS_DOSTOPA_VER
    datum_dostopa = datum_pisanja = T_TRENUTEK_MIN;
#endif
    return izvor.Odpusti();
}


inline T_STANJE RMedFizDatoteka::Odpri(TK_NIZ ime, T_UINT nacin)
{
    // e datoteko odpiramo za pisanje, potem jo bomo preko medpomnilnika morali tudi brati.
    if (nacin & RDAT_PISANJE) nacin |= RDAT_BRANJE;
#ifdef RDAT_BELEZI_CAS_DOSTOPA_VER
    datum_dostopa = datum_pisanja = T_TRENUTEK_MIN;
#endif
    return stanje = izvor.Odpri(ime, nacin);
}


inline T_BOOL RMedFizDatoteka::JeVeljaven() const
{
    return izvor.JeVeljaven();
}


//////////////////////////////////////////////////////////////////////
// RPomDatoteka
//////////////////////////////////////////////////////////////////////

inline const T_VOID* RPomDatoteka::VrniPodatke() const
{
    return podatki;
}


inline T_ODMIK RPomDatoteka::PrestaviZac(T_ODMIK _odmik)
{
    // Preverimo 4 GB mejo.
    assert(_odmik <= T_SIZE_MAX);

    return odmik = (T_SIZE)_odmik;
}


inline T_ODMIK RPomDatoteka::PrestaviTren(T_RODMIK _odmik)
{
    // Preverimo 4 GB mejo.
    assert(T_INT_MIN <= _odmik && _odmik <= T_INT_MAX);

    return odmik += (T_SIZE)_odmik;
}


inline T_ODMIK RPomDatoteka::PrestaviKon(T_RODMIK _odmik)
{
    // Preverimo 4 GB mejo.
    assert(T_INT_MIN <= _odmik && _odmik <= T_INT_MAX);

    return odmik = dolzina + (T_SIZE)_odmik;
}


inline T_DOLZINA RPomDatoteka::ZapisiTok(RTokPodatkov &dat, T_DOLZINA koliko)
{
    T_SIZE prebranih, pon_odmik = odmik, pon_dolzina = odmik;
    T_DOLZINA prepisanih = 0, ostanek = koliko;

    stanje = A_OK;

    if (koliko != (T_DOLZINA)-1) {
        // elena dolina je znana. Preberemo naenkrat.

        // Preverimo 4 GB mejo.
        assert(((T_DOLZINA)pon_dolzina + koliko) <= T_SIZE_MAX);

        pon_dolzina += (T_SIZE)koliko;

        // Nastavimo pomnilnik na eleno velikost.
        verify(USPESNO(RezervirajDolzino(pon_dolzina)));

        while (ostanek) {
            // Prepiemo vsebino.
            prebranih = dat.Preberi(podatki + pon_odmik, (T_SIZE)ostanek);

            // e smo naleteli na konec toka, to ni napaka.
            stanje = dat.stanje != AOSN_NAPAKA_KONEC_TOKA ? dat.stanje : A_OK;
            if (NEUSPESNO(dat.stanje))
                break;

            // Podaljamo dolino, kolikor smo prebrali podatkov.
            pon_dolzina = pon_odmik += prebranih;
            prepisanih += prebranih;
            ostanek    -= prebranih;

            stanje = A_OK;
        };
    } else {
        // Neznana dolina. Beremo po blokih.
        T_SIZE velikost_bloka;

        while (ostanek) {
            velikost_bloka = (T_DOLZINA)RDAT_VELIKOST_BLOKA <= ostanek ? RDAT_VELIKOST_BLOKA : (T_SIZE)ostanek;

            // Preverimo 4 GB mejo.
            assert(((T_DOLZINA)pon_dolzina + velikost_bloka) <= T_SIZE_MAX);

            pon_dolzina += velikost_bloka;

            // Nastavimo pomnilnik na eleno velikost.
            verify(USPESNO(RezervirajDolzino(pon_dolzina)));

            // Prepiemo vsebino.
            prebranih = dat.Preberi(podatki + pon_odmik, velikost_bloka);

            // e smo naleteli na konec toka, to ni napaka.
            stanje = dat.stanje != AOSN_NAPAKA_KONEC_TOKA ? dat.stanje : A_OK;
            if (NEUSPESNO(dat.stanje))
                break;

            // Podaljamo dolino, kolikor smo prebrali podatkov.
            pon_dolzina = pon_odmik += prebranih;
            prepisanih += prebranih;
            ostanek    -= prebranih;

            stanje = A_OK;
        };
    }

    // Postavimo ciljno datoteko na konec bloka.
    odmik = pon_odmik;
    if (odmik > dolzina) dolzina = odmik;
#ifdef RDAT_BELEZI_CAS_DOSTOPA_VER
    datum_dostopa = datum_pisanja = RDatum::VrniTrenutniCas();
#endif

    return prepisanih;
}


inline T_STANJE RPomDatoteka::ZapisiBajt(T_U1 bajt, T_SIZE koliko)
{
#ifdef RDAT_NE_PREVERJAJ_STANJA_VER
    assert(USPESNO(stanje));
#else
    if (NEUSPESNO(stanje)) return stanje;
#endif
    if (NEUSPESNO(RezervirajDolzino(odmik + koliko))) return stanje;

    memset(podatki + odmik, bajt, koliko);
    odmik += koliko;
    if (odmik > dolzina) dolzina = odmik;
    stanje = A_OK;
#ifdef RDAT_BELEZI_CAS_DOSTOPA_VER
    datum_dostopa = datum_pisanja = RDatum::VrniTrenutniCas();
#endif

    return stanje;
}


inline T_VOID RPomDatoteka::Nastavi(T_ODMIK odmik, const T_1 podatek)      { _Nastavi<T_1>(*this, odmik, podatek); }
inline T_VOID RPomDatoteka::Nastavi(T_ODMIK odmik, const T_2 podatek)      { _Nastavi<T_2>(*this, odmik, podatek); }
inline T_VOID RPomDatoteka::Nastavi(T_ODMIK odmik, const T_4 podatek)      { _Nastavi<T_4>(*this, odmik, podatek); }
inline T_VOID RPomDatoteka::Nastavi(T_ODMIK odmik, const T_8 podatek)      { _Nastavi<T_8>(*this, odmik, podatek); }
inline T_VOID RPomDatoteka::Nastavi(T_ODMIK odmik, const T_U1 podatek)     { _Nastavi<T_U1>(*this, odmik, podatek); }
inline T_VOID RPomDatoteka::Nastavi(T_ODMIK odmik, const T_U2 podatek)     { _Nastavi<T_U2>(*this, odmik, podatek); }
inline T_VOID RPomDatoteka::Nastavi(T_ODMIK odmik, const T_U4 podatek)     { _Nastavi<T_U4>(*this, odmik, podatek); }
inline T_VOID RPomDatoteka::Nastavi(T_ODMIK odmik, const T_U8 podatek)     { _Nastavi<T_U8>(*this, odmik, podatek); }
#ifdef _NATIVE_SIZE_T_DEFINED
inline T_VOID RPomDatoteka::Nastavi(T_ODMIK odmik, const T_SIZE podatek)   { _Nastavi<T_SIZE>(*this, odmik, podatek); }
#endif
inline T_VOID RPomDatoteka::Nastavi(T_ODMIK odmik, const T_FLOAT podatek)  { _Nastavi<T_FLOAT>(*this, odmik, podatek); }
inline T_VOID RPomDatoteka::Nastavi(T_ODMIK odmik, const T_DOUBLE podatek) { _Nastavi<T_DOUBLE>(*this, odmik, podatek); }
inline T_VOID RPomDatoteka::Nastavi(T_ODMIK odmik, const T_AZNAK podatek)  { _Nastavi<T_AZNAK>(*this, odmik, podatek); }
#ifdef _NATIVE_WCHAR_T_DEFINED
inline T_VOID RPomDatoteka::Nastavi(T_ODMIK odmik, const T_UZNAK podatek)  { _Nastavi<T_UZNAK>(*this, odmik, podatek); }
#endif

inline T_VOID RPomDatoteka::Vrni(T_ODMIK odmik, T_1 &podatek)           { _Vrni<T_1>(*this, odmik, podatek); }
inline T_VOID RPomDatoteka::Vrni(T_ODMIK odmik, T_2 &podatek)           { _Vrni<T_2>(*this, odmik, podatek); }
inline T_VOID RPomDatoteka::Vrni(T_ODMIK odmik, T_4 &podatek)           { _Vrni<T_4>(*this, odmik, podatek); }
inline T_VOID RPomDatoteka::Vrni(T_ODMIK odmik, T_8 &podatek)           { _Vrni<T_8>(*this, odmik, podatek); }
inline T_VOID RPomDatoteka::Vrni(T_ODMIK odmik, T_U1 &podatek)          { _Vrni<T_U1>(*this, odmik, podatek); }
inline T_VOID RPomDatoteka::Vrni(T_ODMIK odmik, T_U2 &podatek)          { _Vrni<T_U2>(*this, odmik, podatek); }
inline T_VOID RPomDatoteka::Vrni(T_ODMIK odmik, T_U4 &podatek)          { _Vrni<T_U4>(*this, odmik, podatek); }
inline T_VOID RPomDatoteka::Vrni(T_ODMIK odmik, T_U8 &podatek)          { _Vrni<T_U8>(*this, odmik, podatek); }
#ifdef _NATIVE_SIZE_T_DEFINED
inline T_VOID RPomDatoteka::Vrni(T_ODMIK odmik, T_SIZE &podatek)        { _Vrni<T_SIZE>(*this, odmik, podatek); }
#endif
inline T_VOID RPomDatoteka::Vrni(T_ODMIK odmik, T_FLOAT &podatek)       { _Vrni<T_FLOAT>(*this, odmik, podatek); }
inline T_VOID RPomDatoteka::Vrni(T_ODMIK odmik, T_DOUBLE &podatek)      { _Vrni<T_DOUBLE>(*this, odmik, podatek); }
inline T_VOID RPomDatoteka::Vrni(T_ODMIK odmik, T_AZNAK &podatek)       { _Vrni<T_AZNAK>(*this, odmik, podatek); }
#ifdef _NATIVE_WCHAR_T_DEFINED
inline T_VOID RPomDatoteka::Vrni(T_ODMIK odmik, T_UZNAK &podatek)       { _Vrni<T_UZNAK>(*this, odmik, podatek); }
#endif


//////////////////////////////////////////////////////////////////////
// T_IDPODATKI
//////////////////////////////////////////////////////////////////////

template <class TIP, class TIP_ID, class TIP_DOLZINA, unsigned int PORAVNAVA> T_IDPODATKI<TIP, TIP_ID, TIP_DOLZINA, PORAVNAVA>::T_IDPODATKI(TIP &_podatki) :
    podatki(_podatki)
{
}


template <class TIP, class TIP_ID, class TIP_DOLZINA, unsigned int PORAVNAVA> T_IDPODATKI<TIP, TIP_ID, TIP_DOLZINA, PORAVNAVA>::T_IDPODATKI(const TIP &_podatki) :
    podatki((TIP&)_podatki)
{
}


template <class TIP, class TIP_ID, class TIP_DOLZINA, unsigned int PORAVNAVA> inline const T_IDPODATKI<TIP, TIP_ID, TIP_DOLZINA, PORAVNAVA>& T_IDPODATKI<TIP, TIP_ID, TIP_DOLZINA, PORAVNAVA>::operator =(const T_IDPODATKI<TIP, TIP_ID, TIP_DOLZINA, PORAVNAVA> &zapis)
{
    podatki = zapis.podatki;
    return *this;
}


template <class TIP, class TIP_ID, class TIP_DOLZINA, unsigned int PORAVNAVA> inline T_ODMIK T_IDPODATKI<TIP, TIP_ID, TIP_DOLZINA, PORAVNAVA>::OdpriGlavo(RDatoteka &dat)
{
    return _OdpriGlavo<TIP_ID, TIP_DOLZINA>(dat, id);
}


template <class TIP, class TIP_ID, class TIP_DOLZINA, unsigned int PORAVNAVA> inline T_ODMIK T_IDPODATKI<TIP, TIP_ID, TIP_DOLZINA, PORAVNAVA>::ZapriGlavo(RDatoteka &dat, T_ODMIK zacetek)
{
    return _ZapriGlavo<TIP_ID, TIP_DOLZINA, PORAVNAVA>(dat, zacetek);
}


template <class TIP, class TIP_ID, class TIP_DOLZINA, unsigned int PORAVNAVA> inline RTokPodatkov& operator <<(RTokPodatkov &tok, const T_IDPODATKI<TIP, TIP_ID, TIP_DOLZINA, PORAVNAVA> zapis)
{
    RPomDatoteka dat;
    TIP_DOLZINA dolzina, ostanek;

    if (NEUSPESNO(dat.VrniStanje())) return tok;
    tok << zapis.id;

    // Pripravimo zapis najprej v pomnilniku.
    dat << zapis.podatki;

    // Zapiemo dolino strukture.
    if (NEUSPESNO(tok.VrniStanje())) return tok;
    dolzina = (TIP_DOLZINA)dat.VrniDolzino(),
    ostanek = (TIP_DOLZINA)(PORAVNAVA - dolzina) % PORAVNAVA; // tevilo bajtov, ki jih moramo dodati, da je zapis dolg celo tevilo enot doline PORAVNAVA
    tok << dolzina;

    // Prepiemo iz pomnilnika na tok podatkov
    if (NEUSPESNO(dat.VrniStanje())) return tok;
    dat.Prestavi(0);
    tok.ZapisiTok(dat);

    if (ostanek) {
        // Dodamo polnilo na koncu.
        tok.ZapisiBajt(0, ostanek);
    }

    return tok;
}


template <class TIP, class TIP_ID, class TIP_DOLZINA, unsigned int PORAVNAVA> inline RDatoteka& operator <<(RDatoteka &tok, const T_IDPODATKI<TIP, TIP_ID, TIP_DOLZINA, PORAVNAVA> zapis)
{
    T_ODMIK zacetek_bloka;

    if (NEUSPESNO(tok.VrniStanje())) return tok;
    zacetek_bloka = zapis.OdpriGlavo(tok);

    if (NEUSPESNO(tok.VrniStanje())) return tok;
    tok << zapis.podatki;

    if (NEUSPESNO(tok.VrniStanje())) return tok;
    zapis.ZapriGlavo(tok, zacetek_bloka);

    return tok;
}


template <class TIP, class TIP_ID, class TIP_DOLZINA, unsigned int PORAVNAVA> inline RTokPodatkov& operator >>(RTokPodatkov &tok, T_IDPODATKI<TIP, TIP_ID, TIP_DOLZINA, PORAVNAVA> zapis)
{
    // Parametra zapis ne rabimo podajati po referenci, saj ima samo eno polje (podatki) ki je referenca e samo. Polje id pa je tako ali tako statino.

    TIP_DOLZINA dolzina;

    // Preberemo dolino zapisa.
    tok >> dolzina;
    if (tok.JeKonec()) return tok;

    ROmejenTokPodatkov _tok(&tok, dolzina);

    // Preberemo zapis.
    _tok >> zapis.podatki;
    if (_tok.JeKonec()) return tok;

    dolzina  = (TIP_DOLZINA)_tok.VrniDolzinoBranja();
    dolzina += (TIP_DOLZINA)(PORAVNAVA - dolzina) % PORAVNAVA; // tevilo bajtov, ki so dodani, da je zapis dolg celo tevilo enot doline PORAVNAVA

    // Preskoimo ostanek podatkov.
    tok.Preskoci(dolzina);

    return tok;
}


template <class TIP, class TIP_ID, class TIP_DOLZINA, unsigned int PORAVNAVA> inline RDatoteka& operator >>(RDatoteka &tok, T_IDPODATKI<TIP, TIP_ID, TIP_DOLZINA, PORAVNAVA> zapis)
{
    // Parametra zapis ne rabimo podajati po referenci, saj ima samo eno polje (podatki) ki je referenca e samo. Polje id pa je tako ali tako statino.

    TIP_DOLZINA dolzina;
    T_ODMIK zacetek_podatkov;

    // Preberemo dolino bloka.
    tok >> dolzina;
    if (tok.JeKonec()) return tok;

    // Preberemo podatke.
    zacetek_podatkov = tok.VrniOdmik();
    tok >> zapis.podatki;

    dolzina += (TIP_DOLZINA)(PORAVNAVA - dolzina) % PORAVNAVA; // tevilo bajtov, ki so dodani, da je zapis dolg celo tevilo enot doline PORAVNAVA
    tok.Prestavi(zacetek_podatkov + dolzina);

    return tok;
}


#ifdef AOSN_BASE64

//////////////////////////////////////////////////////////////////////
// RBase64
//////////////////////////////////////////////////////////////////////

inline T_UINT RBase64::VrniKodDolzino(T_SIZE dolzina) const
{
    return ((k_stevilo + dolzina + 2)/3) * 4;
}


inline T_SIZE RBase64::VrniDeKodDolzino(T_UINT dolzina) const
{
    return ((d_stevilo + dolzina)/4)*3;
}


inline T_VOID RBase64::Sprazni()
{
    k_stevilo = 0;
    d_stevilo = 0;
}

#endif // AOSN_BASE64


#ifdef AOSN_VTIC

//////////////////////////////////////////////////////////////////////
// RVticnica
//////////////////////////////////////////////////////////////////////

inline T_STANJE RVticnica::Privezi(TK_NIZ vmesnik, T_UINT vrata)
{
    T_SOCKADDR_IN naslov;
    memset(&naslov, 0, sizeof(T_SOCKADDR_IN));

    stanje = PoisciNaslov(vmesnik, &naslov.sin_addr.S_un.S_addr);
    if (USPESNO(stanje)) {
        naslov.sin_port = ahtons((u_short)vrata);
        naslov.sin_family = AF_INET;
        return Privezi((T_SOCKADDR*)&naslov, sizeof(T_SOCKADDR_IN));
    } else
        return stanje;
}


inline T_STANJE RVticnica::Povezi(TK_NIZ vmesnik, T_UINT vrata)
{
    T_SOCKADDR_IN naslov;
    memset(&naslov, 0, sizeof(T_SOCKADDR_IN));

    stanje = PoisciNaslov(vmesnik, &naslov.sin_addr.S_un.S_addr);
    if (USPESNO(stanje)) {
        naslov.sin_port = ahtons((u_short)vrata);
        naslov.sin_family = AF_INET;
        return Povezi((T_SOCKADDR*)&naslov, sizeof(T_SOCKADDR_IN));
    } else
        return stanje;
}


inline T_BOOL RVticnica::JeVeljaven() const
{
    return JE_VELJAVNA_VTICNICA(vticnica);
}


inline T_VTICNICA RVticnica::Vrni() const
{
    return vticnica;
}


inline RVticnica::operator T_VTICNICA() const
{
    return vticnica;
}

#endif // AOSN_VTIC


#ifdef AOSN_ODTISNIK

//////////////////////////////////////////////////////////////////////
// T_ODTIS_MD2
//////////////////////////////////////////////////////////////////////

inline T_BOOL operator ==(const T_ODTIS_MD2 odtis1, const T_ODTIS_MD2 odtis2)
{
    return memcmp(&odtis1, &odtis2, sizeof(T_ODTIS_MD2)) == 0;
}


inline T_BOOL operator !=(const T_ODTIS_MD2 odtis1, const T_ODTIS_MD2 odtis2)
{
    return memcmp(&odtis1, &odtis2, sizeof(T_ODTIS_MD2)) != 0;
}


template <class TOK> inline TOK& operator <<(TOK &tok, const T_ODTIS_MD2 odtis)
{
    if (NEUSPESNO(tok.VrniStanje())) return tok;
    tok.ZapisiTab(&odtis, sizeof(T_ODTIS_MD2), 1);

    return tok;
}


template <class TOK> inline TOK& operator >>(TOK &tok, T_ODTIS_MD2 &odtis)
{
    tok.PreberiTab(&odtis, sizeof(T_ODTIS_MD2), 1);
    return tok;
}


//////////////////////////////////////////////////////////////////////
// T_ODTIS_SHA
//////////////////////////////////////////////////////////////////////

inline T_BOOL operator ==(const T_ODTIS_SHA odtis1, const T_ODTIS_SHA odtis2)
{
    return memcmp(&odtis1, &odtis2, sizeof(T_ODTIS_SHA)) == 0;
}


inline T_BOOL operator !=(const T_ODTIS_SHA odtis1, const T_ODTIS_SHA odtis2)
{
    return memcmp(&odtis1, &odtis2, sizeof(T_ODTIS_SHA)) != 0;
}


template <class TOK> inline TOK& operator <<(TOK &tok, const T_ODTIS_SHA odtis)
{
    if (NEUSPESNO(tok.VrniStanje())) return tok;
    tok.ZapisiTab(&odtis, sizeof(T_ODTIS_SHA), 1);

    return tok;
}


template <class TOK> inline TOK& operator >>(TOK &tok, T_ODTIS_SHA &odtis)
{
    tok.PreberiTab(&odtis, sizeof(T_ODTIS_SHA), 1);
    return tok;
}


//////////////////////////////////////////////////////////////////////
// RCRC32
//////////////////////////////////////////////////////////////////////

template <class TOK> inline TOK& operator <<(TOK &tok, const RCRC32 &odtis)
{
    odtis.Zapisi(tok);
    return tok;
}


template <class TOK> inline TOK& operator >>(TOK &tok, RCRC32 &odtis)
{
    odtis.Preberi(tok);
    return tok;
}


//////////////////////////////////////////////////////////////////////
// RMD5
//////////////////////////////////////////////////////////////////////

template <class TOK> inline TOK& operator <<(TOK &tok, const RMD5 &odtis)
{
    odtis.Zapisi(tok);
    return tok;
}


template <class TOK> inline TOK& operator >>(TOK &tok, RMD5 &odtis)
{
    odtis.Preberi(tok);
    return tok;
}


//////////////////////////////////////////////////////////////////////
// RSHA1
//////////////////////////////////////////////////////////////////////

template <class TOK> inline TOK& operator <<(TOK &tok, const RSHA1 &odtis)
{
    odtis.Zapisi(tok);
    return tok;
}


template <class TOK> inline TOK& operator >>(TOK &tok, RSHA1 &odtis)
{
    odtis.Preberi(tok);
    return tok;
}

#endif // AOSN_ODTISNIK


#ifdef AOSN_VIRI

//////////////////////////////////////////////////////////////////////
// RBazaVirov
//////////////////////////////////////////////////////////////////////

inline T_STANJE RBazaVirov::NaloziZbirkoIkone(HMODULE rocica, UINT id, LPCGRPICONDIR &podatki, T_SIZE *dolzina, T_KODAJEZIKA2 jezik)
{
    return NaloziPodatke(rocica, RT_GROUP_ICON, id, (TK_KAZALEC*)&podatki, dolzina, jezik);
}


inline T_STANJE RBazaVirov::NaloziZbirkoIkone(HMODULE rocica, UINT id, RTokPodatkov &seznam, T_KODAJEZIKA2 jezik)
{
    return NaloziPodatke(rocica, RT_GROUP_ICON, id, seznam, jezik);
}


inline T_STANJE RBazaVirov::NaloziIkono(HMODULE rocica, UINT id, TK_KAZALEC *podatki, T_SIZE *dolzina, T_KODAJEZIKA2 jezik)
{
    return NaloziPodatke(rocica, RT_ICON, id, podatki, dolzina, jezik);
}


inline T_STANJE RBazaVirov::NaloziIkono(HMODULE rocica, UINT id, RTokPodatkov &ikona, T_KODAJEZIKA2 jezik)
{
    return NaloziPodatke(rocica, RT_ICON, id, ikona, jezik);
}


inline T_STANJE RBazaVirov::NaloziSliko(HMODULE rocica, UINT id, TK_KAZALEC *podatki, T_SIZE *dolzina, T_KODAJEZIKA2 jezik)
{
    return NaloziPodatke(rocica, RT_BITMAP, id, podatki, dolzina, jezik);
}


inline T_STANJE RBazaVirov::NaloziSliko(HMODULE rocica, UINT id, RTokPodatkov &slika, T_KODAJEZIKA2 jezik)
{
    return NaloziPodatke(rocica, RT_BITMAP, id, slika, jezik);
}

#endif // AOSN_VIRI


#ifdef AOSN_REGISTER

//////////////////////////////////////////////////////////////////////
// RRegister
//////////////////////////////////////////////////////////////////////

inline T_REGTIP RRegister::VrniTip(TK_NIZ vrednost) const
{
    assert(JE_VELJAVNA_ROCICA(rocica));

    DWORD tip;
    return ::RegQueryValueEx((HKEY)rocica, vrednost, NULL, &tip, NULL, NULL) == ERROR_SUCCESS ? (T_REGTIP)tip : RREG_NI;
}


inline T_SIZE RRegister::VrniDolzino(TK_NIZ vrednost) const
{
    assert(JE_VELJAVNA_ROCICA(rocica));

    DWORD dolzina;
    return ::RegQueryValueEx((HKEY)rocica, vrednost, NULL, NULL, NULL, &dolzina) == ERROR_SUCCESS ? dolzina : 0;
}


inline RRegister::operator HKEY() const
{
    return (HKEY)rocica;
}

#endif // AOSN_REGISTER


#ifdef AOSN_DNEVNIK

//////////////////////////////////////////////////////////////////////
// RDnevnik
//////////////////////////////////////////////////////////////////////

inline T_STANJE RDnevnik::Zapisi(T_DNEVNIKPRIORITETA prioriteta, TK_NIZ sporocilo, T_LOCALE locale, ...)
{
    T_STANJE stanje;
    va_list param;

    va_start(param, locale);
    stanje = ZapisiP(prioriteta, sporocilo, locale, param);
    va_end(param);

    return stanje;
}


inline T_STANJE RDnevnik::Zapisi(T_DNEVNIKPRIORITETA prioriteta, T_UINT koda_sporocila, T_LOCALE locale, ...)
{
    T_STANJE stanje;
    va_list param;

    va_start(param, locale);
    stanje = ZapisiP(prioriteta, RNiz(modul, koda_sporocila, jezik).Vrni(), locale, param);
    va_end(param);

    return stanje;
}


//////////////////////////////////////////////////////////////////////
// RDnevnikNT
//////////////////////////////////////////////////////////////////////

inline T_STANJE RDnevnikNT::Zapisi(T_DNEVNIKPRIORITETA prioriteta, T_UINT koda_sporocila, ...)
{
    T_STANJE stanje;
    va_list param;

    va_start(param, koda_sporocila);
    stanje = ZapisiP(prioriteta, NULL, 0, koda_sporocila, param);
    va_end(param);

    return stanje;
}


inline T_STANJE RDnevnikNT::Zapisi(T_DNEVNIKPRIORITETA prioriteta, T_KAZALEC podatki, T_SIZE dolzina, T_UINT koda_sporocila, ...)
{
    T_STANJE stanje;
    va_list param;

    va_start(param, koda_sporocila);
    stanje = ZapisiP(prioriteta, podatki, dolzina, koda_sporocila, param);
    va_end(param);

    return stanje;
}

#endif // AOSN_DNEVNIK


#ifdef AOSN_SERVIS

//////////////////////////////////////////////////////////////////////
// RRegisterServisov
//////////////////////////////////////////////////////////////////////

inline T_ROCICA RRegisterServisov::DodajServis(RServisImpl *servis)
{
    assert(servis);
    return servisi.Dodaj(servis);
}


inline T_STANJE RRegisterServisov::OdstraniServis(T_ROCICA rocica)
{
    assert(rocica);
    servisi.Brisi(rocica);
    return A_OK;
}


inline T_STANJE RRegisterServisov::OdstraniServis(TK_NIZ ime)
{
    T_ROCICA rocica = VrniRocicoServisa(ime);
    return rocica ? OdstraniServis(rocica) : AOSN_NAPAKA_NI_SERVISA;
}


inline T_ROCICA RRegisterServisov::VrniRocicoServisa(TK_NIZ ime) const
{
    T_ROCICA rocica;

    for (rocica = servisi.VrniPrvega(); rocica; rocica = servisi.VrniNaslednjega(rocica)) {
        RServisImpl *&servis = servisi[rocica];
        if (!astricmp(ime, servis->VrniIme()))
            return rocica;
    }

    return NULL;
}


inline RServisImpl* RRegisterServisov::VrniServis(T_ROCICA rocica) const
{
    return servisi[rocica];
}


inline RServisImpl* RRegisterServisov::VrniServis(TK_NIZ ime) const
{
    T_ROCICA rocica = VrniRocicoServisa(ime);
    return rocica ? VrniServis(rocica) : NULL;
}


inline RRegisterServisov* RRegisterServisov::VrniRegisterServisov()
{
    assert(register_servisov);
    return register_servisov;
}


//////////////////////////////////////////////////////////////////////
// RRegisterServisovDnevnikP
//////////////////////////////////////////////////////////////////////

#ifdef AOSN_DNEVNIK

template <class T_base> RRegisterServisovDnevnikP<T_base>::RRegisterServisovDnevnikP(TK_NIZ _ime_dnevnika, T_UINT podrocje, TK_NIZ _identifikacija, T_UINT _vrste_prioritet) :
    T_base(),
    ime_dnevnika(_ime_dnevnika),
    identifikacija(_identifikacija),
    vrste_prioritet(_vrste_prioritet),
    dnevnik(podrocje, _identifikacija)
{
}


template <class T_base> T_STANJE RRegisterServisovDnevnikP<T_base>::ObRegistraciji()
{
    T_STANJE stanje;

    // Registriramo register servisov.
    stanje = T_base::ObRegistraciji();
    if (NEUSPESNO(stanje))
        return stanje;

    // Registriramo dnevnik dogodkov.
    stanje = RDnevnikNT::Registriraj(ime_dnevnika.Vrni(), identifikacija.Vrni(), vrste_prioritet, pot_modula);
    if (NEUSPESNO(stanje))
        return stanje;

    return A_OK;
}


template <class T_base> T_STANJE RRegisterServisovDnevnikP<T_base>::ObOdjavi()
{
    // Odjavimo dnevnik dogodkov.
    verify(USPESNO(RDnevnikNT::Odjavi(ime_dnevnika.Vrni(), identifikacija.Vrni())));

    // Odjavimo register servisov.
    return T_base::ObOdjavi();
}


template <class T_base> T_STANJE RRegisterServisovDnevnikP<T_base>::ObZagonu()
{
    T_STANJE stanje;

    // Vzpostavimo register servisov.
    stanje = T_base::ObZagonu();
    if (NEUSPESNO(stanje))
        return stanje;

    // Vzpostavimo dnevnik.
    stanje = dnevnik.Odpri();
    if (NEUSPESNO(stanje)) {
        adebug(ADNE_NAPAKA, ADNE_AOSN _T("Napaka pri odpiranju sistemskega dnevnika (stanje ") _T(T_STANJE_PRINTF) _T(").\n"), stanje);
        return stanje;
    }

    return A_OK;
}


template <class T_base> T_STANJE RRegisterServisovDnevnikP<T_base>::ObZakljucku()
{
    // Zakljuimo dnevnik.
    verify(USPESNO(dnevnik.Zapri()));

    // Zakljuimo register servisov.
    return T_base::ObZakljucku();
}

#endif // AOSN_DNEVNIK


//////////////////////////////////////////////////////////////////////
// RServisImpl
//////////////////////////////////////////////////////////////////////

inline T_STANJE RServisImpl::SporociStatus()
{
    if (statusna_rocica)
        verify(::SetServiceStatus(statusna_rocica, (LPSERVICE_STATUS)&status));
    return ObStatusu();
}


inline T_STANJE RServisImpl::SporociNaslednjiKorak(T_UINT milisekund)
{
    status.dwCheckPoint++;
    status.dwWaitHint = (DWORD)milisekund;
    return SporociStatus();
}


inline T_STANJE RServisImpl::SporociStatus(T_STATUSSERVISA stanje)
{
    status.dwCurrentState  = stanje;
    status.dwWin32ExitCode = NO_ERROR;
    status.dwCheckPoint    = 0;
    status.dwWaitHint      = RDTM_MINUTA;
    return SporociStatus();
}


//////////////////////////////////////////////////////////////////////
// RServisStdP
//////////////////////////////////////////////////////////////////////

template <class T_base> RServisStdP<T_base>::RServisStdP() :
    T_base(),
    delaj(RSEM_POSTAVLJEN | RSEM_ROCNI_RESET),
    koncaj(RSEM_ROCNI_RESET)
{

}


template <class T_base> T_VOID RServisStdP<T_base>::PredRegistracijoServisa()
{
    T_base::PredRegistracijoServisa();

    // Nastavimo, da servis sprejema ukaze pavza/nadaljuj, stop in zaustavitev sistema.
    status.dwControlsAccepted = SERVICE_ACCEPT_PAUSE_CONTINUE | SERVICE_ACCEPT_STOP | SERVICE_ACCEPT_SHUTDOWN;
}


template <class T_base> T_STANJE RServisStdP<T_base>::ObZagonu()
{
    T_STANJE stanje;

    // Resetiramo dogodek koncaj, saj ele zaganjamo servis.
    verify(USPESNO(koncaj.Resetiraj()));

    stanje = T_base::ObZagonu();
    if (NEUSPESNO(stanje))
        return stanje;

    // Postavimo dogodek delaj, da sprostimo akajoe niti (sicer bi moral biti e postavljen, a ni ne de).
    verify(USPESNO(delaj.Postavi()));
    return A_OK;
}


template <class T_base> T_STANJE RServisStdP<T_base>::ObZaustavitvi(T_BOOL)
{
    verify(USPESNO(SporociNaslednjiKorak(RDTM_MINUTA)));

    // Naznanimo fazo zakljuevanja.
    verify(USPESNO(koncaj.Postavi()));

    // Postavimo dogodek delaj, da sprostimo akajoe niti.
    verify(USPESNO(delaj.Postavi()));

    // Sporoimo niti servisa, naj se zakljui.
    verify(USPESNO(Sporoci(SP_KONEC, 0, NULL)));
    return 0;
}


template <class T_base> T_STANJE RServisStdP<T_base>::ObPrekinitvi()
{
    // Resetiramo dogodek in zaasno ustavimo delo.
    verify(USPESNO(delaj.Resetiraj()));
    return T_base::ObPrekinitvi();
}


template <class T_base> T_STANJE RServisStdP<T_base>::ObNadaljevanju()
{
    // Hura, delo lahko spet stee.
    verify(USPESNO(delaj.Postavi()));
    return T_base::ObNadaljevanju();
}


//////////////////////////////////////////////////////////////////////
// RServisOdjemalecP
//////////////////////////////////////////////////////////////////////

template <class T_srv> RServisOdjemalecP<T_srv>::RServisOdjemalecP(T_srv &_servis) :
    RNit(),
    servis(_servis)
{
}


//////////////////////////////////////////////////////////////////////
// RServisOdjemalecKanalP
//////////////////////////////////////////////////////////////////////

#ifdef AOSN_KANAL

template <class T_srv, class T_base> RServisOdjemalecKanalP<T_srv, T_base>::RServisOdjemalecKanalP(T_srv &servis) : T_base(servis)
{
}


template <class T_srv, class T_base> RTokPodatkov& RServisOdjemalecKanalP<T_srv, T_base>::VrniTokPodatkov()
{
    return kanal;
}


template <class T_srv, class T_base> RNiz RServisOdjemalecKanalP<T_srv, T_base>::VrniImeOdjemalca()
{
    RNiz niz;

    if (USPESNO(kanal.VrniNaslovVrstnika(niz)))
        return niz;
    else
        return RNiz();
}


template <class T_srv, class T_base> T_STANJE RServisOdjemalecKanalP<T_srv, T_base>::Zakljuci()
{
    // e zakljuimo kanal, se bo zakljuil tudi odjemalec.
    if (kanal.JeVeljaven())
        kanal.Zakljuci();
    return A_OK;
}


template <class T_srv, class T_base> T_STANJE RServisOdjemalecKanalP<T_srv, T_base>::Zapri()
{
    verify(USPESNO(kanal.Zapri()));
    return RServisOdjemalecP::Zapri();
}

#endif // AOSN_KANAL


//////////////////////////////////////////////////////////////////////
// RServisOdjemalecVticP
//////////////////////////////////////////////////////////////////////

#ifdef AOSN_VTIC

template <class T_srv, class T_base> RServisOdjemalecVticP<T_srv, T_base>::RServisOdjemalecVticP(T_srv &servis) : T_base(servis)
{
}


template <class T_srv, class T_base> RTokPodatkov& RServisOdjemalecVticP<T_srv, T_base>::VrniTokPodatkov()
{
    return vticnica;
}


template <class T_srv, class T_base> RNiz RServisOdjemalecVticP<T_srv, T_base>::VrniImeOdjemalca()
{
    T_SOCKADDR_IN naslov;
    T_SIZE dolzina = sizeof(T_SOCKADDR_IN);

    if (USPESNO(vticnica.VrniNaslovVrstnika((T_SOCKADDR*)&naslov, &dolzina))) {
        RNiz ime;

        ime.Oblikuj(_T("%u.%u.%u.%u"), T_LOCALE_THREAD_DEFAULT,
            (unsigned int)naslov.sin_addr.s_net,
            (unsigned int)naslov.sin_addr.s_host,
            (unsigned int)naslov.sin_addr.s_lh,
            (unsigned int)naslov.sin_addr.s_impno);

        return ime;
    } else
        return RNiz();
}


template <class T_srv, class T_base> T_STANJE RServisOdjemalecVticP<T_srv, T_base>::Zakljuci()
{
    // Zakljuimo vtinico za pisanje.
    if (vticnica.JeVeljaven())
        verify(USPESNO(vticnica.Zakljuci(VTIC_KONCAJ_PISANJE)));
    return A_OK;
}


template <class T_srv, class T_base> T_STANJE RServisOdjemalecVticP<T_srv, T_base>::Zapri()
{
    verify(USPESNO(vticnica.Zapri()));
    return RServisOdjemalecP::Zapri();
}

#endif // AOSN_VTIC


//////////////////////////////////////////////////////////////////////
// RServisSprejemnikP
//////////////////////////////////////////////////////////////////////

template <class T_srv, class T_odj_base> RServisSprejemnikP<T_srv, T_odj_base>::RServisSprejemnikP(T_srv &_servis) :
    RNit(),
    servis(_servis)
{
}


//////////////////////////////////////////////////////////////////////
// RServisSprejemnikKanalP
//////////////////////////////////////////////////////////////////////

#ifdef AOSN_KANAL

template <class T_srv, class T_odj, class T_odj_base, class T_base> RServisSprejemnikKanalP<T_srv, T_odj, T_odj_base, T_base>::RServisSprejemnikKanalP(T_srv &servis) : T_base(servis)
{
}


template <class T_srv, class T_odj, class T_odj_base, class T_base> T_STANJE RServisSprejemnikKanalP<T_srv, T_odj, T_odj_base, T_base>::Vzpostavi(TK_NIZ _ime_kanala)
{
    adebug(ADNE_OBVESTILO, ADNE_AOSN _T("Vzpostavljam sprejemnik na kanalu %s ...\n"), _ime_kanala);

    // Zapomnimo si ime kanala.
    ime_kanala  = _T("\\\\.\\pipe\\");
    ime_kanala += _ime_kanala;

    return A_OK;
}


template <class T_srv, class T_odj, class T_odj_base, class T_base> T_STANJE RServisSprejemnikKanalP<T_srv, T_odj, T_odj_base, T_base>::Zakljuci()
{
    RFizDatoteka dat;

    // Poveemo se na kanal in ga zapremo, tako da sprostimo sprejemnikovo nit, ki aka na odjemalca.
    if (USPESNO(dat.Odpri(ime_kanala, RDAT_BRANJE | RDAT_PISANJE | RDAT_BINARNO | RDAT_PISI_SKOZI | RDAT_BREZ_MEDPOMN | RDAT_DOSTOP_ZAPOREDEN)))
        dat.Zapri();
    return A_OK;
}


template <class T_srv, class T_odj, class T_odj_base, class T_base> T_STANJE RServisSprejemnikKanalP<T_srv, T_odj, T_odj_base, T_base>::SprejmiOdjemalca(T_odj_base *&odjemalec)
{
    T_STANJE stanje = A_OK;
    T_odj *o;

    // Ustvarimo odjemalca.
    o = new T_odj(servis);
    assert(o);

    // Ustvarimo nov kanal za povezavo.
    stanje = o->kanal.Ustvari(ime_kanala);
    if (NEUSPESNO(stanje))
        goto napaka2;

    // Poakamo in sprejmemo odjemalca.
    stanje = o->kanal.Sprejmi();
    if (NEUSPESNO(stanje))
        goto napaka3;

    if (USPESNO(servis.koncaj.Pocakaj(0))) {
        stanje = AOSN_NAPAKA_PREKINJENO;
        goto napaka4;
    }

#ifdef _DEBUG
    {
        T_ZNAK uporabnik[MAX_PATH];

        uporabnik[::GetNamedPipeHandleState(o->kanal, NULL, NULL, NULL, NULL, uporabnik, MAX_PATH) ? MAX_PATH - 1 : 0] = 0;
        adebug(ADNE_DIAG, ADNE_AOSN _T("Odjemalec uspeno sprejet (uporabnik \"%.*s\").\n"), MAX_PATH, uporabnik);
    }
#endif

    odjemalec = o;
    return A_OK;

napaka4:
    verify(USPESNO(o->kanal.Zakljuci()));
napaka3:
    verify(USPESNO(o->kanal.Zapri()));
napaka2:
    delete o;
    odjemalec = NULL;
    return stanje;
}

#endif // AOSN_KANAL


//////////////////////////////////////////////////////////////////////
// RServisSprejemnikVticP
//////////////////////////////////////////////////////////////////////

#ifdef AOSN_VTIC

template <class T_srv, class T_odj, class T_odj_base, class T_base> RServisSprejemnikVticP<T_srv, T_odj, T_odj_base, T_base>::RServisSprejemnikVticP(T_srv &servis) : T_base(servis)
{
}


template <class T_srv, class T_odj, class T_odj_base, class T_base> T_STANJE RServisSprejemnikVticP<T_srv, T_odj, T_odj_base, T_base>::Vzpostavi(const T_SOCKADDR *naslov, T_SIZE dolzina)
{
    T_STANJE stanje;

    adebug(ADNE_OBVESTILO, ADNE_AOSN _T("Vzpostavljam sprejemnik na vratih %u.%u.%u.%u:%u ...\n"),
        (unsigned int)((T_SOCKADDR_IN*)naslov)->sin_addr.s_net,
        (unsigned int)((T_SOCKADDR_IN*)naslov)->sin_addr.s_host,
        (unsigned int)((T_SOCKADDR_IN*)naslov)->sin_addr.s_lh,
        (unsigned int)((T_SOCKADDR_IN*)naslov)->sin_addr.s_impno,
        (unsigned int)antohs(((T_SOCKADDR_IN*)naslov)->sin_port)
        );

    // Ustvarimo vtinico.
    stanje = vticnica.Odpri();
    if (USPESNO(stanje)) {
        // Poveemo vtinico na vmesnik:vrata.
        stanje = vticnica.Privezi(naslov, dolzina);
        if (USPESNO(stanje)) {
            // Zanemo posluati.
            stanje = vticnica.Poslusaj();
            if (USPESNO(stanje))
                return stanje;
        }

        // Nekdo najbr e poslua na teh vratih.
        adebug(ADNE_NAPAKA, ADNE_AOSN _T("Napaka pri povezavi sprejemnika (koda ") _T(T_STANJE_PRINTF) _T(").\n"), stanje);
        verify(USPESNO(vticnica.Zapri()));
    }

    return stanje;
}


template <class T_srv, class T_odj, class T_odj_base, class T_base> T_STANJE RServisSprejemnikVticP<T_srv, T_odj, T_odj_base, T_base>::Zakljuci()
{
    // Zapremo vtinico in s tem sprostimo sprejemnik, ki aka na odjemalca.
    verify(USPESNO(vticnica.Zapri()));
    return A_OK;
}


template <class T_srv, class T_odj, class T_odj_base, class T_base> T_STANJE RServisSprejemnikVticP<T_srv, T_odj, T_odj_base, T_base>::SprejmiOdjemalca(T_odj_base *&odjemalec)
{
    T_STANJE stanje = A_OK;
    T_odj *o;
    T_SOCKADDR_IN naslov;
    T_SIZE dolzina = sizeof(T_SOCKADDR_IN);

    // Ustvarimo odjemalca.
    o = new T_odj(servis);
    assert(o);

    // Poakamo in sprejmemo odjemalca.
    stanje = vticnica.Sprejmi(o->vticnica, (T_SOCKADDR*)&naslov, &dolzina);
    if (NEUSPESNO(stanje))
        goto napaka1;

    adebug(ADNE_DIAG, ADNE_AOSN _T("Odjemalec uspeno sprejet (uporabnik %u.%u.%u.%u).\n"),
        (unsigned int)naslov.sin_addr.s_net,
        (unsigned int)naslov.sin_addr.s_host,
        (unsigned int)naslov.sin_addr.s_lh,
        (unsigned int)naslov.sin_addr.s_impno);

    odjemalec = o;
    return A_OK;

napaka1:
    delete o;
    odjemalec = NULL;
    return stanje;
}


template <class T_srv, class T_odj, class T_odj_base, class T_base> inline T_STANJE RServisSprejemnikVticP<T_srv, T_odj, T_odj_base, T_base>::Vzpostavi(TK_NIZ vmesnik, T_UINT vrata)
{
    T_STANJE stanje;
    T_SOCKADDR_IN naslov;
    memset(&naslov, 0, sizeof(naslov));

    adebug(ADNE_DIAG, ADNE_AOSN _T("Iem naslov \"%s\" ...\n"), vmesnik);
    stanje = RVticnica::PoisciNaslov(vmesnik, &naslov.sin_addr.S_un.S_addr);
    if (USPESNO(stanje)) {
        naslov.sin_port = ahtons((u_short)vrata);
        naslov.sin_family = AF_INET;
        return Vzpostavi((T_SOCKADDR*)&naslov, sizeof(naslov));
    } else
        return stanje;
}

#endif // AOSN_VTIC

#endif // AOSN_SERVIS


#ifdef AOSN_HTML

//////////////////////////////////////////////////////////////////////
// RHTMLRegElIdentP
//////////////////////////////////////////////////////////////////////

template <class TIP> RHTMLRegElIdentP<TIP>::RHTMLRegElIdentP() : RRegElementP<TIP>()
{
}


template <class TIP> T_BOOL RHTMLRegElIdentP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    UNREFERENCED_PARAMETER(zastavice);

    // Zanemo na zaetku.
    interval.konec = zacetek;

    for (;;) {
        if (interval.konec >= konec || !besedilo[interval.konec]) {
            // Zmanjkalo je znakov.
            if (zacetek < interval.konec) {
                // Konamo s tem, kar imamo do zdaj.
                interval.zacetek = zacetek;
                return TRUE;
            } else {
                // Zmanjkalo je znakov, a nimamo niesar.
                interval.zacetek = 1;
                interval.konec   = 0;
                return FALSE;
            }
        } else if (
            besedilo[interval.konec] == '>' ||
            besedilo[interval.konec] == '=' ||
            besedilo[interval.konec] == '/' && interval.konec + 1 < konec && besedilo[interval.konec + 1] == '>' ||
            aisspace(besedilo[interval.konec]))
        {
            // Nali smo ">", enaaj, "/>" ali presledek, zato konamo.
            interval.zacetek = zacetek;
            return TRUE;
        } else {
            // Preskoimo vsak drug znak.
            interval.konec++;
        }
    }
}


//////////////////////////////////////////////////////////////////////
// RHTMLRegElVrednostP
//////////////////////////////////////////////////////////////////////

template <class TIP> RHTMLRegElVrednostP<TIP>::RHTMLRegElVrednostP() :
    RRegElementP<TIP>(),
    vsebina(1, 0)
{
}


template <class TIP> T_BOOL RHTMLRegElVrednostP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    UNREFERENCED_PARAMETER(zastavice);

    // Zanemo na zaetku.
    interval.konec = zacetek;

    if (interval.konec < konec &&
        (besedilo[interval.konec] == '\"' || besedilo[interval.konec] == '\''))
    {
        // Nali smo narekovaj. Vrednost je zapisana v narekovajih.
        TIP narekovaj = besedilo[interval.konec];

        vsebina.zacetek = ++interval.konec;

        // Poiemo konni narekovaj.
        for (;;) {
            if (interval.konec >= konec || !besedilo[interval.konec]) {
                // Konnega narekovaja nismo nali, ker nam je prezgodaj zmanjkalo znakov.
                assert(0); // TODO: Preizkusi ta del kode.
                vsebina.zacetek = 1;
                vsebina.konec   = 0;

                interval.zacetek = 1;
                interval.konec   = 0;
                return FALSE;
            } else if (besedilo[interval.konec] == narekovaj) {
                // Nali smo enak narekovaj, kot je bil uvodni, zato konamo.
                vsebina.konec    = interval.konec;
                interval.zacetek = zacetek;
                interval.konec++;
                return TRUE;
            } else {
                // Preskoimo vsak znak.
                interval.konec++;
            }
        }
    } else {
        // Vrednost se ne zane z narekovajem, zato proglasimo vse do prvega presledka, ">" ali "/>" za vrednost.
        vsebina.zacetek = interval.konec;

        for (;;) {
            if (interval.konec >= konec || !besedilo[interval.konec]) {
                // Zmanjkalo je znakov, zato konamo s tem, kar imamo do sedaj.
                assert(0); // TODO: Preizkusi ta del kode.
                vsebina.konec   = interval.konec;
                interval.zacetek = zacetek;
                return TRUE;
            } else if (
                besedilo[interval.konec] == '>' ||
                besedilo[interval.konec] == '/' && interval.konec + 1 < konec && besedilo[interval.konec + 1] == '>' ||
                aisspace(besedilo[interval.konec]))
            {
                // Nali smo ">", "/>" ali presledek, zato konamo.
                vsebina.konec    = interval.konec;
                interval.zacetek = zacetek;
                return TRUE;
            } else {
                // Preskoimo vsak znak.
                interval.konec++;
            }
        }
    }
}


template <class TIP> T_VOID RHTMLRegElVrednostP<TIP>::Razveljavi()
{
    // Razveljavimo podelemente.
    vsebina.zacetek = 1;
    vsebina.konec   = 0;

    RRegElementP<TIP>::Razveljavi();
}


//////////////////////////////////////////////////////////////////////
// RHTMLRegElOznakaP
//////////////////////////////////////////////////////////////////////

template <class TIP> RHTMLRegElOznakaP<TIP>::RHTMLRegElOznakaP() :
    RRegElementP<TIP>(),
    vrsta(HTML_ODSEK_NEZNAN),
    ime(1, 0)
{
}


template <class TIP> T_BOOL RHTMLRegElOznakaP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);

    if (zacetek >= konec || besedilo[zacetek] != '<') {
        // e ni uvodnega znaka "<", ni oznaka.
        goto napaka;
    }

    // Zanemo za uvodnim znakom.
    interval.konec = zacetek + 1;

    if (interval.konec >= konec || !besedilo[interval.konec]) {
        // Zmanjkalo nam je znakov.
        goto napaka;
    }

    if (besedilo[interval.konec] == '/' &&
        ident.PreveriUjemanje(besedilo, interval.konec + 1, konec, zastavice))
    {
        // Uvodnemu znaku sledi "/" in nato ime oznake. Oznaka bo zakljuna.
        vrsta = HTML_ODSEK_OZNAKA_ZAKLJUCNA;
        ime   = ident.interval;
        interval.konec = ident.interval.konec;
    } else if (besedilo[interval.konec] == '!') {
        // Uvodnemu znaku sledi "!". Oznaka bo deklaracija ali komentar HTML.
        interval.konec++;

        if (interval.konec + 1 < konec &&
            besedilo[interval.konec    ] == '-' &&
            besedilo[interval.konec + 1] == '-')
        {
            // Nali smo zaetek komentarja HTML (zaporedje "<!" in nato takoj "--"). Poiemo konec komentarja.
            ime.zacetek = interval.konec = interval.konec + 2;

            for (;;) {
                if (interval.konec >= konec || !besedilo[interval.konec]) {
                    // Komentar ni zakljuen, oznaka ni veljavna.
                    assert(0); // TODO: Preizkusi ta del kode.
                    goto napaka;
                } else if (
                    interval.konec + 2 < konec &&
                    besedilo[interval.konec    ] == '-' &&
                    besedilo[interval.konec + 1] == '-' &&
                    besedilo[interval.konec + 2] == '>')
                {
                    // Nali smo konec komentarja (zaporedje "-->").
                    vrsta = HTML_ODSEK_KOMENTAR;
                    ime.konec = interval.konec;
                    lastnosti.Sprazni();

                    interval.zacetek = zacetek;
                    interval.konec   = interval.konec + 3;
                    return TRUE;
                } else {
                    // Preskoimo vsak znak.
                    interval.konec++;
                }
            }
        } else {
            vrsta = HTML_ODSEK_DEKLARACIJA;
            ime.zacetek = ime.konec = interval.konec;
        }
    } else if (besedilo[interval.konec] == '?') {
        // Uvodnemu znaku sledi "?". Oznaka bo navodilo. Poiemo e "?>" ali ">".
        ime.zacetek = ++interval.konec;
        for (;;) {
            if (interval.konec >= konec || !besedilo[interval.konec]) {
                // Navodilo ni zakljueno, oznaka ni veljavna.
                goto napaka;
            } else if (besedilo[interval.konec] == '>') {
                // Nali smo konec navodila ">".
                vrsta = HTML_ODSEK_NAVODILO;
                ime.konec = interval.konec;
                lastnosti.Sprazni();

                interval.zacetek = zacetek;
                interval.konec++;
                return TRUE;
            } else if (
                interval.konec + 1 < konec &&
                besedilo[interval.konec    ] == '?' &&
                besedilo[interval.konec + 1] == '>')
            {
                // Nali smo konec navodila "?>".
                vrsta = HTML_ODSEK_NAVODILO;
                ime.konec = interval.konec;
                lastnosti.Sprazni();

                interval.zacetek = zacetek;
                interval.konec   = interval.konec + 2;
                return TRUE;
            } else {
                // Preskoimo vsak znak.
                interval.konec++;
            }
        }
    } else if (ident.PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
        // Oznaka bo uvodna.
        vrsta = HTML_ODSEK_OZNAKA_UVODNA;
        ime   = ident.interval;
        interval.konec = ident.interval.konec;
    } else {
        // Uvodnemu znaku "<" ne sledi ime oznake. Oznaka ni veljavna.
        goto napaka;
    }

    // Preskoimo presledke.
    for (; interval.konec < konec && besedilo[interval.konec] && aisspace(besedilo[interval.konec]); interval.konec++);

    lastnosti.Sprazni();

    for (;;) {
        if (vrsta == HTML_ODSEK_OZNAKA_UVODNA &&
            interval.konec + 1 < konec &&
            besedilo[interval.konec    ] == '/' &&
            besedilo[interval.konec + 1] == '>')
        {
            // Nali smo zakljuek samostojne oznake "/>".
            vrsta = HTML_ODSEK_OZNAKA_SAMOSTOJNA;
            interval.konec = interval.konec + 2;
            break;
        } else if (interval.konec < konec &&
            besedilo[interval.konec] == '>')
        {
            // Nali smo zakljuek oznake ">".
            interval.konec++;
            break;
        } else if (vrsta == HTML_ODSEK_DEKLARACIJA &&
            interval.konec + 1 < konec &&
            besedilo[interval.konec    ] == '!' &&
            besedilo[interval.konec + 1] == '>')
        {
            // Nali smo zakljuek deklaracije "!>".
            assert(0); // TODO: Preizkusi ta del kode.
            interval.konec = interval.konec + 2;
            break;
        } else if (vrsta == HTML_ODSEK_DEKLARACIJA &&
            interval.konec + 1 < konec &&
            besedilo[interval.konec    ] == '-' &&
            besedilo[interval.konec + 1] == '-')
        {
            // Nali smo zaetek komentarja v deklaraciji (zaporedje "--"). Poiemo konec komentarja.
            interval.konec = interval.konec + 2;

            for (;;) {
                if (interval.konec >= konec || !besedilo[interval.konec]) {
                    // Komentar ni zakljuen, oznaka ni veljavna.
                    goto napaka;
                } else if (interval.konec + 1 < konec &&
                    besedilo[interval.konec    ] == '-' &&
                    besedilo[interval.konec + 1] == '-')
                {
                    // Nali smo konec komentarja (zaporedje "--").
                    interval.konec = interval.konec + 2;
                    break;
                } else {
                    // Preskoimo vsak znak.
                    interval.konec++;
                }
            }

            // Preskoimo presledke.
            for (; interval.konec < konec && besedilo[interval.konec] && aisspace(besedilo[interval.konec]); interval.konec++);

            continue;
        } else {
            // Nadaljevanje predstavlja zapis lastnosti.
            T_HTMLLASTNOST *l = NULL; // kazalec na lastnost, ki smo jo nali

            if (interval.konec >= konec || !besedilo[interval.konec]) {
                // Zmanjkalo nam je znakov sredi oznake.
                goto napaka;
            } else if (ident.PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
                // Nali smo lastnost.
                T_UINT n = lastnosti.VrniStevilo();
                lastnosti.NastaviStevilo(n + 1);

                l = &(lastnosti[n]);
                l->ime = ident.interval;
                interval.konec = ident.interval.konec;
            } else {
                // Znak ne predstavlja imena lastnosti. udno!? Kakorkoli, preskoimo znak in nadaljujemo z obdelavo.
                interval.konec++;
                continue;
            }

            // Preskoimo presledke.
            for (; interval.konec < konec && besedilo[interval.konec] && aisspace(besedilo[interval.konec]); interval.konec++);

            if (interval.konec < konec && besedilo[interval.konec] == '=') {
                // Nali smo enaaj "=".
                assert(l);
                interval.konec++;

                // Preskoimo presledke.
                for (; interval.konec < konec && besedilo[interval.konec] && aisspace(besedilo[interval.konec]); interval.konec++);

                if (vrednost.PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
                    // Nali smo vrednost.
                    l->vrednost = vrednost.vsebina;
                    interval.konec = vrednost.interval.konec;

                    // Preskoimo presledke.
                    for (; interval.konec < konec && besedilo[interval.konec] && aisspace(besedilo[interval.konec]); interval.konec++);
                }
            } else {
                // Lastnost nima eksplicitno doloene vrednosti.
                l->vrednost.zacetek = 1;
                l->vrednost.konec   = 0;
            }
        }
    }

    interval.zacetek = zacetek;
    return TRUE;

napaka:
    vrsta = HTML_ODSEK_NEZNAN;
    ime.zacetek = 1;
    ime.konec   = 0;
    lastnosti.Sprazni();

    interval.zacetek = 1;
    interval.konec   = 0;
    return FALSE;
}


template <class TIP> T_VOID RHTMLRegElOznakaP<TIP>::Razveljavi()
{
    // Razveljavimo podelemente.
    vrsta = HTML_ODSEK_NEZNAN;
    ime.zacetek = 1;
    ime.konec   = 0;
    lastnosti.Sprazni();

    RRegElementP<TIP>::Razveljavi();
}


//////////////////////////////////////////////////////////////////////
// RHTMLRegElDeklaracijaPogojZacP
//////////////////////////////////////////////////////////////////////

template <class TIP> RHTMLRegElDeklaracijaPogojZacP<TIP>::RHTMLRegElDeklaracijaPogojZacP() :
    RRegElementP<TIP>(),
    pogoj(1, 0)
{
}


template <class TIP> T_BOOL RHTMLRegElDeklaracijaPogojZacP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    UNREFERENCED_PARAMETER(zastavice);

    if (zacetek + 2 < konec &&
        besedilo[zacetek    ] == '<' &&
        besedilo[zacetek + 1] == '!' &&
        besedilo[zacetek + 2] == '[')
    {
        // Nali smo uvodno zaporedje za pogoj ("<![").
        interval.konec = zacetek + 3;

        // Preskoimo presledke.
        for (; interval.konec < konec && besedilo[interval.konec] && aisspace(besedilo[interval.konec]); interval.konec++);

        pogoj.zacetek = pogoj.konec = interval.konec;

        for (;;) {
            if (interval.konec >= konec || !besedilo[interval.konec]) {
                // Pogoj ni zakljuen, deklaracija ni veljavna.
                break;
            } else if (besedilo[interval.konec] == '[') {
                // Nali smo zaetek vsebine.
                interval.zacetek = zacetek;
                interval.konec++;
                return TRUE;
            } else if (aisspace(besedilo[interval.konec])) {
                // Nali smo presledek. Preskoimo.
                interval.konec++;
            } else {
                // Nali smo poljuben znak. Podaljamo konec pogoja in nadaljujemo.
                pogoj.konec = ++interval.konec;
            }
        }
    }

    pogoj.zacetek = 1;
    pogoj.konec   = 0;

    interval.zacetek = 1;
    interval.konec   = 0;
    return FALSE;
}


template <class TIP> T_VOID RHTMLRegElDeklaracijaPogojZacP<TIP>::Razveljavi()
{
    // Razveljavimo podelemente.
    pogoj.zacetek = 1;
    pogoj.konec   = 0;

    RRegElementP<TIP>::Razveljavi();
}


//////////////////////////////////////////////////////////////////////
// RHTMLRegElDeklaracijaPogojKonP
//////////////////////////////////////////////////////////////////////

template <class TIP> RHTMLRegElDeklaracijaPogojKonP<TIP>::RHTMLRegElDeklaracijaPogojKonP() : RRegElementP<TIP>()
{
}


template <class TIP> T_BOOL RHTMLRegElDeklaracijaPogojKonP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    UNREFERENCED_PARAMETER(zastavice);

    if (zacetek + 2 < konec &&
        besedilo[zacetek    ] == ']' &&
        besedilo[zacetek + 1] == ']' &&
        besedilo[zacetek + 2] == '>')
    {
        // Nali smo zakljuno zaporedje za pogoj ("]]>").
        interval.zacetek = zacetek;
        interval.konec   = zacetek + 3;
        return TRUE;
    } else {
        interval.zacetek = 1;
        interval.konec   = 0;
        return FALSE;
    }
}


//////////////////////////////////////////////////////////////////////
// RCSSRegElKomentarP
//////////////////////////////////////////////////////////////////////

template <class TIP> RCSSRegElKomentarP<TIP>::RCSSRegElKomentarP() :
    RRegElementP<TIP>(),
    vsebina(1, 0)
{
}


template <class TIP> T_BOOL RCSSRegElKomentarP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    UNREFERENCED_PARAMETER(zastavice);

    if (zacetek + 1 < konec &&
        besedilo[zacetek    ] == '/' &&
        besedilo[zacetek + 1] == '*')
    {
        // Nali smo uvodno zaporedje za komentar ("/*").
        vsebina.zacetek = interval.konec = zacetek + 2;

        for (;;) {
            if (interval.konec >= konec || !besedilo[interval.konec]) {
                // Komentar ni zakljuen in ni veljaven.
                break;
            } else if (interval.konec + 1 < konec &&
                besedilo[interval.konec    ] == '*' &&
                besedilo[interval.konec + 1] == '/')
            {
                // Nali smo konec pogoja.
                vsebina.konec    = interval.konec;
                interval.zacetek = zacetek;
                interval.konec   = interval.konec + 2;
                return TRUE;
            } else {
                // Nali smo poljuben znak.
                interval.konec++;
            }
        }
    }

    vsebina.zacetek  = 1;
    vsebina.konec    = 0;

    interval.zacetek = 1;
    interval.konec   = 0;
    return FALSE;
}


template <class TIP> T_VOID RCSSRegElKomentarP<TIP>::Razveljavi()
{
    // Razveljavimo podelemente.
    vsebina.zacetek  = 1;
    vsebina.konec    = 0;

    RRegElementP<TIP>::Razveljavi();
}


//////////////////////////////////////////////////////////////////////
// RCSSRegElCDOP
//////////////////////////////////////////////////////////////////////

template <class TIP> RCSSRegElCDOP<TIP>::RCSSRegElCDOP() : RRegElementP<TIP>()
{
}


template <class TIP> T_BOOL RCSSRegElCDOP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    UNREFERENCED_PARAMETER(zastavice);

    if (zacetek + 3 < konec &&
        besedilo[zacetek    ] == '<' &&
        besedilo[zacetek + 1] == '!' &&
        besedilo[zacetek + 2] == '-' &&
        besedilo[zacetek + 3] == '-')
    {
        // Nali smo zaporedje za CDO ("<!--").
        interval.zacetek = zacetek;
        interval.konec   = zacetek + 4;
        return TRUE;
    }

    interval.zacetek = 1;
    interval.konec   = 0;
    return FALSE;
}


//////////////////////////////////////////////////////////////////////
// RCSSRegElCDCP
//////////////////////////////////////////////////////////////////////

template <class TIP> RCSSRegElCDCP<TIP>::RCSSRegElCDCP() : RRegElementP<TIP>()
{
}


template <class TIP> T_BOOL RCSSRegElCDCP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    UNREFERENCED_PARAMETER(zastavice);

    if (zacetek + 2 < konec &&
        besedilo[zacetek    ] == '-' &&
        besedilo[zacetek + 1] == '-' &&
        besedilo[zacetek + 2] == '>')
    {
        // Nali smo zaporedje za CDC ("-->").
        interval.zacetek = zacetek;
        interval.konec   = zacetek + 3;
        return TRUE;
    }

    interval.zacetek = 1;
    interval.konec   = 0;
    return FALSE;
}


//////////////////////////////////////////////////////////////////////
// RCSSRegElStringP
//////////////////////////////////////////////////////////////////////

template <class TIP> RCSSRegElStringP<TIP>::RCSSRegElStringP() :
    RRegElementP<TIP>(),
    vsebina(1, 0)
{
}


template <class TIP> T_BOOL RCSSRegElStringP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(0); // TODO: Preizkusi ta del kode.
    assert(besedilo || !konec);
    UNREFERENCED_PARAMETER(zastavice);

    // Zanemo na zaetku.
    interval.konec = zacetek;

    if (interval.konec < konec &&
        (besedilo[interval.konec] == '\"' || besedilo[interval.konec] == '\''))
    {
        // Nali smo zaetni narekovaj.
        TIP narekovaj = besedilo[interval.konec];

        vsebina.zacetek = ++interval.konec;

        // Poiemo konni narekovaj.
        for (;;) {
            if (interval.konec >= konec || !besedilo[interval.konec]) {
                // Konnega narekovaja nismo nali, ker nam je prezgodaj zmanjkalo znakov.
                break;
            } else if (interval.konec + 1< konec &&
                 besedilo[interval.konec    ] == '\\' &&
                (besedilo[interval.konec + 1] == '\"' || besedilo[interval.konec + 1] == '\''))
            {
                // Nali smo zaiten narekovaj, ki ne predstavlja konca niza.
                interval.konec = interval.konec + 2;
            } else if (besedilo[interval.konec] == narekovaj) {
                // Nali smo enak narekovaj, kot je bil uvodni, zato konamo.
                vsebina.konec    = interval.konec;
                interval.zacetek = zacetek;
                interval.konec++;
                return TRUE;
            } else {
                // Preskoimo vsak znak.
                interval.konec++;
            }
        }
    }

    vsebina.zacetek  = 1;
    vsebina.konec    = 0;

    interval.zacetek = 1;
    interval.konec   = 0;
    return FALSE;
}


template <class TIP> T_VOID RCSSRegElStringP<TIP>::Razveljavi()
{
    // Razveljavimo podelemente.
    vsebina.zacetek  = 1;
    vsebina.konec    = 0;

    RRegElementP<TIP>::Razveljavi();
}


//////////////////////////////////////////////////////////////////////
// RCSSRegElURIP
//////////////////////////////////////////////////////////////////////

template <class TIP> RCSSRegElURIP<TIP>::RCSSRegElURIP() :
    RRegElementP<TIP>(),
    vsebina(1, 0)
{
}


template <class TIP> T_BOOL RCSSRegElURIP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    UNREFERENCED_PARAMETER(zastavice);

    // Zanemo na zaetku.
    interval.konec = zacetek;

    if (interval.konec + 3 >= konec &&
        (besedilo[interval.konec    ] == 'u' || besedilo[interval.konec    ] == 'U') &&
        (besedilo[interval.konec + 1] == 'r' || besedilo[interval.konec + 1] == 'R') &&
        (besedilo[interval.konec + 2] == 'l' || besedilo[interval.konec + 2] == 'L') &&
         besedilo[interval.konec + 3] == '(')
    {
        // Nali smo uvodni niz "url(".
        interval.konec = interval.konec + 4;

        // Preskoimo presledke.
        for (; interval.konec < konec && besedilo[interval.konec] && aisspace(besedilo[interval.konec]); interval.konec++);

        if (interval.konec < konec &&
            (besedilo[interval.konec] == '\"' || besedilo[interval.konec] == '\''))
        {
            // Nali smo zaetni narekovaj. URL je zapisan kot niz.
            TIP narekovaj = besedilo[interval.konec];

            vsebina.zacetek = ++interval.konec;

            // Poiemo konni narekovaj.
            for (;;) {
                if (interval.konec >= konec || !besedilo[interval.konec]) {
                    // Konnega narekovaja nismo nali, ker nam je prezgodaj zmanjkalo znakov.
                    goto napaka;
                } else if (interval.konec + 1< konec &&
                     besedilo[interval.konec    ] == '\\' &&
                    (besedilo[interval.konec + 1] == '\"' || besedilo[interval.konec + 1] == '\''))
                {
                    // Nali smo zaiten narekovaj, ki ne predstavlja konca niza.
                    interval.konec = interval.konec + 2;
                } else if (besedilo[interval.konec] == narekovaj) {
                    // Nali smo enak narekovaj, kot je bil uvodni, zato konamo.
                    vsebina.konec  = interval.konec;
                    interval.konec++;
                    break;
                } else {
                    // Preskoimo vsak znak.
                    interval.konec++;
                }
            }

            // Preskoimo presledke.
            for (; interval.konec < konec && besedilo[interval.konec] && aisspace(besedilo[interval.konec]); interval.konec++);

            if (interval.konec < konec &&
                besedilo[interval.konec] == ')')
            {
                // Nali smo zakljuni zaklepaj.
                interval.zacetek = zacetek;
                interval.konec++;
                return TRUE;
            }
        } else {
            // URL je zapisan brez narekovajev.
            vsebina.zacetek = vsebina.konec = interval.konec;

            for (;;) {
                if (interval.konec >= konec || !besedilo[interval.konec]) {
                    // Zakljunega zaklepaja nismo nali, ker nam je prezgodaj zmanjkalo znakov.
                    goto napaka;
                } else if (besedilo[interval.konec] == ')') {
                    // Nali smo zakljuni zaklepaj.
                    interval.zacetek = zacetek;
                    interval.konec++;
                    return TRUE;
                } else if (aisspace(besedilo[interval.konec])) {
                    // Nali smo presledek, ki ga preskoimo.
                    interval.konec++;
                } else {
                    // Preskoimo vsak znak. Vmes prilagajamo interval vsebine.
                    vsebina.konec = ++interval.konec;
                }
            }
        }
    }

napaka:
    vsebina.zacetek  = 1;
    vsebina.konec    = 0;

    interval.zacetek = 1;
    interval.konec   = 0;
    return FALSE;
}


template <class TIP> T_VOID RCSSRegElURIP<TIP>::Razveljavi()
{
    // Razveljavimo podelemente.
    vsebina.zacetek  = 1;
    vsebina.konec    = 0;

    RRegElementP<TIP>::Razveljavi();
}


//////////////////////////////////////////////////////////////////////
// RCSSRegElImportP
//////////////////////////////////////////////////////////////////////

template <class TIP> RCSSRegElImportP<TIP>::RCSSRegElImportP() :
    RRegElementP<TIP>(),
    vsebina(1, 0)
{
}


template <class TIP> T_BOOL RCSSRegElImportP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    UNREFERENCED_PARAMETER(zastavice);

    // Zanemo na zaetku.
    interval.konec = zacetek;

    if (interval.konec + 6 < konec &&
         besedilo[interval.konec    ] == '@' &&
        (besedilo[interval.konec + 1] == 'i' || besedilo[interval.konec + 1] == 'I') &&
        (besedilo[interval.konec + 2] == 'm' || besedilo[interval.konec + 2] == 'M') &&
        (besedilo[interval.konec + 3] == 'p' || besedilo[interval.konec + 3] == 'P') &&
        (besedilo[interval.konec + 4] == 'o' || besedilo[interval.konec + 4] == 'O') &&
        (besedilo[interval.konec + 5] == 'r' || besedilo[interval.konec + 5] == 'R') &&
        (besedilo[interval.konec + 6] == 't' || besedilo[interval.konec + 6] == 'T'))
    {
        // Nali smo uvodni niz "@import".
        interval.konec = interval.konec + 7;

        // Preskoimo presledke.
        for (; interval.konec < konec && besedilo[interval.konec] && aisspace(besedilo[interval.konec]); interval.konec++);

        if (interval.konec < konec &&
            (besedilo[interval.konec] == '\"' || besedilo[interval.konec] == '\''))
        {
            // Nali smo zaetni narekovaj. URL je zapisan kot niz.
            TIP narekovaj = besedilo[interval.konec];

            vsebina.zacetek = ++interval.konec;

            // Poiemo konni narekovaj.
            for (;;) {
                if (interval.konec >= konec || !besedilo[interval.konec]) {
                    // Konnega narekovaja nismo nali, ker nam je prezgodaj zmanjkalo znakov.
                    goto napaka;
                } else if (interval.konec + 1< konec &&
                     besedilo[interval.konec    ] == '\\' &&
                    (besedilo[interval.konec + 1] == '\"' || besedilo[interval.konec + 1] == '\''))
                {
                    // Nali smo zaiten narekovaj, ki ne predstavlja konca niza.
                    interval.konec = interval.konec + 2;
                } else if (besedilo[interval.konec] == narekovaj) {
                    // Nali smo enak narekovaj, kot je bil uvodni, zato konamo.
                    vsebina.konec    = interval.konec;
                    interval.zacetek = zacetek;
                    interval.konec++;
                    return TRUE;
                } else {
                    // Preskoimo vsak znak.
                    interval.konec++;
                }
            }
        }
    }

napaka:
    vsebina.zacetek  = 1;
    vsebina.konec    = 0;

    interval.zacetek = 1;
    interval.konec   = 0;
    return FALSE;
}


template <class TIP> T_VOID RCSSRegElImportP<TIP>::Razveljavi()
{
    // Razveljavimo podelemente.
    vsebina.zacetek  = 1;
    vsebina.konec    = 0;

    RRegElementP<TIP>::Razveljavi();
}


//////////////////////////////////////////////////////////////////////
// RMIMERegElContentTypeP
//////////////////////////////////////////////////////////////////////

template <class TIP> RMIMERegElContentTypeP<TIP>::RMIMERegElContentTypeP() :
    RRegElementP<TIP>(),
    mime_osnovni(1, 0),
    mime_dodatni(1, 0),
    kodna_stran(1, 0)
{
}


template <class TIP> T_BOOL RMIMERegElContentTypeP<TIP>::PreveriUjemanje(const TIP *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);
    UNREFERENCED_PARAMETER(zastavice);

    // Zanemo na zaetku.
    interval.konec = zacetek;

    mime_osnovni.zacetek = interval.konec;
    for (;;) {
        if (interval.konec >= konec || !besedilo[interval.konec]) {
            // Zmanjkalo je znakov.
            break;
        } else if (
            besedilo[interval.konec] == '/' ||
            besedilo[interval.konec] == ';' ||
            aisspace(besedilo[interval.konec]))
        {
            // Nali smo znak, ki ni ve del tipa MIME.
            break;
        } else {
            // Drugi znaki so del tipa MIME.
            interval.konec++;
        }
    }
    if (mime_osnovni.zacetek < interval.konec) {
        // Nali smo osnovni tip MIME.
        mime_osnovni.konec = interval.konec;

        if (interval.konec < konec && besedilo[interval.konec] == '/') {
            // Nali smo loilo med osnovnim in dodatnim tipom MIME.
            interval.konec++;

            mime_dodatni.zacetek = interval.konec;
            for (;;) {
                if (interval.konec >= konec || !besedilo[interval.konec]) {
                    // Zmanjkalo je znakov.
                    break;
                } else if (
                    besedilo[interval.konec] == '/' ||
                    besedilo[interval.konec] == ';' ||
                    aisspace(besedilo[interval.konec]))
                {
                    // Nali smo znak, ki ni ve del tipa MIME.
                    break;
                } else {
                    // Drugi znaki so del tipa MIME.
                    interval.konec++;
                }
            }
            if (mime_dodatni.zacetek < interval.konec) {
                // Nali smo dodatni tip MIME.
                mime_dodatni.konec = interval.konec;

                // Predpostavimo, da kodne strani ne bo.
                kodna_stran.zacetek  = 1;
                kodna_stran.konec    = 0;

                if (interval.konec <konec && besedilo[interval.konec] == ';') {
                    interval.konec++;

                    // Preskoimo presledke.
                    for (; interval.konec < konec && besedilo[interval.konec] && aisspace(besedilo[interval.konec]); interval.konec++);

                    if (interval.konec + 7 < konec &&
                        (besedilo[interval.konec    ] == 'c' || besedilo[interval.konec    ] == 'C') &&
                        (besedilo[interval.konec + 1] == 'h' || besedilo[interval.konec + 1] == 'H') &&
                        (besedilo[interval.konec + 2] == 'a' || besedilo[interval.konec + 2] == 'A') &&
                        (besedilo[interval.konec + 3] == 'r' || besedilo[interval.konec + 3] == 'R') &&
                        (besedilo[interval.konec + 4] == 's' || besedilo[interval.konec + 4] == 'S') &&
                        (besedilo[interval.konec + 5] == 'e' || besedilo[interval.konec + 5] == 'E') &&
                        (besedilo[interval.konec + 6] == 't' || besedilo[interval.konec + 6] == 'T') &&
                         besedilo[interval.konec + 7] == '=')
                    {
                        // Nali smo niz "charset=". Doloimo e kodno stran.
                        interval.konec = interval.konec + 8;

                        if (interval.konec < konec &&
                            (besedilo[interval.konec] == '\"' || besedilo[interval.konec] == '\''))
                        {
                            assert(0); // TODO: Preizkusi ta del kode.

                            // Nali smo narekovaj. Vrednost je zapisana v narekovajih.
                            TIP narekovaj = besedilo[interval.konec];

                            kodna_stran.zacetek = ++interval.konec;

                            // Poiemo konni narekovaj.
                            for (;;) {
                                if (interval.konec >= konec || !besedilo[interval.konec]) {
                                    // Konnega narekovaja nismo nali, ker nam je prezgodaj zmanjkalo znakov.
                                    kodna_stran.zacetek = 1;
                                    kodna_stran.konec   = 0;
                                    break;
                                } else if (besedilo[interval.konec] == narekovaj) {
                                    // Nali smo enak narekovaj, kot je bil uvodni, zato konamo.
                                    kodna_stran.konec = interval.konec;
                                    interval.konec++;
                                    break;
                                } else {
                                    // Preskoimo vsak znak.
                                    interval.konec++;
                                }
                            }
                        } else {
                            // Vrednost se ne zane z narekovajem, zato proglasimo vse do prvega presledka za vrednost.
                            kodna_stran.zacetek = interval.konec;

                            for (;;) {
                                if (interval.konec >= konec || !besedilo[interval.konec]) {
                                    // Zmanjkalo je znakov, zato konamo s tem, kar imamo do sedaj.
                                    kodna_stran.konec = interval.konec;
                                    break;
                                } if (aisspace(besedilo[interval.konec])) {
                                    // Nali smo presledek, zato konamo.
                                    kodna_stran.konec = interval.konec;
                                    break;
                                } else {
                                    // Preskoimo vsak znak.
                                    interval.konec++;
                                }
                            }
                        }
                    }
                }

                interval.zacetek = zacetek;
                return TRUE;
            }
        }
    }

    mime_osnovni.zacetek = 1;
    mime_osnovni.konec   = 0;
    mime_dodatni.zacetek = 1;
    mime_dodatni.konec   = 0;
    kodna_stran.zacetek  = 1;
    kodna_stran.konec    = 0;

    interval.zacetek = 1;
    interval.konec   = 0;
    return FALSE;
}


template <class TIP> T_VOID RMIMERegElContentTypeP<TIP>::Razveljavi()
{
    // Razveljavimo podelemente.
    mime_osnovni.zacetek = 1;
    mime_osnovni.konec   = 0;
    mime_dodatni.zacetek = 1;
    mime_dodatni.konec   = 0;
    kodna_stran.zacetek  = 1;
    kodna_stran.konec    = 0;

    RRegElementP<TIP>::Razveljavi();
}


//////////////////////////////////////////////////////////////////////
// RHTMLZeton
//////////////////////////////////////////////////////////////////////

inline T_UINT RHTMLZeton::PrilepiOznako(RNizU &niz) const
{
    T_UZNAK oznaka[HTML_OZNAKA_ZETONA_MAX];
    T_UINT dolzina;

    // Uporabimo %X namesto %p, da bo zapis oznake zavzel im manj znakov.
    dolzina = asnprintf(oznaka, HTML_OZNAKA_ZETONA_MAX, L"%c%" _L(T_UINT_PRINTF_SIZE_PREFIX) L"X%c", T_LOCALE_THREAD_DEFAULT, PR_K_KOMENTAR_ZACETEK, (T_UINT)this, PR_K_KOMENTAR_KONEC);
    assert(dolzina < HTML_OZNAKA_ZETONA_MAX);
    niz.Prilepi(oznaka, HTML_OZNAKA_ZETONA_MAX);
    return dolzina;
}


inline RHTMLZeton* RHTMLZeton::AnalizirajOznako(TK_UNICODE niz, T_UINT &odmik)
{
    RHTMLZeton *zeton;
    T_UINT konec, dolzina;

    if (niz[odmik] == PR_K_KOMENTAR_ZACETEK) {
        // Poiemo konec oznake.
        for (konec = odmik + 1; ; konec++) {
            if (!niz[konec]) {
                // Niz se je prezgodaj zakljuil.
                return NULL;
            } else if (niz[konec] == PR_K_KOMENTAR_KONEC) {
                // Nali smo konec oznake.
                break;
            }
        }

        // V nadomestni oznaki je zapisan naslov etona estnajstiko.
        zeton = (RHTMLZeton*)astrtoui(niz + odmik + 1, konec - odmik - 1, &dolzina, 16);

        // eton ne sme biti enak NULL.
        assert(zeton);

        odmik = konec + 1;
        return zeton;
    } else
        return NULL;
}


//////////////////////////////////////////////////////////////////////
// RHTMLDokument
//////////////////////////////////////////////////////////////////////

inline T_STANJE RHTMLDokument::Nastavi(TK_UNICODE koda, T_UINT znakov)
{
    T_STANJE stanje;

    // Spraznemo staro vsebino dokumenta.
    Sprazni();

    // Prilepimo kodo HTML.
    stanje = Prilepi(koda, znakov);
    if (NEUSPESNO(stanje))
        return stanje;

    // Naznanimo konec dokumenta.
    return Zakljuci();
}


inline T_UINT RHTMLDokument::ZamenjajEntitete(RNizU &izhod, TK_UNICODE vhod, T_UINT znakov) const
{
    assert(vhod || !znakov);
    T_UINT i, j, st_entitet = entitete.VrniStevilo();
    TK_UNICODE _koda = koda.Vrni();

    izhod.Sprazni();
    for (i = 0; i < znakov && vhod[i];) {
        if (vhod[i] == L'%') {
            // Nali smo entiteto.
            for (j = 0; j < st_entitet; j++) {
                const RHTMLEntiteta *e = entitete[j];
                assert(e);
                T_UINT dolzina_entitete = e->ime.VrniDolzino();

                if (i + dolzina_entitete + 1 < znakov &&
                    !astrncmp(vhod + i + 1, _koda + e->ime.zacetek, dolzina_entitete) &&
                    vhod[i + dolzina_entitete + 1] == L';')
                {
                    // Razirimo entiteto.
                    izhod.Prilepi(e->vrednost);
                    i += dolzina_entitete + 2;
                    break;
                }
            }

            if (j < st_entitet) {
                // Entiteto smo nali in uspeno razirili.
                continue;
            } else {
                assert(0); // Entiteta ni definirana.
            }
        }

        izhod += vhod[i++];
    }

    return izhod.VrniDolzino();
}


//////////////////////////////////////////////////////////////////////
// RHTMLAnalizator
//////////////////////////////////////////////////////////////////////


inline const RHTMLTabelaZetonov& RHTMLAnalizator::VrniTabeloZetonov() const
{
    return zetoni;
}


inline RHTMLZeton* RHTMLAnalizator::DodajZeton(RHTMLZeton *zeton)
{
    if (zeton) {
        // Dodamo eton v zbirko etonov.
        zetoni += zeton;
    }

    return zeton;
}


inline RHTMLZeton* RHTMLAnalizator::DodajOznakoZetona(RHTMLZeton *zeton, RNizU &za_prevajanje)
{
    if (zeton) {
        // Dodamo eton v zbirko etonov.
        zetoni += zeton;

        // Prilepimo oznako etona k nizu za prevajanje.
        zeton->PrilepiOznako(za_prevajanje);
    }

    return zeton;
}


inline T_VOID RHTMLAnalizator::OdpriZetone(RNizU &besedilo_prevoda, RHTMLSeznamZetonov2 &odprti_zetoni, const RHTMLSeznamZetonov2 &novi_zetoni, T_ROCICA rocica)
{
    // Odpremo etone od "rocica" naprej.
    for (; rocica; rocica = novi_zetoni.VrniNaslednjega(rocica)) {
        RHTMLZeton *zeton = novi_zetoni[rocica];
        zeton->PrilepiOznako(besedilo_prevoda);
        odprti_zetoni.Dodaj(zeton);
    }
}


inline T_VOID RHTMLAnalizator::ZapisiVstavljeneZetone(RNizU &besedilo_prevoda, RHTMLSeznamVstavljenihZetonov &vstavljeni_zetoni, T_UINT indeks, T_BOOL za_besedo, RHTMLSeznamZetonov2 &odprti_zetoni)
{
    T_ROCICA rocica;

    for (rocica = vstavljeni_zetoni.VrniPrvega(); rocica; ) {
        T_HTMLVSTAVLJENZETON &p = vstavljeni_zetoni[rocica];
        assert(p.zeton);

        if (p.indeks_besede == indeks && p.za_besedo == za_besedo) {
            // Nali smo vstavljen eton, ki se nanaa na besedo indeks.
            T_ROCICA r;

            if (p.zeton->vrsta != HTML_ZETON_ZAKLJUCNI) {
                // Zapremo prejnje etone.
                r = ZapriZetone(besedilo_prevoda, odprti_zetoni, p.odprti_zetoni);

                // Odpremo nove etone.
                OdpriZetone(besedilo_prevoda, odprti_zetoni, p.odprti_zetoni, r);
            }

            // Zapiemo eton.
            p.zeton->PrilepiOznako(besedilo_prevoda);

            // Pobriemo uporabljeni eton.
            r = rocica;
            rocica = vstavljeni_zetoni.VrniNaslednjega(rocica);
            vstavljeni_zetoni.Brisi(r);
        } else
            rocica = vstavljeni_zetoni.VrniNaslednjega(rocica);
    }
}


inline T_VOID RHTMLAnalizator::Unija(RHTMLSeznamZetonov2 &a, const RHTMLSeznamZetonov2 &b)
{
    T_ROCICA r1, r2;

    for (r2 = b.VrniPrvega(); r2; r2 = b.VrniNaslednjega(r2)) {
        // Poiemo, ali je element iz seznama b e v seznamu a.
        RHTMLZeton *z2 = b[r2];
        T_BOOL najden = FALSE;

        for (r1 = a.VrniPrvega(); r1; r1 = a.VrniNaslednjega(r1)) {
            RHTMLZeton *z1 = a[r1];
            if (z1 == z2) {
                najden = TRUE;
                break;
            }
        }

        if (!najden) {
            // Elementa nismo nali v seznamu a, zato ga dodamo.
            a += z2;
        }
    }
}

#endif // AOSN_HTML


#ifdef AOSN_HTTP

//////////////////////////////////////////////////////////////////////
// RRegElHTTPUtezenZapis
//////////////////////////////////////////////////////////////////////

template <class TIP> RRegElHTTPUtezenZapis<TIP>::RRegElHTTPUtezenZapis() :
    RRegElementA(),
    zvezdica(1, 0)
{
}


template <class TIP> T_BOOL RRegElHTTPUtezenZapis<TIP>::PreveriUjemanje(const T_AZNAK *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);

    T_UINT konec_jezika;

    interval.konec = zacetek;

    if (interval.konec < konec && besedilo[interval.konec] == '*') {
        // Nali smo zvezdico, ki oznauje univerzalno vrednost.
        zvezdica.konec = (zvezdica.zacetek = interval.konec) + 1;
        interval.konec = konec_jezika = zvezdica.konec;
        vrednost.Razveljavi();
    } else if (vrednost.PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
        // Nali smo konkretno vrednost.
        interval.konec = konec_jezika = vrednost.interval.konec;
        zvezdica.zacetek = 1;
        zvezdica.konec   = 0;
    } else {
        // Nismo nali ne zvezdice ne zapisa.
        zvezdica.zacetek = 1;
        zvezdica.konec   = 0;
        vrednost.Razveljavi();

        interval.zacetek = (interval.konec = zacetek) + 1;
        return FALSE;
    }

    // Preverimo, ali sledi faktor kakovosti.
    while (interval.konec < konec && besedilo[interval.konec] && aisspace(besedilo[interval.konec])) interval.konec++;
    if (interval.konec < konec && besedilo[interval.konec] == ';') {
        interval.konec++;
        while (interval.konec < konec && besedilo[interval.konec] && aisspace(besedilo[interval.konec])) interval.konec++;
        if (interval.konec < konec && (besedilo[interval.konec] == 'q' || besedilo[interval.konec] == 'Q')) {
            interval.konec++;
            while (interval.konec < konec && besedilo[interval.konec] && aisspace(besedilo[interval.konec])) interval.konec++;
            if (interval.konec < konec && besedilo[interval.konec] == '=') {
                interval.konec++;
                while (interval.konec < konec && besedilo[interval.konec] && aisspace(besedilo[interval.konec])) interval.konec++;
                if (faktor.PreveriUjemanje(besedilo, interval.konec, konec, zastavice)) {
                    // Nali smo faktor kakovosti.
                    interval.konec = faktor.interval.konec;
                }
            }
        }
    }

    if (!faktor.interval.JeVeljaven()) {
        // Faktorja nismo nali, zato ga nastavimo na privzeto vrednost in se vrnemo na konec jezika.
        faktor.Razveljavi();
        interval.konec = konec_jezika;
    }

    interval.zacetek = zacetek;
    return TRUE;
}


template <class TIP> T_VOID RRegElHTTPUtezenZapis<TIP>::Razveljavi()
{
    // Razveljavimo podelemente.
    zvezdica.zacetek = 1;
    zvezdica.konec   = 0;
    vrednost.Razveljavi();
    faktor.Razveljavi();

    RRegElementA::Razveljavi();
}


//////////////////////////////////////////////////////////////////////
// RSeznamElementovGlaveHTTP
//////////////////////////////////////////////////////////////////////

template <class TIP> RSeznamElementovGlaveHTTP<TIP>::RSeznamElementovGlaveHTTP() : TIP()
{
}


template <class TIP> RSeznamElementovGlaveHTTP<TIP>::~RSeznamElementovGlaveHTTP()
{
    Unici();
}


template <class TIP> T_VOID RSeznamElementovGlaveHTTP<TIP>::DodajIzGlave(const T_AZNAK *besedilo, T_UINT zacetek, T_UINT konec, T_UINT zastavice)
{
    assert(besedilo || !konec);

    while (zacetek < konec) {
        T_ROCICA rocica;

        // Preskoimo vejico in presledke med elementi.
        while (zacetek < konec && besedilo[zacetek] && aisspace(besedilo[zacetek])) zacetek++;
        if (zacetek < konec && besedilo[zacetek] == ',') {
            zacetek++;
            while (zacetek < konec && besedilo[zacetek] && aisspace(besedilo[zacetek])) zacetek++;
        }

        // Identificiramo element.
        rocica = UstvariVozel();
        assert(rocica);
        RRegElementA &el = VrniElement(rocica);

        if (el.PreveriUjemanje(besedilo, zacetek, konec, zastavice)) {
            // Nali smo element. Dodamo ga v spisek.
            zacetek = el.interval.konec;
            DodajVozel(rocica);
        } else {
            // Nismo nali elementa, zato konamo.
            UniciVozel(rocica);
            break;
        }
    }
}


//////////////////////////////////////////////////////////////////////
// RSeznamUtezenihZapisovHTTP
//////////////////////////////////////////////////////////////////////

template <class TIP> T_INT RSeznamUtezenihZapisovHTTP<TIP>::Primerjaj(TIP const &prvi, TIP const &drugi) const
{
    if (prvi.faktor.vrednost > drugi.faktor.vrednost) {
        return -1;
    } else if (prvi.faktor.vrednost < drugi.faktor.vrednost) {
        return 1;
    } else
        return 0;
}


//////////////////////////////////////////////////////////////////////
// ROdjemalecHTTP
//////////////////////////////////////////////////////////////////////

inline T_ROCICA ROdjemalecHTTP::NajdiGlavo(TK_ASCII ime_glave, T_UINT dolzina) const
{
    return NajdiGlavo(glave_zahteve.VrniPrvega(), ime_glave, dolzina);
}


inline T_ROCICA ROdjemalecHTTP::NajdiGlavo(T_ROCICA rocica, TK_ASCII ime_glave, T_UINT dolzina) const
{
    TK_ASCII podatki = (TK_ASCII)podatki_glave.VrniPodatke();

    // Poiemo prvo glavo z elenim imenom.
    for (; rocica; rocica = glave_zahteve.VrniNaslednjega(rocica)) {
        RRegElHTTPGlava &glava = glave_zahteve.VrniElement(rocica);

        if (astrnicmp(podatki + glava.ime.zacetek, glava.ime.VrniDolzino(), ime_glave, dolzina) == 0)
            return rocica;
    }

    // Glave nismo nali.
    return NULL;
}


inline T_ROCICA ROdjemalecHTTP::NajdiParameterURL(TK_ASCII ime_parametra, T_UINT dolzina) const
{
    return NajdiParameterURL(zahteva.url.parametri.VrniPrvega(), ime_parametra, dolzina);
}


inline T_ROCICA ROdjemalecHTTP::NajdiParameterURL(T_ROCICA rocica, TK_ASCII ime_parametra, T_UINT dolzina) const
{
    TK_ASCII podatki = (TK_ASCII)podatki_glave.VrniPodatke();

    // Poiemo prvi parameter z elenim imenom.
    for (; rocica; rocica = zahteva.url.parametri.VrniNaslednjega(rocica)) {
        RRegElHTTPParameterURL &parameter = zahteva.url.parametri.VrniElement(rocica);

        if (astrnicmp(podatki + parameter.ime.zacetek, parameter.ime.VrniDolzino(), ime_parametra, dolzina) == 0)
            return rocica;
    }

    // Parametra nismo nali.
    return NULL;
}


inline T_STANJE ROdjemalecHTTP::PrilepiVrstico(RTokPodatkov &tok, RPomDatoteka &vsebina)
{
    T_AZNAK znak;
    TK_ASCII podatki;
    T_UINT odmik, dolzina;

    for (odmik = (T_UINT)vsebina.VrniDolzino();;) {
        // Preberemo en znak iz toka podatkov in ga dodamo v vsebino.
        tok >> znak;
        if (NEUSPESNO(tok.VrniStanje())) return AOSN_NAPAKA_HTTP_VRSTICA_PREKRATKA;
        assert(USPESNO(vsebina.VrniStanje()));
        vsebina << znak;

        podatki = (TK_ASCII)vsebina.VrniPodatke();
        dolzina = (T_UINT)vsebina.VrniDolzino();

        // Preverimo, ali smo presegli dovoljeno dolino vrstice.
        if (dolzina - odmik >= RHTTP_MAX_DOLZINA_VRSTICE) return AOSN_NAPAKA_HTTP_VRSTICA_PREDOLGA;

        if (dolzina >= 2 &&
            podatki[dolzina - 2] == '\r' &&
            podatki[dolzina - 1] == '\n' ||
            dolzina >= 1 &&
            podatki[dolzina - 1] == '\n')
        {
            // Prebrali smo zaporedje CRLF oziroma LF, ki naznanja konec vrstice.
            return A_OK;
        }
    }
}


inline T_STANJE ROdjemalecHTTP::PosljiOdgovor(T_UINT status)
{
    assert(tok);

    T_STANJE stanje;
    RNizA opis;

    if (verzija < 0x100) {
        // Pri protokolu HTTP stareje verzije (pred 1.0), odgovor nikoli ne vsebuje uvodne vrstice.
        assert(0);
        return A_OK;
    }

    // Sestavimo odgovor. Niz opis mora biti vedno v angleini, ker gre v glavo odgovora, niz vsebina pa je lokaliziran.
    VrniOpisStatusa(status, opis);

    // Poljemo glavo odgovora.
    stanje = tok->VrniStanje();
    if (NEUSPESNO(stanje)) return stanje;
    tok->ZapisiObl("HTTP/%u.%u %u %.*hs\r\n", T_LOCALE_THREAD_DEFAULT,
        (unsigned int)RHTTP_VERZIJA_HTTP_MAJ(verzija), (unsigned int)RHTTP_VERZIJA_HTTP_MIN(verzija),
        (unsigned int)status,
        (int)opis.VrniDolzino(), opis.Vrni());

    return A_OK;
}

#endif // AOSN_HTTP


#ifdef AOSN_IZJEMA

//////////////////////////////////////////////////////////////////////
// ROddajnikHTTP
//////////////////////////////////////////////////////////////////////

inline T_BOOL ROddajnikHTTP::JeVeljaven()
{
    return zahteva != NULL;
}


//////////////////////////////////////////////////////////////////////
// ROddajnikIzjem
//////////////////////////////////////////////////////////////////////

inline T_STANJE ROddajnikIzjem::Odpri()
{
    return ROddajnikHTTP::Odpri(
        AOSN_AHROSCAR_STREZNIK,
        AOSN_AHROSCAR_STREZNIK_VRATA,
        AOSN_AHROSCAR_SKR_SPREJEM,
        NULL,
        NULL,
        _T("POST"),
        _T("AHroscar/") _T(AOSN_VERZIJA_STR),
        zelena_vrsta_odgovora);
}

inline T_STANJE ROddajnikIzjem::PreberiOdgovor(T_UINT &status)
{
    return ROddajnikHTTP::PreberiOdgovor(zelena_vrsta_odgovora[0], status, vrsta_odgovora, odgovor);
}


//////////////////////////////////////////////////////////////////////
// RRokovalnikIzjem
//////////////////////////////////////////////////////////////////////

inline T_STANJE RRokovalnikIzjem::UstvariDodatniOpis(TK_ASCII niz, T_UINT znakov, T_KODNASTRAN kodna_stran)
{
    assert(niz || !znakov);

    if (indeks_tls_dodatnega_opisa != TLS_OUT_OF_INDEXES) {
        // Besedilo shranimo v TLS.
        T_UNICODE _niz = (T_UNICODE)::TlsGetValue(indeks_tls_dodatnega_opisa);
        if (_niz) return AOSN_NAPAKA_ZE_OBSTAJA;
        astrndup2(&_niz, niz, znakov, kodna_stran);
        if (!_niz) return AOSN_NAPAKA_POMNILNIK;
        return ::TlsSetValue(indeks_tls_dodatnega_opisa, _niz) ? A_OK : AOSN_NAPAKA_NASTAVI;
    } else {
        // Besedilo shranimo neposredno v dodatni opis.
        dodatni_opis.NastaviA(niz, znakov, kodna_stran);
        return A_OK;
    }
}


inline T_STANJE RRokovalnikIzjem::UstvariDodatniOpis(TK_UNICODE niz, T_UINT znakov)
{
    assert(niz || !znakov);

    if (indeks_tls_dodatnega_opisa != TLS_OUT_OF_INDEXES) {
        // Besedilo shranimo v TLS.
        T_UNICODE _niz = (T_UNICODE)::TlsGetValue(indeks_tls_dodatnega_opisa);
        if (_niz) return AOSN_NAPAKA_ZE_OBSTAJA;
        // PAZI! Ta verzija astrndup() jemlje podano tevilo znakov za dokonnega (vkljuno z zakljunim). Tudi e je T_UINT_MAX.
        znakov = astrnlen(niz, znakov);
        _niz = (T_UNICODE)aalloc((znakov + 1)*sizeof(T_UZNAK));
        if (!_niz) return AOSN_NAPAKA_POMNILNIK;
        memcpy(_niz, niz, znakov * sizeof(T_UZNAK));
        _niz[znakov] = 0;
        return ::TlsSetValue(indeks_tls_dodatnega_opisa, _niz) ? A_OK : AOSN_NAPAKA_NASTAVI;
    } else {
        // Besedilo shranimo neposredno v dodatni opis.
        dodatni_opis.Nastavi(niz, znakov);
        return A_OK;
    }
}


inline T_STANJE RRokovalnikIzjem::UniciDodatniOpis()
{
    if (indeks_tls_dodatnega_opisa != TLS_OUT_OF_INDEXES) {
        T_UNICODE _niz = (T_UNICODE)::TlsGetValue(indeks_tls_dodatnega_opisa);
        if (_niz) {
            afree(_niz);
            verify(::TlsSetValue(indeks_tls_dodatnega_opisa, NULL));
            return A_OK;
        } else
            return AOSN_OPOZORILO_NE_OBSTAJA;
    } else {
        dodatni_opis.Sprazni();
        return A_OK;
    }
}

#endif // AOSN_IZJEMA































































































































//////////////////////////////////////////////////////////////////////
// Funkcije za pretvorbe napak
//////////////////////////////////////////////////////////////////////

inline T_STANJE astanje(DWORD koda_win, T_STANJE privzeta)
{
    switch (koda_win) {
    case NO_ERROR:                          return A_OK;
    case ERROR_INVALID_FUNCTION:
    case ERROR_NOT_SUPPORTED:
    case ERROR_BAD_COMMAND:                 return AOSN_NAPAKA_NI_PODPRTO;
    case ERROR_FILE_NOT_FOUND:              return AOSN_NAPAKA_NI_DATOTEKE;
    case ERROR_PATH_NOT_FOUND:              return AOSN_NAPAKA_POT;
    case ERROR_TOO_MANY_OPEN_FILES:         return AOSN_NAPAKA_PREVEC_DATOTEK;
    case ERROR_ACCESS_DENIED:               return AOSN_NAPAKA_NI_DOSTOPA;
    case ERROR_SHARING_VIOLATION:           return AOSN_NAPAKA_NEDELJIV;
    case ERROR_LOCK_VIOLATION:              return AOSN_NAPAKA_ZAKLENJEN;
    case ERROR_INVALID_HANDLE:
    case ERROR_WINHTTP_INCORRECT_HANDLE_TYPE: return AOSN_NAPAKA_ROCICA;
    case ERROR_CRC:                         return AOSN_NAPAKA_CRC;
    case ERROR_NOT_READY:                   return AOSN_NAPAKA_NI_PRIPRAVLJEN;
    case ERROR_WRITE_PROTECT:               return AOSN_NAPAKA_ZASCITEN_MEDIJ;
    case ERROR_READ_FAULT:                  return AOSN_NAPAKA_BRANJE;
    case ERROR_WRITE_FAULT:                 return AOSN_NAPAKA_PISANJE;
    case ERROR_SECTOR_NOT_FOUND:            return AOSN_NAPAKA_NI_SEKTORJA;
    case ERROR_HANDLE_DISK_FULL:            return AOSN_NAPAKA_ZMANJKALO_PROSTORA;
    case ERROR_ALREADY_EXISTS:
    case NTE_EXISTS:                        return AOSN_NAPAKA_ZE_OBSTAJA;
    case ERROR_DATABASE_DOES_NOT_EXIST:     return AOSN_NAPAKA_NI_BAZE;
    case ERROR_INVALID_NAME:                return AOSN_NAPAKA_IME;
    case ERROR_SERVICE_DOES_NOT_EXIST:      return AOSN_NAPAKA_NI_SERVISA;
    case ERROR_CIRCULAR_DEPENDENCY:         return AOSN_NAPAKA_KROZNA_ODVISNOST;
    case ERROR_DUP_NAME:
    case ERROR_SERVICE_EXISTS:              return AOSN_NAPAKA_ZE_OBSTAJA;
    case ERROR_INVALID_SERVICE_ACCOUNT:     return AOSN_NAPAKA_NI_UPORABNIKA;
    case ERROR_SERVICE_MARKED_FOR_DELETE:   return AOSN_NAPAKA_ZE_OZNACEN_ZA_BRISANJE;
    case ERROR_SERVICE_ALREADY_RUNNING:     return AOSN_NAPAKA_ZE_ZAGNAN;
    case ERROR_SERVICE_DATABASE_LOCKED:     return AOSN_NAPAKA_ZAKLENJEN;
    case ERROR_SERVICE_LOGON_FAILED:        return AOSN_NAPAKA_PRIJAVA_UPORABNIKA;
    case ERROR_INVALID_THREAD_ID:           return AOSN_NAPAKA_NI_NIT;
    case ERROR_NO_MORE_ITEMS:               return AOSN_NAPAKA_NI_VEC_ZADETKOV;
    case ERROR_NOT_ENOUGH_MEMORY:
    case NTE_NO_MEMORY:                     return AOSN_NAPAKA_POMNILNIK;
    case ERROR_INVALID_PARAMETER:           return AOSN_NAPAKA_PARAMETER;
    case NTE_BAD_HASH_STATE:                return AOSN_NAPAKA_STANJE;
    case NTE_KEYSET_ENTRY_BAD:
    case NTE_BAD_KEYSET:                    return AOSN_NAPAKA_POKVARJENO_SKLADISCE;
    case NTE_KEYSET_NOT_DEF:                return AOSN_NAPAKA_NI_SKLADISCA;
    case ERROR_WINHTTP_INVALID_URL:         return AOSN_NAPAKA_URL;
    case ERROR_WINHTTP_OPERATION_CANCELLED: return AOSN_NAPAKA_PREKINJENO;
    case ERROR_WINHTTP_UNRECOGNIZED_SCHEME: return AOSN_NAPAKA_SHEMA;
    case ERROR_WINHTTP_TIMEOUT:             return AOSN_NAPAKA_CAS_POTEKEL;
#ifdef AOSN_VTIC
    case WSAECONNREFUSED:                   return AOSN_NAPAKA_POVEZAVA_ZAVRNJENA;
#endif
    case ERROR_RESOURCE_NAME_NOT_FOUND:     return AOSN_NAPAKA_VIRI;
    default: return privzeta;
    }
}


//////////////////////////////////////////////////////////////////////
// Predlogi amin in amax
//////////////////////////////////////////////////////////////////////

template <class TIP> inline TIP amin(const TIP v1, const TIP v2)
{
    return v2 < v1 ? v2 : v1;
}


template <class TIP> inline TIP amax(const TIP v1, const TIP v2)
{
    return v1 < v2 ? v2 : v1;
}


//////////////////////////////////////////////////////////////////////
// Predloge in funkcije za raunanje
//////////////////////////////////////////////////////////////////////

template <class TIP> inline T_INT asign(TIP num)
{
    if (num > (TIP)0.0) return 1;
    if (num < (TIP)0.0) return -1;
    return 0;
}


inline T_INT asign(T_UINT num)
{
    UNREFERENCED_PARAMETER(num);
    return 1;
}


template <class TIP> inline T_UINT around_pos(TIP num)
{
    assert(num >= (TIP)0.0);
    return (T_UINT)(num + (TIP)0.5);
}


inline float around(float num)
{
    float fraction, truncated, roundedFraction;

    fraction = modff(num, &truncated);
    modff(2.0f * fraction, &roundedFraction);
    return truncated + roundedFraction;
}


inline double around(double num)
{
    double fraction, truncated, roundedFraction;

    fraction = modf(num, &truncated);
    modf(2.0 * fraction, &roundedFraction);
    return truncated + roundedFraction;
}


template <class TIP> inline TIP aabs(const TIP num)
{
    return num < 0 ? -num : num;
}


inline T_UINT aabs(const T_UINT num)
{
    return num;
}


template <class TIP> inline TIP adiff(const TIP v1, const TIP v2)
{
    return v1 < v2 ? v2 - v1 : v1 - v2;
}


template <class TIP> inline T_VOID aswap(TIP &v1, TIP &v2)
{
    TIP pom = v1;
    v1 = v2;
    v2 = pom;
}


template <class TIP, T_INT(COMP)(const TIP &a, const TIP &b)> T_VOID aqsort(TIP *tabela, T_UINT st_elementov)
{
    assert(tabela || !st_elementov);

    if (st_elementov < 2) {
        // Imamo 0 ali 1 element, ni potrebe po urejanju.
    } else if (st_elementov < 3) {
        // Imamo dva elementa. Primerjamo ju in po potrebi obrnemo, da ne izvajamo polnega urejanja.
        if (COMP(tabela[1], tabela[0]) < 0)
            aswap(tabela[0], tabela[1]);
    } else if (st_elementov < AQSORT_MIN_DOLZINA) {
        register T_UINT i, j, n = st_elementov - 1;

        // Bubble-sort

        for (i = 0; i < n; i++) {
            for (j = i + 1; j < st_elementov; j++) {
                if (COMP(tabela[j], tabela[i]) < 0)
                    aswap(tabela[j], tabela[i]);
            }
        }
    } else {
        T_UINT p = 0;

        // Quick-sort

        // Naredimo loitev tabele na elemente manje ali enake in veje od pivota.
        {
            register T_UINT i;

            // Shranimo pivot na zacetek tabele. Sedaj bo pivot v tabela[0].
            aswap(tabela[st_elementov / 2], tabela[p]);

            // Naredimo loitev tabele tako, da na zaetek tabele shranimo vse elemente, ki so manji ali enaki pivotu.
            for (i = 1; i < st_elementov; i++)
                if (!(COMP(tabela[0], tabela[i]) < 0)) {
                    p++;
                    if (i != p)
                        aswap(tabela[i], tabela[p]);
                }

            // Vrnemo pivot na pravo mesto.
            aswap(tabela[p], tabela[0]);
        }

        // Uredimo e obe polovici.
        aqsort<TIP, COMP>(tabela, p);
        p++;
        aqsort<TIP, COMP>(tabela + p, st_elementov - p);
    }
}


template <class TIP, T_INT(COMP)(const TIP &a, const TIP &b)> inline T_UINT alinsearch(const TIP *tabela, T_UINT st_elementov, const TIP &iskani)
{
    assert(tabela || !st_elementov);

    register T_UINT i;

    for (i = 0; i < st_elementov; i++) {
        if (!COMP(tabela[i], iskani)) {
            // Nali smo element.
            return i;
        }
    }

    return T_UINT_MAX;
}


template <class TIP, T_INT(COMP)(const TIP &a, const TIP &b)> inline T_UINT abinsearch(const TIP *tabela, T_UINT st_elementov, const TIP &iskani)
{
    assert(tabela || !st_elementov);

    if (!st_elementov) {
        // Imamo 0 elementov, ni potrebe po urejanju.
    } else if (st_elementov < ABINSEARCH_MIN_DOLZINA) {
        register T_UINT i;
        register T_INT r;

        // Linearno iskanje po urejeni tabeli.

        for (i = 0; i < st_elementov; i++) {
            r = COMP(tabela[i], iskani);

            if (!r) {
                // Nali smo element.
                return i;
            } else if (r > 0) {
                // Elementa ne bomo ve nali, saj sledijo le e veji elementi.
                break;
            }
        }
    } else {
        register T_UINT l, d, s;
        register T_INT r;

        // Binarno iskanje.

        for (l = 0, d = st_elementov; l < d; ){
            s = (l + d) / 2;
            r = COMP(tabela[s], iskani);
            if (r < 0) {
                // Iskani element bo desno, e bo.
                l = s + 1;
            } else if (r > 0) {
                // Iskani element bo levo, e bo.
                d = s;
            } else {
                // Nali smo element.
                return s;
            }
        }
    }

    return T_UINT_MAX;
}


#if _MSC_VER >= 1300

template <class TIP> T_VOID aqsort(TIP *tabela, T_UINT st_elementov)
{
    assert(0); // TODO: Preizkusi ta del kode.
    assert(tabela || !st_elementov);

    if (st_elementov < 2) {
        // Imamo 0 ali 1 element, ni potrebe po urejanju.
    } else if (st_elementov < 3) {
        // Imamo dva elementa. Primerjamo ju in po potrebi obrnemo, da ne izvajamo polnega urejanja.
        if (tabela[1] < tabela[0])
            aswap(tabela[0], tabela[1]);
    } else if (st_elementov < AQSORT_MIN_DOLZINA) {
        register T_UINT i, j, n = st_elementov - 1;

        // Bubble-sort

        for (i = 0; i < n; i++) {
            for (j = i + 1; j < st_elementov; j++) {
                if (tabela[j] < tabela[i])
                    aswap(tabela[j], tabela[i]);
            }
        }
    } else {
        T_UINT p = 0;

        // Quick-sort

        // Naredimo loitev tabele na elemente manje ali enake in veje od pivota.
        {
            register T_UINT i;

            // Shranimo pivot na zacetek tabele. Sedaj bo pivot v tabela[0].
            aswap(tabela[st_elementov / 2], tabela[p]);

            // Naredimo loitev tabele tako, da na zaetek tabele shranimo vse elemente, ki so manji ali enaki pivotu.
            for (i = 1; i < st_elementov; i++)
                if (!(tabela[0] < tabela[i])) {
                    p++;
                    if (i != p)
                        aswap(tabela[i], tabela[p]);
                }

            // Vrnemo pivot na pravo mesto.
            aswap(tabela[p], tabela[0]);
        }

        // Uredimo e obe polovici.
        aqsort<TIP>(tabela, p);
        p++;
        aqsort<TIP>(tabela + p, st_elementov - p);
    }
}


template <class TIP> inline T_UINT alinsearch(const TIP *tabela, T_UINT st_elementov, const TIP &iskani)
{
    assert(0); // TODO: Preizkusi ta del kode.
    assert(tabela || !st_elementov);

    register T_UINT i;

    for (i = 0; i < st_elementov; i++) {
        if (tabela[i] < iskani)
            continue;
        else if (iskani < tabela[i])
            continue;
        else {
            // Nali smo element.
            return i;
        }
    }

    return T_UINT_MAX;
}


template <class TIP> inline T_UINT abinsearch(const TIP *tabela, T_UINT st_elementov, const TIP &iskani)
{
    assert(0); // TODO: Preizkusi ta del kode.
    assert(tabela || !st_elementov);

    if (!st_elementov) {
        // Imamo 0 elementov, ni potrebe po urejanju.
    } else if (st_elementov < ABINSEARCH_MIN_DOLZINA) {
        register T_UINT i;
        register T_INT r;

        // Linearno iskanje po urejeni tabeli.
        for (i = 0; i < st_elementov; i++) {
            if (tabela[i] < iskani)
                continue;
            else if (iskani < tabela[i]) {
                // Elementa ne bomo ve nali, saj sledijo le e veji elementi.
                break;
            } else {
                // Nali smo element.
                return i;
            }
        }
    } else {
        register T_UINT l, d, s;

        // Binarno iskanje.

        for (l = 0, d = st_elementov; l < d; ) {
            s = (l + d) / 2;
            if (tabela[s] < iskani) {
                // Iskani element bo desno, e bo.
                l = s + 1;
            } else if (iskani < tabela[s]) {
                // Iskani element bo levo, e bo.
                d = s;
            } else {
                // Nali smo element.
                return s;
            }
        }
    }

    return T_UINT_MAX;
}

#endif // _MSC_VER >= 1300


inline T_INT amuldiv(T_INT n, T_INT k, T_INT q)
{
#if defined(_WIN64)
    assert(n >= 0);  // TODO: Preizkusi ta del kode za negativne vrednosti n.
    assert(k >= 0);  // TODO: Preizkusi ta del kode za negativne vrednosti k.
    assert(q >= 0);  // TODO: Preizkusi ta del kode za negativne vrednosti q.

    T_INT h, l;

    // Pomnoimo nk. Rezultat bo l:h.
    l = _mul128(n, k, &h);

    // Bit po bit delimo l:h s q.
    for (T_UINT i = 0; i < 64; i++) {
        if (h >> 63) {
            h = ((h << 1) | (((T_UINT)l) >> 63)) - q;
            l = (l << 1) + 1;
        } else {
            h = ((h << 1) | (((T_UINT)l) >> 63));
            l = (l << 1);
            if (h >= q) {
                h -= q;
                l += 1;
            }
        }
    }

    // Ostanek je v h, rezultat pa v l.
    return l;
#elif defined(_WIN32)
    return (T_INT)((signed __int64)((signed __int64)n * k) / q);
#else
#error Platforma (e) ni podprta!
#endif
}


inline T_UINT amuldiv(T_UINT n, T_UINT k, T_UINT q)
{
#if defined(_WIN64)
    T_UINT h, l;

    // Pomnoimo nk. Rezultat bo l:h.
    l = _umul128(n, k, &h);

    // Bit po bit delimo l:h s q.
    for (T_UINT i = 0; i < 64; i++) {
        if (h >> 63) {
            h = ((h << 1) | (l >> 63)) - q;
            l = (l << 1) + 1;
        } else {
            h = ((h << 1) | (l >> 63));
            l = (l << 1);
            if (h >= q) {
                h -= q;
                l += 1;
            }
        }
    }

    // Ostanek je v h, rezultat pa v l.
    return l;
#elif defined(_WIN32)
    return (T_UINT)((unsigned __int64)((unsigned __int64)n * k) / q);
#else
#error Platforma (e) ni podprta!
#endif
}


template <class TIP> inline TIP agcd(TIP a, TIP b, TIP *_c, TIP *_d)
{
    T_INT
        u[3] = { 1, 0, aabs(a) },
        v[3] = { 0, 1, aabs(b) },
        t[3],
        *_u = u,
        *_v = v,
        *_t = t,
        *_w, q;

    while (_v[2]) {
        // Delimo tevili.
        q = _u[2] / _v[2];

        // Izraunamo novo vrednost iteracije.
        _t[0] = _u[0] - _v[0]*q;
        _t[1] = _u[1] - _v[1]*q;
        _t[2] = _u[2] - _v[2]*q;

        // Premeamo vektorje.
        _w = _u;
        _u = _v;
        _v = _t;
        _t = _w;
    }

    if (_c) *_c = _u[0] * asign(a);
    if (_d) *_d = _u[1] * asign(b);
    return _u[2];
}


//////////////////////////////////////////////////////////////////////
// Predloge funkcij za delo z imaginarnimi tevili
//////////////////////////////////////////////////////////////////////

template <class TIP> inline const TIP anorm(const T_KOMPLP<TIP> z)
{
    return z.r*z.r + z.i*z.i;
}


template <class TIP> inline const TIP anorm(const T_KOMPLRP<TIP> z)
{
    return z.a*z.a;
}


template <class TIP> inline const TIP aabs(const T_KOMPLP<TIP> z)
{
    return (TIP)sqrt(norm(z));
}


template <class TIP> inline const TIP aabs(const T_KOMPLRP<TIP> z)
{
    return z.a;
}


template <class TIP> inline const TIP aarg(const T_KOMPLP<TIP> z)
{
    return (TIP)atan2(z.i, z.r);
}


template <class TIP> inline const TIP aarg(const T_KOMPLRP<TIP> z)
{
    return z.f;
}


template <class TIP> inline const T_KOMPLP<TIP> alog(const T_KOMPLP<TIP> z)
{
    return T_KOMPLP<TIP>((TIP)log(abs(z)), arg(z));
}


template <class TIP> inline const T_KOMPLP<TIP> alog(const T_KOMPLRP<TIP> z)
{
    return T_KOMPLP<TIP>((TIP)log(z.a), z.f);
}


template <class TIP> inline const T_KOMPLP<TIP> aexp(const T_KOMPLP<TIP> z)
{
    register TIP
        a = (TIP)exp(z.r);

    return T_KOMPLP<TIP>(
        a*(TIP)cos(z.i),
        a*(TIP)sin(z.i)
    );
}


template <class TIP> inline const T_KOMPLP<TIP> apow(const T_KOMPLP<TIP> z1, const T_KOMPLP<TIP> z2)
{
    return exp(z2 * log(z1));
}


template <class TIP> inline const T_KOMPLP<TIP> apow(const T_KOMPLP<TIP> z, const TIP e)
{
    register TIP
        a = (TIP)pow((double)abs(z), (double)e),
        f = arg(z) * e;

    return T_KOMPLP<TIP>(
        a*(TIP)cos(f),
        a*(TIP)sin(f)
    );
}


template <class TIP> inline const T_KOMPLP<TIP> apow(const TIP r, const T_KOMPLP<TIP> z)
{
    return exp(z * (TIP)log(r));
}


template <class TIP> inline const T_KOMPLP<TIP> asin(const T_KOMPLP<TIP> z)
{
    register T_KOMPLP<TIP>
        t = exp(T_KOMPLP<TIP>(-z.i, z.r)),
        u = (t-1/t)*0.5;

    return T_KOMPLP<TIP>(u.i, -u.r);
}


template <class TIP> inline const T_KOMPLP<TIP> acos(const T_KOMPLP<TIP> z)
{
    register T_KOMPLP<TIP>
        t = exp(T_KOMPLP<TIP>(-z.i, z.r));

    return (t+1/t)*0.5;
}


template <class TIP> inline T_VOID asincos(const T_KOMPLP<TIP> z, T_KOMPLP<TIP> &s, T_KOMPLP<TIP> &c)
{
    register T_KOMPLP<TIP>
        t = exp(T_KOMPLP<TIP>(-z.i, z.r)),
        t_ = 1/t,
        u = (t-t_)*0.5;

    s = T_KOMPLP<TIP>(u.i, -u.r);
    c = (t+t_)*0.5;
}


template <class TIP> inline const T_KOMPLP<TIP> asinh(const T_KOMPLP<TIP> z)
{
    register T_KOMPLP<TIP> t = exp(z);
    return (t-1/t)*0.5;
}


template <class TIP> inline const T_KOMPLP<TIP> acosh(const T_KOMPLP<TIP> z)
{
    register T_KOMPLP<TIP> t = exp(z);
    return (t+1/t)*0.5;
}


template <class TIP> inline T_VOID asincosh(const T_KOMPLP<TIP> z, T_KOMPLP<TIP> &s, T_KOMPLP<TIP> &c)
{
    register T_KOMPLP<TIP>
        t = exp(z),
        t_ = 1/t;

    s = (t-t_)*0.5;
    c = (t+t_)*0.5;
}


//////////////////////////////////////////////////////////////////////
// Funkcije za rezervacijo pomnilnika
//////////////////////////////////////////////////////////////////////

inline T_KAZALEC _aalloc(T_SIZE dolzina)
{
    return ::HeapAlloc(agetheap(), 0, dolzina);
}


inline T_KAZALEC _arealloc(T_KAZALEC pom, T_SIZE dolzina)
{
    if (dolzina) {
        T_ROCICAOS kopica = agetheap();
        if (pom) {
            // Ponovno rezerviramo pomnilniki blok z novo dolino.
            return ::HeapReAlloc(kopica, 0, pom, dolzina);
        } else {
            // Parameter pom je enak NULL. Rezerviramo nov pomnilniki blok.
            return ::HeapAlloc(kopica, 0, dolzina);
        }
    } else if (pom) {
        // Kadar uporabnik eli spremeniti dolino podatkovnega bloka na 0, ga sprostimo.
        _afree(pom);
    }

    return NULL;
}


inline T_KAZALEC _aqrealloc(T_KAZALEC pom, T_SIZE dolzina, T_BOOL ne_krajsaj)
{
    T_ROCICAOS kopica = agetheap();

    // Ali je pomnilnik e rezerviran?
    if (pom) {
        // e je rezerviran veji kos, ga pustimo, oz. skrajamo.
        if (::HeapSize(kopica, 0, pom) >= dolzina) {
            // Novi pomnilniki blok bo kraji.
            return ne_krajsaj ? pom : ::HeapReAlloc(kopica, 0, pom, dolzina);
        } else {
            // Novi pomnilniki blok bo dalji. Blok najprej sprostimo.
            ::HeapFree(kopica, 0, pom);
        }
    }

    return ::HeapAlloc(kopica, 0, dolzina);
}


inline T_VOID _afree(T_KAZALEC pom)
{
    assert(pom);  // TODO: Poskusi, kaj se zgodi, e je pom == NULL.
    assert(aheapvalid(pom, 0));
    verify(::HeapFree(agetheap(), 0, pom));
}


inline T_SIZE _amsize(T_KAZALEC pom)
{
    assert(pom);  // TODO: Poskusi, kaj se zgodi, e je pom == NULL.
    return ::HeapSize(agetheap(), 0, pom);
}


inline T_BOOL _aheapvalid(T_KAZALEC pom, T_SIZE dolzina)
{
    T_ROCICAOS kopica = agetheap();

    // Preizkusimo, da dolina bloka ni kraja od priakovane.
    if (::HeapSize(kopica, 0, pom) < dolzina)
        return FALSE;

    // Preizkusimo, ali je pomnilniki blok v kopici veljaven.
    return ::HeapValidate(kopica, 0, pom) ? TRUE: FALSE;
}


//////////////////////////////////////////////////////////////////////
// Predloge funkcij in funkcije za delo z nizi
//////////////////////////////////////////////////////////////////////

template <class TIP> inline TIP* astrdup(const TIP* izvor)
{
    if (izvor) {
        register T_UINT znakov = astrlen(izvor) + 1;
        TIP* _izvor = (TIP*)aalloc(znakov*sizeof(TIP));
        assert(_izvor);

        astrncpy2(_izvor, znakov, izvor, T_UINT_MAX);
        return _izvor;
    } else
        return NULL;
}


template <class TIP> inline TIP* astrndup(const TIP* izvor, T_UINT znakov)
{
    assert(izvor || !znakov);

    TIP* _izvor = (TIP*)aalloc(znakov * sizeof(TIP));
    assert(_izvor);

    astrncpy2(_izvor, znakov, izvor, T_UINT_MAX);
    return _izvor;
}


template <class TIP> inline T_UINT astrdup2(TIP** cilj, const TIP* izvor)
{
    assert(cilj);

    if (izvor) {
        register T_UINT znakov = astrlen(izvor) + 1;
        (*cilj) = (TIP*)aalloc(znakov*sizeof(TIP));
        assert(*cilj);

        return astrncpy2(*cilj, znakov, izvor, T_UINT_MAX);
    } else {
        *cilj = NULL;
        return 0;
    }
}


inline T_UINT astrdup2(T_ASCII* cilj, TK_UNICODE izvor, T_KODNASTRAN kodna_stran)
{
    assert(cilj);

    if (izvor) {
        register T_UINT znakov = astrnlen(izvor, T_UINT_MAX, kodna_stran);
        (*cilj) = (T_ASCII)aalloc((znakov+1)*sizeof(T_AZNAK));
        assert(*cilj);

        verify(astrncpy2(*cilj, znakov, izvor, T_UINT_MAX, kodna_stran) == znakov);
        (*cilj)[znakov] = 0;
        return znakov;
    } else {
        *cilj = NULL;
        return 0;
    }
}


inline T_UINT astrdup2(T_UNICODE* cilj, TK_ASCII izvor, T_KODNASTRAN kodna_stran)
{
    assert(cilj);

    if (izvor) {
        register T_UINT znakov = astrnlen(izvor, T_UINT_MAX, kodna_stran);
        (*cilj) = (T_UNICODE)aalloc((znakov+1)*sizeof(T_UZNAK));
        assert(*cilj);

        znakov = astrncpy2(*cilj, znakov, izvor, T_UINT_MAX, kodna_stran);
        (*cilj)[znakov] = 0;
        return znakov;
    } else {
        *cilj = NULL;
        return 0;
    }
}


template <class TIP> inline T_UINT astrndup2(TIP** cilj, const TIP* izvor, T_UINT znakov)
{
    assert(cilj);
    assert(izvor || !znakov);

    (*cilj) = (TIP*)aalloc(znakov * sizeof(TIP));
    assert(*cilj);

    return astrncpy2(*cilj, znakov, izvor, T_UINT_MAX);
}


inline T_UINT astrndup2(T_ASCII* cilj, TK_UNICODE izvor, T_UINT znakov, T_KODNASTRAN kodna_stran)
{
    assert(cilj);
    assert(izvor || !znakov);

    register T_UINT znakov_cilj = astrnlen(izvor, znakov, kodna_stran);
    (*cilj) = (T_ASCII)aalloc((znakov_cilj+1)*sizeof(T_AZNAK));
    assert(*cilj);

    znakov_cilj = astrncpy2(*cilj, znakov_cilj, izvor, znakov, kodna_stran);
    (*cilj)[znakov_cilj] = 0;
    return znakov_cilj;
}


inline T_UINT astrndup2(T_UNICODE* cilj, TK_ASCII izvor, T_UINT znakov, T_KODNASTRAN kodna_stran)
{
    assert(cilj);
    assert(izvor || !znakov);

    register T_UINT znakov_cilj = astrnlen(izvor, znakov, kodna_stran);
    (*cilj) = (T_UNICODE)aalloc((znakov_cilj+1)*sizeof(T_UZNAK));
    assert(*cilj);

    znakov_cilj = astrncpy2(*cilj, znakov_cilj, izvor, znakov, kodna_stran);
    (*cilj)[znakov_cilj] = 0;
    return znakov_cilj;
}


template <class TIP> inline TIP* astrnset(TIP* niz, TIP znak, T_UINT znakov)
{
    assert(niz);

    register T_UINT i;
    for (i = 0; i < znakov; i++)
        niz[i] = znak;
    niz[i] = (TIP)0;
    return niz;
}


inline T_ASCII astrnset(T_ASCII niz, T_UZNAK znak, T_UINT znakov, T_KODNASTRAN kodna_stran)
{
    assert(niz);

    register T_UINT i;
    register T_AZNAK _znak = aunitoasc(znak, kodna_stran);
    for (i=0; i<znakov; i++)
        niz[i] = _znak;
    niz[i] = 0;
    return niz;
}


inline T_UNICODE astrnset(T_UNICODE niz, T_AZNAK znak, T_UINT znakov, T_KODNASTRAN kodna_stran)
{
    assert(niz);

    register T_UINT i;
    register T_UZNAK _znak = aasctouni(&znak, 1, kodna_stran);
    for (i=0; i<znakov; i++)
        niz[i] = _znak;
    niz[i] = 0;
    return niz;
}


template <class TIP> inline TIP* astrcpy(TIP* cilj, const TIP* izvor)
{
    astrcpy2<TIP>(cilj, izvor);
    return cilj;
}


inline T_ASCII astrcpy(T_ASCII cilj, TK_UNICODE izvor, T_KODNASTRAN kodna_stran)
{
    astrcpy2(cilj, izvor, kodna_stran);
    return cilj;
}


inline T_UNICODE astrcpy(T_UNICODE cilj, TK_ASCII izvor, T_KODNASTRAN kodna_stran)
{
    astrcpy2(cilj, izvor, kodna_stran);
    return cilj;
}


template <class TIP> inline TIP* astrncpy(TIP* cilj, const TIP* izvor, T_UINT znakov)
{
    astrncpy2<TIP>(cilj, izvor, znakov);
    return cilj;
}


template <class TIP> inline TIP* astrncpy(TIP* cilj, T_UINT znakov_cilj, const TIP* izvor, T_UINT znakov_izvor)
{
    register T_UINT znakov;
    znakov = astrncpy2<TIP>(cilj, znakov_cilj, izvor, znakov_izvor);
    if (znakov < znakov_cilj)
        cilj[znakov] = (TIP)0;
    return cilj;
}


inline T_ASCII astrncpy(T_ASCII cilj, T_UINT znakov_cilj, TK_UNICODE izvor, T_UINT znakov_izvor, T_KODNASTRAN kodna_stran)
{
    register T_UINT znakov;
    znakov = astrncpy2(cilj, znakov_cilj, izvor, znakov_izvor, kodna_stran);
    if (znakov < znakov_cilj)
        cilj[znakov] = (T_AZNAK)0;
    return cilj;
}


inline T_UNICODE astrncpy(T_UNICODE cilj, T_UINT znakov_cilj, TK_ASCII izvor, T_UINT znakov_izvor, T_KODNASTRAN kodna_stran)
{
    register T_UINT znakov;
    znakov = astrncpy2(cilj, znakov_cilj, izvor, znakov_izvor, kodna_stran);
    if (znakov < znakov_cilj)
        cilj[znakov] = (T_UZNAK)0;
    return cilj;
}


template <class TIP> inline T_UINT astrcpy2(TIP* cilj, const TIP* izvor)
{
    assert(cilj);
    assert(izvor);

    register T_UINT i = 0;

    for (;;) {
        if ((cilj[i] = izvor[i]) != 0)
            i++;
        else
            return i + 1;
    }
}


inline T_UINT astrcpy2(T_ASCII cilj, TK_UNICODE izvor, T_KODNASTRAN kodna_stran)
{
    assert(cilj);
    assert(izvor);

    register int potrebno  = ::WideCharToMultiByte(kodna_stran, 0, izvor, -1, NULL, 0,        NULL, NULL);
    register int prepisano = ::WideCharToMultiByte(kodna_stran, 0, izvor, -1, cilj, potrebno, NULL, NULL);
    assert(astrnlen(cilj, potrebno) == (T_UINT)prepisano - 1);
    return prepisano - 1;
}


inline T_UINT astrcpy2(T_UNICODE cilj, TK_ASCII izvor, T_KODNASTRAN kodna_stran)
{
    assert(cilj);
    assert(izvor);

    register DWORD zastavice = kodna_stran < KODNASTRAN_UTF7 ? MB_PRECOMPOSED : 0;
    register int potrebno  = ::MultiByteToWideChar(kodna_stran, zastavice, izvor, -1, NULL, 0);
    register int prepisano = ::MultiByteToWideChar(kodna_stran, zastavice, izvor, -1, cilj, potrebno);
    assert(astrnlen(cilj, potrebno) == (T_UINT)prepisano - 1);
    return prepisano - 1;
}


template <class TIP> inline T_UINT astrncpy2(TIP* cilj, const TIP* izvor, T_UINT znakov)
{
    assert(cilj && izvor || !znakov);

    register T_UINT i = 0;

    for (;;) {
        if (i < znakov) {
            if ((cilj[i] = izvor[i]) != 0) {
                // Prepisali smo znak, ki pa e ni zakljuni. Nadaljujemo.
                i++;
            } else {
                // Prepisali smo zakljuni znak. Konamo.
                return i;
            }
        } else {
            // Naleteli smo na dolinsko omejitev. Konamo.
            return i;
        }
    }
}


template <class TIP> inline T_UINT astrncpy2(TIP* cilj, T_UINT znakov_cilj, const TIP* izvor, T_UINT znakov_izvor)
{
    assert(cilj  || !znakov_cilj);
    assert(izvor || !znakov_izvor);

    return astrncpy2(cilj, izvor, amin<T_UINT>(znakov_cilj, znakov_izvor));
}


inline T_UINT astrncpy2(T_ASCII cilj, T_UINT znakov_cilj, TK_UNICODE izvor, T_UINT znakov_izvor, T_KODNASTRAN kodna_stran)
{
    assert(cilj  || !znakov_cilj);
    assert(izvor || !znakov_izvor);

    if (izvor && znakov_izvor && znakov_cilj) {
        register int prepisano = ::WideCharToMultiByte(kodna_stran, 0, izvor, (int)znakov_izvor, cilj, (int)znakov_cilj, NULL, NULL);
        if (prepisano) {
            // Funkcija je uspeno pretvorila niz, ne vemo pa, ali je prepisala tudi zakljuni znak, ali ne.
            return astrnlen(cilj, prepisano);
        } else {
            // Zmanjkalo je prostora v ciljnem nizu.
            assert(::GetLastError() == ERROR_INSUFFICIENT_BUFFER);
            return znakov_cilj;
        }
    } else {
        // e je izvorni niz prazen, ne delamo niesar.
        return 0;
    }
}


inline T_UINT astrncpy2(T_UNICODE cilj, T_UINT znakov_cilj, TK_ASCII izvor, T_UINT znakov_izvor, T_KODNASTRAN kodna_stran)
{
    assert(cilj  || !znakov_cilj);
    assert(izvor || !znakov_izvor);

    if (izvor && znakov_izvor && znakov_cilj) {
        register DWORD zastavice = kodna_stran < KODNASTRAN_UTF7 ? MB_PRECOMPOSED : 0;
        register int prepisano = ::MultiByteToWideChar(kodna_stran, zastavice, izvor, (int)znakov_izvor, cilj, (int)znakov_cilj);
        if (prepisano) {
            // Funkcija je uspeno pretvorila niz, ne vemo pa, ali je prepisala tudi zakljuni znak, ali ne.
            return astrnlen(cilj, prepisano);
        } else {
            // Zmanjkalo je prostora v ciljnem nizu.
            assert(::GetLastError() == ERROR_INSUFFICIENT_BUFFER);
            return znakov_cilj;
        }
    } else {
        // e je izvorni niz prazen, ne delamo niesar.
        return 0;
    }
}


template <class TIP> inline TIP* astrcat(TIP* cilj, const TIP* izvor)
{
    astrcat2<TIP>(cilj, izvor);
    return cilj;
}


inline T_ASCII astrcat(T_ASCII cilj, TK_UNICODE izvor, T_KODNASTRAN kodna_stran)
{
    astrcat2(cilj, izvor, kodna_stran);
    return cilj;
}


inline T_UNICODE astrcat(T_UNICODE cilj, TK_ASCII izvor, T_KODNASTRAN kodna_stran)
{
    astrcat2(cilj, izvor, kodna_stran);
    return cilj;
}


template <class TIP> inline TIP* astrncat(TIP* cilj, const TIP* izvor, T_UINT znakov)
{
    astrncat2<TIP>(cilj, izvor, znakov);
    return cilj;
}


template <class TIP> inline TIP* astrncat(TIP* cilj, T_UINT znakov_cilj, const TIP* izvor, T_UINT znakov_izvor)
{
    astrncat2<TIP>(cilj, znakov_cilj, izvor, znakov_izvor);
    return cilj;
}


inline T_ASCII astrncat(T_ASCII cilj, T_UINT znakov_cilj, TK_UNICODE izvor, T_UINT znakov_izvor, T_KODNASTRAN kodna_stran)
{
    astrncat2(cilj, znakov_cilj, izvor, znakov_izvor, kodna_stran);
    return cilj;
}


inline T_UNICODE astrncat(T_UNICODE cilj, T_UINT znakov_cilj, TK_ASCII izvor, T_UINT znakov_izvor, T_KODNASTRAN kodna_stran)
{
    astrncat2(cilj, znakov_cilj, izvor, znakov_izvor, kodna_stran);
    return cilj;
}


template <class TIP> inline T_UINT astrcat2(TIP* cilj, const TIP* izvor)
{
    assert(cilj && izvor);

    register T_UINT i;

    for (i = 0; cilj[i]; i++);
    return astrcpy2(cilj + i, izvor);
}


inline T_UINT astrcat2(T_ASCII cilj, TK_UNICODE izvor, T_KODNASTRAN kodna_stran)
{
    assert(cilj && izvor);

    register T_UINT i;

    for (i=0; cilj[i]; i++);
    return astrcpy2(cilj + i, izvor, kodna_stran);
}


inline T_UINT astrcat2(T_UNICODE cilj, TK_ASCII izvor, T_KODNASTRAN kodna_stran)
{
    assert(cilj && izvor);

    register T_UINT i;

    for (i=0; cilj[i]; i++);
    return astrcpy2(cilj + i, izvor, kodna_stran);
}


template <class TIP> inline T_UINT astrncat2(TIP* cilj, const TIP* izvor, T_UINT znakov)
{
    assert(cilj && izvor || !znakov);

    register T_UINT i;

    for (i = 0; cilj[i]; i++);
    return astrncpy2(cilj + i, izvor, znakov);
}


template <class TIP> inline T_UINT astrncat2(TIP* cilj, T_UINT znakov_cilj, const TIP* izvor, T_UINT znakov_izvor)
{
    assert(cilj || !znakov_cilj);
    assert(izvor || !znakov_izvor);

    register T_UINT i;

    for (i = 0; i < znakov_cilj && cilj[i]; i++);
    return astrncpy2(cilj + i, znakov_cilj - i, izvor, znakov_izvor);
}


inline T_UINT astrncat2(T_ASCII cilj, T_UINT znakov_cilj, TK_UNICODE izvor, T_UINT znakov_izvor, T_KODNASTRAN kodna_stran)
{
    assert(cilj || !znakov_cilj);
    assert(izvor || !znakov_izvor);

    register T_UINT i;

    for (i = 0; i < znakov_cilj && cilj[i]; i++);
    return astrncpy2(cilj + i, znakov_cilj - i, izvor, znakov_izvor, kodna_stran);
}


inline T_UINT astrncat2(T_UNICODE cilj, T_UINT znakov_cilj, TK_ASCII izvor, T_UINT znakov_izvor, T_KODNASTRAN kodna_stran)
{
    assert(cilj || !znakov_cilj);
    assert(izvor || !znakov_izvor);

    register T_UINT i;

    for (i = 0; i < znakov_cilj && cilj[i]; i++);
    return astrncpy2(cilj + i, znakov_cilj - i, izvor, znakov_izvor, kodna_stran);
}


template <class TIP> inline T_UINT astrlen(const TIP* niz)
{
    assert(niz);

    register T_UINT i;
    for (i = 0; niz[i]; i++);
    return i;
}


template <class TIP> inline T_UINT astrnlen(const TIP* niz, T_UINT znakov)
{
    assert(niz || !znakov);

    register T_UINT i;
    for (i = 0; i < znakov && niz[i]; i++);
    return i;
}


inline T_UINT astrnlen(TK_ASCII niz, T_UINT znakov, T_KODNASTRAN kodna_stran)
{
    assert(niz || !znakov);

    register DWORD zastavice = kodna_stran < KODNASTRAN_UTF7 ? MB_PRECOMPOSED : 0;
    return ::MultiByteToWideChar(kodna_stran, zastavice, niz, (int)astrnlen(niz, znakov), NULL, 0);
}


inline T_UINT astrnlen(TK_UNICODE niz, T_UINT znakov, T_KODNASTRAN kodna_stran)
{
    assert(niz || !znakov);

    return ::WideCharToMultiByte(kodna_stran, 0, niz, (int)astrnlen(niz, znakov), NULL, 0, NULL, NULL);
}


inline T_UINT achrlen(TK_ASCII entiteta, T_UINT znakov, T_KODNASTRAN kodna_stran)
{
    assert(znakov && entiteta && entiteta[0]);
    UNREFERENCED_PARAMETER(znakov);

    return ::IsDBCSLeadByteEx(kodna_stran, entiteta[0]) ? 2 : 1;
}


inline T_UINT achrlen(TK_UNICODE entiteta, T_UINT znakov)
{
    assert(znakov && entiteta && entiteta[0]);

    register T_UINT i;
    for (i = 1;
        i < znakov && (
            0x0300 <= entiteta[i] && entiteta[i] < 0x0370 ||
            0x1dc0 <= entiteta[i] && entiteta[i] < 0x1e00 ||
            0x20d0 <= entiteta[i] && entiteta[i] < 0x2100 ||
            0xfe20 <= entiteta[i] && entiteta[i] < 0xfe30
        ); i++);
    return i;
}


inline T_UINT achrrlen(TK_ASCII entiteta, T_UINT znakov, T_KODNASTRAN kodna_stran)
{
    assert(znakov && entiteta && entiteta[znakov - 1]);

    return znakov >= 2 && ::IsDBCSLeadByteEx(kodna_stran, entiteta[znakov - 2]) ? 2 : 1;
}


inline T_UINT achrrlen(TK_UNICODE entiteta, T_UINT znakov)
{
    assert(znakov && entiteta && entiteta[znakov - 1]);

    register T_UINT i;
    for (i = znakov; ;) {
        if (i == 0) return znakov;
        i--;

        if ((entiteta[i] < 0x0300 || 0x0370 <= entiteta[i]) &&
            (entiteta[i] < 0x1dc0 || 0x1e00 <= entiteta[i]) &&
            (entiteta[i] < 0x20d0 || 0x2100 <= entiteta[i]) &&
            (entiteta[i] < 0xfe20 || 0xfe30 <= entiteta[i]))
        {
            return znakov - i;
        }

        assert(0); // TODO: Preizkusi ta del kode.
    }
}


template <class TIP1, class TIP2> inline T_INT astrcmp(const TIP1 *niz1, const TIP2 *niz2)
{
    assert(niz1 && niz2);

    register T_UINT i;
    register TIP1 a;
    register TIP2 b;

    for (i = 0; (a = niz1[i]) | (b = niz2[i]); i++) {
        if (a > b) return         i + 1; // Vrnemo tudi odmik, na kateremu mestu se niza razlikujeta.
        if (a < b) return -(T_INT)i - 1;
    }

    return 0;
}


template <class TIP1, class TIP2> inline T_INT astrncmp(const TIP1 *niz1, const TIP2 *niz2, T_UINT znakov)
{
    assert(niz1 && niz2 || !znakov);

    register T_UINT i;
    register TIP1 a;
    register TIP2 b;

    for (i = 0; i < znakov && ((a = niz1[i]) | (b = niz2[i])); i++) {
        if (a > b) return         i + 1; // Vrnemo tudi odmik, na kateremu mestu se niza razlikujeta.
        if (a < b) return -(T_INT)i - 1;
    }

    return 0;
}


template <class TIP1, class TIP2> inline T_INT astrncmp(const TIP1 *niz1, T_UINT znakov1, const TIP2 *niz2, T_UINT znakov2)
{
    assert(niz1 || !znakov1);
    assert(niz2 || !znakov2);

    register T_UINT i;
    register TIP1 a;
    register TIP2 b;

    for (i = 0; i < znakov1 && i < znakov2 && ((a = niz1[i]) | (b = niz2[i])); i++) {
        if (a > b) return         i + 1; // Vrnemo tudi odmik, na kateremu mestu se niza razlikujeta.
        if (a < b) return -(T_INT)i - 1;
    }

    // Primerjamo e ostanek nizov.
         if (i < znakov1 && niz1[i]) return         i + 1;
    else if (i < znakov2 && niz2[i]) return -(T_INT)i - 1;
    else return 0;
}


template <class TIP1, class TIP2> inline T_INT astricmp(const TIP1 *niz1, const TIP2 *niz2)
{
    assert(niz1 && niz2);

    register T_UINT i;
    register TIP1 a;
    register TIP2 b;

    for (i = 0; (a = atolower(niz1[i])) | (b = atolower(niz2[i])); i++) {
        if (a > b) return         i + 1; // Vrnemo tudi odmik, na kateremu mestu se niza razlikujeta.
        if (a < b) return -(T_INT)i - 1;
    }

    return 0;
}


template <class TIP1, class TIP2> inline T_INT astrnicmp(const TIP1 *niz1, const TIP2 *niz2, T_UINT znakov)
{
    assert(niz1 && niz2 || !znakov);

    register T_UINT i;
    register TIP1 a;
    register TIP2 b;

    for (i = 0; i < znakov && ((a = atolower(niz1[i])) | (b = atolower(niz2[i]))); i++) {
        if (a > b) return         i + 1; // Vrnemo tudi odmik, na kateremu mestu se niza razlikujeta.
        if (a < b) return -(T_INT)i - 1;
    }

    return 0;
}


template <class TIP1, class TIP2> inline T_INT astrnicmp(const TIP1 *niz1, T_UINT znakov1, const TIP2 *niz2, T_UINT znakov2)
{
    assert(niz1 || !znakov1);
    assert(niz2 || !znakov2);

    register T_UINT i;
    register TIP1 a;
    register TIP2 b;

    for (i = 0; i < znakov1 && i < znakov2 && ((a = atolower(niz1[i])) | (b = atolower(niz2[i]))); i++) {
        if (a > b) return         i + 1; // Vrnemo tudi odmik, na kateremu mestu se niza razlikujeta.
        if (a < b) return -(T_INT)i - 1;
    }

    // Primerjamo e ostanek nizov.
         if (i < znakov1 && niz1[i]) return         i + 1;
    else if (i < znakov2 && niz2[i]) return -(T_INT)i - 1;
    else return 0;
}


template <class TIP1, class TIP2> inline T_INT astrrcmp(const TIP1 *niz1, const TIP2 *niz2)
{
    assert(niz1 && niz2);

    register T_UINT
        i = astrlen(niz1),
        j = astrlen(niz2),
        k;
    register TIP1 a;
    register TIP2 b;

    for (k = 1; i && j; k++) {
        i--; j--;

        if ((a = niz1[i]) > (b = niz2[j]))
            return k;
        else if (a < b)
            return -(T_INT)k;
    }

    if (i && !j)
        return k;
    else if (!i && j)
        return -(T_INT)k;
    else
        return 0;
}


template <class TIP1, class TIP2> inline T_INT astrrncmp(const TIP1 *niz1, const TIP2 *niz2, T_UINT znakov)
{
    assert(niz1 && niz2 || !znakov);

    register T_UINT
        i = astrnlen(niz1, znakov),
        j = astrnlen(niz2, znakov),
        k;
    register TIP1 a;
    register TIP2 b;

    for (k = 1; i && j; k++) {
        i--; j--;

        if ((a = niz1[i]) > (b = niz2[j]))
            return k;
        else if (a < b)
            return -(T_INT)k;
    }

    if (i && !j)
        return k;
    else if (!i && j)
        return -(T_INT)k;
    else
        return 0;
}


template <class TIP1, class TIP2> inline T_INT astrrncmp(const TIP1 *niz1, T_UINT znakov1, const TIP2 *niz2, T_UINT znakov2)
{
    assert(niz1 || !znakov1);
    assert(niz2 || !znakov2);

    register T_UINT
        i = astrnlen(niz1, znakov1),
        j = astrnlen(niz2, znakov2),
        k;
    register TIP1 a;
    register TIP2 b;

    for (k = 1; i && j; k++) {
        i--; j--;

        if ((a = niz1[i]) > (b = niz2[j]))
            return k;
        else if (a < b)
            return -(T_INT)k;
    }

    if (i && !j)
        return k;
    else if (!i && j)
        return -(T_INT)k;
    else
        return 0;
}


template <class TIP1, class TIP2> inline T_INT astrricmp(const TIP1 *niz1, const TIP2 *niz2)
{
    assert(niz1 && niz2);

    register T_UINT
        i = astrlen(niz1),
        j = astrlen(niz2),
        k;
    register TIP1 a;
    register TIP2 b;

    for (k = 1; i && j; k++) {
        i--; j--;

        if ((a = atolower(niz1[i])) > (b = atolower(niz2[j])))
            return k;
        else if (a < b)
            return -(T_INT)k;
    }

    if (i && !j)
        return k;
    else if (!i && j)
        return -(T_INT)k;
    else
        return 0;
}


template <class TIP1, class TIP2> inline T_INT astrrnicmp(const TIP1 *niz1, const TIP2 *niz2, T_UINT znakov)
{
    assert(niz1 && niz2 || !znakov);

    register T_UINT
        i = astrnlen(niz1, znakov),
        j = astrnlen(niz2, znakov),
        k;
    register TIP1 a;
    register TIP2 b;

    for (k = 1; i && j; k++) {
        i--; j--;

        if ((a = atolower(niz1[i])) > (b = atolower(niz2[j])))
            return k;
        else if (a < b)
            return -(T_INT)k;
    }

    if (i && !j)
        return k;
    else if (!i && j)
        return -(T_INT)k;
    else
        return 0;
}


template <class TIP1, class TIP2> inline T_INT astrrnicmp(const TIP1 *niz1, T_UINT znakov1, const TIP2 *niz2, T_UINT znakov2)
{
    assert(niz1 || !znakov1);
    assert(niz2 || !znakov2);

    register T_UINT
        i = astrnlen(niz1, znakov1),
        j = astrnlen(niz2, znakov2),
        k;
    register TIP1 a;
    register TIP2 b;

    for (k = 1; i && j; k++) {
        i--; j--;

        if ((a = atolower(niz1[i])) > (b = atolower(niz2[j])))
            return k;
        else if (a < b)
            return -(T_INT)k;
    }

    if (i && !j)
        return k;
    else if (!i && j)
        return -(T_INT)k;
    else
        return 0;
}


template <class TIP1, class TIP2> inline T_INT astrercmp(const TIP1 *niz1, const TIP2 *niz2)
{
    assert(niz1 && niz2);

    register T_UINT
        i = astrlen(niz1),
        j = astrlen(niz2),
        k;
    register TIP1 a;
    register TIP2 b;

    for (k = 1; i && j; k++) {
        i--; j--;

        if ((a = niz1[i]) > (b = niz2[j]))
            return k;
        else if (a < b)
            return -(T_INT)k;
    }

    return 0;
}


template <class TIP1, class TIP2> inline T_INT astrericmp(const TIP1 *niz1, const TIP2 *niz2)
{
    assert(niz1 && niz2);

    register T_UINT
        i = astrlen(niz1),
        j = astrlen(niz2),
        k;
    register TIP1 a;
    register TIP2 b;

    for (k = 1; i && j; k++) {
        i--; j--;

        if ((a = atolower(niz1[i])) > (b = atolower(niz2[j])))
            return k;
        else if (a < b)
            return -(T_INT)k;
    }

    return 0;
}


template <class TIP> inline T_INT astrcoll(const TIP* niz1, const TIP* niz2, T_KODALOCALE locale)
{
    UNREFERENCED_PARAMETER(locale);
    return astrcmp<TIP, TIP>(niz1, niz2);
}


template <> inline T_INT astrcoll(TK_ASCII niz1, TK_ASCII niz2, T_KODALOCALE locale)
{
    assert(niz1 && niz2);

    register int rezultat;

    rezultat = ::CompareStringA(locale, 0, niz1, -1, niz2, -1);
    assert(rezultat);
    return rezultat ? rezultat - CSTR_EQUAL : astrcmp(niz1, niz2); // e je prilo do napake pri primerjavi, se zateemo k binarni primerjavi.
}


template <> inline T_INT astrcoll(TK_UNICODE niz1, TK_UNICODE niz2, T_KODALOCALE locale)
{
    assert(niz1 && niz2);

    register int rezultat;

    rezultat = ::CompareStringW(locale, 0, niz1, -1, niz2, -1);
    assert(rezultat);
    return rezultat ? rezultat - CSTR_EQUAL : astrcmp(niz1, niz2); // e je prilo do napake pri primerjavi, se zateemo k binarni primerjavi.
}


template <class TIP> inline T_INT astricoll(const TIP* niz1, const TIP* niz2, T_KODALOCALE locale)
{
    UNREFERENCED_PARAMETER(locale);
    return astricmp<TIP, TIP>(niz1, niz2);
}


template <> inline T_INT astricoll(TK_ASCII niz1, TK_ASCII niz2, T_KODALOCALE locale)
{
    assert(niz1 && niz2);

    register int rezultat;

    rezultat = ::CompareStringA(locale, NORM_IGNORECASE, niz1, -1, niz2, -1);
    assert(rezultat);
    return rezultat ? rezultat - CSTR_EQUAL : astricmp(niz1, niz2); // e je prilo do napake pri primerjavi, se zateemo k binarni primerjavi.
}


template <> inline T_INT astricoll(TK_UNICODE niz1, TK_UNICODE niz2, T_KODALOCALE locale)
{
    assert(niz1 && niz2);

    register int rezultat;

    rezultat = ::CompareStringW(locale, NORM_IGNORECASE, niz1, -1, niz2, -1);
    assert(rezultat);
    return rezultat ? rezultat - CSTR_EQUAL : astricmp(niz1, niz2); // e je prilo do napake pri primerjavi, se zateemo k binarni primerjavi.
}


template <class TIP> inline T_INT astrncoll(const TIP* niz1, const TIP* niz2, T_UINT znakov, T_KODALOCALE locale)
{
    UNREFERENCED_PARAMETER(locale);
    return astrncmp<TIP, TIP>(niz1, niz2, znakov);
}


template <> inline T_INT astrncoll(TK_ASCII niz1, TK_ASCII niz2, T_UINT znakov, T_KODALOCALE locale)
{
    assert(niz1 && niz2 || !znakov);

    register int rezultat;

    if (!znakov) return 0;

    // Funkciji CompareString() moramo navesti -1 ali pa povsem tono dolino nizov. Sicer se primerjava ne ustavi na zakljunem znaku.
    rezultat = ::CompareStringA(locale, 0, niz1, (int)astrnlen(niz1, znakov), niz2, (int)astrnlen(niz1, znakov));
    assert(rezultat);
    return rezultat ? rezultat - CSTR_EQUAL : astrncmp(niz1, niz2, znakov); // e je prilo do napake pri primerjavi, se zateemo k binarni primerjavi.
}


template <> inline T_INT astrncoll(TK_UNICODE niz1, TK_UNICODE niz2, T_UINT znakov, T_KODALOCALE locale)
{
    assert(niz1 && niz2 || !znakov);

    register int rezultat;

    if (!znakov) return 0;

    // Funkciji CompareString() moramo navesti -1 ali pa povsem tono dolino nizov. Sicer se primerjava ne ustavi na zakljunem znaku.
    rezultat = ::CompareStringW(locale, 0, niz1, (int)astrnlen(niz1, znakov), niz2, (int)astrnlen(niz1, znakov));
    assert(rezultat);
    return rezultat ? rezultat - CSTR_EQUAL : astrncmp(niz1, niz2, znakov); // e je prilo do napake pri primerjavi, se zateemo k binarni primerjavi.
}


template <class TIP> inline T_INT astrncoll(const TIP* niz1, T_UINT znakov1, const TIP* niz2, T_UINT znakov2, T_KODALOCALE locale)
{
    UNREFERENCED_PARAMETER(locale);
    return astrncmp<TIP, TIP>(niz1, znakov1, niz2, znakov2);
}


template <> inline T_INT astrncoll(TK_ASCII niz1, T_UINT znakov1, TK_ASCII niz2, T_UINT znakov2, T_KODALOCALE locale)
{
    assert(niz1 || !znakov1);
    assert(niz2 || !znakov2);

    register int rezultat;

    if (!znakov1 && !znakov2) return 0;

    // Funkciji CompareString() moramo navesti -1 ali pa povsem tono dolino nizov. Sicer se primerjava ne ustavi na zakljunem znaku.
    rezultat = ::CompareStringA(locale, 0, niz1, (int)astrnlen(niz1, znakov1), niz2, (int)astrnlen(niz2, znakov2));
    assert(rezultat);
    return rezultat ? rezultat - CSTR_EQUAL : astrncmp(niz1, znakov1, niz2, znakov2); // e je prilo do napake pri primerjavi, se zateemo k binarni primerjavi.
}


template <> inline T_INT astrncoll(TK_UNICODE niz1, T_UINT znakov1, TK_UNICODE niz2, T_UINT znakov2, T_KODALOCALE locale)
{
    assert(niz1 || !znakov1);
    assert(niz2 || !znakov2);

    register int rezultat;

    if (!znakov1 && !znakov2) return 0;

    // Funkciji CompareString() moramo navesti -1 ali pa povsem tono dolino nizov. Sicer se primerjava ne ustavi na zakljunem znaku.
    rezultat = ::CompareStringW(locale, 0, niz1, (int)astrnlen(niz1, znakov1), niz2, (int)astrnlen(niz2, znakov2));
    assert(rezultat);
    return rezultat ? rezultat - CSTR_EQUAL : astrncmp(niz1, znakov1, niz2, znakov2); // e je prilo do napake pri primerjavi, se zateemo k binarni primerjavi.
}


template <class TIP> inline T_INT astrnicoll(const TIP* niz1, const TIP* niz2, T_UINT znakov, T_KODALOCALE locale)
{
    UNREFERENCED_PARAMETER(locale);
    return astrnicmp<TIP, TIP>(niz1, niz2, znakov);
}


template <> inline T_INT astrnicoll(TK_ASCII niz1, TK_ASCII niz2, T_UINT znakov, T_KODALOCALE locale)
{
    assert(niz1 && niz2 || !znakov);

    register int rezultat;

    if (!znakov) return 0;

    // Funkciji CompareString() moramo navesti -1 ali pa povsem tono dolino nizov. Sicer se primerjava ne ustavi na zakljunem znaku.
    rezultat = ::CompareStringA(locale, NORM_IGNORECASE, niz1, (int)astrnlen(niz1, znakov), niz2, (int)astrnlen(niz1, znakov));
    assert(rezultat);
    return rezultat ? rezultat - CSTR_EQUAL : astrnicmp(niz1, niz2, znakov); // e je prilo do napake pri primerjavi, se zateemo k binarni primerjavi.
}


template <> inline T_INT astrnicoll(TK_UNICODE niz1, TK_UNICODE niz2, T_UINT znakov, T_KODALOCALE locale)
{
    assert(niz1 && niz2 || !znakov);

    register int rezultat;

    if (!znakov) return 0;

    // Funkciji CompareString() moramo navesti -1 ali pa povsem tono dolino nizov. Sicer se primerjava ne ustavi na zakljunem znaku.
    rezultat = ::CompareStringW(locale, NORM_IGNORECASE, niz1, (int)astrnlen(niz1, znakov), niz2, (int)astrnlen(niz1, znakov));
    assert(rezultat);
    return rezultat ? rezultat - CSTR_EQUAL : astrnicmp(niz1, niz2, znakov); // e je prilo do napake pri primerjavi, se zateemo k binarni primerjavi.
}


template <class TIP> inline T_INT astrnicoll(const TIP* niz1, T_UINT znakov1, const TIP* niz2, T_UINT znakov2, T_KODALOCALE locale)
{
    UNREFERENCED_PARAMETER(locale);
    return astrnicmp<TIP, TIP>(niz1, znakov1, niz2, znakov2);
}


template <> inline T_INT astrnicoll(TK_ASCII niz1, T_UINT znakov1, TK_ASCII niz2, T_UINT znakov2, T_KODALOCALE locale)
{
    assert(niz1 || !znakov1);
    assert(niz2 || !znakov2);

    register int rezultat;

    if (!znakov1 && !znakov2) return 0;

    // Funkciji CompareString() moramo navesti -1 ali pa povsem tono dolino nizov. Sicer se primerjava ne ustavi na zakljunem znaku.
    rezultat = ::CompareStringA(locale, NORM_IGNORECASE, niz1, (int)astrnlen(niz1, znakov1), niz2, (int)astrnlen(niz2, znakov2));
    assert(rezultat);
    return rezultat ? rezultat - CSTR_EQUAL : astrnicmp(niz1, znakov1, niz2, znakov2); // e je prilo do napake pri primerjavi, se zateemo k binarni primerjavi.
}


template <> inline T_INT astrnicoll(TK_UNICODE niz1, T_UINT znakov1, TK_UNICODE niz2, T_UINT znakov2, T_KODALOCALE locale)
{
    assert(niz1 || !znakov1);
    assert(niz2 || !znakov2);

    register int rezultat;

    if (!znakov1 && !znakov2) return 0;

    // Funkciji CompareString() moramo navesti -1 ali pa povsem tono dolino nizov. Sicer se primerjava ne ustavi na zakljunem znaku.
    rezultat = ::CompareStringW(locale, NORM_IGNORECASE, niz1, (int)astrnlen(niz1, znakov1), niz2, (int)astrnlen(niz2, znakov2));
    assert(rezultat);
    return rezultat ? rezultat - CSTR_EQUAL : astrnicmp(niz1, znakov1, niz2, znakov2); // e je prilo do napake pri primerjavi, se zateemo k binarni primerjavi.
}


template <class TIP> inline TIP* astrchr(const TIP* niz, TIP znak)
{
    assert(niz);

    register T_UINT i;

    for (i = 0; niz[i]; i++)
        if (niz[i] == znak) return (TIP*)niz + i;

    return NULL;
}


template <class TIP> inline TIP* astrnchr(const TIP* niz, TIP znak, T_UINT znakov)
{
    assert(niz || !znakov);

    register T_UINT i;

    for (i = 0; i < znakov && niz[i]; i++)
        if (niz[i] == znak) return (TIP*)niz + i;

    return NULL;
}


template <class TIP> inline TIP* astrichr(const TIP* niz, TIP znak)
{
    assert(niz);

    register T_UINT i;
    register TIP _znak = atolower(znak);

    for (i = 0; niz[i]; i++)
        if (atolower(niz[i]) == _znak) return (TIP*)niz + i;

    return NULL;
}


template <class TIP> inline TIP* astrnichr(const TIP* niz, TIP znak, T_UINT znakov)
{
    assert(niz || !znakov);

    register T_UINT i;
    register TIP _znak = atolower(znak);

    for (i = 0; i < znakov && niz[i]; i++)
        if (atolower(niz[i]) == _znak) return (TIP*)niz + i;

    return NULL;
}


template <class TIP> inline TIP* astrrchr(const TIP* niz, TIP znak)
{
    assert(niz);

    register T_UINT i;
    register TIP* z = NULL;

    for (i = 0; niz[i]; i++)
        if (niz[i] == znak) z = (TIP*)niz + i;

    return z;
}


template <class TIP> inline TIP* astrrnchr(const TIP* niz, TIP znak, T_UINT znakov)
{
    assert(niz || !znakov);

    register T_UINT i;
    register TIP* z = NULL;

    for (i = 0; i < znakov && niz[i]; i++)
        if (niz[i] == znak) z = (TIP*)niz + i;

    return z;
}


template <class TIP> inline TIP* astrrichr(const TIP* niz, TIP znak)
{
    assert(niz);

    register T_UINT i;
    register TIP* z = NULL;
    register TIP _znak = atolower(znak);

    for (i = 0; niz[i]; i++)
        if (atolower(niz[i]) == _znak) z = (TIP*)niz + i;

    return z;
}


template <class TIP> inline TIP* astrrnichr(const TIP* niz, TIP znak, T_UINT znakov)
{
    assert(niz || !znakov);

    register T_UINT i;
    register TIP* z = NULL;
    register TIP _znak = atolower(znak);

    for (i = 0; i < znakov && niz[i]; i++)
        if (atolower(niz[i]) == _znak) z = (TIP*)niz + i;

    return z;
}


template <class TIP> inline T_UINT astrnchr2(const TIP* niz, T_UINT znakov, TIP znak)
{
    assert(niz || !znakov);

    register T_UINT i;

    for (i = 0; i < znakov && niz[i]; i++)
        if (niz[i] == znak) return i;

    return T_UINT_MAX;
}


template <class TIP> inline T_UINT astrnichr2(const TIP* niz, T_UINT znakov, TIP znak)
{
    assert(niz || !znakov);

    register T_UINT i;
    register TIP _znak = atolower(znak);

    for (i = 0; i < znakov && niz[i]; i++)
        if (atolower(niz[i]) == _znak) return i;

    return T_UINT_MAX;
}


template <class TIP> inline T_UINT astrrnchr2(const TIP* niz, T_UINT znakov, TIP znak)
{
    assert(niz || !znakov);

    register T_UINT i;
    register T_UINT z = T_UINT_MAX;

    for (i = 0; i < znakov && niz[i]; i++)
        if (niz[i] == znak) z = i;

    return z;
}


template <class TIP> inline T_UINT astrrnichr2(const TIP* niz, T_UINT znakov, TIP znak)
{
    assert(niz || !znakov);

    register T_UINT i;
    register T_UINT z = T_UINT_MAX;
    register TIP _znak = atolower(znak);

    for (i = 0; i < znakov && niz[i]; i++)
        if (atolower(niz[i]) == _znak) z = i;

    return z;
}


template <class TIP> inline T_UINT astrcountchr(const TIP* niz, TIP znak)
{
    assert(niz);
    register T_UINT i, n;

    for (i = n = 0; niz[i]; i++)
        if (niz[i] == znak)
            n++;

    return n;
}


template <class TIP> inline T_UINT astrncountchr(const TIP* niz, TIP znak, T_UINT znakov)
{
    assert(niz || !znakov);
    register T_UINT i, n;

    for (i = n = 0; i < znakov && niz[i]; i++)
        if (niz[i] == znak)
            n++;

    return n;
}


template <class TIP> inline T_UINT astricountchr(const TIP* niz, TIP znak)
{
    assert(niz);
    register T_UINT i, n;
    register TIP _znak = atolower(znak);

    for (i = n = 0; niz[i]; i++)
        if (atolower(niz[i]) == _znak)
            n++;

    return n;
}



template <class TIP> inline T_UINT astrnicountchr(const TIP* niz, TIP znak, T_UINT znakov)
{
    assert(niz || !znakov);
    register T_UINT i, n;
    register TIP _znak = atolower(znak);

    for (i = n = 0; i < znakov && niz[i]; i++)
        if (atolower(niz[i]) == _znak)
            n++;

    return n;
}


template <class TIP> inline TIP* astrstr(const TIP* niz, const TIP* vzorec)
{
    assert(0); // TODO: Preizkusi ta del kode.
    assert(niz && vzorec);

    register TIP* n, *m, *o;

    for (n = (TIP*)niz; *n; n += achrlen(n, T_UINT_MAX)) {
        // Poemo, do kam se niza ujemata.
        for (m = n, o = (TIP*)vzorec; *o && *m==*o; m++, o++);

        // Ali smo dobili popolno ujemanje?
        if (!*o && achrlen(m - 1, T_UINT_MAX) == 1)
            return n;
    }

    return NULL;
}


template <class TIP> inline TIP* astrnstr(const TIP* niz, const TIP* vzorec, T_UINT znakov)
{
    assert(niz || !znakov);
    assert(vzorec);

    register T_UINT i, j, k;

    for (i = 0; i < znakov && niz[i]; i += achrlen(niz + i, znakov - i)) {
        // Poemo, do kam se niza ujemata.
        for (j = i, k = 0; vzorec[k] && j < znakov && niz[j] == vzorec[k]; j++, k++);

        // Ali smo dobili popolno ujemanje?
        if (!vzorec[k] && achrlen(niz + j - 1, znakov - (j - 1)) == 1)
            return (TIP*)niz + i;
    }

    return NULL;
}


template <class TIP> inline TIP* astristr(const TIP* niz, const TIP* vzorec)
{
    assert(0); // TODO: Preizkusi ta del kode.
    assert(niz && vzorec);

    register TIP* n, *m, *o;

    for (n = (TIP*)niz; *n; n += achrlen(n, T_UINT_MAX)) {
        // Poemo, do kam se niza ujemata.
        for (m = n, o = (TIP*)vzorec; *o && atolower(*m) == atolower(*o); m++, o++);

        // Ali smo dobili popolno ujemanje?
        if (!*o && achrlen(m - 1, T_UINT_MAX) == 1)
            return n;
    }

    return NULL;
}


template <class TIP> inline TIP* astrnistr(const TIP* niz, const TIP* vzorec, T_UINT znakov)
{
    assert(0); // TODO: Preizkusi ta del kode.
    assert(niz || !znakov);
    assert(vzorec);

    register T_UINT i, j, k;

    for (i = 0; i < znakov && niz[i]; i += achrlen(niz + i, znakov - i)) {
        // Poemo, do kam se niza ujemata.
        for (j = i, k = 0; vzorec[k] && j < znakov && atolower(niz[j]) == atolower(vzorec[k]); j++, k++);

        // Ali smo dobili popolno ujemanje?
        if (!vzorec[k] && achrlen(niz + j - 1, znakov - (j - 1)) == 1)
            return (TIP*)niz + i;
    }

    return NULL;
}


template <class TIP> inline TIP* astrrstr(const TIP* niz, const TIP* vzorec)
{
    assert(0); // TODO: Preizkusi ta del kode.
    assert(niz && vzorec);

    register TIP* n, *m, *o, *z;

    for (n = (TIP*)niz, z = NULL; *n; n += achrlen(n, T_UINT_MAX)) {
        // Poemo, do kam se niza ujemata.
        for (m = n, o = (TIP*)vzorec; *o && *m==*o; m++, o++);

        // Ali smo dobili popolno ujemanje?
        if (!*o && achrlen(m - 1, T_UINT_MAX) == 1)
            z = n;
    }

    return z;
}


template <class TIP> inline TIP* astrrnstr(const TIP* niz, const TIP* vzorec, T_UINT znakov)
{
    assert(0); // TODO: Preizkusi ta del kode.
    assert(niz && vzorec);

    register T_UINT i, j, k;
    register TIP *z;

    for (i = 0, z = NULL; i < znakov && niz[i]; i += achrlen(niz + i, znakov - i)) {
        // Poemo, do kam se niza ujemata.
        for (j = i, k = 0; vzorec[k] && j < znakov && niz[j] == vzorec[k]; j++, k++);

        // Ali smo dobili popolno ujemanje?
        if (!vzorec[k] && achrlen(niz + j - 1, znakov - (j - 1)) == 1)
            z = (TIP*)niz + i;
    }

    return z;
}


template <class TIP> inline TIP* astrristr(const TIP* niz, const TIP* vzorec)
{
    assert(0); // TODO: Preizkusi ta del kode.
    assert(niz && vzorec);

    register TIP* n, *m, *o, *z;

    for (n = (TIP*)niz, z = NULL; *n; n += achrlen(n, T_UINT_MAX)) {
        // Poemo, do kam se niza ujemata.
        for (m = n, o = (TIP*)vzorec; *o && atolower(*m) == atolower(*o); m++, o++);

        // Ali smo dobili popolno ujemanje?
        if (!*o && achrlen(m - 1, T_UINT_MAX) == 1)
            z = n;
    }

    return z;
}


template <class TIP> inline TIP* astrrnistr(const TIP* niz, const TIP* vzorec, T_UINT znakov)
{
    assert(0); // TODO: Preizkusi ta del kode.
    assert(niz && vzorec);

    register T_UINT i, j, k;
    register TIP *z;

    for (i = 0, z = NULL; i<znakov && niz[i]; i += achrlen(niz + i, znakov - i)) {
        // Poemo, do kam se niza ujemata.
        for (j = i, k = 0; vzorec[k] && j < znakov && atolower(niz[j]) == atolower(vzorec[k]); j++, k++);

        // Ali smo dobili popolno ujemanje?
        if (!vzorec[k] && achrlen(niz + j - 1, znakov - (j - 1)) == 1)
            z = (TIP*)niz + i;
    }

    return z;
}


template <class TIP> inline T_UINT astrspn(const TIP* niz, const TIP* nabor)
{
    assert(niz && nabor);

    register T_UINT i, j;
    register T_BOOL najden;

    for (i = 0; niz[i]; i++) {
        najden = FALSE;
        for (j = 0; nabor[j]; j++) {
            if (niz[i] == nabor[j]) {
                najden = TRUE;
                break;
            }
        }

        // ce nismo nasli znaka, koncamo
        if (!najden) return i;
    }

    return i;
}


template <class TIP> inline T_UINT astrnspn(const TIP* niz, const TIP* nabor, T_UINT znakov)
{
    assert((niz || !znakov) && nabor);

    register T_UINT i, j;
    register T_BOOL najden;

    for (i = 0; i < znakov && niz[i]; i++) {
        najden = FALSE;
        for (j = 0; nabor[j]; j++) {
            if (niz[i] == nabor[j]) {
                najden = TRUE;
                break;
            }
        }

        // ce nismo nasli znaka, koncamo
        if (!najden) return i;
    }

    return i;
}


template <class TIP> inline T_UINT astrcspn(const TIP* niz, const TIP* nabor)
{
    assert(niz && nabor);

    register T_UINT i, j;

    for (i = 0; niz[i]; i++) {
        for (j = 0; nabor[j]; j++) {
            if (niz[i] == nabor[j])
                return i;
        }
    }

    return i;
}


template <class TIP> inline T_UINT astrcnspn(const TIP* niz, const TIP* nabor, T_UINT znakov)
{
    assert((niz || !znakov) && nabor);

    register T_UINT i, j;

    for (i = 0; i < znakov && niz[i]; i++) {
        for (j = 0; nabor[j]; j++) {
            if (niz[i] == nabor[j])
                return i;
        }
    }

    return i;
}


template <class TIP> inline TIP atolower(TIP znak)
{
    return znak;
}


template <> inline T_AZNAK atolower(T_AZNAK znak)
{
    return (T_AZNAK)tolower(znak);
}


template <> inline T_UZNAK atolower(T_UZNAK znak)
{
    switch (znak) {
    case 0x01D1: return 0x01D2; // LATIN CAPITAL LETTER O WITH CARON
    default: return towlower(znak);
    }
}


template <class TIP> inline TIP atoupper(TIP znak)
{
    return znak;
}


template <> inline T_AZNAK atoupper(T_AZNAK znak)
{
    return (T_AZNAK)toupper(znak);
}


template <> inline T_UZNAK atoupper(T_UZNAK znak)
{
    switch (znak) {
    case 0x01D2: return 0x01D1; // LATIN SMALL LETTER O WITH CARON
    default: return towupper(znak);
    }
}


template <class TIP> inline TIP* astrupr(TIP* niz)
{
    assert(niz);

    register T_UINT i;
    for (i=0; niz[i]; i++)
        niz[i] = atoupper(niz[i]);

    return niz;
}


template <class TIP> inline TIP* astrnupr(TIP* niz, T_UINT znakov)
{
    assert(niz || !znakov);

    register T_UINT i;
    for (i=0; i<znakov && niz[i]; i++)
        niz[i] = atoupper(niz[i]);

    return niz;
}


template <class TIP> inline TIP* astrlwr(TIP* niz)
{
    assert(niz);

    register T_UINT i;
    for (i=0; niz[i]; i++)
        niz[i] = atolower(niz[i]);

    return niz;
}


template <class TIP> inline TIP* astrnlwr(TIP* niz, T_UINT znakov)
{
    assert(niz || !znakov);

    register T_UINT i;
    for (i=0; i<znakov && niz[i]; i++)
        niz[i] = atolower(niz[i]);

    return niz;
}


template <class TIP> inline T_UINT acrlf2nl(TIP* cilj, const TIP* izvor)
{
    assert(cilj);
    assert(izvor);

    register T_UINT i, j;

    for (i = j = 0; izvor[j];) {
        if (izvor[j] != (TIP)'\r' || izvor[j+1] != (TIP)'\n')
            cilj[i++] = izvor[j++];
        else {
            cilj[i++] = (TIP)'\n';
            j += 2;
        }
    }
    cilj[i] = (TIP)0;

    return i;
}


inline T_BOOL aisalnum(T_AZNAK znak)
{
    return isalnum((unsigned char)znak) ? TRUE: FALSE;
}


inline T_BOOL aisalnum(T_AZNAK znak, T_LOCALE locale)
{
    return
#if _MSC_VER >= 1400
        _isalnum_l((unsigned char)znak, locale)
#else
        isalnum((unsigned char)znak)
#endif
        ? TRUE: FALSE;
}


inline T_BOOL aisalnum(T_UZNAK znak)
{
    return iswalnum(znak) ? TRUE : FALSE;
}


inline T_BOOL aisalpha(T_AZNAK znak)
{
    return isalpha((unsigned char)znak) ? TRUE: FALSE;
}


inline T_BOOL aisalpha(T_AZNAK znak, T_LOCALE locale)
{
    return
#if _MSC_VER >= 1400
        _isalpha_l((unsigned char)znak, locale)
#else
        isalpha((unsigned char)znak)
#endif
        ? TRUE: FALSE;
}


inline T_BOOL aisalpha(T_UZNAK znak)
{
    return iswalpha(znak) ? TRUE: FALSE;
}


inline T_BOOL aiscntrl(T_AZNAK znak)
{
    return iscntrl((unsigned char)znak) ? TRUE: FALSE;
}


inline T_BOOL aiscntrl(T_AZNAK znak, T_LOCALE locale)
{
    return
#if _MSC_VER >= 1400
        _iscntrl_l((unsigned char)znak, locale)
#else
        iscntrl((unsigned char)znak)
#endif
        ? TRUE: FALSE;
}


inline T_BOOL aiscntrl(T_UZNAK znak)
{
    return iswcntrl(znak) ? TRUE: FALSE;
}


inline T_BOOL aisdigit(T_AZNAK znak)
{
    return isdigit((unsigned char)znak) ? TRUE: FALSE;
}


inline T_BOOL aisdigit(T_AZNAK znak, T_LOCALE locale)
{
    return
#if _MSC_VER >= 1400
        _isdigit_l((unsigned char)znak, locale)
#else
        isdigit((unsigned char)znak)
#endif
        ? TRUE: FALSE;
}


inline T_BOOL aisdigit(T_UZNAK znak)
{
    return iswdigit(znak) ? TRUE: FALSE;
}


inline T_BOOL aisgraph(T_AZNAK znak)
{
    return isgraph((unsigned char)znak) ? TRUE: FALSE;
}


inline T_BOOL aisgraph(T_AZNAK znak, T_LOCALE locale)
{
    return
#if _MSC_VER >= 1400
        _isgraph_l((unsigned char)znak, locale)
#else
        isgraph((unsigned char)znak)
#endif
        ? TRUE: FALSE;
}


inline T_BOOL aisgraph(T_UZNAK znak)
{
    return iswgraph(znak) ? TRUE: FALSE;
}


inline T_BOOL aislower(T_AZNAK znak)
{
    return islower((unsigned char)znak) ? TRUE: FALSE;
}


inline T_BOOL aislower(T_AZNAK znak, T_LOCALE locale)
{
    return
#if _MSC_VER >= 1400
        _islower_l((unsigned char)znak, locale)
#else
        islower((unsigned char)znak)
#endif
        ? TRUE: FALSE;
}


inline T_BOOL aislower(T_UZNAK znak)
{
    return iswlower(znak) ? TRUE: FALSE;
}


inline T_BOOL aisprint(T_AZNAK znak)
{
    return isprint((unsigned char)znak) ? TRUE: FALSE;
}


inline T_BOOL aisprint(T_AZNAK znak, T_LOCALE locale)
{
    return
#if _MSC_VER >= 1400
        _isprint_l((unsigned char)znak, locale)
#else
        isprint((unsigned char)znak)
#endif
        ? TRUE: FALSE;
}


inline T_BOOL aisprint(T_UZNAK znak)
{
    return iswprint(znak) ? TRUE: FALSE;
}


inline T_BOOL aispunct(T_AZNAK znak)
{
    return ispunct((unsigned char)znak) ? TRUE: FALSE;
}


inline T_BOOL aispunct(T_AZNAK znak, T_LOCALE locale)
{
    return
#if _MSC_VER >= 1400
        _ispunct_l((unsigned char)znak, locale)
#else
        ispunct((unsigned char)znak)
#endif
        ? TRUE: FALSE;
}


inline T_BOOL aispunct(T_UZNAK znak)
{
    return iswpunct(znak) ? TRUE: FALSE;
}


inline T_BOOL aisspace(T_AZNAK znak)
{
    return isspace((unsigned char)znak) ? TRUE: FALSE;
}


inline T_BOOL aisspace(T_AZNAK znak, T_LOCALE locale)
{
    return
#if _MSC_VER >= 1400
        _isspace_l((unsigned char)znak, locale)
#else
        isspace((unsigned char)znak)
#endif
        ? TRUE: FALSE;
}


inline T_BOOL aisspace(T_UZNAK znak)
{
    return iswspace(znak) ? TRUE: FALSE;
}


inline T_BOOL aisupper(T_AZNAK znak)
{
    return isupper((unsigned char)znak) ? TRUE: FALSE;
}


inline T_BOOL aisupper(T_AZNAK znak, T_LOCALE locale)
{
    return
#if _MSC_VER >= 1400
        _isupper_l((unsigned char)znak, locale)
#else
        isupper((unsigned char)znak)
#endif
        ? TRUE: FALSE;
}


inline T_BOOL aisupper(T_UZNAK znak)
{
    return iswupper(znak) ? TRUE: FALSE;
}


inline T_BOOL aisxdigit(T_AZNAK znak)
{
    return isxdigit((unsigned char)znak) ? TRUE: FALSE;
}


inline T_BOOL aisxdigit(T_AZNAK znak, T_LOCALE locale)
{
    return
#if _MSC_VER >= 1400
        _isxdigit_l((unsigned char)znak, locale)
#else
        isxdigit((unsigned char)znak)
#endif
        ? TRUE: FALSE;
}


inline T_BOOL aisxdigit(T_UZNAK znak)
{
    return iswxdigit(znak) ? TRUE: FALSE;
}


inline T_BOOL aisrdigit(T_AZNAK znak)
{
    switch (znak) {
        case 'I':
        case 'i':
        case 'V':
        case 'v':
        case 'X':
        case 'x':
        case 'L':
        case 'l':
        case 'C':
        case 'c':
        case 'D':
        case 'd':
        case 'M':
        case 'm':   return TRUE;
        default:    return FALSE;
    }
}


inline T_BOOL aisrdigit(T_UZNAK znak)
{
    switch (znak) {
        case L'I':
        case L'i':
        case L'V':
        case L'v':
        case L'X':
        case L'x':
        case L'L':
        case L'l':
        case L'C':
        case L'c':
        case L'D':
        case L'd':
        case L'M':
        case L'm':  return TRUE;
        default:    return FALSE;
    }
}


inline T_BOOL aislbreak(T_AZNAK znak)
{
    switch (znak) {
        case '\n':
        case '\x0c': return TRUE;
        default:     return FALSE;
    }
}


inline T_BOOL aislbreak(T_UZNAK znak)
{
    switch (znak) {
        case L'\n':
        case L'\x0c': return TRUE;
        default:      return FALSE;
    }
}


template <class TIP> inline T_BOOL ais7bit(TIP* niz)
{
    assert(niz);

    register T_UINT i;

    for (i = 0; niz[i]; i++)
        if ((T_UINT)(niz[i]) > 0x7f)
            return FALSE;

    return TRUE;
}


template <class TIP> inline T_BOOL ais7bit(TIP* niz, T_UINT znakov)
{
    assert(niz || !znakov);

    register T_UINT i;

    for (i = 0; i < znakov && niz[i]; i++)
        if ((T_UINT)(niz[i]) > 0x7f)
            return FALSE;

    return TRUE;
}


template <class TIP> inline T_BOOL aisspace(TIP* niz, T_UINT znakov)
{
    assert(niz || !znakov);

    register T_UINT i;

    for (i = 0; i < znakov && niz[i]; i++)
        if (!aisspace(niz[i]))
            return FALSE;

    return TRUE;
}


template <class TIP> inline T_UINT altrimspace(TIP* cilj, const TIP* izvor)
{
    assert(cilj);
    assert(izvor);
    assert(0); // TODO: Preizkusi ta del kode.

    register T_UINT i, j;

    // Preskoimo presledke na zaetku besede.
    for (j = 0; izvor[j] && aisspace(izvor[j]); j++);

    // Prepiemo ostanek.
    for (i = 0; izvor[j]; i++, j++)
        cilj[i] = izvor[j];
    cilj[i] = (TIP)0;

    return i;
}


template <class TIP> inline T_UINT artrimspace(TIP* cilj, const TIP* izvor)
{
    assert(cilj);
    assert(izvor);
    assert(0); // TODO: Preizkusi ta del kode.

    register T_UINT i, j;

    // Poiemo konec besede.
    for (j = 0; izvor[j]; j++);

    // Preskoimo presledke na koncu besede.
    for (;;) {
        if (!j || !aisspace(izvor[j-1]))
            break;
        else
            j--;
    }

    // Prepiemo j znakov.
    for (i = 0; i < j; i++)
        cilj[i] = izvor[i];
    cilj[i] = (TIP)0;

    return i;
}


template <class TIP> inline T_UINT atrimspace(TIP* cilj, const TIP* izvor)
{
    assert(cilj);
    assert(izvor);

    register T_UINT i, j, k;

    // Preskoimo presledke na zaetku besede.
    for (j = 0; izvor[j] && aisspace(izvor[j]); j++);

    // Poiemo konec besede.
    for (k = j; izvor[k]; k++);

    // Preskoimo presledke na koncu besede.
    for (;;) {
        if (!k || !aisspace(izvor[k-1]))
            break;
        else
            k--;
    }

    // Prepiemo znake od j do k.
    for (i = 0; j < k;)
        cilj[i++] = izvor[j++];
    cilj[i] = (TIP)0;

    return i;
}


template<class TIP> inline T_BOOL astrtoguid(const TIP* niz, T_UINT znakov, GUID *id)
{
    assert(niz);
    assert(id);

    T_UINT i = 0, j;
    T_U8 n;

    // Preskoimo presledke.
    for (; i < znakov && niz[i] && aisspace(niz[i]); i++);

    // Na zaetku je {.
    if (i >= znakov || niz[i] != (TIP)'{') return FALSE;
    i++;

    // Preskoimo presledke.
    for (; i < znakov && niz[i] && aisspace(niz[i]); i++);

    // Preberemo prvi niz estnajstikih cifer.
    n = astrtou8(niz + i, znakov - i, &j, 16);
    if (n > T_U4_MAX) return FALSE;
    id->Data1 = (unsigned long)n;
    i += j;

    // Preskoimo presledke.
    for (; i < znakov && niz[i] && aisspace(niz[i]); i++);

    // Potem je -.
    if (i >= znakov || niz[i] != (TIP)'-') return FALSE;
    i++;

    // Preskoimo presledke.
    for (; i < znakov && niz[i] && aisspace(niz[i]); i++);

    // Preberemo drugi niz estnajstikih cifer.
    n = astrtou8(niz + i, znakov - i, &j, 16);
    if (n > T_U2_MAX) return FALSE;
    id->Data2 = (unsigned short)n;
    i += j;

    // Preskoimo presledke.
    for (; i < znakov && niz[i] && aisspace(niz[i]); i++);

    // Potem je -.
    if (i >= znakov || niz[i] != (TIP)'-') return FALSE;
    i++;

    // Preskoimo presledke.
    for (; i < znakov && niz[i] && aisspace(niz[i]); i++);

    // Preberemo tretji niz estnajstikih cifer.
    n = astrtou8(niz + i, znakov - i, &j, 16);
    if (n > T_U2_MAX) return FALSE;
    id->Data3 = (unsigned short)n;
    i += j;

    // Preskoimo presledke.
    for (; i < znakov && niz[i] && aisspace(niz[i]); i++);

    // Potem je -.
    if (i >= znakov || niz[i] != (TIP)'-') return FALSE;
    i++;

    // Preskoimo presledke.
    for (; i < znakov && niz[i] && aisspace(niz[i]); i++);

    // Preberemo etrti niz estnajstikih cifer.
    n = astrtou8(niz + i, znakov - i, &j, 16);
    if (n > T_U2_MAX) return FALSE;
    id->Data4[0] = (unsigned char)((n >> 8) & 0xff);
    id->Data4[1] = (unsigned char)((n     ) & 0xff);
    i += j;

    // Preskoimo presledke.
    for (; i < znakov && niz[i] && aisspace(niz[i]); i++);

    // Potem je -.
    if (i >= znakov && niz[i] != (TIP)'-') return FALSE;
    i++;

    // Preskoimo presledke.
    for (; i < znakov && niz[i] && aisspace(niz[i]); i++);

    // Preberemo peti niz estnajstikih cifer.
    n = astrtou8(niz + i, znakov - i, &j, 16);
    if (n > 0xffffffffffff) return FALSE;
    id->Data4[2] = (unsigned char)((n >> 40) & 0xff);
    id->Data4[3] = (unsigned char)((n >> 32) & 0xff);
    id->Data4[4] = (unsigned char)((n >> 24) & 0xff);
    id->Data4[5] = (unsigned char)((n >> 16) & 0xff);
    id->Data4[6] = (unsigned char)((n >>  8) & 0xff);
    id->Data4[7] = (unsigned char)((n      ) & 0xff);
    i += j;

    // Preskoimo presledke.
    for (; i < znakov && niz[i] && aisspace(niz[i]); i++);

    // Potem je }.
    if (i >= znakov || niz[i] != (TIP)'}') return FALSE;
    i++;

    // Preskoimo presledke.
    for (; i < znakov && niz[i] && aisspace(niz[i]); i++);

    // e smo prili do konca niza, je bil pravilen.
    return i < znakov && niz[i] ? FALSE : TRUE;
}


template<class TIP, class TIP2> inline TIP2 _astrtoint(const TIP* niz, T_UINT znakov, T_UINT *konec, T_UINT osnova, T_U1 &zastavice)
{
    // Sprogramirano na 11.000 m nadmorske viine. Za napake ne odgovarjam!

    assert(niz || !znakov);
    assert(osnova == 0 || 2 <= osnova && osnova <= 36);

    T_UINT i = 0;
    TIP2 vrednost = 0, cifra,
        max_ui = (TIP2)-1,
        max_ui_pre1, max_ui_pre2;

    zastavice = 0;

    // Preskoimo presledke na zaetku.
    for (;; i++) {
        if (i >= znakov || !niz[i]) goto napaka;
        else if (!aisspace(niz[i]))    break;
    }

    // Preberemo predznak.
    if (niz[i] == (TIP)'+') {
        zastavice &= ~0x01;
        i++;
        if (i >= znakov || !niz[i]) goto napaka;
    } else if (niz[i] == (TIP)'-') {
        zastavice |= 0x01;
        i++;
        if (i >= znakov || !niz[i]) goto napaka;
    }

    if (osnova == 16) {
        // e je osnova esnajstika, je lahko na zaetku niza 0x.
        if (niz[i] == (TIP)'0' &&
            i+1 < znakov && (niz[i+1] == (TIP)'x' || niz[i+1] == (TIP)'X')) {
            // Nali smo 0x ali 0X na zaetku niza. Preskoimo ga.
            i += 2;
            if (i >= znakov || !niz[i]) goto napaka;
        }
    } else if (!osnova) {
        // e je osnova enaka 0, doloimo osnovo glede na prvo cifro.
        if (niz[i] == (TIP)'0') {
            // Osnova je lahko osmika ali esnajstika. Preverimo, ali nili sledi x.
            i++;
            if (i >= znakov || !niz[i]) goto napaka;

            if (niz[i] == (TIP)'x' || niz[i] == (TIP)'X') {
                // Osnova je esnajstika.
                osnova = 16;
                i++;
                if (i >= znakov || !niz[i]) goto napaka;
            } else {
                // Osnova je osmika.
                assert(0); // TODO: Preizkusi ta del kode.
                osnova = 8;
            }
        } else {
            // tevilo se ne zane z 0 ali 0x, zato privzamemo desetiko osnovo.
            assert(0); // TODO: Preizkusi ta del kode.
            osnova = 10;
        }
    }

    // Tako, sedaj imamo znano osnovo.
    max_ui_pre1 = max_ui / (TIP2)osnova;
    max_ui_pre2 = max_ui % (TIP2)osnova;

    // Zanemo s pretvorbo.
    for (;;) {
        // Pretvorimo znak v cifro.
        switch (niz[i]) {
            case (TIP)'0': cifra =  0; break;
            case (TIP)'1': cifra =  1; break;
            case (TIP)'2': cifra =  2; break;
            case (TIP)'3': cifra =  3; break;
            case (TIP)'4': cifra =  4; break;
            case (TIP)'5': cifra =  5; break;
            case (TIP)'6': cifra =  6; break;
            case (TIP)'7': cifra =  7; break;
            case (TIP)'8': cifra =  8; break;
            case (TIP)'9': cifra =  9; break;
            case (TIP)'A':
            case (TIP)'a': cifra = 10; break;
            case (TIP)'B':
            case (TIP)'b': cifra = 11; break;
            case (TIP)'C':
            case (TIP)'c': cifra = 12; break;
            case (TIP)'D':
            case (TIP)'d': cifra = 13; break;
            case (TIP)'E':
            case (TIP)'e': cifra = 14; break;
            case (TIP)'F':
            case (TIP)'f': cifra = 15; break;
            case (TIP)'G':
            case (TIP)'g': cifra = 16; break;
            case (TIP)'H':
            case (TIP)'h': cifra = 17; break;
            case (TIP)'I':
            case (TIP)'i': cifra = 18; break;
            case (TIP)'J':
            case (TIP)'j': cifra = 19; break;
            case (TIP)'K':
            case (TIP)'k': cifra = 20; break;
            case (TIP)'L':
            case (TIP)'l': cifra = 21; break;
            case (TIP)'M':
            case (TIP)'m': cifra = 22; break;
            case (TIP)'N':
            case (TIP)'n': cifra = 23; break;
            case (TIP)'O':
            case (TIP)'o': cifra = 24; break;
            case (TIP)'P':
            case (TIP)'p': cifra = 25; break;
            case (TIP)'Q':
            case (TIP)'q': cifra = 26; break;
            case (TIP)'R':
            case (TIP)'r': cifra = 27; break;
            case (TIP)'S':
            case (TIP)'s': cifra = 28; break;
            case (TIP)'T':
            case (TIP)'t': cifra = 29; break;
            case (TIP)'U':
            case (TIP)'u': cifra = 30; break;
            case (TIP)'V':
            case (TIP)'v': cifra = 31; break;
            case (TIP)'W':
            case (TIP)'w': cifra = 32; break;
            case (TIP)'X':
            case (TIP)'x': cifra = 33; break;
            case (TIP)'Y':
            case (TIP)'y': cifra = 34; break;
            case (TIP)'Z':
            case (TIP)'z': cifra = 35; break;
            default:       goto napaka;
        }

        if (cifra >= osnova) goto napaka;

        if (vrednost <  max_ui_pre1 || // Mnoenje niti setevanje ne bosta povzroila preliva.
            vrednost == max_ui_pre1 && cifra <= max_ui_pre2)  // e je cifra dovolj majhna, ne bo prilo do preliva.
        {
            // Ne bo prilo do preliva. Lahko izraunamo novo vrednost.
            vrednost = vrednost * (TIP2)osnova + cifra;
        } else {
            // Prilo bo do izliva bitov.
            zastavice |= 0x02;
        }

        i++;
        if (i >= znakov || !niz[i]) goto napaka;
    }

napaka:
    if (konec) *konec = i;
    return vrednost;
}


// Ker pri predlogah ne moremo ugotavljati doline parametra med asom prevajanja, ampak ele izvajanja, neizogibno pride do opozorila C4310, vendar le v mrtvi kodi.
#pragma warning(push)
#pragma warning(disable: 4310)

template<class TIP, class TIP2> inline TIP2 astrtoint(const TIP* niz, T_UINT znakov, T_UINT *konec, T_UINT osnova)
{
    T_U1 zastavice;
    TIP2 vrednost;

    switch (sizeof(TIP2)) {
        case sizeof(T_U1):
            vrednost = (TIP2)_astrtoint<TIP, T_U1>(niz, znakov, konec, osnova, zastavice);
            if ((zastavice & 0x01) && (vrednost & 0x80)) {
                // V bitu za predznak je e 1. Prilo je do preliva.
                assert(0); // TODO: Preizkusi ta del kode.
                zastavice |= 0x02;
            }
            return (zastavice & 0x02) ?
                (zastavice & 0x01) ? (TIP2)0x80 : (TIP2)0x7f :
                (zastavice & 0x01) ? -vrednost  : vrednost;

        case sizeof(T_U2):
            vrednost = (TIP2)_astrtoint<TIP, T_U2>(niz, znakov, konec, osnova, zastavice);
            if ((zastavice & 0x01) && (vrednost & 0x8000)) {
                // V bitu za predznak je e 1. Prilo je do preliva.
                assert(0); // TODO: Preizkusi ta del kode.
                zastavice |= 0x02;
            }
            return (zastavice & 0x02) ?
                (zastavice & 0x01) ? (TIP2)0x8000 : (TIP2)0x7fff :
                (zastavice & 0x01) ? -vrednost    : vrednost;

        case sizeof(T_U4):
            vrednost = (TIP2)_astrtoint<TIP, T_U4>(niz, znakov, konec, osnova, zastavice);
            if ((zastavice & 0x01) && (vrednost & 0x80000000)) {
                // V bitu za predznak je e 1. Prilo je do preliva.
                assert(0); // TODO: Preizkusi ta del kode.
                zastavice |= 0x02;
            }
            return (zastavice & 0x02) ?
                (zastavice & 0x01) ? (TIP2)0x80000000 : (TIP2)0x7fffffff :
                (zastavice & 0x01) ? -vrednost        : vrednost;

        case sizeof(T_U8):
            vrednost = (TIP2)_astrtoint<TIP, T_U8>(niz, znakov, konec, osnova, zastavice);
            if ((zastavice & 0x01) && (vrednost & 0x8000000000000000)) {
                // V bitu za predznak je e 1. Prilo je do preliva.
                assert(0); // TODO: Preizkusi ta del kode.
                zastavice |= 0x02;
            }
            return (zastavice & 0x02) ?
                (zastavice & 0x01) ? (TIP2)0x8000000000000000 : (TIP2)0x7fffffffffffffff :
                (zastavice & 0x01) ? -vrednost                : vrednost;

        default:
            assert(0); // Paramerti te doline (e) niso podprti.
            return 0;
    }
}

#pragma warning(pop)


template<class TIP, class TIP2> inline TIP2 astrtouint(const TIP* niz, T_UINT znakov, T_UINT *konec, T_UINT osnova)
{
    T_U1 zastavice;
    TIP2 vrednost;

    switch (sizeof(TIP2)) {
        case sizeof(T_U1): vrednost = (TIP2)_astrtoint<TIP, T_U1>(niz, znakov, konec, osnova, zastavice); break;
        case sizeof(T_U2): vrednost = (TIP2)_astrtoint<TIP, T_U2>(niz, znakov, konec, osnova, zastavice); break;
        case sizeof(T_U4): vrednost = (TIP2)_astrtoint<TIP, T_U4>(niz, znakov, konec, osnova, zastavice); break;
        case sizeof(T_U8): vrednost = (TIP2)_astrtoint<TIP, T_U8>(niz, znakov, konec, osnova, zastavice); break;
        default:
            assert(0); // Paramerti te doline (e) niso podprti.
            vrednost = 0;
            zastavice = 0x02;
    }

    return (zastavice & 0x02) ?
        (zastavice & 0x01) ? (TIP2)0   : (TIP2)-1 :
        (zastavice & 0x01) ? ~vrednost : vrednost;
}


template<class TIP> inline T_4 astrto4(const TIP* niz, T_UINT znakov, T_UINT *konec, T_UINT osnova)
{
    return astrtoint<TIP, T_4>(niz, znakov, konec, osnova);
}


template<class TIP> inline T_8 astrto8(const TIP* niz, T_UINT znakov, T_UINT *konec, T_UINT osnova)
{
    return astrtoint<TIP, T_8>(niz, znakov, konec, osnova);
}


template<class TIP> inline T_U4 astrtou4(const TIP* niz, T_UINT znakov, T_UINT *konec, T_UINT osnova)
{
    return astrtouint<TIP, T_U4>(niz, znakov, konec, osnova);
}


template<class TIP> inline T_U8 astrtou8(const TIP* niz, T_UINT znakov, T_UINT *konec, T_UINT osnova)
{
    return astrtouint<TIP, T_U8>(niz, znakov, konec, osnova);
}


inline T_FLOAT astrtof(TK_ASCII niz, T_UINT znakov, T_UINT *konec, T_LOCALE locale)
{
    return (T_FLOAT)astrtod(niz, znakov, konec, locale);
}


inline T_FLOAT astrtof(TK_UNICODE niz, T_UINT znakov, T_UINT *konec, T_LOCALE locale)
{
    return (T_FLOAT)astrtod(niz, znakov, konec, locale);
}


inline T_DOUBLE astrtod(TK_ASCII niz, T_UINT znakov, T_UINT *konec, T_LOCALE locale)
{
    T_ASCII pom, _konec;
    T_DOUBLE r;

    znakov = astrnlen(niz, znakov);
    pom = astrndup(niz, znakov + 1);
    assert(pom);
    pom[znakov] = 0;
#if _MSC_VER >= 1400
    r = _strtod_l(pom, &_konec, locale);
#else
    {
        char *locale_prej;

        if (locale) {
            locale_prej = astrdup(setlocale(LC_ALL, NULL));
            setlocale(locale->category, locale->locale);
        } else
            locale_prej = NULL;

        r = strtod(pom, &_konec);

        if (locale_prej) {
            setlocale(LC_ALL, locale_prej);
            afree(locale_prej);
        }
    }
#endif
    if (konec) *konec = (T_UINT)(_konec - pom);
    afree(pom);
    return r;
}


inline T_DOUBLE astrtod(TK_UNICODE niz, T_UINT znakov, T_UINT *konec, T_LOCALE locale)
{
    T_UNICODE pom, _konec;
    T_DOUBLE r;

    znakov = astrnlen(niz, znakov);
    pom = astrndup(niz, znakov + 1);
    assert(pom);
    pom[znakov] = 0;
#if _MSC_VER >= 1400
    r = _wcstod_l(pom, &_konec, locale);
#else
    {
        char *locale_prej;

        if (locale) {
            locale_prej = astrdup(setlocale(LC_ALL, NULL));
            setlocale(locale->category, locale->locale);
        } else
            locale_prej = NULL;

        r = wcstod(pom, &_konec);

        if (locale_prej) {
            setlocale(LC_ALL, locale_prej);
            afree(locale_prej);
        }
    }
#endif
    if (konec) *konec = (T_UINT)(_konec - pom);
    afree(pom);
    return r;
}


inline TK_ASCII   asetlocale(T_INT kategorija, TK_ASCII locale)
{
#ifndef _WIN32_WCE
    return setlocale((int)kategorija, locale);
#else
    return NULL;
#endif
}


inline TK_UNICODE asetlocale(T_INT kategorija, TK_UNICODE locale)
{
#ifndef _WIN32_WCE
    return _wsetlocale((int)kategorija, locale);
#else
    return NULL;
#endif
}


inline T_LOCALE acreatelocale(T_INT kategorija, TK_ASCII locale)
{
#if _MSC_VER >= 1400
    return _create_locale((int)kategorija, locale);
#else
    T_LOCALE l = (T_LOCALE)aalloc(sizeof(*l));
    if (l) {
        l->category = kategorija;
        astrdup2(&(l->locale), locale);
    }
    return l;
#endif
}


inline T_LOCALE acreatelocale(T_INT kategorija, TK_UNICODE locale)
{
#if _MSC_VER >= 1700
    return _wcreate_locale((int)kategorija, locale);
#elif _MSC_VER >= 1400
    T_ASCII pom;
    T_LOCALE l;

    // Najprej pretvorimo locale v ASCII. V ta namen naredimo kopijo na kopici.
    astrndup2(&pom, locale, AOSN_PRIVZETI_CP);
    if (!pom) {
        assert(0);
        return 0;
    }

    // Potem ustvarimo locale.
    l = _create_locale((int)kategorija, pom);
    afree(pom);
    return l;
#else
    T_LOCALE l = (T_LOCALE)aalloc(sizeof(*l));
    if (l) {
        l->category = kategorija;
        astrdup2(&(l->locale), locale);
    }
    return l;
#endif
}


inline T_VOID afreelocale(T_LOCALE locale)
{
#if _MSC_VER >= 1400
    _free_locale(locale);
#else
    if (locale) {
        if (locale->locale) afree(locale->locale);
        afree(locale);
    }
#endif
}


inline T_UINT astrncpy2(T_ASCII cilj, T_UINT znakov_cilj, T_KODNASTRAN kodna_stran_cilj, TK_ASCII izvor, T_UINT znakov_izvor, T_KODNASTRAN kodna_stran_izvor)
{
    T_UNICODE pom;
    T_UINT znakov;

    // Najprej pretvorimo vhodni niz v Unicode. V ta namen naredimo kopijo na kopici.
    znakov = astrndup2(&pom, izvor, znakov_izvor, kodna_stran_izvor);
    if (!pom) {
        assert(0);
        return 0;
    }

    // Nato pretvorimo niz Unicode v eleno kodno stran in ga sprostimo.
    znakov = astrncpy2(cilj, znakov_cilj, pom, znakov, kodna_stran_cilj);
    afree(pom);
    return znakov;
}


inline T_UZNAK aasctouni(TK_ASCII znak, T_UINT znakov, T_KODNASTRAN kodna_stran)
{
    T_UZNAK w;
    register DWORD zastavice = kodna_stran < KODNASTRAN_UTF7 ? MB_PRECOMPOSED : 0;
    return ::MultiByteToWideChar(kodna_stran, zastavice, znak, (int)znakov, &w, 1) ? w : (T_UZNAK)0;
}


inline T_UZNAK ayuasctouni(T_AZNAK znak)
{
    switch (znak) {
    case '~':  return 0x10d;
    case '^':  return 0x10c;
    case '{':  return 0x161;
    case '[':  return 0x160;
    case '`':  return 0x17e;
    case '@':  return 0x17d;
    case '}':  return 0x107;
    case ']':  return 0x106;
    case '|':  return 0x111;
    case '\\': return 0x110;
    default:   return znak < 0x80 ? znak : (T_UZNAK)0;
    }
}


inline T_AZNAK aunitoasc(T_UZNAK znak, T_KODNASTRAN kodna_stran)
{
    assert(MB_CUR_MAX <= 5);

    T_AZNAK mbch;
    return ::WideCharToMultiByte(kodna_stran, 0, &znak, 1, &mbch, 1, NULL, NULL) ? mbch : (T_AZNAK)0;
}


inline T_AZNAK aunitoyuasc(T_UZNAK znak)
{
    switch (znak) {
    case 0x010d: return '~';
    case 0x010c: return '^';
    case 0x0161: return '{';
    case 0x0160: return '[';
    case 0x017e: return '`';
    case 0x017d: return '@';
    case 0x0107: return '}';
    case 0x0106: return ']';
    case 0x0111: return '|';
    case 0x0110: return '\\';

    case 0x00c1:
    case 0x00c0:
    case 0x0102:
    case 0x00c2:
    case 0x00c4:
    case 0x00c3:
    case 0x00c5:
    case 0x0104:
    case 0x0100:
    case 0x0200: return 'A';

    case 0x00e1:
    case 0x00e0:
    case 0x0103:
    case 0x00e2:
    case 0x00e4:
    case 0x00e3:
    case 0x00e5:
    case 0x0105:
    case 0x0101:
    case 0x0201:
    case 0x0203: return 'a';

    case 0x00c9:
    case 0x00c8:
    case 0x0114:
    case 0x00ca:
    case 0x00cb:
    case 0x011a:
    case 0x0118:
    case 0x0112:
    case 0x0116:
    case 0x018f: return 'E';

    case 0x00e9:
    case 0x00e8:
    case 0x0115:
    case 0x00ea:
    case 0x00eb:
    case 0x011b:
    case 0x0119:
    case 0x0113:
    case 0x0117:
    case 0x1eb8:
    case 0x1eb9:
    case 0x0259: return 'e';

    case 0x00cd:
    case 0x00cc:
    case 0x00ce:
    case 0x00cf:
    case 0x0128:
    case 0x0130:
    case 0x012e:
    case 0x012a: return 'I';

    case 0x00ed:
    case 0x00ec:
    case 0x00ee:
    case 0x00ef:
    case 0x0129:
    case 0x012f:
    case 0x012b: return 'i';

    case 0x0141: return 'L';

    case 0x0142: return 'l';

    case 0x00d3:
    case 0x00d2:
    case 0x014e:
    case 0x00d4:
    case 0x00d6:
    case 0x00d5:
    case 0x00d8:
    case 0x01ea:
    case 0x014c:
    case 0x0150:
    case 0x020c: return 'O';

    case 0x00f3:
    case 0x00f2:
    case 0x014f:
    case 0x00f4:
    case 0x00f6:
    case 0x00f5:
    case 0x00f8:
    case 0x01eb:
    case 0x014d:
    case 0x0151:
    case 0x1ecc:
    case 0x1ecd:
    case 0x020d: return 'o';

    case 0x0154:
    case 0x0158:
    case 0x0156:
    case 0x0212: return 'R';

    case 0x0155:
    case 0x0159:
    case 0x0157:
    case 0x0213: return 'R';

    case 0x015a: return 'S';

    case 0x015b: return 's';

    case 0x00da:
    case 0x00d9:
    case 0x016c:
    case 0x00db:
    case 0x00dc:
    case 0x0168:
    case 0x016e:
    case 0x0172:
    case 0x016a:
    case 0x0170:
    case 0x0214:
    case 0x0216: return 'U';

    case 0x00fa:
    case 0x00f9:
    case 0x016d:
    case 0x00fb:
    case 0x00fc:
    case 0x0169:
    case 0x016f:
    case 0x0173:
    case 0x016b:
    case 0x0171:
    case 0x0215:
    case 0x0217: return 'u';

    case 0x028d: return 'v';

    case 0x0179: return 'Z';

    case 0x017a: return 'z';

    default:     return znak < 0x80 ? (T_AZNAK)znak : (T_AZNAK)0;
    }
}


inline T_UINT aguidtostr(const GUID *id, T_ASCII niz, T_UINT znakov)
{
    T_INT n = asnprintf(niz, znakov, GUID_PRINTF_A, T_LOCALE_THREAD_DEFAULT, GUID_PRINTF_VAL(*id));
    return n >= 0 ? (T_UINT)n : znakov;
}


inline T_UINT aguidtostr(const GUID *id, T_UNICODE niz, T_UINT znakov)
{
    T_INT n = asnprintf(niz, znakov, GUID_PRINTF_U, T_LOCALE_THREAD_DEFAULT, GUID_PRINTF_VAL(*id));
    return n >= 0 ? (T_UINT)n : znakov;
}


#ifndef AOSN_BREZ_SGML

inline TK_UNICODE asgmltouni(TK_ASCII entiteta, T_UINT znakov)
{
    assert(entiteta && znakov);

    T_UINT i, j, m;
    T_INT r;

    // Numerinih entitet ta funkcija ne podpira ve, ker bi potrebovala dodaten pomnilnik, da bi vanj shranila kodo znaka in vrnila kazalec nanj.
    assert(znakov < 2 || entiteta[0] != '#');

    // Poiemo z bisekcijo entiteto SGML.
    for (i = 0, j = AOSN_SGML_ENTITET; i < j; ) {
        m = (i + j) / 2;

        // V prvi fazi primerjamo le prva znaka.
        if (::sgml_unicode[m].sgml[0] < entiteta[0])
            i = m + 1;
        else if (::sgml_unicode[m].sgml[0] > entiteta[0])
            j = m;
        else {
            // Prva znaka sta enaka. Primerjamo ostanka entitet.
            r = astrncmp<T_AZNAK, T_AZNAK>(::sgml_unicode[m].sgml + 1, AOSN_SGML_ENTITETA_SGML_MAX - 1, entiteta + 1, znakov - 1);
            if (r < 0)
                i = m + 1;
            else if (r > 0)
                j = m;
            else
                return ::sgml_unicode[m].unicode;
        }
    }

    // Neznana entiteta SGML. Preveri in dodaj.
    assert(0);
    return NULL;
}


inline TK_UNICODE asgmltouni(TK_UNICODE entiteta, T_UINT znakov)
{
    assert(entiteta && znakov);

    T_UINT i, j, m;
    T_INT r;

    // Numerinih entitet ta funkcija ne podpira ve, ker bi potrebovala dodaten pomnilnik, da bi vanj shranila kodo znaka in vrnila kazalec nanj.
    assert(znakov < 2 || entiteta[0] != '#');

    // Poiemo z bisekcijo entiteto SGML.
    for (i = 0, j = AOSN_SGML_ENTITET; i < j; ) {
        m = (i + j) / 2;

        // V prvi fazi primerjamo le prva znaka.
        if (::sgml_unicode[m].sgml[0] < entiteta[0])
            i = m + 1;
        else if (::sgml_unicode[m].sgml[0] > entiteta[0])
            j = m;
        else {
            // Prva znaka sta enaka. Primerjamo ostanka entitet.
            r = astrncmp<T_AZNAK, T_UZNAK>(::sgml_unicode[m].sgml + 1, AOSN_SGML_ENTITETA_SGML_MAX - 1, entiteta + 1, znakov - 1);
            if (r < 0)
                i = m + 1;
            else if (r > 0)
                j = m;
            else
                return ::sgml_unicode[m].unicode;
        }
    }

    return NULL;
}


inline TK_ASCII achrtosgml(TK_ASCII entiteta, T_UINT znakov, T_KODNASTRAN kodna_stran)
{
    assert(0); // TODO: Preizkusi ta del kode.
    assert(entiteta && znakov);

    T_UZNAK znak = aasctouni(entiteta, znakov, kodna_stran);
    return achrtosgml(&znak, 1);
}


inline TK_ASCII achrtosgml(TK_UNICODE entiteta, T_UINT znakov)
{
    assert(entiteta && znakov);

    T_UINT i, j, m;
    T_INT r;
    T_UZNAK e1, e2 = entiteta[0];

    // Poiemo z bisekcijo entiteto Unicode.
    for (i = 0, j = AOSN_SGML_ENTITET; i < j; ) {
        m = (i + j) / 2;

        // V prvi fazi primerjamo le prva znaka.
        e1 = ::sgml_unicode[::unicode_sgml[m]].unicode[0];
        if (e1 < e2)
            i = m + 1;
        else if (e1 > e2)
            j = m;
        else {
            // Prva znaka sta enaka. Primerjamo ostanka entitet.
            r = astrncmp(::sgml_unicode[::unicode_sgml[m]].unicode + 1, AOSN_SGML_ENTITETA_UNICODE_MAX - 1, entiteta + 1, znakov - 1);
            if (r < 0)
                i = m + 1;
            else if (r > 0)
                j = m;
            else {
                // Nali smo iskano etiteto Unicode. Zdaj vrnemo prvo, e je ve enakih. Ne uporabljamo ve bisekcije, ampak linearno iskanje nazaj, saj je podvojitev, e sploh obstajajo, malo.
                for (; i < m && ::sgml_unicode[::unicode_sgml[m - 1]].unicode[0] == e2 && astrncmp(::sgml_unicode[::unicode_sgml[m - 1]].unicode + 1, AOSN_SGML_ENTITETA_UNICODE_MAX - 1, entiteta + 1, znakov - 1) == 0; m--);
                return ::sgml_unicode[::unicode_sgml[m]].sgml;
            }
        }
    }

    return NULL;
}


inline T_UINT asgmltostr(T_ASCII cilj, T_UINT znakov_cilj, TK_ASCII izvor, T_UINT znakov_izvor, T_UINT kateri, T_KODNASTRAN kodna_stran)
{
    assert(0); // TODO: Preizkusi ta del kode.
    assert(cilj  || !znakov_cilj);
    assert(izvor || !znakov_izvor);

    T_UINT i, j, n;
    T_ASCII konec;
    TK_UNICODE entiteta_uni;
    T_UZNAK znak[2];
    T_BOOL
        pusti_narekovaj    = (kateri & AOSN_SGML_NAREKOVAJ   ) == 0,
        pusti_apostrof     = (kateri & AOSN_SGML_APOSTROF    ) == 0,
        pusti_in           = (kateri & AOSN_SGML_IN          ) == 0,
        pusti_manjse_vecje = (kateri & AOSN_SGML_MANJSE_VECJE) == 0,
        pusti_posevnico    = (kateri & AOSN_SGML_POSEVNICA   ) == 0,
        pusti_dolar        = (kateri & AOSN_SGML_DOLAR       ) == 0,
        pusti_odstotek     = (kateri & AOSN_SGML_ODSTOTEK    ) == 0,
        pusti_ajko         = (kateri & AOSN_SGML_AJKA        ) == 0,
        pusti_lojtro       = (kateri & AOSN_SGML_LOJTRA      ) == 0,
        pusti_oklepaja     = (kateri & AOSN_SGML_OKLEPAJA    ) == 0,
        pusti_zav_oklepaja = (kateri & AOSN_SGML_ZAV_OKLEPAJA) == 0,
        pusti_ogl_oklepaja = (kateri & AOSN_SGML_OGL_OKLEPAJA) == 0;

    for (i = j = 0; j < znakov_cilj && i < znakov_izvor && izvor[i];) {
        // Ali smo naleteli na zaetek entitete?
        if (izvor[i] == '&') {
            // Poiemo njen konec.
            konec = asgmlend(izvor + i + 1, znakov_izvor - i - 1);

            // Smo nali konec?
            if (konec) {
                n = konec - izvor - i - 1;

                if (n >= 2 && izvor[i + 1] == '#') {
                    // Gre za numerino entiteto.
                    if (izvor[i + 2] == 'x' || izvor[i + 2] == 'X')
                        znak[0] = (T_UZNAK)astrtoui(izvor + i + 3, n - 2, NULL, 16);
                    else
                        znak[0] = (T_UZNAK)astrtoui(izvor + i + 2, n - 1, NULL, 10);
                    znak[1] = 0;
                    entiteta_uni = znak;
                } else {
                    // Poiemo entiteto v tabeli entitet.
                    entiteta_uni = asgmltouni(izvor + i + 1, n);
                }

                if (entiteta_uni &&
                    (pusti_narekovaj    || (entiteta_uni[0] != L'"'                            )) &&
                    (pusti_apostrof     || (entiteta_uni[0] != L'\''                           )) &&
                    (pusti_in           || (entiteta_uni[0] != L'&'                            )) &&
                    (pusti_manjse_vecje || (entiteta_uni[0] != L'<'  && entiteta_uni[0] != L'>')) &&
                    (pusti_posevnico    || (entiteta_uni[0] != L'\\'                           )) &&
                    (pusti_dolar        || (entiteta_uni[0] != L'$'                            )) &&
                    (pusti_odstotek     || (entiteta_uni[0] != L'%'                            )) &&
                    (pusti_ajko         || (entiteta_uni[0] != L'@'                            )) &&
                    (pusti_lojtro       || (entiteta_uni[0] != L'#'                            )) &&
                    (pusti_oklepaja     || (entiteta_uni[0] != L'('  && entiteta_uni[0] != L')')) &&
                    (pusti_zav_oklepaja || (entiteta_uni[0] != L'{'  && entiteta_uni[0] != L'}')) &&
                    (pusti_ogl_oklepaja || (entiteta_uni[0] != L'['  && entiteta_uni[0] != L']')))
                {
                    // Entiteto pretvorimo v znake.
                    j += astrncpy2(cilj + j, znakov_cilj - j, entiteta_uni, T_UINT_MAX, kodna_stran);
                    i = konec - izvor + 1;
                    continue;
                }
            }
        }

        assert(((T_U1)izvor[i]) < 128);
        cilj[j++] = izvor[i++];
    }

    if (j < znakov_cilj)
        cilj[j] = 0;

    return j;
}


inline T_UINT asgmltostr(T_UNICODE cilj, T_UINT znakov_cilj, TK_ASCII izvor, T_UINT znakov_izvor, T_UINT kateri)
{
    assert(cilj  || !znakov_cilj);
    assert(izvor || !znakov_izvor);

    T_UINT i, j, n;
    T_ASCII konec;
    TK_UNICODE entiteta_uni;
    T_UZNAK znak[2];
    T_BOOL
        pusti_narekovaj    = (kateri & AOSN_SGML_NAREKOVAJ   ) == 0,
        pusti_apostrof     = (kateri & AOSN_SGML_APOSTROF    ) == 0,
        pusti_in           = (kateri & AOSN_SGML_IN          ) == 0,
        pusti_manjse_vecje = (kateri & AOSN_SGML_MANJSE_VECJE) == 0,
        pusti_posevnico    = (kateri & AOSN_SGML_POSEVNICA   ) == 0,
        pusti_dolar        = (kateri & AOSN_SGML_DOLAR       ) == 0,
        pusti_odstotek     = (kateri & AOSN_SGML_ODSTOTEK    ) == 0,
        pusti_ajko         = (kateri & AOSN_SGML_AJKA        ) == 0,
        pusti_lojtro       = (kateri & AOSN_SGML_LOJTRA      ) == 0,
        pusti_oklepaja     = (kateri & AOSN_SGML_OKLEPAJA    ) == 0,
        pusti_zav_oklepaja = (kateri & AOSN_SGML_ZAV_OKLEPAJA) == 0,
        pusti_ogl_oklepaja = (kateri & AOSN_SGML_OGL_OKLEPAJA) == 0;

    for (i = j = 0; j < znakov_cilj && i < znakov_izvor && izvor[i];) {
        // Ali smo naleteli na zaetek entitete?
        if (izvor[i] == '&') {
            // Poiemo njen konec.
            konec = asgmlend(izvor + i + 1, znakov_izvor - i - 1);

            // Smo nali konec?
            if (konec) {
                n = konec - izvor - i - 1;

                if (n >= 2 && izvor[i + 1] == '#') {
                    // Gre za numerino entiteto.
                    if (izvor[i + 2] == 'x' || izvor[i + 2] == 'X')
                        znak[0] = (T_UZNAK)astrtoui(izvor + i + 3, n - 2, NULL, 16);
                    else
                        znak[0] = (T_UZNAK)astrtoui(izvor + i + 2, n - 1, NULL, 10);
                    znak[1] = 0;
                    entiteta_uni = znak;
                } else {
                    // Poiemo entiteto v tabeli entitet.
                    entiteta_uni = asgmltouni(izvor + i + 1, n);
                }

                if (entiteta_uni &&
                    (pusti_narekovaj    || (entiteta_uni[0] != L'"'                            )) &&
                    (pusti_apostrof     || (entiteta_uni[0] != L'\''                           )) &&
                    (pusti_in           || (entiteta_uni[0] != L'&'                            )) &&
                    (pusti_manjse_vecje || (entiteta_uni[0] != L'<'  && entiteta_uni[0] != L'>')) &&
                    (pusti_posevnico    || (entiteta_uni[0] != L'\\'                           )) &&
                    (pusti_dolar        || (entiteta_uni[0] != L'$'                            )) &&
                    (pusti_odstotek     || (entiteta_uni[0] != L'%'                            )) &&
                    (pusti_ajko         || (entiteta_uni[0] != L'@'                            )) &&
                    (pusti_lojtro       || (entiteta_uni[0] != L'#'                            )) &&
                    (pusti_oklepaja     || (entiteta_uni[0] != L'('  && entiteta_uni[0] != L')')) &&
                    (pusti_zav_oklepaja || (entiteta_uni[0] != L'{'  && entiteta_uni[0] != L'}')) &&
                    (pusti_ogl_oklepaja || (entiteta_uni[0] != L'['  && entiteta_uni[0] != L']')))
                {
                    // Entiteto pretvorimo v znake.
                    j += astrncpy2(cilj + j, znakov_cilj - j, entiteta_uni, T_UINT_MAX);
                    i = konec - izvor + 1;
                    continue;
                }
            }
        }

        assert(((T_U1)izvor[i]) < 128);
        cilj[j++] = izvor[i++];
    }

    if (j < znakov_cilj)
        cilj[j] = 0;

    return j;
}


inline T_UINT asgmltostr(T_ASCII cilj, T_UINT znakov_cilj, TK_UNICODE izvor, T_UINT znakov_izvor, T_UINT kateri, T_KODNASTRAN kodna_stran)
{
    assert(0); // TODO: Preizkusi ta del kode.
    assert(cilj  || !znakov_cilj);
    assert(izvor || !znakov_izvor);

    T_UINT i, j, n;
    T_UNICODE konec;
    TK_UNICODE entiteta_uni;
    T_UZNAK znak[2];
    T_BOOL
        pusti_narekovaj    = (kateri & AOSN_SGML_NAREKOVAJ   ) == 0,
        pusti_apostrof     = (kateri & AOSN_SGML_APOSTROF    ) == 0,
        pusti_in           = (kateri & AOSN_SGML_IN          ) == 0,
        pusti_manjse_vecje = (kateri & AOSN_SGML_MANJSE_VECJE) == 0,
        pusti_posevnico    = (kateri & AOSN_SGML_POSEVNICA   ) == 0,
        pusti_dolar        = (kateri & AOSN_SGML_DOLAR       ) == 0,
        pusti_odstotek     = (kateri & AOSN_SGML_ODSTOTEK    ) == 0,
        pusti_ajko         = (kateri & AOSN_SGML_AJKA        ) == 0,
        pusti_lojtro       = (kateri & AOSN_SGML_LOJTRA      ) == 0,
        pusti_oklepaja     = (kateri & AOSN_SGML_OKLEPAJA    ) == 0,
        pusti_zav_oklepaja = (kateri & AOSN_SGML_ZAV_OKLEPAJA) == 0,
        pusti_ogl_oklepaja = (kateri & AOSN_SGML_OGL_OKLEPAJA) == 0;

    for (i = j = 0; j < znakov_cilj && i < znakov_izvor && izvor[i];) {
        // Ali smo naleteli na zaetek entitete?
        if (izvor[i] == L'&') {
            // Poiemo njen konec.
            konec = asgmlend(izvor + i + 1, znakov_izvor - i - 1);

            // Smo nali konec?
            if (konec) {
                n = konec - izvor - i - 1;

                if (n >= 2 && izvor[i + 1] == L'#') {
                    // Gre za numerino entiteto.
                    if (izvor[i + 2] == L'x' || izvor[i + 2] == L'X')
                        znak[0] = (T_UZNAK)astrtoui(izvor + i + 3, n - 2, NULL, 16);
                    else
                        znak[0] = (T_UZNAK)astrtoui(izvor + i + 2, n - 1, NULL, 10);
                    znak[1] = 0;
                    entiteta_uni = znak;
                } else {
                    // Poiemo entiteto v tabeli entitet.
                    entiteta_uni = asgmltouni(izvor + i + 1, n);
                }

                if (entiteta_uni &&
                    (pusti_narekovaj    || (entiteta_uni[0] != L'"'                            )) &&
                    (pusti_apostrof     || (entiteta_uni[0] != L'\''                           )) &&
                    (pusti_in           || (entiteta_uni[0] != L'&'                            )) &&
                    (pusti_manjse_vecje || (entiteta_uni[0] != L'<'  && entiteta_uni[0] != L'>')) &&
                    (pusti_posevnico    || (entiteta_uni[0] != L'\\'                           )) &&
                    (pusti_dolar        || (entiteta_uni[0] != L'$'                            )) &&
                    (pusti_odstotek     || (entiteta_uni[0] != L'%'                            )) &&
                    (pusti_ajko         || (entiteta_uni[0] != L'@'                            )) &&
                    (pusti_lojtro       || (entiteta_uni[0] != L'#'                            )) &&
                    (pusti_oklepaja     || (entiteta_uni[0] != L'('  && entiteta_uni[0] != L')')) &&
                    (pusti_zav_oklepaja || (entiteta_uni[0] != L'{'  && entiteta_uni[0] != L'}')) &&
                    (pusti_ogl_oklepaja || (entiteta_uni[0] != L'['  && entiteta_uni[0] != L']')))
                {
                    // Entiteto pretvorimo v znake.
                    j += astrncpy2(cilj + j, znakov_cilj - j, entiteta_uni, T_UINT_MAX, kodna_stran);
                    i = konec - izvor + 1;
                    continue;
                }
            }
        }

        n = achrlen(izvor + i, znakov_izvor - i);
        j += astrncpy2(cilj + j, znakov_cilj - j, izvor + i, n, kodna_stran);
        i += n;
    }

    if (j < znakov_cilj)
        cilj[j] = 0;

    return j;
}


inline T_UINT asgmltostr(T_UNICODE cilj, T_UINT znakov_cilj, TK_UNICODE izvor, T_UINT znakov_izvor, T_UINT kateri)
{
    assert(cilj  || !znakov_cilj);
    assert(izvor || !znakov_izvor);

    T_UINT i, j, n;
    T_UNICODE konec;
    TK_UNICODE entiteta_uni;
    T_UZNAK znak[2];
    T_BOOL
        pusti_narekovaj    = (kateri & AOSN_SGML_NAREKOVAJ   ) == 0,
        pusti_apostrof     = (kateri & AOSN_SGML_APOSTROF    ) == 0,
        pusti_in           = (kateri & AOSN_SGML_IN          ) == 0,
        pusti_manjse_vecje = (kateri & AOSN_SGML_MANJSE_VECJE) == 0,
        pusti_posevnico    = (kateri & AOSN_SGML_POSEVNICA   ) == 0,
        pusti_dolar        = (kateri & AOSN_SGML_DOLAR       ) == 0,
        pusti_odstotek     = (kateri & AOSN_SGML_ODSTOTEK    ) == 0,
        pusti_ajko         = (kateri & AOSN_SGML_AJKA        ) == 0,
        pusti_lojtro       = (kateri & AOSN_SGML_LOJTRA      ) == 0,
        pusti_oklepaja     = (kateri & AOSN_SGML_OKLEPAJA    ) == 0,
        pusti_zav_oklepaja = (kateri & AOSN_SGML_ZAV_OKLEPAJA) == 0,
        pusti_ogl_oklepaja = (kateri & AOSN_SGML_OGL_OKLEPAJA) == 0;

    for (i = j = 0; j < znakov_cilj && i < znakov_izvor && izvor[i];) {
        // Ali smo naleteli na zaetek entitete?
        if (izvor[i] == L'&') {
            // Poiemo njen konec.
            konec = asgmlend(izvor + i + 1, znakov_izvor - i - 1);

            // Smo nali konec?
            if (konec) {
                n = konec - izvor - i - 1;

                if (n >= 2 && izvor[i + 1] == L'#') {
                    // Gre za numerino entiteto.
                    if (izvor[i + 2] == L'x' || izvor[i + 2] == L'X')
                        znak[0] = (T_UZNAK)astrtoui(izvor + i + 3, n - 2, NULL, 16);
                    else
                        znak[0] = (T_UZNAK)astrtoui(izvor + i + 2, n - 1, NULL, 10);
                    znak[1] = 0;
                    entiteta_uni = znak;
                } else {
                    // Poiemo entiteto v tabeli entitet.
                    entiteta_uni = asgmltouni(izvor + i + 1, n);
                }

                if (entiteta_uni &&
                    (pusti_narekovaj    || (entiteta_uni[0] != L'"'                            )) &&
                    (pusti_apostrof     || (entiteta_uni[0] != L'\''                           )) &&
                    (pusti_in           || (entiteta_uni[0] != L'&'                            )) &&
                    (pusti_manjse_vecje || (entiteta_uni[0] != L'<'  && entiteta_uni[0] != L'>')) &&
                    (pusti_posevnico    || (entiteta_uni[0] != L'\\'                           )) &&
                    (pusti_dolar        || (entiteta_uni[0] != L'$'                            )) &&
                    (pusti_odstotek     || (entiteta_uni[0] != L'%'                            )) &&
                    (pusti_ajko         || (entiteta_uni[0] != L'@'                            )) &&
                    (pusti_lojtro       || (entiteta_uni[0] != L'#'                            )) &&
                    (pusti_oklepaja     || (entiteta_uni[0] != L'('  && entiteta_uni[0] != L')')) &&
                    (pusti_zav_oklepaja || (entiteta_uni[0] != L'{'  && entiteta_uni[0] != L'}')) &&
                    (pusti_ogl_oklepaja || (entiteta_uni[0] != L'['  && entiteta_uni[0] != L']')))
                {
                    // Entiteto pretvorimo v znake.
                    j += astrncpy2(cilj + j, znakov_cilj - j, entiteta_uni, T_UINT_MAX);
                    i = konec - izvor + 1;
                    continue;
                }
            }
        }

        cilj[j++] = izvor[i++];
    }

    if (j < znakov_cilj)
        cilj[j] = 0;

    return j;
}


template <class TIP> inline TIP* asgmlend(const TIP* niz, T_UINT znakov)
{
    assert(niz || !znakov);

    register T_UINT i;

    for (i = 0; i < znakov; i++) {
        if (niz[i] == (TIP)';')
            return (TIP*)niz + i;
        else if (!niz[i] || niz[i] == (TIP)'&' || aisspace(niz[i]))
            break;
    }

    return NULL;
}


template <class TIP> inline T_UINT asgmlerr(const TIP* niz, T_UINT znakov)
{
    assert(0); // TODO: Preizkusi ta del kode.
    assert(niz || !znakov);

    T_UINT i, n;
    TIP *konec;
    TK_UNICODE entiteta_uni;
    T_UZNAK znak[2];

    for (i = 0; i < znakov && niz[i];) {
        // Ali smo naleteli na zaetek entitete?
        if (niz[i] == (TIP)'&') {
            // Poiemo njen konec.
            konec = asgmlend(niz + i + 1, znakov - i - 1);

            // Smo nali konec?
            if (konec) {
                n = konec - niz - i - 1;

                if (n >= 2 && niz[i + 1] == L'#') {
                    // Gre za numerino entiteto.
                    if (niz[i + 2] == L'x' || niz[i + 2] == L'X')
                        znak[0] = (T_UZNAK)astrtoui(niz + i + 3, n - 2, NULL, 16);
                    else
                        znak[0] = (T_UZNAK)astrtoui(niz + i + 2, n - 1, NULL, 10);
                    znak[1] = 0;
                    entiteta_uni = znak;
                } else {
                    // Poiemo entiteto v tabeli entitet.
                    entiteta_uni = asgmltouni(niz + i + 1, n);
                }

                if (entiteta_uni) {
                    // Entiteto lahko pretvorimo v znak.
                    i = konec - niz + 1;
                    continue;
                } else {
                    // Neznana entiteta.
                    return i;
                }
            } else {
                // Entiteta ni zakljuena.
                return i;
            }
        }

        assert(((T_U1)niz[i]) < 128);
        i++;
    }

    return T_UINT_MAX;
}


inline T_UINT astrtosgml(T_ASCII cilj, T_UINT znakov_cilj, TK_UNICODE izvor, T_UINT znakov_izvor, T_UINT kateri)
{
    assert(cilj  || !znakov_cilj);
    assert(izvor || !znakov_izvor);

    T_UINT i, j, n;
    TK_ASCII entiteta;
    T_BOOL
        pusti_ascii        = (kateri & AOSN_SGML_POLNI       ) == 0,
        pusti_narekovaj    = (kateri & AOSN_SGML_NAREKOVAJ   ) == 0,
        pusti_apostrof     = (kateri & AOSN_SGML_APOSTROF    ) == 0,
        pusti_manjse_vecje = (kateri & AOSN_SGML_MANJSE_VECJE) == 0,
        pusti_posevnico    = (kateri & AOSN_SGML_POSEVNICA   ) == 0,
        pusti_dolar        = (kateri & AOSN_SGML_DOLAR       ) == 0,
        pusti_odstotek     = (kateri & AOSN_SGML_ODSTOTEK    ) == 0,
        pusti_ajko         = (kateri & AOSN_SGML_AJKA        ) == 0,
        pusti_lojtro       = (kateri & AOSN_SGML_LOJTRA      ) == 0,
        pusti_oklepaja     = (kateri & AOSN_SGML_OKLEPAJA    ) == 0,
        pusti_zav_oklepaja = (kateri & AOSN_SGML_ZAV_OKLEPAJA) == 0,
        pusti_ogl_oklepaja = (kateri & AOSN_SGML_OGL_OKLEPAJA) == 0;

    for (i = j = 0; j < znakov_cilj && i < znakov_izvor && izvor[i];) {
        n = achrlen(izvor + i, znakov_izvor - i);
        if (n == 1 &&
            pusti_ascii && (T_U2)izvor[i] < 128 &&
                                    izvor[i] != L'&'                        &&
            (pusti_narekovaj    || (izvor[i] != L'"'                     )) &&
            (pusti_apostrof     || (izvor[i] != L'\''                    )) &&
            (pusti_manjse_vecje || (izvor[i] != L'<'  && izvor[i] != L'>')) &&
            (pusti_posevnico    || (izvor[i] != L'\\'                    )) &&
            (pusti_dolar        || (izvor[i] != L'$'                     )) &&
            (pusti_odstotek     || (izvor[i] != L'%'                     )) &&
            (pusti_ajko         || (izvor[i] != L'@'                     )) &&
            (pusti_lojtro       || (izvor[i] != L'#'                     )) &&
            (pusti_oklepaja     || (izvor[i] != L'('  && izvor[i] != L')')) &&
            (pusti_zav_oklepaja || (izvor[i] != L'{'  && izvor[i] != L'}')) &&
            (pusti_ogl_oklepaja || (izvor[i] != L'['  && izvor[i] != L']')))
        {
            // Znak je 7-bitni ASCII in nimamo posebne elje, da bi ga pretvorili v entiteto. Zato ga le prepiemo.
            cilj[j++] = (T_AZNAK)izvor[i++];
        } else {
            entiteta = achrtosgml(izvor + i, n);
            if (entiteta) {
                // Celoten znak lahko zapiemo z eno entiteto.
                assert(j < znakov_cilj); cilj[j++] = '&';
                j += astrncpy2(cilj + j, znakov_cilj - j, entiteta, T_UINT_MAX);
                assert(j < znakov_cilj); cilj[j++] = ';';
                i += n;
            } else if (n == 1) {
                // Znak je trivialen (doline ena), entitete SGML zanj ne poznamo.
                if ((T_U2)izvor[i] < 128) {
                    // Znak je 7-bitni ASCII. Zato ga prepiemo.
                    assert(j < znakov_cilj); cilj[j++] = (T_AZNAK)izvor[i++];
                } else {
                    // Zapiemo numerino.
                    assert(j < znakov_cilj); cilj[j++] = '&';
                    assert(j < znakov_cilj); cilj[j++] = '#';
                    assert(j < znakov_cilj); cilj[j++] = 'x';
#if _MSC_VER >= 1500
                    _itoa_s(izvor[i], cilj + j, znakov_cilj - j, 16);
#else
                    _itoa(izvor[i], cilj + j, 16);
#endif
                    j += astrnlen(cilj + j, znakov_cilj - j);
                    assert(j < znakov_cilj); cilj[j++] = ';';
                    i++;
                }
            } else {
                // Znak je sestavljen, zato ga pretvorimo po delih.
                T_UINT konec = i + n;
                while (i < konec) {
                    entiteta = achrtosgml(izvor + i, 1);
                    if (entiteta) {
                        // Zapiemo z entiteto.
                        assert(j < znakov_cilj); cilj[j++] = '&';
                        j += astrncpy2(cilj + j, znakov_cilj - j, entiteta, T_UINT_MAX);
                        assert(j < znakov_cilj); cilj[j++] = ';';
                        i++;
                    } else if ((T_U2)izvor[i] < 128) {
                        // Prepiemo.
                        assert(j < znakov_cilj); cilj[j++] = (T_AZNAK)izvor[i++];
                    } else {
                        // Zapiemo numerino.
                        assert(j < znakov_cilj); cilj[j++] = '&';
                        assert(j < znakov_cilj); cilj[j++] = '#';
                        assert(j < znakov_cilj); cilj[j++] = 'x';
#if _MSC_VER >= 1500
                        _itoa_s(izvor[i], cilj + j, znakov_cilj - j, 16);
#else
                        _itoa(izvor[i], cilj + j, 16);
#endif
                        j += astrnlen(cilj + j, znakov_cilj - j);
                        assert(j < znakov_cilj); cilj[j++] = ';';
                        i++;
                    }
                }
            }
        }
    }
    if (j < znakov_cilj) cilj[j] = 0;

    return j;
}


inline RNizA astrtosgml(TK_ASCII niz, T_UINT koliko, T_UINT kateri, T_KODNASTRAN kodna_stran)
{
    return RNizA::VrniSGML(niz, koliko, kateri, kodna_stran);
}


inline RNizA astrtosgml(TK_UNICODE niz, T_UINT koliko, T_UINT kateri)
{
    return RNizU::VrniSGML(niz, koliko, kateri);
}

#endif


inline T_VOID* amemcpy(T_KAZALEC dst, TK_KAZALEC src, T_SIZE n)
{
    assert(dst && src || !n);

    switch (n) {
#if defined(_WIN64) || defined(__LP64__)
    case sizeof(T_U8):
        *(T_U8*)dst = *(T_U8*)src;
        break;
#endif
    case sizeof(T_U4):
        *(T_U4*)dst = *(T_U4*)src;
        break;
    case sizeof(T_U1):
        *(T_U1*)dst = *(T_U1*)src;
        break;
    case sizeof(T_U2):
        *(T_U2*)dst = *(T_U2*)src;
        break;
    case 0:
        break;
    default:
        memcpy(dst, src, n);
    };

    return dst;
}


inline T_INT avsnprintf(T_ASCII niz, T_UINT znakov, TK_ASCII format, T_LOCALE locale, va_list parametri)
{
    // Ne uporabimo funckije _vsnprintf_s(), saj ta na silo vrine zakljuni znak, tudi kadar izrecno elimo pisati v ivi rob (niz brez zakljuitve).
    // Zato raje izklopimo nadleno opozorilo o nevarnosti. ;)
#pragma warning(push)
#pragma warning(disable: 4995)
#pragma warning(disable: 4996)
#if _MSC_VER >= 1400
    return _vsnprintf_l(niz, znakov, format, locale, parametri);
#else
    char *locale_prej;
    T_INT r;

    if (locale) {
        locale_prej = astrdup(setlocale(LC_ALL, NULL));
        setlocale(locale->category, locale->locale);
    } else
        locale_prej = NULL;

    r = _vsnprintf(niz, znakov, format, parametri);

    if (locale_prej) {
        setlocale(LC_ALL, locale_prej);
        afree(locale_prej);
    }

    return r;
#endif
#pragma warning(pop)
}


inline T_INT avsnprintf(T_UNICODE niz, T_UINT znakov, TK_UNICODE format, T_LOCALE locale, va_list parametri)
{
    // Ne uporabimo funckije _vsnwprintf_s(), saj ta na silo vrine zakljuni znak, tudi kadar izrecno elimo pisati v ivi rob (niz brez zakljuitve).
    // Zato raje izklopimo nadleno opozorilo o nevarnosti. ;)
#pragma warning(push)
#pragma warning(disable: 4996)
#pragma warning(disable: 4995)
#if _MSC_VER >= 1400
    return _vsnwprintf_l(niz, znakov, format, locale, parametri);
#else
    char *locale_prej;
    T_INT r;

    if (locale) {
        locale_prej = astrdup(setlocale(LC_ALL, NULL));
        setlocale(locale->category, locale->locale);
    } else
        locale_prej = NULL;

    r = _vsnwprintf(niz, znakov, format, parametri);

    if (locale_prej) {
        setlocale(LC_ALL, locale_prej);
        afree(locale_prej);
    }

    return r;
#endif
#pragma warning(pop)
}


inline T_INT asnprintf(T_ASCII niz, T_UINT znakov, TK_ASCII format, T_LOCALE locale, ...)
{
    va_list parametri;
    T_INT r;

    va_start(parametri, locale);
    r = avsnprintf(niz, znakov, format, locale, parametri);
    va_end(parametri);

    return r;
}


inline T_INT asnprintf(T_UNICODE niz, T_UINT znakov, TK_UNICODE format, T_LOCALE locale, ...)
{
    va_list parametri;
    T_INT r;

    va_start(parametri, locale);
    r = avsnprintf(niz, znakov, format, locale, parametri);
    va_end(parametri);

    return r;
}


inline T_INT aascvfprintf(FILE *izhod, HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_KODNASTRAN kodna_stran, T_LOCALE locale, va_list parametri)
{
    TK_UNICODE format;
    T_ASCII format_asc;
    T_UINT znakov, znakov_asc;
    T_INT r;

    znakov = aloadstring(modul, koda, &format, jezik);
    znakov_asc = astrnlen(format, znakov, kodna_stran);
    format_asc = (T_ASCII)aalloc((znakov_asc + 1) * sizeof(T_AZNAK));
    assert(format_asc);
    znakov_asc = astrncpy2(format_asc, znakov_asc, format, znakov, kodna_stran);
    format_asc[znakov_asc] = 0;
#if _MSC_VER >= 1400
    r = _vfprintf_l(izhod, format_asc, locale, parametri);
#else
    {
        char *locale_prej;

        if (locale) {
            locale_prej = astrdup(setlocale(LC_ALL, NULL));
            setlocale(locale->category, locale->locale);
        } else
            locale_prej = NULL;

        r = vfprintf(izhod, format_asc, parametri);

        if (locale_prej) {
            setlocale(LC_ALL, locale_prej);
            afree(locale_prej);
        }
    }
#endif
    afree(format_asc);
    return r;
}


inline T_INT aunivfprintf(FILE *izhod, HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_LOCALE locale, va_list parametri)
{
    TK_UNICODE format;

    verify(aloadstring(modul, koda, &format, jezik));
#if _MSC_VER >= 1400
    return _vfwprintf_l(izhod, format, locale, parametri);
#else
    {
        char *locale_prej;
        T_INT r;

        if (locale) {
            locale_prej = astrdup(setlocale(LC_ALL, NULL));
            setlocale(locale->category, locale->locale);
        } else
            locale_prej = NULL;

        r = vfwprintf(izhod, format, parametri);

        if (locale_prej) {
            setlocale(LC_ALL, locale_prej);
            afree(locale_prej);
        }

        return r;
    }
#endif
}


inline T_INT aascfprintf(FILE *izhod, HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_KODNASTRAN kodna_stran, T_LOCALE locale, ...)
{
    va_list parametri;
    T_INT r;

    va_start(parametri, kodna_stran);
    r = aascvfprintf(izhod, modul, koda, jezik, kodna_stran, locale, parametri);
    va_end(parametri);

    return r;
}


inline T_INT aunifprintf(FILE *izhod, HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_LOCALE locale, ...)
{
    va_list parametri;
    T_INT r;

    va_start(parametri, locale);
    r = aunivfprintf(izhod, modul, koda, jezik, locale, parametri);
    va_end(parametri);

    return r;
}


#ifndef _UNICODE

inline T_INT avfprintf(FILE *izhod, HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_LOCALE locale, va_list parametri)
{
    return aascvfprintf(izhod, modul, koda, jezik, AOSN_PRIVZETI_CP, locale, parametri);
}


inline T_INT afprintf(FILE *izhod, HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_LOCALE locale, ...)
{
    va_list parametri;
    T_INT r;

    va_start(parametri, locale);
    r = aascvfprintf(izhod, modul, koda, jezik, AOSN_PRIVZETI_CP, locale, parametri);
    va_end(parametri);

    return r;
}

#endif


inline T_UINT aloadstringz(HMODULE modul, T_UINT koda, TK_UNICODE *niz, T_KODAJEZIKA2 jezik)
{
    HRSRC izvor;
    HGLOBAL vir;
    TK_UNICODE zaporedje;
    T_UINT i, dolzina;

    *niz = NULL;

#ifdef _WIN32_WCE
    izvor = ::FindResource(modul, MAKEINTRESOURCE((koda>>4)+1), RT_STRING);
#else
    izvor = ::FindResourceEx(modul, RT_STRING, MAKEINTRESOURCE((koda>>4)+1), (WORD)jezik);
#endif
    if (!izvor)
        return 0;

    vir = ::LoadResource(modul, izvor);
    if (!vir)
        return 0;

    zaporedje = (TK_UNICODE)::LockResource(vir);
    if (!zaporedje)
        return 0;

    // zaporedje nizov je sestavljeno iz:
    //   2    bajta  (n0 = dolzina niza 0)
    //   2*n0 bajtov (niz 0 - v unicode brez zakljucitvene nicle)
    //   2    bajta  (n1 = dolzina niza 1)
    //   2*n1 bajtov (niz 1 - v unicode brez zakljucitvene nicle)
    //   .
    //   .
    //   .

    for (i = koda & 0x0f; dolzina = *(zaporedje++), i; i--) {
        // Nizi v virih morajo biti NULL-terminirani (pri prevajanju virov uporabi stikalo /n)!
        assert(!zaporedje[dolzina - 1]);
        zaporedje += dolzina;
    }

    if (!dolzina) {
        ::SetLastError(ERROR_RESOURCE_NAME_NOT_FOUND);
        return 0;
    }

    if (niz)
        *niz = zaporedje;

    ::SetLastError(NO_ERROR);
    return dolzina - 1;
}


inline T_UINT aloadstring(HMODULE modul, T_UINT koda, TK_UNICODE *niz, T_KODAJEZIKA2 jezik)
{
    HRSRC izvor;
    HGLOBAL vir;
    TK_UNICODE zaporedje;
    T_UINT i, dolzina;

    *niz = NULL;

#ifdef _WIN32_WCE
    izvor = ::FindResource(modul, MAKEINTRESOURCE((koda>>4)+1), RT_STRING);
#else
    izvor = ::FindResourceEx(modul, RT_STRING, MAKEINTRESOURCE((koda>>4)+1), (WORD)jezik);
#endif
    if (!izvor)
        return 0;

    vir = ::LoadResource(modul, izvor);
    if (!vir)
        return 0;

    zaporedje = (TK_UNICODE)::LockResource(vir);
    if (!zaporedje)
        return 0;

    // zaporedje nizov je sestavljeno iz:
    //   2    bajta  (n0 = dolzina niza 0)
    //   2*n0 bajtov (niz 0 - v unicode brez zakljucitvene nicle)
    //   2    bajta  (n1 = dolzina niza 1)
    //   2*n1 bajtov (niz 1 - v unicode brez zakljucitvene nicle)
    //   .
    //   .
    //   .

    for (i = koda & 0x0f; dolzina = *(zaporedje++), i; i--)
        zaporedje += dolzina;

    if (!dolzina)
        return 0;

    // Ce so viri prevedeni z /n (nizi imajo dodano zakljucno niclo), odstejemo odvecno niclo.
    if (!zaporedje[dolzina - 1])
        dolzina--;

    if (niz)
        *niz = zaporedje;

    return dolzina;
}


inline T_UINT aloadstring(HMODULE modul, T_UINT koda, T_ASCII niz, T_UINT znakov, T_KODAJEZIKA2 jezik, T_KODNASTRAN kodna_stran)
{
    HRSRC izvor;
    HGLOBAL vir;
    TK_UNICODE zaporedje;
    T_UINT i, dolzina;

#ifdef _WIN32_WCE
    izvor = ::FindResource(modul, MAKEINTRESOURCE((koda>>4)+1), RT_STRING);
#else
    izvor = ::FindResourceEx(modul, RT_STRING, MAKEINTRESOURCE((koda>>4)+1), (WORD)jezik);
#endif
    if (!izvor)
        return 0;

    vir = ::LoadResource(modul, izvor);
    if (!vir)
        return 0;

    zaporedje = (TK_UNICODE)::LockResource(vir);
    if (!zaporedje)
        return 0;

    // Zaporedje nizov je sestavljeno iz:
    //   2    bajta  (n0 = dolina niza 0)
    //   2*n0 bajtov (niz 0 - v unicode brez zakljuitvene nile)
    //   2    bajta  (n1 = dolina niza 1)
    //   2*n1 bajtov (niz 1 - v unicode brez zakljuitvene nile)
    //   .
    //   .
    //   .

    for (i = koda & 0x0f; dolzina = *(zaporedje++), i; i--)
        zaporedje += dolzina;

    if (!dolzina)
        return 0;

    // e so viri prevedeni z /n (nizi imajo dodano zakljuno nilo), odtejemo odveno nilo.
    if (!zaporedje[dolzina - 1])
        dolzina--;

    assert(0); // TODO: Preizkusi ta del kode.
    return astrncpy2(niz, znakov, zaporedje, dolzina, kodna_stran);
}


inline T_UINT aloadstring(HMODULE modul, T_UINT koda, T_UNICODE niz, T_UINT znakov, T_KODAJEZIKA2 jezik)
{
    HRSRC izvor;
    HGLOBAL vir;
    TK_UNICODE zaporedje;
    T_UINT i, dolzina;

#ifdef _WIN32_WCE
    izvor = ::FindResource(modul, MAKEINTRESOURCE((koda>>4)+1), RT_STRING);
#else
    izvor = ::FindResourceEx(modul, RT_STRING, MAKEINTRESOURCE((koda>>4)+1), (WORD)jezik);
#endif
    if (!izvor)
        return 0;

    vir = ::LoadResource(modul, izvor);
    if (!vir)
        return 0;

    zaporedje = (TK_UNICODE)::LockResource(vir);
    if (!zaporedje)
        return 0;

    // Zaporedje nizov je sestavljeno iz:
    //   2    bajta  (n0 = dolina niza 0)
    //   2*n0 bajtov (niz 0 - v unicode brez zakljuitvene nile)
    //   2    bajta  (n1 = dolina niza 1)
    //   2*n1 bajtov (niz 1 - v unicode brez zakljuitvene nile)
    //   .
    //   .
    //   .

    for (i = koda & 0x0f; dolzina = *(zaporedje++), i; i--)
        zaporedje += dolzina;

    if (!dolzina)
        return 0;

    // e so viri prevedeni z /n (nizi imajo dodano zakljuno nilo), odtejemo odveno nilo.
    if (!zaporedje[dolzina - 1])
        dolzina--;

    assert(0); // TODO: Preizkusi ta del kode.
    return astrncpy2(niz, znakov, zaporedje, dolzina);
}


inline T_UINT alangtoiso639(T_KODAJEZIKA2 jezik, T_AZNAK iso639[AOSN_KODA_ISO639_MAX])
{
    assert(iso639);

    T_UINT n = ::GetLocaleInfoA(MAKELCID(jezik, SORT_DEFAULT), LOCALE_SISO639LANGNAME, iso639, AOSN_KODA_ISO639_MAX);
    return n ? n - 1 : 0;
}


inline T_UINT alangtoiso639(T_KODAJEZIKA2 jezik, T_UZNAK iso639[AOSN_KODA_ISO639_MAX])
{
    assert(iso639);

    T_UINT n = ::GetLocaleInfoW(MAKELCID(jezik, SORT_DEFAULT), LOCALE_SISO639LANGNAME, iso639, AOSN_KODA_ISO639_MAX);
    return n ? n - 1 : 0;
}


inline T_UINT alangtoiso3166(T_KODAJEZIKA2 jezik, T_AZNAK iso3166[AOSN_KODA_ISO3166_MAX])
{
    assert(iso3166);

    T_UINT n = ::GetLocaleInfoA(MAKELCID(jezik, SORT_DEFAULT), LOCALE_SISO3166CTRYNAME, iso3166, AOSN_KODA_ISO3166_MAX);
    return n ? n - 1 : 0;
}


inline T_UINT alangtoiso3166(T_KODAJEZIKA2 jezik, T_UZNAK iso3166[AOSN_KODA_ISO3166_MAX])
{
    assert(iso3166);

    T_UINT n = ::GetLocaleInfoW(MAKELCID(jezik, SORT_DEFAULT), LOCALE_SISO3166CTRYNAME, iso3166, AOSN_KODA_ISO3166_MAX);
    return n ? n - 1 : 0;
}


inline T_VOID aobfuscate(T_KAZALEC cilj, TK_KAZALEC izvor, T_SIZE dolzina, T_U1 zrno)
{
    assert(cilj && izvor || !dolzina);

    register T_UINT i;

    for (i = 0; i < dolzina; i++) {
        ((T_U1*)cilj)[i] = ((T_U1*)izvor)[i] ^zrno;
        zrno = (T_U1)(((T_UINT)zrno * 257 + 991) & 0xff);
    }
}


inline RNizA astrtoutf8(TK_ASCII niz, T_UINT koliko, T_KODNASTRAN kodna_stran)
{
    return RNizA::VrniUTF8(niz, koliko, kodna_stran);
}


inline RNizA astrtoutf8(TK_UNICODE niz, T_UINT koliko)
{
    return RNizU::VrniUTF8(niz, koliko);
}


#ifndef AOSN_BREZ_SGML

inline T_VOID html_unescape(RNizA &cilj, TK_ASCII izvor, T_UINT znakov)
{
    cilj.PrilepiSGML(izvor, znakov);
}


inline T_VOID html_unescape(RNizU &cilj, TK_UNICODE izvor, T_UINT znakov)
{
    cilj.PrilepiSGML(izvor, znakov);
}

#endif // AOSN_BREZ_SGML


inline T_VOID html_escape(RNizP<T_AZNAK> &cilj, TK_ASCII izvor, T_UINT znakov)
{
    assert(izvor || !znakov);

    T_UINT i;

    for (i = 0; i < znakov && izvor[i]; i++) {
        switch (izvor[i]) {
            case '&':    cilj += "&amp;";   break;
            case ';':    cilj += "&semi;";  break;
            case '\"':   cilj += "&quot;";  break;
            case '\'':   cilj += "&#x27;";  break;
            case '<':    cilj += "&lt;";    break;
            case '>':    cilj += "&gt;";    break;
            case 0x00a0: cilj += "&nbsp;";  break;  // No-break space moramo zapisovati kot entiteto SGML, sicer ga brskalniki upotevajo, kot navaden presledek
            default:     cilj += izvor[i];  break;
        }
    }
}


inline T_VOID html_escape(RNizP<T_UZNAK> &cilj, TK_UNICODE izvor, T_UINT znakov)
{
    assert(izvor || !znakov);

    T_UINT i;

    for (i = 0; i < znakov && izvor[i]; i++) {
        switch (izvor[i]) {
            case L'&':   cilj += L"&amp;";  break;
            case L';':   cilj += L"&semi;"; break;
            case L'\"':  cilj += L"&quot;"; break;
            case L'\'':  cilj += L"&#x27;"; break;
            case L'<':   cilj += L"&lt;";   break;
            case L'>':   cilj += L"&gt;";   break;
            case 0x00a0: cilj += L"&nbsp;"; break;  // No-break space moramo zapisovati kot entiteto SGML, sicer ga brskalniki upotevajo, kot navaden presledek
            default:     cilj += izvor[i];  break;
        }
    }
}


inline T_VOID html_escape_min(RNizP<T_AZNAK> &cilj, T_AZNAK znak)
{
    switch (znak) {
        case '&':    cilj += "&amp;";  break;
        case '<':    cilj += "&lt;";   break;
        case '>':    cilj += "&gt;";   break;
        case 0x00a0: cilj += "&nbsp;"; break;  // No-break space moramo zapisovati kot entiteto SGML, sicer ga brskalniki upotevajo, kot navaden presledek
        default:     cilj += znak;     break;
    }
}


inline T_VOID html_escape_min(RNizP<T_UZNAK> &cilj, T_UZNAK znak)
{
    switch (znak) {
        case L'&':   cilj += L"&amp;";  break;
        case L'<':   cilj += L"&lt;";   break;
        case L'>':   cilj += L"&gt;";   break;
        case 0x00a0: cilj += L"&nbsp;"; break;  // No-break space moramo zapisovati kot entiteto SGML, sicer ga brskalniki upotevajo, kot navaden presledek
        default:     cilj += znak;      break;
    }
}


inline T_VOID html_escape_min(RNizP<T_AZNAK> &cilj, TK_ASCII izvor, T_UINT znakov)
{
    assert(izvor || !znakov);

    T_UINT i;

    for (i = 0; i < znakov && izvor[i]; i++) {
        switch (izvor[i]) {
            case '&':    cilj += "&amp;";   break;
            case '<':    cilj += "&lt;";    break;
            case '>':    cilj += "&gt;";    break;
            case 0x00a0: cilj += "&nbsp;";  break;  // No-break space moramo zapisovati kot entiteto SGML, sicer ga brskalniki upotevajo, kot navaden presledek
            default:     cilj += izvor[i];  break;
        }
    }
}


inline T_VOID html_escape_min(RNizP<T_UZNAK> &cilj, TK_UNICODE izvor, T_UINT znakov)
{
    assert(izvor || !znakov);

    T_UINT i;

    for (i = 0; i < znakov && izvor[i]; i++) {
        switch (izvor[i]) {
            case L'&':   cilj += L"&amp;";  break;
            case L'<':   cilj += L"&lt;";   break;
            case L'>':   cilj += L"&gt;";   break;
            case 0x00a0: cilj += L"&nbsp;"; break;  // No-break space moramo zapisovati kot entiteto SGML, sicer ga brskalniki upotevajo, kot navaden presledek
            default:     cilj += izvor[i];  break;
        }
    }
}


template <class TIP> inline T_VOID css_unescape(RNizP<TIP> &cilj, const TIP *izvor, T_UINT znakov)
{
    assert(izvor || !znakov);

    T_UINT i;

    for (i = 0; i < znakov && izvor[i];) {
        if (izvor[i] != '\\') {
            // Navadne znake prilepimo na konec niza cilj.
            cilj += izvor[i++];
        } else if (i + 1 < znakov) {
            // Nali smo ubenico.
            i++;

            switch (izvor[i]) {
                // Klasina ubena zaporedja
                case 'n':  cilj += '\n'; i++; break;
                case 'r':  cilj += '\r'; i++; break;
                case 't':  cilj += '\t'; i++; break;

                // Ubenica na koncu vrstice
                case '\n': i++; break;

                // Ubenica s kodo znaka Unicode
                case '0':
                case '1':
                case '2':
                case '3':
                case '4':
                case '5':
                case '6':
                case '7':
                case '8':
                case '9':
                case 'A': case 'a':
                case 'B': case 'b':
                case 'C': case 'c':
                case 'D': case 'd':
                case 'E': case 'e':
                case 'F': case 'f': {
                    T_UZNAK znak = 0;
                    T_UINT konec = amin(znakov, i + 6);

                    // Pretvorimo kodo znaka v znak.
                    for (; i < konec; i++) {
                        if ('0' <= izvor[i] && izvor[i] <= '9')
                            znak = znak * 0x10 + izvor[i] - '0';
                        else if ('A' <= izvor[i] && izvor[i] <= 'F')
                            znak = znak * 0x10 + izvor[i] - 'A' + 10;
                        else if ('a' <= izvor[i] && izvor[i] <= 'f')
                            znak = znak * 0x10 + izvor[i] - 'a' + 10;
                        else
                            break;
                    }

                    // Prilepimo znak na konec niza cilj.
                    cilj += (TIP)znak;

                    if (i < konec && izvor[i] == ' ') {
                        // Presledek za ubenim zaporedjem preskoimo.
                        i++;
                    }

                    break;
                }

                // Druga ubena zaporedja
                default: cilj += izvor[i++];
            }
        }
    }
}


inline T_VOID css_escape(RNizP<T_AZNAK> &cilj, TK_ASCII izvor, T_UINT znakov)
{
    assert(izvor || !znakov);

    T_UINT i;

    for (i = 0; i < znakov && izvor[i]; i++) {
        switch (izvor[i]) {
            case '\\': cilj += "\\\\";   break;
            case '\n': cilj += "\\n";    break;
            case '\r': cilj += "\\r";    break;
            case '\t': cilj += "\\t";    break;
            case '\"': cilj += "\\\"";   break;
            case '\'': cilj += "\\'";    break;
            default:   cilj += izvor[i]; break;
        }
    }
}


inline T_VOID css_escape(RNizP<T_UZNAK> &cilj, TK_UNICODE izvor, T_UINT znakov)
{
    assert(izvor || !znakov);

    T_UINT i;

    for (i = 0; i < znakov && izvor[i]; i++) {
        switch (izvor[i]) {
            case L'\\': cilj += L"\\\\";  break;
            case L'\n': cilj += L"\\n";   break;
            case L'\r': cilj += L"\\r";   break;
            case L'\t': cilj += L"\\t";   break;
            case L'\"': cilj += L"\\\"";  break;
            case L'\'': cilj += L"\\'";   break;
            default:    cilj += izvor[i]; break;
        }
    }
}


//////////////////////////////////////////////////////////////////////
// Predloge funkcij za delo z jeziki
//////////////////////////////////////////////////////////////////////

template <class TIP> inline T_KODAJEZIKA avrnikodojezika(const TIP *iso639)
{
    T_U4 koda;

    if (iso639 && iso639[0]) {
        koda  = atoupper(iso639[0]);
        koda |= atoupper(iso639[1]) << 8;

        if (iso639[2]=='-') {
            koda |= atoupper(iso639[3]) << 16;
            koda |= atoupper(iso639[4]) << 24;
        }
    } else
        koda = KODAJEZIKA_NEZNANA;

    return (T_KODAJEZIKA)koda;
}


template <class TIP> inline T_UINT avrnioznakojezika(T_KODAJEZIKA koda, TIP *iso639)
{
    iso639[0] = (TIP) (koda & 0x000000ff);
    iso639[1] = (TIP)((koda & 0x0000ff00) >> 8);

    if (koda & 0xffff0000) {
        iso639[2] = '-';
        iso639[3] = (TIP)((koda & 0x00ff0000) >> 16);
        iso639[4] = (TIP)((koda & 0xff000000) >> 24);
        iso639[5] = 0;
        return 5;
    } else {
        iso639[2] = 0;
        return 2;
    }
}

//////////////////////////////////////////////////////////////////////
// Funkcije za pisanje dnevnika
//////////////////////////////////////////////////////////////////////

#if defined(_DEBUG) || defined(AOSN_DIAGNOSTIKA)

inline T_UINT adebugPA(T_DNEVNIKPRIORITETA prioriteta, TK_ASCII format, va_list parametri)
{
    // e je prioriteta sporoila dovolj pomembna, ga izpiemo v diagnostino konzolo.
    if (prioriteta <= ADNE_PRIORITETA) {
        T_ASCII buf = NULL;
        T_UINT znakov = 0;
        T_INT zapisano;

        do {
            znakov += 1000;
            buf = (T_ASCII)aqrealloc(buf, znakov*sizeof(T_AZNAK), FALSE);
            assert(buf);

            zapisano = avsnprintf(buf, znakov, format, ADNE_LOCALE, parametri);
        } while (zapisano < 0 || (T_UINT)zapisano == znakov);

        ::OutputDebugStringA(buf);
        afree(buf);

        return zapisano;
    } else
        return 0;
}


inline T_UINT adebugPU(T_DNEVNIKPRIORITETA prioriteta, TK_UNICODE format, va_list parametri)
{
    // e je prioriteta sporoila dovolj pomembna, ga izpiemo v diagnostino konzolo.
    if (prioriteta <= ADNE_PRIORITETA) {
        T_UNICODE buf = NULL;
        T_UINT znakov = 0;
        T_INT zapisano;

        do {
            znakov += 1000;
            buf = (T_UNICODE)aqrealloc(buf, znakov*sizeof(T_UZNAK), FALSE);
            assert(buf);

            zapisano = avsnprintf(buf, znakov, format, ADNE_LOCALE, parametri);
        } while (zapisano < 0 || (T_UINT)zapisano == znakov);

        ::OutputDebugStringW(buf);
        afree(buf);

        return zapisano;
    } else
        return 0;
}


inline T_UINT adebugA(T_DNEVNIKPRIORITETA prioriteta, TK_ASCII format, ...)
{
    T_UINT n;

    va_list seznam;
    va_start(seznam, format);
    n = adebugPA(prioriteta, format, seznam);
    va_end(seznam);

    return n;
}


inline T_UINT adebugU(T_DNEVNIKPRIORITETA prioriteta, TK_UNICODE format, ...)
{
    T_UINT n;

    va_list seznam;
    va_start(seznam, format);
    n = adebugPU(prioriteta, format, seznam);
    va_end(seznam);

    return n;
}


inline T_UINT adebugKPA(T_DNEVNIKPRIORITETA prioriteta, TK_ASCII datoteka, T_UINT vrstica, TK_ASCII format, va_list parametri)
{
    // e je prioriteta sporoila dovolj pomembna, ga izpiemo v diagnostino konzolo.
    if (prioriteta <= ADNE_PRIORITETA) {
        T_ASCII buf = NULL;
        T_UINT znakov = 0, n;
        T_INT zapisano;

        for (;;) {
            znakov += 1000;
            buf = (T_ASCII)aqrealloc(buf, znakov*sizeof(T_AZNAK), FALSE);
            assert(buf);

            zapisano = asnprintf(buf, znakov, "%s(%u): ", ADNE_LOCALE, datoteka, vrstica);
            if (zapisano < 0 || (T_UINT)zapisano == znakov)
                continue;
            n = zapisano;

            zapisano = avsnprintf(buf + n, znakov - n, format, ADNE_LOCALE, parametri);
            if (zapisano < 0 || (T_UINT)zapisano == znakov)
                continue;
            n += zapisano;

            break;
        }

        ::OutputDebugStringA(buf);
        afree(buf);

        return n;
    } else
        return 0;
}


inline T_UINT adebugKPU(T_DNEVNIKPRIORITETA prioriteta, TK_UNICODE datoteka, T_UINT vrstica, TK_UNICODE format, va_list parametri)
{
    // e je prioriteta sporoila dovolj pomembna, ga izpiemo v diagnostino konzolo.
    if (prioriteta <= ADNE_PRIORITETA) {
        T_UNICODE buf = NULL;
        T_UINT znakov = 0, n;
        T_INT zapisano;

        for (;;) {
            znakov += 1000;
            buf = (T_UNICODE)aqrealloc(buf, znakov*sizeof(T_UZNAK), FALSE);
            assert(buf);

            zapisano = asnprintf(buf, znakov, L"%s(%u): ", ADNE_LOCALE, datoteka, vrstica);
            if (zapisano < 0 || (T_UINT)zapisano == znakov)
                continue;
            n = zapisano;

            zapisano = avsnprintf(buf + n, znakov - n, format, ADNE_LOCALE, parametri);
            if (zapisano < 0 || (T_UINT)zapisano == znakov)
                continue;
            n += zapisano;

            break;
        }

        ::OutputDebugStringW(buf);
        afree(buf);

        return n;
    } else
        return 0;
}


inline T_UINT adebugKA (T_DNEVNIKPRIORITETA prioriteta, TK_ASCII datoteka, T_UINT vrstica, TK_ASCII format, ...)
{
    T_UINT n;

    va_list seznam;
    va_start(seznam, format);
    n = adebugKPA(prioriteta, datoteka, vrstica, format, seznam);
    va_end(seznam);

    return n;
}


inline T_UINT adebugKU(T_DNEVNIKPRIORITETA prioriteta, TK_UNICODE datoteka, T_UINT vrstica, TK_UNICODE format, ...)
{
    T_UINT n;

    va_list seznam;
    va_start(seznam, format);
    n = adebugKPU(prioriteta, datoteka, vrstica, format, seznam);
    va_end(seznam);

    return n;
}

#endif // _DEBUG || AOSN_DIAGNOSTIKA


//////////////////////////////////////////////////////////////////////
// Funkcije za delo z vtinicami
//////////////////////////////////////////////////////////////////////

#ifdef AOSN_VTIC

inline T_VTICNICA asocket(T_VTICDOMENA druzina, T_VTICVRSTA tip, T_INT protokol)
{
    return socket(druzina, tip, (int)protokol);
}


inline T_INT aclosesocket(T_VTICNICA vticnica)
{
    return closesocket(vticnica);
}


inline T_INT abind(T_VTICNICA vticnica, const T_SOCKADDR *naslov, T_SIZE dolzina)
{
    assert(dolzina >= 0 && dolzina <= T_INT_MAX);
    return bind(vticnica, naslov, (int)dolzina);
}


inline T_INT alisten(T_VTICNICA vticnica, T_INT stevilo)
{
    if (stevilo == NESKONCNO)
        stevilo = SOMAXCONN;

    return listen(vticnica, (int)stevilo);
}


inline T_VTICNICA aaccept(T_VTICNICA vticnica, T_SOCKADDR *naslov, T_SIZE *dolzina)
{
    return accept(vticnica, naslov, (int*)dolzina);
}


inline T_INT aconnect(T_VTICNICA vticnica, const T_SOCKADDR *naslov, T_SIZE dolzina)
{
    assert(dolzina >= 0 && dolzina <= T_INT_MAX);
    return connect(vticnica, naslov, (int)dolzina);
}


inline T_INT ashutdown(T_VTICNICA vticnica, T_VTICNACINZAPIRANJA kako)
{
    return shutdown(vticnica, kako);
}


inline T_INT arecv(T_VTICNICA vticnica, T_KAZALEC buf, T_SIZE dolzina, T_INT zastavice)
{
    assert(dolzina >= 0 && dolzina <= T_INT_MAX);
    return recv(vticnica, (char*)buf, (int)dolzina, (int)zastavice);
}


inline T_INT arecvfrom(T_VTICNICA vticnica, T_KAZALEC podatki, T_SIZE dolzina, T_INT zastavice, T_SOCKADDR *naslov, T_SIZE *dolzina_naslova)
{
    assert(dolzina >= 0 && dolzina <= T_INT_MAX);
#if defined(_WIN64) || defined(__LP64__)
    if (dolzina_naslova) {
        int r, pom;

        pom = (int)*dolzina_naslova;
        r = recvfrom(vticnica, (char*)podatki, (int)dolzina, (int)zastavice, naslov, &pom);
        *dolzina_naslova = pom;
        return r;
    } else
        return recvfrom(vticnica, (char*)podatki, (int)dolzina, (int)zastavice, naslov, NULL);
#else
    assert(sizeof(int) == sizeof(T_SIZE));
    return recvfrom(vticnica, (char*)podatki, (int)dolzina, (int)zastavice, naslov, (int*)dolzina_naslova);
#endif
}


inline T_INT asend(T_VTICNICA vticnica, TK_KAZALEC podatki, T_SIZE dolzina, T_INT zastavice)
{
    assert(dolzina >= 0 && dolzina <= T_INT_MAX);
    return send(vticnica, (const char*)podatki, (int)dolzina, (int)zastavice);
}


inline T_INT asendto(T_VTICNICA vticnica, TK_KAZALEC podatki, T_SIZE dolzina, T_INT zastavice, const T_SOCKADDR *naslov, T_SIZE dolzina_naslova)
{
    assert(dolzina >= 0 && dolzina <= T_INT_MAX);
    assert(dolzina_naslova >= 0 && dolzina_naslova <= T_INT_MAX);
    return sendto(vticnica, (const char*)podatki, (int)dolzina, (int)zastavice, naslov, (int)dolzina_naslova);
}


inline T_INT agetsockname(T_VTICNICA vticnica, T_SOCKADDR *naslov, T_SIZE *dolzina)
{
    return getsockname(vticnica, naslov, (int*)dolzina);
}


inline T_INT agetpeername(T_VTICNICA vticnica, T_SOCKADDR *naslov, T_SIZE *dolzina)
{
    return getpeername(vticnica, naslov, (int*)dolzina);
}


inline T_INT agetsockopt(T_VTICNICA vticnica, T_VTICNIVOPARAM nivo, T_VTICPARAMETER opcija, T_VOID* vrednost, T_SIZE* dolzina)
{
    return getsockopt(vticnica, nivo, opcija, (char*)vrednost, (int*)dolzina);
}


inline T_INT asetsockopt(T_VTICNICA vticnica, T_VTICNIVOPARAM nivo, T_VTICPARAMETER opcija, TK_KAZALEC vrednost, T_SIZE dolzina)
{
    assert(dolzina >= 0 && dolzina <= T_INT_MAX);
    return setsockopt(vticnica, nivo, opcija, (const char*)vrednost, (int)dolzina);
}


inline T_INT aioctlsocket(T_VTICNICA vticnica, T_INT ukaz, T_UINT *parameter)
{
#if defined(_WIN64) || defined(__LP64__)
    if (parameter) {
        int r;
        u_long pom;

        pom = (u_long)*parameter;
        r = ioctlsocket(vticnica, (long)ukaz, &pom);
        *parameter = pom;
        return r;
    } else
        return ioctlsocket(vticnica, (long)ukaz, NULL);
#else
    assert(sizeof(u_long) == sizeof(T_UINT));
    return ioctlsocket(vticnica, (long)ukaz, (u_long*)parameter);
#endif
}


inline T_INT aselect(T_INT vticnic, T_FDSET *berljive_vticnice, T_FDSET *zapisljive_vticnice, T_FDSET *napacne_vticnice, T_UINT naj_cas)
{
    if (naj_cas == NESKONCNO)
        return select((int)vticnic, berljive_vticnice, zapisljive_vticnice, napacne_vticnice, NULL);
    else {
        struct timeval tv;

        tv.tv_sec  = (long) (naj_cas / 1000);
        tv.tv_usec = (long)((naj_cas % 1000) * 1000);

        return select((int)vticnic, berljive_vticnice, zapisljive_vticnice, napacne_vticnice, &tv);
    }
}


inline T_INT agethostname(T_NIZ ime, T_UINT dolzina)
{
#ifndef _UNICODE
    return gethostname(ime, (int)dolzina);
#else
    T_ASCII _ime = (T_ASCII)aalloc(dolzina);
    T_INT rez = gethostname(_ime, (int)dolzina);
    astrncpy2(ime, dolzina, _ime, dolzina);
    afree(_ime);
    return rez;
#endif
}


inline T_HOSTENT *agethostbyaddr(TK_NIZ naslov, T_UINT dolzina, T_INT tip)
{
#ifndef _UNICODE
    return gethostbyaddr(naslov, (int)dolzina, (int)tip);
#else
    T_ASCII _naslov;
    T_HOSTENT *he;

    dolzina = astrndup2(&_naslov, naslov, dolzina);
    he = gethostbyaddr(_naslov, (int)dolzina, (int)tip);
    afree(_naslov);

    return he;
#endif
}


inline T_HOSTENT *agethostbyname(TK_NIZ ime)
{
#ifndef _UNICODE
    return gethostbyname(ime);
#else
    T_ASCII _ime;
    T_HOSTENT *he;

    astrdup2(&_ime, ime);
    he = gethostbyname(_ime);
    afree(_ime);

    return he;
#endif
}


inline T_PROTOENT *agetprotobynumber(T_INT protokol)
{
    return getprotobynumber((int)protokol);
}


inline T_PROTOENT *agetprotobyname(TK_NIZ ime)
{
#ifndef _UNICODE
    return getprotobyname(ime);
#else
    T_ASCII _ime;
    T_PROTOENT *pe;

    astrdup2(&_ime, ime);
    pe = getprotobyname(_ime);
    afree(_ime);

    return pe;
#endif
}


inline T_SERVENT *agetservbyport(T_INT vrata, TK_NIZ protokol)
{
#ifndef _UNICODE
    return getservbyport((int)vrata, protokol);
#else
    T_ASCII _protokol;
    T_SERVENT *se;

    if (protokol)
        astrdup2(&_protokol, protokol);
    else
        _protokol = NULL;

    se = getservbyport((int)vrata, _protokol);

    if (_protokol) afree(_protokol);

    return se;
#endif
}


inline T_SERVENT *agetservbyname(TK_NIZ ime, TK_NIZ protokol)
{
#ifndef _UNICODE
    return getservbyname(ime, protokol);
#else
    T_ASCII _ime, _protokol;
    T_SERVENT *se;

    astrdup2(&_ime, ime);
    if (protokol)
        astrdup2(&_protokol, protokol);
    else
        _protokol = NULL;

    se = getservbyname(_ime, _protokol);

    if (_protokol) afree(_protokol);
    afree(_ime);

    return se;
#endif
}


inline TK_ASCII ainet_ntoa(const T_INADDR naslov)
{
    return inet_ntoa(naslov);
}


inline T_NIZ ainet_ntoa(const T_INADDR naslov, T_NIZ ime, T_UINT dolzina)
{
    astrncpy2(ime, dolzina, inet_ntoa(naslov), T_UINT_MAX);
    return ime;
}


inline T_U4 ainet_addr(TK_NIZ naslov)
{
#ifndef _UNICODE
    return inet_addr(naslov);
#else
    T_ASCII _naslov;
    T_U4 u;

    astrdup2(&_naslov, naslov);
    u = inet_addr(_naslov);
    afree(_naslov);

    return u;
#endif
}


inline T_U4 ahtonl(T_U4 stevilo)
{
    return htonl(stevilo);
}


inline T_U2 ahtons(T_U2 stevilo)
{
    return htons(stevilo);
}


inline T_U4 antohl(T_U4 stevilo)
{
    return ntohl(stevilo);
}


inline T_U2 antohs(T_U2 stevilo)
{
    return ntohs(stevilo);
}

#endif // AOSN_VTIC


//////////////////////////////////////////////////////////////////////
// Javne funkcije
//////////////////////////////////////////////////////////////////////

namespace AOsn {

#if defined(_DEBUG) || defined(AOSN_DIAGNOSTIKA)

inline T_UINT AOSN_API IzpisiDiagnosticnoSp(TK_ASCII format, T_LOCALE locale, ...)
{
    T_UINT znakov;

    va_list seznam;
    va_start(seznam, locale);
    znakov = IzpisiDiagnosticnoSpP(format, locale, seznam);
    va_end(seznam);

    return znakov;
}


inline T_UINT AOSN_API IzpisiDiagnosticnoSp(TK_UNICODE format, T_LOCALE locale, ...)
{
    T_UINT znakov;

    va_list seznam;
    va_start(seznam, locale);
    znakov = IzpisiDiagnosticnoSpP(format, locale, seznam);
    va_end(seznam);

    return znakov;
}

#endif // _DEBUG || AOSN_DIAGNOSTIKA


inline T_UINT IzpisiO(T_STD_ROCICA izhod, TK_ASCII format, T_LOCALE locale, ...)
{
    T_UINT znakov;

    va_list seznam;
    va_start(seznam, locale);
    znakov = IzpisiOP(izhod, format, locale, seznam);
    va_end(seznam);

    return znakov;
}


inline T_UINT IzpisiO(T_STD_ROCICA izhod, TK_UNICODE format, T_LOCALE locale, ...)
{
    T_UINT znakov;

    va_list seznam;
    va_start(seznam, locale);
    znakov = IzpisiOP(izhod, format, locale, seznam);
    va_end(seznam);

    return znakov;
}


inline T_UINT IzpisiO(T_STD_ROCICA izhod, HMODULE modul, T_UINT koda, T_KODAJEZIKA2 jezik, T_LOCALE locale, ...)
{
    T_UINT znakov;

    va_list seznam;
    va_start(seznam, locale);
    znakov = IzpisiOP(izhod, modul, koda, jezik, locale, seznam);
    va_end(seznam);

    return znakov;
}


#if defined(_WIN64) || defined(__LP64__)

inline T_BOOL JeProcesWOW64()
{
    // Na 64-bitnih platformah je odgovor trivialen.
    return FALSE;
}

#endif


inline LPSAFEARRAY VrniSAFEARRAY(VARTYPE vt, T_UINT polj, T_UINT zapisov, TK_KAZALEC tabela)
{
    LPSAFEARRAY sa;
    T_SIZE dolzina_polja;
    T_KAZALEC p;

    if (polj == 1)
        // e je le eno polje, naredimo vektor.
        sa = ::SafeArrayCreateVector(vt, 0, (ULONG)zapisov);
    else {
        // e je polj ve, naredimo dvodimenzionalno tabelo.
        SAFEARRAYBOUND dim[2] = {
            { (ULONG)polj,    0 },
            { (ULONG)zapisov, 0 }
        };
        sa = ::SafeArrayCreate(vt, 2, dim);
    }

    if (!sa)
        return NULL;

    switch (vt) {
        case VT_UI4:
        case VT_I4:   dolzina_polja = 4; break;
        case VT_UI2:
        case VT_I2:
        case VT_BOOL: dolzina_polja = 2; break;
        case VT_UI1:
        case VT_I1:
        default:      dolzina_polja = 1;
    };

    verify(SUCCEEDED(::SafeArrayAccessData(sa, &p)));
    memcpy(p, tabela, polj * dolzina_polja * zapisov);
    verify(SUCCEEDED(::SafeArrayUnaccessData(sa)));

    return sa;
}


inline HRESULT VrniVBARRAY(VARTYPE vt, TK_KAZALEC tabela, T_UINT polj, T_UINT zapisov, VARIANT *var)
{
    assert(var);

    LPSAFEARRAY sa;
    T_UINT i, n;
    T_U1 *dst, *src;
    T_SIZE deltas, deltad;

    if (polj == 1) {
        // e je le eno polje, naredimo vektor.
        sa = ::SafeArrayCreateVector(VT_VARIANT, 0, (ULONG)zapisov);
        n = zapisov;
    } else {
        // e je polj ve, naredimo dvodimenzionalno tabelo.
        SAFEARRAYBOUND dim[2] = {
            { (ULONG)polj,    0 },
            { (ULONG)zapisov, 0 }
        };
        sa = ::SafeArrayCreate(VT_VARIANT, 2, dim);
        n = polj * zapisov;
    }

    if (!sa)
        return E_OUTOFMEMORY;

    switch (vt) {
        case VT_UI4:
        case VT_I4:   deltas = 4; break;
        case VT_UI2:
        case VT_I2:
        case VT_BOOL: deltas = 2; break;
        case VT_UI1:
        case VT_I1:
        default:      deltas = 1;
    };
    deltad = ::SafeArrayGetElemsize(sa);

    verify(SUCCEEDED(::SafeArrayAccessData(sa, (T_VOID**)&dst)));
    src = (T_U1*)tabela;

    for (i = 0; i < n; i++, src+=deltas, dst+=deltad) {
        VARIANT *v = (VARIANT*)dst;

        // Ne delamo VariantInit, saj SafeArrayCreate(Vector) e sam inicializira vse elemente na 0.
        // VariantInit(v);
        V_VT(v) = vt;
        memcpy(&(v->byref), src, deltas);
    }

    verify(SUCCEEDED(::SafeArrayUnaccessData(sa)));

    verify(SUCCEEDED(::VariantClear(var)));
    V_VT(var) = VT_ARRAY | VT_VARIANT;
    V_ARRAY(var) = sa;
    return S_OK;
}


#pragma warning(push)
#pragma warning(disable: 4127)

template<class T, int polj> inline HRESULT VrniVBARRAY(const T *tabela, T_UINT zapisov, VARIANT *var)
{
    assert(var);

    LPSAFEARRAY sa;
    T_UINT i;
    VARIANT *dst, *dst2;

    if (polj == 1) {
        // e je le eno polje, naredimo vektor.
        sa = ::SafeArrayCreateVector(VT_VARIANT, 0, (ULONG)zapisov);
    } else {
        // e je polj ve, naredimo dvodimenzionalno tabelo.
        SAFEARRAYBOUND dim[2] = {
            { (ULONG)polj,    0 },
            { (ULONG)zapisov, 0 }
        };
        sa = ::SafeArrayCreate(VT_VARIANT, _countof(dim), dim);
    }

    if (!sa)
        return E_OUTOFMEMORY;

    assert(::SafeArrayGetElemsize(sa) == sizeof(VARIANT));

    verify(SUCCEEDED(::SafeArrayAccessData(sa, (T_VOID**)&dst)));
    for (i = 0; i < zapisov; i++) {
        dst2 = &(*dst << tabela[i]);
        assert(dst + polj == dst2);
        dst = dst2;
    }
    verify(SUCCEEDED(::SafeArrayUnaccessData(sa)));

    verify(SUCCEEDED(::VariantClear(var)));
    V_VT(var) = VT_ARRAY | VT_VARIANT;
    V_ARRAY(var) = sa;
    return S_OK;
}

#pragma warning(pop)


inline HRESULT ZakleniVsebinoSAFEARRAY(LPSAFEARRAY sa, T_KAZALEC *podatki, T_SIZE *dolzina)
{
    assert(sa);

    T_KAZALEC p;
    HRESULT hr;

    if (dolzina) {
        T_UINT i, dim;
        LONG ubound, lbound;

        *dolzina = ::SafeArrayGetElemsize(sa);

        // Najprej izraunamo velikost pomnilnika (zmnoimo doline vseh dimenzij z velikostjo elementa).
        dim = ::SafeArrayGetDim(sa);
        for (i = 0; i < dim; i++) {
            if (::SafeArrayGetDim(sa) != 1) return E_INVALIDARG;
            verify(SUCCEEDED(::SafeArrayGetUBound(sa, 1, &ubound)));
            verify(SUCCEEDED(::SafeArrayGetLBound(sa, 1, &lbound)));
            *dolzina *= ubound - lbound + 1;
        }
    }

    // Zaklenemo vsebino tabele.
    hr = ::SafeArrayAccessData(sa, &p);
    if (podatki) *podatki = SUCCEEDED(hr) ? p : NULL;
    return hr;
}


inline HRESULT OdkleniVsebinoSAFEARRAY(LPSAFEARRAY sa)
{
    assert(sa);

    // Odklenemo vsebino tabele.
    return ::SafeArrayUnaccessData(sa);
}


template<class T> inline T_VOID SproziDogodekIDispatch(T *cp, DISPID id, DISPPARAMS *param, LCID locale)
{
    CComPtr<IEnumConnections> e;

    if (SUCCEEDED(cp->EnumConnections(&e))) {
        CONNECTDATA cd;
        while (e->Next(1, &cd, NULL) == S_OK) {
            CComQIPtr<IDispatch> d(cd.pUnk);
            if (d)
                d->Invoke(id, IID_NULL, locale, DISPATCH_METHOD, param, NULL, NULL, NULL);
        }
    }
}


template<class T> inline T_BOOL VrniSkalar(const VARIANT *var, T &dst)
{
    switch (V_VT(var)) {
        case VT_UINT_PTR: dst = (T)V_UINT_PTR(var); break;
        case VT_INT_PTR:  dst = (T)V_INT_PTR(var);  break;
        case VT_UINT:     dst = (T)V_UINT(var);     break;
        case VT_INT:      dst = (T)V_INT(var);      break;
        case VT_UI4:      dst = (T)V_UI4(var);      break;
        case VT_I4:       dst = (T)V_I4(var);       break;
        case VT_UI2:      dst = (T)V_UI2(var);      break;
        case VT_I2:       dst = (T)V_I2(var);       break;
        case VT_UI1:      dst = (T)V_UI1(var);      break;
        case VT_I1:       dst = (T)V_I1(var);       break;
        default:          return FALSE;
    }
    return TRUE;
}


inline T_BOOL VrniLogicnoVrednost(const VARIANT *var, T_BOOL &dst)
{
    switch (V_VT(var)) {
        case VT_BOOL:     dst = V_BOOL(var)     ? TRUE : FALSE; break;
        case VT_UI4:      dst = V_UI4(var)      ? TRUE : FALSE; break;
        case VT_I4:       dst = V_I4(var)       ? TRUE : FALSE; break;
        case VT_UI2:      dst = V_UI2(var)      ? TRUE : FALSE; break;
        case VT_I2:       dst = V_I2(var)       ? TRUE : FALSE; break;
        case VT_UI1:      dst = V_UI1(var)      ? TRUE : FALSE; break;
        case VT_I1:       dst = V_I1(var)       ? TRUE : FALSE; break;
        case VT_UINT:     dst = V_UINT(var)     ? TRUE : FALSE; break;
        case VT_INT:      dst = V_INT(var)      ? TRUE : FALSE; break;
        case VT_UINT_PTR: dst = V_UINT_PTR(var) ? TRUE : FALSE; break;
        case VT_INT_PTR:  dst = V_INT_PTR(var)  ? TRUE : FALSE; break;
        default:          return FALSE;
    }
    return TRUE;
}

} // namespace AOsn


#ifdef AOSN_WAV

//////////////////////////////////////////////////////////////////////
// T_WAV_GLAVA
//////////////////////////////////////////////////////////////////////

template <class TOK> inline TOK& operator <<(TOK &tok, const T_WAV_GLAVA &glava)
{
    if (NEUSPESNO(tok.VrniStanje())) return tok;
    tok << (T_U4)glava.format;

    return tok;
}


template <class TOK> inline TOK& operator >>(TOK &tok, T_WAV_GLAVA &glava)
{
    T_U4 pom4;

    tok >> pom4;
    if (tok.JeKonec()) goto napaka1;
    glava.format = pom4;

    return tok;

napaka1:
    glava.format = 0;

    return tok;
}


//////////////////////////////////////////////////////////////////////
// T_WAV_FORMAT
//////////////////////////////////////////////////////////////////////

template <class TOK> inline TOK& operator <<(TOK &tok, const T_WAV_FORMAT &format)
{
    T_U2 dolzina = (T_U2)format.dodatni_podatki.VrniDolzino();

    if (NEUSPESNO(tok.VrniStanje())) return tok;
    tok << (T_U2)format.zapis;

    if (NEUSPESNO(tok.VrniStanje())) return tok;
    tok << (T_U2)format.st_kanalov;

    if (NEUSPESNO(tok.VrniStanje())) return tok;
    tok << (T_U4)format.vz_frekvenca;

    if (NEUSPESNO(tok.VrniStanje())) return tok;
    tok << (T_U4)format.bajtov_na_sekundo;

    if (NEUSPESNO(tok.VrniStanje())) return tok;
    tok << (T_U2)format.bajtov_na_vzorec;

    if (NEUSPESNO(tok.VrniStanje())) return tok;
    tok << (T_U2)format.bitov_na_kanal;

    if (dolzina) {
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok << (T_U2)dolzina;

        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok.Zapisi(format.dodatni_podatki.VrniPodatke(), dolzina);
    }

    return tok;
}


template <class TOK> inline TOK& operator >>(TOK &tok, T_WAV_FORMAT &format)
{
    T_U4 pom4;
    T_U2 pom2;

    tok >> pom2;
    if (tok.JeKonec()) goto napaka1;
    format.zapis = (T_WAV_FORMAT::ZAPIS)pom2;

    tok >> pom2;
    if (tok.JeKonec()) goto napaka2;
    format.st_kanalov = pom2;

    tok >> pom4;
    if (tok.JeKonec()) goto napaka3;
    format.vz_frekvenca = pom4;

    tok >> pom4;
    if (tok.JeKonec()) goto napaka4;
    format.bajtov_na_sekundo = pom4;

    tok >> pom2;
    if (tok.JeKonec()) goto napaka5;
    format.bajtov_na_vzorec = pom2;

    tok >> pom2;
    if (tok.JeKonec()) goto napaka6;
    format.bitov_na_kanal = pom2;

    tok >> pom2;
    if (tok.JeKonec() || !pom2) goto napaka7;
    format.dodatni_podatki.Prestavi(0);
    format.dodatni_podatki.ZapisiTok(tok, pom2);
    if (NEUSPESNO(tok.VrniStanje())) goto napaka7;
    verify(USPESNO(format.dodatni_podatki.PostaviKonec()));

    return tok;

napaka1:
    format.zapis = T_WAV_FORMAT::ZAPIS_NEZNAN;
napaka2:
    format.st_kanalov = 0;
napaka3:
    format.vz_frekvenca = 0;
napaka4:
    format.bajtov_na_sekundo = 0;
napaka5:
    format.bajtov_na_vzorec = 0;
napaka6:
    format.bitov_na_kanal = 0;
napaka7:
    format.dodatni_podatki.Prestavi(0);
    verify(USPESNO(format.dodatni_podatki.PostaviKonec()));

    return tok;
}


//////////////////////////////////////////////////////////////////////
// T_WAV_PODATKI
//////////////////////////////////////////////////////////////////////

template <class TOK> inline TOK& operator <<(TOK &tok, const T_WAV_PODATKI &podatki)
{
    // Zapiemo podatke.
    if (NEUSPESNO(tok.VrniStanje())) return tok;
    tok.Zapisi(podatki.podatki.VrniPodatke(), (T_SIZE)podatki.podatki.VrniDolzino());

    return tok;
}


template <class TOK> inline TOK& operator >>(TOK &tok, T_WAV_PODATKI &podatki)
{
    // Preberemo podatke.
    podatki.podatki.Prestavi(0);
    podatki.podatki.ZapisiTok(tok);
    verify(USPESNO(podatki.podatki.PostaviKonec()));

    return tok;
}


//////////////////////////////////////////////////////////////////////
// T_WAV_TISINA
//////////////////////////////////////////////////////////////////////

template <class TOK> inline TOK& operator <<(TOK &tok, const T_WAV_TISINA &tisina)
{
    if (NEUSPESNO(tok.VrniStanje())) return tok;
    tok << (T_U4)tisina.dolzina;

    return tok;
}


template <class TOK> inline TOK& operator >>(TOK &tok, T_WAV_TISINA &tisina)
{
    T_U4 pom4;

    tok >> pom4;
    if (tok.JeKonec()) goto napaka1;
    tisina.dolzina = pom4;

    return tok;

napaka1:
    tisina.dolzina = 0;

    return tok;
}


//////////////////////////////////////////////////////////////////////
// T_WAV_OZNAKA
//////////////////////////////////////////////////////////////////////

namespace AOsn {

inline T_INT WavPrimerjajOznakiPoID(const T_WAV_OZNAKA &a, const T_WAV_OZNAKA &b)
{
    if (a.id < b.id) return -1;
    else if (a.id > b.id) return 1;
    else return 0;
}


inline T_INT WavPrimerjajOznakiPoCasu(const T_WAV_OZNAKA &a, const T_WAV_OZNAKA &b)
{
    if (a.vzorec < b.vzorec) return -1;
    else if (a.vzorec > b.vzorec) return 1;
    else return 0;
}

} // namespace AOsn


//////////////////////////////////////////////////////////////////////
// T_WAV_OZNAKA_EX
//////////////////////////////////////////////////////////////////////

inline T_WAV_OZNAKA_EX::T_WAV_OZNAKA_EX()
{
    memset((T_WAV_OZNAKA*)this, 0, sizeof(T_WAV_OZNAKA));
    dolzina     = 0;
    id_namena   = 0;
    drzava      = 0;
    jezik       = 0;
    narecje     = 0;
    kodna_stran = 0;
}


inline const T_WAV_OZNAKA_EX& T_WAV_OZNAKA_EX::operator =(const T_WAV_OZNAKA_EX &oznaka)
{
    memcpy((T_WAV_OZNAKA*)this, (T_WAV_OZNAKA*)&oznaka, sizeof(T_WAV_OZNAKA));
    dolzina     = oznaka.dolzina;
    id_namena   = oznaka.id_namena;
    drzava      = oznaka.drzava;
    jezik       = oznaka.jezik;
    narecje     = oznaka.narecje;
    kodna_stran = oznaka.kodna_stran;
    opis        = oznaka.opis;
    naslov      = oznaka.naslov;
    opomba      = oznaka.opomba;

    return *this;
}


namespace AOsn {

inline T_INT WavPrimerjajOznakiExPoID(const T_WAV_OZNAKA_EX &a, const T_WAV_OZNAKA_EX &b)
{
    if (a.id < b.id) return -1;
    else if (a.id > b.id) return 1;
    else return 0;
}


inline T_INT WavPrimerjajOznakiExPoCasu(const T_WAV_OZNAKA_EX &a, const T_WAV_OZNAKA_EX &b)
{
    if (a.vzorec < b.vzorec) return -1;
    else if (a.vzorec > b.vzorec) return 1;
    else return 0;
}

} // namespace AOsn


//////////////////////////////////////////////////////////////////////
// T_WAV_TABELA_OZNAK
//////////////////////////////////////////////////////////////////////

template <class TOK> inline TOK& operator <<(TOK &tok, const T_WAV_TABELA_OZNAK &oznake)
{
    T_UINT st_oznak = oznake.oznake.VrniStevilo();

    assert(st_oznak < T_U4_MAX);

    // Zapiemo tevilo oznak.
    if (NEUSPESNO(tok.VrniStanje())) return tok;
    tok << (T_U4)st_oznak;

    // Zapiemo oznake.
    if (NEUSPESNO(tok.VrniStanje())) return tok;
    tok.ZapisiTab(oznake.oznake.Vrni(), sizeof(T_WAV_OZNAKA), st_oznak);

    return tok;
}


template <class TOK> inline TOK& operator >>(TOK &tok, T_WAV_TABELA_OZNAK &oznake)
{
    T_U4 st_oznak;
    T_UINT prebranih;
    T_WAV_OZNAKA *p;

    // Preberemo tevilo oznak.
    tok >> st_oznak;
    if (tok.JeKonec()) goto napaka1;

    // Preberemo oznake.
    p = oznake.oznake.Odpusti(st_oznak, FALSE);
    if (p) {
        prebranih = tok.PreberiTab(p, sizeof(T_WAV_OZNAKA), st_oznak);
        oznake.oznake.Uporabi(p, prebranih, FALSE);
        if (tok.JeKonec()) return tok;
    } else {
        assert(0); // TODO: Preizkusi ta del kode.

        // Zmanjkalo je pomnilnika.
        oznake.oznake.Uporabi(p, 0, FALSE);
        tok.NastaviStanje(AOSN_NAPAKA_POMNILNIK);
        return tok;
    }

    return tok;

napaka1:
    oznake.oznake.Sprazni();

    return tok;
}


//////////////////////////////////////////////////////////////////////
// T_WAV_LTXT
//////////////////////////////////////////////////////////////////////

template <class TOK> inline TOK& operator <<(TOK &tok, const T_WAV_LTXT &ltxt)
{
    T_UINT dolzina;

    if (NEUSPESNO(tok.VrniStanje())) return tok;
    tok << (T_U4)ltxt.id;

    if (NEUSPESNO(tok.VrniStanje())) return tok;
    tok << (T_U4)ltxt.dolzina;

    if (NEUSPESNO(tok.VrniStanje())) return tok;
    tok << (T_U4)ltxt.id_namena;

    if (NEUSPESNO(tok.VrniStanje())) return tok;
    tok << (T_U2)ltxt.drzava;

    if (NEUSPESNO(tok.VrniStanje())) return tok;
    tok << (T_U2)ltxt.jezik;

    if (NEUSPESNO(tok.VrniStanje())) return tok;
    tok << (T_U2)ltxt.narecje;

    if (NEUSPESNO(tok.VrniStanje())) return tok;
    tok << (T_U2)ltxt.kodna_stran;

    dolzina = ltxt.opis.VrniDolzino();
    if (dolzina) {
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok.ZapisiTab(ltxt.opis.Vrni(), sizeof(T_AZNAK), dolzina);
        tok << (T_AZNAK)0;
    }

    return tok;
}


template <class TOK> inline TOK& operator >>(TOK &tok, T_WAV_LTXT &ltxt)
{
    T_U4 pom4;
    T_U2 pom2;
    T_ASCII p;
    T_SIZE dolzina;

    tok >> pom4;
    if (tok.JeKonec()) goto napaka1;
    ltxt.id = pom4;

    tok >> pom4;
    if (tok.JeKonec()) goto napaka2;
    ltxt.dolzina = pom4;

    tok >> pom4;
    if (tok.JeKonec()) goto napaka3;
    ltxt.id_namena = pom4;

    tok >> pom2;
    if (tok.JeKonec()) goto napaka4;
    ltxt.drzava = pom2;

    tok >> pom2;
    if (tok.JeKonec()) goto napaka5;
    ltxt.jezik = pom2;

    tok >> pom2;
    if (tok.JeKonec()) goto napaka6;
    ltxt.narecje = pom2;

    tok >> pom2;
    if (tok.JeKonec()) goto napaka7;
    ltxt.kodna_stran = pom2;

    // V ostanku toka je opis.
    dolzina = tok.PreberiOstanek((T_VOID*&)p);
    if (!p) goto napaka8;
    ltxt.opis.Uporabi(p, dolzina);

    return tok;

napaka1:
    ltxt.id = 0;
napaka2:
    ltxt.dolzina = 0;
napaka3:
    ltxt.id_namena = 0;
napaka4:
    ltxt.drzava = 0;
napaka5:
    ltxt.jezik = 0;
napaka6:
    ltxt.narecje = 0;
napaka7:
    ltxt.kodna_stran = 0;
napaka8:
    ltxt.opis.Sprazni();

    return tok;
}


//////////////////////////////////////////////////////////////////////
// T_WAV_NASLOV
//////////////////////////////////////////////////////////////////////

template <class TOK> inline TOK& operator <<(TOK &tok, const T_WAV_NASLOV &naslov)
{
    T_UINT dolzina;

    if (NEUSPESNO(tok.VrniStanje())) return tok;
    tok << (T_U4)naslov.id;

    dolzina = naslov.naslov.VrniDolzino();
    if (dolzina) {
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok.ZapisiTab(naslov.naslov.Vrni(), sizeof(T_AZNAK), dolzina);
        tok << (T_AZNAK)0;
    }

    return tok;
}


template <class TOK> inline TOK& operator >>(TOK &tok, T_WAV_NASLOV &naslov)
{
    T_U4 pom4;
    T_ASCII p;
    T_SIZE dolzina;

    tok >> pom4;
    if (tok.JeKonec()) goto napaka1;
    naslov.id = pom4;

    // V ostanku toka je naslov.
    dolzina = tok.PreberiOstanek((T_VOID*&)p);
    if (!p) goto napaka2;
    naslov.naslov.Uporabi(p, dolzina);

    return tok;

napaka1:
    naslov.id = 0;
napaka2:
    naslov.naslov.Sprazni();

    return tok;
}


//////////////////////////////////////////////////////////////////////
// T_WAV_OPOMBA
//////////////////////////////////////////////////////////////////////

template <class TOK> inline TOK& operator <<(TOK &tok, const T_WAV_OPOMBA &opomba)
{
    T_UINT dolzina;

    if (NEUSPESNO(tok.VrniStanje())) return tok;
    tok << (T_U4)opomba.id;

    dolzina = opomba.opomba.VrniDolzino();
    if (dolzina) {
        if (NEUSPESNO(tok.VrniStanje())) return tok;
        tok.ZapisiTab(opomba.opomba.Vrni(), sizeof(T_AZNAK), dolzina);
        tok << (T_AZNAK)0;
    }

    return tok;
}


template <class TOK> inline TOK& operator >>(TOK &tok, T_WAV_OPOMBA &opomba)
{
    T_U4 pom4;
    T_ASCII p;
    T_SIZE dolzina;

    tok >> pom4;
    if (tok.JeKonec()) goto napaka1;
    opomba.id = pom4;

    // V ostanku toka je opomba.
    dolzina = tok.PreberiOstanek((T_VOID*&)p);
    if (!p) goto napaka2;
    opomba.opomba.Uporabi(p, dolzina);

    return tok;

napaka1:
    opomba.id = 0;
napaka2:
    opomba.opomba.Sprazni();

    return tok;
}


//////////////////////////////////////////////////////////////////////
// T_WAV_TABELA_OZNAK_EX
//////////////////////////////////////////////////////////////////////

template <class TOK> inline TOK& operator <<(TOK &dat, const T_WAV_TABELA_OZNAK_EX &oznake)
{
    T_ODMIK zacetek;
    T_UINT i, st_oznak;

    // Odpremo glavo za oznake.
    zacetek = _OdpriGlavo<T_WAV_ID, T_WAV_DOLZINA>(dat, T_WAV_OZNAKE_ID::id);

    // Zapiemo tevilo oznak.
    st_oznak = oznake.oznake.VrniStevilo();
    assert(st_oznak < T_U4_MAX);
    if (NEUSPESNO(dat.VrniStanje())) return dat;
    dat << (T_U4)st_oznak;

    // Zapiemo vse oznake.
    for (i = 0; i < st_oznak; i++) {
        if (NEUSPESNO(dat.VrniStanje())) return dat;
        dat.ZapisiTab((T_WAV_OZNAKA*)&oznake.oznake[i], sizeof(T_WAV_OZNAKA), 1);
    }

    // Zapremo glavo za oznake.
    _ZapriGlavo<T_WAV_ID, T_WAV_DOLZINA, WAV_PORAVNAVA>(dat, zacetek);

    // Odpremo glavo za seznam.
    zacetek = _OdpriGlavo<T_WAV_ID, T_WAV_DOLZINA>(dat, T_WAV_SEZNAM_ID::id);

    // Seznam bo vrste "adtl".
    if (NEUSPESNO(dat.VrniStanje())) return dat;
    dat << *(const T_WAV_ID*)"adtl";

    for (i = 0; i < st_oznak; i++) {
        T_WAV_OZNAKA_EX &oznaka = oznake.oznake[i];
        T_WAV_LTXT ltxt;

        // Zapiemo oznako ltxt.
        ltxt.id          = oznaka.id;
        ltxt.dolzina     = oznaka.dolzina;
        ltxt.id_namena   = oznaka.id_namena;
        ltxt.drzava      = oznaka.drzava;
        ltxt.jezik       = oznaka.jezik;
        ltxt.narecje     = oznaka.narecje;
        ltxt.kodna_stran = oznaka.kodna_stran;
        ltxt.opis        = oznaka.opis;

        if (NEUSPESNO(dat.VrniStanje())) return dat;
        dat << T_WAV_LTXT_ID(ltxt);

        if (!oznaka.naslov.JePrazen()) {
            T_WAV_NASLOV naslov;

            // Zapiemo oznako labl.
            naslov.id     = oznaka.id;
            naslov.naslov = oznaka.naslov;

            if (NEUSPESNO(dat.VrniStanje())) return dat;
            dat << T_WAV_NASLOV_ID(naslov);
        }

        if (!oznaka.opomba.JePrazen()) {
            // Zapiemo oznako note.
            T_WAV_OPOMBA opomba;

            opomba.id     = oznaka.id;
            opomba.opomba = oznaka.opomba;

            if (NEUSPESNO(dat.VrniStanje())) return dat;
            dat << T_WAV_OPOMBA_ID(opomba);
        }
    }

    // Zapremo glavo za dodatne podatke.
    _ZapriGlavo<T_WAV_ID, T_WAV_DOLZINA, WAV_PORAVNAVA>(dat, zacetek);

    return dat;
}


//////////////////////////////////////////////////////////////////////
// Predloge in funkcije za delo z datotekami WAV
//////////////////////////////////////////////////////////////////////

namespace AOsn {

template <class TIP> inline T_STANJE WavNajdiPrviBlok(RDatoteka &dat, T_WAV_ID dodatni_id, T_ODMIK konec_bloka, T_ODMIK *konec_najdenega_bloka)
{
    T_STANJE stanje;

    while (dat.VrniOdmik() < konec_bloka) {
        stanje = T_IDPODATKI<TIP, T_WAV_ID, T_WAV_DOLZINA, WAV_PORAVNAVA>::NajdiGlavo(dat, konec_bloka);
        if (USPESNO(stanje)) {
            T_WAV_DOLZINA dolzina;
            T_WAV_ID id;
            T_ODMIK konec_bloka;

            // Preberemo dolino elementa.
            dat >> dolzina;
            stanje = dat.VrniStanje();
            if (NEUSPESNO(stanje)) return stanje;

            // Izraunamo, kje bo konec bloka.
            konec_bloka = dat.VrniOdmik() + dolzina;

            // Preberemo dodatni id.
            dat >> id;
            stanje = dat.VrniStanje();
            if (NEUSPESNO(stanje)) return stanje;

            if (id == dodatni_id) {
                // Nali smo eleni blok.
                if (konec_najdenega_bloka) *konec_najdenega_bloka = konec_bloka;
                return A_OK;
            }

            // Blok smo nali, vendar je dodatni ID drugaen.
            // Preskoimo na naslednji blok.
            konec_bloka += (WAV_PORAVNAVA - konec_bloka) % WAV_PORAVNAVA;
            dat.Prestavi(konec_bloka);
        } else {
            // Bloka nismo nali.
            return stanje;
        }
    }

    return AOSN_NAPAKA_KONEC_TOKA;
}


template <class TIP> inline T_STANJE WavPreberiPrviBlok<TIP>(RDatoteka &dat, TIP &podatki, T_ODMIK konec_bloka)
{
    T_STANJE stanje;

    // Poiemo blok fmt.
    stanje = T_IDPODATKI<TIP, T_WAV_ID, T_WAV_DOLZINA, WAV_PORAVNAVA>::NajdiGlavo(dat, konec_bloka);
    if (NEUSPESNO(stanje)) return stanje;

    // Preberemo podatke.
    dat >> T_IDPODATKI<TIP, T_WAV_ID, T_WAV_DOLZINA, WAV_PORAVNAVA>(podatki);
    stanje = dat.VrniStanje();
    if (NEUSPESNO(stanje)) return stanje;

    return A_OK;
}


inline T_STANJE WavNajdiVsebino(RDatoteka &dat, T_ODMIK konec_bloka, T_ODMIK *konec_vsebine)
{
    return WavNajdiPrviBlok<T_WAV_GLAVA>(dat, T_WAV_WAVE_ID::id, konec_bloka, konec_vsebine);
}

} // namespace AOsn

#endif // AOSN_WAV


//////////////////////////////////////////////////////////////////////
// Zasebne funkcije in predloge funkcij
//////////////////////////////////////////////////////////////////////

template <class TOK, class TIP> inline TOK& _Zapisi(TOK &tok, const TIP podatek)
{
#ifdef RDAT_NE_PREVERJAJ_STANJA_VER
    assert(USPESNO(tok.VrniStanje()));
#else
    if (NEUSPESNO(tok.VrniStanje())) return tok;
#endif

#ifdef DEBELEJSI_KONEC_VER
    TIP pod = _HE2LE(podatek);
    tok.Zapisi(&pod, sizeof(TIP));
#else
    tok.Zapisi(&podatek, sizeof(TIP));
#endif // DEBELEJSI_KONEC_VER

    return tok;
}


template <class TIP> inline RPomDatoteka& _Zapisi(RPomDatoteka &tok, const TIP podatek)
{
#ifdef RDAT_NE_PREVERJAJ_STANJA_VER
    assert(USPESNO(tok.VrniStanje()));
#else
    if (NEUSPESNO(tok.VrniStanje())) return tok;
#endif

    T_SIZE zeljeno = tok.odmik + sizeof(TIP);
    if (zeljeno > tok.fiz_dolzina && NEUSPESNO(tok.RezervirajDolzino(zeljeno)))
        return tok;

    (*(TIP*)(tok.podatki + tok.odmik)) = _HE2LE(podatek);
    tok.odmik += sizeof(TIP);
    if (tok.odmik > tok.dolzina) tok.dolzina = tok.odmik;
    tok.stanje = A_OK;

#ifdef RDAT_BELEZI_CAS_DOSTOPA_VER
    tok.datum_dostopa = tok.datum_pisanja = RDatum::VrniTrenutniCas();
#endif

    return tok;
}


template <class TOK, class TIP> inline TOK& _Preberi(TOK &tok, TIP &podatek)
{
    tok.PreberiTab(&podatek, sizeof(TIP), 1);
#ifdef RDAT_NE_PREVERJAJ_STANJA_VER
    assert(USPESNO(tok.VrniStanje()));
#else
    if (NEUSPESNO(tok.VrniStanje())) return tok;
#endif
    _LE2HE(&podatek);

    return tok;
}


template <class TIP> inline RPomDatoteka& _Preberi(RPomDatoteka &tok, TIP &podatek)
{
#ifdef RDAT_NE_PREVERJAJ_EOF_VER
    assert(tok.odmik + sizeof(TIP) <= tok.dolzina);
#else
    if (tok.odmik + sizeof(TIP) <= tok.dolzina)
#endif
    {
        podatek = _LE2HE(*(TIP*)(tok.podatki + tok.odmik));

        tok.odmik += sizeof(TIP);
        tok.stanje = A_OK;
#ifndef RDAT_NE_PREVERJAJ_EOF_VER
    } else {
        tok.odmik = tok.dolzina;
        tok.stanje = AOSN_NAPAKA_KONEC_TOKA;
#endif
    }

#ifdef RDAT_BELEZI_CAS_DOSTOPA_VER
    tok.datum_dostopa = RDatum::VrniTrenutniCas();
#endif

    return tok;
}


template <class TIP> inline T_VOID _Vrni(RPomDatoteka &dat, T_ODMIK odmik, TIP &podatek)
{
    assert(odmik + sizeof(TIP) < dat.dolzina);
    podatek = _LE2HE(*(TIP*)(dat.podatki + odmik));
#ifdef RDAT_BELEZI_CAS_DOSTOPA_VER
    dat.datum_dostopa = RDatum::VrniTrenutniCas();
#endif
}


template <class TIP> inline T_VOID _Nastavi(RPomDatoteka &dat, T_ODMIK odmik, const TIP podatek)
{
    assert(odmik + sizeof(TIP) < dat.dolzina);
    (*(TIP*)(dat.podatki + odmik)) = _HE2LE(podatek);
#ifdef RDAT_BELEZI_CAS_DOSTOPA_VER
    dat.datum_dostopa = dat.datum_pisanja = RDatum::VrniTrenutniCas();
#endif
}


template <class TOK> inline TOK& _ZapisiNiz(TOK &tok, TK_ASCII podatek)
{
    T_U4 znakov = (T_U4)astrlen(podatek);

    _Zapisi(tok, znakov);

    if (NEUSPESNO(tok.VrniStanje())) return tok;
    tok.ZapisiTab(podatek, sizeof(T_AZNAK), znakov);

    return tok;
}


template <class TOK> inline TOK& _ZapisiNiz(TOK &tok, TK_UNICODE podatek)
{
    T_U4 znakov = (T_U4)astrlen(podatek);

    _Zapisi(tok, znakov);

    if (NEUSPESNO(tok.VrniStanje())) return tok;
    tok.ZapisiTab(podatek, sizeof(T_UZNAK), znakov);

    return tok;
}


inline RPomDatoteka& _ZapisiNiz(RPomDatoteka &tok, TK_ASCII podatek)
{
    // TODO: Preizkusi ta del kode.
    assert(0);

    if (NEUSPESNO(tok.stanje)) return tok;

    T_UINT znakov = astrlen(podatek);
    T_SIZE bajtov = sizeof(T_U4) + znakov * sizeof(T_AZNAK);
    T_SIZE zeljeno = tok.odmik + bajtov;
    if (zeljeno > tok.fiz_dolzina && NEUSPESNO(tok.RezervirajDolzino(zeljeno)))
        return tok;

    T_U1 *p = tok.podatki + tok.odmik;

    *(T_U4*)p = _HE2LE((T_U4)znakov);
    p += sizeof(T_U4);

    astrncpy2((T_ASCII)p, znakov, podatek, T_UINT_MAX);

    tok.odmik += bajtov;
    if (tok.odmik > tok.dolzina) tok.dolzina = tok.odmik;
    tok.stanje = A_OK;

#ifdef RDAT_BELEZI_CAS_DOSTOPA_VER
    tok.datum_dostopa = tok.datum_pisanja = RDatum::VrniTrenutniCas();
#endif

    return tok;
}


inline RPomDatoteka& _ZapisiNiz(RPomDatoteka &tok, TK_UNICODE podatek)
{
    if (NEUSPESNO(tok.stanje)) return tok;

    T_UINT znakov = astrlen(podatek);
    T_SIZE bajtov = sizeof(T_U4) + znakov * sizeof(T_UZNAK);
    T_SIZE zeljeno = tok.odmik + bajtov;
    if (zeljeno > tok.fiz_dolzina && NEUSPESNO(tok.RezervirajDolzino(zeljeno)))
        return tok;

    T_U1 *p = tok.podatki + tok.odmik;

    *(T_U4*)p = _HE2LE((T_U4)znakov);
    p += sizeof(T_U4);

    astrncpy2((T_UNICODE)p, znakov, podatek, T_UINT_MAX);

    tok.odmik += bajtov;
    if (tok.odmik > tok.dolzina) tok.dolzina = tok.odmik;
    tok.stanje = A_OK;

#ifdef RDAT_BELEZI_CAS_DOSTOPA_VER
    tok.datum_dostopa = tok.datum_pisanja = RDatum::VrniTrenutniCas();
#endif

    return tok;
}


template <class TOK> inline TOK& _PreberiNiz(TOK &tok, RNizP<T_AZNAK> &podatek)
{
    T_U4 znakov;

    _Preberi(tok, znakov);
    if (NEUSPESNO(tok.VrniStanje())) return tok;

    T_ASCII niz = podatek.Odpusti(znakov, FALSE);
    podatek.Uporabi(niz, tok.PreberiTab(niz, sizeof(T_AZNAK), znakov), FALSE);

    return tok;
}


template <class TOK> inline TOK& _PreberiNiz(TOK &tok, RNizP<T_UZNAK> &podatek)
{
    T_U4 znakov;

    _Preberi(tok, znakov);
    if (NEUSPESNO(tok.VrniStanje())) return tok;

    T_UNICODE niz = podatek.Odpusti(znakov, FALSE);
    podatek.Uporabi(niz, tok.PreberiTab(niz, sizeof(T_UZNAK), znakov), FALSE);

    return tok;
}


inline RPomDatoteka& _PreberiNiz(RPomDatoteka &tok, RNizP<T_AZNAK> &podatek)
{
    // TODO: Preizkusi ta del kode.
    assert(0);

#ifdef RDAT_NE_PREVERJAJ_EOF_VER
    assert(tok.odmik + sizeof(T_U4) <= tok.dolzina);
#else
    if (tok.odmik + sizeof(T_U4) <= tok.dolzina)
#endif
    {
        T_U4 znakov = _LE2HE(*(T_U4*)(tok.podatki + tok.odmik));
        tok.odmik += sizeof(T_U4);

#ifdef RDAT_NE_PREVERJAJ_EOF_VER
        assert(tok.odmik + znakov * sizeof(T_AZNAK) <= tok.dolzina);
#else
        if (tok.odmik + znakov * sizeof(T_AZNAK) <= tok.dolzina)
#endif
        {
            podatek.Nastavi((T_ASCII)(tok.podatki + tok.odmik), znakov);
            tok.odmik += znakov * sizeof(T_AZNAK);

#ifndef RDAT_NE_PREVERJAJ_EOF_VER
            tok.stanje = A_OK;
        } else {
            tok.odmik = tok.dolzina;
            tok.stanje = AOSN_NAPAKA_KONEC_TOKA;
#endif
        }
#ifndef RDAT_NE_PREVERJAJ_EOF_VER
    } else {
        tok.odmik = tok.dolzina;
        tok.stanje = AOSN_NAPAKA_KONEC_TOKA;
#endif
    }

#ifdef RDAT_BELEZI_CAS_DOSTOPA_VER
    tok.datum_dostopa = RDatum::VrniTrenutniCas();
#endif

    return tok;
}


inline RPomDatoteka& _PreberiNiz(RPomDatoteka &tok, RNizP<T_UZNAK> &podatek)
{
#ifdef RDAT_NE_PREVERJAJ_EOF_VER
    assert(tok.odmik + sizeof(T_U4) <= tok.dolzina);
#else
    if (tok.odmik + sizeof(T_U4) <= tok.dolzina)
#endif
    {
        T_U4 znakov = _LE2HE(*(T_U4*)(tok.podatki + tok.odmik));
        tok.odmik += sizeof(T_U4);

#ifdef RDAT_NE_PREVERJAJ_EOF_VER
        assert(tok.odmik + znakov * sizeof(T_UZNAK) <= tok.dolzina);
#else
        if (tok.odmik + znakov * sizeof(T_UZNAK) <= tok.dolzina)
#endif
        {
            podatek.Nastavi((T_UNICODE)(tok.podatki + tok.odmik), znakov);
            tok.odmik += znakov * sizeof(T_UZNAK);

#ifndef RDAT_NE_PREVERJAJ_EOF_VER
            tok.stanje = A_OK;
        } else {
            tok.odmik = tok.dolzina;
            tok.stanje = AOSN_NAPAKA_KONEC_TOKA;
#endif
        }
#ifndef RDAT_NE_PREVERJAJ_EOF_VER
    } else {
        tok.odmik = tok.dolzina;
        tok.stanje = AOSN_NAPAKA_KONEC_TOKA;
#endif
    }

#ifdef RDAT_BELEZI_CAS_DOSTOPA_VER
    tok.datum_dostopa = RDatum::VrniTrenutniCas();
#endif

    return tok;
}


inline T_VOID _UrediOktete(T_U2 *podatek)
{
    assert(podatek);

    T_U2 t = (T_U2)((*podatek) << 8);
    (*podatek) >>= 8;
    (*podatek) |= t;
}

inline T_VOID _UrediOktete(T_U4 *podatek)
{
    T_U4 t;

    t  = (T_U4)((*podatek) << 24);
    t |= (T_U4)((*podatek) << 8) & 0x00ff0000;
    t |= (T_U4)((*podatek) >> 8) & 0x0000ff00;
    t |= (T_U4)((*podatek) >> 24);

    (*podatek) = t;
}

inline T_VOID _UrediOktete(T_U8 *podatek)
{
    T_U8 t;

    t  = (T_U8)((*podatek) << 56);
    t |= (T_U8)((*podatek) << 40) & 0x00ff000000000000;
    t |= (T_U8)((*podatek) << 24) & 0x0000ff0000000000;
    t |= (T_U8)((*podatek) << 8)  & 0x000000ff00000000;
    t |= (T_U8)((*podatek) >> 8)  & 0x00000000ff000000;
    t |= (T_U8)((*podatek) >> 24) & 0x0000000000ff0000;
    t |= (T_U8)((*podatek) >> 40) & 0x000000000000ff00;
    t |= (T_U8)((*podatek) >> 56);

    (*podatek) = t;
}

inline T_U2 _UrediOktete(T_U2 podatek)
{
    T_U2 t = (T_U2)(podatek << 8);
    podatek >>= 8;
    podatek |= t;

    return podatek;
}

inline T_U4 _UrediOktete(T_U4 podatek)
{
    T_U4 t;

    t  = (T_U4)(podatek << 24);
    t |= (T_U4)(podatek << 8) & 0x00ff0000;
    t |= (T_U4)(podatek >> 8) & 0x0000ff00;
    t |= (T_U4)(podatek >> 24);

    return t;
}

inline T_U8 _UrediOktete(T_U8 podatek)
{
    T_U8 t;

    t  = (T_U8)(podatek << 56);
    t |= (T_U8)(podatek << 40) & 0x00ff000000000000;
    t |= (T_U8)(podatek << 24) & 0x0000ff0000000000;
    t |= (T_U8)(podatek << 8)  & 0x000000ff00000000;
    t |= (T_U8)(podatek >> 8)  & 0x00000000ff000000;
    t |= (T_U8)(podatek >> 24) & 0x0000000000ff0000;
    t |= (T_U8)(podatek >> 40) & 0x000000000000ff00;
    t |= (T_U8)(podatek >> 56);

    return t;
}


template <class TIP_DOLZINA, unsigned int PORAVNAVA, class TOK> inline T_STANJE _PreskociIdPodatke(TOK &dat)
{
    TIP_DOLZINA dolzina;

    // Preberemo dolino zapisa.
    dat >> dolzina;
    if (NEUSPESNO(dat.VrniStanje())) return dat.VrniStanje();

    // Preskoimo zapis.
    dolzina += (TIP_DOLZINA)(PORAVNAVA - dolzina) % PORAVNAVA;
    dat.Preskoci(dolzina);

    return dat.VrniStanje();
}


template <class TIP_ID, class TIP_DOLZINA> inline T_ODMIK _OdpriGlavo(RDatoteka &dat, TIP_ID id)
{
    T_ODMIK zacetek = dat.VrniOdmik();

    // Zapiemo ID in 0 namesto doline podatkov.
    if (NEUSPESNO(dat.VrniStanje())) return zacetek;
    dat << id;

    if (NEUSPESNO(dat.VrniStanje())) return zacetek;
    dat << (TIP_DOLZINA)0;

    return zacetek;
}


template <class TIP_ID, class TIP_DOLZINA, unsigned int PORAVNAVA> inline T_ODMIK _ZapriGlavo(RDatoteka &dat, T_ODMIK zacetek)
{
    T_ODMIK konec = dat.VrniOdmik();
    TIP_DOLZINA
        dolzina = (TIP_DOLZINA)(konec - zacetek - sizeof(TIP_ID) - sizeof(TIP_DOLZINA)),
        ostanek = (TIP_DOLZINA)(PORAVNAVA - dolzina) % PORAVNAVA; // tevilo bajtov, ki jih moramo dodati, da je zapis dolg celo tevilo enot doline PORAVNAVA

    if (ostanek) {
        // Dodamo polnilo na koncu.
        dat.ZapisiBajt(0, ostanek);
        konec += ostanek;
    }

    // Zapiemo pravo dolino na ustrezno mesto v datoteki.
    if (NEUSPESNO(dat.VrniStanje())) return konec;
    dat.Prestavi(zacetek + sizeof(TIP_ID));
    dat << dolzina;
    dat.Prestavi(konec);

    return konec;
}


template <class TIP_ID, class TIP_DOLZINA, unsigned int PORAVNAVA, class TOK> inline T_STANJE _NajdiGlavo(TOK &dat, TIP_ID id, T_ODMIK konec_bloka)
{
    TIP_ID _id;
    T_STANJE stanje;

    while (dat.VrniOdmik() < konec_bloka) {
        dat >> _id;
        stanje = dat.VrniStanje();
        if (NEUSPESNO(stanje)) return stanje;

        if (_id == id) {
            // Nali smo iskan zapis.
            return A_OK;
        } else
            _PreskociIdPodatke<TIP_DOLZINA, PORAVNAVA, TOK>(dat);
    }

    return AOSN_NAPAKA_NI_ZAPISA;
}

#endif // !RC_INVOKED && !MIDL_PASS && __cplusplus
#endif // __AOSN_H__
